#!/usr/bin/env python
#
# Copyright (C) 2014 Narf Industries <info@narfindustries.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
import string
import sys
import os

from xml.sax.saxutils import escape
from generator.actions import Actions
from random import choice,randint
from struct import *


# Copyright (C) 2014 Narf Industries <info@narfindustries.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

rofl = ['process_rachiometersuprachoroid', 'process_Theopaschiteeviction', 'process_maltingsurrection', 'process_heronerchondroplasty', 'process_improvisatorizenoneditorial', 'process_reburstsummity', 'process_predefinitionCarnaria', 'process_ourselfmetaplast', 'process_toadwiselaundrymaid', 'process_theohumanhooper', 'process_awiwimegaloglossia', 'process_intergeneratingruneword', 'process_kansrush', 'process_thysanuriformcrossrail', 'process_ramraceBorderies', 'process_byworkplastid', 'process_allegoristerserendite', 'process_relapcantalite', 'process_querulitycooer', 'process_polyspermatouscreationistic', 'process_GemitoresBourignian', 'process_remisrepresentationlancet', 'process_warneriodocasein', 'process_tuchunateacademization', 'process_outvenomviameter', 'process_indirecthierarchism', 'process_receptivenesssempervirent', 'process_crookedparonomasiastic', 'process_seminegroSemiticize', 'process_deploredlyGolaseccan', 'process_Fichteanismconjobble', 'process_usurpinglyoscin', 'process_unadversenessmaro', 'process_improvisionweed', 'process_paleobotanyworkpeople', 'process_nondistributionclitellus', 'process_otogenouschromatographic', 'process_submountainhopper', 'process_noninfectionvenerativeness', 'process_adminiculatephosphosilicate', 'process_Batwaoverpopularity', 'process_Voltaprotarsal', 'process_ExobasidialesEppy', 'process_Paridaeamylum', 'process_triquetricinfrasternal', 'process_thiodiphenylaminediterpene', 'process_benzalethylaminedesulphurate', 'process_potheenpharmacologia', 'process_phantasmascopeMelanochroid', 'process_inquilinecopse', 'process_unrevenuedindecorousness', 'process_pavonatedcozily', 'process_damnonianscrankly', 'process_Lachnosternaadenodermia', 'process_triplewisepostepileptic', 'process_pseudodemocraticproconscription', 'process_spattertriphenylated', 'process_kempstergarefowl', 'process_epitrophygoatlike', 'process_strangulableargentamid', 'process_gawkyporchless', 'process_isuroidunfitly', 'process_enforcedlypraisable', 'process_euquinquennium', 'process_teleorganicanthracitiferous', 'process_assecurationAshkenazim', 'process_unquailingshive', 'process_prerailwaycannibalistically', 'process_teleiosisunshipwrecked', 'process_epistlarcystoid', 'process_phenegollocalization', 'process_stavelessindissolubleness', 'process_emblazonarsenopyrite', 'process_galimatiasphacocystectomy', 'process_reshoedrachmae', 'process_subregenthelmeted', 'process_urogastricjesting', 'process_Trinorantumpyramides', 'process_gluttonousprebend', 'process_dejectedincreasing', 'process_mallemuckyawner', 'process_ophthalmalgiamisproduce', 'process_uncomminutedcommix', 'process_butyrochloralfertilizational', 'process_interimperialvignetter', 'process_mattapharyngological', 'process_organoantimonypreoperator', 'process_theretowardmoosebird', 'process_picturedomArchaeopteris', 'process_cesserreichspfennig', 'process_sageshipcarcoon', 'process_consignificationmarshbuck', 'process_proportionaltasselmaker', 'process_simpletonianreformulate', 'process_zeuctocoelomicmetapodial', 'process_arsheenperspiration', 'process_coinbellmaker', 'process_trentepohliaceousHectorean', 'process_collationdissuasively', 'process_unmooredtowy', 'process_thymegollidflower', 'process_dissuasivenessnondeforestation', 'process_acanthopterygianMuranese', 'process_mammillationpemphigous', 'process_xerophagyhematography', 'process_idioglossiascabble', 'process_pistoleerproexamination', 'process_volubilityThuidium', 'process_haabdimeric', 'process_Opisthocomidaeheterochiral', 'process_ridgeplatedisturbed', 'process_refilmopenhandedness', 'process_sharkletcompactedly', 'process_ecclesiaLatinization', 'process_tautoousianentente', 'process_vernileDasya', 'process_sleekgavelock', 'process_outwindowmesothoracic', 'process_hyperneuriasymbolatry', 'process_undistinctivenondisfranchised', 'process_prefactoranchoret', 'process_nonaugmentativehypertelic', 'process_Tantalussubcavity', 'process_contrarietyinconceivableness', 'process_popeyednaphtha', 'process_phenomenalisticallyunmomentary', 'process_munjmuchness', 'process_prizeexcrescence', 'process_unusehydroponist', 'process_igelstromiteMoraceae', 'process_ineloquentundishonored', 'process_vareisogeothermic', 'process_semistillpassback', 'process_pyroaceticnunciature', 'process_spadelikemassacrer', 'process_applanationnitrifaction', 'process_merseglobular', 'process_cinecameraHydropotes', 'process_zooperalorganotin', 'process_Chilopsiscompactible', 'process_indulginglyretrue', 'process_affinitativelybrawling', 'process_typhemiacubit', 'process_superestablishmentsuccor', 'process_irreclaimableconjugally', 'process_cattlefolk', 'process_yinsttenderness', 'process_flashpanstature', 'process_gymnosporouswoubit', 'process_prelanguagecloudage', 'process_avalanchestylopization', 'process_pedestrianateStromateidae', 'process_urningsubpubescent', 'process_undercropArenga', 'process_Plymouthistnashgab', 'process_desoxycorticosteroneshakerag', 'process_hemologistbeglide', 'process_lagoonaltanning', 'process_leadstonehypovitaminosis', 'process_pinkberrynonvillainous', 'process_ragamuffinismwageless', 'process_Saxonicalpalet', 'process_imperializetrispaston', 'process_arhatsporozoic', 'process_cudavaogreish', 'process_assentaneoushemal', 'process_remirrorundepreciated', 'process_syphilologyannularity', 'process_wingerconsoler', 'process_preroyaltycoagulin', 'process_rewhirlhypermotility', 'process_vasoconstrictorsupracretaceous', 'process_spinthariscopemolybdena', 'process_preinjuryduplicature', 'process_sulphostannideuntimeliness', 'process_surlyreptilferous', 'process_Caraipaearcap', 'process_leucoencephalitisconsistent', 'process_warfaringdraghound', 'process_elephantryleptocephalan', 'process_amlipyrexic', 'process_TelopeaCyclotosaurus', 'process_xenopodidtrencherless', 'process_eurycephalicunhazardousness', 'process_MesothelaeCarisa', 'process_scruplercellulifugal', 'process_saltlypropugnator', 'process_petalocerouscamus', 'process_tellurethurryproof', 'process_unoverhauledGalinsoga', 'process_SpatangusChayma', 'process_autoplastycava', 'process_iconismanisostemonous', 'process_qualmyishHolocene', 'process_ruinlikesilva', 'process_parathyroidectomizeoutheart', 'process_tuboovariandeducibleness', 'process_gumdiggingsalvarsan', 'process_asperationoraculousness', 'process_delthyrialGee', 'process_Humeaerohydroplane', 'process_proteosomalsuppletion', 'process_engrossedlyDinoceras', 'process_unhealablenessknoppy', 'process_scutcheonwiseileocolitis', 'process_fetoracclimatement', 'process_Lithosiinaecoequation', 'process_endopathicnonmarrying', 'process_oboltask', 'process_haversinepitaya', 'process_laterodeviationNarciss', 'process_depositoryteloblastic', 'process_tripartedlyOssetine', 'process_outlawrypervertedness', 'process_Eurypteroideachamaeprosopic', 'process_peritrichouslyhepatoflavin', 'process_listeningBroussonetia', 'process_intorsiondermatograph', 'process_dyewoodsocii', 'process_limsypersistence', 'process_Abrahamicinordinateness', 'process_orthotonicquab', 'process_chemokineticstatutorily', 'process_uxoriouslyelectrotechnic', 'process_malthouseenteralgia', 'process_ulnaleptodactyl', 'process_changeablyzoophilitic', 'process_tenesmicHymettic', 'process_hypernutritionmarae', 'process_sideflashmagniloquent', 'process_crossboltedasexually', 'process_inkfishpoppycock', 'process_aerocraftforbar', 'process_woodrowelshrievalty', 'process_pericyclonicdipteran', 'process_phototherapistupsetted', 'process_autovivisectionoverleather', 'process_arnberrydodecadrachm', 'process_hypoplasyhooping', 'process_unsensualDamocles', 'process_mediumismgypsyism', 'process_intwistpunter', 'process_Alalamenispermine', 'process_batteruncommutable', 'process_abjudicationunpleading', 'process_wickedlyinflatedness', 'process_funestworser', 'process_misspellquinaldic', 'process_acutelyminar', 'process_scleroblastemicpalaeocosmology', 'process_congregationalvocimotor', 'process_Zantedeschiacladocarpous', 'process_secrecyheteroecy', 'process_veldcraftsubprefect', 'process_revenantpromisee', 'process_gatewiseunderpot', 'process_counterdraftdamewort', 'process_yawpwoodwax', 'process_semiduplexskirt', 'process_unstalledneutralism', 'process_homoeomeriametagnathous', 'process_practicelegitimatist', 'process_lamellicornousPolygonaceae', 'process_ornithomanticrada', 'process_nontechnicalrongeur', 'process_araguatolucinoid', 'process_peerlesslyforetalk', 'process_dextrosinistralElaeococca', 'process_unmonarchicalnourishment', 'process_arecolidinehyalodacite', 'process_utterabilitypavement', 'process_misadministrationbroody', 'process_vivifybenefactorship', 'process_provectgastrocolostomy', 'process_querulouslycooky', 'process_unmensurableSoohong', 'process_responsivitykimigayo', 'process_cystocarppapaprelatical', 'process_notwitch', 'process_cicisbeismGonystylus', 'process_cancelationZoochlorella', 'process_cognaticalintransmissible', 'process_galvanothermometerBalzacian', 'process_creditiveplatonesque', 'process_uniquityrobotism', 'process_outsumunrefusingly', 'process_overcriticalnesslovableness', 'process_Hetaeristaltimetrical', 'process_carangoidbotryomycotic', 'process_adiaphorousfalsifiable', 'process_radomenetherwards', 'process_dihedronsubcircuit', 'process_faddyamputational', 'process_retickettopotaxis', 'process_excentricalProtococcales', 'process_predestinarianglia', 'process_gulchalilonghi', 'process_archsnoblodgepole', 'process_raspberrylikesubvertebral', 'process_larunfermenting', 'process_booteebifold', 'process_actordocility', 'process_trichitepersonship', 'process_hornilychrysolitic', 'process_keraunophoneinhabited', 'process_hammerkopnegativer', 'process_overganggenesial', 'process_untastedgirllike', 'process_alkargenmoop', 'process_hypogenicquietus', 'process_monodromiclyretail', 'process_Castoroidespentacrinite', 'process_alphabetismpolyfenestral', 'process_prattlersuffumigate', 'process_aerophilethyroidless', 'process_gooselikeaerohydropathy', 'process_superabsurdditremid', 'process_cassiteritecasemaking', 'process_vibrativeoversail', 'process_paraderDendrocygna', 'process_unsubstantiaterightfulness', 'process_luminaristvasculated', 'process_pellagrosemongrelization', 'process_unfannedhopperman', 'process_tonguinessresoundingly', 'process_allottrichopterous', 'process_mausoleandecasualize', 'process_preservatizeskyphoi', 'process_wirrshillingless', 'process_craunchprovitamin', 'process_undiscoverableelectrifiable', 'process_anusimnonstationary', 'process_iodolabsolutistic', 'process_unconvenedperpetually', 'process_symmetricalantimasker', 'process_indecencyjimply', 'process_misputheptarchist', 'process_sciosophyunlarge', 'process_Moorshipspermatova', 'process_blepharanthracosisuncliented', 'process_bacteriformpiercel', 'process_unenterprisedargumentatious', 'process_roofprespur', 'process_disaffectedanchorite', 'process_ambisyllabicfruitful', 'process_hookahsupersimplicity', 'process_codeinesalience', 'process_solferinocircumjacence', 'process_unimplicitoothecal', 'process_precoxseambiter', 'process_unodoriferousWhiggish', 'process_mercurializationsimulacre', 'process_Philoctetessupersalesman', 'process_hetericismswayable', 'process_ectallycoenosteal', 'process_settlehydrophid', 'process_monogamianportio', 'process_premortuarybenchy', 'process_toxiferousphthalate', 'process_concussionalmonobromoacetanilide', 'process_tautologicpanimmunity', 'process_withsavesatinize', 'process_slopinglyautomatically', 'process_photoheliographoctuplicate', 'process_syenitemanufactural', 'process_exempttanninlike', 'process_forswearfreewheel', 'process_withoctopede', 'process_autozooidexternization', 'process_entrapmentvoyageable', 'process_unpopulatecurry', 'process_uplookbootlegger', 'process_nowhitoffscape', 'process_coxbonesbirle', 'process_skilderprothalline', 'process_ankylenterongreenfish', 'process_Bronxbiotechnics', 'process_Quitugryde', 'process_hippocampalscrow', 'process_redepositsubclassify', 'process_Tdapproximatively', 'process_lipemiabenjamin', 'process_pantomnesiadiporpa', 'process_refragablenessabstergent', 'process_violationguggle', 'process_deletoryrollerskating', 'process_intercoolingpotentialization', 'process_photocompositioneneuch', 'process_coeternaloverhonor', 'process_Vandiemenianwinery', 'process_subcineritiousphrenitic', 'process_foliicolousskeletonweed', 'process_palatableJonesian', 'process_Wagnerianaaviculturist', 'process_preformisticexemplifiable', 'process_antiphonybackplate', 'process_carcerationinterrenal', 'process_plagioclinalmesolecithal', 'process_lippitudebaetyl', 'process_motacillinewidespreadly', 'process_Ciceronicpownie', 'process_quakinglyilliterate', 'process_rathmemorizable', 'process_homozygotemagicalize', 'process_xiphosternamedia', 'process_vanilleshellburst', 'process_Manobountopping', 'process_unflukedcleck', 'process_brackishrehazard', 'process_togueseaflower', 'process_projicientcolumellate', 'process_medicochirurgicadvise', 'process_snackmisinstruction', 'process_stickleafethenyl', 'process_tintsausinger', 'process_terribletaut', 'process_leathermakersemishirker', 'process_miningFlavia', 'process_Islamiticgreenbark', 'process_depositumspiritsome', 'process_OrleansSchedius', 'process_tecalipalingenesy', 'process_cytochromemonosepalous', 'process_camphyleneremarkedly', 'process_dookmainport', 'process_matelessbeatitude', 'process_muckyuxoricide', 'process_ankylophobiaAsperula', 'process_Physciawenny', 'process_xenogenesisprenoble', 'process_buttTarahumara', 'process_Slavophilesedigitate', 'process_yoreexponent', 'process_unfangedramline', 'process_prankinglypneumotherapy', 'process_torskpiss', 'process_Erotylidaeprehesitate', 'process_goodlyterebenthene', 'process_panegyricalPodsnappery', 'process_woodwosesupraterraneous', 'process_frolickytriphyline', 'process_hemianacusiadouble', 'process_unmistgraffer', 'process_microcrystallogenyfuniculus', 'process_rattlepodMuntiacus', 'process_tenodesisunroaming', 'process_Ternstroemiaanisostomous', 'process_correctorSpirochaeta', 'process_laparotomycephalohumeralis', 'process_overhollowescort', 'process_geriatricundaubed', 'process_allanitictrichitis', 'process_declamatorinessSerrifera', 'process_Polemoniumoutburn', 'process_stomagringo', 'process_inwrapmentcarcinogenesis', 'process_hallowerhydrophthalmos', 'process_semicolumnrankly', 'process_subordinationbrachial', 'process_unexchangedsupraventricular', 'process_unspendablevanilla', 'process_parandruspercribration', 'process_Rodolphhumuslike', 'process_gardenedfugacious', 'process_spinthariscopiclieutenancy', 'process_vivacityOlneya', 'process_usurperunplannedly', 'process_insidiouslysurplicewise', 'process_billbackdisease', 'process_dinitrilholocentrid', 'process_lindengamy', 'process_holdsmanoversalty', 'process_cylindrarthrosisnonplusation', 'process_grammaticismmignonette', 'process_bronchiaunbaffling', 'process_vaporizetannery', 'process_denieragedrapery', 'process_outgushpenniveined', 'process_channelizeungarter', 'process_syngraphstaminiferous', 'process_androgynyvegetoalkaline', 'process_gratefulAlcedinidae', 'process_chartermarrowy', 'process_lobectomypreinflection', 'process_saddirhamtaxometer', 'process_simulcastriboflavin', 'process_maternityhomogenetic', 'process_electrocardiographyamaranthaceous', 'process_heterophyllychlorochromates', 'process_TaboriteSanche', 'process_terrazzododder', 'process_Vickyimmigrant', 'process_bawcockPicnickian', 'process_polishedlyhematosis', 'process_orographicniddick', 'process_distilleryKiwanis', 'process_Chlamydobacteriaceaesystematize', 'process_Bitulithicscrin', 'process_archcrownundistantly', 'process_Histriobdellauntread', 'process_outworthbenevolence', 'process_schuleclethraceous', 'process_stakeholderunforbade', 'process_alphabetizermonoclinal', 'process_endogalvanismunwarrantedly', 'process_ciderishazury', 'process_penitentiaryshiporderedness', 'process_uncatholicizeSiphonognathus', 'process_cantingnesstideful', 'process_docimasytrouserdom', 'process_manageriallyflanger', 'process_catmalisoncoevally', 'process_Theodotianjigget', 'process_cycloolefinmonostylous']
lol  = ['process_photonephographPima', 'process_decimosextountractarian', 'process_maltingsurrection', 'process_appendiceunmetaled', 'process_reburstsummity', 'process_ourselfmetaplast', 'process_Silicoideasaltator', 'process_toadwiselaundrymaid', 'process_awiwimegaloglossia', 'process_intergeneratingruneword', 'process_interventraliaforeutter', 'process_thysanuriformcrossrail', 'process_ramraceBorderies', 'process_bullyrooklaminarin', 'process_byworkplastid', 'process_unaccuracyblepharoadenitis', 'process_solemnlystre', 'process_peccationfoolery', 'process_corticationmotleyness', 'process_GemitoresBourignian', 'process_warneriodocasein', 'process_tuchunateacademization', 'process_diazobenzenedisburden', 'process_amaranthoidunpulleyed', 'process_butterrootchagrin', 'process_indirecthierarchism', 'process_crookedparonomasiastic', 'process_seminegroSemiticize', 'process_deploredlyGolaseccan', 'process_Fichteanismconjobble', 'process_usurpinglyoscin', 'process_esophagoplastyrestrainedness', 'process_nondistributionclitellus', 'process_isatogenvestibulum', 'process_pejoristbromalbumin', 'process_otogenouschromatographic', 'process_submountainhopper', 'process_noninfectionvenerativeness', 'process_ExobasidialesEppy', 'process_inquilinecopse', 'process_unrevenuedindecorousness', 'process_scholasticlyInd', 'process_alveololingualMindererus', 'process_Lachnosternaadenodermia', 'process_unarrayapparitor', 'process_pseudodemocraticproconscription', 'process_hancesmoothness', 'process_kempstergarefowl', 'process_neurofibriljanapan', 'process_epitrophygoatlike', 'process_Grahamsaloon', 'process_gawkyporchless', 'process_dermobranchiataboyardom', 'process_subcostalbaldmoney', 'process_enforcedlypraisable', 'process_ureterorrhagiahemogenetic', 'process_Pamirioversystematic', 'process_teleorganicanthracitiferous', 'process_unquailingshive', 'process_venomouslypilferment', 'process_angiomyocardiacmisinformer', 'process_teleiosisunshipwrecked', 'process_phenegollocalization', 'process_radiopaqueunrecruitable', 'process_tantarabobusaurify', 'process_subregenthelmeted', 'process_urogastricjesting', 'process_Proteroglyphapiezoelectric', 'process_hyperexaltationBrachyphyllum', 'process_Trinorantumpyramides', 'process_misproduceunthrilled', 'process_gluttonousprebend', 'process_dejectedincreasing', 'process_cephaloconicunbaptized', 'process_skeegalveoloclasia', 'process_unlasheddialyzable', 'process_mallemuckyawner', 'process_uncomminutedcommix', 'process_Triuridalesplagiarism', 'process_butyrochloralfertilizational', 'process_tartishlynarcotical', 'process_interimperialvignetter', 'process_mattapharyngological', 'process_Tullianrubidium', 'process_organoantimonypreoperator', 'process_demibeastuninflicted', 'process_prebromidicMonopetalae', 'process_sageshipcarcoon', 'process_twinklybingo', 'process_proportionaltasselmaker', 'process_zeuctocoelomicmetapodial', 'process_arsheenperspiration', 'process_disjointedlytriamylose', 'process_coinbellmaker', 'process_collationdissuasively', 'process_unmooredtowy', 'process_dissuasivenessnondeforestation', 'process_acanthopterygianMuranese', 'process_smackinglyScheuchzeriaceae', 'process_Toryizesynechthran', 'process_spraysemisaprophyte', 'process_volubilityThuidium', 'process_impracticalnessNemichthyidae', 'process_Eomecondiscolorate', 'process_haabdimeric', 'process_unaccoutereddrivebolt', 'process_Opisthocomidaeheterochiral', 'process_ridgeplatedisturbed', 'process_micrencephalypalpus', 'process_sharkletcompactedly', 'process_ecclesiaLatinization', 'process_sleekgavelock', 'process_nonaugmentativehypertelic', 'process_crouchingpurebred', 'process_stereopicturesalep', 'process_contrarietyinconceivableness', 'process_goniometerhexameral', 'process_phenomenalisticallyunmomentary', 'process_munjmuchness', 'process_prizeexcrescence', 'process_plurifacialmicrographical', 'process_unusehydroponist', 'process_igelstromiteMoraceae', 'process_frontomallarforedetermine', 'process_filietypester', 'process_pluviographicspermatorrhea', 'process_ineloquentundishonored', 'process_erythriticsynergidal', 'process_semistillpassback', 'process_cotteextubate', 'process_pyroaceticnunciature', 'process_applanationnitrifaction', 'process_merseglobular', 'process_countryfolkintolerance', 'process_zooperalorganotin', 'process_indulginglyretrue', 'process_affinitativelybrawling', 'process_typhemiacubit', 'process_weathercockismcustodier', 'process_Galwayslaminous', 'process_superestablishmentsuccor', 'process_cattlefolk', 'process_prelanguagecloudage', 'process_pedestrianateStromateidae', 'process_undercropArenga', 'process_hemologistbeglide', 'process_lagoonaltanning', 'process_chromophilouspyometra', 'process_sheepkeepingfeedman', 'process_Saxonicalpalet', 'process_imperializetrispaston', 'process_lungflowerhorrormonger', 'process_assentaneoushemal', 'process_remirrorundepreciated', 'process_wingerconsoler', 'process_rewhirlhypermotility', 'process_surlyreptilferous', 'process_Negritohydroponicist', 'process_reladepropiolaldehyde', 'process_leucoencephalitisconsistent', 'process_balandracaducibranch', 'process_unsilentiousskimpy', 'process_undiametricsinningness', 'process_elephantryleptocephalan', 'process_amlipyrexic', 'process_TelopeaCyclotosaurus', 'process_xenopodidtrencherless', 'process_grapedmassively', 'process_eurycephalicunhazardousness', 'process_corkeralbanite', 'process_MesothelaeCarisa', 'process_saltlypropugnator', 'process_petalocerouscamus', 'process_untuckedsolenoglyphic', 'process_SpatangusChayma', 'process_logarithmeticallydeliriant', 'process_steevingerotic', 'process_microcaltropmyosarcomatous', 'process_degerminatorblo', 'process_asperationoraculousness', 'process_microcosmographyunratified', 'process_Humeaerohydroplane', 'process_proteosomalsuppletion', 'process_engrossedlyDinoceras', 'process_unhealablenessknoppy', 'process_scutcheonwiseileocolitis', 'process_Lithosiinaecoequation', 'process_endopathicnonmarrying', 'process_vitriolizemonal', 'process_laterodeviationNarciss', 'process_depositoryteloblastic', 'process_tripartedlyOssetine', 'process_outlawrypervertedness', 'process_biserialsmithite', 'process_peritrichouslyhepatoflavin', 'process_beseemingnessprefulgent', 'process_saffianpackcloth', 'process_tumoredcrocodilite', 'process_limsypersistence', 'process_Abrahamicinordinateness', 'process_orthotonicquab', 'process_chemokineticstatutorily', 'process_ulnaleptodactyl', 'process_Sumasslevulosuria', 'process_teleophoreunspinsterlike', 'process_tenesmicHymettic', 'process_addressorcondensedly', 'process_roblaumontite', 'process_bairnlyneocosmic', 'process_outdoortenorister', 'process_loketprincipiate', 'process_pericyclonicdipteran', 'process_phototherapistupsetted', 'process_autovivisectionoverleather', 'process_catastateateliosis', 'process_unsensualDamocles', 'process_diopterpelvioradiography', 'process_intwistpunter', 'process_Alalamenispermine', 'process_batteruncommutable', 'process_wickedlyinflatedness', 'process_sagaiebarrister', 'process_undercovertcoloss', 'process_micrifyoverfrighten', 'process_foreimaginationenthalpy', 'process_Zantedeschiacladocarpous', 'process_untrammelednessHannibalian', 'process_gatewiseunderpot', 'process_chaffererunheaded', 'process_counterdraftdamewort', 'process_yawpwoodwax', 'process_pentaptychBantingism', 'process_ornithomanticrada', 'process_evenworthyharebrain', 'process_cardialgiacontingence', 'process_nontechnicalrongeur', 'process_shellycoatcallousness', 'process_araguatolucinoid', 'process_dachshundpuddly', 'process_utterabilitypavement', 'process_prosubscriptiontribracteate', 'process_unengravedeosin', 'process_vivifybenefactorship', 'process_provectgastrocolostomy', 'process_querulouslycooky', 'process_unmensurableSoohong', 'process_responsivitykimigayo', 'process_cancelationZoochlorella', 'process_bustedpredoubter', 'process_creditiveplatonesque', 'process_cleansingpentahedral', 'process_cineplastyanonang', 'process_tongueshoticonophilism', 'process_overcriticalnesslovableness', 'process_graphologicautovaccination', 'process_carangoidbotryomycotic', 'process_adiaphorousfalsifiable', 'process_radomenetherwards', 'process_uncunningmonticuliporidean', 'process_dihedronsubcircuit', 'process_slutteryprivant', 'process_faddyamputational', 'process_retickettopotaxis', 'process_excentricalProtococcales', 'process_predestinarianglia', 'process_gulchalilonghi', 'process_archsnoblodgepole', 'process_fillmetroptosis', 'process_booteebifold', 'process_derationalizationunchoked', 'process_outfeatvasodilator', 'process_menialitypreintelligent', 'process_rosariumpathetism', 'process_keraunophoneinhabited', 'process_hammerkopnegativer', 'process_oversolicitouslyhour', 'process_overganggenesial', 'process_untastedgirllike', 'process_inferiorismobstetrix', 'process_monodromiclyretail', 'process_alphabetismpolyfenestral', 'process_galledisocinchomeronic', 'process_acclaimerilluminability', 'process_aerophilethyroidless', 'process_unfootsorepoonac', 'process_postiquedefeasibility', 'process_lemologydiplasion', 'process_superabsurdditremid', 'process_vibrativeoversail', 'process_unsubstantiaterightfulness', 'process_luminaristvasculated', 'process_unfannedhopperman', 'process_cathodofluorescencemonkcraft', 'process_psilotaceousectozoan', 'process_refallGanguela', 'process_entomicperjuriousness', 'process_craunchprovitamin', 'process_irislikeaphyllose', 'process_foreuseuninfluencing', 'process_undiscoverableelectrifiable', 'process_unconvenedperpetually', 'process_multifurcateobstructively', 'process_indecencyjimply', 'process_misputheptarchist', 'process_springlikemonosymmetrically', 'process_symptosissubcorneous', 'process_Graphiolacolorimetry', 'process_bacteriformpiercel', 'process_unenterprisedargumentatious', 'process_ambisyllabicfruitful', 'process_raucousEstheriidae', 'process_codeinesalience', 'process_unimplicitoothecal', 'process_precoxseambiter', 'process_mercurializationsimulacre', 'process_diseasednessthioantimonate', 'process_colletingobylike', 'process_Philoctetessupersalesman', 'process_Dokoelectrochemically', 'process_invulnerabledimerization', 'process_whiskerypodoscapher', 'process_opportunisttitlark', 'process_dissogenyBarney', 'process_ectallycoenosteal', 'process_pilchermonaulos', 'process_monogamianportio', 'process_premortuarybenchy', 'process_algorithmicSericana', 'process_tautologicpanimmunity', 'process_bumblefooticonology', 'process_multicrystallinekeratoglossus', 'process_withsavesatinize', 'process_splanchnopleureprelapsarian', 'process_slopinglyautomatically', 'process_recapitalizationdissipative', 'process_steinkirkmisaffection', 'process_noniccosmopoietic', 'process_bemuzzlesurficial', 'process_exempttanninlike', 'process_forswearfreewheel', 'process_carpolitemortifier', 'process_hungerlysphenocephaly', 'process_respitelesssuccenturiation', 'process_unpopulatecurry', 'process_toyingere', 'process_uplookbootlegger', 'process_ankylenterongreenfish', 'process_summarizationyatter', 'process_physiognomicallybrasse', 'process_certainarchpontiff', 'process_Quitugryde', 'process_hippocampalscrow', 'process_redepositsubclassify', 'process_Tdapproximatively', 'process_shortishscob', 'process_deletoryrollerskating', 'process_intercoolingpotentialization', 'process_surfactantchurchgrith', 'process_coeternaloverhonor', 'process_noggencapitulate', 'process_Vandiemenianwinery', 'process_subcineritiousphrenitic', 'process_foliicolousskeletonweed', 'process_preformisticexemplifiable', 'process_feveretunderbox', 'process_agoraphobiaLenzites', 'process_antiphonybackplate', 'process_heliconbonnetman', 'process_plagioclinalmesolecithal', 'process_lippitudebaetyl', 'process_Ciceronicpownie', 'process_rathmemorizable', 'process_proctorshipscoptical', 'process_homozygotemagicalize', 'process_gemeledAdonai', 'process_xiphosternamedia', 'process_vanilleshellburst', 'process_fitfulunshrill', 'process_unvoiceCamacan', 'process_Steganophthalmiagnomic', 'process_brackishrehazard', 'process_archiereusHainan', 'process_projicientcolumellate', 'process_snackmisinstruction', 'process_Piscataqualagoonal', 'process_stickleafethenyl', 'process_tintsausinger', 'process_terribletaut', 'process_phlebectomySiam', 'process_miningFlavia', 'process_piskgriff', 'process_katabolizedermic', 'process_unhyphenedallose', 'process_depositumspiritsome', 'process_OrleansSchedius', 'process_cytochromemonosepalous', 'process_bullswooldraggletail', 'process_camphyleneremarkedly', 'process_dookmainport', 'process_indubitablenoncollaboration', 'process_ankylophobiaAsperula', 'process_overseateddiscouragingly', 'process_skeelysubtriangular', 'process_xenogenesisprenoble', 'process_yoreexponent', 'process_prankinglypneumotherapy', 'process_protosiphonaceousossiferous', 'process_exponencecrubeen', 'process_goodlyterebenthene', 'process_overedgeevangelican', 'process_panegyricalPodsnappery', 'process_hyperduliaferrateen', 'process_snakeletwounds', 'process_campulitropoussapogenin', 'process_retroclusionmetaphysicianism', 'process_bizonedraconites', 'process_oxmanoutpull', 'process_correctorSpirochaeta', 'process_laparotomycephalohumeralis', 'process_previousnessoisin', 'process_overhollowescort', 'process_allanitictrichitis', 'process_poonghiehectic', 'process_Polemoniumoutburn', 'process_stomagringo', 'process_sulphuratorjonquil', 'process_subordinationbrachial', 'process_unexchangedsupraventricular', 'process_unspendablevanilla', 'process_parandruspercribration', 'process_falsificationcomer', 'process_Rodolphhumuslike', 'process_Ibaditehypotenuse', 'process_oversoldafield', 'process_chytridialgoosemouth', 'process_insidiouslysurplicewise', 'process_billbackdisease', 'process_Bombycillahonoraria', 'process_barrelmakingparoemia', 'process_baptizeeFrenchize', 'process_dinitrilholocentrid', 'process_lindengamy', 'process_holdsmanoversalty', 'process_agonizefloating', 'process_grammaticismmignonette', 'process_metatitanatetarente', 'process_sokarailer', 'process_untabernacledmedicamental', 'process_whealwormrice', 'process_barkeeperCurtis', 'process_knuckleboneunnegotiableness', 'process_syngraphstaminiferous', 'process_androgynyvegetoalkaline', 'process_chartermarrowy', 'process_lobectomypreinflection', 'process_acquisitumvaletudinarist', 'process_photometricalacantholysis', 'process_Spongiaealcelaphine', 'process_cosilybridecake', 'process_heterophyllychlorochromates', 'process_ananaamasty', 'process_triseriallypreaccess', 'process_TaboriteSanche', 'process_Vickyimmigrant', 'process_bawcockPicnickian', 'process_polishedlyhematosis', 'process_exarteritisthenadays', 'process_galleywormphos', 'process_distilleryKiwanis', 'process_placitumunmortgage', 'process_Chlamydobacteriaceaesystematize', 'process_Bitulithicscrin', 'process_archcrownundistantly', 'process_outworthbenevolence', 'process_Lawsonsemiconversion', 'process_prehexameraldissyllabize', 'process_schuleclethraceous', 'process_piperitiousreekingly', 'process_stakeholderunforbade', 'process_alphabetizermonoclinal', 'process_calycoideousunpressed', 'process_endogalvanismunwarrantedly', 'process_penitentiaryshiporderedness', 'process_semideliriousmelituria', 'process_recapitalizerelevate', 'process_docimasytrouserdom', 'process_ornithotomyblackwort', 'process_cannotdentigerous', 'process_catmalisoncoevally', 'process_rosiedunarchdeacon']
pollinfo = {'rachiometersuprachoroid': ([], ['letohl', 'string', 'ntohll', 'string', 'double', 'ntohs', 'lv', 'letohl', 'string', 'lv', 'byte', 'ntohll','nextproto_b']), 'photonephographPima': ([], ['string', 'ntohl', 'lv', 'string', 'byte', 'ntohs', 'letohll', 'ntohll']), 'decimosextountractarian': ([], ['lv', 'string', 'ntohl', 'ntohs', 'byte', 'letohs', 'string', 'letohl', 'double', 'ntohl', 'ntohl', 'ntohl', 'ntohll', 'letohll', 'letohs']), 'Theopaschiteeviction': ([], ['ntohs', 'double', 'ntohll', 'letohs', 'letohll', 'ntohl', 'ntohl', 'letohl', 'ntohs', 'letohll', 'ntohl', 'letohl', 'ntohll', 'double', 'byte', 'ntohl', 'letohl', 'ntohs', 'lv', 'ntohll', 'letohs', 'letohll', 'letohll', 'float', 'letohs', 'letohs', 'ntohll', 'double', 'ntohl', 'letohs', 'ntohs', 'string', 'ntohll']), 'maltingsurrection': (['outworthbenevolence', 'unmistgraffer', 'cannotdentigerous', 'evaluecystatrophia', 'susurrateoutvie', 'pneumodynamicsprimariness', 'collationdissuasively', 'saltlypropugnator', 'cassiteritecasemaking', 'veldcraftsubprefect', 'Steganophthalmiagnomic', 'focoidsstackfreed'], ['letohs', 'letohs', 'letohs', 'double', 'letohll', 'string', 'letohll', 'letohl', 'string', 'letohll', 'nextproto_b', 'ntohs', 'letohs', 'float', 'float', 'float', 'ntohl', 'lv', 'letohll', 'float', 'ntohll', 'byte', 'double', 'string', 'nextproto_s', 'ntohll', 'float', 'letohl', 'letohll', 'nextproto_s', 'ntohl', 'float', 'letohll', 'letohll', 'letohll', 'byte', 'letohll', 'ntohl', 'nextproto_s', 'nextproto_s', 'lv', 'ntohs', 'double', 'double', 'string', 'letohs', 'letohs', 'nextproto_b', 'lv', 'string']), 'heronerchondroplasty': ([], ['string', 'ntohl', 'letohs', 'ntohll', 'byte', 'byte', 'ntohl', 'double', 'ntohll', 'letohs', 'ntohl', 'float', 'double']), 'improvisatorizenoneditorial': ([], ['letohl', 'letohll', 'ntohl', 'string', 'letohs', 'letohll', 'ntohll', 'ntohll', 'ntohl', 'letohl']), 'appendiceunmetaled': ([], ['letohll', 'letohl', 'float', 'ntohl', 'float', 'ntohll', 'ntohll', 'string', 'double', 'ntohl', 'float', 'letohl', 'ntohl', 'letohl', 'ntohll', 'letohs', 'letohll', 'ntohl', 'ntohl', 'lv', 'float', 'float', 'ntohl', 'letohs', 'ntohl', 'string', 'double', 'letohl', 'double', 'lv', 'float', 'string', 'float']), 'reburstsummity': ([], ['lv', 'byte', 'double', 'double', 'letohl', 'ntohs', 'letohl', 'letohll', 'float', 'ntohll', 'letohl', 'letohll', 'letohll', 'ntohs', 'string', 'ntohs', 'double', 'double', 'string', 'float', 'letohll', 'ntohs', 'ntohs', 'double', 'float', 'string', 'letohs', 'ntohs', 'ntohs']), 'predefinitionCarnaria': ([], ['ntohll', 'lv', 'letohl', 'letohs', 'letohll', 'byte', 'ntohll', 'double', 'letohs', 'letohs', 'letohl', 'lv', 'letohs', 'lv', 'ntohll', 'string', 'ntohll', 'byte', 'double', 'string', 'string', 'letohll', 'letohs', 'double', 'double', 'double', 'string', 'byte', 'letohl', 'string', 'byte', 'letohs', 'byte', 'ntohll', 'letohll', 'letohs', 'ntohs', 'float', 'ntohs', 'ntohs', 'double']), 'ourselfmetaplast': (['leucoencephalitisconsistent', 'Maytimeraillike', 'anomalousparallelinerved', 'remisrepresentationlancet', 'shortcakeabase', 'scruplercellulifugal', 'Robenhausianreboil', 'sleekgavelock', 'receptivenesssempervirent', 'pinkberrynonvillainous', 'undercovertcoloss', 'unhyphenedallose', 'preservatizeskyphoi', 'plurifacialmicrographical', 'dermoiddiversifiable', 'syphilologyannularity', 'untuckedsolenoglyphic', 'hanginglypoethood', 'depositoryteloblastic', 'subcostalbaldmoney', 'unbeggarbroncholithiasis', 'ofttimessnatchingly', 'endogalvanismunwarrantedly', 'allerChilostoma', 'ricketssubtrihedral', 'depositumspiritsome', 'predesignateunderservice', 'repolymerizationwesselton', 'lemologydiplasion', 'evenworthyharebrain', 'pentaptychBantingism', 'semisomnolencegunj', 'retroclusionmetaphysicianism', 'erythriticsynergidal', 'phototherapistupsetted', 'Sumasslevulosuria', 'neurofibriljanapan', 'surrenalinconcluding', 'asteamincandescency', 'Piscataqualagoonal', 'hemologistbeglide', 'matelessbeatitude', 'grapedmassively', 'cycloolefinmonostylous', 'declamatorinessSerrifera', 'overcriticalnesslovableness', 'androgynyvegetoalkaline', 'opportunisttitlark', 'sideflashmagniloquent', 'tollgateandrophagous', 'Vickyimmigrant', 'untastedgirllike', 'cacuminalgastrohysterorrhaphy', 'emblazonarsenopyrite', 'euquinquennium', 'triquetricinfrasternal', 'steinkirkmisaffection', 'galledisocinchomeronic', 'nonadjustmentwritmaking', 'tecalipalingenesy', 'Alalamenispermine', 'zoosporangialbuyable', 'parandruspercribration', 'limsypersistence', 'Oliveanpyromancer', 'holdsmanoversalty', 'responsivitykimigayo', 'engrossedlyDinoceras', 'trinodineacetaldehyde', 'subcineritiousphrenitic', 'hippocampalscrow', 'oxmanoutpull', 'prizeexcrescence', 'menialitypreintelligent', 'elementalismpietism'], ['float', 'byte', 'byte', 'ntohll', 'nextproto_b', 'letohll', 'ntohl', 'ntohl', 'ntohs', 'letohl', 'ntohl', 'ntohll', 'string', 'nextproto_s', 'ntohll', 'letohs']), 'Silicoideasaltator': ([], ['string', 'float', 'ntohll', 'double', 'ntohs', 'letohl', 'ntohl', 'ntohs', 'string', 'letohl', 'ntohll', 'ntohll', 'ntohs', 'byte', 'ntohs', 'letohll', 'ntohll', 'ntohs', 'ntohl', 'letohs', 'byte', 'letohl', 'byte', 'letohll', 'string', 'ntohs', 'ntohs', 'ntohl', 'ntohll', 'byte', 'double', 'lv']), 'toadwiselaundrymaid': ([], ['float', 'byte', 'double', 'ntohll', 'ntohll', 'byte', 'string', 'double']), 'theohumanhooper': ([], ['letohll', 'ntohl', 'ntohl', 'ntohl', 'ntohs', 'byte', 'letohs', 'byte']), 'awiwimegaloglossia': ([], ['string', 'letohll', 'ntohl', 'ntohll', 'letohll', 'double', 'ntohs', 'letohs', 'byte', 'ntohl', 'letohll', 'letohll', 'letohs', 'ntohll', 'float', 'letohll', 'string', 'letohll', 'letohll', 'lv', 'string', 'byte', 'double', 'float']), 'intergeneratingruneword': (['symptosissubcorneous', 'triquetricinfrasternal', 'slutteryprivant', 'butterrootchagrin', 'unquailingshive', 'peccationfoolery', 'ettleoptimize', 'cleansingpentahedral', 'adiaphorousfalsifiable', 'chaffererunheaded', 'wutproamusement', 'Sumasslevulosuria', 'bemuzzlesurficial', 'udometricpredefault', 'sulfureasupertramp', 'kempstergarefowl', 'herpetologistindeed', 'sitfastcaret', 'purgaNycticorax', 'springlikemonosymmetrically', 'unimplicitoothecal', 'Vandiemenianwinery', 'Suionesunprejudicially', 'logarithmeticallydeliriant', 'geriatricundaubed', 'ancestorialLicania', 'chromophilouspyometra'], ['nextproto_s', 'lv', 'float', 'letohs', 'ntohl', 'letohl', 'ntohs', 'letohs', 'float', 'letohs', 'ntohl', 'letohl', 'letohl', 'letohs', 'double', 'letohll', 'letohs', 'byte', 'ntohll', 'string', 'letohs', 'ntohl', 'letohs', 'nextproto_s', 'ntohl', 'ntohll', 'byte', 'nextproto_b', 'letohl', 'letohs', 'float', 'letohs', 'letohll', 'float', 'ntohl', 'byte', 'letohs', 'letohl', 'ntohll', 'byte', 'float', 'letohll', 'letohs', 'letohl']), 'kansrush': (['micrencephalypalpus', 'wutproamusement', 'Sarothrawrencher', 'unpaintterebinic', 'prattlersuffumigate', 'visorlikeNagari', 'arhatsporozoic', 'isuroidunfitly', 'Eomecondiscolorate', 'subcostalbaldmoney', 'bustedpredoubter', 'ricketssubtrihedral', 'extravagantkaryoplasmatic', 'unpopulatecurry', 'Slovenerecure', 'spraysemisaprophyte', 'baptizeeFrenchize', 'cesserreichspfennig', 'catmalisoncoevally', 'cantingnesstideful', 'indubitablenoncollaboration', 'predisciplinetukra', 'precoxseambiter', 'buttonholerindigestive', 'cerebroidodontolcate', 'whusslenoreast', 'foliicolousskeletonweed', 'prelanguagecloudage', 'warneriodocasein', 'cinecameraHydropotes', 'domanialPhora', 'uncomminutedcommix', 'provectgastrocolostomy', 'unhittabledoublehorned', 'oxmanoutpull', 'organosiliconsegmentary', 'poonghiehectic', 'addressorcondensedly', 'spinthariscopiclieutenancy', 'imperializetrispaston', 'dermobranchiataboyardom', 'napalmbrevifoliate', 'evenworthyharebrain', 'scleroblastemicpalaeocosmology', 'springlikemonosymmetrically', 'unlasheddialyzable', 'prehexameraldissyllabize', 'utterabilitypavement', 'photoheliographoctuplicate', 'stagemansupa', 'overganggenesial', 'xenopodidtrencherless', 'roofprespur', 'listeningBroussonetia', 'grapedmassively', 'bumblefooticonology', 'Sumasslevulosuria', 'surlyreptilferous', 'Lawsonsemiconversion', 'trentepohliaceousHectorean', 'kansrush', 'opportunisttitlark', 'phototherapistupsetted', 'cicisbeismGonystylus', 'sheepkeepingfeedman', 'peccationfoolery', 'reladepropiolaldehyde', 'parandruspercribration', 'byworkplastid', 'unconvenedperpetually', 'intrathoraciccoemployment', 'carangoidbotryomycotic', 'strangulableargentamid', 'Vandiemenianwinery', 'pneumodynamicsprimariness', 'epistlarcystoid', 'susurrateoutvie', 'vibrativeoversail', 'faddyamputational', 'semiduplexskirt', 'genipacombiner', 'Mayorunahybridizer', 'declamatorinessSerrifera', 'malthouseenteralgia', 'fleaweedprobate', 'peerlesslyforetalk', 'epexegeticallyreadjournment'], ['byte', 'nextproto_s', 'ntohll', 'ntohs', 'letohl', 'letohl', 'letohl', 'nextproto_s', 'nextproto_b', 'letohl', 'byte', 'string', 'float', 'letohll', 'byte', 'letohll', 'byte', 'nextproto_b', 'string', 'nextproto_s', 'ntohl', 'byte', 'ntohl', 'float', 'letohll', 'ntohs', 'ntohs', 'string', 'byte', 'letohl', 'lv', 'nextproto_s', 'float', 'byte', 'double', 'nextproto_b', 'byte', 'byte']), 'carannaaccension': ([], ['ntohll', 'double', 'letohll', 'ntohl', 'letohl', 'ntohs']), 'exportnontarnishable': ([], ['letohl', 'double', 'byte', 'ntohl', 'letohll', 'letohs', 'ntohl', 'byte', 'ntohll', 'ntohs', 'letohl', 'double', 'letohl', 'letohs', 'lv', 'float', 'string', 'lv', 'byte', 'letohs', 'lv', 'byte', 'ntohs', 'double', 'letohs', 'letohs', 'float', 'ntohs', 'letohl', 'ntohll']), 'interventraliaforeutter': (['gatewiseunderpot', 'Steganophthalmiagnomic', 'Tullianrubidium', 'dermobranchiataboyardom', 'polyspermatouscreationistic', 'overgenialitybuzzle', 'anomalousparallelinerved', 'hetericismswayable', 'ambisyllabicfruitful', 'Lespedezafuthorc', 'Stromatoporoideabarry', 'Eomecondiscolorate', 'unfannedhopperman', 'scutcheonwiseileocolitis', 'stakeholderunforbade', 'unhittabledoublehorned', 'predisciplinetukra', 'Voltaprotarsal', 'superabsurdditremid', 'changeablyzoophilitic', 'hemianacusiadouble', 'cancelationZoochlorella', 'cesserreichspfennig', 'Triuridalesplagiarism'], ['lv', 'double', 'letohll', 'ntohl', 'byte', 'nextproto_s', 'letohl', 'string', 'letohll', 'float', 'byte', 'double', 'nextproto_b', 'byte', 'string', 'byte', 'float', 'letohl', 'nextproto_b', 'letohll', 'ntohll', 'letohl', 'letohll', 'byte', 'ntohll', 'double', 'ntohll', 'double', 'letohs', 'ntohl', 'ntohl', 'float', 'lv', 'nextproto_b', 'nextproto_b', 'nextproto_b', 'letohl', 'ntohll', 'float', 'double', 'ntohl', 'nextproto_s', 'ntohs', 'ntohs', 'nextproto_s', 'letohs', 'lv', 'ntohl', 'double']), 'oilinessbookwright': ([], ['double', 'ntohl', 'ntohs', 'ntohll', 'ntohll', 'letohl', 'float', 'ntohs', 'letohll', 'ntohs', 'float', 'letohl', 'ntohs', 'letohs', 'ntohll', 'ntohl', 'ntohll', 'lv', 'ntohl', 'ntohs', 'ntohll', 'ntohll', 'double', 'ntohs', 'ntohll', 'letohs', 'ntohll', 'ntohll', 'letohl', 'letohs', 'float', 'byte', 'letohs', 'double', 'double', 'letohl', 'double', 'lv', 'letohs']), 'thysanuriformcrossrail': ([], ['letohl', 'letohs', 'letohl', 'float', 'ntohs', 'lv', 'lv', 'lv', 'ntohs']), 'buprestidanarithmetic': ([], ['lv', 'ntohs', 'letohl', 'letohs', 'letohl', 'string', 'float', 'lv', 'double', 'ntohl', 'ntohl', 'ntohs', 'string', 'byte', 'letohl', 'ntohs', 'ntohs']), 'ramraceBorderies': ([], ['letohl', 'double', 'ntohs', 'lv', 'ntohs', 'lv', 'lv', 'float', 'float', 'string', 'string', 'lv', 'letohs', 'float', 'letohl', 'string', 'lv', 'letohs', 'byte', 'letohl', 'ntohll', 'lv', 'lv', 'double', 'string', 'letohl', 'letohs', 'ntohs', 'ntohll', 'string', 'ntohl', 'byte', 'letohs']), 'bullyrooklaminarin': (['refallGanguela', 'acquisitumvaletudinarist', 'exportnontarnishable', 'androgynyvegetoalkaline', 'Ciceronicpownie', 'demibeastuninflicted', 'grapedmassively', 'overedgeevangelican', 'aerocraftforbar', 'butyrochloralfertilizational', 'picturedomArchaeopteris', 'reburstsummity', 'chartermarrowy', 'perukiershiplexicographer', 'onomatopoeiaeggfish', 'vibrativeoversail', 'opportunisttitlark', 'dyewoodsocii', 'micrencephalypalpus', 'pensefulnessdrought', 'unadversenessmaro', 'hypernutritionmarae', 'unhittabledoublehorned', 'lindengamy', 'Oliveanpyromancer', 'phenegollocalization', 'rosariumpathetism', 'zincotypetripodic', 'steevingerotic', 'unquailingshive', 'filietypester', 'superestablishmentsuccor', 'oversecurelyelocution', 'hemologistbeglide', 'predesignateunderservice', 'notwitch', 'assecurationAshkenazim', 'Philonismpinivorous', 'cryptomnesiamillward', 'unsubstantiaterightfulness', 'susurrateoutvie', 'unstalledneutralism', 'chytridialgoosemouth', 'lipemiabenjamin', 'summarizationyatter', 'cardinghygeistic', 'kansrush', 'Nathanielbiliteral', 'remisrepresentationlancet', 'palatableJonesian', 'catastateateliosis', 'Spongiaealcelaphine', 'untastedgirllike', 'booteebifold', 'Theodotianjigget', 'forswearfreewheel', 'Castoroidespentacrinite', 'imperializetrispaston', 'diazobenzenedisburden', 'thysanuriformcrossrail', 'unaccuracyblepharoadenitis', 'Robenhausianreboil', 'receptivenesssempervirent', 'pellagrosemongrelization', 'cudavaogreish', 'dermobranchiataboyardom', 'wolfberrydeclaredness', 'shortishscob', 'tautoousianentente', 'predestinarianglia', 'Hetaeristaltimetrical', 'pegologyscavenage', 'importationPerisphinctidae', 'undistinctivenondisfranchised', 'oboltask', 'panegyricalPodsnappery', 'redepositsubclassify'], ['double', 'letohs', 'double', 'byte', 'letohll', 'ntohll', 'double', 'byte', 'double', 'nextproto_s', 'float', 'byte', 'float', 'letohll', 'float', 'letohs', 'letohll', 'double', 'letohl', 'letohl', 'string', 'lv', 'byte', 'ntohs', 'nextproto_b', 'letohl', 'float', 'letohs']), 'byworkplastid': (['xenopodidtrencherless', 'peccationfoolery', 'dermoiddiversifiable', 'mattapharyngological', 'grapedmassively', 'collationdissuasively', 'Fichteanismconjobble', 'picayunishapogeotropic', 'napalmbrevifoliate', 'dehydrogenizeCambrian', 'whusslenoreast', 'syphilologyannularity', 'symmetricalantimasker', 'udometricpredefault', 'recapitalizerelevate', 'roofprespur', 'spinthariscopemolybdena', 'pedestrianateStromateidae', 'Lespedezafuthorc', 'asepticallyBernese', 'bullswooldraggletail', 'ambisyllabicfruitful', 'asperationoraculousness', 'antleredadunc', 'noggencapitulate', 'sokarailer', 'subregenthelmeted', 'Pamirioversystematic', 'untastedgirllike', 'catmalisoncoevally', 'paleobotanyworkpeople', 'menialitypreintelligent', 'goniometerhexameral', 'countryfolkintolerance', 'Wagnerianaaviculturist', 'pneumodynamicsprimariness', 'subcineritiousphrenitic', 'semiduplexskirt', 'superestablishmentsuccor', 'steelworkpsychophysiological', 'barrelmakingparoemia', 'outworthbenevolence', 'Bryumextrafocal', 'diseasednessthioantimonate', 'hookahsupersimplicity', 'interimperialvignetter', 'coeternaloverhonor', 'epigenesistbisexed', 'cannotdentigerous', 'Eomecondiscolorate', 'cinecameraHydropotes', 'shuttlecockscanmag', 'semicolumnrankly', 'Oliveanpyromancer', 'mataiuntameness'], ['double', 'letohl', 'nextproto_s', 'ntohs', 'ntohs', 'nextproto_b', 'nextproto_b', 'letohs', 'ntohl', 'double', 'nextproto_s', 'ntohll', 'letohll', 'string', 'byte', 'float', 'float', 'ntohl', 'ntohll', 'ntohll', 'letohs', 'ntohl', 'byte', 'ntohs', 'letohll', 'float', 'ntohl', 'double', 'letohl', 'string', 'nextproto_s', 'letohll', 'float', 'float', 'ntohl', 'lv', 'string', 'letohl', 'letohl', 'letohll', 'byte', 'byte', 'ntohl', 'ntohl', 'letohl', 'string', 'nextproto_s']), 'notchycoralliferous': ([], ['ntohll', 'ntohll', 'ntohs', 'letohs', 'letohll', 'byte', 'string', 'double', 'letohll', 'ntohl', 'letohs', 'lv', 'float', 'ntohs', 'float', 'byte']), 'allegoristerserendite': ([], ['letohl', 'ntohs', 'lv', 'float', 'ntohs', 'letohl', 'byte', 'ntohll', 'double', 'letohll']), 'unaccuracyblepharoadenitis': ([], ['ntohll', 'letohs', 'letohs', 'letohs', 'string', 'double', 'ntohll', 'ntohl', 'letohs', 'byte', 'lv', 'lv', 'string', 'letohll', 'float', 'string', 'float', 'ntohs', 'ntohl', 'float', 'lv', 'float', 'float']), 'bombonnefiendhead': ([], ['ntohs', 'byte', 'ntohl', 'letohl', 'lv', 'letohll', 'string', 'double', 'letohs', 'lv', 'float', 'letohll', 'ntohl', 'ntohs', 'letohs', 'ntohll', 'ntohll', 'letohl']), 'relapcantalite': ([], ['letohl', 'ntohl', 'string', 'letohl', 'byte', 'letohl', 'letohs', 'ntohs', 'ntohl', 'lv', 'ntohll', 'letohll', 'float', 'letohl', 'double', 'string', 'letohs', 'letohs', 'byte', 'ntohll', 'lv', 'ntohll', 'ntohs', 'letohl', 'lv', 'double']), 'solemnlystre': (['skeesicksunsteamed', 'pensefulnessdrought', 'bairnlyneocosmic', 'nowhitoffscape', 'dejectedincreasing', 'previousnessoisin', 'crookedparonomasiastic', 'Piscataqualagoonal', 'knuckleboneunnegotiableness', 'gardenedfugacious', 'unbeggarbroncholithiasis', 'integralizationbremeness', 'mischieveunfomented', 'tumultuouslymammonitish', 'dermobranchiataboyardom', 'docimasytrouserdom', 'outvenomviameter', 'microcaltropmyosarcomatous', 'herpetologistindeed', 'grapedmassively', 'unpaintterebinic', 'dyewoodsocii', 'grammaticismmignonette', 'remisrepresentationlancet'], ['ntohl', 'nextproto_s', 'ntohl', 'ntohs', 'ntohs', 'ntohl', 'nextproto_b', 'lv', 'string', 'letohll', 'letohll', 'double', 'ntohl']), 'peccationfoolery': (['collationdissuasively', 'sacroposteriorveratryl', 'ornithotomyblackwort', 'veldcraftsubprefect', 'coeternaloverhonor', 'hyperneuriasymbolatry', 'blepharanthracosisuncliented', 'asperationoraculousness'], ['double', 'float', 'nextproto_b', 'nextproto_s', 'letohl', 'letohs', 'letohl', 'ntohll', 'letohl', 'nextproto_b', 'ntohl', 'double', 'ntohll', 'nextproto_s', 'letohll', 'letohs', 'string', 'letohl', 'ntohl', 'nextproto_b', 'float', 'nextproto_s', 'lv', 'byte', 'letohl', 'letohl', 'ntohs', 'lv', 'double', 'float', 'ntohs', 'float', 'letohs', 'lv', 'double', 'lv', 'byte']), 'querulitycooer': ([], ['float', 'ntohl', 'string', 'letohll', 'float', 'byte', 'ntohl', 'string', 'float', 'lv', 'letohs', 'ntohll', 'ntohll', 'letohl', 'ntohll', 'letohll', 'lv', 'string', 'letohs', 'ntohl', 'byte', 'ntohll', 'ntohll', 'string', 'ntohl', 'string', 'double', 'string', 'ntohs', 'ntohll', 'letohll', 'string', 'ntohll', 'letohl', 'string', 'ntohs', 'ntohs', 'byte']), 'polyspermatouscreationistic': ([], ['letohl', 'ntohs', 'byte', 'lv']), 'corticationmotleyness': (['intrathoraciccoemployment', 'corticationmotleyness', 'unmooredtowy', 'Anglomaniaclovableness', 'deletoryrollerskating', 'prerailwaycannibalistically', 'tongueshoticonophilism', 'Lithosiinaecoequation', 'unremittinglyaffronting', 'awiwimegaloglossia', 'unenterprisedargumentatious', 'Tantalussubcavity', 'eudaemonisticallyCoccolobis', 'lippitudebaetyl', 'codeinesalience', 'interventraliaforeutter', 'blossomscrimshander', 'cumshawzelatrice', 'pentaptychBantingism', 'Fichteanismconjobble', 'blepharanthracosisuncliented', 'syngraphstaminiferous', 'tollgateandrophagous', 'peepypatrologic', 'veldcraftsubprefect', 'urogastricjesting', 'dihedronsubcircuit', 'teleiosisunshipwrecked', 'Aparaipsychiatrist', 'lemologydiplasion', 'agonizefloating', 'undistinctivenondisfranchised', 'cophosisclour', 'Limodorumscrotal', 'hypogenicquietus', 'racegoingunperformed', 'enclothearmiferous', 'susurrateoutvie', 'loketprincipiate', 'uncomminutedcommix', 'ivoryliketransessentiate', 'oboltask', 'recapitalizationdissipative', 'archiereusHainan', 'bumblefooticonology', 'prefactoranchoret', 'spattertriphenylated', 'Voltaprotarsal', 'unhyphenedallose', 'Lespedezafuthorc', 'theohumanhooper', 'oversoldafield', 'leucoencephalitisconsistent', 'Piscataqualagoonal', 'uniquityrobotism', 'catagmaticMegalosaurus', 'manageriallyflanger', 'etioporphyrinpubovesical', 'muckyuxoricide', 'tenodesisunroaming', 'Abrahamicinordinateness', 'geriatricundaubed', 'unfootedHilary', 'Eurypteroideachamaeprosopic', 'reproachablepancreatogenic', 'elephantryleptocephalan', 'homoeomeriametagnathous', 'scleroblastemicpalaeocosmology', 'referumbrellawort', 'onomatopoeiaeggfish', 'miningFlavia', 'cryptanalystteenet', 'expiatorytranscriptional', 'steelworkpsychophysiological', 'yawpwoodwax', 'uplookbootlegger', 'maltingsurrection', 'alphabetismpolyfenestral', 'frolickytriphyline', 'TaboriteSanche', 'cycloolefinmonostylous', 'iconismanisostemonous', 'evaluecystatrophia', 'hyperduliaferrateen', 'stereopicturesalep', 'spraysemisaprophyte', 'metasomalNachitoches', 'retroclusionmetaphysicianism', 'wickedlyinflatedness', 'organosiliconsegmentary', 'parorchispalingenic', 'buttTarahumara'], ['nextproto_s', 'nextproto_b', 'ntohll', 'nextproto_b', 'ntohl', 'lv', 'letohl', 'byte', 'byte', 'ntohll', 'ntohs', 'letohl', 'ntohs', 'byte', 'lv', 'ntohll']), 'oversecurelyelocution': ([], ['double', 'ntohll', 'letohs', 'byte', 'ntohs', 'double', 'byte', 'letohll', 'ntohl', 'letohs', 'letohs', 'byte', 'ntohl', 'lv']), 'GemitoresBourignian': (['GemitoresBourignian', 'lindengamy', 'epexegeticallyreadjournment', 'napalmbrevifoliate', 'pantomnesiadiporpa', 'reladepropiolaldehyde', 'motacillinewidespreadly', 'xenopodidtrencherless', 'parandruspercribration', 'antleredadunc', 'cardialgiacontingence', 'parathyroidectomizeoutheart', 'Dokoelectrochemically', 'paralyzerthiocarbimide', 'tellurethurryproof', 'wingerconsoler', 'trichitepersonship', 'monodromiclyretail', 'phenomenalisticallyunmomentary', 'Wagnerianaaviculturist', 'mausoleandecasualize', 'adminiculatephosphosilicate', 'roofprespur', 'unenterprisedargumentatious', 'unfannedhopperman', 'gumdiggingsalvarsan', 'ettleoptimize', 'sideflashmagniloquent', 'steinkirkmisaffection', 'ridgeplatedisturbed', 'listeningBroussonetia', 'cylindrarthrosisnonplusation', 'applanationnitrifaction', 'veldcraftsubprefect', 'etioporphyrinpubovesical', 'cacuminalgastrohysterorrhaphy', 'grammaticismmignonette', 'TaboriteSanche', 'scleroblastemicpalaeocosmology', 'creditiveplatonesque', 'predefinitionCarnaria', 'subregenthelmeted', 'piperitiousreekingly'], ['nextproto_s', 'letohll', 'lv', 'ntohll', 'lv', 'letohl', 'double', 'nextproto_b', 'ntohl', 'letohs', 'letohl', 'double', 'string', 'byte', 'float', 'byte']), 'remisrepresentationlancet': ([], ['letohl', 'double', 'letohl', 'double', 'ntohs', 'lv', 'string', 'ntohs', 'lv', 'letohs', 'byte', 'float', 'double', 'letohl', 'ntohl', 'letohl']), 'warneriodocasein': ([], ['ntohl', 'string', 'float', 'byte', 'lv', 'letohl', 'lv', 'ntohll', 'letohl', 'letohll', 'float', 'ntohl']), 'tuchunateacademization': ([], ['ntohl', 'lv', 'double', 'string', 'letohs', 'lv', 'ntohl', 'lv', 'string', 'letohs']), 'cumshawzelatrice': (['Silicoideasaltator', 'dissuasivenessnondeforestation', 'hippocampalscrow', 'purgaNycticorax', 'congregationalvocimotor', 'misputheptarchist', 'micrencephalypalpus', 'nondistributionclitellus', 'etioporphyrinpubovesical', 'pinkberrynonvillainous', 'crouchingpurebred', 'motacillinewidespreadly', 'ornithotomyblackwort', 'notchycoralliferous', 'penitentiaryshiporderedness', 'terribletaut', 'GemitoresBourignian', 'lepidodendridcounterplead', 'variationaladjutory', 'concussionalmonobromoacetanilide', 'antleredadunc', 'cerebroidodontolcate', 'carangoidbotryomycotic', 'repolymerizationwesselton', 'carannaaccension', 'balandracaducibranch', 'warneriodocasein', 'dachshundpuddly', 'Brandipriestcraft', 'mediumismgypsyism', 'countrymanisodimorphism', 'acquisitumvaletudinarist', 'euquinquennium', 'dracontiasisinterparliamentary', 'bairnlyneocosmic', 'violationguggle', 'microcaltropmyosarcomatous', 'huddlingcladautoicous', 'collationdissuasively', 'proportionaltasselmaker', 'counterspyingdungeon', 'xenogenesisprenoble', 'Lawsonsemiconversion', 'interimperialvignetter', 'counterdraftdamewort', 'ourselfmetaplast', 'crossboltedasexually', 'sulphostannideuntimeliness', 'adminiculatephosphosilicate', 'arnberrydodecadrachm', 'chromophilouspyometra', 'susurrateoutvie', 'triquetricinfrasternal', 'fleaweedprobate', 'cacuminalgastrohysterorrhaphy', 'uncomminutedcommix', 'sowbackgastrotrichan', 'crookedparonomasiastic', 'Piscataqualagoonal', 'antiviraltackety', 'ramraceBorderies', 'codeinesalience', 'unbeggarbroncholithiasis', 'zeuctocoelomicmetapodial', 'cannotdentigerous', 'cantingnesstideful', 'kansrush'], ['letohs', 'letohll', 'byte', 'byte', 'lv', 'lv', 'ntohl', 'ntohs', 'lv']), 'diazobenzenedisburden': ([], ['string', 'string', 'lv', 'ntohl', 'string', 'byte', 'ntohll', 'ntohll', 'byte', 'double', 'ntohl', 'byte', 'letohl', 'byte', 'lv', 'string', 'string', 'double', 'ntohs', 'letohs', 'ntohl', 'letohl', 'double', 'ntohll', 'ntohs', 'float', 'lv', 'letohs', 'lv', 'lv', 'ntohs', 'double', 'byte', 'letohll', 'letohl', 'letohs', 'ntohs', 'letohl', 'ntohll', 'ntohs']), 'outvenomviameter': ([], ['ntohs', 'lv', 'float', 'byte', 'ntohs', 'double', 'byte', 'lv', 'ntohs', 'float', 'ntohs', 'letohll', 'ntohl', 'letohs', 'letohl', 'byte', 'byte', 'letohs', 'ntohl', 'string', 'ntohs', 'letohl', 'ntohs', 'letohl', 'string', 'letohl', 'ntohll', 'ntohll', 'lv', 'float', 'ntohs', 'byte', 'ntohll']), 'amaranthoidunpulleyed': ([], ['string', 'double', 'ntohs', 'ntohs', 'ntohs', 'lv', 'ntohll', 'lv', 'letohl', 'string', 'ntohs', 'letohs', 'double', 'lv', 'letohl', 'float', 'byte', 'letohs', 'ntohl', 'double', 'letohll', 'ntohll', 'letohs', 'letohll', 'ntohl', 'float', 'byte', 'ntohll', 'ntohll', 'ntohll', 'letohl', 'ntohl', 'string', 'letohll', 'letohs', 'letohll', 'double', 'byte', 'string', 'string']), 'butterrootchagrin': ([], ['double', 'ntohll', 'lv', 'ntohs', 'ntohl', 'ntohs', 'letohll', 'letohl', 'letohll', 'letohl', 'ntohll', 'byte', 'letohs', 'float', 'ntohl', 'ntohl', 'ntohll', 'byte', 'lv', 'float']), 'indirecthierarchism': ([], ['ntohl', 'ntohl', 'float', 'ntohll', 'lv', 'ntohl', 'ntohl', 'lv', 'lv', 'letohs', 'float', 'letohll', 'lv', 'letohll', 'letohs', 'string', 'ntohl']), 'Leskeaceaemotto': (['appendiceunmetaled', 'subcostalbaldmoney', 'tintsausinger', 'frolickytriphyline', 'medicochirurgicadvise', 'muckyuxoricide', 'monogamianportio', 'logarithmeticallydeliriant', 'unsubstantiaterightfulness', 'whusslenoreast', 'micrencephalypalpus', 'smackinglyScheuchzeriaceae', 'desoxycorticosteroneshakerag', 'whillyunbet', 'noninfectionvenerativeness', 'unhealablenessknoppy', 'wutproamusement', 'Ternstroemiaanisostomous', 'recapitalizerelevate', 'dermoiddiversifiable', 'relapcantalite', 'simpletonianreformulate', 'typhemiacubit', 'cosilybridecake', 'cryptanalystteenet', 'pavonatedcozily', 'trentepohliaceousHectorean', 'interventraliaforeutter', 'lobectomypreinflection', 'hedgesublimish', 'grammaticismmignonette', 'Piscataqualagoonal', 'ectallycoenosteal', 'repealistbillsticking', 'onomatopoeiaeggfish', 'utterabilitypavement', 'pellagrosemongrelization', 'uplookbootlegger', 'mallemuckyawner', 'practicelegitimatist', 'Alalamenispermine', 'Lawsonsemiconversion', 'hammerkopnegativer', 'galvanothermometerBalzacian', 'strainedlypsychopompos', 'metatitanatetarente', 'misproduceunthrilled', 'unpaintterebinic', 'tollgateandrophagous', 'galimatiasphacocystectomy', 'overpoliticunderlooker', 'undiscoverableelectrifiable', 'Lithosiinaecoequation', 'carpolitemortifier', 'galledisocinchomeronic', 'untrammelednessHannibalian', 'unsilentiousskimpy', 'exempttanninlike', 'potheenpharmacologia', 'Oliveanpyromancer', 'carannaaccension', 'proportionaltasselmaker', 'bronchiaunbaffling', 'ineloquentundishonored', 'filietypester', 'hyperduliaferrateen', 'gatewiseunderpot', 'Hetaeristaltimetrical', 'congregationalvocimotor', 'asteamincandescency', 'diseasednessthioantimonate', 'trichitepersonship', 'laparotomycephalohumeralis', 'vasoconstrictorsupracretaceous', 'Zantedeschiacladocarpous', 'archaeologyapiin', 'spadelikemassacrer'], ['lv', 'double', 'letohs', 'nextproto_s', 'byte', 'float', 'float', 'letohl', 'letohll', 'ntohs', 'ntohl', 'ntohs', 'letohl', 'nextproto_b', 'letohll', 'letohl', 'ntohl', 'nextproto_b', 'letohl', 'lv', 'string', 'nextproto_b', 'nextproto_s', 'ntohll', 'ntohll', 'double', 'ntohs', 'string', 'nextproto_s', 'ntohll', 'double', 'float', 'byte', 'float', 'letohs', 'float', 'double']), 'receptivenesssempervirent': (['violationguggle', 'yawpwoodwax', 'hypoplasyhooping', 'agoraphobiaLenzites', 'loketprincipiate', 'furoidbasanite', 'variationaladjutory', 'tuchunateacademization', 'catmalisoncoevally', 'congregationalvocimotor', 'nondistributionclitellus', 'blossomscrimshander', 'terrazzododder', 'countrymanisodimorphism', 'paleobotanyworkpeople', 'paleocrystallinespinulosodenticulate', 'electrocardiographyamaranthaceous', 'polishedlyhematosis', 'exponencecrubeen', 'disjointedlytriamylose', 'practicelegitimatist', 'addressorcondensedly', 'splanchnopleureprelapsarian', 'entomicperjuriousness', 'ivoryliketransessentiate', 'oxmanoutpull', 'euquinquennium', 'dejectedincreasing', 'Nathanielbiliteral', 'malthouseenteralgia', 'veldcraftsubprefect', 'seminegroSemiticize'], ['lv', 'byte', 'nextproto_s', 'letohll', 'nextproto_s', 'nextproto_s', 'ntohll', 'lv', 'ntohll', 'ntohll']), 'crookedparonomasiastic': ([], ['lv', 'letohl', 'lv', 'letohll', 'letohll', 'letohs', 'double', 'letohll', 'ntohll', 'ntohl', 'letohs', 'string', 'ntohll', 'letohll', 'ntohl', 'float', 'float', 'double', 'ntohs', 'ntohll', 'ntohs', 'double', 'byte', 'double', 'ntohs', 'lv', 'letohll', 'string', 'byte', 'letohl']), 'seminegroSemiticize': ([], []), 'deploredlyGolaseccan': ([], ['lv', 'letohll', 'byte', 'double', 'float', 'letohll', 'ntohl', 'string', 'ntohs', 'ntohs', 'string', 'ntohl', 'letohl', 'lv', 'ntohl', 'ntohl', 'ntohl', 'letohll', 'ntohll', 'ntohl', 'letohll', 'lv', 'ntohl', 'string', 'lv', 'letohll', 'lv', 'letohll', 'byte']), 'Fichteanismconjobble': ([], ['byte', 'ntohl', 'string', 'letohs', 'ntohl', 'letohll', 'double', 'letohs', 'string', 'double', 'letohll', 'ntohll', 'lv', 'ntohs', 'ntohs', 'ntohs', 'ntohll', 'float', 'ntohs', 'letohll', 'float', 'letohll', 'letohs', 'ntohll', 'letohs', 'byte', 'ntohs', 'ntohll', 'letohll', 'byte']), 'sandwortFierasfer': ([], ['letohs', 'letohl', 'letohl', 'ntohs', 'float', 'letohl', 'float', 'letohll', 'ntohl', 'lv', 'letohll', 'double', 'ntohl', 'float', 'ntohs', 'ntohs', 'ntohs', 'ntohs', 'byte', 'double', 'string', 'letohll', 'float', 'ntohs', 'byte', 'ntohl', 'byte', 'lv', 'ntohl', 'letohl']), 'usurpinglyoscin': ([], ['string', 'lv', 'lv', 'byte', 'byte', 'letohll']), 'esophagoplastyrestrainedness': ([], ['float', 'ntohll', 'letohs', 'letohll', 'ntohll', 'string', 'letohs']), 'unadversenessmaro': ([], ['ntohl', 'letohl', 'letohl', 'double', 'letohl', 'float', 'letohll', 'letohs', 'double', 'letohll', 'letohs', 'letohs', 'ntohl', 'letohs', 'ntohll', 'string', 'byte', 'ntohl', 'ntohl', 'double', 'byte', 'double', 'string', 'letohs', 'ntohl', 'letohs', 'ntohs', 'string', 'letohl', 'ntohs']), 'improvisionweed': ([], ['letohl', 'string', 'lv', 'lv', 'double', 'letohs', 'string', 'letohll', 'string', 'float', 'float', 'ntohll']), 'paleobotanyworkpeople': (['retroclusionmetaphysicianism', 'hetericismswayable', 'symmetricalantimasker', 'etioporphyrinpubovesical', 'shuttlecockscanmag', 'apioidalNagari', 'sokarailer', 'perukiershiplexicographer', 'loungyimpolite', 'carannaaccension', 'malthouseenteralgia', 'wutproamusement', 'ochronosusafterbody', 'chaffererunheaded', 'Vandiemenianwinery', 'weathercockismcustodier', 'Lespedezafuthorc', 'strangulableargentamid', 'crouchingpurebred', 'opportunisttitlark', 'coeternaloverhonor', 'mattapharyngological', 'counterpotentMetabola', 'overhollowescort', 'dermobranchiataboyardom', 'shortcakeabase', 'multicrystallinekeratoglossus', 'unbeggarbroncholithiasis', 'Steganophthalmiagnomic', 'udometricpredefault', 'focoidsstackfreed', 'cystocarppapaprelatical', 'ambisyllabicfruitful', 'unhittabledoublehorned', 'superestablishmentsuccor', 'ornithotomyblackwort', 'xenogenesisprenoble', 'cassiteritecasemaking', 'amlipyrexic', 'countryfolkintolerance', 'evaluecystatrophia', 'susurrateoutvie', 'unfannedhopperman', 'foliicolousskeletonweed', 'surlyreptilferous', 'unreprovedlysprier', 'epigenesistbisexed', 'veldcraftsubprefect', 'dermoiddiversifiable'], ['ntohs', 'string', 'ntohll', 'string', 'ntohll', 'float', 'nextproto_s', 'nextproto_s', 'letohll', 'nextproto_s', 'ntohll', 'byte', 'letohl', 'ntohll', 'letohl', 'string', 'ntohs', 'string', 'byte', 'ntohs', 'string', 'ntohll', 'letohl', 'ntohll', 'letohl', 'float', 'lv', 'letohll', 'nextproto_b', 'ntohl', 'ntohs']), 'nondistributionclitellus': ([], ['letohl', 'ntohll', 'string', 'letohll', 'letohs', 'string', 'letohl', 'lv', 'byte', 'float', 'double', 'ntohs', 'string', 'ntohll', 'double', 'lv', 'letohs', 'letohl', 'letohs', 'ntohl', 'byte', 'byte', 'ntohl', 'string', 'ntohs', 'float', 'double', 'byte', 'float', 'byte', 'string', 'ntohll', 'ntohs', 'double', 'ntohl', 'ntohl', 'letohl', 'letohs', 'float', 'float', 'letohs', 'lv']), 'isatogenvestibulum': ([], ['ntohl', 'float', 'letohl', 'lv', 'letohll', 'ntohll', 'ntohs', 'ntohs', 'double', 'ntohs', 'double', 'ntohl', 'ntohl', 'letohl', 'letohll', 'letohs', 'letohl', 'ntohs', 'byte', 'double', 'letohll', 'ntohl', 'ntohl', 'ntohll', 'double', 'ntohl', 'ntohll', 'byte', 'ntohll', 'ntohll']), 'pejoristbromalbumin': ([], ['byte', 'letohll', 'string', 'byte', 'letohll', 'double', 'double', 'byte', 'double', 'double', 'letohl']), 'asepticallyBernese': ([], ['ntohll', 'ntohll', 'letohs', 'double', 'lv', 'letohs', 'double', 'double', 'letohl', 'ntohl', 'letohs', 'lv', 'letohs', 'ntohs', 'letohl', 'double', 'letohl', 'ntohll', 'lv', 'lv', 'ntohs', 'letohs', 'lv', 'string', 'ntohs', 'letohs', 'float', 'ntohs', 'letohs', 'ntohll', 'string', 'string', 'letohs', 'letohl', 'ntohs', 'ntohl', 'byte', 'ntohll', 'string', 'ntohs', 'letohl', 'letohll']), 'visorlikeNagari': ([], ['ntohl', 'letohs', 'letohl', 'string', 'ntohl', 'byte', 'ntohs', 'letohl', 'string', 'letohs', 'double', 'letohl', 'ntohs', 'byte', 'ntohs', 'ntohs', 'byte', 'letohll', 'byte', 'letohll', 'string', 'letohs', 'byte', 'letohll', 'byte', 'double', 'byte', 'byte', 'letohl', 'letohs', 'ntohl', 'double']), 'inwrapbilophodont': ([], ['letohs', 'ntohll', 'string', 'ntohs', 'byte', 'ntohll', 'lv', 'byte', 'lv']), 'echinostomewont': (['overpoliticunderlooker', 'uncatholicizeSiphonognathus', 'Orakzaiunsatisfiedly', 'chaffererunheaded', 'venomouslypilferment', 'Pamirioversystematic', 'Eomecondiscolorate', 'raspberrylikesubvertebral', 'cesserreichspfennig', 'terribletaut', 'sulfureasupertramp', 'erythriticsynergidal', 'predestinarianglia', 'mediumismgypsyism', 'unexchangedsupraventricular', 'intercoolingpotentialization', 'utterabilitypavement', 'prizeexcrescence', 'evenworthyharebrain', 'Bryumextrafocal', 'arecolidinehyalodacite', 'photocompositioneneuch', 'buttTarahumara', 'Fichteanismconjobble', 'spadelikemassacrer', 'unfeasiblecollodiotype', 'bawcockPicnickian', 'unenterprisedargumentatious', 'cacuminalgastrohysterorrhaphy', 'pinkberrynonvillainous', 'butterrootchagrin', 'unlasheddialyzable', 'delthyrialGee', 'acclaimerilluminability', 'fetoracclimatement', 'docimasytrouserdom', 'predefinitionCarnaria', 'picayunishapogeotropic', 'subsoilercruent', 'tumoredcrocodilite', 'zoosporangialbuyable', 'ornithotomyblackwort', 'whusslenoreast', 'retroclusionmetaphysicianism', 'adiaphorousfalsifiable', 'asperationoraculousness', 'sokarailer', 'scheltopusikAmpelidaceae', 'subregenthelmeted', 'focoidsstackfreed', 'pilchermonaulos', 'apioidalNagari', 'tenodesisunroaming', 'echinostomewont', 'isuroidunfitly', 'hetericismswayable', 'galledisocinchomeronic', 'paralyzerthiocarbimide', 'scruplercellulifugal', 'grapedmassively', 'unhittabledoublehorned', 'byworkplastid', 'photoheliographoctuplicate', 'archsnoblodgepole', 'allerChilostoma', 'superestablishmentsuccor', 'loungyimpolite', 'Lespedezafuthorc', 'gemeledAdonai', 'pellagrosemongrelization', 'counterpotentMetabola', 'dehydrogenizeCambrian', 'symmetricalantimasker', 'catmalisoncoevally', 'addressorcondensedly', 'yoreexponent', 'meddlingsmall', 'summarizationyatter', 'trentepohliaceousHectorean', 'epexegeticallyreadjournment', 'reladepropiolaldehyde', 'Suionesunprejudicially'], ['byte', 'nextproto_b', 'string', 'ntohll', 'letohs', 'ntohll', 'letohll', 'ntohl', 'string', 'lv', 'letohll', 'letohs', 'ntohs', 'double', 'ntohll', 'letohll', 'ntohs', 'lv', 'nextproto_s', 'nextproto_s', 'string', 'byte', 'nextproto_s', 'double', 'byte', 'lv', 'nextproto_s', 'ntohll', 'letohl', 'letohs', 'string', 'letohll', 'letohl', 'letohl', 'ntohll', 'letohs', 'double', 'float', 'ntohll', 'ntohl', 'nextproto_s', 'ntohs']), 'otogenouschromatographic': ([], ['letohs', 'letohll', 'letohll', 'letohs', 'float', 'byte', 'float', 'string', 'string', 'lv', 'byte', 'string', 'lv', 'float', 'ntohl', 'ntohl']), 'submountainhopper': ([], ['string', 'letohl', 'ntohs', 'double', 'string', 'letohll', 'ntohs', 'double', 'ntohll', 'ntohl', 'ntohll', 'letohl', 'byte', 'float', 'ntohs', 'double', 'ntohll', 'double', 'ntohs', 'letohll', 'float', 'letohll', 'ntohll', 'ntohll', 'byte', 'ntohll']), 'sawtobjurgatory': ([], ['ntohs', 'letohl', 'ntohll', 'byte', 'ntohs', 'ntohll', 'float', 'float', 'ntohs', 'ntohl', 'byte', 'string', 'lv', 'ntohll', 'ntohll', 'letohll', 'letohll', 'ntohl', 'string', 'lv', 'double', 'ntohll', 'ntohs', 'double']), 'noninfectionvenerativeness': (['improvisatorizenoneditorial', 'goniometerhexameral', 'tuboovariandeducibleness', 'weathercockismcustodier', 'hypoplasyhooping', 'superestablishmentsuccor', 'grammaticismmignonette', 'dachshundpuddly', 'semisomnolencegunj', 'keraunophoneinhabited', 'counterspyingdungeon', 'uncomminutedcommix', 'peerlesslyforetalk', 'Lespedezafuthorc', 'photoheliographoctuplicate', 'microcrystallogenyfuniculus', 'trichitepersonship', 'bairnlyneocosmic', 'chytridialgoosemouth', 'coeternaloverhonor', 'graphologicautovaccination', 'outworthbenevolence', 'ramraceBorderies', 'nasicornousfasciated', 'denieragedrapery', 'declamatorinessSerrifera', 'oversolicitouslyhour', 'carcerationinterrenal', 'overedgeevangelican', 'antiphonybackplate', 'paleobotanyworkpeople', 'unfootsorepoonac', 'allerChilostoma', 'metatitanatetarente', 'unremittinglyaffronting', 'cacuminalgastrohysterorrhaphy', 'Grahamsaloon', 'Vandiemenianwinery', 'overhollowescort', 'scutcheonwiseileocolitis', 'semiduplexskirt', 'outfeatvasodilator', 'overganggenesial', 'valvotomypensionably', 'sleekgavelock', 'heliconbonnetman', 'hallowerhydrophthalmos', 'udometricpredefault', 'superabsurdditremid'], ['string', 'double', 'byte', 'double', 'letohl', 'float', 'letohll', 'byte', 'byte', 'nextproto_b', 'lv', 'string', 'nextproto_b', 'double', 'lv', 'nextproto_s', 'letohl', 'ntohs', 'nextproto_s', 'double', 'ntohl', 'ntohs', 'nextproto_b', 'nextproto_s', 'ntohs', 'ntohs', 'ntohll', 'double', 'letohs', 'double', 'nextproto_b', 'letohll', 'letohl', 'nextproto_b', 'letohs', 'letohl', 'ntohs', 'ntohs', 'float', 'ntohs', 'ntohll', 'lv', 'nextproto_s', 'nextproto_b', 'letohs', 'ntohll', 'double', 'nextproto_b', 'lv', 'letohll']), 'adminiculatephosphosilicate': ([], ['byte', 'ntohs', 'ntohll', 'ntohll', 'ntohs', 'byte', 'byte', 'string', 'ntohs', 'letohl', 'double', 'ntohll', 'letohs', 'double', 'lv', 'ntohs', 'letohl', 'byte', 'letohl', 'ntohl', 'letohll', 'letohll', 'letohs', 'string', 'ntohll', 'ntohs', 'letohs', 'ntohll', 'byte', 'double', 'letohs', 'byte', 'lv', 'ntohs']), 'Batwaoverpopularity': ([], ['letohs', 'string']), 'Voltaprotarsal': ([], ['string', 'letohl', 'double', 'string', 'double', 'lv', 'ntohs', 'byte', 'string', 'double', 'float', 'ntohl', 'letohl', 'string', 'ntohs', 'letohll', 'string', 'lv', 'string', 'float', 'double', 'float', 'byte']), 'ExobasidialesEppy': ([], ['double', 'letohl', 'byte', 'string', 'float', 'ntohs', 'float', 'float', 'float', 'float', 'float', 'ntohll', 'double', 'byte', 'ntohs', 'string', 'ntohs', 'ntohll', 'byte', 'letohl', 'byte', 'letohl']), 'Paridaeamylum': ([], ['lv']), 'counterambushAlbainn': ([], ['letohl', 'lv', 'letohll', 'float', 'ntohl', 'letohs', 'ntohll', 'string', 'double', 'ntohs', 'byte', 'ntohl', 'letohll', 'lv', 'lv', 'string', 'ntohs', 'byte', 'ntohll', 'ntohll', 'ntohs', 'double', 'ntohl', 'letohll', 'ntohl', 'ntohs', 'float', 'byte', 'letohll', 'ntohll', 'ntohl']), 'triquetricinfrasternal': ([], ['letohll', 'ntohl', 'ntohll', 'ntohs', 'byte', 'ntohs', 'ntohl']), 'thiodiphenylaminediterpene': ([], ['lv', 'ntohl', 'lv', 'byte', 'letohs', 'letohs']), 'turbidlycorticoefferent': ([], ['float', 'float', 'lv', 'lv', 'letohl', 'float', 'letohll']), 'benzalethylaminedesulphurate': ([], ['ntohs', 'string', 'lv', 'double']), 'potheenpharmacologia': ([], ['double', 'float', 'double', 'lv', 'letohl', 'byte', 'float', 'letohll', 'ntohl', 'double', 'string', 'byte', 'double', 'letohll', 'letohll', 'float', 'ntohll', 'float', 'ntohl']), 'clientageshudderingly': ([], ['float', 'letohl', 'byte', 'lv', 'byte', 'lv', 'byte', 'double', 'lv', 'float', 'ntohs', 'string', 'ntohl', 'ntohll', 'double', 'letohll']), 'phantasmascopeMelanochroid': (['semicolumnrankly', 'unconvenedperpetually', 'untastedgirllike', 'cinecameraHydropotes', 'maltingsurrection', 'changeablyzoophilitic', 'overganggenesial', 'indubitablenoncollaboration', 'pegologyscavenage', 'racegoingunperformed', 'algorithmicSericana', 'phlebectomySiam', 'coeternaloverhonor', 'Voltaprotarsal', 'epexegeticallyreadjournment', 'overgenialitybuzzle', 'alphabetismpolyfenestral', 'contrarietyinconceivableness', 'awiwimegaloglossia', 'burgonetcarefully', 'mausoleandecasualize', 'crouchingpurebred', 'cesserreichspfennig', 'unspendablevanilla', 'venomouslypilferment', 'splanchnopleureprelapsarian', 'ornithomanticrada', 'superestablishmentsuccor', 'radomenetherwards', 'irislikeaphyllose', 'subrigidlithophysal', 'coxbonesbirle', 'hemologistbeglide', 'monodromiclyretail', 'buttTarahumara', 'engrossedlyDinoceras', 'unexchangedsupraventricular', 'overcriticalnesslovableness', 'importationPerisphinctidae', 'terribletaut', 'ExobasidialesEppy', 'anomalousparallelinerved', 'outworthbenevolence', 'dachshundpuddly', 'refallGanguela', 'ramraceBorderies', 'prebromidicMonopetalae', 'ineloquentundishonored', 'lepidodendridcounterplead', 'keraunophoneinhabited', 'dracontiasisinterparliamentary', 'unscalednessChamaeleon', 'Bitulithicscrin', 'remirrorundepreciated', 'nowhitoffscape', 'notwitch', 'frolickytriphyline', 'skilderprothalline', 'previousnessoisin', 'enclothearmiferous', 'anusimnonstationary', 'Rodolphhumuslike', 'countrymanisodimorphism', 'asteamincandescency', 'cleansingpentahedral', 'Oliveanpyromancer', 'homozygotemagicalize', 'unmensurableSoohong', 'napalmbrevifoliate', 'thiodiphenylaminediterpene', 'butterrootchagrin', 'hanginglypoethood', 'iridemiabisque'], ['ntohll', 'ntohl', 'ntohl', 'ntohll', 'float', 'nextproto_s', 'ntohll', 'letohs', 'float', 'letohl', 'nextproto_s', 'letohll', 'letohs', 'letohl', 'nextproto_b', 'byte', 'ntohl', 'double', 'ntohs', 'letohll', 'letohl', 'double', 'ntohs', 'lv', 'letohs']), 'surrenalinconcluding': ([], ['lv', 'byte', 'byte', 'ntohll', 'letohl', 'float', 'letohll', 'letohl', 'lv', 'double', 'byte', 'byte', 'ntohs', 'letohs', 'float', 'ntohl', 'letohl', 'float', 'byte', 'byte', 'ntohl', 'letohl', 'letohll', 'lv', 'ntohl', 'float', 'ntohl', 'byte', 'letohl', 'letohll', 'ntohs', 'ntohl', 'letohl', 'letohl', 'lv', 'byte', 'letohll', 'double', 'ntohs', 'float', 'double', 'lv', 'letohs']), 'inquilinecopse': (['preformisticexemplifiable'], ['letohs', 'nextproto_b', 'byte', 'double', 'ntohll', 'letohll', 'ntohl', 'letohs', 'double', 'double', 'ntohl', 'nextproto_s', 'letohll', 'string', 'float', 'nextproto_b', 'byte', 'float', 'float', 'byte', 'nextproto_b', 'letohll', 'letohs', 'nextproto_s', 'string']), 'unrevenuedindecorousness': (['crouchingpurebred', 'nonadjustmentwritmaking', 'subcostalbaldmoney', 'Carpathianmetanephron', 'interventraliaforeutter', 'cinecameraHydropotes', 'unpopulatecurry', 'bumblefooticonology', 'pantomnesiadiporpa', 'domanialPhora', 'chytridialgoosemouth', 'racegoingunperformed', 'Stromatoporoideabarry', 'hookahsupersimplicity', 'spraysemisaprophyte', 'munjmuchness', 'splanchnopleureprelapsarian', 'oxmanoutpull', 'sageshipcarcoon', 'collationdissuasively', 'unoverhauledGalinsoga', 'picayunishapogeotropic', 'Suionesunprejudicially', 'imperializetrispaston', 'preinjuryduplicature', 'venomouslypilferment', 'surlyreptilferous', 'wingerconsoler', 'recapitalizerelevate', 'unhittabledoublehorned', 'engrossedlyDinoceras', 'Momotinaenonfortification', 'bombonnefiendhead', 'monodromiclyretail', 'subrigidlithophysal', 'pilchermonaulos', 'hetericismswayable', 'carangoidbotryomycotic', 'changeablyzoophilitic', 'bairnlyneocosmic', 'isatogenvestibulum', 'parandruspercribration', 'acclaimerilluminability', 'Oliveanpyromancer', 'pedestrianateStromateidae', 'unbeggarbroncholithiasis', 'codeinesalience', 'multicrystallinekeratoglossus', 'cancelationZoochlorella', 'apioidalNagari', 'cardialgiacontingence', 'goniometerhexameral', 'intrathoraciccoemployment', 'keraunophoneinhabited', 'fleaweedprobate', 'repealistbillsticking', 'piskgriff', 'organosiliconsegmentary', 'tongueshoticonophilism', 'paleobotanyworkpeople', 'previousnessoisin', 'docimasytrouserdom', 'Lespedezafuthorc', 'weathercockismcustodier', 'misspellquinaldic'], ['lv', 'float', 'letohl', 'byte', 'ntohs', 'string', 'ntohl', 'nextproto_s', 'nextproto_b', 'ntohll', 'nextproto_b', 'ntohl', 'string', 'letohl', 'ntohll', 'lv', 'letohl', 'ntohl', 'ntohll', 'byte', 'nextproto_b', 'ntohll', 'letohl', 'ntohll', 'letohl', 'string', 'nextproto_b', 'nextproto_b', 'lv', 'nextproto_s', 'float']), 'pavonatedcozily': ([], ['lv', 'float', 'letohl', 'double', 'string', 'ntohs', 'double', 'ntohll', 'ntohl', 'ntohl', 'ntohs', 'double', 'letohl', 'float', 'string', 'float', 'ntohl', 'float', 'ntohs', 'float', 'letohl', 'string', 'lv', 'double', 'letohl', 'letohs', 'ntohl', 'byte', 'letohll', 'lv', 'letohl', 'ntohl', 'ntohll', 'letohs']), 'scholasticlyInd': ([], ['ntohll', 'float', 'ntohl', 'lv', 'float', 'ntohs', 'ntohs', 'double', 'ntohll', 'letohs', 'double', 'lv', 'lv', 'letohll', 'float', 'lv', 'float', 'ntohs', 'letohll', 'ntohs', 'float', 'lv', 'ntohll', 'lv', 'letohl', 'ntohl', 'ntohl', 'lv', 'float', 'letohll', 'lv', 'lv', 'byte', 'byte', 'ntohs', 'letohs', 'float', 'float', 'float', 'ntohl', 'letohll']), 'dowsettroughway': ([], []), 'alveololingualMindererus': ([], ['double', 'letohl', 'letohs', 'letohl', 'letohs', 'float', 'byte', 'string', 'letohl', 'letohs', 'ntohl', 'ntohs', 'lv', 'ntohl', 'letohll', 'ntohl', 'string', 'ntohl', 'letohs', 'byte', 'ntohs', 'float', 'lv', 'letohll', 'double', 'letohs', 'double', 'ntohs', 'float']), 'damnonianscrankly': ([], ['float', 'ntohl', 'string', 'lv', 'float', 'ntohll', 'ntohl', 'string', 'letohs']), 'Lachnosternaadenodermia': (['bumblefooticonology', 'inquilinecopse', 'pensefulnessdrought', 'byworkplastid'], ['byte', 'letohl', 'letohs', 'float', 'letohs', 'nextproto_s', 'nextproto_b', 'string', 'letohll', 'ntohll', 'letohl', 'letohll', 'letohs', 'ntohll', 'nextproto_s', 'letohl', 'byte', 'ntohs', 'nextproto_b', 'byte', 'float', 'byte', 'byte', 'nextproto_b', 'letohs', 'nextproto_s', 'letohll', 'nextproto_b', 'letohl', 'letohs', 'ntohl', 'letohl', 'ntohll', 'string', 'byte', 'ntohl', 'ntohll', 'ntohl', 'letohll', 'nextproto_b', 'double', 'nextproto_b', 'byte', 'ntohll', 'ntohll']), 'unarrayapparitor': ([], ['lv', 'float', 'letohl', 'float', 'float', 'lv', 'ntohll', 'ntohl', 'byte', 'ntohl', 'float', 'ntohs', 'string', 'ntohl', 'letohll', 'letohl', 'ntohl', 'string', 'float', 'float', 'string', 'letohll', 'lv', 'double', 'double', 'double', 'double', 'lv', 'double', 'string', 'lv', 'ntohs', 'double']), 'triplewisepostepileptic': ([], ['string', 'ntohll', 'ntohl', 'lv', 'letohll', 'double', 'letohll', 'byte', 'letohl', 'ntohl', 'float', 'ntohs', 'string', 'ntohll', 'letohl', 'letohll', 'ntohl', 'string', 'double', 'ntohl', 'ntohs', 'string', 'letohll', 'ntohll', 'ntohl', 'letohll', 'double', 'string', 'ntohs', 'string', 'ntohl', 'letohll', 'letohs', 'lv', 'ntohl', 'string', 'lv']), 'pseudodemocraticproconscription': ([], ['lv', 'double', 'letohll', 'double', 'ntohll', 'letohll', 'string', 'float', 'float', 'string', 'letohll', 'letohl', 'ntohs', 'float', 'string', 'ntohs', 'ntohll', 'ntohl', 'string', 'letohl', 'letohs', 'lv', 'double', 'lv', 'lv', 'ntohll', 'double', 'letohs', 'string', 'byte', 'letohll', 'double', 'letohl', 'byte', 'byte', 'lv', 'ntohl', 'letohl', 'string', 'letohl', 'letohll']), 'spattertriphenylated': ([], ['letohll', 'ntohll', 'letohs', 'ntohs', 'double', 'letohl', 'double', 'letohl', 'ntohs', 'lv', 'float', 'byte', 'ntohll', 'float', 'ntohl', 'byte', 'letohll', 'letohs', 'ntohl', 'lv', 'ntohll', 'letohl', 'string', 'letohll', 'lv', 'lv', 'lv', 'letohl', 'float', 'double', 'lv', 'ntohl']), 'hancesmoothness': ([], ['lv', 'float', 'string', 'ntohs', 'string', 'float', 'letohl', 'letohll', 'string', 'double', 'float', 'string', 'letohl']), 'kempstergarefowl': (['refallGanguela', 'fetoracclimatement', 'alkaneirrigable', 'Lawsonsemiconversion', 'blepharanthracosisuncliented', 'exportnontarnishable', 'Wagnerianaaviculturist', 'catafalquedree', 'previousnessoisin', 'overseateddiscouragingly', 'unusehydroponist', 'adminiculatephosphosilicate', 'subsoilercruent', 'overhollowescort', 'unodoriferousWhiggish', 'cassiteritecasemaking', 'onomatopoeiaeggfish', 'surfactantchurchgrith', 'unconvenedperpetually', 'Cobitidaedismissal', 'sitfastcaret', 'togueseaflower', 'tuboovariandeducibleness', 'Ibaditehypotenuse', 'lepidodendridcounterplead', 'ralphautonomically', 'orographicniddick', 'metatitanatetarente', 'kempstergarefowl', 'organoantimonypreoperator', 'dejectedincreasing', 'mercurializationsimulacre', 'tantarabobusaurify', 'tumoredcrocodilite', 'spinthariscopemolybdena', 'mattapharyngological', 'Mayorunahybridizer', 'improvisatorizenoneditorial', 'intwistpunter', 'maltingsurrection', 'counterdraftdamewort', 'renverseundethroned', 'prosubscriptiontribracteate', 'eudaemonisticallyCoccolobis', 'loungyimpolite', 'huddlingcladautoicous', 'Voltaprotarsal', 'herpetologistindeed', 'proportionaltasselmaker', 'Aparaipsychiatrist', 'dextrosinistralElaeococca'], ['ntohll', 'letohl', 'double', 'ntohll', 'float', 'ntohs', 'double', 'nextproto_b', 'letohs', 'letohl', 'letohs', 'nextproto_b', 'byte', 'double', 'ntohl', 'string', 'ntohl', 'letohs', 'ntohll', 'nextproto_b', 'ntohl', 'double', 'ntohl', 'letohs']), 'slichtarradiddler': (['unreprovedlysprier', 'springlikemonosymmetrically'], ['letohs', 'ntohl', 'string', 'lv', 'ntohs', 'nextproto_b', 'byte', 'string', 'double', 'double', 'nextproto_s', 'double', 'byte', 'ntohll', 'double', 'double', 'byte', 'letohs', 'letohl', 'ntohll', 'lv', 'string', 'byte', 'letohll', 'string', 'letohl', 'letohll', 'ntohll', 'byte', 'nextproto_b']), 'Carpathianmetanephron': ([], ['ntohll', 'byte', 'byte', 'ntohl', 'ntohs']), 'neurofibriljanapan': ([], ['double', 'ntohll', 'string', 'letohll', 'letohl', 'ntohs', 'ntohl', 'lv', 'string', 'ntohll', 'ntohl', 'letohs', 'double', 'ntohl', 'letohl', 'string', 'letohs', 'float', 'lv', 'byte', 'float', 'ntohl', 'lv', 'double', 'letohs', 'letohll', 'ntohs', 'lv', 'letohl', 'letohl', 'byte']), 'genipacombiner': ([], ['ntohl', 'ntohl', 'lv', 'float', 'letohs', 'letohs', 'string', 'ntohl', 'ntohll', 'lv', 'letohll', 'string', 'ntohll', 'letohs', 'double', 'ntohs', 'ntohs', 'ntohll', 'byte', 'letohl', 'lv', 'ntohs', 'letohll', 'letohl', 'letohll', 'letohs', 'float', 'ntohl', 'letohl', 'lv', 'double', 'ntohl', 'byte', 'lv', 'double', 'ntohl', 'string']), 'epitrophygoatlike': ([], ['string', 'letohll', 'string', 'lv', 'letohll', 'lv']), 'emergencechouette': ([], ['lv', 'byte', 'ntohs', 'ntohl', 'double', 'lv', 'ntohl', 'lv', 'letohl', 'double', 'letohll', 'string', 'string']), 'skeesicksunsteamed': (['chytridialgoosemouth', 'semistillpassback', 'sulfureasupertramp', 'oversolicitouslyhour', 'refilmopenhandedness', 'piskgriff', 'hungerlysphenocephaly', 'dracontiasisinterparliamentary', 'tintsausinger'], ['double', 'letohs', 'nextproto_s', 'letohs', 'double', 'double', 'byte', 'nextproto_b', 'letohs', 'letohll', 'nextproto_b', 'ntohs', 'nextproto_b']), 'strangulableargentamid': (['cardialgiacontingence', 'counterpotentMetabola', 'Tullianrubidium', 'prattlersuffumigate', 'cancelationZoochlorella', 'maltingsurrection', 'katabolizedermic', 'countryfolkintolerance', 'cesserreichspfennig', 'asperationoraculousness', 'tautoousianentente', 'pneumodynamicsprimariness', 'cannotdentigerous', 'hetericismswayable', 'unhittabledoublehorned', 'collationdissuasively', 'apioidalNagari', 'dermoiddiversifiable', 'superabsurdditremid', 'veldcraftsubprefect', 'hyperneuriasymbolatry', 'unreprovedlysprier', 'semicolumnrankly', 'Bryumextrafocal', 'vaporizetannery', 'Triuridalesplagiarism', 'symmetricalantimasker', 'steelworkpsychophysiological', 'Piscataqualagoonal', 'cystocarppapaprelatical', 'bawcockPicnickian', 'piskgriff', 'pilchermonaulos', 'Pamirioversystematic', 'Steganophthalmiagnomic', 'perukiershiplexicographer', 'udometricpredefault', 'wutproamusement', 'unmistgraffer', 'xenopodidtrencherless', 'peritrichouslyhepatoflavin', 'saltlypropugnator', 'loungyimpolite', 'amlipyrexic', 'ochronosusafterbody', 'ornithotomyblackwort', 'intrathoraciccoemployment', 'unbeggarbroncholithiasis'], ['string', 'letohll', 'float', 'lv', 'ntohll', 'byte', 'ntohl', 'string', 'letohl', 'float', 'letohs', 'nextproto_s', 'lv', 'nextproto_s', 'lv', 'string', 'string', 'double', 'ntohl', 'nextproto_b', 'string', 'double', 'double', 'float', 'nextproto_b', 'ntohs', 'ntohl', 'string', 'byte', 'ntohl', 'ntohs', 'nextproto_s', 'ntohll', 'ntohl', 'ntohl', 'double', 'letohs', 'letohs', 'letohs', 'double', 'lv', 'string', 'letohll', 'letohs', 'nextproto_s', 'lv', 'nextproto_b', 'double', 'letohll']), 'Grahamsaloon': ([], ['float', 'ntohl']), 'semisomnolencegunj': ([], ['ntohs', 'nextproto_b', 'letohl', 'nextproto_b', 'nextproto_s', 'ntohll', 'float', 'ntohs', 'string', 'nextproto_s', 'float', 'lv', 'nextproto_b', 'string', 'ntohl', 'nextproto_s', 'double', 'float', 'ntohs', 'ntohs', 'ntohl', 'letohs', 'letohll']), 'herpetologistindeed': ([], ['lv', 'byte', 'letohll', 'float', 'ntohs', 'letohl', 'byte', 'byte', 'ntohll', 'string', 'float', 'letohs', 'ntohs', 'letohl', 'ntohll', 'string', 'byte', 'letohll', 'double', 'byte', 'lv', 'ntohl', 'letohll', 'ntohl', 'byte', 'ntohll', 'ntohl', 'letohl', 'letohl', 'letohs']), 'gawkyporchless': ([], ['letohl', 'letohll', 'byte']), 'dermobranchiataboyardom': ([], ['letohs', 'ntohll', 'lv', 'lv', 'double', 'letohl', 'ntohll']), 'maskflowerkeynoter': (['noniccosmopoietic', 'hematozoalinfinitarily', 'yoreexponent', 'loungyimpolite', 'coinbellmaker', 'yawpwoodwax', 'pensefulnessdrought', 'heliconbonnetman', 'reladepropiolaldehyde', 'togueseaflower', 'kleenebocJungermannia', 'maternityhomogenetic', 'dejectedincreasing', 'refilmopenhandedness', 'superestablishmentsuccor', 'thysanuriformcrossrail', 'intercoolingpotentialization', 'blepharanthracosisuncliented', 'notchycoralliferous', 'overseateddiscouragingly', 'metatitanatetarente', 'schuleclethraceous', 'ExobasidialesEppy', 'Sumasslevulosuria', 'Robenhausianreboil', 'uncatholicizeSiphonognathus', 'Dokoelectrochemically', 'prosubscriptiontribracteate', 'cerebroidodontolcate', 'scleroblastemicpalaeocosmology', 'micrencephalypalpus', 'renverseundethroned', 'pistoleerproexamination', 'bairnlyneocosmic', 'kansrush', 'anomalousparallelinerved', 'Pamirioversystematic', 'maltingsurrection', 'northwestwardpassementerie', 'contrarietyinconceivableness', 'extravagantkaryoplasmatic', 'surrenalinconcluding', 'agonizefloating', 'unconvenedperpetually', 'Ibaditehypotenuse', 'xenogenesisprenoble', 'appendiceunmetaled', 'doubleheartedstaphylolysin', 'pegologyscavenage', 'agoraphobiaLenzites', 'bullswooldraggletail', 'counterspyingdungeon', 'awiwimegaloglossia', 'sulphostannideuntimeliness', 'pinkberrynonvillainous', 'plurifacialmicrographical', 'hemianacusiadouble', 'cinecameraHydropotes', 'bumblefooticonology', 'refallGanguela', 'peccationfoolery', 'esophagoplastyrestrainedness', 'erythriticsynergidal', 'denieragedrapery', 'phenomenalisticallyunmomentary', 'tenodesisunroaming', 'unengravedeosin', 'nonadjustmentwritmaking', 'allegoristerserendite', 'ruinlikesilva', 'listeningBroussonetia', 'Sarothrawrencher', 'autovivisectionoverleather', 'Erotylidaeprehesitate', 'indirecthierarchism', 'unmistgraffer', 'overpoliticunderlooker', 'foreuseuninfluencing', 'warfaringdraghound', 'sokarailer', 'wutproamusement', 'Bharatadomain', 'ureterorrhagiahemogenetic', 'subrelationsepiolite', 'pneumodynamicsprimariness', 'Bryumextrafocal', 'correctorSpirochaeta'], ['float', 'lv', 'float', 'letohll', 'ntohll', 'string', 'float', 'nextproto_s', 'ntohl', 'ntohl', 'double', 'ntohll', 'letohll', 'ntohs', 'ntohs', 'ntohl', 'string', 'nextproto_s', 'nextproto_s', 'ntohll', 'letohl', 'ntohl', 'nextproto_s', 'ntohs', 'nextproto_s', 'ntohs', 'letohs', 'float', 'ntohl', 'float', 'string', 'nextproto_s', 'letohll', 'byte', 'ntohl', 'ntohl', 'letohl', 'nextproto_s', 'string', 'double', 'lv', 'lv', 'letohs', 'byte', 'string', 'letohll']), 'subcostalbaldmoney': (['mataiuntameness', 'responsivitykimigayo', 'counterpotentMetabola', 'warfaringdraghound', 'microcrystallogenyfuniculus', 'prosubscriptiontribracteate', 'codeinesalience', 'agoraphobiaLenzites', 'anomalousparallelinerved', 'unlasheddialyzable', 'herpetologistindeed', 'avalanchestylopization', 'superestablishmentsuccor', 'xenogenesisprenoble', 'cassiteritecasemaking', 'unhittabledoublehorned', 'querulouslycooky', 'Opisthocomidaeheterochiral', 'whusslenoreast', 'dissogenyBarney', 'Mayorunahybridizer', 'untastedgirllike', 'tongueshoticonophilism', 'Stromatoporoideabarry', 'spinthariscopiclieutenancy', 'unhyphenedallose', 'allerChilostoma', 'pavonatedcozily', 'paralyzerthiocarbimide', 'previousnessoisin', 'Bryumextrafocal', 'Plymouthistnashgab', 'piskgriff', 'indubitablenoncollaboration', 'overhollowescort', 'saltlypropugnator', 'gatewiseunderpot', 'ornithotomyblackwort', 'subordinationbrachial', 'interventraliaforeutter', 'clientageshudderingly', 'blepharanthracosisuncliented'], ['letohll', 'string']), 'isuroidunfitly': ([], ['float', 'letohs', 'letohl', 'letohl', 'letohll', 'ntohs', 'string', 'ntohll', 'letohs', 'ntohll', 'byte', 'ntohl', 'letohs', 'ntohll', 'string', 'double', 'letohl', 'letohs', 'ntohs', 'letohll', 'string', 'double', 'letohll', 'letohl', 'float', 'letohl', 'double', 'letohs', 'ntohs', 'float', 'letohl']), 'enforcedlypraisable': (['nonadjustmentwritmaking', 'crossboltedasexually', 'preformisticexemplifiable', 'Larinaecoydog', 'haabdimeric', 'vernileDasya', 'decimosextountractarian', 'poonghiehectic', 'tongueshoticonophilism', 'outsumunrefusingly', 'peritrichouslyhepatoflavin', 'xerophagyhematography', 'cacuminalgastrohysterorrhaphy', 'tautologicpanimmunity', 'porencephalonpostplegic', 'asperationoraculousness', 'wolfberrydeclaredness', 'prelanguagecloudage', 'hippocampalscrow', 'shuttlecockscanmag', 'interventraliaforeutter', 'oboltask', 'graphologicautovaccination', 'Limodorumscrotal', 'arnberrydodecadrachm', 'dermobranchiataboyardom', 'submountainhopper', 'archaeologyapiin', 'byworkplastid', 'dyewoodsocii', 'countryfolkintolerance', 'syngraphstaminiferous', 'hungerlysphenocephaly', 'limsypersistence', 'snakeletwounds', 'unhealablenessknoppy', 'rattlepodMuntiacus', 'TelopeaCyclotosaurus', 'triplewisepostepileptic', 'overganggenesial', 'potheenpharmacologia', 'denieragedrapery', 'opportunisttitlark', 'bawcockPicnickian', 'prattlersuffumigate', 'maskflowerkeynoter', 'interimperialvignetter', 'whillyunbet', 'racemizestintedly', 'miningFlavia', 'anapneaCystignathidae', 'bullswooldraggletail', 'inwrapbilophodont', 'collationdissuasively', 'stomagringo', 'hetericismswayable', 'blossomscrimshander', 'wirrshillingless', 'tautoousianentente', 'plowtailinfectress', 'domanialPhora', 'visorlikeNagari', 'proteosomalsuppletion', 'epexegeticallyreadjournment', 'frontomallarforedetermine', 'pavonatedcozily', 'undercropArenga', 'noggencapitulate', 'pericyclonicdipteran', 'sternoxiphoidunenlivened', 'ridgeplatedisturbed', 'Tullianrubidium', 'appendiceunmetaled', 'urningsubpubescent', 'epistlarcystoid', 'eurycephalicunhazardousness', 'sagaiebarrister', 'peepypatrologic', 'subregenthelmeted', 'extravagantkaryoplasmatic', 'loungyimpolite', 'butterrootchagrin', 'urogastricjesting', 'petalousausterity', 'orthotonicquab', 'hancesmoothness', 'saddirhamtaxometer', 'goniometerhexameral', 'Sarothrawrencher', 'hornilychrysolitic', 'exportnontarnishable', 'symmetricalantimasker', 'katabolizedermic', 'unspendablevanilla', 'premortuarybenchy'], ['double', 'ntohll', 'ntohl', 'double', 'float', 'byte', 'ntohl', 'ntohs', 'nextproto_b', 'letohs', 'letohl', 'float', 'nextproto_b', 'nextproto_b', 'lv', 'ntohl']), 'ureterorrhagiahemogenetic': ([], ['letohs', 'string', 'letohl', 'double', 'double', 'letohl', 'letohl', 'float', 'float', 'double', 'lv', 'string', 'letohl', 'string', 'string', 'ntohs', 'float', 'double', 'ntohs', 'letohl', 'letohs', 'lv', 'letohs', 'letohs', 'ntohll', 'double', 'letohll', 'lv', 'letohl', 'double', 'letohl', 'letohll', 'float', 'ntohll', 'byte', 'letohl', 'letohs', 'double', 'lv', 'string', 'ntohl']), 'redifferentiationmustachio': ([], ['lv', 'string', 'byte', 'ntohs', 'letohll', 'ntohll', 'lv', 'ntohll', 'letohl', 'float', 'letohs', 'ntohl', 'ntohs', 'ntohl', 'ntohs', 'ntohs', 'double']), 'euquinquennium': ([], ['float', 'letohl', 'byte', 'ntohs', 'double', 'ntohl', 'ntohs', 'letohl', 'letohl', 'byte', 'letohs', 'ntohl', 'ntohl', 'string', 'string', 'letohl', 'ntohs', 'string', 'lv', 'ntohll', 'ntohl', 'byte', 'letohs', 'ntohll', 'double', 'lv', 'ntohl', 'letohl', 'letohl', 'letohll', 'ntohs', 'letohll', 'double', 'ntohs', 'ntohl', 'byte', 'ntohll']), 'dominionistversableness': ([], ['ntohs', 'letohl', 'letohl', 'ntohl', 'byte', 'letohll', 'letohll', 'string', 'ntohll', 'letohll', 'letohs', 'float', 'float', 'ntohll', 'string', 'ntohl', 'letohl', 'byte', 'string', 'letohll', 'double', 'float', 'ntohl', 'letohl', 'float', 'lv', 'byte', 'letohll', 'letohll']), 'purgaNycticorax': ([], ['ntohl', 'ntohl']), 'Pamirioversystematic': ([], ['letohs', 'ntohs', 'float', 'letohs', 'byte', 'ntohll', 'ntohll', 'letohll', 'lv', 'ntohs', 'ntohs', 'ntohl', 'byte', 'double', 'ntohl', 'byte', 'letohs', 'letohl', 'lv', 'ntohll', 'double', 'byte', 'lv', 'letohl', 'float', 'double', 'letohll', 'letohll', 'ntohs', 'letohl', 'ntohl', 'float', 'letohs', 'ntohl', 'lv', 'float', 'ntohs', 'ntohll']), 'ancestorialLicania': ([], ['string', 'ntohll', 'lv', 'float', 'lv', 'letohl', 'letohs', 'float', 'lv', 'ntohs', 'letohll', 'float', 'double', 'letohl', 'ntohs', 'float', 'ntohll', 'float', 'letohs', 'letohl', 'letohs', 'ntohs', 'letohll', 'ntohl', 'lv', 'ntohl', 'lv', 'float', 'double', 'ntohll', 'byte']), 'teleorganicanthracitiferous': ([], ['letohll', 'string', 'ntohl', 'ntohl', 'letohl', 'string', 'double', 'string', 'ntohs', 'double', 'byte', 'ntohs', 'ntohs', 'ntohll', 'byte', 'byte', 'letohl', 'ntohll', 'string', 'letohs']), 'predisciplinetukra': ([], ['ntohl', 'ntohll', 'letohs', 'ntohl', 'ntohll', 'ntohll', 'byte', 'letohs', 'letohll', 'ntohl', 'string', 'double', 'ntohl', 'ntohl', 'lv', 'ntohl', 'letohs', 'ntohll', 'byte', 'string', 'string', 'letohll', 'ntohl']), 'assecurationAshkenazim': ([], ['ntohs', 'ntohs']), 'peepypatrologic': ([], ['double', 'letohs', 'letohll', 'letohl', 'string', 'letohs', 'byte', 'letohs', 'double', 'ntohl', 'float', 'letohl', 'ntohll', 'double', 'double', 'byte', 'ntohs', 'byte', 'ntohs', 'letohs', 'lv']), 'unquailingshive': ([], ['string', 'lv', 'letohll', 'ntohs', 'byte']), 'prerailwaycannibalistically': (['pantomnesiadiporpa', 'noggencapitulate', 'sageshipcarcoon', 'cardialgiacontingence', 'recapitalizationdissipative', 'indubitablenoncollaboration', 'overseateddiscouragingly', 'sulphhemoglobinHerculanean', 'tenesmicHymettic', 'cassiteritecasemaking', 'turbidlycorticoefferent', 'micrencephalypalpus', 'androgynyvegetoalkaline', 'Sarothrawrencher', 'Suionesunprejudicially', 'Triuridalesplagiarism', 'summarizationyatter', 'wolfberrydeclaredness', 'cannotdentigerous', 'isatogenvestibulum', 'keraunophoneinhabited', 'stagemansupa', 'Fichteanismconjobble', 'undercovertcoloss', 'chromophilouspyometra'], ['byte', 'float', 'byte', 'ntohl', 'lv']), 'venomouslypilferment': ([], ['string', 'byte', 'lv', 'letohs', 'ntohl', 'string', 'float', 'letohs', 'letohl', 'ntohll', 'ntohll', 'ntohll', 'ntohll', 'byte', 'float', 'string', 'byte', 'double', 'lv', 'ntohl', 'ntohs']), 'angiomyocardiacmisinformer': ([], ['lv', 'ntohll', 'letohll', 'letohl', 'byte', 'string', 'double']), 'Senecanovercorruptly': (['uncomminutedcommix', 'tautoousianentente', 'collationdissuasively', 'barrelmakingparoemia', 'multicrystallinekeratoglossus', 'zeuctocoelomicmetapodial', 'pyrroylprobity', 'organoantimonypreoperator', 'idioglossiascabble', 'bustedpredoubter'], ['byte', 'string', 'nextproto_b', 'letohl', 'lv', 'float', 'letohs', 'double', 'ntohll', 'nextproto_b', 'nextproto_b', 'letohs', 'ntohs', 'nextproto_s', 'float', 'ntohll', 'string', 'string', 'byte', 'ntohl', 'lv', 'string', 'ntohl', 'nextproto_b', 'nextproto_b', 'double', 'ntohs', 'nextproto_b', 'ntohll', 'ntohll', 'nextproto_s', 'nextproto_s', 'nextproto_s', 'float', 'nextproto_b', 'nextproto_b', 'lv']), 'teleiosisunshipwrecked': ([], ['byte', 'ntohs', 'string', 'ntohl', 'byte', 'letohll', 'letohl', 'float', 'letohs', 'letohll', 'ntohs', 'letohll', 'letohl', 'double', 'letohs', 'ntohll', 'ntohs', 'ntohs', 'byte', 'letohs', 'letohl', 'letohl', 'letohll', 'letohl', 'byte', 'byte', 'lv', 'letohs']), 'systemizableepode': ([], ['double', 'ntohll']), 'epistlarcystoid': ([], ['lv', 'string', 'letohll', 'letohl', 'string', 'letohll', 'ntohll', 'byte', 'letohll', 'byte', 'letohs', 'byte', 'double', 'string', 'double', 'float', 'string', 'ntohll']), 'phenegollocalization': ([], ['byte', 'ntohl', 'letohs', 'double', 'ntohll', 'ntohl', 'string', 'ntohll', 'lv', 'letohll', 'letohl', 'ntohs', 'letohl', 'byte', 'letohl', 'letohll', 'string', 'letohll', 'double', 'string', 'ntohs', 'ntohl', 'letohll']), 'stavelessindissolubleness': ([], ['double', 'string', 'ntohll', 'ntohl', 'lv', 'letohs', 'letohll', 'letohll', 'ntohll', 'float']), 'meddlingsmall': (['roofprespur', 'sulfureasupertramp', 'interimperialvignetter', 'syphilologyannularity', 'racegoingunperformed', 'reshoedrachmae', 'nonadjustmentwritmaking', 'superabsurdditremid', 'epexegeticallyreadjournment', 'imperializetrispaston', 'raspberrylikesubvertebral', 'unhyphenedallose', 'spadelikemassacrer', 'xerophagyhematography', 'ettleoptimize', 'keraunophoneinhabited', 'northwestwardpassementerie', 'Senecanovercorruptly', 'semicolumnrankly', 'distilleryKiwanis', 'prebromidicMonopetalae', 'importationPerisphinctidae', 'changeablyzoophilitic', 'declamatorinessSerrifera', 'misproduceunthrilled', 'lepidodendridcounterplead', 'surlyreptilferous', 'wolfberrydeclaredness', 'hammerkopnegativer', 'laparotomycephalohumeralis'], ['float', 'letohl', 'double', 'byte', 'lv', 'string', 'ntohll', 'byte', 'letohll', 'nextproto_b', 'letohs', 'ntohs', 'letohll', 'nextproto_b', 'float', 'letohl', 'nextproto_b', 'byte', 'ntohs', 'nextproto_b', 'nextproto_s', 'float', 'letohl', 'lv', 'letohs', 'letohl', 'ntohll', 'ntohll', 'letohs', 'nextproto_b', 'ntohl', 'nextproto_b', 'ntohl', 'ntohll', 'nextproto_s', 'float', 'ntohs', 'float', 'letohl', 'double']), 'emblazonarsenopyrite': (['lobectomypreinflection', 'bumblefooticonology', 'hyperduliaferrateen', 'dermobranchiataboyardom', 'superestablishmentsuccor', 'Lespedezafuthorc', 'nasicornousfasciated', 'Piscataqualagoonal', 'kansrush', 'meddlingsmall', 'katabolizedermic', 'remisrepresentationlancet', 'tenodesisunroaming', 'northwestwardpassementerie', 'cancelationZoochlorella', 'crouchingpurebred', 'coeternaloverhonor', 'sharkletcompactedly', 'cosilybridecake', 'Oliveanpyromancer', 'Opisthocomidaeheterochiral', 'buttonholerindigestive', 'malthouseenteralgia', 'ineloquentundishonored', 'ureterorrhagiahemogenetic', 'dihedronsubcircuit', 'unconvenedperpetually', 'parandruspercribration', 'predefinitionCarnaria', 'pistoleerproexamination', 'simulcastriboflavin', 'unstalledneutralism', 'codeinesalience', 'proportionaltasselmaker', 'photocompositioneneuch', 'erythriticsynergidal', 'ExobasidialesEppy', 'plurifacialmicrographical', 'superabsurdditremid', 'fleaweedprobate', 'seminegroSemiticize', 'subcineritiousphrenitic', 'pseudodemocraticproconscription', 'maltingsurrection', 'domanialPhora', 'channelizeungarter', 'poonghiehectic', 'hippocampalscrow', 'subrelationsepiolite', 'pantomnesiadiporpa', 'photoheliographoctuplicate', 'unbeggarbroncholithiasis', 'Fichteanismconjobble', 'Carpathianmetanephron', 'symmetricalantimasker', 'Stromatoporoideabarry', 'listeningBroussonetia', 'Wagnerianaaviculturist', 'appendiceunmetaled', 'kleenebocJungermannia', 'crossboltedasexually', 'opportunisttitlark', 'isuroidunfitly', 'campulitropoussapogenin', 'subcostalbaldmoney', 'esophagoplastyrestrainedness', 'catafalquedree', 'delthyrialGee', 'spraysemisaprophyte', 'iconismanisostemonous', 'susurrateoutvie', 'leathermakersemishirker', 'emblazonarsenopyrite', 'epistlarcystoid', 'rosiedunarchdeacon', 'Bryumextrafocal', 'menialitypreintelligent', 'unsubstantiaterightfulness', 'hyperneuriasymbolatry', 'Sonjapylorogastrectomy', 'schuleclethraceous', 'tellurethurryproof', 'premortuarybenchy', 'laparotomycephalohumeralis'], ['byte', 'ntohll', 'ntohll', 'nextproto_s', 'letohll', 'letohl', 'byte', 'letohl', 'letohll', 'nextproto_s', 'ntohll', 'nextproto_s', 'string', 'double', 'byte', 'lv', 'byte', 'string', 'ntohll', 'byte', 'byte', 'lv', 'nextproto_b', 'nextproto_s', 'float', 'letohll', 'nextproto_b', 'double', 'letohll', 'letohll', 'ntohll', 'ntohs', 'string', 'string', 'double', 'ntohll', 'letohll', 'ntohs', 'lv', 'string']), 'galimatiasphacocystectomy': ([], []), 'reshoedrachmae': (['anomalousparallelinerved', 'schuleclethraceous', 'prelanguagecloudage', 'addressorcondensedly', 'galledisocinchomeronic', 'udometricpredefault', 'kansrush', 'misadministrationbroody', 'Triuridalesplagiarism', 'spadelikemassacrer', 'untuckedsolenoglyphic', 'usurperunplannedly', 'antleredadunc', 'visorlikeNagari', 'hypoplasyhooping', 'percontationMaimonist', 'barrelmakingparoemia', 'Philoctetessupersalesman', 'avalanchestylopization', 'roofprespur', 'hemianacusiadouble', 'Sonjapylorogastrectomy', 'carannaaccension', 'importationPerisphinctidae', 'depositoryteloblastic', 'crossboltedasexually', 'Lawsonsemiconversion', 'Sarothrawrencher', 'yawpwoodwax', 'peccationfoolery', 'cosilybridecake', 'idioglossiascabble', 'unsubstantiaterightfulness', 'Opisthocomidaeheterochiral', 'rosiedunarchdeacon', 'awiwimegaloglossia', 'provectgastrocolostomy', 'unconvenedperpetually', 'faddyamputational', 'pyrroylprobity', 'agonizefloating', 'collationdissuasively', 'opportunisttitlark', 'dermoiddiversifiable', 'dermobranchiataboyardom', 'zeuctocoelomicmetapodial', 'poonghiehectic', 'hammerkopnegativer', 'overganggenesial', 'butterrootchagrin', 'unmistgraffer', 'piskgriff', 'iconismanisostemonous', 'renverseundethroned', 'subsoilercruent', 'chytridialgoosemouth', 'responsivitykimigayo', 'epistlarcystoid', 'correctorSpirochaeta', 'tautologicpanimmunity', 'spinthariscopiclieutenancy', 'arecolidinehyalodacite', 'remisrepresentationlancet', 'appendiceunmetaled', 'bombonnefiendhead', 'retroclusionmetaphysicianism', 'woodrowelshrievalty', 'misproduceunthrilled', 'unreprovedlysprier', 'unexchangedsupraventricular', 'lemologydiplasion', 'ineloquentundishonored', 'mattapharyngological', 'parandruspercribration'], ['letohl', 'nextproto_b', 'letohll', 'nextproto_b', 'nextproto_s', 'nextproto_b', 'double', 'letohll', 'letohl', 'float', 'double', 'letohll', 'nextproto_s', 'letohs', 'float', 'float', 'nextproto_b', 'ntohs', 'letohs', 'letohl', 'letohll', 'letohl', 'letohs', 'letohll', 'float', 'letohs', 'nextproto_s', 'letohl', 'ntohs', 'ntohll', 'ntohll', 'float', 'nextproto_b', 'byte', 'float', 'string']), 'radiopaqueunrecruitable': (['xenogenesisprenoble', 'loungyimpolite', 'Pamirioversystematic', 'bullswooldraggletail', 'blepharanthracosisuncliented', 'sokarailer', 'Tullianrubidium', 'apioidalNagari', 'coeternaloverhonor', 'dermoiddiversifiable', 'prattlersuffumigate', 'Orakzaiunsatisfiedly', 'piskgriff', 'perukiershiplexicographer', 'carangoidbotryomycotic', 'superestablishmentsuccor', 'foliicolousskeletonweed', 'malthouseenteralgia', 'pilchermonaulos', 'cystocarppapaprelatical', 'barrelmakingparoemia', 'maltingsurrection', 'dehydrogenizeCambrian', 'peritrichouslyhepatoflavin', 'Steganophthalmiagnomic', 'radiopaqueunrecruitable', 'bawcockPicnickian', 'hetericismswayable', 'ornithotomyblackwort', 'multicrystallinekeratoglossus', 'unreprovedlysprier', 'cancelationZoochlorella', 'xenopodidtrencherless', 'isuroidunfitly', 'cassiteritecasemaking', 'peccationfoolery', 'wutproamusement', 'weathercockismcustodier', 'predesignateunderservice', 'spraysemisaprophyte', 'superabsurdditremid', 'saltlypropugnator', 'menialitypreintelligent', 'unmistgraffer', 'unhittabledoublehorned', 'unfannedhopperman', 'pneumodynamicsprimariness', 'sheepkeepingfeedman', 'ambisyllabicfruitful', 'crouchingpurebred', 'tellurethurryproof', 'subordinationbrachial', 'sacroposteriorveratryl', 'susurrateoutvie', 'mattapharyngological'], ['ntohs', 'ntohs', 'nextproto_b', 'double', 'nextproto_b', 'nextproto_s', 'ntohs', 'letohl', 'byte']), 'tantarabobusaurify': ([], ['ntohll', 'string', 'double', 'string', 'ntohl', 'ntohll']), 'subregenthelmeted': ([], ['double', 'double', 'ntohs', 'ntohs', 'letohl', 'ntohl', 'float', 'byte', 'double', 'ntohs', 'ntohl', 'ntohl', 'byte', 'letohs', 'ntohl', 'letohl', 'letohl', 'lv', 'double', 'ntohl', 'string', 'ntohs', 'ntohl', 'letohl', 'ntohs', 'ntohl', 'letohs', 'float', 'ntohs', 'ntohl', 'double', 'string', 'string', 'double', 'letohl']), 'urogastricjesting': (['archiereusHainan', 'Chilopsiscompactible', 'keelfathoplomachos', 'assecurationAshkenazim', 'overcriticalnesslovableness', 'Jesperyearlong', 'usurperunplannedly', 'spraysemisaprophyte', 'thymegollidflower', 'tartishlynarcotical', 'bronchiaunbaffling', 'preinjuryduplicature', 'iconismanisostemonous', 'preroyaltycoagulin', 'cinecameraHydropotes', 'pneumodynamicsprimariness', 'Sumasslevulosuria', 'SpatangusChayma', 'fetoracclimatement', 'unsilentiousskimpy', 'seminegroSemiticize', 'nowhitoffscape', 'chartermarrowy', 'algorithmicSericana', 'somnipathistcarbonometry', 'zincotypetripodic', 'reshoedrachmae', 'revenantpromisee', 'Maytimeraillike', 'OrleansSchedius', 'whusslenoreast', 'Negritohydroponicist', 'catmalisoncoevally', 'bairnlyneocosmic', 'acanthopterygianMuranese', 'phototherapistupsetted', 'limsypersistence', 'vaporizetannery', 'untrainhearkener', 'pluviographicspermatorrhea', 'stickleafethenyl', 'unodoriferousWhiggish', 'undercropArenga', 'carpolitemortifier', 'acutelyminar', 'sowbackgastrotrichan', 'petalousausterity', 'scleroblastemicpalaeocosmology', 'remirrorundepreciated', 'engrossedlyDinoceras', 'semisomnolencegunj', 'furoidbasanite', 'frontomallarforedetermine', 'predestinarianglia', 'Stromatoporoideabarry', 'syenitemanufactural', 'docimasytrouserdom', 'pentaptychBantingism', 'misadministrationbroody', 'northwestwardpassementerie', 'crouchingpurebred', 'venomouslypilferment', 'qualmyishHolocene', 'undistinctivenondisfranchised'], ['lv', 'letohs', 'ntohl', 'double', 'double', 'letohll', 'byte', 'lv', 'letohll', 'nextproto_s', 'double', 'byte', 'letohl', 'lv', 'lv', 'ntohl', 'letohs', 'float', 'ntohs', 'byte', 'nextproto_b', 'letohll', 'float', 'letohs', 'nextproto_b', 'letohs', 'byte', 'ntohs', 'double', 'ntohll', 'lv', 'ntohll', 'string', 'nextproto_s', 'double', 'letohll', 'float', 'lv', 'letohl', 'letohl', 'ntohl', 'nextproto_b', 'ntohl', 'letohll', 'nextproto_s', 'nextproto_s', 'letohs', 'ntohll', 'float']), 'Proteroglyphapiezoelectric': ([], ['ntohll', 'letohll', 'lv', 'float', 'ntohl', 'letohll', 'float']), 'hanginglypoethood': ([], ['double', 'letohll', 'letohl', 'float', 'ntohll', 'string', 'ntohs', 'string', 'byte', 'letohll', 'letohl', 'letohll', 'letohs', 'lv', 'letohl', 'byte', 'letohll', 'ntohll', 'letohl', 'float', 'letohll', 'ntohl', 'letohl', 'letohs', 'letohll', 'string', 'double', 'string', 'ntohl', 'string', 'double', 'ntohs', 'double', 'lv']), 'hyperexaltationBrachyphyllum': ([], ['letohll', 'ntohs', 'lv', 'ntohl', 'lv', 'string', 'lv', 'byte', 'lv', 'letohl', 'double', 'letohl', 'double', 'letohl', 'ntohll', 'ntohs', 'double', 'double', 'float', 'letohs', 'double', 'ntohs', 'letohl', 'lv', 'letohs', 'float', 'byte', 'float', 'float', 'ntohl', 'string', 'byte', 'ntohs', 'float', 'double', 'string', 'byte']), 'quatercentenaryferry': ([], ['float', 'ntohs', 'lv', 'lv', 'lv', 'lv', 'string', 'lv', 'lv', 'ntohll', 'string', 'double', 'ntohll', 'byte', 'ntohs', 'ntohl', 'letohs', 'letohs', 'ntohl', 'ntohll', 'letohll', 'ntohll', 'letohs', 'letohs', 'byte', 'lv', 'byte', 'letohs']), 'paralyzerthiocarbimide': (['symmetricalantimasker', 'pellagrosemongrelization', 'refilmopenhandedness', 'hemianacusiadouble', 'whusslenoreast', 'doubleheartedstaphylolysin', 'katabolizedermic', 'focoidsstackfreed', 'menialitypreintelligent', 'prattlersuffumigate', 'Voltaprotarsal', 'idioglossiascabble', 'sokarailer', 'superestablishmentsuccor', 'cannotdentigerous', 'napalmbrevifoliate', 'sheepkeepingfeedman', 'pneumodynamicsprimariness', 'paralyzerthiocarbimide', 'grapedmassively', 'shuttlecockscanmag', 'goniometerhexameral', 'carangoidbotryomycotic', 'dehydrogenizeCambrian', 'nonadjustmentwritmaking', 'outworthbenevolence', 'Fichteanismconjobble', 'surlyreptilferous', 'overgenialitybuzzle', 'visorlikeNagari', 'iconismanisostemonous', 'piskgriff', 'stickleafethenyl', 'Bryumextrafocal', 'barrelmakingparoemia', 'hyperduliaferrateen', 'maltingsurrection', 'veldcraftsubprefect', 'radiopaqueunrecruitable', 'foliicolousskeletonweed', 'polyspermatouscreationistic', 'Tullianrubidium', 'hookahsupersimplicity', 'dermoiddiversifiable', 'ineloquentundishonored', 'sageshipcarcoon', 'tautoousianentente', 'weathercockismcustodier', 'picayunishapogeotropic', 'Triuridalesplagiarism', 'Steganophthalmiagnomic', 'antleredadunc', 'epigenesistbisexed', 'cesserreichspfennig', 'carannaaccension', 'unconvenedperpetually', 'subcineritiousphrenitic', 'overhollowescort', 'bumblefooticonology', 'crossboltedasexually', 'peccationfoolery', 'utterabilitypavement', 'frolickytriphyline', 'unfannedhopperman', 'byworkplastid', 'woodrowelshrievalty', 'multicrystallinekeratoglossus', 'steelworkpsychophysiological', 'unlasheddialyzable', 'saltlypropugnator', 'udometricpredefault', 'superabsurdditremid'], ['lv', 'float', 'nextproto_b', 'ntohs', 'ntohs', 'ntohl', 'float', 'letohs', 'string', 'nextproto_s', 'letohl', 'double', 'letohs', 'byte', 'letohl', 'byte', 'letohll', 'letohll', 'string', 'letohll', 'letohll', 'letohs', 'nextproto_b', 'double', 'nextproto_s', 'float', 'letohs', 'nextproto_b', 'letohs', 'nextproto_s', 'double', 'letohs', 'nextproto_s', 'ntohll', 'nextproto_b', 'ntohl', 'float', 'ntohl', 'letohl', 'letohs', 'nextproto_b']), 'Trinorantumpyramides': (['micrencephalypalpus', 'ruinlikesilva', 'cylindrarthrosisnonplusation', 'Fichteanismconjobble', 'awiwimegaloglossia'], ['ntohs', 'double', 'float', 'float', 'ntohll', 'letohl', 'nextproto_s', 'float', 'letohll', 'double', 'letohs', 'letohll', 'letohl', 'nextproto_b', 'lv', 'float', 'lv', 'letohs', 'ntohs', 'letohs', 'letohll', 'double', 'string', 'nextproto_b', 'ntohs', 'ntohs', 'letohs', 'nextproto_b', 'letohll', 'letohll', 'string', 'double', 'nextproto_b', 'nextproto_b', 'ntohs', 'letohs', 'letohll', 'double', 'double', 'letohl', 'lv', 'nextproto_b', 'ntohll', 'nextproto_s', 'letohs', 'ntohl', 'lv', 'double', 'double', 'nextproto_s']), 'misproduceunthrilled': ([], ['string', 'lv', 'nextproto_s', 'byte', 'letohs', 'letohll', 'byte', 'letohs', 'string', 'letohs', 'ntohl', 'ntohl', 'nextproto_b', 'ntohll', 'ntohll', 'letohll', 'nextproto_s', 'byte', 'lv', 'lv', 'lv', 'nextproto_b', 'ntohs', 'nextproto_s']), 'gluttonousprebend': (['subordinationbrachial', 'valvotomypensionably', 'overkneePolypoda', 'unlasheddialyzable', 'mammillationpemphigous', 'retickettopotaxis', 'ettleoptimize', 'distilleryKiwanis', 'cacuminalgastrohysterorrhaphy', 'tautoousianentente', 'excentricalProtococcales', 'Orakzaiunsatisfiedly', 'receptivelynonshredding', 'thiodiphenylaminediterpene', 'unbeggarbroncholithiasis', 'carangoidbotryomycotic', 'reburstsummity', 'Slovenerecure', 'pneumodynamicsprimariness', 'unmooredtowy', 'merseglobular', 'polishedlyhematosis', 'flashpanstature', 'brackishrehazard', 'chromophilouspyometra', 'antiphonybackplate', 'hetericismswayable', 'surlyreptilferous', 'piperitiousreekingly', 'ancestorialLicania', 'tellurethurryproof', 'untuckedsolenoglyphic', 'dunneaneuploidy', 'peragratemultifoliate', 'alkaneirrigable', 'counterspyingdungeon', 'unfootedHilary', 'laparotomycephalohumeralis', 'yinsttenderness', 'nookingspellword', 'mediumismgypsyism', 'nonaugmentativehypertelic', 'idioglossiascabble', 'proteosomalsuppletion', 'archaeologyapiin', 'redifferentiationmustachio', 'autoplastycava', 'steelworkpsychophysiological', 'hookahsupersimplicity', 'zooperalorganotin', 'snakeletwounds', 'loketprincipiate', 'contrarietyinconceivableness', 'unquailingshive', 'depositumspiritsome', 'ulnaleptodactyl', 'Spongiaealcelaphine', 'intwistpunter', 'dookmainport', 'monogamianportio', 'declamatorinessSerrifera', 'frolickytriphyline', 'cynophileLobale', 'cassiteritecasemaking', 'heronerchondroplasty', 'togueseaflower', 'qualmyishHolocene', 'epitrophygoatlike', 'hyperneuriasymbolatry', 'iodolabsolutistic', 'leadstonehypovitaminosis', 'snackmisinstruction', 'turbidlycorticoefferent', 'outdoortenorister', 'homozygotemagicalize', 'orthotonicquab', 'northwestwardpassementerie', 'hypoplasyhooping', 'evaluecystatrophia', 'vitriolizemonal', 'Chilopsiscompactible', 'unscalednessChamaeleon', 'microcaltropmyosarcomatous', 'psilotaceousectozoan', 'nondistributionclitellus', 'tenodesisunroaming', 'ciderishazury', 'withsavesatinize'], ['letohl', 'ntohl', 'nextproto_s', 'lv', 'letohll', 'ntohll', 'byte', 'lv', 'letohl', 'letohll', 'double', 'lv', 'float', 'string', 'nextproto_b', 'letohll', 'double']), 'etioporphyrinpubovesical': ([], ['ntohl', 'ntohs', 'string', 'lv', 'ntohll', 'float', 'float', 'double', 'float', 'letohll', 'float', 'ntohll', 'ntohl', 'float', 'ntohl', 'letohl', 'ntohl', 'ntohl', 'ntohs', 'double', 'ntohl', 'letohl', 'ntohl', 'letohs', 'letohl', 'double', 'letohll', 'string', 'letohl', 'float', 'ntohs', 'letohl', 'byte', 'ntohll']), 'dejectedincreasing': ([], ['float', 'letohl', 'ntohl', 'string', 'ntohl', 'ntohll', 'ntohs', 'letohs', 'letohl', 'double', 'ntohll', 'ntohll', 'ntohl', 'letohll', 'letohs', 'string', 'ntohl', 'float', 'float', 'byte', 'ntohll', 'letohl', 'letohll', 'letohl', 'byte', 'letohll', 'lv', 'ntohs', 'string', 'lv', 'letohl', 'letohll', 'letohl']), 'blossomscrimshander': ([], ['letohs', 'letohl', 'ntohll', 'lv', 'lv', 'lv', 'ntohl', 'letohl', 'ntohl', 'ntohl', 'letohll', 'byte', 'float', 'ntohll', 'letohl', 'letohl', 'double', 'letohll', 'ntohl', 'letohs', 'ntohs', 'ntohs', 'float', 'ntohs', 'ntohl', 'ntohl', 'string', 'byte', 'letohs', 'letohl', 'byte', 'ntohl', 'ntohs', 'ntohl', 'lv', 'ntohll', 'ntohs', 'lv', 'ntohl', 'float', 'string', 'ntohll', 'float']), 'cephaloconicunbaptized': ([], ['double', 'ntohl', 'letohl', 'letohs', 'byte', 'byte', 'string', 'float', 'ntohll']), 'skeegalveoloclasia': (['reshoedrachmae', 'oversolicitouslyhour', 'chytridialgoosemouth', 'Mayorunahybridizer', 'membershiptownsboy', 'schuleclethraceous', 'foliicolousskeletonweed', 'ineloquentundishonored', 'mediumismgypsyism', 'tollgateandrophagous', 'enclothearmiferous', 'hancesmoothness', 'predestinarianglia', 'ettleoptimize', 'echinostomewont', 'Bharatadomain', 'volubilityThuidium', 'countrymanisodimorphism', 'limsypersistence', 'Physciawenny', 'catmalisoncoevally', 'galledisocinchomeronic', 'amaranthoidunpulleyed', 'haabdimeric', 'interventraliaforeutter', 'funestworser', 'warneriodocasein', 'placitumunmortgage', 'multicrystallinekeratoglossus', 'notwitch', 'hemianacusiadouble', 'outdoortenorister', 'hypoplasyhooping', 'respitelesssuccenturiation', 'Boneyretreater', 'awiwimegaloglossia', 'warfaringdraghound', 'congregationalvocimotor', 'cystocarppapaprelatical', 'tumoredcrocodilite', 'teleiosisunshipwrecked', 'katabolizedermic', 'Triuridalesplagiarism', 'pedestrianateStromateidae', 'dinitrilholocentrid', 'mataiuntameness', 'bombonnefiendhead', 'adminiculatephosphosilicate', 'inwrapbilophodont', 'concussionalmonobromoacetanilide', 'visorlikeNagari', 'paleocrystallinespinulosodenticulate', 'correctorSpirochaeta', 'sharkletcompactedly', 'intergeneratingruneword', 'Castoroidespentacrinite', 'outvenomviameter', 'outfeatvasodilator', 'cylindrarthrosisnonplusation', 'antiviraltackety', 'sageshipcarcoon', 'amlipyrexic', 'untuckedsolenoglyphic', 'Paridaeamylum', 'unfootedHilary', 'tintsausinger'], ['byte', 'string', 'letohl', 'string', 'double', 'letohll', 'double', 'string']), 'unlasheddialyzable': ([], ['byte', 'byte', 'ntohs', 'ntohs', 'double', 'byte', 'ntohs']), 'mallemuckyawner': ([], ['byte', 'double', 'float', 'letohl', 'ntohl', 'ntohll', 'byte', 'ntohl', 'letohs', 'ntohs', 'byte', 'ntohs', 'lv', 'string', 'double']), 'ophthalmalgiamisproduce': (['fetoracclimatement', 'orographicniddick', 'pedestrianateStromateidae', 'SpatangusChayma', 'asperationoraculousness', 'querulouslycooky', 'campulitropoussapogenin', 'tongueshoticonophilism', 'asteamincandescency', 'strainedlypsychopompos'], ['float', 'byte', 'ntohll', 'double', 'ntohll', 'letohll', 'string', 'ntohll', 'letohl', 'byte', 'ntohs', 'ntohl', 'ntohl', 'string', 'double', 'string', 'letohll', 'letohl', 'ntohll', 'ntohl', 'letohll', 'string', 'string', 'float', 'nextproto_b']), 'uncomminutedcommix': (['antleredadunc', 'recapitalizerelevate', 'esophagoplastyrestrainedness', 'zoosporangialbuyable', 'iconismanisostemonous', 'outfeatvasodilator', 'trentepohliaceousHectorean', 'picayunishapogeotropic', 'carannaaccension', 'maltingsurrection', 'cinecameraHydropotes', 'precoxseambiter', 'addressorcondensedly', 'fleaweedprobate', 'subordinationbrachial', 'pilchermonaulos', 'undercovertcoloss', 'Lespedezafuthorc', 'ornithotomyblackwort', 'crouchingpurebred', 'vaporizetannery', 'semiduplexskirt', 'semicolumnrankly', 'Orakzaiunsatisfiedly', 'scutcheonwiseileocolitis', 'symptosissubcorneous', 'woodrowelshrievalty', 'symmetricalantimasker', 'Triuridalesplagiarism', 'napalmbrevifoliate', 'hookahsupersimplicity', 'correctorSpirochaeta', 'overgenialitybuzzle', 'gumdiggingsalvarsan', 'veldcraftsubprefect', 'querulouslycooky', 'piskgriff', 'refilmopenhandedness', 'unreprovedlysprier', 'predesignateunderservice', 'chytridialgoosemouth', 'unmistgraffer', 'lepidodendridcounterplead', 'ambisyllabicfruitful', 'paleobotanyworkpeople', 'Piscataqualagoonal', 'unconvenedperpetually', 'xenopodidtrencherless', 'uncatholicizeSiphonognathus', 'Vandiemenianwinery', 'declamatorinessSerrifera', 'microcrystallogenyfuniculus', 'ineloquentundishonored'], ['letohs', 'double', 'string', 'string', 'ntohs', 'byte', 'nextproto_s', 'letohll', 'ntohl', 'ntohl']), 'Triuridalesplagiarism': ([], ['ntohs', 'ntohs', 'letohs', 'string', 'ntohl', 'float', 'float', 'float', 'byte', 'byte', 'lv', 'byte', 'ntohll', 'string', 'double', 'string', 'letohs']), 'butyrochloralfertilizational': ([], ['letohs', 'string', 'float', 'byte', 'ntohl', 'double', 'ntohll', 'lv', 'letohll', 'letohl', 'ntohl', 'string']), 'hematozoalinfinitarily': ([], []), 'tartishlynarcotical': ([], ['float', 'ntohll', 'byte', 'string', 'byte', 'ntohs', 'byte', 'double', 'letohll', 'letohll', 'byte', 'string', 'string', 'ntohll', 'ntohl', 'ntohs', 'letohl', 'float', 'double', 'ntohl', 'byte', 'string', 'letohl', 'double', 'letohll', 'ntohs', 'ntohs', 'letohll', 'byte']), 'interimperialvignetter': ([], ['ntohll']), 'wolfberrydeclaredness': ([], ['ntohl', 'letohll', 'float', 'ntohs', 'letohs', 'double', 'ntohs', 'float', 'ntohs', 'ntohs', 'letohs', 'letohll', 'letohs']), 'mattapharyngological': ([], ['lv', 'float', 'string', 'string', 'ntohll', 'float', 'letohll', 'lv', 'byte', 'letohl', 'float', 'ntohll', 'letohl', 'string', 'ntohs', 'letohll', 'ntohs', 'letohs', 'ntohl', 'string', 'byte', 'letohl']), 'Tullianrubidium': ([], ['ntohl', 'lv', 'double', 'letohs', 'double', 'lv', 'letohs']), 'organoantimonypreoperator': ([], ['lv', 'ntohl', 'double', 'ntohll', 'lv', 'byte', 'letohll', 'byte', 'letohll', 'ntohl', 'ntohll', 'lv', 'double', 'lv', 'float', 'string', 'letohll', 'float', 'string', 'letohll', 'ntohs', 'lv', 'string', 'letohl', 'string']), 'racegoingunperformed': (['dehydrogenizeCambrian', 'napalmbrevifoliate', 'xenopodidtrencherless', 'opportunisttitlark', 'unreprovedlysprier', 'chaffererunheaded', 'Vandiemenianwinery', 'bumblefooticonology', 'apioidalNagari', 'iconismanisostemonous', 'maltingsurrection', 'roofprespur', 'shortcakeabase', 'usurperunplannedly', 'cassiteritecasemaking', 'dermoiddiversifiable', 'ochronosusafterbody', 'Lespedezafuthorc', 'menialitypreintelligent', 'multicrystallinekeratoglossus', 'udometricpredefault', 'unconvenedperpetually', 'Bryumextrafocal', 'crouchingpurebred', 'ineloquentundishonored', 'counterpotentMetabola', 'weathercockismcustodier', 'symmetricalantimasker', 'catmalisoncoevally', 'carangoidbotryomycotic', 'Stromatoporoideabarry', 'hammerkopnegativer', 'mattapharyngological', 'hyperneuriasymbolatry', 'xenogenesisprenoble', 'unbeggarbroncholithiasis', 'overhollowescort', 'collationdissuasively', 'bawcockPicnickian', 'epigenesistbisexed', 'woodrowelshrievalty', 'syphilologyannularity', 'cannotdentigerous', 'esophagoplastyrestrainedness', 'saltlypropugnator', 'strangulableargentamid', 'extravagantkaryoplasmatic', 'unmistgraffer', 'frolickytriphyline', 'vaporizetannery', 'Piscataqualagoonal', 'barrelmakingparoemia', 'tautoousianentente', 'cardialgiacontingence', 'intrathoraciccoemployment', 'anomalousparallelinerved', 'retroclusionmetaphysicianism', 'unhittabledoublehorned', 'subordinationbrachial', 'hetericismswayable', 'pilchermonaulos', 'sacroposteriorveratryl', 'malthouseenteralgia', 'sheepkeepingfeedman', 'peritrichouslyhepatoflavin', 'asperationoraculousness', 'sokarailer', 'chytridialgoosemouth', 'ornithotomyblackwort'], ['ntohl', 'float', 'string', 'double', 'ntohs', 'letohl', 'float', 'letohs', 'letohll', 'letohl', 'letohll', 'letohl', 'lv', 'float', 'letohll', 'byte', 'ntohs', 'ntohs', 'byte', 'ntohl', 'letohll', 'letohs', 'ntohll', 'nextproto_b', 'byte', 'letohl', 'ntohs', 'letohll', 'nextproto_b', 'ntohll', 'string', 'float', 'nextproto_s', 'ntohs', 'ntohs', 'nextproto_s', 'letohl', 'nextproto_s', 'ntohl', 'nextproto_b', 'nextproto_s']), 'loungyimpolite': ([], ['byte', 'ntohl', 'ntohll', 'letohl', 'ntohl', 'float', 'ntohll', 'double', 'byte', 'string', 'byte', 'float', 'ntohll', 'float', 'double', 'byte', 'ntohll', 'letohl', 'letohl', 'letohll', 'letohl', 'letohll', 'double', 'letohll', 'letohll', 'byte', 'ntohll']), 'theretowardmoosebird': ([], ['letohs', 'lv', 'letohll', 'letohl', 'letohs', 'letohll', 'letohl', 'double', 'letohs', 'letohs']), 'demibeastuninflicted': ([], ['letohl', 'byte', 'string', 'float', 'lv', 'letohll', 'byte', 'byte', 'double', 'float']), 'prebromidicMonopetalae': (['asperationoraculousness', 'outfeatvasodilator', 'huddlingcladautoicous', 'surlyreptilferous', 'avalanchestylopization', 'Senecanovercorruptly', 'buttonholerindigestive', 'terribletaut', 'baptizeeFrenchize', 'shortcakeabase', 'spraysemisaprophyte', 'tongueshoticonophilism', 'allerChilostoma', 'indirecthierarchism', 'countryfolkintolerance', 'organoantimonypreoperator', 'warneriodocasein', 'Bryumextrafocal', 'endogalvanismunwarrantedly', 'overganggenesial', 'usurperunplannedly', 'crouchingpurebred', 'TelopeaCyclotosaurus', 'scruplercellulifugal', 'unlasheddialyzable', 'napalmbrevifoliate', 'hyperduliaferrateen', 'cancelationZoochlorella', 'malthouseenteralgia', 'strangulableargentamid', 'utterabilitypavement', 'domanialPhora', 'pilchermonaulos', 'spadelikemassacrer', 'pellagrosemongrelization', 'cylindrarthrosisnonplusation', 'appendiceunmetaled', 'Cobitidaedismissal', 'uncomminutedcommix', 'paralyzerthiocarbimide', 'archsnoblodgepole', 'reladepropiolaldehyde', 'katabolizedermic', 'Erotylidaeprehesitate', 'hyperneuriasymbolatry', 'interventraliaforeutter', 'catafalquedree', 'shuttlecockscanmag', 'stakeholderunforbade', 'unhittabledoublehorned', 'manageriallyflanger', 'lepidodendridcounterplead', 'Lawsonsemiconversion', 'foliicolousskeletonweed', 'overpoliticunderlooker', 'arhatsporozoic', 'counterpotentMetabola', 'misspellquinaldic', 'noggencapitulate', 'sulphhemoglobinHerculanean', 'scheltopusikAmpelidaceae', 'phototherapistupsetted', 'untuckedsolenoglyphic', 'unreprovedlysprier', 'galledisocinchomeronic', 'snakeletwounds', 'Slovenerecure', 'Fichteanismconjobble', 'predefinitionCarnaria', 'chaffererunheaded', 'collationdissuasively', 'arecolidinehyalodacite', 'reburstsummity', 'scutcheonwiseileocolitis', 'Dokoelectrochemically', 'piskgriff', 'channelizeungarter', 'raspberrylikesubvertebral', 'unfannedhopperman', 'cesserreichspfennig', 'codeinesalience', 'ricketssubtrihedral', 'subsorterbecuffed', 'preinjuryduplicature', 'eudaemonisticallyCoccolobis', 'bairnlyneocosmic', 'cerebroidodontolcate', 'slichtarradiddler', 'yawpwoodwax', 'pinkberrynonvillainous', 'lindengamy', 'carangoidbotryomycotic', 'schuleclethraceous', 'querulouslycooky', 'Stromatoporoideabarry', 'listeningBroussonetia'], ['string', 'string', 'ntohll', 'byte', 'letohl', 'ntohl', 'byte', 'ntohl', 'ntohll', 'lv', 'nextproto_b', 'nextproto_b']), 'picturedomArchaeopteris': (['Voltaprotarsal', 'ruinlikesilva', 'munjmuchness', 'pseudodemocraticproconscription', 'hyperneuriasymbolatry', 'unlasheddialyzable', 'tonguinessresoundingly', 'appendiceunmetaled', 'apioidalNagari', 'remisrepresentationlancet', 'preformisticexemplifiable', 'subsoilercruent', 'galvanothermometerBalzacian', 'whitewareCladoselachidae', 'somnipathistcarbonometry', 'archcrownundistantly', 'scheltopusikAmpelidaceae', 'alkargenmoop', 'zeuctocoelomicmetapodial', 'manageriallyflanger', 'popeyednaphtha', 'paralyzerthiocarbimide', 'sageshipcarcoon', 'predestinarianglia', 'hematozoalinfinitarily', 'urningsubpubescent', 'raspberrylikesubvertebral', 'bemuzzlesurficial', 'nasicornousfasciated', 'unsubstantiaterightfulness', 'gymnosporouswoubit', 'malthouseenteralgia', 'counterpotentMetabola', 'erythriticsynergidal', 'Vickyimmigrant', 'reshoedrachmae', 'congregationalvocimotor', 'maskflowerkeynoter', 'sowbackgastrotrichan', 'togueseaflower', 'rathmemorizable', 'plurifacialmicrographical', 'unbeggarbroncholithiasis', 'prosubscriptiontribracteate', 'thymegollidflower', 'allottrichopterous', 'postiquedefeasibility', 'prerailwaycannibalistically', 'spraysemisaprophyte', 'hammerkopnegativer', 'cancelationZoochlorella'], ['string', 'ntohs', 'ntohll', 'byte', 'float', 'nextproto_b', 'double', 'letohll', 'string', 'string', 'ntohs', 'float', 'float', 'nextproto_b', 'byte', 'lv', 'string', 'nextproto_s', 'letohll', 'letohll', 'double', 'ntohs', 'letohll', 'letohs']), 'cesserreichspfennig': ([], ['lv', 'string', 'ntohs', 'letohs', 'letohl', 'float', 'string', 'letohl', 'byte', 'byte', 'letohl', 'lv', 'ntohll', 'double', 'string', 'byte', 'letohl', 'ntohs', 'ntohl', 'float', 'string', 'letohll', 'letohs', 'letohs', 'double', 'double', 'ntohs', 'double', 'ntohll', 'float', 'byte', 'letohll', 'string', 'letohs', 'byte']), 'sageshipcarcoon': ([], ['double', 'double', 'ntohll', 'float', 'ntohs', 'string', 'float', 'byte', 'ntohs', 'letohs', 'string', 'lv', 'ntohs', 'letohs', 'double', 'byte', 'letohl', 'ntohl', 'ntohl', 'letohll', 'ntohl', 'letohs', 'ntohs', 'letohll', 'float', 'ntohll', 'letohll', 'ntohs', 'string', 'float', 'ntohl', 'string', 'float', 'ntohll']), 'napalmbrevifoliate': ([], ['string', 'ntohs', 'string', 'float', 'double', 'letohl', 'letohll', 'byte', 'double', 'letohs', 'letohl', 'ntohll', 'ntohll', 'letohs', 'ntohl', 'string', 'letohll', 'float', 'letohll', 'letohl', 'ntohll', 'letohll', 'string', 'letohll']), 'twinklybingo': (['unpaintterebinic', 'nonaugmentativehypertelic', 'isuroidunfitly', 'amlipyrexic'], ['ntohl', 'ntohl', 'ntohl', 'ntohll', 'byte', 'nextproto_s', 'ntohll', 'letohl', 'letohs', 'ntohs', 'letohl', 'lv', 'letohs', 'nextproto_s', 'letohll', 'double', 'nextproto_b', 'double', 'nextproto_s', 'float', 'float', 'double', 'string', 'byte', 'string', 'byte', 'ntohs', 'ntohs', 'letohl', 'letohll', 'letohl', 'ntohs', 'ntohs', 'float', 'lv']), 'consignificationmarshbuck': (['Mayorunahybridizer', 'coinbellmaker', 'udometricpredefault', 'rathmemorizable', 'flashpanstature', 'Ibaditehypotenuse', 'perukiershiplexicographer', 'butyrochloralfertilizational', 'ornithotomyblackwort', 'hallowerhydrophthalmos', 'Toryizesynechthran', 'loungyimpolite', 'xenopodidtrencherless', 'Nathanielbiliteral', 'predestinarianglia', 'summarizationyatter', 'refilmopenhandedness', 'stagemansupa', 'syphilologyannularity', 'catagmaticMegalosaurus', 'utterabilitypavement', 'oversoldafield', 'unvoiceCamacan', 'plurifacialmicrographical', 'renverseundethroned', 'refallGanguela', 'arecolidinehyalodacite', 'petalousausterity', 'unaccuracyblepharoadenitis', 'barrelmakingparoemia', 'addressorcondensedly', 'venomouslypilferment', 'cardinghygeistic', 'laterodeviationNarciss', 'maskflowerkeynoter', 'mausoleandecasualize', 'outlawrypervertedness', 'sideflashmagniloquent', 'asperationoraculousness', 'iridemiabisque', 'Oliveanpyromancer', 'holdsmanoversalty', 'Slovenerecure', 'Abrahamicinordinateness', 'counterpotentMetabola', 'unimplicitoothecal', 'triplewisepostepileptic', 'tellurethurryproof', 'lamellicornousPolygonaceae', 'unsanctioningperiuvular', 'apioidalNagari', 'Heterodactylaefrisk', 'cylindrarthrosisnonplusation', 'gratefulAlcedinidae', 'logarithmeticallydeliriant', 'unexchangedsupraventricular', 'hyperneuriasymbolatry', 'paralyzerthiocarbimide', 'tenesmicHymettic', 'Eomecondiscolorate', 'subsorterbecuffed', 'unfeasiblecollodiotype', 'peritrichouslyhepatoflavin', 'hyperduliaferrateen', 'overedgeevangelican', 'bumblefooticonology', 'overgenialitybuzzle', 'docimasytrouserdom', 'arhatsporozoic', 'ancestorialLicania', 'Suionesunprejudicially', 'Jesperyearlong', 'unflukedcleck', 'hungerlysphenocephaly', 'leucoencephalitisconsistent', 'Stromatoporoideabarry', 'strangulableargentamid', 'Senecanovercorruptly'], ['ntohs', 'ntohll', 'ntohll', 'ntohll', 'ntohll', 'ntohl', 'ntohs', 'letohl', 'letohll', 'letohl', 'letohll', 'letohl', 'nextproto_b', 'lv', 'ntohl', 'letohl', 'double', 'byte', 'double', 'lv', 'letohll', 'lv', 'letohll', 'float', 'nextproto_s', 'ntohl', 'float', 'letohll', 'string', 'float', 'letohl']), 'onomatopoeiaeggfish': ([], ['letohll', 'letohs', 'ntohs', 'letohs', 'letohl', 'ntohll', 'ntohs', 'letohl', 'string', 'float', 'letohs', 'letohl', 'letohl', 'letohl', 'double', 'float', 'float', 'ntohl', 'letohll', 'float', 'ntohs', 'letohs', 'letohll', 'ntohl', 'double', 'ntohll', 'ntohll', 'ntohl', 'lv', 'letohs', 'ntohl', 'letohl', 'byte', 'string', 'ntohll', 'letohs', 'letohl', 'ntohs', 'letohll', 'letohs']), 'proportionaltasselmaker': (['unbeggarbroncholithiasis', 'hyperduliaferrateen', 'percontationMaimonist', 'misproduceunthrilled', 'hookahsupersimplicity', 'channelizeungarter', 'Mayorunahybridizer', 'tenodesisunroaming', 'bawcockPicnickian', 'usurperunplannedly', 'dehydrogenizeCambrian', 'parathyroidectomizeoutheart', 'mattapharyngological', 'dissogenyBarney', 'Philonismpinivorous', 'gatewiseunderpot', 'outworthbenevolence', 'chaffererunheaded', 'utterabilitypavement', 'Vandiemenianwinery', 'asepticallyBernese', 'feveretunderbox', 'herpetologistindeed', 'TelopeaCyclotosaurus', 'esophagoplastyrestrainedness', 'visorlikeNagari', 'overhollowescort', 'collationdissuasively', 'napalmbrevifoliate', 'Cobitidaedismissal', 'unpopulatecurry', 'denieragedrapery', 'zoosporangialbuyable', 'Lawsonsemiconversion', 'menialitypreintelligent', 'cystocarppapaprelatical', 'ochronosusafterbody', 'focoidsstackfreed', 'doubleheartedstaphylolysin', 'stickleafethenyl', 'extravagantkaryoplasmatic', 'shortcakeabase', 'piskgriff', 'ambisyllabicfruitful', 'antleredadunc', 'fetoracclimatement'], ['ntohs', 'ntohs', 'letohl', 'letohs', 'ntohs', 'byte', 'letohs', 'letohs', 'double', 'ntohs', 'string']), 'evaluecystatrophia': ([], ['double', 'lv', 'ntohll', 'ntohll', 'byte', 'double', 'byte', 'string']), 'simpletonianreformulate': ([], ['ntohs', 'ntohl', 'ntohl', 'ntohs', 'ntohl', 'letohs', 'double', 'byte', 'letohs', 'letohll', 'letohll', 'lv', 'ntohs', 'lv', 'float', 'ntohll', 'lv', 'ntohl', 'string', 'string', 'byte', 'lv', 'ntohl', 'double', 'letohs', 'double', 'ntohs', 'float', 'double', 'letohs', 'letohl', 'lv', 'letohs']), 'receptivelynonshredding': ([], ['ntohs', 'ntohl', 'letohl', 'ntohll', 'float', 'ntohl', 'byte', 'double', 'letohll', 'string']), 'zeuctocoelomicmetapodial': ([], ['letohs', 'byte', 'byte', 'string', 'ntohl', 'ntohl', 'letohl', 'byte', 'ntohs', 'ntohs', 'string', 'letohl', 'string', 'lv', 'letohs', 'lv', 'letohl', 'letohll', 'letohll', 'double', 'ntohll', 'byte', 'byte', 'ntohll', 'ntohl', 'lv', 'letohs', 'letohs', 'letohl', 'letohl', 'ntohll', 'byte', 'ntohs']), 'arsheenperspiration': ([], ['byte', 'ntohl', 'letohl', 'lv', 'ntohs', 'letohll', 'lv', 'ntohs', 'double', 'ntohll', 'ntohl', 'ntohs', 'double', 'letohll', 'ntohs', 'letohl', 'letohl', 'ntohl', 'float', 'byte', 'letohl', 'byte', 'letohl', 'lv', 'ntohs', 'ntohll', 'ntohs', 'ntohl', 'ntohl', 'float', 'ntohs', 'ntohs', 'letohl', 'float', 'letohll', 'byte', 'byte', 'ntohs', 'string', 'lv', 'lv', 'double', 'float', 'letohll']), 'cophosisclour': ([], ['letohll', 'string', 'lv', 'lv', 'ntohl', 'letohs', 'letohs', 'float', 'byte', 'ntohll', 'ntohs', 'letohs', 'lv', 'ntohl', 'ntohs', 'float', 'ntohs', 'ntohll', 'letohs', 'letohl', 'letohs', 'ntohll', 'float', 'ntohs', 'letohl', 'double', 'ntohs', 'ntohs', 'ntohs', 'float', 'letohl', 'letohll', 'double', 'float', 'ntohll', 'letohs', 'letohs', 'string']), 'disjointedlytriamylose': ([], ['letohl', 'letohll', 'lv', 'ntohs', 'string', 'ntohl', 'lv', 'lv', 'ntohs', 'ntohl', 'letohll', 'string', 'ntohs', 'string', 'lv', 'double', 'letohs', 'float']), 'coinbellmaker': ([], ['float', 'lv', 'letohll', 'byte', 'ntohs', 'string', 'byte', 'ntohll', 'ntohl', 'float', 'lv', 'byte', 'letohs', 'byte', 'float', 'letohs', 'ntohll']), 'Philonismpinivorous': ([], ['string', 'ntohll', 'ntohs', 'lv', 'byte', 'letohll', 'letohll', 'string', 'ntohl', 'float', 'ntohl', 'ntohs', 'lv', 'letohl', 'letohl', 'ntohll', 'letohl', 'string', 'ntohll', 'ntohs', 'byte', 'ntohl', 'letohl', 'lv', 'double', 'byte', 'letohll', 'byte', 'ntohl', 'float', 'ntohll', 'letohll', 'ntohl', 'letohs', 'letohll', 'letohll', 'ntohl', 'ntohs', 'ntohs', 'letohs', 'ntohs']), 'trentepohliaceousHectorean': ([], ['byte', 'letohs', 'byte', 'lv', 'letohll', 'byte', 'ntohll', 'ntohl', 'ntohl', 'letohl', 'letohl', 'float', 'ntohl', 'ntohl', 'byte', 'letohll', 'lv', 'ntohll', 'letohll']), 'collationdissuasively': ([], ['float', 'letohs', 'ntohl', 'ntohs', 'double', 'ntohl', 'ntohs', 'ntohl', 'string', 'ntohll', 'lv', 'byte', 'letohll', 'letohl', 'ntohs', 'lv']), 'unmooredtowy': ([], ['ntohl', 'letohl', 'double', 'string', 'letohll', 'ntohl', 'byte', 'byte', 'string', 'letohl', 'ntohll', 'float', 'double', 'lv', 'letohs', 'double', 'float', 'ntohs', 'letohl', 'ntohl', 'ntohl', 'byte', 'letohll', 'lv', 'ntohll', 'ntohs', 'letohs', 'letohll', 'letohl', 'letohll', 'ntohl', 'float', 'lv', 'letohl', 'ntohl', 'float', 'letohl', 'double', 'double']), 'thymegollidflower': ([], ['ntohll', 'string', 'string', 'ntohll', 'ntohs', 'lv', 'double', 'string', 'ntohll', 'double', 'string', 'float', 'string', 'letohll', 'letohl']), 'dissuasivenessnondeforestation': ([], ['byte', 'byte', 'double', 'float', 'float', 'byte', 'double', 'byte', 'string', 'string', 'ntohs', 'letohs', 'string', 'ntohl', 'ntohll', 'ntohll', 'byte', 'byte', 'ntohs', 'letohll', 'letohs', 'ntohl', 'byte', 'double', 'ntohs', 'lv', 'ntohs']), 'acanthopterygianMuranese': (['unfeasiblecollodiotype', 'motacillinewidespreadly', 'evaluecystatrophia', 'hetericismswayable', 'ciderishazury', 'schuleclethraceous', 'huddlingcladautoicous', 'esophagoplastyrestrainedness', 'grapedmassively', 'monodromiclyretail', 'correctorSpirochaeta', 'unlasheddialyzable', 'coxbonesbirle', 'goniometerhexameral', 'baptizeeFrenchize', 'phenomenalisticallyunmomentary', 'blepharanthracosisuncliented', 'steelworkpsychophysiological', 'ettleoptimize', 'Mayorunahybridizer', 'recapitalizerelevate', 'campulitropoussapogenin', 'intwistpunter', 'faddyamputational', 'warfaringdraghound', 'meddlingsmall', 'acquisitumvaletudinarist', 'saltlypropugnator', 'Bryumextrafocal', 'pellagrosemongrelization', 'pilchermonaulos', 'Suionesunprejudicially', 'uncatholicizeSiphonognathus', 'sharkletcompactedly', 'assecurationAshkenazim', 'katabolizedermic', 'engrossedlyDinoceras', 'tecalipalingenesy'], ['string', 'ntohll', 'ntohl', 'letohs', 'double', 'nextproto_s', 'ntohs', 'nextproto_b', 'ntohs', 'lv', 'float', 'byte', 'letohs', 'nextproto_b', 'lv', 'nextproto_b', 'double', 'byte', 'ntohll', 'ntohl']), 'sincerenessundominoed': ([], ['letohll', 'letohl', 'letohll', 'byte', 'ntohs', 'letohl', 'letohs', 'float', 'double', 'double', 'ntohs', 'ntohl', 'letohll', 'float', 'lv', 'ntohs', 'string', 'ntohll', 'ntohl', 'letohll', 'letohs', 'ntohs', 'ntohl', 'letohs', 'lv', 'byte', 'double', 'letohl', 'string', 'ntohl', 'double', 'ntohl', 'double']), 'oysterhouseamarillo': ([], ['ntohll', 'letohll', 'letohll', 'ntohs']), 'mammillationpemphigous': (['depositumspiritsome', 'contrarietyinconceivableness', 'micrencephalypalpus', 'ecclesiaLatinization', 'prehexameraldissyllabize', 'susurrateoutvie', 'predesignateunderservice', 'superestablishmentsuccor', 'addressorcondensedly', 'unhittabledoublehorned', 'metatitanatetarente', 'bacteriformpiercel', 'sulphostannideuntimeliness', 'herpetologistindeed', 'preinjuryduplicature', 'polyspermatouscreationistic', 'declamatorinessSerrifera', 'misproduceunthrilled', 'overcriticalnesslovableness', 'submountainhopper', 'pellagrosemongrelization', 'noniccosmopoietic', 'xiphosternamedia', 'gatewiseunderpot', 'agoraphobiaLenzites', 'lungflowerhorrormonger', 'Vandiemenianwinery', 'tollgateandrophagous', 'Sumasslevulosuria', 'Senecanovercorruptly', 'burgonetcarefully', 'surrenalinconcluding', 'pistoleerproexamination', 'electrocardiographyamaranthaceous', 'echinostomewont', 'campulitropoussapogenin', 'carangoidbotryomycotic', 'nasicornousfasciated', 'autovivisectionoverleather', 'hematozoalinfinitarily', 'domanialPhora', 'woodrowelshrievalty', 'catagmaticMegalosaurus', 'denieragedrapery', 'subordinationbrachial', 'goniometerhexameral', 'percontationMaimonist', 'Plymouthistnashgab', 'mausoleandecasualize', 'unexchangedsupraventricular', 'vivifybenefactorship', 'previousnessoisin', 'OrleansSchedius', 'cudavaogreish', 'enclothearmiferous', 'chaffererunheaded', 'trentepohliaceousHectorean', 'dissogenyBarney', 'renverseundethroned', 'pantomnesiadiporpa', 'bemuzzlesurficial', 'bawcockPicnickian', 'improvisatorizenoneditorial', 'outlawrypervertedness', 'saltlypropugnator', 'bullswooldraggletail', 'codeinesalience', 'ineloquentundishonored', 'skeelysubtriangular', 'predefinitionCarnaria', 'splanchnopleureprelapsarian', 'slichtarradiddler', 'ureterorrhagiahemogenetic', 'zincotypetripodic', 'interimperialvignetter', 'unaccuracyblepharoadenitis', 'schuleclethraceous', 'changeablyzoophilitic', 'vibrativeoversail', 'blepharanthracosisuncliented', 'tautologicpanimmunity', 'furoidbasanite', 'focoidsstackfreed', 'TelopeaCyclotosaurus', 'asperationoraculousness', 'shortcakeabase', 'laterodeviationNarciss', 'Carpathianmetanephron'], ['ntohl', 'ntohl', 'letohs', 'nextproto_b', 'float', 'letohs', 'letohll', 'string', 'float', 'lv', 'ntohll', 'ntohl', 'ntohs', 'letohs', 'double', 'letohl', 'ntohll', 'letohll', 'nextproto_b', 'nextproto_s', 'float', 'ntohs', 'ntohs', 'double', 'ntohl', 'byte', 'lv', 'byte', 'ntohl', 'letohll', 'ntohs']), 'xerophagyhematography': ([], ['letohl', 'string', 'letohll', 'ntohl', 'byte', 'ntohl', 'ntohll', 'ntohll', 'letohs', 'ntohs', 'byte', 'ntohll', 'byte', 'string', 'double', 'letohs', 'letohs', 'ntohl', 'letohl', 'letohll', 'letohll', 'ntohl', 'byte', 'float', 'float', 'byte', 'letohl', 'double', 'string', 'ntohs', 'ntohs', 'ntohs', 'ntohs', 'float', 'double', 'double', 'ntohs', 'ntohl']), 'idioglossiascabble': ([], ['ntohl', 'string', 'float', 'double', 'ntohs', 'lv']), 'pistoleerproexamination': ([], ['ntohl', 'lv']), 'asteamincandescency': ([], ['double', 'letohll', 'float', 'string', 'byte', 'ntohl', 'letohs', 'double', 'lv', 'letohl', 'letohl']), 'smackinglyScheuchzeriaceae': (['raspberrylikesubvertebral', 'Sarothrawrencher', 'rewhirlhypermotility', 'TaboriteSanche', 'overgenialitybuzzle', 'warneriodocasein', 'exportnontarnishable', 'chinkingcytologic', 'tellurethurryproof', 'fleaweedprobate', 'skilderprothalline', 'tuboovariandeducibleness', 'receptivelynonshredding', 'logarithmeticallydeliriant', 'spadelikemassacrer', 'cesserreichspfennig', 'whusslenoreast', 'hippocampalscrow', 'opportunisttitlark', 'preservatizeskyphoi', 'querulouslycooky', 'hanginglypoethood', 'evenworthyharebrain', 'lamellicornousPolygonaceae', 'redifferentiationmustachio', 'submountainhopper', 'prattlersuffumigate', 'scheltopusikAmpelidaceae', 'unmensurableSoohong', 'lemologydiplasion'], ['string', 'ntohs', 'nextproto_s', 'letohl', 'double', 'nextproto_s', 'letohs', 'float', 'letohll', 'string', 'ntohll', 'ntohs', 'string', 'ntohl', 'lv', 'string', 'string', 'letohs', 'string', 'lv', 'double', 'letohl', 'letohl', 'ntohll', 'ntohs', 'letohll', 'byte', 'string', 'byte', 'float', 'lv', 'letohll', 'letohl', 'ntohs', 'ntohll', 'letohll', 'letohs', 'double']), 'Toryizesynechthran': ([], ['ntohl', 'float', 'byte', 'letohs', 'byte', 'string', 'byte', 'ntohs', 'ntohll', 'double', 'letohl', 'lv', 'byte', 'ntohs', 'lv', 'double', 'letohll', 'letohs', 'lv', 'letohll', 'ntohll', 'ntohll', 'ntohll', 'letohll', 'lv', 'ntohll', 'byte', 'letohs', 'letohs', 'ntohll', 'ntohl', 'lv']), 'spraysemisaprophyte': ([], ['float', 'letohs', 'byte', 'double', 'float', 'byte', 'string', 'float', 'ntohs', 'double', 'float']), 'ettleoptimize': ([], ['ntohs', 'ntohll', 'lv', 'double', 'string', 'ntohll', 'double', 'letohs', 'byte', 'letohs', 'byte', 'ntohl', 'byte', 'ntohll', 'string', 'double', 'ntohl', 'letohll', 'ntohs', 'string', 'lv', 'letohll', 'float', 'double', 'byte', 'ntohll', 'byte', 'double', 'string', 'ntohl', 'lv', 'float', 'double']), 'chinkingcytologic': (['refallGanguela', 'tenodesisunroaming', 'semiduplexskirt', 'lepidodendridcounterplead', 'semistillpassback', 'kleenebocJungermannia', 'pseudodemocraticproconscription', 'enclothearmiferous', 'Saxonicalpalet', 'predisciplinetukra', 'springlikemonosymmetrically', 'cesserreichspfennig', 'reburstsummity', 'unbeggarbroncholithiasis', 'prebromidicMonopetalae', 'misputheptarchist', 'cannotdentigerous', 'raspberrylikesubvertebral', 'addressorcondensedly', 'benzalethylaminedesulphurate', 'sulfureasupertramp', 'epitrophygoatlike', 'semicolumnrankly', 'paralyzerthiocarbimide', 'countryfolkintolerance', 'disjointedlytriamylose', 'gatewiseunderpot', 'unconvenedperpetually', 'petalousausterity', 'pistoleerproexamination', 'sheepkeepingfeedman', 'misspellquinaldic', 'untastedgirllike', 'notchycoralliferous', 'asepticallyBernese', 'paleobotanyworkpeople', 'susurrateoutvie', 'prankinglypneumotherapy', 'anomalousparallelinerved', 'nontechnicalrongeur', 'Brandipriestcraft', 'gynarchicagedly', 'dermobranchiataboyardom', 'warfaringdraghound', 'cystocarppapaprelatical', 'undercovertcoloss', 'Robenhausianreboil', 'ettleoptimize', 'Erotylidaeprehesitate', 'vivifybenefactorship', 'balandracaducibranch', 'tumoredcrocodilite', 'changeablyzoophilitic', 'denieragedrapery', 'cardialgiacontingence', 'Ternstroemiaanisostomous', 'untuckedsolenoglyphic', 'cudavaogreish', 'turbidlycorticoefferent', 'untrainhearkener', 'leadstonehypovitaminosis', 'unhyphenedallose', 'Maytimeraillike', 'ambisyllabicfruitful', 'Piscataqualagoonal', 'doubleheartedstaphylolysin', 'ancestorialLicania', 'exponencecrubeen', 'ridgeplatedisturbed', 'dominionistversableness', 'Sarothrawrencher', 'photoheliographoctuplicate', 'androgynyvegetoalkaline', 'metatitanatetarente', 'abjudicationunpleading', 'frolickytriphyline', 'tuboovariandeducibleness', 'channelizeungarter', 'Lawsonsemiconversion', 'wolfberrydeclaredness', 'ineloquentundishonored', 'volubilityThuidium', 'Proteroglyphapiezoelectric', 'reshoedrachmae', 'Wagnerianaaviculturist', 'hypoplasyhooping', 'remisrepresentationlancet', 'carangoidbotryomycotic', 'superestablishmentsuccor', 'organoantimonypreoperator'], ['ntohs', 'lv', 'byte', 'byte', 'string', 'ntohs', 'ntohs', 'string']), 'volubilityThuidium': (['awiwimegaloglossia', 'tautologicpanimmunity', 'Senecanovercorruptly', 'dihedronsubcircuit', 'pedestrianateStromateidae', 'etioporphyrinpubovesical', 'tongueshoticonophilism', 'Fichteanismconjobble', 'surlyreptilferous', 'repealistbillsticking', 'coinbellmaker', 'OrleansSchedius', 'distilleryKiwanis', 'cystocarppapaprelatical', 'stakeholderunforbade', 'baptizeeFrenchize', 'mischieveunfomented', 'laparotomycephalohumeralis', 'sulphhemoglobinHerculanean', 'pistoleerproexamination', 'changeablyzoophilitic', 'subordinationbrachial'], ['lv', 'nextproto_b', 'double', 'string', 'letohl', 'string', 'double', 'ntohs', 'letohl', 'ntohll', 'letohs', 'letohs', 'string', 'ntohs', 'ntohll', 'ntohll', 'letohll', 'letohs', 'letohs', 'lv', 'byte', 'lv', 'letohs', 'letohl', 'double', 'letohll', 'double', 'string', 'ntohll', 'letohll', 'float', 'byte', 'byte', 'letohl', 'ntohs', 'letohs', 'string', 'lv', 'ntohs', 'ntohl', 'letohll', 'string', 'letohll', 'nextproto_s', 'letohll', 'nextproto_b', 'lv']), 'racemizestintedly': (['hancesmoothness', 'hanginglypoethood', 'grammaticismmignonette', 'apioidalNagari', 'emergencechouette', 'metasomalNachitoches', 'improvisatorizenoneditorial', 'loketprincipiate', 'unbeggarbroncholithiasis', 'outvenomviameter', 'subordinationbrachial', 'peritrichouslyhepatoflavin', 'Aparaipsychiatrist', 'strangulableargentamid', 'tautoousianentente', 'sowbackgastrotrichan', 'Moorshipspermatova', 'utterabilitypavement', 'snackmisinstruction', 'pejoristbromalbumin', 'tongueshoticonophilism', 'petalousausterity', 'Tullianrubidium', 'Silicoideasaltator', 'silcretemercurous', 'outworthbenevolence', 'wingerconsoler', 'rathmemorizable', 'cancelationZoochlorella', 'counterspyingdungeon', 'ofttimessnatchingly', 'reshoedrachmae', 'desoxycorticosteroneshakerag', 'merseglobular', 'consignificationmarshbuck', 'thiodiphenylaminediterpene', 'diseasednessthioantimonate', 'refallGanguela', 'Plymouthistnashgab', 'shortcakeabase', 'unfootedHilary', 'barkeeperCurtis', 'Humeaerohydroplane', 'blepharanthracosisuncliented', 'vaporizetannery', 'unimplicitoothecal', 'noninfectionvenerativeness', 'plurifacialmicrographical', 'archsnoblodgepole', 'tonguinessresoundingly', 'unconvenedperpetually', 'mammillationpemphigous', 'fetoracclimatement', 'angiomyocardiacmisinformer', 'receptivenesssempervirent', 'Lithosiinaecoequation', 'Toryizesynechthran'], ['ntohl', 'ntohl', 'nextproto_s', 'nextproto_b', 'ntohs', 'letohll', 'float', 'lv', 'double', 'letohl', 'nextproto_b', 'ntohl', 'letohs', 'ntohll', 'ntohs', 'ntohs', 'letohll', 'byte', 'nextproto_b', 'lv', 'byte', 'letohl', 'ntohl', 'ntohll', 'string', 'ntohll', 'lv', 'lv', 'string', 'nextproto_b', 'letohl', 'letohl', 'letohll', 'lv', 'lv', 'ntohl', 'lv', 'lv', 'letohs', 'double', 'nextproto_b', 'double', 'ntohs', 'string', 'letohl']), 'impracticalnessNemichthyidae': (['Trinorantumpyramides', 'anusimnonstationary', 'coinbellmaker'], ['double', 'ntohll', 'letohs', 'letohl', 'ntohll', 'nextproto_s', 'nextproto_b', 'double', 'letohl', 'ntohll', 'nextproto_b', 'letohl', 'letohll', 'letohs', 'letohll', 'double', 'string', 'lv', 'nextproto_b', 'float', 'ntohll', 'ntohl', 'string', 'letohll', 'ntohs', 'letohl', 'lv', 'double', 'ntohs', 'float', 'nextproto_s', 'letohll', 'letohs', 'lv', 'letohll', 'ntohll', 'letohs', 'nextproto_s', 'ntohll', 'ntohl', 'double', 'lv', 'double', 'nextproto_b']), 'Eomecondiscolorate': ([], ['byte', 'ntohll', 'ntohll', 'ntohs', 'lv', 'float', 'string', 'double', 'string', 'float', 'byte', 'letohl', 'ntohll', 'byte', 'double', 'lv', 'ntohs', 'byte', 'ntohs', 'ntohs', 'letohl', 'ntohll']), 'haabdimeric': ([], ['letohll', 'double', 'ntohs', 'letohl', 'ntohll', 'double', 'ntohl', 'ntohll', 'ntohl', 'ntohl', 'ntohll', 'byte', 'ntohl', 'ntohl', 'lv', 'string', 'letohs', 'letohll', 'double', 'ntohl', 'string', 'ntohs', 'double', 'ntohs', 'byte', 'letohl', 'float', 'letohl', 'letohll', 'lv', 'ntohs', 'lv', 'string', 'ntohl', 'ntohs', 'ntohll', 'double', 'float', 'byte', 'double', 'double', 'letohl', 'ntohs', 'letohl', 'letohll']), 'unaccoutereddrivebolt': (['bizonedraconites', 'microcaltropmyosarcomatous', 'photocompositioneneuch', 'Cobitidaedismissal', 'epitrophygoatlike', 'engrossedlyDinoceras', 'indulginglyretrue', 'iridemiabisque', 'esophagoplastyrestrainedness', 'simulcastriboflavin', 'distilleryKiwanis', 'phlebectomySiam', 'scheltopusikAmpelidaceae', 'matelessbeatitude', 'Vandiemenianwinery', 'Philonismpinivorous', 'unenterprisedargumentatious', 'ureterorrhagiahemogenetic', 'Slavophilesedigitate', 'outlawrypervertedness', 'quakinglyilliterate', 'antiphonybackplate', 'cacuminalgastrohysterorrhaphy', 'cantingnesstideful', 'angiomyocardiacmisinformer', 'butyrochloralfertilizational', 'peerlesslyforetalk', 'ophthalmalgiamisproduce', 'onomatopoeiaeggfish', 'cephaloconicunbaptized', 'Ciceronicpownie', 'sulphhemoglobinHerculanean', 'applanationnitrifaction', 'withsavesatinize', 'venomouslypilferment', 'tonguinessresoundingly', 'Limodorumscrotal', 'entomicperjuriousness', 'ralphautonomically', 'bumblefooticonology', 'subsorterbecuffed', 'refilmopenhandedness', 'peepypatrologic', 'Carpathianmetanephron', 'syphilologyannularity', 'predefinitionCarnaria', 'homoeomeriametagnathous', 'symmetricalantimasker', 'declamatorinessSerrifera', 'wolfberrydeclaredness', 'attestatorcoronule', 'changeablyzoophilitic', 'limsypersistence', 'correctorSpirochaeta', 'igelstromiteMoraceae', 'heliconbonnetman', 'ambisyllabicfruitful', 'unstalledneutralism', 'intrathoraciccoemployment', 'Suionesunprejudicially', 'asepticallyBernese', 'nowhitoffscape', 'postiquedefeasibility', 'laurdalitewistonwish', 'sowbackgastrotrichan', 'eudaemonisticallyCoccolobis', 'euquinquennium', 'coeternaloverhonor', 'xenopodidtrencherless', 'semistillpassback', 'autovivisectionoverleather', 'heronerchondroplasty', 'Silicoideasaltator', 'misputheptarchist', 'crossboltedasexually', 'oversoldafield', 'fitfulunshrill'], ['ntohll', 'double', 'float', 'ntohl', 'lv', 'nextproto_b', 'letohl', 'nextproto_s', 'string', 'letohs', 'nextproto_b', 'ntohl', 'float', 'ntohll', 'letohll', 'float', 'float', 'letohll', 'letohs', 'letohs', 'float', 'letohs', 'string', 'nextproto_s', 'ntohl', 'byte', 'byte', 'nextproto_b', 'ntohl', 'letohs', 'nextproto_s', 'nextproto_s', 'ntohll']), 'Opisthocomidaeheterochiral': ([], ['double']), 'psychiatristringhals': ([], ['letohl', 'ntohs', 'string', 'double', 'letohll', 'string', 'string', 'lv', 'lv', 'float', 'letohl', 'string', 'string']), 'ridgeplatedisturbed': (['phenomenalisticallyunmomentary', 'Jesperyearlong', 'responsivitykimigayo', 'opportunisttitlark', 'abjudicationunpleading', 'overseateddiscouragingly', 'applanationnitrifaction', 'overhollowescort', 'malthouseenteralgia', 'cinecameraHydropotes', 'katabolizedermic', 'vivifybenefactorship', 'eudaemonisticallyCoccolobis', 'maskflowerkeynoter', 'intrathoraciccoemployment', 'ochronosusafterbody', 'uncomminutedcommix', 'dermoiddiversifiable', 'Triuridalesplagiarism', 'exponencecrubeen', 'unlasheddialyzable', 'peccationfoolery', 'enclothearmiferous', 'evenworthyharebrain', 'lobectomypreinflection', 'unusehydroponist', 'unreprovedlysprier', 'unscalednessChamaeleon', 'untuckedsolenoglyphic', 'recapitalizerelevate', 'pellagrosemongrelization', 'piperitiousreekingly', 'grapedmassively', 'subsoilercruent', 'flashpanstature', 'rosiedunarchdeacon', 'pistoleerproexamination', 'yawpwoodwax', 'lungflowerhorrormonger', 'cophosisclour', 'lemologydiplasion', 'noggencapitulate', 'yoreexponent', 'outfeatvasodilator', 'imperializetrispaston', 'plurifacialmicrographical', 'spraysemisaprophyte', 'precoxseambiter', 'superabsurdditremid', 'hetericismswayable', 'unhyphenedallose', 'visorlikeNagari', 'oversoldafield', 'Philonismpinivorous', 'chaffererunheaded', 'steelworkpsychophysiological', 'noniccosmopoietic', 'parathyroidectomizeoutheart', 'Saxonicalpalet', 'sokarailer', 'menialitypreintelligent', 'intercoolingpotentialization', 'warfaringdraghound', 'unquailingshive', 'piskgriff', 'pantomnesiadiporpa', 'xerophagyhematography', 'bacteriformpiercel', 'undercovertcoloss', 'xenogenesisprenoble', 'laparotomycephalohumeralis', 'sowbackgastrotrichan', 'antleredadunc', 'Grahamsaloon', 'dominionistversableness', 'pegologyscavenage', 'indubitablenoncollaboration', 'proportionaltasselmaker', 'terrazzododder', 'buttonholerindigestive', 'steinkirkmisaffection', 'oxmanoutpull', 'ruinlikesilva', 'Ternstroemiaanisostomous', 'Lawsonsemiconversion', 'gynarchicagedly', 'bawcockPicnickian', 'misspellquinaldic', 'wolfberrydeclaredness', 'Voltaprotarsal', 'collationdissuasively'], ['ntohl', 'string', 'ntohll', 'byte', 'lv', 'string', 'letohl', 'double', 'letohll', 'ntohl', 'letohl', 'letohs', 'nextproto_b', 'float', 'letohl', 'letohl', 'ntohll', 'byte', 'letohs', 'byte', 'byte', 'letohl', 'float', 'ntohs', 'double', 'letohs', 'ntohl', 'float', 'ntohs', 'nextproto_b', 'letohl', 'nextproto_s', 'string', 'ntohl', 'ntohll', 'ntohs', 'string', 'float', 'ntohl', 'string', 'lv']), 'refilmopenhandedness': (['asepticallyBernese', 'crouchingpurebred', 'radiopaqueunrecruitable', 'saltlypropugnator', 'bairnlyneocosmic', 'pneumodynamicsprimariness', 'sokarailer', 'Steganophthalmiagnomic', 'cylindrarthrosisnonplusation', 'superabsurdditremid', 'intrathoraciccoemployment', 'surlyreptilferous', 'cancelationZoochlorella', 'unmistgraffer', 'cassiteritecasemaking', 'subordinationbrachial', 'Vandiemenianwinery'], ['float', 'letohl', 'letohl', 'letohl', 'float', 'ntohl', 'nextproto_s', 'float', 'letohl', 'letohl', 'double', 'ntohl', 'double', 'string']), 'keelfathoplomachos': ([], ['ntohl', 'byte', 'ntohs', 'float', 'letohll', 'float', 'ntohll', 'byte', 'letohl', 'byte', 'double', 'letohs', 'ntohs', 'double', 'ntohll']), 'micrencephalypalpus': (['antleredadunc', 'sacroposteriorveratryl', 'epexegeticallyreadjournment', 'trentepohliaceousHectorean', 'susurrateoutvie', 'recapitalizerelevate', 'vaporizetannery', 'TelopeaCyclotosaurus', 'organoantimonypreoperator', 'Opisthocomidaeheterochiral', 'docimasytrouserdom', 'napalmbrevifoliate', 'unhyphenedallose', 'outworthbenevolence', 'cardialgiacontingence', 'strangulableargentamid', 'denieragedrapery', 'Eomecondiscolorate', 'indirecthierarchism', 'bairnlyneocosmic', 'scutcheonwiseileocolitis', 'faddyamputational', 'declamatorinessSerrifera', 'extravagantkaryoplasmatic', 'Robenhausianreboil', 'parandruspercribration', 'barrelmakingparoemia', 'Grahamsaloon', 'mattapharyngological', 'racegoingunperformed', 'cacuminalgastrohysterorrhaphy', 'blepharanthracosisuncliented', 'appendiceunmetaled', 'semiduplexskirt', 'superabsurdditremid', 'tautoousianentente', 'dermobranchiataboyardom', 'tenodesisunroaming', 'renverseundethroned', 'Stromatoporoideabarry', 'cesserreichspfennig', 'idioglossiascabble', 'gatewiseunderpot', 'saltlypropugnator', 'menialitypreintelligent', 'Oliveanpyromancer', 'spadelikemassacrer', 'ureterorrhagiahemogenetic', 'springlikemonosymmetrically', 'genipacombiner', 'Alalamenispermine', 'Sarothrawrencher', 'micrencephalypalpus', 'paleobotanyworkpeople', 'crouchingpurebred', 'dehydrogenizeCambrian', 'whusslenoreast', 'laparotomycephalohumeralis', 'ricketssubtrihedral', 'androgynyvegetoalkaline', 'iconismanisostemonous', 'stakeholderunforbade', 'interventraliaforeutter', 'undercovertcoloss', 'preinjuryduplicature', 'grapedmassively', 'sheepkeepingfeedman', 'pavonatedcozily', 'intrathoraciccoemployment'], ['ntohs', 'ntohll', 'float', 'ntohs', 'letohl', 'letohl', 'double', 'ntohl', 'letohs', 'ntohl', 'lv', 'letohl', 'lv', 'nextproto_b', 'nextproto_b', 'ntohs', 'letohs', 'ntohs', 'letohl', 'nextproto_b', 'letohl', 'ntohll', 'letohs', 'ntohl', 'ntohl', 'ntohll', 'letohll', 'double', 'float', 'byte', 'nextproto_b', 'ntohll', 'ntohl', 'byte', 'double', 'nextproto_s', 'ntohl', 'letohl', 'letohs', 'float', 'nextproto_b', 'double', 'nextproto_b', 'letohll', 'ntohll']), 'buttonholerindigestive': (['subsorterbecuffed', 'utterabilitypavement', 'delthyrialGee', 'menialitypreintelligent', 'Tullianrubidium', 'Voltaprotarsal', 'unmistgraffer', 'subcineritiousphrenitic', 'opportunisttitlark', 'carcerationinterrenal', 'byworkplastid', 'multicrystallinekeratoglossus', 'spinthariscopemolybdena', 'mattapharyngological', 'retroclusionmetaphysicianism', 'evaluecystatrophia', 'ambisyllabicfruitful', 'Triuridalesplagiarism', 'Bryumextrafocal', 'Sarothrawrencher', 'dissogenyBarney', 'katabolizedermic', 'prelanguagecloudage', 'parandruspercribration', 'TelopeaCyclotosaurus', 'lepidodendridcounterplead', 'steelworkpsychophysiological', 'flashpanstature', 'polyspermatouscreationistic', 'Philonismpinivorous', 'piskgriff', 'etioporphyrinpubovesical', 'sagaiebarrister', 'faddyamputational', 'intrathoraciccoemployment', 'bemuzzlesurficial', 'bumblefooticonology', 'stickleafethenyl', 'ruinlikesilva', 'remisrepresentationlancet', 'outfeatvasodilator', 'paralyzerthiocarbimide', 'apioidalNagari', 'cacuminalgastrohysterorrhaphy', 'Oliveanpyromancer', 'superabsurdditremid', 'semiduplexskirt', 'chytridialgoosemouth', 'isuroidunfitly', 'picayunishapogeotropic', 'misadministrationbroody', 'crouchingpurebred', 'tautoousianentente', 'peritrichouslyhepatoflavin', 'Pamirioversystematic', 'responsivitykimigayo', 'outworthbenevolence', 'unsanctioningperiuvular', 'summarizationyatter', 'foliicolousskeletonweed', 'recapitalizerelevate', 'proportionaltasselmaker', 'focoidsstackfreed', 'shuttlecockscanmag', 'bawcockPicnickian', 'listeningBroussonetia', 'organosiliconsegmentary', 'ivoryliketransessentiate', 'Robenhausianreboil', 'scutcheonwiseileocolitis', 'yawpwoodwax', 'carangoidbotryomycotic', 'crossboltedasexually', 'sokarailer', 'vibrativeoversail', 'parathyroidectomizeoutheart', 'grapedmassively', 'unenterprisedargumentatious', 'cystocarppapaprelatical', 'cancelationZoochlorella', 'Wagnerianaaviculturist', 'unpopulatecurry', 'overpoliticunderlooker', 'anomalousparallelinerved'], ['float', 'nextproto_s', 'ntohll', 'letohs', 'ntohl', 'letohl', 'letohll', 'byte', 'ntohl', 'lv', 'float']), 'sharkletcompactedly': (['galledisocinchomeronic', 'semiduplexskirt', 'esophagoplastyrestrainedness', 'zeuctocoelomicmetapodial', 'slichtarradiddler', 'cosilybridecake', 'utterabilitypavement', 'lindengamy', 'loungyimpolite', 'susurrateoutvie', 'scheltopusikAmpelidaceae', 'gatewiseunderpot', 'mattapharyngological', 'unexchangedsupraventricular'], ['nextproto_b', 'ntohs', 'letohs', 'double', 'ntohl']), 'ecclesiaLatinization': ([], ['letohll', 'lv', 'letohs', 'lv', 'ntohll', 'letohll', 'lv', 'byte', 'float', 'ntohll', 'ntohll', 'ntohs', 'string', 'letohl', 'ntohs', 'lv', 'ntohs', 'double', 'byte', 'letohll', 'double', 'ntohll']), 'tautoousianentente': ([], ['float', 'ntohll', 'letohl', 'float', 'letohs', 'letohll', 'ntohll', 'lv', 'letohl', 'byte', 'lv', 'string', 'byte', 'ntohs', 'ntohl', 'float', 'string', 'lv', 'letohs', 'letohl', 'ntohl', 'lv', 'letohl', 'lv', 'lv']), 'vernileDasya': (['Anchtheriumunastonish', 'concussionalmonobromoacetanilide', 'vitriolizemonal', 'pantomnesiadiporpa', 'referumbrellawort', 'carannaaccension', 'dissuasivenessnondeforestation', 'unscalednessChamaeleon', 'stakeholderunforbade', 'Negritohydroponicist', 'Sonjapylorogastrectomy', 'ivoryliketransessentiate', 'cycloolefinmonostylous', 'Castoroidespentacrinite', 'tenodesisunroaming', 'erythriticsynergidal', 'imperializetrispaston', 'assecurationAshkenazim', 'overgenialitybuzzle', 'revenantpromisee', 'pellagrosemongrelization', 'androgynyvegetoalkaline', 'hetericismswayable', 'inquilinecopse', 'muckyuxoricide', 'coinbellmaker', 'vibrativeoversail', 'nonaugmentativehypertelic', 'slutteryprivant', 'sulphhemoglobinHerculanean', 'angiomyocardiacmisinformer', 'semiduplexskirt', 'lagoonaltanning', 'photocompositioneneuch', 'ecclesiaLatinization', 'paleocrystallinespinulosodenticulate', 'opportunisttitlark', 'skilderprothalline', 'ofttimessnatchingly', 'sulphuratorjonquil', 'evaluecystatrophia', 'docimasytrouserdom', 'unodoriferousWhiggish', 'membershiptownsboy', 'spinthariscopemolybdena', 'rosiedunarchdeacon', 'pavonatedcozily', 'chartermarrowy', 'TelopeaCyclotosaurus', 'intwistpunter', 'cardinghygeistic', 'unquailingshive', 'Aparaipsychiatrist', 'hemologistbeglide', 'peepypatrologic', 'noninfectionvenerativeness', 'counterspyingdungeon', 'bizonedraconites', 'herpetologistindeed', 'cattlefolk', 'peerlesslyforetalk', 'predisciplinetukra', 'Slavophilesedigitate', 'irislikeaphyllose', 'Trinorantumpyramides', 'Vickyimmigrant', 'outvenomviameter', 'craunchprovitamin', 'plurifacialmicrographical', 'hookahsupersimplicity'], ['nextproto_s', 'letohll', 'ntohs', 'lv', 'nextproto_s', 'ntohl', 'byte']), 'countrymanisodimorphism': ([], ['double', 'ntohl', 'letohs', 'double']), 'sleekgavelock': (['herpetologistindeed', 'unsanctioningperiuvular'], ['ntohs', 'nextproto_b', 'letohll', 'ntohl', 'byte', 'letohs', 'lv', 'letohs', 'nextproto_s', 'nextproto_s', 'ntohll', 'ntohll', 'letohll', 'ntohll', 'byte']), 'outwindowmesothoracic': (['awiwimegaloglossia', 'catafalquedree', 'autoplastycava', 'misadministrationbroody', 'outdoortenorister', 'querulouslycooky', 'sowbackgastrotrichan', 'susurrateoutvie', 'acclaimerilluminability', 'lepidodendridcounterplead', 'organoantimonypreoperator', 'xerophagyhematography', 'radomenetherwards', 'countrymanisodimorphism', 'syngraphstaminiferous', 'poonghiehectic', 'cineplastyanonang', 'untabernacledmedicamental', 'predisciplinetukra', 'avalanchestylopization', 'tellurethurryproof', 'yawpwoodwax', 'utterabilitypavement', 'preinjuryduplicature', 'reshoedrachmae', 'paralyzerthiocarbimide', 'codeinesalience', 'etioporphyrinpubovesical', 'prebromidicMonopetalae', 'goodlyterebenthene', 'dissogenyBarney', 'Philonismpinivorous', 'actordocility', 'plurifacialmicrographical', 'pneumodynamicsprimariness', 'angiomyocardiacmisinformer', 'previousnessoisin', 'correctorSpirochaeta', 'alkargenmoop', 'spinosotuberculatedeossify', 'hancesmoothness', 'porencephalonpostplegic', 'billbackdisease', 'Lawsonsemiconversion', 'lagoonaltanning', 'carannaaccension', 'disjointedlytriamylose', 'pegologyscavenage', 'steevingerotic', 'frolickytriphyline', 'hallowerhydrophthalmos', 'hippocampalscrow', 'Jesperyearlong', 'Moorshipspermatova', 'oboltask', 'baptizeeFrenchize', 'frontomallarforedetermine', 'flamprelate', 'spadelikemassacrer', 'recapitalizerelevate', 'parandruspercribration', 'entomicperjuriousness', 'Eomecondiscolorate', 'pinkberrynonvillainous', 'medicochirurgicadvise', 'algorithmicSericana', 'subordinationbrachial', 'mercurializationsimulacre', 'mausoleandecasualize', 'sulphhemoglobinHerculanean', 'unhealablenessknoppy', 'filietypester', 'bullswooldraggletail', 'oxmanoutpull', 'remisrepresentationlancet', 'phenomenalisticallyunmomentary', 'polyspermatouscreationistic', 'Fichteanismconjobble'], ['float', 'float', 'nextproto_b', 'letohs', 'string', 'byte', 'nextproto_s', 'double', 'float', 'nextproto_b']), 'hyperneuriasymbolatry': ([], ['double', 'letohl', 'ntohll', 'double', 'ntohl', 'letohll', 'letohs', 'letohl', 'string', 'byte', 'byte', 'ntohll', 'string', 'letohs', 'float', 'ntohll', 'ntohll', 'ntohl', 'ntohs', 'ntohll', 'letohl', 'ntohll', 'letohl', 'ntohl', 'ntohl', 'ntohl', 'ntohll']), 'undistinctivenondisfranchised': (['redepositsubclassify', 'lippitudebaetyl'], ['lv', 'string', 'ntohll', 'double', 'ntohs', 'double']), 'prefactoranchoret': (['sulphostannideuntimeliness', 'ambisyllabicfruitful', 'unaccuracyblepharoadenitis', 'repolymerizationwesselton', 'amlipyrexic', 'awiwimegaloglossia', 'usurperunplannedly', 'Stromatoporoideabarry', 'superestablishmentsuccor', 'Dokoelectrochemically', 'hemianacusiadouble', 'Cobitidaedismissal', 'maskflowerkeynoter', 'preinjuryduplicature', 'frolickytriphyline', 'pedestrianateStromateidae', 'Alalamenispermine', 'keraunophoneinhabited', 'chaffererunheaded', 'tautoousianentente', 'cineplastyanonang', 'picayunishapogeotropic', 'sacroposteriorveratryl', 'fleaweedprobate', 'cardialgiacontingence', 'herpetologistindeed', 'untastedgirllike'], ['double', 'nextproto_b', 'letohs', 'letohl', 'string', 'nextproto_s', 'letohl', 'ntohll', 'letohl', 'nextproto_b', 'double', 'float', 'float', 'nextproto_b']), 'nonaugmentativehypertelic': ([], ['string', 'ntohl', 'letohs', 'string', 'double', 'string', 'letohs', 'ntohs', 'float', 'double', 'ntohs']), 'Tantalussubcavity': (['overdiligentlyrifleshot', 'allegoristerserendite', 'tollgateandrophagous', 'Castoroidespentacrinite', 'cumshawzelatrice', 'mausoleandecasualize', 'ochronosusafterbody', 'prefactoranchoret', 'provectgastrocolostomy', 'superabsurdditremid', 'herpetologistindeed', 'veldcraftsubprefect', 'nonaugmentativehypertelic', 'preservatizeskyphoi', 'cylindrarthrosisnonplusation', 'vibrativeoversail', 'OrleansSchedius', 'untuckedsolenoglyphic', 'oysterhouseamarillo', 'unexchangedsupraventricular', 'overgenialitybuzzle', 'pneumodynamicsprimariness', 'ruinlikesilva', 'otogenouschromatographic', 'leadstonehypovitaminosis', 'postiquedefeasibility', 'toyingere', 'laparotomycephalohumeralis', 'cesserreichspfennig', 'unvoiceCamacan'], ['letohl', 'letohl', 'letohll', 'byte', 'ntohll', 'ntohll', 'string', 'float', 'letohs', 'ntohll', 'lv', 'letohll', 'lv', 'byte', 'double', 'double', 'lv', 'ntohs', 'byte', 'float', 'letohl', 'ntohll', 'ntohll', 'nextproto_s', 'byte', 'byte', 'letohl', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'letohll', 'double', 'double', 'nextproto_s', 'nextproto_s', 'nextproto_b', 'double', 'letohl', 'nextproto_b', 'nextproto_b', 'byte', 'float']), 'crouchingpurebred': ([], ['ntohll', 'letohs', 'float', 'ntohll', 'letohl', 'ntohl', 'letohll', 'ntohl', 'string', 'ntohl', 'ntohll', 'letohl', 'ntohl', 'string', 'string', 'letohll', 'string', 'lv', 'float', 'letohs', 'ntohll', 'ntohl', 'lv', 'ntohll', 'letohll', 'ntohll', 'letohs', 'double', 'byte', 'letohs', 'float', 'string', 'ntohs', 'double', 'letohl', 'lv', 'letohl', 'double', 'string', 'float', 'letohl', 'float']), 'stereopicturesalep': ([], ['lv', 'ntohl', 'double', 'lv', 'ntohs', 'ntohll', 'ntohll', 'lv', 'double', 'ntohl', 'byte', 'ntohs', 'letohll', 'ntohs', 'string', 'letohll', 'ntohl', 'letohs', 'letohl', 'float', 'string', 'byte', 'float']), 'whillyunbet': ([], ['lv', 'ntohll', 'string', 'lv', 'letohll', 'ntohl', 'float', 'letohll', 'ntohl', 'letohll', 'lv', 'ntohll', 'byte', 'lv', 'letohs', 'letohl', 'byte', 'ntohl', 'ntohll', 'letohl', 'lv', 'ntohll', 'letohl', 'letohll', 'ntohs', 'lv', 'letohs', 'double', 'letohl', 'ntohl', 'double', 'ntohl', 'string']), 'Limodorumscrotal': (['cancelationZoochlorella', 'splanchnopleureprelapsarian', 'focoidsstackfreed', 'galledisocinchomeronic', 'epigenesistbisexed', 'Carpathianmetanephron', 'spinthariscopemolybdena', 'androgynyvegetoalkaline', 'peritrichouslyhepatoflavin', 'Stromatoporoideabarry', 'prosubscriptiontribracteate', 'piskgriff', 'terrazzododder', 'anomalousparallelinerved', 'unlasheddialyzable', 'photoheliographoctuplicate', 'turbidlycorticoefferent', 'allerChilostoma', 'qualmyishHolocene', 'bawcockPicnickian', 'cosilybridecake', 'pinkberrynonvillainous', 'countryfolkintolerance', 'monodromiclyretail', 'Dokoelectrochemically', 'repealistbillsticking', 'ambisyllabicfruitful', 'ivoryliketransessentiate', 'cassiteritecasemaking', 'oversolicitouslyhour', 'arhatsporozoic', 'Eomecondiscolorate', 'Lawsonsemiconversion', 'hyperneuriasymbolatry', 'remisrepresentationlancet', 'correctorSpirochaeta', 'sulfureasupertramp', 'Fichteanismconjobble', 'laparotomycephalohumeralis', 'cardinghygeistic', 'emergencechouette', 'tollgateandrophagous', 'superabsurdditremid', 'Wagnerianaaviculturist', 'unpopulatecurry', 'overganggenesial', 'plurifacialmicrographical', 'unenterprisedargumentatious', 'weathercockismcustodier', 'tautoousianentente', 'metatitanatetarente', 'racegoingunperformed', 'semicolumnrankly', 'proportionaltasselmaker', 'outfeatvasodilator', 'unexchangedsupraventricular', 'ochronosusafterbody', 'hookahsupersimplicity', 'northwestwardpassementerie', 'veldcraftsubprefect', 'parandruspercribration', 'hyperduliaferrateen', 'OrleansSchedius', 'symptosissubcorneous', 'ricketssubtrihedral', 'hemianacusiadouble', 'prebromidicMonopetalae'], ['ntohs', 'ntohs', 'byte', 'nextproto_b', 'letohll', 'ntohs', 'lv', 'letohs', 'byte', 'string', 'double', 'lv', 'letohll', 'string', 'letohll', 'string', 'string', 'letohl', 'ntohl', 'lv', 'lv', 'nextproto_s', 'ntohl', 'nextproto_s', 'ntohl', 'nextproto_s']), 'contrarietyinconceivableness': ([], ['ntohll', 'byte', 'ntohs', 'string', 'byte', 'letohl', 'lv', 'byte', 'letohs', 'letohl', 'string', 'string', 'lv', 'letohl', 'letohl', 'letohll', 'letohs', 'letohl', 'letohl', 'string']), 'popeyednaphtha': ([], ['string', 'lv', 'ntohl', 'ntohl', 'string', 'ntohll']), 'goniometerhexameral': ([], ['letohs', 'lv', 'ntohs', 'string', 'ntohs', 'letohl']), 'phenomenalisticallyunmomentary': ([], ['string', 'ntohl', 'ntohs', 'string', 'float', 'lv', 'string', 'byte', 'letohll', 'double', 'ntohs', 'double', 'ntohl', 'float', 'letohs', 'letohll', 'string', 'letohs', 'letohl', 'string', 'float', 'ntohl', 'double', 'letohs', 'letohll', 'byte', 'ntohll']), 'overkneePolypoda': ([], ['letohs', 'ntohs', 'string', 'float', 'ntohl', 'ntohs', 'ntohl', 'ntohll', 'byte', 'lv', 'lv', 'letohs', 'lv', 'letohs', 'string', 'ntohs', 'string', 'string', 'letohl', 'ntohs', 'byte', 'letohll', 'letohl', 'letohs', 'letohl', 'ntohs', 'letohll', 'letohll', 'double', 'float', 'byte', 'ntohll', 'string', 'lv', 'lv', 'double']), 'munjmuchness': ([], ['float', 'letohll', 'ntohs', 'ntohll', 'letohs', 'letohl', 'lv', 'lv', 'ntohs', 'lv', 'letohll', 'string', 'byte', 'ntohl', 'letohl', 'ntohll', 'float', 'ntohl', 'byte', 'letohl']), 'prizeexcrescence': ([], ['byte', 'byte', 'letohll', 'float', 'letohs', 'letohll', 'string', 'float', 'ntohll', 'ntohs', 'ntohs', 'string', 'byte', 'float', 'ntohl', 'ntohll', 'float', 'string', 'lv', 'ntohll', 'ntohs', 'letohl', 'letohs', 'ntohll', 'ntohll', 'float', 'ntohll', 'letohll']), 'plurifacialmicrographical': (['picayunishapogeotropic', 'sagaiebarrister', 'agonizefloating', 'misadministrationbroody', 'benzalethylaminedesulphurate', 'unhyphenedallose', 'cineplastyanonang', 'syphilologyannularity', 'springlikemonosymmetrically', 'provectgastrocolostomy', 'hyperduliaferrateen', 'woodrowelshrievalty'], ['byte', 'double', 'letohll', 'double', 'letohl', 'letohl', 'lv', 'float', 'double', 'lv', 'float', 'lv', 'string', 'nextproto_b', 'float', 'letohll', 'letohll', 'letohl', 'nextproto_b', 'string', 'double', 'byte', 'nextproto_s', 'ntohl', 'nextproto_b', 'nextproto_b', 'string', 'ntohl', 'letohs', 'ntohl']), 'unusehydroponist': ([], []), 'renverseundethroned': ([], ['double', 'lv', 'double', 'letohll', 'letohll', 'letohl', 'double', 'string', 'ntohs', 'letohl', 'letohl', 'ntohl', 'float', 'lv']), 'igelstromiteMoraceae': ([], ['ntohs', 'string', 'byte', 'double', 'double', 'float', 'letohll', 'letohs', 'letohll', 'byte', 'letohs', 'float', 'ntohll', 'lv', 'lv', 'ntohs', 'ntohs', 'double', 'letohl', 'float', 'byte', 'string', 'letohl', 'lv', 'byte', 'letohl', 'letohl', 'ntohl', 'ntohll', 'ntohl', 'letohs', 'ntohll', 'lv', 'byte', 'ntohl', 'letohll', 'ntohll', 'byte', 'letohs', 'letohll']), 'frontomallarforedetermine': (['heliconbonnetman', 'zincotypetripodic', 'pseudodemocraticproconscription', 'piskgriff', 'clinandriabryologist', 'tecalipalingenesy', 'Jesperyearlong', 'prizeexcrescence', 'collationdissuasively', 'percontationMaimonist', 'pedestrianateStromateidae', 'unstalledneutralism', 'ciderishazury', 'maternityhomogenetic', 'Pamirioversystematic', 'untuckedsolenoglyphic', 'denieragedrapery', 'retroclusionmetaphysicianism', 'chromophilouspyometra', 'unpaintterebinic', 'unscalednessChamaeleon', 'monodromiclyretail', 'mausoleandecasualize', 'carangoidbotryomycotic', 'ruinlikesilva', 'focoidsstackfreed', 'radiopaqueunrecruitable', 'autovivisectionoverleather', 'overseateddiscouragingly', 'oversoldafield', 'symptosissubcorneous', 'unconvenedperpetually', 'esophagoplastyrestrainedness', 'cudavaogreish', 'predesignateunderservice', 'malthouseenteralgia', 'uncatholicizeSiphonognathus', 'acanthopterygianMuranese', 'adminiculatephosphosilicate', 'dermobranchiataboyardom', 'gatewiseunderpot', 'benzalethylaminedesulphurate', 'anomalousparallelinerved', 'Alalamenispermine', 'unfootsorepoonac', 'tenodesisunroaming', 'inquilinecopse', 'lepidodendridcounterplead', 'epitrophygoatlike', 'peerlesslyforetalk', 'Plymouthistnashgab', 'appendiceunmetaled', 'tautologicpanimmunity', 'neurofibriljanapan', 'trichitepersonship', 'subregenthelmeted', 'outfeatvasodilator', 'hookahsupersimplicity', 'recapitalizationdissipative', 'napalmbrevifoliate', 'Trinorantumpyramides', 'galledisocinchomeronic', 'menialitypreintelligent', 'peccationfoolery', 'feveretunderbox', 'repolymerizationwesselton', 'surrenalinconcluding', 'precoxseambiter', 'distilleryKiwanis', 'certainarchpontiff', 'overganggenesial', 'diseasednessthioantimonate', 'dejectedincreasing', 'isuroidunfitly', 'hystericsupersuperior', 'shuttlecockscanmag'], ['ntohs', 'nextproto_b', 'ntohs', 'ntohl', 'ntohl', 'double', 'byte']), 'filietypester': ([], ['byte', 'letohl', 'float', 'letohll', 'letohl', 'lv', 'letohs', 'letohll']), 'Oliveanpyromancer': ([], ['letohll', 'ntohs', 'double', 'ntohl', 'string', 'lv', 'ntohll', 'letohl', 'byte', 'lv', 'float', 'letohll', 'string', 'float', 'float', 'byte', 'string', 'double', 'letohll', 'ntohl', 'float', 'byte', 'lv', 'float', 'ntohs', 'byte', 'ntohs', 'letohs', 'lv', 'ntohl', 'ntohll', 'ntohs', 'lv', 'double', 'byte', 'byte', 'letohll', 'byte', 'letohll', 'double']), 'overpoliticunderlooker': (['vaporizetannery', 'superabsurdditremid', 'xenopodidtrencherless', 'subordinationbrachial', 'Bryumextrafocal', 'cesserreichspfennig', 'unbeggarbroncholithiasis', 'focoidsstackfreed', 'prattlersuffumigate', 'surlyreptilferous', 'counterpotentMetabola', 'bawcockPicnickian', 'hyperneuriasymbolatry', 'Triuridalesplagiarism', 'untastedgirllike'], ['ntohl', 'nextproto_b', 'ntohs', 'byte', 'float', 'letohl', 'nextproto_s', 'ntohll', 'lv', 'double', 'byte', 'letohll', 'ntohs', 'nextproto_b', 'letohl', 'string', 'lv', 'nextproto_b']), 'pluviographicspermatorrhea': (['pseudodemocraticproconscription', 'surrenalinconcluding', 'interventraliaforeutter', 'hallowerhydrophthalmos', 'lindengamy', 'cosilybridecake', 'dissuasivenessnondeforestation', 'prerailwaycannibalistically', 'scleroblastemicpalaeocosmology', 'parandruspercribration', 'Sumasslevulosuria', 'skeesicksunsteamed', 'photoheliographoctuplicate', 'psychrographismdom', 'unfannedhopperman', 'damnonianscrankly', 'mediumismgypsyism', 'allegoristerserendite', 'redifferentiationmustachio', 'kansrush', 'coinbellmaker', 'undercovertcoloss', 'terrazzododder', 'unmistgraffer', 'elementalismpietism', 'paleobotanyworkpeople', 'pyrroylprobity', 'extravagantkaryoplasmatic', 'surlyreptilferous', 'overpoliticunderlooker', 'membershiptownsboy', 'unquailingshive', 'carangoidbotryomycotic', 'palatableJonesian', 'subrigidlithophysal', 'bustedpredoubter', 'trentepohliaceousHectorean', 'arnberrydodecadrachm', 'ureterorrhagiahemogenetic', 'angiomyocardiacmisinformer', 'Anglomaniaclovableness', 'dejectedincreasing', 'heliconbonnetman', 'epexegeticallyreadjournment', 'scruplercellulifugal', 'carcerationinterrenal', 'alphabetismpolyfenestral', 'unfangedramline', 'roofprespur', 'marblelikeTenaktak', 'geriatricundaubed', 'acclaimerilluminability', 'ornithotomyblackwort', 'unaccuracyblepharoadenitis', 'echinostomewont', 'entomicperjuriousness', 'unconvenedperpetually', 'intercoolingpotentialization', 'sulphuratorjonquil', 'triseriallypreaccess', 'dyewoodsocii', 'refallGanguela', 'Chilopsiscompactible', 'warfaringdraghound', 'munjmuchness', 'tecalipalingenesy', 'steevingerotic', 'Piscataqualagoonal', 'simulcastriboflavin', 'indubitablenoncollaboration', 'renverseundethroned', 'algorithmicSericana', 'practicelegitimatist', 'overfretdisenthronement', 'ophthalmalgiamisproduce', 'Philoctetessupersalesman', 'fillmetroptosis', 'strainedlypsychopompos', 'disjointedlytriamylose', 'iconismanisostemonous', 'misadministrationbroody', 'wirrshillingless', 'overganggenesial', 'plurifacialmicrographical', 'tuboovariandeducibleness', 'metatitanatetarente', 'untrainhearkener', 'decimosextountractarian', 'mausoleandecasualize', 'predestinarianglia', 'hetericismswayable'], ['nextproto_s', 'ntohs', 'double', 'letohll', 'letohs', 'letohs', 'float', 'letohll', 'nextproto_s', 'lv', 'nextproto_s', 'ntohll', 'byte', 'byte', 'letohll', 'letohs', 'float', 'letohll', 'nextproto_s', 'nextproto_s', 'ntohs', 'ntohs']), 'ofttimessnatchingly': ([], ['letohl', 'ntohll', 'double', 'ntohs']), 'ineloquentundishonored': (['katabolizedermic', 'collationdissuasively', 'outworthbenevolence', 'intrathoraciccoemployment', 'opportunisttitlark', 'Eomecondiscolorate', 'carangoidbotryomycotic', 'dermobranchiataboyardom', 'ochronosusafterbody', 'cesserreichspfennig', 'peritrichouslyhepatoflavin', 'shortcakeabase', 'cannotdentigerous', 'radiopaqueunrecruitable', 'asepticallyBernese', 'predesignateunderservice', 'steelworkpsychophysiological', 'hetericismswayable', 'dehydrogenizeCambrian', 'goniometerhexameral'], ['byte', 'float', 'nextproto_b', 'ntohs', 'ntohl']), 'vareisogeothermic': ([], ['ntohl', 'byte', 'byte', 'float', 'float', 'lv', 'letohll', 'ntohs', 'ntohl', 'lv', 'ntohs', 'ntohs', 'double', 'double', 'double', 'lv', 'byte', 'letohs', 'ntohl', 'string', 'letohl', 'byte', 'string', 'ntohs', 'byte', 'letohs', 'letohs', 'ntohll', 'ntohl', 'ntohs', 'letohll', 'float', 'ntohll', 'float', 'string', 'ntohll', 'double', 'float', 'string', 'letohll', 'string']), 'erythriticsynergidal': ([], ['double', 'byte', 'string', 'ntohs', 'letohll', 'ntohs', 'letohll', 'double', 'lv', 'letohs', 'float', 'double', 'ntohl', 'double', 'letohl', 'lv', 'ntohll', 'letohs', 'ntohs', 'byte', 'ntohl', 'letohl']), 'semistillpassback': ([], ['ntohll', 'byte', 'letohl', 'lv', 'letohll', 'letohs', 'lv', 'letohll', 'lv', 'string', 'ntohl', 'letohs', 'letohs', 'ntohs', 'lv', 'letohll', 'letohll', 'double', 'letohs', 'lv', 'float', 'letohs', 'letohs', 'byte']), 'stertoriouscrass': (['indirecthierarchism', 'maternityhomogenetic', 'hypoplasyhooping', 'addressorcondensedly', 'mammillationpemphigous', 'unfootsorepoonac', 'Histriobdellauntread', 'coeternaloverhonor', 'strangulableargentamid', 'Anchtheriumunastonish', 'aerophilethyroidless', 'triplewisepostepileptic', 'pericyclonicdipteran', 'balandracaducibranch', 'unflukedcleck', 'algorithmicSericana', 'multifurcateobstructively', 'indecencyjimply', 'Philoctetessupersalesman', 'shuttlecockscanmag', 'prehexameraldissyllabize', 'cynophileLobale', 'Bharatadomain', 'scheltopusikAmpelidaceae', 'springlikemonosymmetrically', 'antiviraltackety', 'prebromidicMonopetalae', 'triquetricinfrasternal', 'turbidlycorticoefferent', 'vanilleshellburst', 'buttTarahumara', 'relapcantalite', 'Slavophilesedigitate', 'spermatozoaTrachodontidae', 'brackishrehazard', 'camphyleneremarkedly', 'Oliveanpyromancer', 'Margaropusscooter', 'membershiptownsboy', 'uncomminutedcommix', 'retroclusionmetaphysicianism', 'unremittinglyaffronting', 'abjudicationunpleading', 'Bombycillahonoraria', 'Brandipriestcraft', 'frontomallarforedetermine', 'deletoryrollerskating', 'rewhirlhypermotility', 'excentricalProtococcales', 'Lawsonsemiconversion', 'lemologydiplasion', 'paraderDendrocygna', 'archsnoblodgepole', 'extravagantkaryoplasmatic', 'remisrepresentationlancet', 'ofttimessnatchingly', 'subcostalbaldmoney', 'ambisyllabicfruitful', 'tautoousianentente', 'visorlikeNagari', 'alkargenmoop', 'Vandiemenianwinery', 'spicousHippopotamidae', 'pneumodynamicsprimariness', 'mallemuckyawner', 'Lithosiinaecoequation'], ['ntohs', 'nextproto_b', 'string', 'letohs', 'byte', 'string', 'ntohs', 'lv', 'float', 'float', 'lv', 'ntohs', 'ntohll', 'ntohll', 'letohl', 'ntohll', 'ntohs', 'byte', 'letohl', 'ntohs', 'string', 'lv', 'letohll', 'letohs', 'letohl', 'letohl']), 'cotteextubate': ([], ['lv', 'string', 'ntohs', 'letohll', 'letohll', 'ntohl', 'byte', 'letohl', 'byte', 'double', 'ntohl', 'ntohl', 'byte', 'float', 'lv']), 'pyroaceticnunciature': ([], ['float', 'ntohs', 'letohl', 'letohs', 'ntohl', 'ntohll', 'letohll', 'lv', 'lv', 'byte', 'ntohs', 'letohl', 'ntohll', 'letohs']), 'predisorderlyGladys': (['variationaladjutory', 'udometricpredefault', 'leathermakersemishirker', 'cardialgiacontingence', 'galvanothermometerBalzacian', 'etherifyCicadidae', 'zincotypetripodic', 'semideliriousmelituria', 'schuleclethraceous', 'cantingnesstideful', 'marblelikeTenaktak', 'quakinglyilliterate', 'unfangedramline', 'archsnoblodgepole', 'ridgeplatedisturbed', 'dunneaneuploidy', 'poonghiehectic', 'fetoracclimatement', 'torskpiss', 'antleredadunc', 'unfeasiblecollodiotype', 'sokarailer', 'unfootedHilary', 'crossboltedasexually', 'systemizableepode', 'outgushpenniveined', 'epitrophygoatlike', 'algorithmicSericana', 'catafalquedree', 'oilinessbookwright', 'esophagoplastyrestrainedness', 'membershiptownsboy', 'terrazzododder', 'GemitoresBourignian', 'assentaneoushemal', 'polyspermatouscreationistic', 'Chlamydobacteriaceaesystematize', 'teleophoreunspinsterlike', 'blossomscrimshander', 'oversolicitouslyhour', 'antiphonybackplate', 'smotheringlyhumpbacked', 'laterodeviationNarciss', 'gemeledAdonai', 'loungyimpolite', 'deadlockperiangitis', 'warneriodocasein', 'bacteriformpiercel', 'organoantimonypreoperator', 'falsificationcomer', 'indulginglyretrue', 'predisciplinetukra', 'bizonedraconites', 'multifurcateobstructively', 'enclothearmiferous', 'brackishrehazard', 'fillmetroptosis', 'tonkredarken', 'haversinepitaya', 'medicochirurgicadvise', 'maskflowerkeynoter', 'overcriticalnesslovableness', 'Castoroidespentacrinite', 'beseemingnessprefulgent', 'dookmainport', 'denieragedrapery', 'percontationMaimonist', 'cassiteritecasemaking', 'Pileabayadere', 'whealwormrice', 'ochronosusafterbody', 'solemnlystre', 'Erotylidaeprehesitate', 'superestablishmentsuccor', 'uncatholicizeSiphonognathus', 'pneumodynamicsprimariness', 'cylindrarthrosisnonplusation', 'grapedmassively', 'unreprovedlysprier', 'yoreexponent', 'indecencyjimply', 'unfannedhopperman', 'intergeneratingruneword', 'planetologyphocine', 'Momotinaenonfortification', 'perukiershiplexicographer', 'exarteritisthenadays', 'valvotomypensionably', 'lipemiabenjamin', 'kempstergarefowl', 'surlyreptilferous', 'reladepropiolaldehyde', 'subsoilercruent', 'simulcastriboflavin', 'surrenalinconcluding', 'Graphiolacolorimetry'], ['ntohs', 'ntohs', 'double', 'ntohs', 'letohs', 'ntohl', 'string', 'ntohs', 'nextproto_b', 'letohl', 'ntohll', 'nextproto_b', 'nextproto_s', 'double', 'letohs', 'string', 'ntohl', 'float', 'float', 'letohl', 'lv', 'nextproto_s', 'ntohl', 'string', 'ntohs', 'byte', 'float', 'byte', 'letohs', 'byte', 'letohl', 'letohl', 'nextproto_b', 'ntohl', 'nextproto_b', 'letohl', 'ntohll', 'letohl', 'letohs', 'float']), 'spadelikemassacrer': ([], ['string', 'letohl', 'letohll', 'byte', 'double', 'letohs', 'lv', 'letohl', 'lv', 'ntohl', 'float', 'ntohl', 'letohl', 'string', 'letohl', 'ntohl', 'letohl', 'double', 'letohl', 'letohs', 'double', 'letohll', 'byte']), 'applanationnitrifaction': ([], ['letohl', 'letohs']), 'superlapsariandrawlatch': ([], ['letohll', 'letohs']), 'overdiligentlyrifleshot': ([], ['letohll', 'letohs', 'double', 'ntohs', 'float', 'double', 'float', 'byte', 'letohll', 'byte', 'ntohl', 'lv', 'float', 'letohl', 'ntohl', 'ntohl']), 'merseglobular': ([], ['letohl', 'lv', 'float', 'ntohs', 'letohll', 'double', 'lv', 'ntohs', 'lv', 'float', 'byte', 'lv', 'letohs', 'letohs', 'ntohs', 'letohll', 'string', 'letohs', 'letohl', 'double', 'letohs', 'ntohs', 'letohs', 'double', 'letohll', 'double', 'string', 'string', 'ntohl', 'float', 'lv', 'byte', 'float', 'float', 'letohl', 'letohs', 'letohll', 'letohs', 'letohs', 'ntohll', 'ntohl', 'letohl', 'ntohl', 'letohll', 'letohl']), 'empyreumatizefraternism': ([], ['ntohl', 'float', 'byte', 'ntohs', 'float', 'lv', 'letohll', 'float']), 'cacuminalgastrohysterorrhaphy': (['barrelmakingparoemia', 'ochronosusafterbody', 'superestablishmentsuccor', 'Triuridalesplagiarism', 'superabsurdditremid', 'maltingsurrection', 'cystocarppapaprelatical', 'cesserreichspfennig', 'pneumodynamicsprimariness', 'unbeggarbroncholithiasis', 'Tullianrubidium', 'collationdissuasively', 'evaluecystatrophia', 'outworthbenevolence', 'bawcockPicnickian', 'apioidalNagari', 'peccationfoolery', 'perukiershiplexicographer', 'ambisyllabicfruitful', 'blepharanthracosisuncliented', 'Steganophthalmiagnomic', 'foliicolousskeletonweed', 'steelworkpsychophysiological', 'bairnlyneocosmic', 'cylindrarthrosisnonplusation', 'symmetricalantimasker', 'susurrateoutvie', 'multicrystallinekeratoglossus', 'dehydrogenizeCambrian', 'veldcraftsubprefect', 'menialitypreintelligent', 'intrathoraciccoemployment', 'asepticallyBernese', 'udometricpredefault', 'Orakzaiunsatisfiedly', 'radiopaqueunrecruitable', 'wutproamusement', 'counterpotentMetabola', 'amlipyrexic', 'semicolumnrankly', 'hetericismswayable', 'malthouseenteralgia', 'Bryumextrafocal', 'cacuminalgastrohysterorrhaphy', 'strangulableargentamid', 'coeternaloverhonor', 'opportunisttitlark', 'countryfolkintolerance', 'asperationoraculousness', 'pilchermonaulos', 'cardialgiacontingence', 'xenopodidtrencherless', 'dermoiddiversifiable', 'prattlersuffumigate', 'sheepkeepingfeedman', 'piskgriff', 'focoidsstackfreed', 'Pamirioversystematic', 'Vandiemenianwinery', 'mattapharyngological', 'epigenesistbisexed', 'sacroposteriorveratryl', 'tautoousianentente', 'unhittabledoublehorned', 'unfannedhopperman', 'weathercockismcustodier', 'loungyimpolite', 'shortcakeabase', 'goniometerhexameral', 'cassiteritecasemaking', 'peritrichouslyhepatoflavin', 'cannotdentigerous', 'saltlypropugnator', 'Piscataqualagoonal', 'bullswooldraggletail', 'spraysemisaprophyte', 'hyperneuriasymbolatry', 'unreprovedlysprier', 'ornithotomyblackwort', 'unmistgraffer', 'isuroidunfitly', 'carangoidbotryomycotic', 'vaporizetannery', 'katabolizedermic', 'subordinationbrachial', 'tellurethurryproof', 'predesignateunderservice'], ['letohl', 'double', 'float', 'double', 'lv', 'letohl', 'float', 'ntohs', 'string', 'ntohl', 'ntohs', 'ntohl', 'letohl', 'letohll', 'ntohs', 'nextproto_s', 'byte', 'letohs', 'ntohll', 'ntohl', 'byte']), 'cinecameraHydropotes': ([], ['byte', 'letohs', 'ntohl', 'ntohl', 'string', 'float', 'letohl', 'ntohs', 'byte', 'double', 'lv', 'ntohll', 'double', 'byte', 'lv', 'ntohll', 'lv', 'letohl', 'ntohll', 'double', 'byte', 'letohs', 'double', 'ntohl', 'string', 'double', 'letohs', 'double', 'letohs', 'letohl', 'ntohll', 'lv', 'letohll']), 'antiviraltackety': ([], ['float', 'ntohs', 'lv', 'byte', 'string', 'letohl', 'string', 'ntohl', 'lv', 'ntohl', 'letohll', 'letohl', 'double', 'lv', 'string', 'letohs', 'ntohs', 'letohs', 'ntohs', 'double', 'letohs', 'letohll', 'letohs', 'ntohll', 'letohl', 'ntohs', 'letohll', 'letohl', 'letohs', 'letohl', 'ntohs', 'lv']), 'countryfolkintolerance': (['loungyimpolite', 'unbeggarbroncholithiasis', 'bawcockPicnickian', 'katabolizedermic', 'cardialgiacontingence'], ['lv', 'lv', 'byte', 'ntohll', 'byte', 'ntohll', 'letohll', 'letohs', 'letohll', 'string', 'lv', 'letohl', 'ntohll', 'lv', 'ntohs', 'nextproto_s', 'letohl', 'byte', 'byte', 'nextproto_s', 'string', 'nextproto_s', 'nextproto_s', 'ntohl', 'letohl', 'nextproto_s', 'letohll', 'ntohl', 'letohll', 'double', 'letohs', 'double', 'double', 'nextproto_s', 'double', 'ntohs', 'letohl', 'float', 'ntohll', 'byte', 'letohll', 'byte', 'ntohs', 'ntohll', 'double', 'ntohl', 'ntohs']), 'cryptanalystteenet': ([], ['double', 'float', 'letohl', 'string']), 'zooperalorganotin': ([], ['ntohll', 'letohs', 'float', 'letohs', 'letohll', 'letohl', 'ntohs', 'float', 'float', 'ntohl', 'double', 'ntohll', 'float', 'string', 'float']), 'Chilopsiscompactible': ([], ['lv', 'ntohl', 'float', 'letohs', 'letohll', 'ntohll', 'letohs', 'double', 'letohll', 'double', 'ntohl', 'ntohs', 'letohs', 'letohs', 'ntohl', 'float', 'ntohs', 'ntohs', 'byte', 'double', 'letohs', 'double', 'letohll', 'letohll', 'lv', 'letohl', 'double', 'ntohll']), 'indulginglyretrue': ([], ['letohs', 'byte', 'letohll', 'letohll', 'ntohs', 'ntohll', 'ntohl', 'double', 'ntohl', 'float', 'string', 'letohs', 'float', 'float', 'ntohll', 'letohs', 'ntohl', 'ntohs', 'string', 'ntohll', 'letohl', 'letohl', 'ntohll', 'string', 'double', 'letohs', 'string', 'byte', 'string', 'byte', 'float', 'string', 'ntohs']), 'Robenhausianreboil': ([], ['letohll', 'byte', 'ntohs', 'lv', 'ntohl', 'lv', 'ntohs', 'letohs', 'byte', 'lv', 'byte', 'ntohll', 'letohll', 'float', 'letohll', 'ntohl', 'ntohl', 'byte', 'lv', 'string', 'letohs', 'letohs', 'letohl', 'ntohs', 'byte', 'letohs', 'letohl', 'ntohll', 'ntohl', 'letohl', 'letohl', 'ntohl', 'ntohll', 'string', 'letohs', 'string', 'float', 'letohl', 'float']), 'Orakzaiunsatisfiedly': ([], ['string']), 'affinitativelybrawling': ([], ['float', 'letohl', 'lv', 'lv', 'ntohs', 'ntohl', 'ntohs', 'letohll', 'letohs', 'letohl', 'float', 'lv', 'byte', 'double', 'ntohs', 'letohl', 'ntohs', 'letohs', 'letohs', 'double', 'float', 'string', 'ntohs', 'ntohs', 'string', 'ntohs', 'ntohll', 'ntohll', 'lv', 'letohll']), 'cerebroidodontolcate': ([], ['letohll', 'ntohll', 'letohs', 'float', 'letohs', 'lv', 'string', 'float', 'ntohs', 'double', 'letohll', 'double', 'float', 'ntohll', 'string', 'string', 'string', 'float', 'ntohl', 'ntohll', 'double']), 'typhemiacubit': ([], ['string', 'byte']), 'weathercockismcustodier': ([], []), 'Galwayslaminous': (['thysanuriformcrossrail', 'strainedlypsychopompos', 'unodoriferousWhiggish', 'fetoracclimatement', 'tartishlynarcotical', 'precoxseambiter', 'excentricalProtococcales', 'OrleansSchedius', 'ricketssubtrihedral', 'inkfishpoppycock', 'hemologistbeglide', 'paralyzerthiocarbimide', 'nondistributionclitellus', 'Slavophilesedigitate', 'nonaugmentativehypertelic', 'tecalipalingenesy', 'doubleheartedstaphylolysin', 'symmetricalantimasker', 'homozygotemagicalize', 'Mayorunahybridizer', 'channelizeungarter', 'monodromiclyretail', 'mattapharyngological', 'geriatricundaubed', 'Marcosianpictographically', 'leucoencephalitisconsistent', 'cassiteritecasemaking', 'limsypersistence', 'radiopaqueunrecruitable', 'docimasytrouserdom', 'pyrroylprobity', 'iconismanisostemonous', 'androgynyvegetoalkaline', 'interimperialvignetter', 'erythriticsynergidal', 'trentepohliaceousHectorean', 'motacillinewidespreadly', 'Chilopsiscompactible', 'overhollowescort', 'Stromatoporoideabarry', 'Grahamsaloon', 'monogamianportio', 'surfactantchurchgrith', 'gatewiseunderpot', 'peccationfoolery', 'misadministrationbroody', 'bombonnefiendhead', 'exponencecrubeen', 'oversoldafield', 'lindengamy', 'gemeledAdonai', 'hippocampalscrow', 'irislikeaphyllose', 'changeablyzoophilitic', 'percontationMaimonist', 'noniccosmopoietic', 'malapleurogenous', 'outlawrypervertedness', 'Suionesunprejudicially', 'exarteritisthenadays', 'racegoingunperformed', 'spraysemisaprophyte', 'heliconbonnetman'], ['ntohll', 'letohll', 'ntohll', 'float', 'nextproto_s', 'string', 'nextproto_b']), 'superestablishmentsuccor': (['blepharanthracosisuncliented', 'ornithotomyblackwort', 'Tullianrubidium', 'loungyimpolite', 'tautoousianentente', 'symmetricalantimasker', 'hyperneuriasymbolatry', 'focoidsstackfreed', 'pilchermonaulos', 'amlipyrexic', 'vaporizetannery', 'collationdissuasively', 'menialitypreintelligent', 'asperationoraculousness', 'pneumodynamicsprimariness', 'cardialgiacontingence', 'peccationfoolery', 'intrathoraciccoemployment', 'katabolizedermic', 'cylindrarthrosisnonplusation', 'cannotdentigerous', 'weathercockismcustodier', 'unbeggarbroncholithiasis', 'countryfolkintolerance', 'unmistgraffer', 'Orakzaiunsatisfiedly', 'xenopodidtrencherless', 'mattapharyngological', 'Steganophthalmiagnomic', 'dehydrogenizeCambrian', 'cystocarppapaprelatical', 'coeternaloverhonor', 'steelworkpsychophysiological', 'sacroposteriorveratryl', 'sokarailer', 'superestablishmentsuccor'], ['letohs', 'lv', 'nextproto_s', 'byte', 'double', 'nextproto_b', 'ntohs', 'ntohs', 'float', 'ntohl', 'nextproto_s', 'letohl', 'string', 'ntohl', 'letohs', 'byte', 'letohll', 'float', 'letohs', 'string', 'ntohs', 'nextproto_s', 'ntohll', 'letohs', 'byte', 'nextproto_b', 'double', 'ntohl', 'float', 'letohs', 'double', 'letohs', 'letohl', 'letohs', 'float', 'letohs', 'ntohll', 'float', 'letohs', 'letohll', 'letohs', 'nextproto_b', 'float', 'letohs', 'letohs', 'float', 'double', 'letohs']), 'irreclaimableconjugally': ([], ['string', 'letohll', 'ntohll', 'letohs', 'lv', 'letohll', 'letohl', 'string', 'byte', 'letohs', 'ntohs', 'ntohs', 'letohl', 'ntohl', 'lv', 'letohs', 'ntohl', 'lv', 'double', 'double', 'byte', 'string', 'ntohll', 'ntohs', 'ntohs', 'ntohll', 'ntohll', 'ntohl']), 'cattlefolk': (['unfeasiblecollodiotype', 'receptivelynonshredding', 'Slavophilesedigitate', 'psychrographismdom', 'Negritohydroponicist', 'crossboltedasexually', 'entomicperjuriousness', 'pedestrianateStromateidae', 'addressorcondensedly', 'sagaiebarrister', 'tecalipalingenesy', 'lindengamy', 'phenomenalisticallyunmomentary', 'carannaaccension', 'intwistpunter', 'intercoolingpotentialization', 'benzalethylaminedesulphurate', 'depositoryteloblastic', 'Saxonicalpalet', 'laterodeviationNarciss', 'vivifybenefactorship', 'emergencechouette', 'exponencecrubeen', 'engrossedlyDinoceras', 'leadstonehypovitaminosis', 'prizeexcrescence', 'pellagrosemongrelization', 'subregenthelmeted', 'surrenalinconcluding', 'unmistgraffer', 'knuckleboneunnegotiableness', 'unspendablevanilla', 'hetericismswayable', 'sulphuratorjonquil', 'outfeatvasodilator', 'raucousEstheriidae', 'micrencephalypalpus', 'unfootsorepoonac', 'ciderishazury', 'pilchermonaulos', 'ophthalmalgiamisproduce', 'triquetricinfrasternal', 'creditiveplatonesque', 'subordinationbrachial', 'sulphostannideuntimeliness', 'woodrowelshrievalty', 'apioidalNagari', 'prehexameraldissyllabize', 'veldcraftsubprefect', 'hemologistbeglide', 'cancelationZoochlorella', 'qualmyishHolocene', 'ExobasidialesEppy', 'distilleryKiwanis', 'ricketssubtrihedral', 'wirrshillingless', 'intrathoraciccoemployment', 'stakeholderunforbade', 'limsypersistence', 'gemeledAdonai', 'barrelmakingparoemia', 'spinthariscopemolybdena', 'tuchunateacademization', 'disjointedlytriamylose', 'superestablishmentsuccor', 'valvotomypensionably', 'amlipyrexic', 'predestinarianglia', 'laparotomycephalohumeralis', 'slopinglyautomatically', 'reshoedrachmae', 'avalanchestylopization', 'galvanothermometerBalzacian', 'smackinglyScheuchzeriaceae', 'Stromatoporoideabarry', 'Larinaecoydog', 'protosiphonaceousossiferous', 'peritrichouslyhepatoflavin', 'ornithotomyblackwort'], ['nextproto_s', 'ntohll', 'ntohs', 'letohs', 'letohll', 'letohll', 'byte', 'letohll', 'ntohll', 'letohll', 'nextproto_s', 'nextproto_b', 'float', 'letohs', 'float', 'letohs', 'letohl', 'ntohs', 'letohl', 'ntohl', 'ntohll', 'lv', 'ntohs', 'string', 'nextproto_b', 'nextproto_b', 'ntohll', 'letohs', 'ntohll', 'ntohll', 'letohs', 'ntohll', 'ntohs', 'nextproto_b', 'string', 'string', 'letohll', 'letohs', 'letohl', 'letohl', 'letohs', 'letohs', 'ntohs', 'ntohs', 'lv', 'double', 'lv', 'nextproto_b', 'letohll', 'lv']), 'yinsttenderness': ([], ['ntohl', 'letohll', 'ntohs', 'double', 'ntohs', 'ntohl', 'byte', 'ntohl', 'float', 'letohl', 'letohl', 'string', 'ntohl', 'byte', 'letohs', 'ntohll', 'letohll', 'letohl', 'byte', 'ntohl', 'ntohs', 'letohs', 'ntohll', 'ntohs']), 'flashpanstature': ([], ['float', 'double', 'letohll', 'string', 'letohs', 'ntohs', 'ntohl', 'ntohl', 'letohll', 'float', 'float', 'float', 'ntohll', 'ntohl', 'letohll', 'letohs', 'ntohs', 'ntohl', 'float', 'ntohll', 'double']), 'gymnosporouswoubit': ([], ['ntohl']), 'percontationMaimonist': ([], ['double', 'ntohl', 'ntohl', 'letohl', 'ntohl', 'ntohl', 'string', 'letohll', 'string']), 'prelanguagecloudage': (['woodrowelshrievalty', 'Vandiemenianwinery', 'unhyphenedallose', 'visorlikeNagari', 'untuckedsolenoglyphic', 'symmetricalantimasker', 'unbeggarbroncholithiasis', 'anomalousparallelinerved', 'overpoliticunderlooker', 'faddyamputational', 'isuroidunfitly', 'cinecameraHydropotes', 'avalanchestylopization', 'yoreexponent', 'cesserreichspfennig', 'diseasednessthioantimonate', 'zoosporangialbuyable', 'superabsurdditremid', 'slichtarradiddler', 'ineloquentundishonored', 'querulouslycooky', 'interventraliaforeutter', 'huddlingcladautoicous', 'strangulableargentamid', 'epigenesistbisexed', 'peritrichouslyhepatoflavin', 'paleobotanyworkpeople', 'Sumasslevulosuria', 'opportunisttitlark', 'peccationfoolery', 'weathercockismcustodier', 'changeablyzoophilitic', 'uncatholicizeSiphonognathus', 'parathyroidectomizeoutheart', 'Fichteanismconjobble', 'dermobranchiataboyardom', 'symptosissubcorneous', 'frolickytriphyline', 'Philonismpinivorous', 'xenopodidtrencherless', 'perukiershiplexicographer', 'fetoracclimatement', 'wutproamusement', 'hyperduliaferrateen', 'focoidsstackfreed', 'Lawsonsemiconversion', 'napalmbrevifoliate', 'refilmopenhandedness', 'cylindrarthrosisnonplusation', 'correctorSpirochaeta', 'chaffererunheaded', 'sageshipcarcoon', 'Piscataqualagoonal', 'lepidodendridcounterplead', 'goniometerhexameral', 'utterabilitypavement', 'prelanguagecloudage', 'cardialgiacontingence', 'racegoingunperformed', 'distilleryKiwanis', 'epexegeticallyreadjournment', 'vaporizetannery', 'crossboltedasexually', 'nonadjustmentwritmaking', 'gumdiggingsalvarsan', 'susurrateoutvie', 'chytridialgoosemouth', 'androgynyvegetoalkaline', 'doubleheartedstaphylolysin', 'flashpanstature', 'subordinationbrachial', 'cannotdentigerous', 'addressorcondensedly', 'Opisthocomidaeheterochiral', 'listeningBroussonetia', 'xenogenesisprenoble', 'semiduplexskirt', 'channelizeungarter', 'untastedgirllike', 'seminegroSemiticize', 'udometricpredefault', 'asepticallyBernese', 'dehydrogenizeCambrian', 'bawcockPicnickian', 'pedestrianateStromateidae', 'warneriodocasein', 'outworthbenevolence', 'Steganophthalmiagnomic', 'blepharanthracosisuncliented', 'radiopaqueunrecruitable', 'cystocarppapaprelatical', 'antleredadunc', 'evaluecystatrophia', 'stakeholderunforbade', 'crouchingpurebred', 'unmistgraffer'], ['double', 'byte', 'ntohl', 'ntohs', 'nextproto_b', 'letohll', 'nextproto_b', 'nextproto_b', 'letohl', 'double', 'string', 'letohl', 'string', 'letohs', 'letohl', 'nextproto_b', 'nextproto_b', 'byte', 'ntohll', 'ntohs', 'letohll', 'ntohll', 'nextproto_b', 'letohl', 'ntohl', 'letohl', 'nextproto_s', 'ntohll', 'ntohll', 'double', 'letohs', 'letohs', 'nextproto_b', 'nextproto_s', 'letohll', 'ntohs', 'letohs', 'string', 'nextproto_s']), 'avalanchestylopization': ([], ['letohs', 'letohl', 'ntohl', 'letohll', 'letohs', 'byte', 'ntohs', 'letohs', 'ntohl', 'byte', 'ntohl', 'lv', 'ntohll', 'string', 'double', 'float', 'letohl', 'ntohs', 'ntohs']), 'pedestrianateStromateidae': ([], ['byte', 'ntohll', 'ntohl', 'ntohl', 'float', 'letohl']), 'urningsubpubescent': ([], ['float', 'double', 'ntohll', 'double', 'ntohl', 'byte', 'lv', 'ntohs', 'lv', 'byte', 'lv', 'string', 'ntohl', 'letohl', 'double', 'ntohs', 'lv', 'double', 'ntohs', 'ntohl', 'lv', 'letohs', 'ntohl', 'ntohl', 'float', 'lv', 'byte', 'ntohs', 'ntohl', 'lv', 'string', 'letohl', 'ntohs', 'ntohl', 'byte', 'ntohl', 'ntohll', 'string', 'float']), 'Mayorunahybridizer': ([], ['letohl', 'letohll', 'letohll', 'letohll', 'double', 'letohl', 'ntohll', 'double', 'letohll', 'letohl', 'ntohl', 'float', 'ntohll', 'ntohll', 'letohll', 'letohll', 'lv', 'double', 'ntohs', 'string', 'lv', 'ntohl', 'letohl', 'double', 'ntohl', 'lv', 'double', 'double', 'lv', 'ntohll', 'string', 'letohs']), 'undercropArenga': (['porencephalonpostplegic', 'Anglomaniaclovableness', 'Heterodactylaefrisk', 'galvanothermometerBalzacian', 'herpetologistindeed', 'ramraceBorderies', 'metatitanatetarente', 'pneumodynamicsprimariness', 'baptizeeFrenchize', 'polishedlyhematosis', 'carangoidbotryomycotic', 'merseglobular', 'prelanguagecloudage', 'geriatricundaubed', 'coinbellmaker', 'thymegollidflower', 'bemuzzlesurficial', 'bumblefooticonology', 'menialitypreintelligent'], ['nextproto_s', 'float', 'float', 'nextproto_s', 'byte', 'ntohs', 'string', 'letohl', 'string', 'double', 'byte', 'float']), 'Plymouthistnashgab': ([], ['string', 'byte', 'float', 'letohs', 'ntohl', 'letohll', 'string', 'letohl', 'letohl', 'float', 'letohl', 'float', 'byte', 'ntohll', 'lv', 'letohll', 'double', 'float', 'ntohl', 'ntohll', 'double', 'letohl', 'ntohll', 'letohl', 'lv', 'letohs']), 'desoxycorticosteroneshakerag': ([], ['letohl', 'double', 'double', 'letohll', 'ntohl', 'float', 'double', 'letohll', 'letohs', 'ntohl', 'byte', 'letohs', 'lv']), 'hemologistbeglide': ([], ['ntohl', 'byte', 'letohl', 'ntohl', 'letohl', 'letohl', 'letohs', 'letohs', 'string', 'lv', 'lv', 'letohll', 'letohs', 'letohs', 'letohl', 'ntohl', 'letohll', 'string', 'letohs', 'ntohl', 'letohll', 'ntohs', 'float', 'ntohl', 'ntohll', 'ntohs', 'lv', 'string', 'string', 'byte', 'letohs', 'double', 'float', 'ntohl', 'byte', 'letohl', 'double']), 'lagoonaltanning': ([], ['double', 'float', 'letohl', 'ntohll', 'letohs', 'letohll', 'string', 'ntohll', 'ntohll', 'lv', 'letohll', 'ntohs', 'ntohl', 'double', 'letohl', 'string', 'byte', 'ntohs', 'string', 'lv', 'byte', 'ntohl', 'float', 'ntohl', 'ntohl', 'letohl', 'double', 'letohl', 'letohl', 'letohl', 'lv']), 'Jesperyearlong': ([], ['lv']), 'chromophilouspyometra': ([], ['ntohll', 'letohl']), 'leadstonehypovitaminosis': ([], ['letohl', 'lv', 'letohl', 'string', 'float', 'letohs', 'double', 'ntohll', 'letohs', 'double', 'letohl', 'letohll']), 'chiliasticskean': ([], ['string', 'letohs', 'lv', 'float', 'letohll', 'ntohl', 'string', 'ntohl', 'ntohs', 'letohl', 'float', 'double', 'string', 'float', 'ntohl', 'float', 'letohll', 'letohll', 'ntohl', 'ntohl', 'ntohll', 'string', 'letohl', 'float', 'ntohll', 'ntohs', 'double', 'ntohl', 'byte', 'double', 'string', 'letohl', 'byte', 'letohs', 'lv', 'float', 'letohl', 'ntohll', 'letohll', 'double']), 'pinkberrynonvillainous': ([], ['letohl', 'letohs', 'byte', 'float', 'lv', 'float', 'letohl', 'lv', 'double', 'string', 'letohll', 'double', 'ntohs']), 'sheepkeepingfeedman': (['collationdissuasively', 'perukiershiplexicographer', 'spraysemisaprophyte', 'cancelationZoochlorella', 'foliicolousskeletonweed', 'sheepkeepingfeedman', 'asepticallyBernese', 'outworthbenevolence', 'ochronosusafterbody', 'strangulableargentamid', 'Piscataqualagoonal', 'Tullianrubidium', 'pneumodynamicsprimariness', 'saltlypropugnator', 'pilchermonaulos', 'isuroidunfitly', 'superabsurdditremid', 'ornithotomyblackwort', 'peritrichouslyhepatoflavin', 'hetericismswayable', 'unhittabledoublehorned', 'hyperneuriasymbolatry', 'Bryumextrafocal', 'ambisyllabicfruitful', 'coeternaloverhonor', 'udometricpredefault', 'cylindrarthrosisnonplusation', 'vaporizetannery', 'countryfolkintolerance', 'asperationoraculousness', 'dehydrogenizeCambrian', 'unmistgraffer', 'carangoidbotryomycotic', 'steelworkpsychophysiological', 'sokarailer', 'goniometerhexameral', 'subordinationbrachial', 'piskgriff', 'cystocarppapaprelatical', 'shortcakeabase', 'bairnlyneocosmic', 'tellurethurryproof', 'multicrystallinekeratoglossus', 'tautoousianentente', 'peccationfoolery', 'Orakzaiunsatisfiedly', 'prattlersuffumigate', 'loungyimpolite', 'dermoiddiversifiable', 'susurrateoutvie', 'symmetricalantimasker', 'superestablishmentsuccor', 'blepharanthracosisuncliented', 'Pamirioversystematic', 'counterpotentMetabola', 'sacroposteriorveratryl', 'xenogenesisprenoble', 'cassiteritecasemaking', 'mattapharyngological', 'evaluecystatrophia', 'cesserreichspfennig', 'intrathoraciccoemployment', 'katabolizedermic', 'barrelmakingparoemia', 'xenopodidtrencherless', 'apioidalNagari', 'amlipyrexic'], ['double', 'letohs', 'byte', 'float', 'letohs', 'ntohll', 'float', 'ntohs', 'ntohl', 'string', 'nextproto_b', 'float', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'float', 'double', 'ntohs', 'lv', 'letohl', 'ntohl', 'nextproto_s', 'byte', 'lv', 'ntohs', 'nextproto_b', 'double']), 'udometricpredefault': (['evaluecystatrophia', 'Bryumextrafocal', 'steelworkpsychophysiological', 'ornithotomyblackwort', 'saltlypropugnator', 'udometricpredefault', 'asperationoraculousness', 'mattapharyngological', 'collationdissuasively', 'peccationfoolery', 'tautoousianentente', 'dehydrogenizeCambrian', 'outworthbenevolence', 'pneumodynamicsprimariness', 'crouchingpurebred', 'veldcraftsubprefect', 'subordinationbrachial', 'sacroposteriorveratryl', 'unbeggarbroncholithiasis', 'coeternaloverhonor', 'xenopodidtrencherless', 'cesserreichspfennig', 'blepharanthracosisuncliented', 'intrathoraciccoemployment', 'symmetricalantimasker', 'bawcockPicnickian', 'katabolizedermic', 'weathercockismcustodier', 'loungyimpolite', 'vaporizetannery'], ['double']), 'Suionesunprejudicially': ([], ['letohs', 'string', 'lv', 'string', 'letohll', 'float', 'string', 'letohll', 'float', 'ntohl', 'letohl', 'ntohll', 'ntohll', 'letohl', 'float', 'letohs', 'lv', 'double', 'string', 'double', 'ntohl', 'ntohs', 'letohs', 'ntohll', 'letohl', 'letohl', 'letohll', 'string', 'ntohll', 'ntohll', 'double', 'letohs', 'lv', 'ntohl', 'ntohl']), 'ragamuffinismwageless': ([], ['ntohs', 'lv', 'letohll', 'double', 'letohs', 'string', 'string', 'letohs', 'string', 'float', 'ntohll', 'lv', 'byte', 'byte', 'lv', 'float', 'ntohl', 'byte', 'float', 'ntohll', 'float']), 'somnipathistcarbonometry': (['antiviraltackety', 'schuleclethraceous', 'arecolidinehyalodacite', 'damnonianscrankly', 'aerophilethyroidless', 'spraysemisaprophyte', 'Saxonicalpalet', 'changeablyzoophilitic', 'outworthbenevolence', 'Abrahamicinordinateness', 'nonofficeholdingwaldgravine', 'autovivisectionoverleather', 'demibeastuninflicted', 'wingerconsoler', 'hallowerhydrophthalmos', 'tautologicpanimmunity', 'parandruspercribration', 'improvisatorizenoneditorial', 'isatogenvestibulum', 'teleorganicanthracitiferous', 'cleansingpentahedral', 'saltlypropugnator', 'androgynyvegetoalkaline', 'miningFlavia', 'strainedlypsychopompos', 'urningsubpubescent', 'chartermarrowy', 'leathermakersemishirker', 'tellurethurryproof', 'foreuseuninfluencing', 'parathyroidectomizeoutheart', 'munjmuchness', 'vivifybenefactorship', 'Ternstroemiaanisostomous', 'Boneyretreater', 'unquailingshive', 'Opisthocomidaeheterochiral', 'unmensurableSoohong', 'raucousEstheriidae', 'trichitepersonship', 'sulphuratorjonquil', 'overgenialitybuzzle', 'steelworkpsychophysiological', 'antiphonybackplate', 'catagmaticMegalosaurus', 'irislikeaphyllose', 'gratifyinglymetrorrhea', 'coinbellmaker', 'etherifyCicadidae', 'manageriallyflanger', 'surfactantchurchgrith'], ['ntohs', 'ntohs', 'letohll', 'ntohll', 'letohll', 'double', 'letohll', 'ntohll', 'letohll', 'lv', 'nextproto_s', 'string', 'letohs', 'float', 'string', 'lv', 'letohll', 'float', 'ntohs', 'letohll', 'lv', 'string', 'letohll', 'lv', 'ntohll', 'letohll', 'ntohl', 'letohs', 'byte', 'double', 'ntohll', 'ntohs', 'double', 'ntohs', 'ntohll', 'nextproto_b', 'letohs', 'float', 'letohl', 'float', 'nextproto_s', 'ntohll', 'letohs', 'letohs', 'byte', 'ntohl', 'letohll']), 'Saxonicalpalet': ([], ['lv', 'ntohll', 'ntohl', 'ntohll', 'ntohs', 'letohl', 'double', 'ntohll', 'ntohl', 'double', 'string', 'letohs', 'ntohl', 'letohl', 'letohll', 'float', 'lv', 'ntohll', 'letohl']), 'imperializetrispaston': (['dermoiddiversifiable', 'Steganophthalmiagnomic', 'sacroposteriorveratryl', 'pilchermonaulos', 'extravagantkaryoplasmatic', 'perukiershiplexicographer', 'asperationoraculousness', 'foliicolousskeletonweed', 'epigenesistbisexed', 'roofprespur', 'usurperunplannedly', 'amlipyrexic', 'esophagoplastyrestrainedness', 'overhollowescort', 'malthouseenteralgia', 'tellurethurryproof', 'superestablishmentsuccor', 'refilmopenhandedness', 'hyperneuriasymbolatry', 'cancelationZoochlorella', 'dehydrogenizeCambrian', 'unmistgraffer', 'carannaaccension', 'unbeggarbroncholithiasis', 'imperializetrispaston', 'untastedgirllike', 'stakeholderunforbade', 'sheepkeepingfeedman', 'cesserreichspfennig', 'visorlikeNagari', 'cystocarppapaprelatical', 'subordinationbrachial', 'unconvenedperpetually', 'sokarailer', 'catmalisoncoevally', 'countryfolkintolerance', 'veldcraftsubprefect'], ['letohs', 'letohs', 'lv', 'nextproto_b', 'string', 'letohs', 'nextproto_b', 'letohl', 'letohl', 'letohll', 'ntohll', 'string', 'letohll', 'letohll', 'letohl']), 'arhatsporozoic': (['crouchingpurebred', 'iconismanisostemonous', 'mattapharyngological', 'seminegroSemiticize', 'correctorSpirochaeta', 'shuttlecockscanmag', 'pilchermonaulos', 'springlikemonosymmetrically', 'phototherapistupsetted', 'etioporphyrinpubovesical', 'bairnlyneocosmic', 'predesignateunderservice', 'subcineritiousphrenitic', 'paleobotanyworkpeople', 'sageshipcarcoon', 'fetoracclimatement', 'unreprovedlysprier', 'declamatorinessSerrifera', 'cinecameraHydropotes', 'frolickytriphyline', 'antleredadunc', 'Orakzaiunsatisfiedly', 'Fichteanismconjobble', 'Vandiemenianwinery', 'unhittabledoublehorned', 'pneumodynamicsprimariness', 'Sumasslevulosuria', 'organosiliconsegmentary', 'genipacombiner', 'Opisthocomidaeheterochiral', 'tautoousianentente', 'katabolizedermic', 'Tullianrubidium', 'interventraliaforeutter', 'overhollowescort', 'asperationoraculousness', 'trentepohliaceousHectorean', 'Dokoelectrochemically', 'Pamirioversystematic', 'weathercockismcustodier', 'chytridialgoosemouth', 'superestablishmentsuccor', 'tenesmicHymettic', 'precoxseambiter', 'anomalousparallelinerved', 'predisciplinetukra', 'superabsurdditremid', 'unbeggarbroncholithiasis', 'cannotdentigerous', 'reladepropiolaldehyde', 'pedestrianateStromateidae', 'carcerationinterrenal', 'Mayorunahybridizer', 'Philonismpinivorous', 'piskgriff', 'addressorcondensedly', 'blepharanthracosisuncliented', 'cassiteritecasemaking', 'hemianacusiadouble', 'dermobranchiataboyardom', 'noggencapitulate', 'dehydrogenizeCambrian', 'opportunisttitlark', 'polyspermatouscreationistic', 'spadelikemassacrer', 'sheepkeepingfeedman', 'pellagrosemongrelization', 'avalanchestylopization', 'bumblefooticonology', 'herpetologistindeed', 'coeternaloverhonor', 'barrelmakingparoemia'], ['lv', 'double', 'lv', 'nextproto_s', 'byte', 'lv', 'letohs', 'lv', 'ntohs', 'nextproto_b', 'ntohl', 'ntohs', 'ntohs', 'nextproto_s', 'letohs', 'nextproto_s', 'ntohll', 'letohl', 'ntohs', 'ntohl', 'double', 'letohl', 'letohll', 'ntohs', 'letohl', 'string', 'float', 'ntohll', 'ntohl', 'letohs', 'letohs', 'ntohs', 'ntohl', 'ntohll', 'nextproto_b', 'letohs', 'nextproto_b', 'double', 'ntohl', 'float']), 'lungflowerhorrormonger': ([], ['letohll', 'string', 'byte', 'lv', 'double', 'ntohll']), 'cudavaogreish': (['fleaweedprobate', 'sageshipcarcoon', 'denieragedrapery', 'evaluecystatrophia', 'meddlingsmall', 'cardialgiacontingence', 'buttTarahumara', 'terrazzododder', 'turbidlycorticoefferent', 'cerebroidodontolcate', 'peritrichouslyhepatoflavin', 'retroclusionmetaphysicianism', 'shortcakeabase', 'awiwimegaloglossia', 'cassiteritecasemaking', 'oxmanoutpull', 'docimasytrouserdom', 'indirecthierarchism', 'slichtarradiddler', 'percontationMaimonist', 'unfannedhopperman', 'stagemansupa', 'crouchingpurebred', 'Voltaprotarsal', 'delthyrialGee', 'warneriodocasein', 'unhittabledoublehorned', 'poonghiehectic', 'simulcastriboflavin', 'oversolicitouslyhour', 'catafalquedree', 'Orakzaiunsatisfiedly', 'menialitypreintelligent', 'recapitalizerelevate', 'domanialPhora', 'interventraliaforeutter', 'frolickytriphyline', 'terribletaut', 'tumoredcrocodilite', 'Eomecondiscolorate', 'polyspermatouscreationistic', 'Philoctetessupersalesman', 'pneumodynamicsprimariness', 'misadministrationbroody', 'hippocampalscrow', 'cycloolefinmonostylous', 'unoverhauledGalinsoga', 'bombonnefiendhead', 'Fichteanismconjobble', 'feveretunderbox', 'photocompositioneneuch', 'sulfureasupertramp', 'shuttlecockscanmag', 'sheepkeepingfeedman', 'tenesmicHymettic', 'unsanctioningperiuvular', 'Pamirioversystematic', 'cancelationZoochlorella', 'subsoilercruent', 'dehydrogenizeCambrian', 'arhatsporozoic', 'Dokoelectrochemically'], ['letohl', 'string', 'ntohs', 'letohs', 'nextproto_s', 'nextproto_b', 'letohll', 'double', 'letohll', 'letohll', 'letohs', 'lv', 'letohl', 'double', 'byte', 'ntohl', 'ntohs', 'ntohs', 'ntohl', 'ntohs', 'ntohl', 'letohs', 'float', 'lv', 'lv', 'ntohll', 'float', 'lv', 'ntohl', 'nextproto_b', 'ntohll', 'ntohl', 'ntohll', 'ntohll', 'nextproto_s', 'nextproto_s', 'double', 'nextproto_s', 'nextproto_s', 'letohl', 'byte', 'ntohs', 'byte', 'byte', 'lv', 'letohll']), 'assentaneoushemal': (['endopathicnonmarrying', 'phenomenalisticallyunmomentary', 'sagaiebarrister', 'lipemiabenjamin', 'listeningBroussonetia', 'oxmanoutpull', 'evenworthyharebrain', 'bumblefooticonology', 'galledisocinchomeronic', 'ankylophobiaAsperula', 'asperationoraculousness', 'nondistributionclitellus', 'pyrroylprobity', 'uncatholicizeSiphonognathus', 'bairnlyneocosmic', 'Caraipaearcap', 'clientageshudderingly', 'Physciawenny', 'xiphosternamedia', 'stavelessindissolubleness', 'hyperduliaferrateen', 'blepharanthracosisuncliented', 'skilderprothalline', 'avalanchestylopization', 'craunchprovitamin', 'tauromachyoutgive', 'ragamuffinismwageless', 'apioidalNagari', 'Chlamydobacteriaceaesystematize', 'scutcheonwiseileocolitis', 'sandwortFierasfer', 'affinitativelybrawling', 'oversecurelyelocution', 'byworkplastid', 'vasoconstrictorsupracretaceous', 'perukiershiplexicographer', 'Dokoelectrochemically', 'keelfathoplomachos', 'recapitalizerelevate', 'stagemansupa', 'ophthalmalgiamisproduce', 'paleocrystallinespinulosodenticulate', 'Vickyimmigrant', 'insidiouslysurplicewise', 'declamatorinessSerrifera', 'recapitalizationdissipative', 'unscalednessChamaeleon', 'gardenedfugacious', 'Brandipriestcraft', 'Rodolphhumuslike', 'parorchispalingenic', 'xerophagyhematography', 'carcerationinterrenal', 'outworthbenevolence', 'weathercockismcustodier', 'hedgesublimish', 'spraysemisaprophyte', 'frontomallarforedetermine', 'inwrapbilophodont', 'Erotylidaeprehesitate', 'unfangedramline', 'hypernutritionmarae', 'euquinquennium', 'awiwimegaloglossia', 'raucousEstheriidae', 'proteosomalsuppletion', 'cineplastyanonang', 'epexegeticallyreadjournment', 'electrocardiographyamaranthaceous', 'alphabetismpolyfenestral', 'unarrayapparitor', 'indubitablenoncollaboration', 'elementalismpietism', 'phototherapistupsetted', 'chytridialgoosemouth', 'overpoliticunderlooker', 'sowbackgastrotrichan', 'inferiorismobstetrix', 'mediumismgypsyism', 'shortcakeabase', 'catagmaticMegalosaurus', 'trichitepersonship', 'tautoousianentente', 'laparotomycephalohumeralis', 'sageshipcarcoon', 'diseasednessthioantimonate', 'prattlersuffumigate', 'autozooidexternization', 'ciderishazury', 'unspendablevanilla', 'dinitrilholocentrid', 'crouchingpurebred', 'cicisbeismGonystylus', 'Tantalussubcavity', 'sheepkeepingfeedman'], ['float', 'ntohll', 'double', 'string', 'ntohl', 'float', 'letohs', 'ntohl', 'nextproto_s', 'double', 'letohll', 'float', 'float', 'ntohl', 'letohs', 'ntohll', 'nextproto_s', 'lv', 'nextproto_b', 'byte', 'letohl', 'nextproto_s', 'double', 'byte', 'nextproto_b', 'letohs', 'lv', 'double', 'byte', 'double', 'lv', 'letohl', 'letohl', 'letohs', 'letohll', 'nextproto_b', 'lv', 'nextproto_b', 'lv', 'double']), 'lepidodendridcounterplead': (['blepharanthracosisuncliented', 'carangoidbotryomycotic', 'malthouseenteralgia', 'superestablishmentsuccor', 'Triuridalesplagiarism', 'loungyimpolite', 'usurperunplannedly', 'Bryumextrafocal', 'peccationfoolery', 'stakeholderunforbade', 'sageshipcarcoon', 'cesserreichspfennig', 'unreprovedlysprier', 'subordinationbrachial', 'bairnlyneocosmic', 'tenesmicHymettic', 'weathercockismcustodier', 'Pamirioversystematic', 'hammerkopnegativer', 'chytridialgoosemouth', 'predesignateunderservice', 'Eomecondiscolorate', 'bumblefooticonology', 'piskgriff', 'iconismanisostemonous', 'lepidodendridcounterplead', 'unmistgraffer', 'spinthariscopemolybdena', 'ineloquentundishonored', 'xenogenesisprenoble', 'bullswooldraggletail', 'overpoliticunderlooker', 'carannaaccension', 'counterpotentMetabola', 'changeablyzoophilitic', 'surlyreptilferous', 'sokarailer', 'collationdissuasively', 'pilchermonaulos', 'woodrowelshrievalty', 'shuttlecockscanmag', 'Lawsonsemiconversion', 'huddlingcladautoicous', 'refilmopenhandedness', 'evaluecystatrophia', 'springlikemonosymmetrically', 'Orakzaiunsatisfiedly', 'wutproamusement', 'etioporphyrinpubovesical', 'udometricpredefault', 'pneumodynamicsprimariness', 'bawcockPicnickian', 'cardialgiacontingence', 'multicrystallinekeratoglossus', 'anomalousparallelinerved', 'fetoracclimatement', 'untastedgirllike', 'countryfolkintolerance', 'prattlersuffumigate', 'asperationoraculousness', 'frolickytriphyline', 'cannotdentigerous', 'ambisyllabicfruitful', 'sheepkeepingfeedman'], ['ntohll', 'letohs', 'letohll', 'float', 'letohll', 'letohs']), 'remirrorundepreciated': (['hematozoalinfinitarily', 'pavonatedcozily', 'unhyphenedallose', 'bairnlyneocosmic', 'countryfolkintolerance', 'carangoidbotryomycotic', 'Plymouthistnashgab', 'syphilologyannularity', 'burgonetcarefully', 'Wagnerianaaviculturist', 'mediumismgypsyism', 'stakeholderunforbade', 'noniccosmopoietic', 'recapitalizationdissipative', 'OrleansSchedius', 'Limodorumscrotal', 'symmetricalantimasker', 'plurifacialmicrographical', 'prattlersuffumigate', 'clinandriabryologist', 'weathercockismcustodier', 'isuroidunfitly', 'keraunophoneinhabited', 'leathermakersemishirker', 'focoidsstackfreed', 'maternityhomogenetic', 'denieragedrapery', 'genipacombiner', 'addressorcondensedly', 'yoreexponent', 'diseasednessthioantimonate', 'repealistbillsticking', 'seminegroSemiticize', 'Brandipriestcraft', 'peritrichouslyhepatoflavin', 'Philoctetessupersalesman', 'Steganophthalmiagnomic', 'enclothearmiferous', 'phototherapistupsetted', 'certainarchpontiff', 'Eomecondiscolorate', 'hemianacusiadouble', 'Ternstroemiaanisostomous', 'xerophagyhematography', 'catagmaticMegalosaurus', 'racegoingunperformed', 'adiaphorousfalsifiable', 'bemuzzlesurficial', 'snakeletwounds', 'foliicolousskeletonweed', 'collationdissuasively', 'zincotypetripodic', 'congregationalvocimotor', 'chaffererunheaded', 'kansrush', 'predefinitionCarnaria', 'precoxseambiter', 'Dokoelectrochemically', 'intrathoraciccoemployment', 'depositoryteloblastic', 'refallGanguela', 'microcrystallogenyfuniculus', 'nowhitoffscape', 'Alalamenispermine'], ['nextproto_b', 'string', 'nextproto_b', 'string', 'letohll', 'double', 'byte', 'ntohl', 'letohl', 'letohl', 'byte', 'letohll', 'byte', 'float', 'ntohs', 'ntohll', 'ntohll', 'letohs', 'letohll', 'nextproto_s', 'byte', 'float']), 'syphilologyannularity': (['Orakzaiunsatisfiedly', 'weathercockismcustodier', 'countryfolkintolerance', 'refilmopenhandedness', 'Bryumextrafocal', 'coeternaloverhonor', 'pilchermonaulos', 'malthouseenteralgia', 'predesignateunderservice', 'susurrateoutvie', 'evaluecystatrophia', 'udometricpredefault', 'wutproamusement', 'unlasheddialyzable', 'cassiteritecasemaking'], ['letohl', 'double', 'double', 'ntohl', 'nextproto_b', 'ntohs', 'letohl', 'letohll', 'float', 'byte', 'ntohs', 'ntohll', 'byte', 'string', 'double', 'letohs', 'ntohl', 'letohs', 'nextproto_b', 'ntohll', 'letohs', 'nextproto_s', 'ntohs', 'letohll', 'lv', 'ntohl', 'letohl', 'byte', 'ntohs', 'nextproto_b', 'nextproto_s', 'double', 'double']), 'wingerconsoler': (['bustedpredoubter', 'Opisthocomidaeheterochiral', 'scruplercellulifugal', 'shortcakeabase', 'scutcheonwiseileocolitis'], []), 'Maytimeraillike': ([], ['ntohll', 'ntohll', 'ntohll', 'ntohl', 'float', 'lv', 'letohs', 'letohll', 'letohs', 'letohs', 'byte', 'lv', 'ntohs', 'letohl', 'ntohll', 'ntohs', 'letohl']), 'preroyaltycoagulin': ([], ['double', 'letohs', 'float', 'byte', 'float', 'double']), 'rewhirlhypermotility': ([], []), 'vasoconstrictorsupracretaceous': ([], ['letohs', 'float', 'string', 'double', 'double', 'letohl', 'letohll', 'letohl', 'lv', 'lv', 'letohll', 'ntohll', 'lv', 'letohl', 'double', 'ntohll', 'letohl']), 'spinthariscopemolybdena': ([], ['letohll', 'ntohs', 'letohs', 'letohs', 'letohs', 'byte', 'letohl', 'letohl', 'double', 'ntohs', 'byte', 'letohl', 'double', 'double', 'double', 'letohl', 'string', 'lv', 'letohll', 'letohll', 'letohll', 'letohll', 'lv', 'ntohl', 'float', 'ntohll', 'string', 'float', 'ntohll', 'string', 'byte', 'ntohll', 'ntohs', 'letohl', 'byte']), 'cryptomnesiamillward': (['Bitulithicscrin', 'reladepropiolaldehyde', 'chaffererunheaded', 'frolickytriphyline', 'symptosissubcorneous', 'catastateateliosis', 'importationPerisphinctidae', 'snakeletwounds', 'inferiorismobstetrix', 'Melanorrhoeadewworm', 'predestinarianglia', 'entrapmentvoyageable', 'enclothearmiferous', 'Silicoideasaltator', 'parathyroidectomizeoutheart', 'elementalismpietism', 'carannaaccension', 'desoxycorticosteroneshakerag', 'gatewiseunderpot', 'peerlesslyforetalk', 'unodoriferousWhiggish', 'hancesmoothness', 'Manobountopping', 'acutelyminar', 'allerChilostoma', 'hemologistbeglide', 'maskflowerkeynoter', 'gulchalilonghi', 'togueseaflower', 'violationguggle', 'Castoroidespentacrinite', 'alphabetismpolyfenestral', 'gardenedfugacious', 'redifferentiationmustachio', 'apioidalNagari', 'receptivenesssempervirent', 'udometricpredefault', 'vitriolizemonal', 'crossboltedasexually', 'submountainhopper', 'postiquedefeasibility', 'invulnerabledimerization'], ['nextproto_b', 'letohl', 'byte', 'letohs', 'nextproto_s', 'string', 'string', 'string', 'nextproto_b', 'double', 'nextproto_b', 'lv', 'lv', 'nextproto_b', 'letohs', 'float', 'lv', 'nextproto_b', 'byte', 'float', 'lv', 'byte', 'ntohl', 'nextproto_b', 'string']), 'preinjuryduplicature': ([], ['ntohs', 'ntohll', 'letohl', 'lv', 'letohll', 'float', 'letohs', 'letohl', 'string', 'letohs', 'letohll', 'double', 'string', 'string']), 'limnophilidtrienniality': ([], ['float', 'double', 'byte', 'string', 'ntohl', 'letohs', 'letohl', 'byte', 'lv', 'letohs', 'ntohl', 'byte', 'ntohll', 'letohs', 'ntohs', 'letohl', 'byte', 'ntohll', 'double', 'letohl', 'lv', 'ntohs', 'byte', 'string', 'byte']), 'apioidalNagari': ([], ['float', 'float', 'letohll', 'double', 'letohs', 'letohs', 'letohs', 'letohl', 'ntohl', 'ntohll', 'letohll', 'byte', 'double', 'letohll', 'letohl', 'letohll', 'byte', 'byte', 'float', 'letohl', 'letohll', 'float', 'letohll', 'double', 'letohl', 'lv', 'double', 'letohs', 'byte', 'ntohl', 'float', 'string', 'double', 'letohl', 'letohs', 'byte', 'letohll']), 'sulphostannideuntimeliness': ([], ['byte', 'letohs', 'ntohll', 'lv', 'ntohl', 'letohs', 'byte', 'double', 'string', 'ntohs', 'ntohll', 'letohs', 'float', 'letohs', 'lv', 'string', 'ntohl', 'ntohl', 'double', 'ntohl']), 'surlyreptilferous': ([], ['double', 'byte', 'string', 'letohs', 'float', 'byte', 'ntohs', 'ntohll', 'float', 'letohl', 'float', 'ntohl', 'float', 'float', 'string', 'letohl', 'ntohl', 'string', 'letohll', 'byte', 'letohl', 'string', 'string', 'float', 'ntohs', 'letohs', 'double', 'letohll', 'ntohl', 'letohll', 'letohll', 'lv', 'ntohl', 'lv', 'float', 'letohll', 'letohll']), 'Negritohydroponicist': ([], ['letohll']), 'reladepropiolaldehyde': ([], ['string', 'double', 'string', 'letohl', 'byte', 'ntohll', 'letohs', 'ntohl', 'lv', 'letohs', 'ntohll', 'letohs', 'double', 'byte', 'ntohl', 'lv', 'ntohs', 'ntohl', 'letohl']), 'Caraipaearcap': ([], ['ntohll', 'ntohs', 'byte', 'ntohs', 'ntohl', 'lv', 'string', 'letohll', 'string', 'byte', 'ntohl', 'letohll', 'ntohs', 'ntohl', 'ntohll', 'byte', 'byte', 'ntohs', 'ntohs', 'ntohl', 'lv', 'ntohs', 'float', 'double', 'letohl', 'ntohl', 'byte', 'string', 'ntohs', 'byte', 'lv', 'string', 'ntohl', 'float', 'byte', 'letohl', 'double', 'letohl', 'ntohll', 'ntohll', 'ntohs']), 'achaetouspreparticipation': (['Heterodactylaefrisk', 'tollgateandrophagous', 'applanationnitrifaction', 'counterspyingdungeon', 'ambisyllabicfruitful', 'unscalednessChamaeleon', 'diseasednessthioantimonate', 'Rodolphhumuslike', 'ralphautonomically', 'tuchunateacademization', 'unpopulatecurry', 'pilchermonaulos', 'steelworkpsychophysiological', 'scleroblastemicpalaeocosmology', 'hypoplasyhooping', 'carangoidbotryomycotic', 'bustedpredoubter', 'avalanchestylopization', 'popeyednaphtha', 'simulcastriboflavin', 'opportunisttitlark', 'miningFlavia', 'fillmetroptosis', 'remisrepresentationlancet', 'marblelikeTenaktak', 'foreuseuninfluencing', 'grapedmassively', 'yawpwoodwax', 'subregenthelmeted', 'Abrahamicinordinateness', 'hetericismswayable', 'springlikemonosymmetrically', 'leucoencephalitisconsistent', 'cleansingpentahedral', 'disaffectedanchorite', 'ochronosusafterbody', 'receptivelynonshredding', 'pellagrosemongrelization', 'hematozoalinfinitarily', 'falsificationcomer', 'appendiceunmetaled', 'slopinglyautomatically', 'untrainhearkener', 'preformisticexemplifiable', 'Cobitidaedismissal', 'epexegeticallyreadjournment', 'Mayorunahybridizer', 'pegologyscavenage', 'blepharanthracosisuncliented', 'nasicornousfasciated', 'summarizationyatter', 'stomagringo', 'asepticallyBernese', 'phenomenalisticallyunmomentary', 'gynarchicagedly', 'warfaringdraghound', 'variationaladjutory', 'buttTarahumara', 'postiquedefeasibility', 'metatitanatetarente', 'iridemiabisque'], ['double', 'lv', 'ntohl', 'double', 'letohll', 'string', 'letohs', 'ntohs', 'byte', 'nextproto_b', 'ntohl', 'ntohs', 'float', 'double', 'ntohs', 'letohll', 'nextproto_s', 'nextproto_b', 'float', 'float', 'string', 'ntohl', 'nextproto_s', 'ntohs', 'letohl', 'byte', 'ntohl', 'letohll', 'nextproto_s', 'ntohs', 'double', 'double', 'string', 'lv', 'ntohl', 'byte', 'ntohs', 'letohs', 'float', 'float', 'byte', 'letohl', 'nextproto_s', 'float', 'letohll', 'byte']), 'flamprelate': (['pseudodemocraticproconscription', 'holdsmanoversalty', 'crossboltedasexually', 'undercovertcoloss', 'bumblefooticonology', 'certainarchpontiff', 'nonadjustmentwritmaking', 'cineplastyanonang', 'mammillationpemphigous', 'responsivitykimigayo', 'ornithotomyblackwort', 'thiodiphenylaminediterpene', 'feveretunderbox', 'leucoencephalitisconsistent', 'outlawrypervertedness', 'prizeexcrescence', 'agonizefloating', 'triseriallypreaccess', 'Mayorunahybridizer', 'quakinglyilliterate', 'changeablyzoophilitic', 'yawpwoodwax', 'smackinglyScheuchzeriaceae', 'countryfolkintolerance', 'Aparaipsychiatrist', 'etioporphyrinpubovesical', 'Lachnosternaadenodermia', 'unfannedhopperman', 'chytridialgoosemouth', 'cleansingpentahedral', 'overcriticalnesslovableness', 'acquisitumvaletudinarist', 'disjointedlytriamylose', 'TelopeaCyclotosaurus', 'crouchingpurebred', 'ananaamasty'], ['nextproto_b', 'letohl', 'nextproto_s', 'letohll', 'nextproto_s', 'byte']), 'leucoencephalitisconsistent': ([], ['ntohs', 'ntohs', 'string', 'letohs', 'letohll', 'string', 'ntohll', 'ntohl', 'ntohs', 'letohll', 'ntohs', 'letohs', 'string', 'ntohl', 'letohll', 'byte', 'letohl', 'ntohl', 'ntohl', 'double']), 'balandracaducibranch': ([], ['letohl', 'byte', 'ntohs', 'float', 'byte', 'float', 'letohl', 'letohl', 'letohl', 'letohll', 'letohll', 'letohl', 'ntohll', 'ntohl', 'byte', 'ntohl', 'ntohs', 'lv', 'letohll']), 'unsilentiousskimpy': ([], ['letohll', 'ntohs', 'ntohl', 'byte']), 'undiametricsinningness': ([], ['ntohl', 'string', 'lv', 'ntohll', 'double', 'float', 'byte', 'letohll']), 'iridemiabisque': ([], ['float', 'ntohl', 'letohs', 'letohl', 'ntohs', 'byte', 'ntohll', 'ntohs']), 'warfaringdraghound': ([], ['lv', 'ntohl', 'lv', 'ntohl', 'ntohll', 'ntohs', 'byte', 'double', 'ntohll', 'float', 'string', 'double', 'letohs', 'byte', 'string', 'letohs']), 'elephantryleptocephalan': ([], ['float', 'double', 'letohll', 'ntohll', 'float', 'lv', 'letohs', 'lv', 'ntohs', 'float', 'float', 'byte', 'ntohs', 'lv', 'letohl', 'byte', 'ntohl', 'letohll', 'ntohl', 'lv', 'ntohl', 'ntohll', 'letohl', 'ntohs', 'letohl', 'byte', 'ntohll', 'ntohll', 'letohll', 'byte', 'ntohs', 'ntohll', 'ntohl', 'float', 'letohl', 'byte']), 'amlipyrexic': ([], ['ntohs', 'double', 'string', 'letohl', 'letohs', 'letohl', 'lv', 'ntohll', 'byte', 'letohll', 'ntohll', 'byte', 'letohl', 'ntohll', 'ntohs', 'letohll', 'letohs', 'letohl', 'letohs', 'letohl', 'double', 'ntohs', 'ntohl', 'ntohs', 'ntohs', 'ntohl', 'letohll', 'letohl', 'ntohll', 'letohl', 'ntohs', 'float']), 'sheephookflushboard': ([], ['letohll', 'letohs', 'letohl', 'double']), 'TelopeaCyclotosaurus': ([], ['letohl', 'double', 'letohs', 'ntohl', 'letohl', 'letohl', 'letohs', 'letohl', 'letohl', 'byte', 'string', 'letohs', 'letohl', 'letohl', 'byte', 'string', 'letohl']), 'xenopodidtrencherless': ([], ['float', 'ntohl', 'ntohll', 'float', 'letohs', 'letohs', 'ntohl', 'letohl', 'double', 'byte', 'letohs', 'letohs', 'letohs', 'ntohll', 'letohl', 'double', 'ntohs', 'letohs', 'float', 'letohl']), 'grapedmassively': (['Lespedezafuthorc', 'bullswooldraggletail', 'overhollowescort', 'mattapharyngological', 'Oliveanpyromancer', 'subordinationbrachial', 'sokarailer', 'unhittabledoublehorned', 'unfannedhopperman', 'saltlypropugnator', 'springlikemonosymmetrically', 'chaffererunheaded', 'intrathoraciccoemployment', 'strangulableargentamid', 'stakeholderunforbade', 'dermobranchiataboyardom'], ['letohs', 'double', 'ntohs', 'string', 'ntohl', 'ntohll']), 'eurycephalicunhazardousness': ([], ['lv', 'byte', 'ntohl', 'ntohs', 'ntohll', 'ntohll', 'ntohll', 'double', 'string', 'letohs', 'ntohll', 'float', 'ntohs', 'ntohll']), 'corkeralbanite': ([], ['ntohs', 'string', 'ntohll', 'ntohll', 'letohs', 'letohll', 'ntohll', 'letohll', 'ntohs', 'float', 'ntohll', 'ntohll', 'double', 'letohll', 'letohll', 'ntohs', 'byte', 'ntohl', 'string', 'ntohll', 'letohl', 'float', 'letohll', 'double', 'byte', 'double', 'double', 'letohs', 'lv', 'letohl', 'double', 'float', 'string', 'letohll', 'ntohl']), 'MesothelaeCarisa': ([], ['float', 'double', 'string', 'letohl']), 'scruplercellulifugal': ([], ['float', 'letohll', 'string', 'letohl', 'string', 'lv', 'string', 'float', 'string', 'letohll', 'float', 'letohll', 'ntohl', 'lv', 'lv', 'ntohs', 'float', 'ntohll', 'ntohs', 'byte', 'ntohl', 'ntohs', 'ntohs', 'ntohs', 'double', 'letohll', 'letohl']), 'pyrroylprobity': ([], ['byte', 'letohl', 'double', 'ntohl', 'letohs', 'ntohl', 'ntohll', 'float', 'ntohs', 'ntohs', 'lv', 'letohs', 'ntohll', 'letohll', 'lv', 'byte', 'byte', 'ntohl', 'ntohll', 'letohs', 'ntohl']), 'saltlypropugnator': ([], ['byte', 'letohll', 'double', 'lv', 'byte', 'string', 'letohl', 'string', 'letohl', 'double', 'lv', 'letohs', 'letohl', 'ntohll', 'letohll', 'double', 'ntohs', 'ntohs', 'string', 'letohs', 'byte', 'letohll', 'float', 'ntohll']), 'petalocerouscamus': ([], ['letohs', 'double', 'lv', 'ntohl', 'letohll', 'byte', 'float', 'ntohl', 'letohl', 'ntohl', 'letohl', 'double', 'letohl', 'ntohs', 'string', 'float', 'lv', 'letohs', 'letohs', 'string', 'lv', 'float', 'ntohll', 'lv', 'letohl', 'string', 'letohl', 'letohll', 'letohl', 'ntohll']), 'tellurethurryproof': ([], ['double', 'byte', 'letohl', 'ntohs', 'float', 'float', 'lv', 'lv', 'ntohll', 'float', 'ntohll']), 'untuckedsolenoglyphic': ([], ['string', 'lv', 'double', 'string', 'letohll', 'letohs', 'ntohll', 'letohll', 'lv', 'lv', 'float', 'byte', 'double', 'ntohs', 'letohl', 'ntohl', 'letohs', 'letohl', 'letohs', 'letohll', 'lv', 'string', 'double', 'string', 'byte', 'letohl', 'ntohs', 'float', 'letohs', 'double', 'byte', 'ntohll']), 'unoverhauledGalinsoga': ([], ['ntohs', 'ntohl', 'letohll', 'ntohl', 'ntohll', 'lv', 'ntohs', 'letohl', 'string', 'letohs', 'ntohll', 'letohs', 'string', 'ntohs', 'letohs', 'letohl', 'lv', 'string', 'ntohll', 'letohll', 'string', 'string', 'ntohll', 'float', 'byte', 'ntohll', 'ntohl', 'letohll', 'letohll', 'float', 'letohll', 'letohll', 'ntohs', 'letohl', 'string', 'double', 'ntohll', 'byte', 'ntohll', 'ntohl']), 'SpatangusChayma': (['Larinaecoydog', 'counterspyingdungeon', 'untrainhearkener', 'recapitalizationdissipative', 'channelizeungarter', 'subcineritiousphrenitic', 'querulouslycooky', 'loungyimpolite', 'submountainhopper', 'unmooredtowy', 'antleredadunc', 'carangoidbotryomycotic', 'OrleansSchedius', 'yoreexponent', 'piskgriff', 'hetericismswayable', 'ofttimessnatchingly', 'predisciplinetukra', 'peccationfoolery', 'cosilybridecake', 'overhollowescort', 'bawcockPicnickian', 'cystocarppapaprelatical', 'pantomnesiadiporpa', 'simulcastriboflavin', 'lungflowerhorrormonger', 'oxmanoutpull', 'autovivisectionoverleather', 'coeternaloverhonor', 'mischieveunfomented', 'pistoleerproexamination', 'arsheenperspiration', 'unfeasiblecollodiotype', 'SpatangusChayma', 'distilleryKiwanis', 'refilmopenhandedness', 'pedestrianateStromateidae', 'cicisbeismGonystylus', 'asepticallyBernese', 'unfannedhopperman', 'apioidalNagari', 'unscalednessChamaeleon', 'remisrepresentationlancet', 'stickleafethenyl', 'unaccuracyblepharoadenitis', 'sokarailer', 'unlasheddialyzable', 'pegologyscavenage'], ['letohll', 'nextproto_s', 'nextproto_s', 'letohs', 'nextproto_b', 'byte', 'ntohl', 'byte', 'double', 'string', 'letohll', 'nextproto_b', 'ntohll', 'double', 'ntohs', 'string', 'nextproto_b', 'double', 'byte', 'lv', 'letohl', 'string', 'nextproto_b', 'nextproto_s', 'float', 'byte', 'ntohl', 'letohs', 'ntohl', 'letohs', 'nextproto_s', 'ntohll', 'ntohs', 'string', 'string']), 'autoplastycava': ([], ['letohl', 'letohs', 'byte', 'letohll', 'ntohll', 'string', 'string', 'ntohs', 'ntohl', 'letohll', 'ntohll', 'letohl', 'double', 'ntohll', 'lv', 'ntohll', 'ntohs', 'letohll', 'letohll', 'ntohs', 'ntohll', 'letohl', 'letohs']), 'Anglomaniaclovableness': (['uncatholicizeSiphonognathus', 'ciderishazury', 'cicisbeismGonystylus', 'refallGanguela', 'counterpotentMetabola', 'triquetricinfrasternal', 'Piscataqualagoonal', 'wolfberrydeclaredness', 'mammillationpemphigous', 'agonizefloating', 'slichtarradiddler', 'sleekgavelock', 'ofttimessnatchingly', 'exponencecrubeen', 'tautologicpanimmunity', 'intwistpunter', 'carangoidbotryomycotic', 'unfootsorepoonac', 'veldcraftsubprefect', 'contrarietyinconceivableness', 'Ibaditehypotenuse', 'unpaintterebinic', 'tenesmicHymettic', 'metatitanatetarente', 'nowhitoffscape', 'meddlingsmall', 'catagmaticMegalosaurus', 'subrigidlithophysal', 'hallowerhydrophthalmos', 'mausoleandecasualize', 'adminiculatephosphosilicate', 'appendiceunmetaled', 'northwestwardpassementerie', 'untrainhearkener', 'Saxonicalpalet', 'rewhirlhypermotility', 'outfeatvasodilator', 'hyperduliaferrateen', 'superestablishmentsuccor', 'tuboovariandeducibleness', 'algorithmicSericana', 'hemianacusiadouble', 'polishedlyhematosis', 'carannaaccension', 'dyewoodsocii', 'petalocerouscamus', 'Fichteanismconjobble', 'trentepohliaceousHectorean', 'symmetricalantimasker', 'prehexameraldissyllabize', 'photoheliographoctuplicate', 'lamellicornousPolygonaceae', 'monodromiclyretail', 'buttTarahumara', 'wingerconsoler', 'falsificationcomer', 'arhatsporozoic', 'herpetologistindeed', 'blossomscrimshander', 'imperializetrispaston', 'Momotinaenonfortification', 'allegoristerserendite', 'congregationalvocimotor', 'Marcosianpictographically', 'cinecameraHydropotes', 'gatewiseunderpot', 'sulphhemoglobinHerculanean', 'interventraliaforeutter', 'clientageshudderingly', 'grapedmassively', 'sideflashmagniloquent', 'adiaphorousfalsifiable', 'domanialPhora', 'disjointedlytriamylose', 'knuckleboneunnegotiableness', 'addressorcondensedly', 'paleobotanyworkpeople', 'predefinitionCarnaria', 'cardinghygeistic', 'craunchprovitamin', 'Vandiemenianwinery', 'oversoldafield', 'unspendablevanilla', 'unbeggarbroncholithiasis', 'untuckedsolenoglyphic', 'Triuridalesplagiarism', 'grammaticismmignonette', 'reburstsummity', 'loketprincipiate', 'correctorSpirochaeta', 'prosubscriptiontribracteate', 'cannotdentigerous', 'Steganophthalmiagnomic'], ['nextproto_b', 'ntohs', 'double', 'letohs', 'nextproto_s', 'letohll', 'ntohl', 'ntohl', 'ntohl', 'double', 'letohl', 'letohs', 'nextproto_s', 'ntohs', 'ntohll', 'lv', 'nextproto_s', 'ntohll', 'ntohl', 'ntohl', 'letohl', 'ntohll', 'letohll', 'float', 'double', 'nextproto_s']), 'logarithmeticallydeliriant': ([], ['ntohl', 'ntohs', 'letohl', 'double', 'string', 'byte', 'float', 'letohl', 'ntohll', 'lv', 'byte', 'letohs', 'ntohs', 'ntohs', 'letohl', 'letohll', 'lv', 'ntohl', 'float', 'ntohll', 'double', 'letohl', 'ntohs', 'ntohs']), 'iconismanisostemonous': ([], ['ntohll', 'letohs', 'double', 'float', 'float', 'double', 'ntohl', 'double', 'letohl', 'float', 'lv', 'letohs', 'letohl', 'ntohll', 'lv', 'float', 'double', 'ntohl', 'ntohl']), 'steevingerotic': ([], ['string', 'letohll', 'byte', 'lv', 'string', 'lv', 'byte', 'ntohl', 'double', 'double', 'ntohll', 'ntohll', 'float', 'byte']), 'kleenebocJungermannia': ([], ['float', 'letohll', 'ntohs', 'ntohs', 'ntohl', 'string', 'lv', 'float', 'letohl', 'ntohs', 'float', 'ntohs', 'byte', 'ntohs', 'letohs', 'lv', 'ntohll']), 'qualmyishHolocene': (['tumoredcrocodilite', 'premortuarybenchy', 'carangoidbotryomycotic', 'iconismanisostemonous', 'catmalisoncoevally', 'epexegeticallyreadjournment', 'napalmbrevifoliate', 'roofprespur', 'misputheptarchist', 'outworthbenevolence', 'laterodeviationNarciss', 'Slovenerecure', 'photocompositioneneuch', 'pilchermonaulos', 'Plymouthistnashgab', 'refilmopenhandedness', 'cosilybridecake', 'katabolizedermic', 'unhittabledoublehorned', 'scleroblastemicpalaeocosmology', 'spraysemisaprophyte', 'terribletaut', 'sulphhemoglobinHerculanean', 'misspellquinaldic', 'manageriallyflanger', 'pantomnesiadiporpa', 'peccationfoolery', 'misproduceunthrilled', 'fleaweedprobate', 'unenterprisedargumentatious', 'racegoingunperformed', 'mediumismgypsyism', 'phototherapistupsetted', 'zeuctocoelomicmetapodial', 'percontationMaimonist', 'counterpotentMetabola', 'monodromiclyretail', 'vibrativeoversail', 'isuroidunfitly', 'unoverhauledGalinsoga', 'exponencecrubeen', 'Steganophthalmiagnomic', 'cardinghygeistic', 'Cobitidaedismissal', 'overhollowescort', 'terrazzododder', 'erythriticsynergidal', 'mischieveunfomented', 'docimasytrouserdom', 'noggencapitulate', 'keraunophoneinhabited', 'tautoousianentente', 'asperationoraculousness', 'meddlingsmall'], ['float', 'lv', 'ntohl', 'ntohl', 'float', 'ntohs', 'letohs', 'byte', 'ntohs', 'letohl', 'byte', 'lv', 'letohll', 'letohl', 'nextproto_b', 'lv', 'letohs', 'ntohl', 'nextproto_s', 'float', 'byte', 'nextproto_b', 'letohs', 'byte', 'string', 'letohll', 'nextproto_s', 'byte', 'string', 'ntohll', 'ntohs', 'ntohs', 'float', 'ntohl', 'double', 'ntohl', 'lv', 'byte', 'byte', 'letohll', 'nextproto_s', 'letohl', 'double', 'float', 'ntohl', 'double', 'double']), 'microcaltropmyosarcomatous': (['surlyreptilferous', 'stomagringo', 'overhollowescort', 'epistlarcystoid', 'ExobasidialesEppy', 'unpaintterebinic', 'ochronosusafterbody', 'catmalisoncoevally', 'bullswooldraggletail', 'Negritohydroponicist', 'intwistpunter', 'assecurationAshkenazim', 'Ternstroemiaanisostomous', 'maltingsurrection', 'tellurethurryproof', 'phenegollocalization', 'agoraphobiaLenzites', 'unhyphenedallose', 'Philonismpinivorous', 'Opisthocomidaeheterochiral', 'barrelmakingparoemia', 'carpolitemortifier', 'phallaceousunrebel', 'phototherapistupsetted', 'unodoriferousWhiggish', 'crouchingpurebred', 'onomatopoeiaeggfish', 'manageriallyflanger', 'rewhirlhypermotility', 'perukiershiplexicographer', 'unmooredtowy', 'steelworkpsychophysiological', 'isatogenvestibulum', 'undiametricsinningness', 'intrathoraciccoemployment', 'frolickytriphyline', 'dehydrogenizeCambrian', 'lamellicornousPolygonaceae', 'visorlikeNagari', 'adiaphorousfalsifiable', 'lepidodendridcounterplead', 'lobectomypreinflection', 'dracontiasisinterparliamentary', 'semisomnolencegunj', 'bumblefooticonology', 'organosiliconsegmentary', 'popeyednaphtha', 'strangulableargentamid', 'contrarietyinconceivableness', 'androgynyvegetoalkaline', 'dissuasivenessnondeforestation', 'utterabilitypavement', 'subcostalbaldmoney', 'palatableJonesian', 'prerailwaycannibalistically', 'thysanuriformcrossrail', 'buttonholerindigestive', 'foliicolousskeletonweed', 'exportnontarnishable', 'anomalousparallelinerved', 'cycloolefinmonostylous', 'hyperneuriasymbolatry'], ['float', 'float', 'lv']), 'ruinlikesilva': ([], ['string', 'ntohll', 'letohs', 'letohs', 'letohs', 'ntohll', 'ntohs', 'ntohs', 'letohll', 'ntohll']), 'parathyroidectomizeoutheart': (['warneriodocasein', 'cesserreichspfennig', 'counterpotentMetabola', 'pellagrosemongrelization', 'etioporphyrinpubovesical', 'ineloquentundishonored', 'katabolizedermic', 'focoidsstackfreed', 'springlikemonosymmetrically'], ['letohll', 'lv', 'double', 'float', 'byte', 'letohs', 'ntohl', 'byte', 'nextproto_b', 'ntohs', 'nextproto_s', 'double', 'byte', 'ntohll', 'ntohll', 'lv', 'letohl', 'float', 'nextproto_s', 'lv', 'nextproto_s', 'ntohl', 'nextproto_s', 'byte', 'letohll', 'double', 'lv', 'ntohl', 'letohs', 'string', 'lv', 'float', 'ntohs', 'lv', 'letohll', 'letohs', 'ntohll', 'letohll', 'nextproto_s', 'string', 'byte', 'nextproto_s']), 'tuboovariandeducibleness': ([], ['ntohl', 'byte', 'string', 'ntohs', 'string', 'letohll', 'double', 'ntohl', 'letohll', 'lv']), 'degerminatorblo': ([], ['string', 'string']), 'gumdiggingsalvarsan': ([], ['string', 'ntohll', 'string', 'letohl', 'letohs', 'double', 'letohll', 'letohll', 'lv', 'string', 'lv', 'ntohll', 'double', 'string', 'string', 'ntohl', 'letohl', 'byte', 'letohl', 'ntohs', 'ntohll', 'byte', 'lv', 'letohll', 'letohs']), 'asperationoraculousness': ([], ['float', 'ntohll', 'string', 'float', 'double', 'ntohs', 'double', 'ntohll', 'letohll', 'ntohl', 'string', 'lv', 'ntohll', 'byte', 'letohs', 'ntohs', 'ntohl', 'lv', 'letohs', 'letohll', 'string', 'string', 'double', 'ntohll', 'float', 'ntohs', 'byte', 'byte', 'ntohl', 'ntohll', 'ntohll', 'letohl', 'letohs', 'letohl', 'letohl', 'ntohll', 'lv', 'letohs']), 'fleaweedprobate': ([], ['string', 'byte', 'string', 'nextproto_s', 'nextproto_b', 'byte', 'lv', 'ntohll', 'letohl', 'float', 'ntohl', 'nextproto_s', 'letohll', 'string', 'float', 'float', 'ntohs', 'ntohll', 'byte', 'lv', 'float', 'letohs', 'byte', 'ntohl', 'nextproto_b', 'letohll', 'ntohl', 'double', 'lv', 'string']), 'Brandipriestcraft': (['vaporizetannery', 'retroclusionmetaphysicianism', 'carannaaccension', 'Piscataqualagoonal', 'Bryumextrafocal', 'dissogenyBarney', 'rosiedunarchdeacon', 'picayunishapogeotropic', 'idioglossiascabble', 'catmalisoncoevally', 'scutcheonwiseileocolitis', 'evaluecystatrophia', 'isuroidunfitly', 'unoverhauledGalinsoga', 'addressorcondensedly', 'cylindrarthrosisnonplusation', 'Stromatoporoideabarry', 'peritrichouslyhepatoflavin', 'springlikemonosymmetrically', 'zoosporangialbuyable', 'predisciplinetukra', 'bemuzzlesurficial', 'Erotylidaeprehesitate', 'changeablyzoophilitic', 'faddyamputational', 'Philoctetessupersalesman', 'Philonismpinivorous', 'interimperialvignetter', 'Eomecondiscolorate', 'etioporphyrinpubovesical', 'Sarothrawrencher', 'epistlarcystoid', 'OrleansSchedius', 'sokarailer'], ['letohs', 'ntohll', 'string', 'letohl', 'string', 'byte', 'float', 'double', 'float', 'double', 'lv', 'letohl', 'float', 'byte', 'float', 'nextproto_b', 'letohl', 'float', 'double', 'letohl', 'letohs', 'double', 'double', 'nextproto_b', 'lv', 'letohll', 'string', 'double', 'letohl', 'letohs', 'letohs', 'byte', 'double', 'lv', 'byte', 'double', 'nextproto_s', 'double']), 'delthyrialGee': ([], ['ntohll', 'ntohs', 'letohll', 'string', 'string', 'lv', 'letohl', 'ntohl', 'ntohs', 'letohs', 'lv', 'float', 'letohl', 'double', 'letohs', 'ntohll', 'float', 'letohl', 'byte', 'letohl', 'float', 'ntohs', 'float', 'letohs', 'letohl', 'string', 'float', 'letohl', 'letohll']), 'microcosmographyunratified': ([], ['letohll', 'string', 'letohll', 'letohll', 'string', 'ntohll', 'double', 'letohll']), 'Humeaerohydroplane': ([], ['letohs', 'letohl', 'byte', 'letohs', 'double', 'letohl', 'letohll', 'letohs', 'double', 'ntohll', 'ntohl', 'letohll', 'letohs', 'float', 'ntohs', 'ntohs', 'ntohs', 'letohs', 'string', 'ntohll', 'lv', 'byte', 'ntohs', 'letohll', 'byte', 'letohl', 'ntohl', 'letohl', 'letohs', 'float', 'lv', 'double', 'ntohl', 'float', 'ntohl', 'byte', 'lv', 'double', 'lv', 'letohs', 'lv', 'letohs', 'letohll']), 'proteosomalsuppletion': ([], ['string', 'letohs', 'string', 'ntohl', 'letohll', 'lv', 'letohl', 'letohll', 'double', 'letohs', 'letohl', 'float', 'float', 'byte', 'letohs', 'double', 'letohll', 'letohl', 'ntohl', 'ntohs', 'letohs', 'string', 'double', 'ntohs', 'string', 'ntohs', 'string', 'byte', 'double', 'ntohll', 'letohl']), 'engrossedlyDinoceras': (['pistoleerproexamination', 'cacuminalgastrohysterorrhaphy', 'pilchermonaulos', 'scutcheonwiseileocolitis', 'ornithotomyblackwort', 'outfeatvasodilator', 'vaporizetannery', 'vibrativeoversail', 'tenodesisunroaming', 'epistlarcystoid', 'focoidsstackfreed', 'preinjuryduplicature', 'genipacombiner', 'cardialgiacontingence', 'evaluecystatrophia', 'engrossedlyDinoceras', 'parathyroidectomizeoutheart', 'dehydrogenizeCambrian', 'doubleheartedstaphylolysin', 'epigenesistbisexed', 'amlipyrexic', 'paralyzerthiocarbimide', 'ureterorrhagiahemogenetic', 'untuckedsolenoglyphic', 'lepidodendridcounterplead', 'fetoracclimatement', 'byworkplastid', 'chaffererunheaded', 'steelworkpsychophysiological', 'Bryumextrafocal', 'dissogenyBarney', 'fleaweedprobate', 'cylindrarthrosisnonplusation', 'spadelikemassacrer', 'peccationfoolery', 'etioporphyrinpubovesical', 'peritrichouslyhepatoflavin', 'slichtarradiddler', 'Erotylidaeprehesitate', 'ochronosusafterbody', 'piskgriff', 'nonadjustmentwritmaking', 'hyperneuriasymbolatry', 'countryfolkintolerance', 'iconismanisostemonous', 'veldcraftsubprefect', 'picayunishapogeotropic', 'outworthbenevolence', 'crossboltedasexually', 'grapedmassively', 'frolickytriphyline', 'schuleclethraceous', 'changeablyzoophilitic', 'hemianacusiadouble', 'saltlypropugnator', 'Wagnerianaaviculturist', 'susurrateoutvie', 'spinthariscopemolybdena', 'misadministrationbroody', 'napalmbrevifoliate', 'Vandiemenianwinery', 'surlyreptilferous', 'strangulableargentamid', 'renverseundethroned', 'prattlersuffumigate', 'katabolizedermic', 'tenesmicHymettic', 'bawcockPicnickian', 'Voltaprotarsal', 'collationdissuasively', 'ambisyllabicfruitful', 'stickleafethenyl', 'importationPerisphinctidae', 'carannaaccension', 'Grahamsaloon', 'springlikemonosymmetrically', 'subregenthelmeted', 'microcrystallogenyfuniculus', 'mataiuntameness', 'bumblefooticonology', 'pedestrianateStromateidae', 'gatewiseunderpot', 'Sumasslevulosuria', 'foliicolousskeletonweed', 'monodromiclyretail'], ['string', 'lv', 'byte', 'letohll', 'byte', 'ntohl', 'ntohl', 'ntohs', 'nextproto_b', 'letohl', 'lv', 'letohll', 'nextproto_b', 'ntohs', 'letohs', 'string', 'ntohll', 'letohl', 'letohs', 'ntohl', 'byte', 'double', 'nextproto_b', 'double', 'ntohl', 'letohs', 'letohl', 'string', 'byte', 'ntohl', 'float', 'ntohs', 'letohs', 'string', 'letohll', 'lv', 'ntohl', 'ntohl', 'letohll', 'double', 'nextproto_b', 'byte', 'lv', 'nextproto_s']), 'predesignateunderservice': (['unbeggarbroncholithiasis', 'semicolumnrankly', 'pneumodynamicsprimariness', 'Bryumextrafocal', 'pilchermonaulos', 'predesignateunderservice', 'mattapharyngological', 'loungyimpolite', 'tautoousianentente', 'Orakzaiunsatisfiedly', 'outworthbenevolence', 'evaluecystatrophia', 'subordinationbrachial', 'xenopodidtrencherless', 'peccationfoolery', 'amlipyrexic', 'hyperneuriasymbolatry', 'katabolizedermic', 'symmetricalantimasker', 'asperationoraculousness', 'focoidsstackfreed', 'unmistgraffer'], ['string', 'letohl', 'letohl', 'ntohs', 'double', 'ntohll', 'float', 'nextproto_s', 'double', 'letohs', 'float', 'ntohs', 'float', 'float', 'byte', 'double', 'byte', 'lv', 'nextproto_s']), 'unhealablenessknoppy': (['projicientcolumellate', 'Limodorumscrotal', 'cerebroidodontolcate', 'typhemiacubit', 'skeesicksunsteamed', 'Philoctetessupersalesman', 'overgenialitybuzzle', 'preroyaltycoagulin'], ['letohll', 'ntohl']), 'scutcheonwiseileocolitis': ([], ['ntohll', 'ntohll', 'byte']), 'fetoracclimatement': (['saltlypropugnator', 'superabsurdditremid', 'fetoracclimatement', 'overpoliticunderlooker', 'esophagoplastyrestrainedness', 'Steganophthalmiagnomic', 'untastedgirllike', 'Stromatoporoideabarry', 'vaporizetannery', 'multicrystallinekeratoglossus', 'spinthariscopemolybdena'], ['letohl', 'lv', 'float', 'string', 'letohl', 'string', 'string', 'lv', 'letohs', 'byte', 'letohll', 'ntohl', 'letohl', 'ntohs', 'lv', 'nextproto_s', 'letohll', 'ntohl', 'double', 'ntohll', 'nextproto_s', 'float', 'byte', 'byte', 'letohs']), 'Lithosiinaecoequation': (['plurifacialmicrographical', 'cineplastyanonang', 'coinbellmaker', 'psychrographismdom'], ['nextproto_b', 'letohll', 'letohl', 'lv', 'ntohs', 'letohl', 'float', 'string', 'ntohll', 'letohl', 'string', 'nextproto_b', 'ntohs', 'letohll', 'ntohs', 'byte', 'double', 'float', 'ntohl', 'nextproto_b', 'lv', 'string', 'nextproto_b', 'nextproto_s', 'nextproto_b', 'letohl', 'ntohll', 'letohs', 'nextproto_b', 'float', 'byte', 'lv', 'lv', 'ntohl', 'float', 'letohl', 'ntohs']), 'endopathicnonmarrying': ([], ['ntohll', 'letohll', 'lv', 'float', 'ntohs', 'lv', 'ntohll', 'letohl', 'ntohll', 'ntohl', 'ntohl', 'float', 'byte', 'letohl']), 'oboltask': ([], ['lv', 'float', 'ntohs', 'byte', 'letohl', 'lv', 'double', 'float', 'letohl', 'letohll', 'ntohl', 'ntohl', 'string', 'ntohs', 'double', 'letohll', 'letohll', 'ntohl', 'string', 'letohl', 'letohs', 'ntohs', 'double']), 'haversinepitaya': (['radomenetherwards', 'unhealablenessknoppy', 'wutproamusement', 'semisomnolencegunj', 'feveretunderbox', 'overdiligentlyrifleshot', 'prankinglypneumotherapy', 'raspberrylikesubvertebral', 'Carpathianmetanephron', 'buttonholerindigestive', 'exponencecrubeen', 'abjudicationunpleading', 'igelstromiteMoraceae', 'unfeasiblecollodiotype', 'dowsettroughway', 'ivoryliketransessentiate', 'leadstonehypovitaminosis', 'tuboovariandeducibleness', 'unaccuracyblepharoadenitis', 'paleobotanyworkpeople', 'perukiershiplexicographer', 'collationdissuasively', 'cannotdentigerous', 'whillyunbet', 'vasoconstrictorsupracretaceous', 'subsorterbecuffed', 'cleansingpentahedral', 'elementalismpietism', 'hancesmoothness', 'esophagoplastyrestrainedness', 'mediumismgypsyism', 'Trinorantumpyramides', 'alphabetizermonoclinal', 'counterdraftdamewort', 'dracontiasisinterparliamentary', 'secrecyheteroecy', 'ourselfmetaplast', 'haversinepitaya', 'nonhumanistunsoaked', 'tantarabobusaurify', 'hypoplasyhooping', 'noniccosmopoietic', 'spraysemisaprophyte', 'loketprincipiate', 'Quitugryde', 'toyingere', 'wingerconsoler', 'brackishrehazard', 'androgynyvegetoalkaline', 'terribletaut', 'unadversenessmaro', 'ramraceBorderies', 'mattapharyngological', 'pinkberrynonvillainous', 'Bitulithicscrin', 'subregenthelmeted', 'endogalvanismunwarrantedly', 'prelanguagecloudage', 'oysterhouseamarillo', 'dextrosinistralElaeococca', 'preinjuryduplicature', 'Castoroidespentacrinite', 'overganggenesial'], ['letohs', 'letohll', 'float', 'string', 'ntohs', 'letohll', 'nextproto_s', 'ntohs', 'letohll', 'ntohll', 'ntohl', 'string', 'ntohl', 'nextproto_b', 'ntohs', 'string', 'letohl', 'nextproto_s', 'nextproto_s', 'float', 'float', 'letohll', 'double', 'ntohl', 'ntohl', 'string', 'lv', 'letohl', 'lv', 'byte', 'nextproto_s', 'nextproto_s', 'ntohl']), 'vitriolizemonal': ([], ['ntohl', 'ntohs', 'ntohl', 'double', 'byte', 'ntohl', 'lv', 'ntohll', 'ntohl', 'string', 'ntohs', 'letohl', 'double', 'letohll', 'double', 'ntohl', 'letohs', 'lv', 'float', 'byte', 'letohl', 'float', 'ntohl', 'lv', 'string', 'lv', 'lv', 'float', 'letohll', 'letohl', 'float', 'lv', 'letohl', 'float', 'ntohs', 'ntohl', 'string']), 'laterodeviationNarciss': ([], ['double', 'float', 'letohll', 'ntohs', 'float', 'double', 'byte', 'letohll', 'ntohll', 'float', 'ntohl', 'ntohl', 'ntohll', 'letohl', 'double', 'letohll', 'string', 'ntohl', 'letohl', 'ntohs', 'ntohll', 'ntohs', 'string', 'float', 'ntohs', 'letohl', 'letohl', 'letohs', 'letohs', 'letohl', 'ntohll', 'ntohl', 'byte', 'byte', 'byte', 'letohl', 'lv', 'string', 'float']), 'depositoryteloblastic': ([], ['double', 'float', 'letohl', 'byte', 'ntohl', 'ntohl', 'byte', 'letohll', 'letohs', 'ntohll', 'string', 'letohll', 'ntohl', 'float', 'ntohl', 'string', 'string', 'letohs']), 'ivoryliketransessentiate': ([], ['letohl', 'letohs', 'letohl', 'double', 'lv', 'letohll', 'byte', 'string', 'letohll']), 'externalisticguaranteeship': ([], ['ntohll', 'letohs', 'ntohl', 'float', 'float', 'byte', 'ntohl', 'float', 'letohs', 'double', 'letohs', 'ntohll', 'ntohl', 'ntohs', 'lv', 'letohs', 'double', 'string', 'ntohll', 'ntohl', 'letohll', 'ntohl', 'letohll', 'ntohll']), 'tripartedlyOssetine': ([], ['letohll', 'lv', 'letohll', 'ntohs', 'string', 'string', 'double', 'float', 'float', 'ntohll', 'letohl', 'ntohs', 'lv', 'letohs', 'float', 'double', 'string', 'string', 'byte', 'byte', 'letohl', 'ntohs', 'lv']), 'outlawrypervertedness': (['stickleafethenyl', 'organoantimonypreoperator', 'hippocampalscrow', 'untastedgirllike', 'responsivitykimigayo', 'entomicperjuriousness', 'Philoctetessupersalesman', 'nowhitoffscape', 'overseateddiscouragingly', 'counterspyingdungeon', 'Nathanielbiliteral', 'predesignateunderservice', 'weathercockismcustodier', 'pensefulnessdrought', 'overganggenesial', 'oversoldafield', 'usurperunplannedly', 'mataiuntameness', 'prehexameraldissyllabize', 'Piscataqualagoonal', 'undercovertcoloss', 'hammerkopnegativer', 'poonghiehectic', 'kansrush', 'unfannedhopperman', 'notchycoralliferous', 'ineloquentundishonored'], ['byte', 'nextproto_s', 'nextproto_b', 'byte', 'byte', 'ntohs', 'lv', 'ntohl', 'double', 'lv', 'lv', 'string', 'letohs', 'double', 'ntohs', 'letohll', 'double', 'string']), 'Margaropusscooter': ([], ['byte', 'byte', 'lv', 'letohll', 'ntohs', 'byte', 'ntohs', 'letohl']), 'biserialsmithite': ([], ['letohll', 'float', 'ntohl', 'float', 'letohl', 'ntohl', 'lv', 'ntohl', 'lv', 'string', 'string', 'string', 'letohs', 'float', 'double', 'float', 'letohl', 'ntohll', 'ntohs', 'float', 'float', 'double', 'letohs', 'letohs', 'byte', 'ntohs', 'lv', 'letohll', 'float', 'byte', 'float', 'lv', 'letohs', 'byte', 'ntohs', 'ntohll', 'letohs', 'ntohl', 'string', 'letohll', 'float', 'letohll']), 'Eurypteroideachamaeprosopic': ([], ['lv', 'lv', 'float', 'double', 'letohll', 'letohl', 'ntohl', 'ntohl', 'double', 'letohl', 'byte', 'double', 'double', 'byte', 'lv', 'letohll', 'ntohll', 'ntohs', 'float', 'string', 'string', 'float', 'double', 'ntohs', 'ntohl', 'letohl', 'byte', 'letohs', 'ntohll', 'ntohll', 'ntohs', 'ntohll', 'ntohll', 'letohll', 'double', 'lv', 'ntohl', 'float', 'ntohll']), 'furoidbasanite': ([], ['letohs', 'float', 'lv', 'double', 'byte', 'string', 'letohll', 'ntohs', 'letohll', 'ntohll', 'letohs', 'ntohl', 'letohs', 'letohs', 'lv', 'ntohs', 'lv', 'byte', 'ntohs', 'letohs', 'letohs']), 'Tyleritespecies': (['inquilinecopse', 'decimosextountractarian', 'plowtailinfectress'], ['nextproto_b', 'lv', 'letohll', 'nextproto_b', 'letohll', 'nextproto_b', 'string', 'letohl', 'lv', 'lv', 'letohs', 'letohll', 'letohl', 'letohl', 'nextproto_s', 'ntohl', 'float', 'byte', 'byte', 'byte', 'ntohl', 'lv', 'string', 'nextproto_b', 'ntohll', 'lv', 'float', 'letohs', 'double', 'byte', 'byte', 'letohll', 'double']), 'peritrichouslyhepatoflavin': ([], ['letohs', 'letohll', 'float', 'byte', 'byte', 'string', 'ntohl', 'letohll', 'byte', 'letohll', 'ntohll', 'ntohs', 'ntohl', 'string', 'ntohl', 'letohll', 'byte', 'letohll', 'byte', 'letohs']), 'Actiniomorphaquartzic': (['thysanuriformcrossrail', 'frolickytriphyline', 'idioglossiascabble', 'Momotinaenonfortification', 'fetoracclimatement', 'unstalledneutralism', 'calycoideousunpressed', 'wolfberrydeclaredness', 'etherifyCicadidae', 'outworthbenevolence', 'prankinglypneumotherapy', 'preformisticexemplifiable', 'reproachablepancreatogenic', 'dermobranchiataboyardom'], ['letohll', 'string', 'byte', 'float', 'byte', 'byte', 'letohl', 'float', 'letohl', 'ntohll', 'letohll', 'ntohll', 'byte', 'double', 'ntohll', 'letohll', 'byte', 'lv', 'byte', 'letohs', 'string', 'ntohl', 'ntohll', 'double']), 'beseemingnessprefulgent': ([], ['byte', 'lv']), 'saffianpackcloth': ([], ['ntohs', 'letohs', 'float', 'ntohl', 'double', 'ntohl', 'ntohl', 'ntohl', 'letohll', 'letohll', 'lv', 'string', 'letohll', 'ntohl', 'float', 'ntohs', 'ntohl', 'float', 'letohl', 'string', 'byte']), 'listeningBroussonetia': ([], ['string', 'letohl', 'byte', 'ntohl', 'letohll', 'letohll', 'string', 'string', 'double', 'letohll', 'string', 'letohll', 'letohl', 'letohll', 'letohl', 'ntohl', 'byte', 'letohll', 'double', 'letohl', 'float', 'ntohs', 'byte', 'lv', 'letohl', 'letohl', 'lv', 'letohll', 'letohs', 'letohl', 'double', 'float']), 'tumoredcrocodilite': ([], ['byte', 'ntohs', 'lv', 'ntohs', 'double', 'float']), 'intorsiondermatograph': (['emblazonarsenopyrite', 'metatitanatetarente', 'dominionistversableness', 'Tyleritespecies', 'sulphhemoglobinHerculanean', 'Larinaecoydog', 'miningFlavia', 'byworkplastid', 'ambisyllabicfruitful', 'GemitoresBourignian', 'listeningBroussonetia', 'vernileDasya', 'porencephalonpostplegic', 'semiduplexskirt', 'Piscataqualagoonal', 'predisciplinetukra', 'Physciawenny', 'subrigidlithophysal', 'uplookbootlegger', 'unoverhauledGalinsoga', 'craunchprovitamin', 'ExobasidialesEppy'], ['letohl', 'float', 'letohs', 'nextproto_b', 'double', 'double', 'nextproto_s', 'nextproto_s', 'float', 'ntohll', 'nextproto_b', 'byte', 'nextproto_b', 'float', 'lv', 'ntohll', 'ntohs', 'nextproto_b', 'letohs', 'double', 'ntohs', 'ntohll', 'letohl', 'letohll', 'letohl', 'letohl', 'ntohl', 'byte', 'byte', 'float', 'nextproto_b', 'ntohll', 'byte', 'ntohll', 'letohl']), 'dyewoodsocii': (['codeinesalience', 'tongueshoticonophilism', 'unrevenuedindecorousness', 'unexchangedsupraventricular', 'tautologicpanimmunity', 'Alalamenispermine', 'prizeexcrescence', 'iconismanisostemonous'], ['letohs', 'string', 'nextproto_b', 'letohs', 'ntohl', 'letohl', 'letohll', 'double', 'letohl', 'string', 'byte', 'double', 'float', 'letohs', 'letohl', 'ntohs', 'nextproto_s', 'ntohs', 'letohll', 'letohl', 'nextproto_s', 'double', 'double', 'string', 'ntohll', 'ntohll', 'ntohll', 'string']), 'hystericsupersuperior': ([], ['byte', 'double', 'byte', 'lv', 'letohll', 'letohs', 'string', 'ntohl', 'letohll', 'letohll', 'double']), 'limsypersistence': (['OrleansSchedius', 'lindengamy', 'interventraliaforeutter', 'wirrshillingless', 'cognaticalintransmissible', 'noniccosmopoietic', 'depositoryteloblastic', 'pedestrianateStromateidae', 'chinkingcytologic'], ['letohll', 'float', 'double', 'nextproto_b', 'nextproto_s', 'nextproto_b', 'letohll', 'ntohll', 'lv', 'nextproto_s', 'letohll', 'nextproto_b', 'double', 'letohll', 'lv', 'ntohl', 'ntohl', 'letohll', 'byte', 'letohs', 'ntohll', 'ntohs', 'double', 'double', 'nextproto_s', 'string', 'ntohll', 'string', 'ntohll', 'float']), 'Abrahamicinordinateness': ([], ['ntohl', 'letohll', 'letohll', 'lv', 'float', 'letohl', 'ntohll', 'lv', 'letohl', 'lv', 'letohs', 'lv', 'byte', 'float', 'double', 'ntohll', 'string']), 'orthotonicquab': ([], ['ntohl', 'letohl', 'ntohll', 'letohl', 'letohs', 'letohl', 'ntohl', 'lv', 'letohl', 'double', 'letohll', 'double', 'double', 'letohl', 'ntohl', 'double', 'letohll', 'ntohll', 'string', 'letohll', 'letohl', 'string', 'ntohl', 'ntohl', 'double', 'string', 'ntohl', 'string', 'ntohl', 'byte', 'byte', 'string', 'letohs', 'float', 'ntohl', 'byte', 'letohll', 'byte', 'ntohs']), 'xylopyrographyrich': (['tongueshoticonophilism', 'denieragedrapery', 'turbidlycorticoefferent', 'exempttanninlike', 'externalisticguaranteeship', 'unrevenuedindecorousness', 'scruplercellulifugal', 'undercovertcoloss', 'semideliriousmelituria', 'correctorSpirochaeta', 'attestatorcoronule', 'mataiuntameness', 'unfangedramline', 'saddirhamtaxometer', 'Bryumextrafocal', 'goniometerhexameral', 'extravagantkaryoplasmatic', 'lindengamy', 'intrathoraciccoemployment', 'percontationMaimonist', 'submountainhopper', 'syphilologyannularity', 'byworkplastid', 'dinitrilholocentrid', 'freakilyuphoard', 'elementalismpietism', 'awiwimegaloglossia', 'falsificationcomer', 'counterspyingdungeon', 'appendiceunmetaled', 'oversolicitouslyhour', 'overfretdisenthronement', 'tollgateandrophagous', 'dachshundpuddly', 'buttTarahumara', 'surrenalinconcluding', 'urningsubpubescent', 'peerlesslyforetalk', 'kleenebocJungermannia', 'androgynyvegetoalkaline', 'Trinorantumpyramides', 'raucousEstheriidae', 'hallowerhydrophthalmos', 'simpletonianreformulate', 'triplewisepostepileptic', 'Pileabayadere', 'stavelessindissolubleness', 'demibeastuninflicted', 'Bitulithicscrin', 'noniccosmopoietic', 'barkeeperCurtis', 'adminiculatephosphosilicate', 'cephaloconicunbaptized', 'balandracaducibranch', 'Theopaschiteeviction', 'fetoracclimatement', 'shuttlecockscanmag', 'ligniformcoolheadedness', 'hyperneuriasymbolatry', 'alphabetismpolyfenestral', 'warfaringdraghound', 'referumbrellawort', 'chartermarrowy', 'outfeatvasodilator', 'radiopaqueunrecruitable', 'thysanuriformcrossrail', 'enclothearmiferous', 'pyroaceticnunciature', 'rosiedunarchdeacon', 'seminegroSemiticize', 'unlasheddialyzable', 'galledisocinchomeronic', 'piskgriff', 'mercurializationsimulacre', 'fleaweedprobate', 'wutproamusement', 'whusslenoreast'], ['string', 'letohll', 'letohll', 'double', 'lv', 'letohs', 'letohll', 'ntohll', 'letohs', 'letohll', 'lv', 'ntohl', 'float', 'double', 'letohs', 'lv', 'ntohl', 'nextproto_s', 'byte', 'nextproto_b', 'letohs', 'letohl', 'nextproto_s', 'letohs', 'ntohll', 'double', 'ntohl', 'letohl', 'nextproto_b', 'ntohs', 'letohll', 'lv', 'lv', 'letohs', 'double', 'nextproto_s', 'ntohs', 'string', 'nextproto_b', 'byte', 'lv', 'double', 'nextproto_b']), 'chemokineticstatutorily': ([], ['letohl', 'string', 'letohs', 'ntohs', 'lv', 'float', 'ntohs', 'ntohl', 'lv', 'ntohl', 'byte', 'letohll', 'ntohll', 'ntohl', 'letohs', 'letohll', 'ntohs', 'lv', 'lv', 'ntohs', 'ntohll']), 'uxoriouslyelectrotechnic': (['Nathanielbiliteral', 'baptizeeFrenchize', 'rosariumpathetism', 'preservatizeskyphoi', 'scruplercellulifugal', 'scholasticlyInd', 'trichitepersonship', 'raspberrylikesubvertebral', 'noniccosmopoietic', 'reshoedrachmae', 'blossomscrimshander', 'polishedlyhematosis', 'thysanuriformcrossrail', 'buttonholerindigestive', 'stavelessindissolubleness', 'epitrophygoatlike', 'addressorcondensedly', 'sacroposteriorveratryl', 'goodlyterebenthene', 'leucoencephalitisconsistent', 'overganggenesial', 'cosilybridecake', 'collationdissuasively', 'engrossedlyDinoceras', 'munjmuchness', 'pentaptychBantingism', 'butyrochloralfertilizational', 'prochordalnaveled', 'dachshundpuddly', 'theohumanhooper', 'wirrshillingless', 'ivoryliketransessentiate', 'Actiniomorphaquartzic', 'galledisocinchomeronic', 'nontechnicalrongeur', 'sageshipcarcoon', 'spattertriphenylated', 'pegologyscavenage', 'pyroaceticnunciature', 'flashpanstature', 'Chilopsiscompactible', 'motacillinewidespreadly', 'asepticallyBernese', 'Hetaeristaltimetrical', 'reproachablepancreatogenic', 'unhealablenessknoppy', 'untrainhearkener', 'antiphonybackplate', 'tantarabobusaurify', 'sharkletcompactedly', 'hypogenicquietus'], ['float', 'string', 'float', 'nextproto_b', 'float', 'double', 'nextproto_b', 'double', 'float', 'lv', 'ntohs', 'letohl', 'string', 'string', 'byte', 'lv', 'nextproto_s', 'double', 'letohll', 'double', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'letohll', 'float', 'byte', 'lv', 'ntohs', 'byte', 'string', 'ntohll', 'letohs', 'nextproto_s', 'double', 'ntohs', 'letohl', 'float', 'float', 'float', 'letohl', 'float']), 'malthouseenteralgia': ([], ['letohll', 'letohs', 'letohll', 'ntohs']), 'ulnaleptodactyl': ([], ['string', 'byte', 'letohs', 'string', 'byte', 'lv', 'letohs', 'letohs', 'double', 'ntohs', 'letohll', 'letohll', 'ntohll', 'byte', 'letohs', 'letohl', 'letohl', 'letohll', 'double', 'ntohl', 'ntohs', 'letohl', 'letohs', 'byte', 'byte', 'ntohll', 'letohll', 'double', 'ntohll', 'byte', 'byte']), 'changeablyzoophilitic': ([], ['letohll', 'string', 'letohll', 'byte']), 'Sumasslevulosuria': (['undercovertcoloss', 'shuttlecockscanmag', 'Steganophthalmiagnomic', 'subordinationbrachial', 'goniometerhexameral', 'malthouseenteralgia', 'refilmopenhandedness', 'zoosporangialbuyable', 'unlasheddialyzable', 'xenopodidtrencherless', 'paralyzerthiocarbimide', 'hyperneuriasymbolatry', 'Sarothrawrencher', 'dermoiddiversifiable', 'apioidalNagari', 'cinecameraHydropotes', 'interimperialvignetter', 'bawcockPicnickian', 'stickleafethenyl', 'etioporphyrinpubovesical', 'wutproamusement', 'mataiuntameness', 'ornithotomyblackwort', 'Mayorunahybridizer', 'querulouslycooky', 'outworthbenevolence', 'chytridialgoosemouth', 'hyperduliaferrateen', 'recapitalizerelevate', 'sokarailer', 'peritrichouslyhepatoflavin', 'springlikemonosymmetrically', 'barrelmakingparoemia', 'fetoracclimatement', 'asperationoraculousness', 'Wagnerianaaviculturist', 'organosiliconsegmentary', 'Triuridalesplagiarism', 'overpoliticunderlooker', 'peccationfoolery', 'Lespedezafuthorc', 'polyspermatouscreationistic', 'bairnlyneocosmic', 'scutcheonwiseileocolitis', 'hemianacusiadouble', 'maltingsurrection', 'untastedgirllike', 'imperializetrispaston', 'symptosissubcorneous', 'warneriodocasein', 'tollgateandrophagous', 'carangoidbotryomycotic', 'Opisthocomidaeheterochiral', 'pneumodynamicsprimariness', 'cacuminalgastrohysterorrhaphy', 'superestablishmentsuccor', 'Eomecondiscolorate', 'pedestrianateStromateidae', 'iconismanisostemonous', 'Stromatoporoideabarry', 'Lawsonsemiconversion', 'unfannedhopperman', 'lepidodendridcounterplead', 'ineloquentundishonored', 'strangulableargentamid', 'weathercockismcustodier', 'mausoleandecasualize', 'unhittabledoublehorned', 'ambisyllabicfruitful', 'susurrateoutvie', 'Piscataqualagoonal', 'outfeatvasodilator', 'extravagantkaryoplasmatic', 'cardialgiacontingence', 'bustedpredoubter', 'stakeholderunforbade', 'Voltaprotarsal', 'veldcraftsubprefect', 'Vandiemenianwinery', 'crossboltedasexually', 'idioglossiascabble', 'syphilologyannularity', 'isuroidunfitly', 'semicolumnrankly', 'shortcakeabase', 'pellagrosemongrelization', 'catmalisoncoevally', 'Sumasslevulosuria', 'Pamirioversystematic', 'blepharanthracosisuncliented', 'huddlingcladautoicous', 'microcrystallogenyfuniculus'], ['ntohl', 'nextproto_s', 'float', 'ntohll', 'nextproto_b', 'string', 'byte', 'double', 'double', 'nextproto_s', 'string', 'float', 'ntohll', 'lv', 'float']), 'teleophoreunspinsterlike': ([], ['float', 'ntohs', 'string', 'ntohs', 'lv', 'letohll', 'lv', 'ntohl', 'letohs', 'letohll', 'ntohll', 'lv', 'float', 'ntohs', 'lv', 'float', 'lv', 'float', 'ntohs']), 'tenesmicHymettic': ([], ['float', 'lv', 'letohl', 'byte', 'ntohll', 'ntohl', 'ntohll', 'ntohll', 'letohs', 'lv', 'letohs', 'letohll', 'letohll', 'letohll', 'byte', 'float', 'ntohl', 'float', 'letohs', 'ntohl', 'float', 'letohs', 'float', 'ntohl', 'string', 'ntohl', 'ntohs', 'string', 'float', 'letohs', 'letohl', 'ntohl', 'letohs', 'ntohl', 'lv', 'letohs', 'ntohll']), 'addressorcondensedly': (['focoidsstackfreed', 'springlikemonosymmetrically', 'Lawsonsemiconversion', 'ornithotomyblackwort', 'syphilologyannularity', 'ochronosusafterbody', 'refilmopenhandedness', 'unfannedhopperman', 'lepidodendridcounterplead', 'Orakzaiunsatisfiedly', 'bumblefooticonology', 'microcrystallogenyfuniculus', 'cinecameraHydropotes', 'radiopaqueunrecruitable', 'diseasednessthioantimonate', 'counterpotentMetabola', 'dermoiddiversifiable', 'intrathoraciccoemployment', 'blepharanthracosisuncliented', 'overhollowescort', 'veldcraftsubprefect', 'dehydrogenizeCambrian', 'Opisthocomidaeheterochiral', 'utterabilitypavement', 'Eomecondiscolorate', 'changeablyzoophilitic', 'stickleafethenyl', 'cassiteritecasemaking', 'superabsurdditremid', 'pellagrosemongrelization', 'crouchingpurebred', 'antleredadunc', 'organosiliconsegmentary', 'tenesmicHymettic', 'esophagoplastyrestrainedness', 'scutcheonwiseileocolitis', 'overgenialitybuzzle', 'perukiershiplexicographer', 'weathercockismcustodier', 'unlasheddialyzable', 'androgynyvegetoalkaline', 'untastedgirllike', 'shuttlecockscanmag', 'vaporizetannery', 'subregenthelmeted', 'ineloquentundishonored', 'byworkplastid', 'asepticallyBernese', 'predesignateunderservice', 'symmetricalantimasker', 'menialitypreintelligent', 'overpoliticunderlooker', 'Wagnerianaaviculturist', 'mattapharyngological', 'doubleheartedstaphylolysin', 'declamatorinessSerrifera', 'unconvenedperpetually', 'coeternaloverhonor', 'mataiuntameness', 'woodrowelshrievalty', 'udometricpredefault', 'Triuridalesplagiarism', 'multicrystallinekeratoglossus', 'unmistgraffer', 'avalanchestylopization', 'Sarothrawrencher', 'foliicolousskeletonweed', 'polyspermatouscreationistic', 'fetoracclimatement', 'cancelationZoochlorella', 'strangulableargentamid', 'seminegroSemiticize', 'noggencapitulate', 'malthouseenteralgia', 'xenogenesisprenoble', 'chaffererunheaded', 'anomalousparallelinerved', 'pedestrianateStromateidae', 'reladepropiolaldehyde', 'prattlersuffumigate', 'hetericismswayable', 'dermobranchiataboyardom', 'Mayorunahybridizer', 'cardialgiacontingence', 'grapedmassively', 'stakeholderunforbade', 'shortcakeabase', 'barrelmakingparoemia', 'subordinationbrachial', 'iconismanisostemonous', 'piskgriff', 'hammerkopnegativer', 'nonadjustmentwritmaking', 'hookahsupersimplicity', 'huddlingcladautoicous', 'catmalisoncoevally', 'hemianacusiadouble', 'idioglossiascabble', 'steelworkpsychophysiological'], ['letohs', 'lv', 'float', 'letohll', 'letohl', 'letohs', 'nextproto_b', 'letohl', 'nextproto_b', 'letohll', 'lv', 'byte', 'letohl', 'double', 'letohll', 'letohl', 'float', 'letohl', 'ntohll', 'float', 'letohl', 'letohs', 'letohs', 'letohl', 'float', 'byte', 'ntohl', 'ntohs', 'string', 'double']), 'roblaumontite': (['rattlepodMuntiacus', 'Philonismpinivorous', 'cerebroidodontolcate', 'GemitoresBourignian', 'gratefulAlcedinidae', 'Proteroglyphapiezoelectric', 'heliconbonnetman', 'cineplastyanonang', 'appendiceunmetaled', 'nondistributionclitellus', 'surlyreptilferous', 'unfootsorepoonac', 'lungflowerhorrormonger', 'contrarietyinconceivableness', 'desoxycorticosteroneshakerag', 'ruinlikesilva', 'barrelmakingparoemia', 'slopinglyautomatically', 'withsavesatinize', 'congregationalvocimotor', 'cumshawzelatrice', 'parorchispalingenic', 'unmensurableSoohong', 'ulnaleptodactyl', 'Sumasslevulosuria', 'ornithomanticrada', 'outlawrypervertedness', 'Jesperyearlong', 'potheenpharmacologia', 'somnipathistcarbonometry', 'flashpanstature', 'peerlesslyforetalk', 'preroyaltycoagulin', 'sheephookflushboard', 'theohumanhooper', 'sowbackgastrotrichan', 'hungerlysphenocephaly', 'usurperunplannedly', 'solemnlystre', 'Saxonicalpalet', 'crookedparonomasiastic', 'bacteriformpiercel', 'uncomminutedcommix', 'prebromidicMonopetalae', 'retickettopotaxis', 'Stromatoporoideabarry', 'allerChilostoma', 'limnophilidtrienniality', 'inquilinecopse', 'burgonetcarefully', 'Grahamsaloon', 'improvisionweed', 'Chilopsiscompactible'], ['double', 'ntohs', 'string', 'double', 'nextproto_s', 'ntohll', 'nextproto_s', 'float', 'ntohll', 'lv', 'lv', 'string', 'letohs', 'string', 'byte', 'string', 'nextproto_b', 'ntohs', 'byte', 'ntohl', 'nextproto_b', 'ntohll', 'lv', 'double', 'letohll', 'double', 'byte', 'ntohs', 'ntohll', 'nextproto_b', 'nextproto_s', 'byte', 'byte', 'double', 'letohs']), 'hypernutritionmarae': ([], ['byte', 'float', 'letohl', 'double', 'double', 'byte', 'float', 'letohl', 'double', 'ntohs', 'lv', 'ntohl', 'ntohs', 'ntohl', 'ntohs', 'ntohs', 'byte', 'letohll', 'letohl', 'ntohs']), 'sideflashmagniloquent': ([], ['letohs', 'ntohl', 'ntohl', 'letohs', 'float', 'ntohl', 'lv', 'nextproto_b', 'nextproto_s', 'string', 'nextproto_b', 'letohs']), 'steelworkpsychophysiological': (['hyperneuriasymbolatry', 'pilchermonaulos', 'asperationoraculousness', 'Orakzaiunsatisfiedly', 'symmetricalantimasker', 'steelworkpsychophysiological', 'countryfolkintolerance', 'bawcockPicnickian', 'xenopodidtrencherless', 'blepharanthracosisuncliented', 'pneumodynamicsprimariness', 'coeternaloverhonor', 'outworthbenevolence'], ['letohl', 'ntohl', 'double', 'letohll', 'double', 'nextproto_s', 'ntohl', 'letohl', 'ntohs', 'letohl', 'string', 'double', 'ntohs', 'float', 'ntohll', 'ntohll', 'nextproto_b', 'nextproto_b', 'nextproto_b', 'letohl', 'letohs', 'ntohll', 'lv', 'letohl', 'byte', 'ntohs', 'string', 'nextproto_s', 'ntohl', 'ntohl', 'ntohll', 'lv', 'ntohll', 'float', 'letohs', 'ntohll', 'ntohs', 'double', 'float', 'string', 'ntohll', 'letohl', 'ntohll']), 'pneumodynamicsprimariness': ([], ['byte', 'ntohl', 'ntohl', 'ntohll', 'letohs', 'letohl', 'letohll', 'letohs', 'ntohs', 'byte', 'lv', 'letohll', 'byte', 'ntohs', 'double', 'float', 'letohll', 'lv', 'ntohs', 'ntohs', 'byte', 'byte', 'ntohll', 'lv', 'letohl']), 'whitewareCladoselachidae': ([], ['double', 'ntohll', 'ntohs', 'string', 'ntohs', 'string', 'double', 'float', 'ntohll', 'ntohll', 'ntohl', 'ntohll', 'ntohll', 'float', 'lv', 'ntohl', 'lv', 'double', 'ntohll', 'ntohll', 'letohl', 'float', 'string', 'string', 'ntohll', 'float', 'letohl', 'byte', 'ntohs', 'lv', 'lv', 'letohs', 'ntohl', 'float', 'float', 'letohs', 'ntohl', 'byte', 'double', 'byte']), 'Momotinaenonfortification': ([], ['double', 'lv', 'ntohl', 'double', 'letohs', 'letohs', 'double', 'ntohs', 'letohll', 'letohl', 'string', 'float', 'float', 'ntohll', 'letohl', 'double', 'double', 'byte', 'float', 'ntohl', 'letohll', 'ntohll']), 'epexegeticallyreadjournment': ([], ['ntohll', 'letohs', 'lv', 'ntohll', 'letohl', 'ntohs', 'letohs', 'letohll', 'double', 'letohll', 'letohll', 'ntohll', 'letohl', 'letohll', 'float', 'letohs', 'string', 'letohll', 'float', 'lv', 'string', 'letohl', 'lv', 'ntohll', 'letohs', 'ntohl', 'letohl', 'letohs', 'letohl', 'float', 'ntohl', 'byte', 'float', 'letohll', 'double', 'ntohs', 'letohs', 'ntohll', 'float']), 'bairnlyneocosmic': ([], ['lv', 'letohs', 'letohll', 'ntohll', 'string', 'byte', 'ntohl', 'letohs', 'letohl', 'letohs']), 'outdoortenorister': ([], ['double', 'double', 'letohll', 'string', 'byte', 'ntohs', 'letohll', 'letohll', 'letohs', 'letohll', 'ntohll', 'ntohll', 'string', 'letohl', 'ntohl', 'byte', 'ntohs']), 'crossboltedasexually': ([], ['byte', 'ntohs', 'ntohs', 'ntohs', 'float', 'double', 'float']), 'loketprincipiate': ([], ['ntohl', 'ntohl', 'letohl', 'lv', 'letohl', 'letohll', 'double']), 'inkfishpoppycock': (['eudaemonisticallyCoccolobis', 'peepypatrologic', 'interventraliaforeutter', 'raucousEstheriidae', 'spinthariscopiclieutenancy', 'kansrush', 'iridemiabisque', 'radomenetherwards', 'spadelikemassacrer', 'hystericsupersuperior', 'coeternaloverhonor', 'paleobotanyworkpeople', 'noniccosmopoietic', 'cesserreichspfennig', 'springlikemonosymmetrically', 'chaffererunheaded', 'premortuarybenchy', 'weathercockismcustodier', 'Eomecondiscolorate', 'exponencecrubeen', 'prehexameraldissyllabize', 'Opisthocomidaeheterochiral', 'dracontiasisinterparliamentary', 'Slavophilesedigitate', 'urningsubpubescent', 'igelstromiteMoraceae', 'bairnlyneocosmic', 'kempstergarefowl', 'sagaiebarrister', 'ciderishazury', 'dissogenyBarney', 'notwitch', 'untuckedsolenoglyphic', 'achaetouspreparticipation', 'reproachablepancreatogenic', 'loungyimpolite', 'overseateddiscouragingly', 'overcriticalnesslovableness', 'unquailingshive', 'pyroaceticnunciature', 'Boneyretreater', 'redepositsubclassify', 'epitrophygoatlike', 'interimperialvignetter', 'dihedronsubcircuit', 'terrazzododder', 'pegologyscavenage', 'acclaimerilluminability', 'vibrativeoversail', 'Plymouthistnashgab', 'predestinarianglia'], ['ntohll', 'byte', 'byte', 'nextproto_b', 'letohl', 'lv', 'letohl', 'nextproto_b', 'double', 'ntohll', 'nextproto_b', 'string', 'double', 'ntohll', 'ntohs', 'nextproto_s', 'ntohs', 'double', 'float', 'byte', 'letohs', 'double', 'double', 'ntohl', 'lv', 'lv', 'ntohll', 'double', 'double', 'nextproto_b', 'letohl', 'ntohs', 'string', 'letohll', 'letohs', 'letohl']), 'aerocraftforbar': (['vaporizetannery', 'premortuarybenchy', 'Histriobdellauntread', 'photoheliographoctuplicate', 'polishedlyhematosis', 'laterodeviationNarciss', 'alveololingualMindererus', 'oversoldafield', 'unvoiceCamacan', 'archcrownundistantly', 'plowtailinfectress', 'slutteryprivant', 'byworkplastid', 'hallowerhydrophthalmos', 'deadlockperiangitis', 'preservatizeskyphoi', 'skilderprothalline', 'mattapharyngological', 'uncarrieddigitinerved', 'graphologicautovaccination', 'Sonjapylorogastrectomy', 'malapleurogenous', 'galimatiasphacocystectomy', 'dissogenyBarney', 'postiquedefeasibility', 'udometricpredefault', 'Philoctetessupersalesman', 'cephaloconicunbaptized', 'cineplastyanonang', 'carcerationinterrenal', 'asepticallyBernese', 'pedestrianateStromateidae', 'tellurethurryproof', 'wingerconsoler', 'Piscataqualagoonal', 'damnonianscrankly', 'unrevenuedindecorousness', 'changeablyzoophilitic', 'docimasytrouserdom', 'dejectedincreasing', 'evenworthyharebrain', 'cardinghygeistic', 'arhatsporozoic', 'biserialsmithite', 'intercoolingpotentialization', 'epexegeticallyreadjournment', 'Margaropusscooter', 'seminegroSemiticize', 'listeningBroussonetia', 'reshoedrachmae', 'popeyednaphtha', 'prizeexcrescence', 'furoidbasanite', 'Melanorrhoeadewworm', 'contrarietyinconceivableness', 'overgenialitybuzzle', 'ureterorrhagiahemogenetic', 'dowsettroughway', 'grammaticismmignonette', 'stagemansupa', 'cosilybridecake', 'coxbonesbirle', 'unstalledneutralism', 'unoverhauledGalinsoga', 'Oliveanpyromancer', 'nonadjustmentwritmaking', 'Tdapproximatively', 'undistinctivenondisfranchised', 'provectgastrocolostomy', 'unremittinglyaffronting', 'membershiptownsboy', 'cleansingpentahedral', 'sulphhemoglobinHerculanean', 'spraysemisaprophyte'], ['float', 'nextproto_b', 'string', 'letohl', 'ntohll']), 'woodrowelshrievalty': ([], ['ntohs']), 'pericyclonicdipteran': ([], ['ntohl', 'byte', 'letohs', 'float', 'byte', 'letohll', 'ntohl', 'string', 'ntohll', 'ntohll', 'lv', 'letohl', 'float', 'ntohll', 'letohs', 'string', 'lv', 'string', 'ntohs', 'byte', 'float', 'double', 'letohs', 'ntohll', 'letohll', 'letohs', 'ntohll', 'float', 'string', 'lv', 'double', 'float', 'ntohl', 'string', 'ntohs', 'letohs', 'ntohll', 'byte', 'letohs', 'lv', 'letohl', 'letohs']), 'phototherapistupsetted': ([], ['string', 'string', 'letohll', 'ntohll', 'ntohs', 'ntohs', 'ntohll', 'letohll', 'letohll', 'ntohll', 'float', 'byte', 'letohl', 'ntohll', 'double', 'string', 'ntohll', 'string', 'byte', 'byte', 'letohll', 'ntohll', 'ntohs', 'byte', 'double', 'letohll']), 'autovivisectionoverleather': ([], ['letohll', 'letohl', 'string', 'ntohs', 'lv', 'ntohs', 'double', 'letohs', 'double', 'ntohs', 'letohll', 'float', 'ntohl', 'double', 'letohs', 'lv', 'float', 'ntohll', 'ntohll', 'double']), 'arnberrydodecadrachm': ([], ['ntohll', 'ntohs', 'float', 'ntohll', 'string', 'letohll', 'letohs', 'lv', 'ntohll', 'letohs', 'ntohl', 'letohll', 'letohll', 'ntohs', 'byte', 'string', 'ntohl', 'float', 'ntohll', 'letohl', 'letohl', 'letohl', 'ntohs', 'string', 'ntohll', 'lv', 'double', 'letohl', 'byte', 'lv', 'ntohl', 'letohl', 'letohs', 'letohll', 'lv', 'letohl', 'double', 'letohl', 'byte']), 'hypoplasyhooping': ([], ['letohs']), 'catastateateliosis': (['feveretunderbox', 'extravagantkaryoplasmatic', 'furoidbasanite', 'flashpanstature', 'cineplastyanonang', 'symmetricalantimasker', 'cassiteritecasemaking', 'scleroblastemicpalaeocosmology', 'trichitepersonship', 'ecclesiaLatinization', 'blossomscrimshander', 'doubleheartedstaphylolysin'], ['ntohs', 'letohl', 'letohll', 'ntohl', 'double', 'byte', 'letohs', 'byte', 'ntohs', 'string', 'letohll', 'nextproto_s', 'ntohl', 'letohl', 'ntohll', 'ntohl', 'string', 'lv', 'letohll', 'ntohl', 'string', 'ntohl', 'ntohl', 'ntohs', 'lv', 'nextproto_s', 'letohs', 'ntohs', 'byte', 'letohll', 'string', 'string']), 'unsensualDamocles': ([], ['letohll', 'ntohs', 'ntohll', 'double', 'letohll', 'ntohll', 'byte']), 'diopterpelvioradiography': ([], ['letohll', 'letohll', 'letohll', 'byte', 'letohl', 'string', 'string', 'ntohll', 'string', 'lv', 'lv', 'byte', 'letohll', 'letohs']), 'tauromachyoutgive': (['leucoencephalitisconsistent', 'goniometerhexameral', 'organoantimonypreoperator', 'stomagringo', 'photoheliographoctuplicate', 'togueseaflower', 'subsoilercruent', 'qualmyishHolocene', 'Sonjapylorogastrectomy', 'practicelegitimatist', 'stakeholderunforbade', 'cudavaogreish', 'semistillpassback', 'previousnessoisin', 'Nathanielbiliteral', 'coxbonesbirle', 'Triuridalesplagiarism', 'codeinesalience', 'terribletaut', 'vibrativeoversail'], ['nextproto_s', 'nextproto_s', 'float', 'byte', 'byte', 'double', 'nextproto_b', 'double', 'string', 'letohl', 'byte', 'letohs', 'letohl', 'double', 'lv', 'string', 'nextproto_s', 'nextproto_b', 'ntohl', 'letohs', 'letohl', 'ntohl', 'byte', 'ntohll', 'double', 'nextproto_b', 'ntohll', 'lv', 'float', 'letohll', 'lv']), 'mediumismgypsyism': ([], ['lv', 'lv', 'letohll', 'ntohl', 'string', 'string', 'lv']), 'enclothearmiferous': (['galledisocinchomeronic', 'gumdiggingsalvarsan', 'Maytimeraillike', 'parathyroidectomizeoutheart', 'menialitypreintelligent', 'Opisthocomidaeheterochiral', 'exponencecrubeen', 'coinbellmaker', 'simulcastriboflavin', 'mattapharyngological', 'tautologicpanimmunity', 'nonofficeholdingwaldgravine', 'bemuzzlesurficial', 'counterpotentMetabola', 'Sarothrawrencher', 'dihedronsubcircuit', 'adiaphorousfalsifiable', 'meddlingsmall', 'arecolidinehyalodacite', 'dermoiddiversifiable', 'whusslenoreast', 'creditiveplatonesque', 'indubitablenoncollaboration', 'Lawsonsemiconversion', 'motacillinewidespreadly', 'Carpathianmetanephron', 'unsubstantiaterightfulness', 'polyspermatouscreationistic', 'androgynyvegetoalkaline', 'noggencapitulate', 'correctorSpirochaeta', 'unhittabledoublehorned', 'uncatholicizeSiphonognathus', 'faddyamputational', 'unoverhauledGalinsoga', 'ExobasidialesEppy', 'pneumodynamicsprimariness', 'venomouslypilferment', 'organosiliconsegmentary', 'keraunophoneinhabited', 'isatogenvestibulum', 'Momotinaenonfortification', 'applanationnitrifaction', 'dermobranchiataboyardom', 'evaluecystatrophia', 'inquilinecopse', 'terribletaut', 'subsoilercruent', 'springlikemonosymmetrically', 'countryfolkintolerance', 'tenodesisunroaming', 'agonizefloating', 'mischieveunfomented', 'hetericismswayable'], ['letohs', 'string', 'letohs', 'letohll', 'ntohs', 'letohll', 'string', 'letohl', 'nextproto_s', 'string', 'letohl', 'ntohs', 'ntohs', 'letohll', 'double', 'letohs', 'float', 'ntohl', 'string', 'ntohl', 'letohl', 'lv', 'nextproto_s', 'nextproto_b', 'lv', 'ntohl', 'byte', 'nextproto_s', 'lv', 'lv', 'lv', 'ntohs', 'ntohs', 'string', 'ntohs', 'double', 'letohll', 'letohll']), 'Heterodactylaefrisk': ([], ['ntohl', 'lv', 'lv', 'ntohl', 'lv', 'letohl', 'letohl', 'ntohs', 'ntohll', 'letohs', 'letohll', 'letohll', 'string', 'ntohs', 'ntohl', 'letohl', 'string', 'string', 'ntohs', 'ntohs', 'ntohl', 'byte', 'letohl', 'letohs', 'string', 'letohll', 'letohll', 'letohl', 'double', 'letohs', 'ntohll', 'double', 'string', 'ntohll', 'lv', 'ntohl']), 'phallaceousunrebel': ([], ['float', 'double', 'letohll', 'letohs', 'double', 'letohl', 'float', 'letohs', 'lv', 'ntohll', 'letohl', 'ntohl', 'byte', 'lv', 'ntohl', 'letohll', 'letohll', 'ntohll', 'float', 'letohll', 'ntohs', 'double', 'double', 'byte', 'ntohl', 'letohll', 'ntohl', 'ntohll', 'float', 'lv', 'byte', 'letohs', 'letohs', 'letohs']), 'intwistpunter': ([], ['ntohl', 'letohl', 'double', 'letohl', 'ntohll', 'ntohl', 'lv', 'letohll', 'letohs', 'ntohs', 'string', 'string', 'letohll', 'string', 'lv', 'string', 'ntohll']), 'Alalamenispermine': ([], ['letohl', 'string', 'lv', 'byte', 'ntohl', 'letohs', 'ntohll', 'letohs', 'ntohll', 'lv', 'float', 'letohll', 'letohs', 'ntohs', 'lv', 'letohll', 'byte', 'letohs', 'letohs', 'float', 'lv', 'byte', 'float']), 'batteruncommutable': ([], ['ntohll', 'ntohs', 'lv', 'letohl', 'ntohs', 'ntohll', 'double', 'letohll', 'byte', 'letohs', 'ntohs', 'lv']), 'anomalousparallelinerved': ([], ['ntohl', 'letohl', 'byte', 'ntohs', 'ntohs', 'letohl', 'letohl', 'letohll', 'string', 'ntohl', 'lv', 'ntohl', 'letohll', 'letohl', 'letohll', 'ntohs', 'letohll', 'string', 'letohll', 'lv', 'ntohl', 'lv', 'ntohs', 'letohll', 'letohll', 'ntohs', 'byte', 'lv', 'ntohl', 'letohs', 'ntohs', 'ntohl']), 'anapneaCystignathidae': (['addressorcondensedly', 'misproduceunthrilled', 'untastedgirllike', 'phlebectomySiam', 'anusimnonstationary', 'smotheringlyhumpbacked', 'unfootsorepoonac', 'evenworthyharebrain', 'Sarothrawrencher', 'archiereusHainan', 'remisrepresentationlancet', 'gardenedfugacious', 'hookahsupersimplicity', 'steinkirkmisaffection', 'acquisitumvaletudinarist', 'recapitalizerelevate', 'goodlyterebenthene', 'overpoliticunderlooker', 'esophagoplastyrestrainedness', 'reshoedrachmae', 'enclothearmiferous', 'unmistgraffer', 'gumdiggingsalvarsan', 'weathercockismcustodier', 'hammerkopnegativer', 'organosiliconsegmentary', 'assecurationAshkenazim', 'preinjuryduplicature', 'terrazzododder', 'metasomalNachitoches', 'Stromatoporoideabarry', 'redepositsubclassify', 'Eurypteroideachamaeprosopic', 'skilderprothalline', 'cystocarppapaprelatical', 'archcrownundistantly', 'dinitrilholocentrid', 'feveretunderbox', 'twinklybingo', 'practicelegitimatist', 'saffianpackcloth', 'slichtarradiddler', 'loungyimpolite', 'Marcosianpictographically', 'shuttlecockscanmag', 'dermoiddiversifiable', 'overdiligentlyrifleshot', 'misadministrationbroody', 'cathodofluorescencemonkcraft', 'cylindrarthrosisnonplusation', 'Cobitidaedismissal', 'stagemansupa', 'loketprincipiate', 'subregenthelmeted', 'peepypatrologic', 'chromophilouspyometra', 'ettleoptimize', 'orographicniddick', 'dejectedincreasing', 'TelopeaCyclotosaurus', 'homozygotemagicalize', 'sageshipcarcoon', 'tumoredcrocodilite', 'cerebroidodontolcate', 'previousnessoisin', 'Toryizesynechthran', 'cinecameraHydropotes', 'declamatorinessSerrifera', 'summarizationyatter', 'lamellicornousPolygonaceae', 'butyrochloralfertilizational', 'triquetricinfrasternal', 'undiametricsinningness', 'Histriobdellauntread', 'domanialPhora', 'kansrush', 'predesignateunderservice', 'unremittinglyaffronting', 'gatewiseunderpot', 'ralphautonomically', 'archsnoblodgepole', 'stickleafethenyl', 'neurofibriljanapan', 'arhatsporozoic', 'simulcastriboflavin', 'allottrichopterous', 'Bombycillahonoraria', 'Anglomaniaclovableness', 'iridemiabisque', 'ExobasidialesEppy', 'xenogenesisprenoble', 'micrencephalypalpus', 'huddlingcladautoicous', 'actordocility', 'picayunishapogeotropic', 'igelstromiteMoraceae'], ['nextproto_b', 'ntohl', 'nextproto_b', 'letohll', 'letohl', 'letohs', 'string', 'ntohll', 'ntohl', 'ntohll', 'letohs', 'letohs', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'letohl', 'letohll', 'letohll', 'byte', 'letohll', 'string', 'letohl', 'letohl', 'ntohs', 'lv', 'ntohll', 'string', 'float', 'string', 'nextproto_b', 'letohl', 'nextproto_b', 'letohl', 'double']), 'abjudicationunpleading': ([], ['letohl', 'ntohs', 'letohs', 'double', 'ntohl', 'lv', 'letohl', 'string', 'ntohl', 'letohll', 'letohs', 'letohl', 'letohll', 'lv', 'letohs', 'byte', 'byte']), 'wickedlyinflatedness': (['nontechnicalrongeur', 'codeinesalience', 'wickedlyinflatedness', 'reladepropiolaldehyde', 'Bharatadomain', 'uncarrieddigitinerved', 'tuboovariandeducibleness', 'somnipathistcarbonometry', 'damnonianscrankly', 'ecclesiaLatinization', 'psychrographismdom', 'symmetricalantimasker', 'Chilopsiscompactible', 'limsypersistence', 'achaetouspreparticipation', 'Philoctetessupersalesman', 'arsheenperspiration', 'semisomnolencegunj', 'androgynyvegetoalkaline', 'frontomallarforedetermine', 'geriatricundaubed', 'asperationoraculousness', 'snakeletwounds', 'ralphautonomically', 'pavonatedcozily', 'parandruspercribration', 'mercurializationsimulacre', 'receptivelynonshredding', 'kansrush', 'bairnlyneocosmic', 'delthyrialGee', 'visorlikeNagari', 'evenworthyharebrain', 'prefactoranchoret', 'shellycoatcallousness', 'spattertriphenylated', 'Negritohydroponicist', 'cannotdentigerous', 'polyspermatouscreationistic', 'dejectedincreasing', 'redifferentiationmustachio', 'meddlingsmall', 'undiametricsinningness', 'spicousHippopotamidae', 'maskflowerkeynoter', 'motacillinewidespreadly', 'Aparaipsychiatrist', 'phallaceousunrebel', 'cerebroidodontolcate', 'ineloquentundishonored', 'Nathanielbiliteral', 'agonizefloating', 'gratefulAlcedinidae', 'epitrophygoatlike', 'peerlesslyforetalk', 'placitumunmortgage', 'skeelysubtriangular', 'unmooredtowy', 'sternoxiphoidunenlivened', 'Silicoideasaltator', 'flamprelate', 'anapneaCystignathidae', 'repolymerizationwesselton', 'outsumunrefusingly', 'trichitepersonship', 'saffianpackcloth', 'springlikemonosymmetrically', 'spadelikemassacrer', 'correctorSpirochaeta', 'prizeexcrescence', 'ananaamasty', 'peepypatrologic', 'vareisogeothermic', 'preroyaltycoagulin', 'zoosporangialbuyable', 'smackinglyScheuchzeriaceae', 'unhyphenedallose', 'phlebectomySiam', 'malthouseenteralgia', 'perukiershiplexicographer', 'overhollowescort', 'Robenhausianreboil', 'lepidodendridcounterplead', 'paraderDendrocygna', 'oysterhouseamarillo', 'untrainhearkener', 'amlipyrexic', 'roofprespur', 'Bitulithicscrin'], ['string', 'nextproto_b', 'lv', 'float', 'string', 'byte', 'string', 'ntohl', 'letohll', 'ntohll', 'ntohl', 'letohll', 'byte']), 'marblelikeTenaktak': ([], ['letohll', 'lv', 'float', 'double', 'ntohl', 'letohll', 'string', 'byte', 'ntohll', 'double', 'lv', 'letohs', 'ntohll', 'float']), 'catagmaticMegalosaurus': ([], ['double', 'ntohs', 'ntohl', 'letohll', 'float', 'float', 'byte', 'ntohll', 'letohs']), 'sagaiebarrister': ([], ['ntohs', 'byte', 'float', 'ntohll', 'string', 'ntohs', 'ntohs', 'ntohll', 'ntohs', 'ntohs', 'letohs', 'ntohl', 'double', 'lv', 'string', 'letohll', 'ntohs', 'letohll']), 'undercovertcoloss': ([], ['lv', 'letohs', 'letohll', 'double', 'string', 'double', 'float', 'lv', 'float']), 'micrifyoverfrighten': ([], ['ntohll', 'letohll', 'lv', 'string', 'byte', 'ntohs', 'float', 'string', 'letohs', 'letohll', 'float', 'string', 'ntohll', 'ntohl', 'ntohll', 'float', 'letohl', 'lv', 'letohs', 'ntohll', 'double', 'letohll', 'ntohll', 'double', 'lv', 'letohs', 'ntohll', 'letohl', 'ntohs']), 'funestworser': ([], ['byte', 'ntohs', 'string', 'byte', 'ntohs', 'letohl', 'letohl']), 'Ephemeridacaecilian': (['importationPerisphinctidae', 'violationguggle', 'batteruncommutable', 'unhittabledoublehorned', 'foreuseuninfluencing', 'furoidbasanite', 'somnipathistcarbonometry', 'hemologistbeglide', 'piskgriff', 'undercovertcoloss', 'esophagoplastyrestrainedness', 'Fichteanismconjobble', 'muckyuxoricide', 'hammerkopnegativer', 'unhealablenessknoppy', 'Voltaprotarsal', 'keelfathoplomachos', 'electrocardiographyamaranthaceous', 'ankylenterongreenfish', 'oversolicitouslyhour', 'usurpinglyoscin', 'turbidlycorticoefferent', 'overseateddiscouragingly', 'endopathicnonmarrying', 'holdsmanoversalty', 'matelessbeatitude', 'cattlefolk', 'foliicolousskeletonweed', 'springlikemonosymmetrically', 'chinkingcytologic', 'deadlockperiangitis', 'improvisatorizenoneditorial', 'appendiceunmetaled', 'warneriodocasein', 'vareisogeothermic', 'antleredadunc', 'Eomecondiscolorate', 'picturedomArchaeopteris', 'paleocrystallinespinulosodenticulate', 'tintsausinger', 'Rodolphhumuslike', 'Silicoideasaltator', 'cardinghygeistic', 'menialitypreintelligent', 'imperializetrispaston', 'purgaNycticorax', 'hallowerhydrophthalmos', 'dissogenyBarney', 'pyroaceticnunciature', 'peccationfoolery', 'submountainhopper', 'paralyzerthiocarbimide', 'marblelikeTenaktak', 'rachiometersuprachoroid', 'SpatangusChayma', 'sulphostannideuntimeliness', 'nasicornousfasciated', 'slopinglyautomatically', 'dominionistversableness', 'outsumunrefusingly', 'prattlersuffumigate', 'unenterprisedargumentatious', 'hornilychrysolitic', 'quakinglyilliterate', 'skeelysubtriangular', 'symmetricalantimasker', 'picayunishapogeotropic', 'Anchtheriumunastonish', 'cannotdentigerous', 'diazobenzenedisburden', 'indirecthierarchism', 'ochronosusafterbody', 'unexchangedsupraventricular', 'microcaltropmyosarcomatous', 'gulchalilonghi', 'untuckedsolenoglyphic', 'triquetricinfrasternal', 'sulfureasupertramp', 'subsoilercruent', 'Larinaecoydog', 'prehexameraldissyllabize'], ['float', 'float', 'ntohll', 'ntohs', 'nextproto_b', 'float', 'letohll', 'nextproto_s', 'float']), 'stagemansupa': ([], ['letohll', 'string', 'double', 'letohll', 'float', 'float', 'lv', 'letohs', 'double', 'double', 'letohl', 'ntohl', 'string', 'string', 'double', 'ntohl', 'ntohl', 'ntohl', 'letohl', 'float', 'double', 'byte', 'byte', 'double', 'ntohl', 'ntohs', 'letohl', 'ntohs', 'letohl', 'letohl', 'ntohs', 'float', 'float', 'float', 'ntohll', 'letohs', 'float', 'ntohs']), 'misspellquinaldic': ([], ['letohl', 'double', 'ntohl', 'letohl', 'double', 'lv', 'double', 'lv', 'ntohs', 'letohll', 'float', 'letohs', 'lv', 'letohs', 'ntohll', 'ntohs', 'lv', 'ntohll', 'string', 'ntohl', 'letohll', 'byte', 'letohs', 'lv']), 'pensefulnessdrought': ([], ['lv', 'string', 'byte', 'double', 'ntohll', 'letohl', 'string', 'ntohl', 'letohl', 'byte', 'ntohl', 'letohl', 'letohll', 'letohl', 'string', 'ntohs', 'byte', 'double', 'double', 'string', 'lv', 'letohll', 'byte', 'byte', 'letohs', 'letohl', 'byte', 'letohl', 'letohs', 'float', 'double', 'ntohll', 'letohll', 'double', 'letohs', 'ntohs', 'lv', 'double', 'letohll']), 'acutelyminar': ([], ['float', 'double', 'ntohll', 'ntohl', 'ntohll', 'ntohll', 'float', 'ntohll', 'string', 'ntohl', 'letohl', 'string', 'letohll', 'double', 'double', 'string', 'ntohl', 'lv', 'float', 'letohll', 'float', 'float', 'string', 'double', 'letohs', 'byte', 'ntohll', 'ntohll', 'ntohll', 'ntohs', 'byte', 'letohl', 'float', 'letohll', 'letohs', 'letohl', 'string', 'double', 'byte', 'letohs', 'float', 'letohll', 'double', 'letohl', 'ntohll', 'float']), 'foreimaginationenthalpy': (['peerlesslyforetalk', 'stereopicturesalep', 'Triuridalesplagiarism', 'Batwaoverpopularity', 'inkfishpoppycock', 'Bronxbiotechnics', 'clientageshudderingly', 'pyrroylprobity', 'somnipathistcarbonometry', 'cotteextubate', 'bemuzzlesurficial', 'phallaceousunrebel', 'visorlikeNagari', 'Ibaditehypotenuse', 'redifferentiationmustachio', 'prefactoranchoret', 'reshoedrachmae', 'limsypersistence', 'usurpinglyoscin', 'ciderishazury', 'dookmainport', 'docimasytrouserdom', 'referumbrellawort', 'pensefulnessdrought', 'cathodofluorescencemonkcraft', 'xenogenesisprenoble', 'ketembillaantiferment', 'redepositsubclassify', 'inwrapmentcarcinogenesis', 'systemizableepode', 'photoheliographoctuplicate', 'evaluecystatrophia', 'agonizefloating', 'uncunningmonticuliporidean', 'receptivenesssempervirent', 'Oliveanpyromancer', 'appendiceunmetaled', 'unquailingshive', 'forswearfreewheel', 'acutelyminar', 'unfootedHilary', 'invulnerabledimerization', 'alphabetizermonoclinal', 'submountainhopper', 'iodolabsolutistic', 'depositumspiritsome', 'refilmopenhandedness', 'hetericismswayable', 'preinjuryduplicature', 'unodoriferousWhiggish', 'nonaugmentativehypertelic', 'overkneePolypoda', 'bullswooldraggletail', 'addressorcondensedly', 'indubitablenoncollaboration', 'alphabetismpolyfenestral', 'dowsettroughway', 'prattlersuffumigate', 'muckyuxoricide', 'untuckedsolenoglyphic', 'catagmaticMegalosaurus', 'unoverhauledGalinsoga', 'vibrativeoversail', 'simulcastriboflavin', 'irreclaimableconjugally', 'nookingspellword', 'Manobountopping', 'undercovertcoloss', 'hemologistbeglide', 'stickleafethenyl', 'androgynyvegetoalkaline', 'allottrichopterous', 'externalisticguaranteeship', 'intwistpunter', 'tumultuouslymammonitish', 'peragratemultifoliate'], ['letohll', 'nextproto_s', 'letohll', 'double', 'float', 'string', 'string', 'nextproto_b', 'lv', 'float', 'letohs', 'double', 'float', 'ntohll', 'ntohll', 'ntohs', 'ntohs', 'nextproto_s', 'double', 'letohl', 'string', 'lv', 'nextproto_s', 'string', 'lv', 'letohs', 'lv', 'ntohl', 'nextproto_s', 'string', 'letohl', 'ntohs', 'lv', 'ntohll']), 'psychrographismdom': ([], ['ntohs', 'ntohll', 'letohs', 'letohl', 'letohs', 'letohl', 'ntohl', 'ntohs', 'string', 'float', 'ntohs']), 'scleroblastemicpalaeocosmology': ([], ['float', 'ntohs', 'ntohs', 'letohll', 'float', 'lv', 'letohll', 'string', 'ntohll', 'ntohl', 'double', 'lv', 'letohll', 'double', 'float', 'ntohs', 'letohl', 'letohll', 'ntohl', 'ntohs', 'lv']), 'congregationalvocimotor': ([], ['letohll', 'ntohl', 'letohll', 'double', 'float', 'letohs']), 'Zantedeschiacladocarpous': (['Silicoideasaltator', 'subcineritiousphrenitic', 'isuroidunfitly', 'gymnosporouswoubit', 'porencephalonpostplegic', 'unsanctioningperiuvular', 'phenomenalisticallyunmomentary', 'sharkletcompactedly', 'goodlyterebenthene', 'stagemansupa', 'unenterprisedargumentatious', 'unstalledneutralism', 'oilinessbookwright', 'subsorterbecuffed', 'radiopaqueunrecruitable', 'nonhumanistunsoaked', 'grapedmassively', 'agonizefloating', 'coxbonesbirle', 'undistinctivenondisfranchised', 'Toryizesynechthran', 'provectgastrocolostomy', 'loungyimpolite'], ['double', 'ntohs', 'float', 'float', 'ntohll', 'double', 'nextproto_b', 'float', 'double', 'byte', 'lv', 'letohl', 'float', 'float', 'ntohs', 'ntohl', 'float', 'nextproto_s', 'nextproto_b', 'letohll', 'ntohs', 'string', 'letohs', 'letohs', 'letohs', 'nextproto_b', 'ntohs', 'double', 'lv', 'lv', 'nextproto_b', 'nextproto_s', 'letohl', 'letohl', 'letohl', 'nextproto_b', 'nextproto_s', 'float', 'double', 'ntohs', 'ntohll']), 'secrecyheteroecy': ([], ['ntohl', 'float', 'byte', 'letohll', 'lv', 'ntohs', 'float', 'letohll', 'byte', 'letohll', 'ntohs', 'string', 'float', 'lv']), 'veldcraftsubprefect': ([], ['double', 'lv', 'lv', 'ntohll', 'ntohs', 'ntohs', 'ntohll', 'ntohl', 'double', 'letohl', 'letohll', 'ntohs', 'float', 'letohl', 'letohl', 'ntohl']), 'nonofficeholdingwaldgravine': ([], ['letohl', 'string', 'ntohll', 'ntohll', 'letohl', 'letohll', 'ntohll', 'double', 'string', 'double', 'ntohs', 'byte', 'letohll', 'ntohl', 'byte', 'letohs', 'ntohs', 'letohs', 'double', 'ntohs', 'string', 'ntohll']), 'untrammelednessHannibalian': ([], ['string', 'lv', 'letohll', 'letohll', 'ntohl', 'ntohl', 'float', 'string', 'ntohs', 'letohll', 'float', 'ntohs', 'double', 'letohs', 'ntohl', 'string', 'letohll', 'ntohs', 'string', 'letohs', 'float', 'letohs', 'float', 'ntohs', 'ntohll', 'letohll', 'float', 'ntohll', 'lv']), 'attestatorcoronule': ([], ['ntohl', 'lv', 'letohl', 'letohl', 'letohs', 'float', 'float', 'lv', 'letohs', 'letohll', 'float', 'float']), 'revenantpromisee': ([], ['float', 'ntohs', 'byte', 'letohl', 'ntohl', 'double', 'ntohl', 'letohl', 'lv', 'letohl', 'letohll', 'byte', 'letohll', 'string', 'letohl', 'lv', 'ntohll']), 'gatewiseunderpot': (['shortcakeabase', 'paralyzerthiocarbimide', 'udometricpredefault', 'surlyreptilferous', 'gatewiseunderpot', 'outfeatvasodilator', 'trentepohliaceousHectorean', 'stickleafethenyl', 'sokarailer', 'saltlypropugnator', 'mataiuntameness', 'avalanchestylopization', 'amlipyrexic', 'unbeggarbroncholithiasis', 'coeternaloverhonor', 'doubleheartedstaphylolysin', 'diseasednessthioantimonate', 'Pamirioversystematic', 'bustedpredoubter', 'paleobotanyworkpeople', 'carannaaccension', 'seminegroSemiticize', 'tenesmicHymettic', 'wutproamusement', 'whusslenoreast', 'counterpotentMetabola', 'reladepropiolaldehyde', 'Lawsonsemiconversion', 'refilmopenhandedness', 'roofprespur', 'picayunishapogeotropic', 'shuttlecockscanmag', 'isuroidunfitly', 'syphilologyannularity', 'hookahsupersimplicity', 'goniometerhexameral', 'foliicolousskeletonweed', 'epigenesistbisexed', 'barrelmakingparoemia', 'mausoleandecasualize', 'microcrystallogenyfuniculus', 'overgenialitybuzzle', 'ambisyllabicfruitful', 'summarizationyatter', 'anomalousparallelinerved', 'nonadjustmentwritmaking', 'racegoingunperformed', 'cacuminalgastrohysterorrhaphy', 'declamatorinessSerrifera', 'organosiliconsegmentary', 'tollgateandrophagous', 'dermobranchiataboyardom', 'pedestrianateStromateidae', 'evaluecystatrophia', 'semicolumnrankly', 'veldcraftsubprefect', 'polyspermatouscreationistic', 'Triuridalesplagiarism', 'Vandiemenianwinery', 'cassiteritecasemaking', 'intrathoraciccoemployment', 'Steganophthalmiagnomic', 'bawcockPicnickian', 'Orakzaiunsatisfiedly', 'predesignateunderservice', 'cesserreichspfennig', 'Fichteanismconjobble', 'loungyimpolite', 'pellagrosemongrelization', 'esophagoplastyrestrainedness', 'bairnlyneocosmic', 'dermoiddiversifiable', 'unhittabledoublehorned', 'apioidalNagari', 'xenogenesisprenoble', 'susurrateoutvie'], ['letohl', 'ntohl', 'letohll', 'float', 'lv', 'ntohll', 'ntohl', 'double', 'nextproto_s', 'letohll', 'ntohs', 'nextproto_b', 'float', 'letohs', 'double', 'byte', 'byte', 'letohs', 'float', 'nextproto_b']), 'chaffererunheaded': ([], ['ntohl', 'float', 'letohs', 'letohs', 'ntohll', 'letohl', 'letohs', 'ntohs', 'byte', 'ntohll', 'letohll', 'double', 'letohl', 'float', 'letohl', 'byte', 'ntohll', 'ntohl', 'ntohl', 'letohll', 'string', 'ntohl', 'byte', 'double', 'lv', 'double']), 'counterdraftdamewort': ([], ['float', 'letohl', 'letohl', 'float', 'lv', 'letohs', 'ntohll', 'double', 'ntohll', 'double', 'letohll']), 'yawpwoodwax': ([], ['lv', 'byte', 'ntohs', 'ntohll', 'float', 'letohl', 'float', 'letohs', 'ntohll', 'lv', 'double', 'byte', 'letohl', 'letohl', 'lv', 'float', 'letohs', 'float', 'ntohll', 'ntohs', 'ntohll', 'ntohs', 'ntohl', 'letohs', 'letohs', 'ntohs', 'letohl', 'letohll', 'float', 'lv', 'double', 'string', 'letohs', 'string', 'lv']), 'semiduplexskirt': (['etioporphyrinpubovesical', 'overhollowescort', 'collationdissuasively', 'intrathoraciccoemployment', 'Piscataqualagoonal', 'cancelationZoochlorella', 'paleobotanyworkpeople', 'asepticallyBernese', 'napalmbrevifoliate', 'stakeholderunforbade', 'dehydrogenizeCambrian', 'surlyreptilferous', 'Vandiemenianwinery', 'strangulableargentamid', 'cylindrarthrosisnonplusation', 'mattapharyngological', 'xenogenesisprenoble', 'pneumodynamicsprimariness', 'subregenthelmeted', 'apioidalNagari', 'maltingsurrection', 'Steganophthalmiagnomic', 'Pamirioversystematic', 'goniometerhexameral', 'bairnlyneocosmic', 'sokarailer', 'sheepkeepingfeedman', 'esophagoplastyrestrainedness', 'counterpotentMetabola', 'opportunisttitlark', 'sacroposteriorveratryl', 'pilchermonaulos', 'epigenesistbisexed', 'asperationoraculousness', 'evaluecystatrophia', 'Triuridalesplagiarism', 'saltlypropugnator', 'crouchingpurebred', 'unconvenedperpetually', 'menialitypreintelligent', 'peccationfoolery', 'malthouseenteralgia', 'superabsurdditremid', 'semicolumnrankly', 'xenopodidtrencherless', 'cesserreichspfennig', 'multicrystallinekeratoglossus', 'unfannedhopperman', 'shortcakeabase', 'blepharanthracosisuncliented', 'subordinationbrachial', 'amlipyrexic', 'Lespedezafuthorc', 'bullswooldraggletail', 'predesignateunderservice', 'cardialgiacontingence', 'semiduplexskirt', 'Orakzaiunsatisfiedly', 'bawcockPicnickian', 'usurperunplannedly', 'woodrowelshrievalty', 'peritrichouslyhepatoflavin', 'carangoidbotryomycotic', 'ornithotomyblackwort', 'tautoousianentente', 'unmistgraffer', 'Bryumextrafocal', 'piskgriff', 'roofprespur', 'Eomecondiscolorate', 'cystocarppapaprelatical', 'prattlersuffumigate', 'symmetricalantimasker', 'weathercockismcustodier', 'barrelmakingparoemia', 'outworthbenevolence', 'wutproamusement', 'hyperneuriasymbolatry', 'hammerkopnegativer', 'cannotdentigerous', 'isuroidunfitly', 'katabolizedermic', 'unreprovedlysprier', 'dermoiddiversifiable', 'ineloquentundishonored', 'cassiteritecasemaking', 'carannaaccension', 'loungyimpolite', 'ochronosusafterbody', 'susurrateoutvie', 'dermobranchiataboyardom', 'radiopaqueunrecruitable', 'coeternaloverhonor', 'superestablishmentsuccor', 'tellurethurryproof', 'foliicolousskeletonweed', 'focoidsstackfreed'], ['byte', 'ntohll', 'float', 'ntohs', 'byte', 'letohl', 'nextproto_s', 'byte', 'nextproto_s', 'lv', 'letohl', 'letohl', 'ntohll', 'nextproto_b', 'ntohs', 'ntohl', 'string', 'nextproto_s', 'double', 'ntohs', 'nextproto_b', 'nextproto_s']), 'unstalledneutralism': ([], ['letohl', 'ntohll', 'ntohl', 'float', 'byte', 'ntohs', 'ntohl', 'double', 'letohs', 'ntohl', 'lv', 'letohl']), 'pentaptychBantingism': (['euquinquennium', 'responsivitykimigayo', 'recapitalizerelevate', 'ivoryliketransessentiate', 'sharkletcompactedly', 'parandruspercribration', 'bairnlyneocosmic', 'epexegeticallyreadjournment', 'interimperialvignetter', 'catmalisoncoevally', 'whusslenoreast', 'unoverhauledGalinsoga', 'diseasednessthioantimonate', 'herpetologistindeed', 'Cobitidaedismissal', 'poonghiehectic', 'overganggenesial', 'crouchingpurebred', 'addressorcondensedly', 'reburstsummity', 'reladepropiolaldehyde', 'photocompositioneneuch', 'fetoracclimatement', 'unengravedeosin', 'symptosissubcorneous', 'tautologicpanimmunity', 'wingerconsoler', 'etioporphyrinpubovesical', 'denieragedrapery', 'stickleafethenyl', 'feveretunderbox', 'prattlersuffumigate', 'counterspyingdungeon', 'peerlesslyforetalk', 'bullswooldraggletail', 'archsnoblodgepole', 'surfactantchurchgrith', 'hetericismswayable', 'redifferentiationmustachio', 'Limodorumscrotal', 'refilmopenhandedness', 'spraysemisaprophyte', 'sokarailer', 'awiwimegaloglossia', 'cacuminalgastrohysterorrhaphy', 'udometricpredefault', 'isatogenvestibulum', 'proportionaltasselmaker', 'mataiuntameness', 'indirecthierarchism', 'zeuctocoelomicmetapodial', 'cicisbeismGonystylus', 'Bharatadomain', 'doubleheartedstaphylolysin', 'unhittabledoublehorned', 'volubilityThuidium', 'zincotypetripodic', 'asepticallyBernese', 'strangulableargentamid', 'cantingnesstideful', 'ettleoptimize', 'tellurethurryproof', 'chaffererunheaded', 'skilderprothalline', 'semiduplexskirt', 'outfeatvasodilator', 'inquilinecopse', 'cineplastyanonang', 'Sumasslevulosuria', 'focoidsstackfreed', 'ochronosusafterbody', 'dermobranchiataboyardom', 'cancelationZoochlorella', 'correctorSpirochaeta', 'surrenalinconcluding', 'peritrichouslyhepatoflavin', 'mischieveunfomented', 'maternityhomogenetic', 'pellagrosemongrelization', 'acquisitumvaletudinarist', 'multicrystallinekeratoglossus', 'abjudicationunpleading', 'spinthariscopemolybdena', 'maltingsurrection', 'cylindrarthrosisnonplusation', 'remisrepresentationlancet', 'mausoleandecasualize', 'crossboltedasexually'], ['lv', 'float', 'letohl', 'nextproto_b', 'string', 'ntohll', 'float', 'double', 'nextproto_b', 'nextproto_b', 'letohs', 'nextproto_s', 'letohs', 'letohll', 'nextproto_b', 'ntohll', 'nextproto_b', 'nextproto_b', 'ntohs', 'ntohl', 'letohl', 'lv', 'nextproto_s', 'float', 'nextproto_b', 'byte', 'nextproto_s', 'double', 'byte', 'byte', 'string', 'ntohl', 'double']), 'archaeologyapiin': ([], ['letohs', 'double', 'string', 'float', 'lv']), 'homoeomeriametagnathous': (['otogenouschromatographic', 'allegoristerserendite', 'nontechnicalrongeur', 'iridemiabisque', 'provectgastrocolostomy', 'arecolidinehyalodacite', 'OrleansSchedius'], ['nextproto_b', 'nextproto_s', 'letohl', 'string', 'letohs', 'byte', 'letohs', 'ntohs', 'ntohl', 'byte', 'double', 'letohl', 'letohs', 'string', 'ntohs', 'string', 'byte', 'lv', 'string', 'letohll', 'float', 'nextproto_s', 'letohll', 'string', 'ntohll', 'ntohll', 'byte', 'double', 'lv', 'ntohl', 'nextproto_b', 'nextproto_b', 'lv', 'letohll', 'float', 'letohl', 'string', 'byte', 'letohll', 'lv', 'double', 'letohs', 'nextproto_b', 'double', 'letohll']), 'practicelegitimatist': ([], ['ntohs', 'letohs', 'ntohll', 'float', 'letohll', 'byte', 'lv', 'lv', 'letohl', 'letohs', 'double', 'ntohl', 'letohs', 'letohll', 'letohll', 'ntohl', 'string', 'letohll', 'letohl', 'letohs', 'lv', 'ntohll', 'string', 'lv', 'float', 'letohs', 'letohll', 'double', 'ntohs', 'letohll', 'letohll', 'letohs', 'letohs', 'letohs', 'letohs', 'letohs', 'lv', 'letohs', 'ntohll', 'double', 'letohll', 'ntohs']), 'lamellicornousPolygonaceae': ([], ['letohll', 'letohs', 'letohll', 'double', 'letohll', 'letohs', 'ntohl', 'ntohll', 'float', 'ntohll', 'string', 'double', 'letohll', 'letohs', 'double', 'letohll', 'ntohll', 'ntohl', 'ntohs', 'byte', 'lv', 'byte', 'double', 'double', 'lv', 'lv', 'letohll', 'ntohll', 'ntohl', 'ntohs', 'lv', 'ntohl', 'ntohl', 'byte', 'ntohs', 'letohs', 'float', 'string', 'lv']), 'eudaemonisticallyCoccolobis': (['unbeggarbroncholithiasis', 'woodrowelshrievalty', 'outworthbenevolence', 'responsivitykimigayo'], ['string', 'float', 'ntohll', 'lv', 'letohl', 'letohl', 'ntohl', 'nextproto_s', 'double', 'double', 'ntohl', 'letohll', 'nextproto_s', 'letohl', 'float', 'string', 'byte', 'nextproto_s', 'lv', 'float', 'ntohll', 'ntohl', 'lv', 'double', 'letohl', 'byte', 'ntohl', 'nextproto_s', 'lv', 'nextproto_b', 'byte', 'letohs', 'byte', 'double', 'string', 'nextproto_s', 'double', 'nextproto_s', 'lv', 'string', 'letohl', 'ntohl', 'float', 'ntohl']), 'focoidsstackfreed': ([], ['letohll', 'letohl', 'float', 'string', 'lv', 'letohs', 'letohl', 'ntohs', 'byte', 'double', 'ntohll', 'letohll', 'lv']), 'ornithomanticrada': (['Grahamsaloon', 'etioporphyrinpubovesical', 'anomalousparallelinerved', 'pavonatedcozily', 'noniccosmopoietic', 'misputheptarchist', 'pistoleerproexamination', 'clientageshudderingly', 'idioglossiascabble', 'changeablyzoophilitic', 'doubleheartedstaphylolysin', 'xenopodidtrencherless', 'shuttlecockscanmag', 'Abrahamicinordinateness', 'piperitiousreekingly', 'herpetologistindeed', 'subregenthelmeted', 'repolymerizationwesselton', 'tenesmicHymettic', 'cinecameraHydropotes', 'collationdissuasively', 'subcineritiousphrenitic', 'hippocampalscrow', 'previousnessoisin', 'dermoiddiversifiable', 'correctorSpirochaeta', 'ornithotomyblackwort', 'menialitypreintelligent', 'bullswooldraggletail', 'byworkplastid', 'remisrepresentationlancet', 'unstalledneutralism', 'opportunisttitlark', 'steelworkpsychophysiological', 'photocompositioneneuch', 'subcostalbaldmoney', 'plurifacialmicrographical', 'isuroidunfitly', 'Proteroglyphapiezoelectric', 'asteamincandescency', 'barrelmakingparoemia', 'stomagringo', 'springlikemonosymmetrically', 'ureterorrhagiahemogenetic', 'fleaweedprobate', 'gynarchicagedly', 'eudaemonisticallyCoccolobis', 'noggencapitulate', 'woodrowelshrievalty', 'delthyrialGee', 'bombonnefiendhead', 'oversoldafield', 'dissogenyBarney', 'polyspermatouscreationistic'], ['nextproto_s', 'nextproto_b', 'nextproto_b', 'letohs', 'nextproto_s', 'string', 'nextproto_s', 'letohll', 'ntohll', 'byte', 'letohs', 'ntohl']), 'evenworthyharebrain': ([], ['ntohs']), 'cardialgiacontingence': ([], ['ntohl', 'ntohl', 'lv', 'ntohll', 'ntohl', 'letohl', 'byte', 'byte', 'ntohll', 'lv', 'letohl', 'lv', 'float', 'letohll', 'ntohl', 'string']), 'nontechnicalrongeur': (['prebromidicMonopetalae', 'untastedgirllike', 'prosubscriptiontribracteate', 'notwitch', 'udometricpredefault', 'pantomnesiadiporpa', 'gumdiggingsalvarsan', 'nontechnicalrongeur', 'radiopaqueunrecruitable', 'Robenhausianreboil', 'volubilityThuidium', 'organosiliconsegmentary', 'esophagoplastyrestrainedness', 'photoheliographoctuplicate', 'sulfureasupertramp', 'strainedlypsychopompos', 'prattlersuffumigate', 'reladepropiolaldehyde', 'mischieveunfomented', 'xiphosternamedia', 'ecclesiaLatinization', 'grammaticismmignonette', 'venomouslypilferment', 'spadelikemassacrer', 'wingerconsoler', 'euquinquennium', 'tenesmicHymettic', 'pyrroylprobity', 'popeyednaphtha', 'steelworkpsychophysiological', 'dissogenyBarney', 'unoverhauledGalinsoga', 'semicolumnrankly', 'diseasednessthioantimonate', 'laparotomycephalohumeralis', 'nonadjustmentwritmaking', 'mausoleandecasualize', 'surfactantchurchgrith', 'kleenebocJungermannia', 'dehydrogenizeCambrian', 'gatewiseunderpot', 'Stromatoporoideabarry', 'catagmaticMegalosaurus', 'bumblefooticonology', 'oversolicitouslyhour', 'unmistgraffer', 'plurifacialmicrographical', 'multicrystallinekeratoglossus', 'terrazzododder', 'misspellquinaldic', 'interimperialvignetter', 'mattapharyngological', 'allegoristerserendite', 'Brandipriestcraft', 'ornithomanticrada', 'clientageshudderingly', 'listeningBroussonetia', 'appendiceunmetaled', 'unaccuracyblepharoadenitis', 'clinandriabryologist', 'unbeggarbroncholithiasis', 'maltingsurrection', 'Ternstroemiaanisostomous', 'prelanguagecloudage', 'avalanchestylopization', 'dihedronsubcircuit', 'epigenesistbisexed', 'photocompositioneneuch', 'lepidodendridcounterplead', 'unsanctioningperiuvular', 'epistlarcystoid', 'Sonjapylorogastrectomy', 'Jesperyearlong', 'ochronosusafterbody', 'stagemansupa', 'imperializetrispaston', 'arnberrydodecadrachm', 'arecolidinehyalodacite', 'ornithotomyblackwort', 'coeternaloverhonor', 'predestinarianglia', 'micrencephalypalpus', 'bawcockPicnickian', 'Suionesunprejudicially', 'interventraliaforeutter', 'bustedpredoubter', 'docimasytrouserdom', 'Carpathianmetanephron', 'sokarailer', 'semiduplexskirt', 'meddlingsmall', 'unpaintterebinic', 'androgynyvegetoalkaline', 'fetoracclimatement', 'subrigidlithophysal', 'zeuctocoelomicmetapodial', 'unrevenuedindecorousness', 'fillmetroptosis'], ['letohll', 'lv', 'ntohl', 'string', 'ntohl', 'nextproto_b', 'ntohl', 'ntohl', 'lv', 'byte', 'ntohll', 'float', 'letohll']), 'shellycoatcallousness': (['untuckedsolenoglyphic', 'seminegroSemiticize', 'avalanchestylopization', 'prizeexcrescence', 'cancelationZoochlorella', 'parathyroidectomizeoutheart', 'weathercockismcustodier', 'hanginglypoethood', 'hematozoalinfinitarily', 'unpaintterebinic', 'triquetricinfrasternal', 'appendiceunmetaled', 'redifferentiationmustachio', 'carcerationinterrenal', 'shellycoatcallousness', 'sulfureasupertramp', 'overcriticalnesslovableness', 'coxbonesbirle', 'Anglomaniaclovableness', 'miningFlavia', 'butterrootchagrin', 'cicisbeismGonystylus', 'declamatorinessSerrifera', 'ralphautonomically', 'disaffectedanchorite', 'perukiershiplexicographer'], ['double', 'ntohl', 'double', 'ntohll', 'ntohll', 'letohs', 'ntohs', 'letohs', 'string', 'letohl', 'ntohll', 'string', 'letohll', 'string', 'string', 'letohll', 'ntohll', 'nextproto_s', 'letohs', 'byte', 'letohll', 'float', 'ntohll', 'letohll', 'letohs', 'nextproto_s', 'letohll', 'string']), 'araguatolucinoid': (['cephaloconicunbaptized', 'euquinquennium', 'iconismanisostemonous', 'pilchermonaulos', 'membershiptownsboy', 'byworkplastid', 'whillyunbet', 'Spongiaealcelaphine', 'paleobotanyworkpeople', 'gatewiseunderpot', 'ralphautonomically', 'woodrowelshrievalty', 'Ciceronicpownie', 'falsificationcomer', 'tonguinessresoundingly', 'gemeledAdonai', 'araguatolucinoid', 'Proteroglyphapiezoelectric', 'valvotomypensionably', 'tuchunateacademization', 'Actiniomorphaquartzic', 'unarrayapparitor', 'subsorterbecuffed', 'rhynchophoranunwinking', 'monodromiclyretail', 'retickettopotaxis', 'sleekgavelock', 'slichtarradiddler', 'bullswooldraggletail', 'thiodiphenylaminediterpene', 'gumdiggingsalvarsan', 'abjudicationunpleading', 'irreclaimableconjugally', 'Rodolphhumuslike', 'syngraphstaminiferous', 'overkneePolypoda', 'parorchispalingenic', 'respitelesssuccenturiation', 'photoheliographoctuplicate', 'loketprincipiate', 'scruplercellulifugal', 'chiliasticskean', 'Oliveanpyromancer', 'strangulableargentamid', 'Tdapproximatively', 'buttonholerindigestive', 'Trinorantumpyramides', 'docimasytrouserdom', 'sowbackgastrotrichan', 'otogenouschromatographic', 'ramraceBorderies', 'lobectomypreinflection', 'triseriallypreaccess', 'counterdraftdamewort', 'petalocerouscamus', 'uxoriouslyelectrotechnic', 'dominionistversableness', 'dracontiasisinterparliamentary', 'simpletonianreformulate', 'burgonetcarefully', 'paralyzerthiocarbimide', 'undercovertcoloss', 'galimatiasphacocystectomy', 'clinandriabryologist'], ['letohl', 'letohl', 'ntohll', 'letohs', 'ntohs', 'nextproto_b', 'ntohll', 'letohll', 'float', 'ntohll', 'nextproto_b', 'nextproto_b', 'nextproto_b', 'ntohll', 'ntohl', 'ntohll', 'nextproto_b', 'byte', 'float', 'double', 'letohs', 'byte', 'ntohll', 'float', 'string']), 'peerlesslyforetalk': (['percontationMaimonist', 'androgynyvegetoalkaline', 'yoreexponent', 'Stromatoporoideabarry', 'faddyamputational', 'Vandiemenianwinery', 'cinecameraHydropotes', 'parathyroidectomizeoutheart'], ['double', 'ntohs', 'lv', 'string', 'letohs', 'ntohs', 'letohs', 'ntohl', 'letohll', 'letohs', 'lv', 'letohs', 'string', 'nextproto_s', 'ntohs', 'string', 'letohs', 'string', 'float', 'lv', 'byte', 'ntohl', 'ntohl', 'ntohs', 'letohl', 'nextproto_s', 'lv', 'letohs', 'byte', 'double']), 'dextrosinistralElaeococca': ([], ['ntohs', 'letohl', 'ntohl', 'ntohl', 'letohs', 'ntohll', 'string', 'string', 'double', 'letohl', 'float', 'ntohs', 'string', 'letohll', 'ntohll', 'letohl', 'letohl', 'letohll', 'ntohl', 'double', 'letohll', 'double', 'ntohl', 'ntohl', 'letohll', 'float', 'letohs', 'string', 'ntohs', 'double', 'string', 'byte', 'ntohs']), 'etherifyCicadidae': ([], ['ntohl', 'lv', 'ntohs']), 'unmonarchicalnourishment': (['Orakzaiunsatisfiedly', 'phlebectomySiam', 'buttonholerindigestive', 'haversinepitaya', 'sokarailer', 'bawcockPicnickian', 'isatogenvestibulum', 'warneriodocasein', 'subordinationbrachial', 'ureterorrhagiahemogenetic', 'responsivitykimigayo', 'tuchunateacademization', 'epexegeticallyreadjournment', 'insidiouslysurplicewise', 'cycloolefinmonostylous', 'Philonismpinivorous', 'correctorSpirochaeta', 'domanialPhora', 'teleophoreunspinsterlike', 'northwestwardpassementerie', 'warfaringdraghound', 'poonghiehectic', 'vareisogeothermic', 'previousnessoisin', 'Eurypteroideachamaeprosopic', 'repolymerizationwesselton', 'plurifacialmicrographical', 'prehexameraldissyllabize', 'agoraphobiaLenzites', 'xenogenesisprenoble', 'radomenetherwards', 'cantingnesstideful', 'Sarothrawrencher', 'roofprespur', 'refallGanguela', 'uncomminutedcommix', 'amaranthoidunpulleyed'], ['lv', 'lv', 'letohl', 'letohs', 'float', 'ntohl', 'float', 'byte', 'float', 'ntohl', 'double', 'ntohl', 'ntohll', 'double', 'letohll', 'double', 'letohll', 'nextproto_b', 'letohl', 'letohll', 'letohl', 'letohs', 'nextproto_b', 'string', 'ntohs', 'lv']), 'antleredadunc': ([], ['string', 'letohl', 'ntohs', 'ntohs', 'byte', 'ntohl', 'string', 'float', 'letohs', 'ntohl', 'string', 'letohs', 'float', 'double', 'float', 'letohs', 'ntohs', 'ntohl', 'ntohll', 'byte', 'byte', 'ntohl', 'letohll', 'byte', 'letohll', 'ntohl']), 'arecolidinehyalodacite': (['barrelmakingparoemia', 'overpoliticunderlooker', 'blepharanthracosisuncliented', 'Oliveanpyromancer', 'tenodesisunroaming', 'indirecthierarchism', 'Grahamsaloon', 'reburstsummity', 'engrossedlyDinoceras', 'misadministrationbroody', 'depositoryteloblastic', 'reladepropiolaldehyde', 'vibrativeoversail', 'whusslenoreast', 'percontationMaimonist', 'cinecameraHydropotes', 'outfeatvasodilator', 'gumdiggingsalvarsan', 'subsorterbecuffed', 'predefinitionCarnaria', 'warneriodocasein', 'Brandipriestcraft', 'picayunishapogeotropic', 'malthouseenteralgia', 'denieragedrapery', 'Slovenerecure', 'hemianacusiadouble', 'stickleafethenyl', 'Tullianrubidium', 'doubleheartedstaphylolysin', 'photocompositioneneuch', 'epexegeticallyreadjournment', 'interventraliaforeutter', 'isuroidunfitly', 'correctorSpirochaeta', 'schuleclethraceous', 'Philoctetessupersalesman', 'misproduceunthrilled', 'organoantimonypreoperator', 'genipacombiner', 'summarizationyatter', 'shuttlecockscanmag', 'Carpathianmetanephron', 'Plymouthistnashgab', 'counterpotentMetabola', 'focoidsstackfreed', 'unexchangedsupraventricular', 'slichtarradiddler', 'steelworkpsychophysiological', 'scutcheonwiseileocolitis', 'ruinlikesilva', 'clientageshudderingly', 'dihedronsubcircuit', 'unreprovedlysprier', 'outworthbenevolence', 'veldcraftsubprefect'], ['ntohs', 'ntohll', 'ntohl', 'string', 'letohl', 'float', 'letohl', 'ntohl', 'nextproto_s', 'double', 'string', 'lv', 'lv', 'letohll', 'letohl', 'string', 'string', 'letohs', 'nextproto_s', 'letohl', 'float', 'ntohll', 'double', 'letohl', 'letohs', 'ntohl', 'ntohl', 'ntohll', 'string']), 'importationPerisphinctidae': ([], ['lv', 'ntohll', 'lv', 'byte', 'letohs', 'letohll', 'lv', 'double', 'lv', 'letohll', 'letohs', 'letohs', 'ntohll', 'string', 'float', 'string', 'letohs', 'ntohl', 'ntohll', 'letohl']), 'Anchtheriumunastonish': (['xenogenesisprenoble', 'outlawrypervertedness', 'lungflowerhorrormonger', 'retroclusionmetaphysicianism', 'peerlesslyforetalk', 'lindengamy', 'proportionaltasselmaker', 'Ternstroemiaanisostomous', 'frontomallarforedetermine', 'asperationoraculousness', 'dextrosinistralElaeococca', 'vibrativeoversail', 'abjudicationunpleading', 'pinkberrynonvillainous', 'pyrroylprobity', 'palatableJonesian', 'blossomscrimshander', 'chaffererunheaded', 'untastedgirllike', 'saltlypropugnator', 'tauromachyoutgive', 'unusehydroponist', 'terrazzododder', 'archsnoblodgepole', 'interimperialvignetter', 'genipacombiner', 'catafalquedree', 'pedestrianateStromateidae', 'nasicornousfasciated', 'evenworthyharebrain', 'erythriticsynergidal', 'recapitalizationdissipative', 'burgonetcarefully', 'togueseaflower', 'ureterorrhagiahemogenetic', 'semicolumnrankly', 'preservatizeskyphoi', 'graphologicautovaccination', 'turbidlycorticoefferent', 'Senecanovercorruptly', 'stagemansupa', 'spinthariscopiclieutenancy', 'fillmetroptosis', 'disjointedlytriamylose', 'pegologyscavenage', 'docimasytrouserdom', 'bronchiaunbaffling', 'onomatopoeiaeggfish', 'Sarothrawrencher', 'mediumismgypsyism', 'cardinghygeistic', 'misproduceunthrilled', 'Larinaecoydog', 'opportunisttitlark'], []), 'dachshundpuddly': ([], ['letohll', 'letohl', 'string', 'letohll', 'letohs', 'double', 'letohll', 'ntohll', 'ntohll', 'lv', 'lv', 'lv', 'lv', 'letohs']), 'utterabilitypavement': ([], ['ntohs', 'float', 'string', 'letohs', 'double', 'letohs', 'byte', 'letohs', 'letohl', 'ntohll', 'letohs', 'float', 'double', 'ntohs', 'ntohl', 'ntohl', 'ntohl', 'letohl', 'letohs', 'letohs', 'ntohl', 'byte', 'ntohl', 'float', 'ntohs', 'double', 'byte', 'letohs', 'letohll', 'float', 'letohs', 'float']), 'misadministrationbroody': (['whusslenoreast', 'Stromatoporoideabarry', 'unhittabledoublehorned', 'fleaweedprobate', 'woodrowelshrievalty', 'katabolizedermic', 'hetericismswayable', 'barrelmakingparoemia', 'overgenialitybuzzle', 'Fichteanismconjobble', 'ornithotomyblackwort', 'udometricpredefault', 'malthouseenteralgia', 'cacuminalgastrohysterorrhaphy', 'amlipyrexic', 'Philonismpinivorous', 'dermobranchiataboyardom', 'Oliveanpyromancer', 'mataiuntameness', 'cerebroidodontolcate'], ['letohl', 'byte', 'ntohl', 'nextproto_s', 'nextproto_b', 'letohll', 'letohl', 'letohl', 'nextproto_s', 'ntohll', 'ntohll', 'string', 'ntohll', 'ntohll', 'ntohll', 'byte', 'double', 'ntohs', 'lv', 'byte', 'letohl', 'letohll', 'nextproto_b', 'lv', 'ntohs', 'double', 'ntohs', 'lv', 'double', 'string', 'ntohll', 'ntohl', 'ntohl', 'double', 'letohs', 'nextproto_b', 'lv', 'ntohl', 'ntohs', 'ntohs', 'nextproto_s', 'lv', 'float']), 'Aparaipsychiatrist': ([], ['ntohll', 'double', 'ntohll', 'lv', 'ntohs', 'string', 'ntohll', 'ntohll', 'letohs', 'double', 'float', 'ntohl', 'string']), 'cardinghygeistic': (['paralyzerthiocarbimide', 'preinjuryduplicature', 'usurperunplannedly', 'organoantimonypreoperator', 'superestablishmentsuccor', 'foliicolousskeletonweed', 'focoidsstackfreed', 'ruinlikesilva', 'refilmopenhandedness', 'previousnessoisin', 'amlipyrexic', 'stakeholderunforbade', 'herpetologistindeed', 'reshoedrachmae', 'repolymerizationwesselton', 'cantingnesstideful', 'noniccosmopoietic', 'apioidalNagari', 'noggencapitulate', 'wutproamusement', 'iconismanisostemonous', 'avalanchestylopization', 'bombonnefiendhead', 'codeinesalience', 'dissogenyBarney', 'surlyreptilferous', 'carannaaccension', 'gatewiseunderpot', 'channelizeungarter', 'thysanuriformcrossrail', 'ettleoptimize', 'grapedmassively', 'Bryumextrafocal', 'cosilybridecake', 'Eomecondiscolorate', 'denieragedrapery', 'hookahsupersimplicity', 'loungyimpolite', 'nonadjustmentwritmaking', 'Alalamenispermine', 'cystocarppapaprelatical', 'oxmanoutpull', 'hypoplasyhooping', 'domanialPhora', 'Grahamsaloon', 'reladepropiolaldehyde', 'erythriticsynergidal', 'unmistgraffer', 'subsoilercruent', 'extravagantkaryoplasmatic', 'endogalvanismunwarrantedly', 'responsivitykimigayo', 'Lespedezafuthorc', 'buttonholerindigestive', 'prizeexcrescence', 'querulouslycooky', 'stagemansupa', 'sokarailer', 'dermoiddiversifiable', 'arecolidinehyalodacite', 'spadelikemassacrer', 'galledisocinchomeronic', 'uncomminutedcommix', 'proportionaltasselmaker', 'menialitypreintelligent', 'schuleclethraceous', 'doubleheartedstaphylolysin', 'flashpanstature', 'pedestrianateStromateidae', 'listeningBroussonetia', 'metatitanatetarente', 'cardialgiacontingence'], ['byte', 'ntohs', 'ntohl', 'byte', 'letohll', 'letohll', 'ntohll', 'ntohll', 'byte', 'float', 'nextproto_s', 'ntohl', 'nextproto_s', 'nextproto_s', 'nextproto_s', 'ntohl', 'letohl', 'string', 'letohll', 'ntohs', 'lv', 'ntohs', 'ntohll', 'letohl', 'float', 'lv', 'double', 'byte', 'string', 'float', 'double', 'letohl', 'byte', 'nextproto_b', 'ntohl', 'letohll', 'double', 'ntohl', 'ntohs', 'ntohs', 'byte', 'nextproto_b', 'nextproto_b', 'letohl', 'letohll', 'letohl', 'string']), 'cynophileLobale': ([], ['ntohl', 'string', 'lv', 'letohll', 'lv', 'ntohl', 'letohl', 'lv', 'ntohs', 'letohs', 'lv', 'byte', 'letohs', 'letohs', 'ntohs', 'double', 'ntohll', 'byte', 'string', 'ntohl', 'ntohl', 'string', 'ntohs', 'ntohs', 'letohs', 'ntohs', 'letohll', 'lv', 'string', 'float', 'ntohll', 'letohs', 'letohs', 'double', 'lv', 'lv', 'double', 'letohll', 'byte', 'ntohs', 'string', 'letohs', 'letohl']), 'prosubscriptiontribracteate': (['imperializetrispaston', 'carcerationinterrenal', 'channelizeungarter', 'shuttlecockscanmag', 'woodrowelshrievalty', 'vaporizetannery', 'extravagantkaryoplasmatic', 'unmistgraffer', 'sageshipcarcoon', 'untastedgirllike', 'cycloolefinmonostylous', 'OrleansSchedius', 'bullswooldraggletail', 'fetoracclimatement', 'unoverhauledGalinsoga', 'Plymouthistnashgab', 'unexchangedsupraventricular', 'clientageshudderingly', 'strangulableargentamid', 'Lespedezafuthorc', 'Piscataqualagoonal', 'apioidalNagari', 'interventraliaforeutter', 'spadelikemassacrer', 'lepidodendridcounterplead', 'focoidsstackfreed', 'bairnlyneocosmic', 'collationdissuasively', 'asepticallyBernese', 'surlyreptilferous', 'Brandipriestcraft', 'refilmopenhandedness', 'cantingnesstideful', 'heliconbonnetman'], ['float', 'ntohll', 'nextproto_b', 'double', 'nextproto_b']), 'unengravedeosin': ([], ['double', 'letohs', 'byte', 'letohl', 'string', 'double', 'lv', 'ntohll', 'ntohl', 'lv', 'ntohl', 'letohl', 'letohs', 'letohl', 'letohll', 'byte', 'letohll', 'float', 'lv', 'letohs', 'double', 'ntohll', 'letohl', 'lv', 'float', 'letohll', 'ntohs', 'double', 'letohll', 'double', 'byte', 'ntohl', 'letohs']), 'vivifybenefactorship': (['burgonetcarefully', 'untuckedsolenoglyphic', 'ineloquentundishonored', 'lamellicornousPolygonaceae', 'engrossedlyDinoceras', 'peccationfoolery', 'subordinationbrachial', 'androgynyvegetoalkaline', 'schuleclethraceous', 'raspberrylikesubvertebral', 'Fichteanismconjobble', 'bacteriformpiercel', 'maltingsurrection', 'polyspermatouscreationistic', 'trentepohliaceousHectorean', 'prosubscriptiontribracteate', 'apioidalNagari', 'blepharanthracosisuncliented', 'steinkirkmisaffection', 'barrelmakingparoemia', 'strangulableargentamid', 'certainarchpontiff', 'photocompositioneneuch', 'prizeexcrescence', 'ornithomanticrada', 'heliconbonnetman', 'cerebroidodontolcate', 'tollgateandrophagous', 'butterrootchagrin', 'unsanctioningperiuvular', 'repolymerizationwesselton', 'overganggenesial', 'cassiteritecasemaking', 'napalmbrevifoliate'], ['ntohll', 'letohl', 'nextproto_s', 'lv', 'string', 'letohs', 'nextproto_b', 'ntohl', 'ntohs', 'letohl', 'double', 'letohs', 'ntohl', 'letohl', 'ntohl', 'ntohll', 'letohl', 'letohs', 'ntohll', 'letohl', 'byte', 'letohl', 'nextproto_b', 'string', 'letohl', 'double']), 'provectgastrocolostomy': ([], ['ntohl', 'byte', 'byte', 'ntohll', 'letohs', 'lv', 'lv', 'ntohs', 'ntohs', 'letohl', 'letohs', 'letohl', 'string', 'ntohl']), 'querulouslycooky': ([], ['lv', 'ntohl', 'float', 'string', 'lv', 'letohll', 'string', 'ntohs', 'lv', 'float', 'byte', 'ntohll', 'double', 'ntohl', 'lv', 'ntohl', 'letohll', 'float', 'ntohs', 'byte', 'letohl', 'double', 'letohll', 'ntohll', 'ntohll', 'ntohll', 'ntohs', 'letohll', 'ntohl', 'string', 'ntohs', 'ntohll', 'ntohl', 'string', 'float']), 'unmensurableSoohong': ([], ['lv', 'ntohs', 'string', 'ntohl', 'letohll', 'ntohl', 'letohl', 'ntohs', 'ntohll', 'letohs', 'ntohl', 'ntohl', 'letohl', 'letohll', 'letohl', 'lv', 'string', 'letohl', 'lv', 'double', 'letohll', 'float', 'lv', 'byte', 'ntohll', 'lv', 'float', 'ntohl', 'letohs', 'letohl', 'ntohl', 'lv', 'letohs', 'letohs', 'ntohll']), 'responsivitykimigayo': (['cannotdentigerous', 'asepticallyBernese', 'overgenialitybuzzle', 'grapedmassively', 'hyperneuriasymbolatry', 'dissogenyBarney', 'doubleheartedstaphylolysin', 'addressorcondensedly', 'weathercockismcustodier', 'cacuminalgastrohysterorrhaphy', 'tellurethurryproof', 'pellagrosemongrelization', 'saltlypropugnator', 'arhatsporozoic', 'usurperunplannedly', 'countryfolkintolerance', 'veldcraftsubprefect', 'hyperduliaferrateen', 'parandruspercribration', 'monodromiclyretail', 'clientageshudderingly', 'Tullianrubidium', 'unhittabledoublehorned', 'semicolumnrankly', 'imperializetrispaston', 'indirecthierarchism', 'scutcheonwiseileocolitis', 'superabsurdditremid', 'summarizationyatter', 'symptosissubcorneous', 'multicrystallinekeratoglossus'], ['string', 'lv', 'byte', 'double', 'letohs', 'nextproto_b', 'nextproto_s', 'byte', 'nextproto_b', 'double', 'lv', 'float', 'letohs', 'ntohll', 'ntohll', 'float', 'byte', 'lv', 'nextproto_s', 'ntohs', 'nextproto_b', 'letohll', 'byte', 'nextproto_s', 'letohll', 'letohl', 'string', 'nextproto_s', 'byte', 'nextproto_s', 'letohl', 'lv', 'lv', 'string']), 'clinandriabryologist': ([], ['double', 'letohs', 'byte', 'letohl', 'ntohs', 'string', 'letohs', 'ntohl', 'byte', 'letohll', 'letohll', 'letohl', 'byte', 'ntohll', 'string', 'lv', 'byte', 'double', 'lv', 'double']), 'parenterallyincitement': ([], ['ntohl', 'lv', 'letohll', 'float', 'string', 'letohs', 'letohll', 'lv', 'letohs', 'ntohl', 'letohll', 'string', 'ntohs', 'double', 'string']), 'cystocarppapaprelatical': (['ornithotomyblackwort'], ['ntohll', 'nextproto_s', 'double', 'lv', 'float', 'letohs', 'ntohl', 'ntohl', 'nextproto_b', 'lv', 'ntohl', 'ntohs', 'letohll', 'byte', 'ntohs', 'ntohll', 'nextproto_s', 'byte', 'nextproto_s', 'letohl', 'byte', 'byte', 'ntohll', 'letohll', 'ntohll', 'ntohs', 'byte', 'ntohll', 'lv', 'letohl', 'ntohs', 'letohll']), 'notwitch': ([], ['ntohl', 'string', 'double', 'nextproto_b', 'letohll', 'byte', 'ntohll', 'byte', 'string', 'byte', 'nextproto_b', 'string', 'string', 'double']), 'cicisbeismGonystylus': ([], ['float', 'letohl', 'ntohll', 'letohl', 'lv', 'byte', 'double', 'ntohll', 'byte', 'byte', 'lv', 'letohll', 'ntohll']), 'porencephalonpostplegic': ([], ['float', 'letohs', 'lv', 'ntohl', 'letohl', 'letohl', 'ntohl', 'letohs', 'double', 'ntohs', 'ntohs', 'ntohll', 'letohl', 'letohs', 'float', 'byte', 'ntohll', 'ntohs', 'ntohll', 'ntohll', 'ntohl', 'ntohs', 'letohll', 'float', 'ntohl', 'string', 'float', 'string', 'ntohs', 'float', 'letohs', 'letohs', 'float', 'double', 'string', 'letohll', 'ntohll']), 'cancelationZoochlorella': ([], ['ntohs', 'ntohs', 'letohl', 'ntohl', 'letohs', 'letohl', 'letohll', 'letohs', 'byte', 'float', 'ntohs', 'float', 'ntohll', 'ntohll', 'lv', 'ntohl', 'double', 'ntohl', 'letohs']), 'cognaticalintransmissible': ([], ['ntohll', 'double', 'letohl', 'byte', 'ntohll', 'double', 'lv', 'byte', 'letohs', 'letohl', 'double', 'ntohl', 'letohll', 'ntohll', 'letohs', 'lv', 'double', 'float', 'ntohs']), 'galvanothermometerBalzacian': ([], ['byte', 'ntohl', 'string', 'lv', 'byte', 'letohll', 'byte', 'letohs', 'lv', 'ntohll', 'byte', 'letohl', 'lv', 'letohs', 'float', 'string', 'byte', 'lv', 'letohs', 'byte', 'lv', 'string', 'double', 'byte', 'ntohll', 'letohll', 'double', 'letohll']), 'bustedpredoubter': ([], ['ntohl', 'letohs', 'ntohll', 'letohs', 'lv', 'letohs', 'ntohs', 'string']), 'creditiveplatonesque': ([], ['lv', 'lv', 'byte', 'letohll', 'lv', 'ntohs', 'byte', 'ntohl', 'string', 'letohl', 'letohs', 'letohl', 'ntohll', 'ntohs', 'letohl', 'letohl', 'lv', 'byte', 'float', 'lv', 'double', 'string', 'lv', 'ntohs', 'letohs', 'ntohl', 'ntohs', 'ntohs', 'lv', 'ntohll', 'ntohs', 'lv', 'lv', 'ntohl', 'ntohl', 'ntohs', 'ntohl', 'string', 'letohs', 'ntohs']), 'membershiptownsboy': ([], ['byte', 'lv', 'letohl', 'ntohs', 'ntohs', 'lv', 'ntohll', 'ntohl', 'string']), 'cleansingpentahedral': (['gymnosporouswoubit', 'pentaptychBantingism', 'limsypersistence', 'sagaiebarrister', 'countryfolkintolerance', 'undercovertcoloss', 'munjmuchness', 'sulphhemoglobinHerculanean', 'ramraceBorderies', 'multicrystallinekeratoglossus', 'docimasytrouserdom', 'nasicornousfasciated', 'goniometerhexameral', 'polyspermatouscreationistic', 'Sonjapylorogastrectomy', 'splanchnopleureprelapsarian', 'maternityhomogenetic', 'syphilologyannularity', 'provectgastrocolostomy', 'Eomecondiscolorate', 'Eurypteroideachamaeprosopic', 'ankylenterongreenfish', 'Piscataqualagoonal'], ['ntohs', 'lv', 'letohs', 'lv', 'lv', 'ntohs', 'double', 'letohl', 'ntohs', 'lv', 'double', 'letohll', 'double', 'string', 'ntohl']), 'cineplastyanonang': (['Tullianrubidium', 'sageshipcarcoon', 'maltingsurrection', 'menialitypreintelligent', 'susurrateoutvie', 'doubleheartedstaphylolysin', 'Opisthocomidaeheterochiral', 'bairnlyneocosmic', 'ambisyllabicfruitful', 'fleaweedprobate', 'gumdiggingsalvarsan', 'overpoliticunderlooker', 'Lespedezafuthorc', 'prelanguagecloudage', 'strangulableargentamid', 'anomalousparallelinerved', 'herpetologistindeed', 'Philoctetessupersalesman', 'bullswooldraggletail', 'Stromatoporoideabarry', 'sacroposteriorveratryl', 'declamatorinessSerrifera', 'precoxseambiter', 'noggencapitulate', 'slichtarradiddler', 'previousnessoisin', 'unmistgraffer', 'peccationfoolery', 'unlasheddialyzable', 'Sarothrawrencher', 'acclaimerilluminability', 'asperationoraculousness', 'carcerationinterrenal', 'pavonatedcozily', 'cardialgiacontingence', 'tenesmicHymettic', 'correctorSpirochaeta', 'recapitalizationdissipative', 'uncomminutedcommix', 'ureterorrhagiahemogenetic', 'ricketssubtrihedral', 'unhittabledoublehorned', 'barrelmakingparoemia', 'Erotylidaeprehesitate', 'engrossedlyDinoceras', 'laparotomycephalohumeralis', 'cineplastyanonang', 'Mayorunahybridizer', 'weathercockismcustodier', 'shortcakeabase', 'mattapharyngological', 'lepidodendridcounterplead', 'loungyimpolite', 'Triuridalesplagiarism', 'Bryumextrafocal', 'carannaaccension', 'spadelikemassacrer', 'hemianacusiadouble', 'yawpwoodwax', 'interventraliaforeutter', 'laterodeviationNarciss', 'antleredadunc', 'unreprovedlysprier', 'unoverhauledGalinsoga', 'etioporphyrinpubovesical', 'epexegeticallyreadjournment', 'tollgateandrophagous', 'symptosissubcorneous', 'prattlersuffumigate', 'dermobranchiataboyardom'], ['string', 'letohll', 'ntohll', 'letohll', 'letohs', 'nextproto_s', 'byte', 'lv', 'byte', 'ntohl', 'byte', 'letohs', 'float', 'ntohll', 'ntohll', 'byte', 'letohs', 'letohs', 'double', 'letohl', 'float']), 'uniquityrobotism': (['dejectedincreasing', 'echinostomewont', 'evenworthyharebrain', 'gratifyinglymetrorrhea', 'balandracaducibranch', 'indirecthierarchism', 'subrigidlithophysal', 'byworkplastid', 'Sumasslevulosuria', 'retroclusionmetaphysicianism', 'undercropArenga', 'Slovenerecure', 'Moorshipspermatova', 'vibrativeoversail', 'blepharanthracosisuncliented', 'cephaloconicunbaptized', 'chromophilouspyometra', 'Piscataqualagoonal', 'pensefulnessdrought', 'cacuminalgastrohysterorrhaphy'], ['ntohll', 'byte', 'nextproto_b', 'double', 'ntohll', 'float', 'letohll', 'byte', 'letohl', 'lv', 'letohll', 'letohs', 'float', 'nextproto_s', 'lv', 'ntohl', 'letohll', 'byte', 'float', 'letohll', 'string', 'float', 'nextproto_s', 'nextproto_s', 'nextproto_s', 'nextproto_b', 'letohs', 'double', 'ntohll', 'nextproto_s', 'letohll', 'lv', 'byte', 'lv', 'lv', 'float', 'nextproto_s', 'lv', 'lv', 'byte', 'lv']), 'outsumunrefusingly': (['overdiligentlyrifleshot', 'esophagoplastyrestrainedness', 'micrencephalypalpus', 'focoidsstackfreed', 'hemianacusiadouble', 'Chilopsiscompactible', 'tartishlynarcotical', 'Robenhausianreboil', 'Suionesunprejudicially', 'diseasednessthioantimonate', 'meddlingsmall', 'Momotinaenonfortification', 'unscalednessChamaeleon', 'congregationalvocimotor', 'intercoolingpotentialization', 'overfretdisenthronement', 'Orakzaiunsatisfiedly', 'tumultuouslymammonitish', 'nasicornousfasciated', 'tripartedlyOssetine', 'butyrochloralfertilizational', 'dunneaneuploidy', 'simulcastriboflavin', 'pyroaceticnunciature', 'vivacityOlneya', 'gynarchicagedly', 'vanilleshellburst', 'Negritohydroponicist', 'weathercockismcustodier', 'wingerconsoler', 'Ciceronicpownie', 'hippocampalscrow', 'peerlesslyforetalk', 'Caraipaearcap', 'preinjuryduplicature', 'venomouslypilferment', 'peragratemultifoliate', 'polishedlyhematosis', 'epigenesistbisexed', 'unoverhauledGalinsoga', 'chartermarrowy', 'phenegollocalization', 'Slavophilesedigitate', 'dermobranchiataboyardom', 'Grahamsaloon', 'projicientcolumellate', 'inkfishpoppycock', 'ciderishazury', 'acquisitumvaletudinarist', 'Paridaeamylum', 'Triuridalesplagiarism', 'ricketssubtrihedral', 'evenworthyharebrain', 'symmetricalantimasker', 'Bryumextrafocal', 'prelanguagecloudage', 'erythriticsynergidal', 'misspellquinaldic', 'Steganophthalmiagnomic', 'nonofficeholdingwaldgravine', 'photocompositioneneuch', 'genipacombiner', 'crouchingpurebred', 'gratefulAlcedinidae', 'galledisocinchomeronic', 'correctorSpirochaeta', 'contrarietyinconceivableness', 'iconismanisostemonous', 'heronerchondroplasty', 'unrevenuedindecorousness', 'unimplicitoothecal', 'cattlefolk', 'hanginglypoethood', 'notwitch', 'pinkberrynonvillainous', 'OrleansSchedius', 'terrazzododder', 'coinbellmaker', 'springlikemonosymmetrically', 'dejectedincreasing', 'mattapharyngological', 'scutcheonwiseileocolitis', 'adminiculatephosphosilicate', 'Dokoelectrochemically', 'Stromatoporoideabarry', 'balandracaducibranch', 'acanthopterygianMuranese', 'bombonnefiendhead', 'previousnessoisin', 'nowhitoffscape', 'maternityhomogenetic', 'prattlersuffumigate', 'lobectomypreinflection', 'gratifyinglymetrorrhea'], ['ntohs', 'string', 'letohll', 'lv', 'letohll', 'float', 'nextproto_s', 'byte', 'float', 'string', 'ntohll', 'ntohl', 'letohll', 'string', 'byte', 'letohs', 'ntohs', 'letohs', 'ntohll', 'double', 'ntohl', 'letohs', 'letohs', 'nextproto_s', 'float', 'ntohs', 'double', 'letohl', 'letohl', 'letohs', 'lv', 'letohll', 'lv', 'ntohll', 'ntohl', 'lv', 'float', 'letohs', 'letohl', 'double', 'nextproto_b', 'ntohs', 'letohl', 'float', 'letohl', 'letohs', 'letohll', 'double', 'letohl', 'letohll']), 'tongueshoticonophilism': ([], ['lv', 'letohs', 'letohs', 'float', 'byte', 'lv', 'lv', 'string', 'string', 'string', 'ntohs', 'ntohll', 'float', 'lv', 'double', 'ntohl', 'float', 'letohll', 'ntohll']), 'overcriticalnesslovableness': ([], ['double', 'ntohs', 'ntohll', 'double']), 'Hetaeristaltimetrical': ([], ['double', 'letohs', 'ntohs', 'ntohs', 'ntohl', 'byte', 'lv', 'ntohl', 'double']), 'graphologicautovaccination': ([], ['ntohl', 'double', 'letohl', 'ntohll', 'letohs', 'letohll', 'letohll', 'double', 'letohll', 'float', 'lv', 'double', 'string', 'ntohl', 'ntohs', 'letohs']), 'nonadjustmentwritmaking': (['xenopodidtrencherless', 'racegoingunperformed', 'outfeatvasodilator', 'Steganophthalmiagnomic', 'Pamirioversystematic', 'cacuminalgastrohysterorrhaphy', 'blepharanthracosisuncliented', 'sheepkeepingfeedman', 'radiopaqueunrecruitable', 'loungyimpolite', 'dehydrogenizeCambrian', 'cardialgiacontingence', 'sacroposteriorveratryl', 'peccationfoolery', 'bairnlyneocosmic', 'multicrystallinekeratoglossus', 'overpoliticunderlooker', 'chytridialgoosemouth', 'carangoidbotryomycotic', 'unbeggarbroncholithiasis', 'xenogenesisprenoble', 'untastedgirllike', 'perukiershiplexicographer', 'unreprovedlysprier', 'carannaaccension', 'unhittabledoublehorned', 'pneumodynamicsprimariness'], ['double', 'ntohs', 'string', 'letohl', 'letohl', 'string', 'ntohl', 'letohl', 'string', 'ntohll', 'ntohl', 'ntohs', 'letohs', 'ntohl', 'ntohl', 'ntohs', 'lv', 'byte', 'byte', 'double', 'letohll', 'ntohl', 'ntohl', 'ntohs', 'string', 'float', 'string', 'nextproto_s', 'letohl', 'letohll', 'ntohs', 'byte']), 'carangoidbotryomycotic': ([], ['lv', 'string', 'letohll', 'string', 'letohl', 'byte', 'float', 'lv', 'float', 'string', 'float', 'lv', 'float', 'letohl', 'ntohl', 'ntohll', 'byte', 'byte', 'lv', 'byte', 'ntohl', 'letohs', 'ntohll', 'letohs', 'ntohll', 'ntohl', 'lv', 'letohll', 'ntohs', 'double']), 'adiaphorousfalsifiable': ([], ['string', 'float', 'ntohs', 'ntohl']), 'radomenetherwards': (['prefactoranchoret', 'ureterorrhagiahemogenetic', 'intrathoraciccoemployment', 'wirrshillingless', 'peerlesslyforetalk', 'Slavophilesedigitate', 'unhittabledoublehorned', 'physiognomicallybrasse', 'spraysemisaprophyte', 'subrelationsepiolite', 'cineplastyanonang', 'surrenalinconcluding', 'phenomenalisticallyunmomentary', 'uncatholicizeSiphonognathus', 'misputheptarchist', 'Saxonicalpalet', 'semisomnolencegunj', 'sideflashmagniloquent', 'fillmetroptosis', 'warfaringdraghound', 'Wagnerianaaviculturist', 'predisciplinetukra', 'dinitrilholocentrid', 'sokarailer', 'anomalousparallelinerved', 'alphabetismpolyfenestral', 'radiopaqueunrecruitable', 'ExobasidialesEppy', 'apioidalNagari', 'sulfureasupertramp', 'untuckedsolenoglyphic', 'remisrepresentationlancet', 'slichtarradiddler', 'cannotdentigerous', 'Sumasslevulosuria', 'counterpotentMetabola', 'refilmopenhandedness', 'surlyreptilferous', 'repolymerizationwesselton', 'lobectomypreinflection', 'sheepkeepingfeedman', 'Lawsonsemiconversion', 'volubilityThuidium', 'monogamianportio', 'codeinesalience', 'snakeletwounds', 'delthyrialGee', 'bawcockPicnickian', 'craunchprovitamin', 'galvanothermometerBalzacian', 'distilleryKiwanis', 'xenopodidtrencherless', 'denieragedrapery', 'intercoolingpotentialization', 'disjointedlytriamylose', 'baptizeeFrenchize', 'Aparaipsychiatrist', 'overgenialitybuzzle', 'surfactantchurchgrith', 'unlasheddialyzable', 'noniccosmopoietic', 'Senecanovercorruptly', 'Nathanielbiliteral', 'appendiceunmetaled', 'zeuctocoelomicmetapodial', 'retroclusionmetaphysicianism', 'Eomecondiscolorate', 'sowbackgastrotrichan', 'paleobotanyworkpeople', 'cinecameraHydropotes', 'cystocarppapaprelatical', 'yawpwoodwax', 'Vickyimmigrant', 'arnberrydodecadrachm', 'Brandipriestcraft', 'zoosporangialbuyable', 'menialitypreintelligent', 'vaporizetannery', 'bairnlyneocosmic', 'changeablyzoophilitic', 'adminiculatephosphosilicate', 'predesignateunderservice'], ['string', 'ntohl', 'lv', 'float']), 'unhittabledoublehorned': ([], ['string', 'letohs', 'letohs', 'letohll', 'ntohs']), 'uncunningmonticuliporidean': ([], ['letohs', 'byte', 'double', 'letohl', 'ntohll', 'string', 'ntohs', 'letohs']), 'dihedronsubcircuit': (['baptizeeFrenchize', 'warfaringdraghound', 'herpetologistindeed', 'visorlikeNagari', 'hyperduliaferrateen', 'Fichteanismconjobble', 'Tullianrubidium', 'emergencechouette', 'surlyreptilferous', 'organosiliconsegmentary'], ['letohs', 'letohll', 'float', 'float', 'double', 'float']), 'slutteryprivant': (['dominionistversableness', 'motacillinewidespreadly', 'subsoilercruent', 'recapitalizerelevate', 'improvisatorizenoneditorial', 'tellurethurryproof', 'gratefulAlcedinidae', 'indirecthierarchism', 'cardinghygeistic', 'zoosporangialbuyable', 'dehydrogenizeCambrian', 'triplewisepostepileptic', 'steelworkpsychophysiological', 'declamatorinessSerrifera', 'projicientcolumellate', 'unengravedeosin', 'epigenesistbisexed', 'Rodolphhumuslike', 'malthouseenteralgia', 'napalmbrevifoliate', 'assecurationAshkenazim', 'idioglossiascabble', 'recapitalizationdissipative', 'strainedlypsychopompos', 'epexegeticallyreadjournment', 'Vandiemenianwinery', 'notwitch', 'remisrepresentationlancet', 'Eurypteroideachamaeprosopic', 'buttonholerindigestive', 'barrelmakingparoemia', 'violationguggle', 'TaboriteSanche', 'arhatsporozoic', 'androgynyvegetoalkaline', 'Maytimeraillike', 'ruinlikesilva', 'tenesmicHymettic', 'decimosextountractarian', 'chaffererunheaded', 'ineloquentundishonored', 'pentaptychBantingism', 'submountainhopper', 'depositoryteloblastic', 'Histriobdellauntread', 'whusslenoreast', 'overganggenesial', 'blepharanthracosisuncliented', 'raspberrylikesubvertebral', 'pavonatedcozily', 'popeyednaphtha', 'sincerenessundominoed', 'overfretdisenthronement', 'semisomnolencegunj', 'remirrorundepreciated', 'Fichteanismconjobble', 'paleocrystallinespinulosodenticulate', 'pensefulnessdrought', 'polyspermatouscreationistic', 'overedgeevangelican', 'bumblefooticonology', 'unscalednessChamaeleon', 'petalocerouscamus', 'tautoousianentente', 'practicelegitimatist', 'pantomnesiadiporpa', 'gumdiggingsalvarsan', 'zincotypetripodic', 'scruplercellulifugal', 'cudavaogreish', 'contrarietyinconceivableness', 'hippocampalscrow', 'unfeasiblecollodiotype', 'iconismanisostemonous', 'Alalamenispermine', 'qualmyishHolocene', 'nonadjustmentwritmaking', 'monodromiclyretail'], ['nextproto_b', 'ntohl', 'letohl', 'ntohll', 'letohll', 'letohl', 'nextproto_b', 'letohs', 'string', 'letohs', 'letohs', 'letohl', 'ntohs', 'byte', 'lv', 'nextproto_s', 'ntohs', 'ntohll', 'lv', 'string', 'byte', 'ntohs', 'nextproto_s', 'nextproto_b', 'nextproto_s', 'string', 'nextproto_s', 'ntohl', 'ntohl', 'letohl']), 'faddyamputational': ([], ['ntohl', 'lv', 'byte', 'lv', 'float', 'lv', 'ntohs', 'byte', 'ntohll', 'byte', 'string', 'string', 'lv', 'lv', 'lv', 'letohs', 'ntohll', 'letohl', 'ntohs', 'letohl']), 'retickettopotaxis': (['proctorshipscoptical', 'meddlingsmall', 'xenogenesisprenoble', 'Larinaecoydog', 'nondistributionclitellus', 'oxmanoutpull', 'racegoingunperformed', 'unhealablenessknoppy', 'pluviographicspermatorrhea', 'yinsttenderness', 'skeelysubtriangular', 'malthouseenteralgia', 'TelopeaCyclotosaurus', 'sacroposteriorveratryl', 'frolickytriphyline', 'baptizeeFrenchize', 'etioporphyrinpubovesical', 'misspellquinaldic', 'Hetaeristaltimetrical'], ['nextproto_b', 'letohl', 'lv', 'letohll', 'letohl', 'double', 'double', 'letohl']), 'burgonetcarefully': ([], ['string', 'ntohs', 'ntohl', 'ntohl', 'byte', 'ntohll', 'double', 'string', 'letohl', 'letohll', 'letohl', 'letohl', 'lv', 'byte', 'string', 'string', 'float', 'letohl', 'string', 'letohl', 'letohs', 'string', 'float', 'string', 'double', 'ntohl', 'letohs', 'lv']), 'excentricalProtococcales': ([], ['byte', 'ntohs', 'lv', 'letohs', 'string', 'byte', 'byte', 'ntohs', 'letohs', 'string']), 'predestinarianglia': ([], ['ntohs', 'byte', 'letohl', 'ntohl', 'ntohs', 'ntohl', 'letohl', 'letohs', 'ntohll', 'ntohll', 'double']), 'gulchalilonghi': ([], ['ntohll', 'byte', 'ntohs', 'ntohll', 'ntohl', 'ntohll', 'byte', 'ntohll', 'letohll', 'letohl', 'double', 'string', 'ntohs', 'ntohl', 'string', 'letohll', 'float', 'double', 'lv', 'lv']), 'archsnoblodgepole': (['vibrativeoversail', 'fleaweedprobate', 'depositoryteloblastic', 'tenesmicHymettic', 'nonadjustmentwritmaking', 'misadministrationbroody', 'bustedpredoubter', 'trentepohliaceousHectorean', 'arhatsporozoic', 'ivoryliketransessentiate', 'asepticallyBernese', 'picayunishapogeotropic', 'docimasytrouserdom', 'intrathoraciccoemployment'], ['string', 'letohs', 'byte', 'nextproto_s', 'lv', 'ntohll', 'string', 'letohs', 'double', 'letohs', 'ntohl', 'letohs', 'letohl', 'lv', 'string', 'nextproto_b', 'letohl', 'letohll', 'letohs', 'byte', 'double', 'ntohl', 'lv', 'letohl', 'letohll', 'double', 'letohl', 'ntohs', 'nextproto_s', 'letohl', 'string', 'ntohll', 'letohs', 'double', 'letohl', 'ntohs', 'ntohll', 'float', 'letohll', 'byte', 'ntohll', 'letohs', 'byte', 'letohll', 'float', 'byte', 'float', 'ntohll', 'ntohll', 'letohl']), 'raspberrylikesubvertebral': ([], ['letohl', 'float', 'ntohll', 'ntohll', 'letohll', 'string', 'ntohl', 'double', 'byte', 'double', 'lv', 'letohll', 'float', 'letohl', 'string', 'float', 'ntohll', 'ntohll', 'letohll', 'string', 'double', 'ntohl', 'letohl', 'ntohl', 'letohs', 'letohs', 'float', 'double']), 'fillmetroptosis': ([], ['letohl', 'ntohl', 'ntohs', 'lv', 'lv', 'letohll', 'lv', 'lv', 'letohl', 'double', 'byte', 'byte', 'ntohl', 'ntohs', 'string', 'ntohll']), 'larunfermenting': ([], ['string', 'letohl', 'lv', 'string', 'ntohl', 'lv', 'letohll', 'letohll', 'ntohl', 'letohll', 'string', 'double', 'ntohll']), 'organosiliconsegmentary': ([], ['ntohs', 'byte', 'lv', 'byte', 'ntohl']), 'booteebifold': ([], ['lv', 'string', 'ntohl', 'string', 'letohl', 'byte', 'ntohll', 'string', 'letohl', 'ntohl', 'ntohll']), 'derationalizationunchoked': (['chinkingcytologic', 'Bronxbiotechnics', 'sandwortFierasfer', 'leathermakersemishirker', 'palatableJonesian', 'Islamiticgreenbark', 'slutteryprivant', 'nonadjustmentwritmaking', 'retickettopotaxis', 'metasomalNachitoches', 'ketembillaantiferment', 'yoreexponent', 'barrelmakingparoemia', 'unaccoutereddrivebolt', 'tripartedlyOssetine', 'demibeastuninflicted', 'huddlingcladautoicous', 'napalmbrevifoliate', 'damnonianscrankly', 'recapitalizerelevate', 'mediumismgypsyism', 'postiquedefeasibility'], ['lv', 'letohll', 'byte', 'double', 'ntohll', 'double', 'letohs', 'nextproto_b', 'nextproto_s', 'string', 'letohl', 'string', 'letohs', 'nextproto_b', 'byte', 'byte', 'letohll', 'nextproto_b', 'ntohs', 'lv', 'byte', 'ntohll', 'letohl', 'float', 'letohs', 'nextproto_s', 'letohl', 'byte', 'ntohs', 'ntohll']), 'outfeatvasodilator': (['chaffererunheaded', 'Triuridalesplagiarism', 'esophagoplastyrestrainedness', 'piskgriff', 'intrathoraciccoemployment', 'unbeggarbroncholithiasis', 'cystocarppapaprelatical', 'symmetricalantimasker', 'cacuminalgastrohysterorrhaphy', 'syphilologyannularity', 'saltlypropugnator', 'sokarailer', 'vaporizetannery', 'loungyimpolite', 'huddlingcladautoicous', 'visorlikeNagari', 'malthouseenteralgia', 'Bryumextrafocal', 'udometricpredefault', 'bairnlyneocosmic', 'unlasheddialyzable', 'cancelationZoochlorella', 'epigenesistbisexed', 'ineloquentundishonored', 'opportunisttitlark', 'asepticallyBernese', 'steelworkpsychophysiological', 'Lespedezafuthorc', 'asperationoraculousness', 'unconvenedperpetually', 'sheepkeepingfeedman', 'untastedgirllike', 'goniometerhexameral', 'dehydrogenizeCambrian', 'carangoidbotryomycotic', 'unmistgraffer', 'crouchingpurebred', 'carannaaccension', 'dermobranchiataboyardom', 'tenesmicHymettic', 'unreprovedlysprier', 'ambisyllabicfruitful', 'anomalousparallelinerved', 'Vandiemenianwinery', 'pellagrosemongrelization', 'pilchermonaulos', 'weathercockismcustodier', 'woodrowelshrievalty', 'prattlersuffumigate', 'catmalisoncoevally', 'etioporphyrinpubovesical', 'counterpotentMetabola', 'utterabilitypavement', 'blepharanthracosisuncliented', 'iconismanisostemonous', 'refilmopenhandedness', 'ornithotomyblackwort', 'extravagantkaryoplasmatic', 'superabsurdditremid', 'semiduplexskirt', 'bawcockPicnickian', 'subregenthelmeted', 'pneumodynamicsprimariness', 'outworthbenevolence', 'hetericismswayable', 'multicrystallinekeratoglossus', 'stakeholderunforbade', 'Piscataqualagoonal', 'cannotdentigerous', 'bullswooldraggletail', 'spinthariscopemolybdena', 'veldcraftsubprefect', 'cylindrarthrosisnonplusation', 'usurperunplannedly', 'collationdissuasively', 'spraysemisaprophyte', 'shortcakeabase', 'wutproamusement', 'outfeatvasodilator', 'Pamirioversystematic', 'menialitypreintelligent', 'cassiteritecasemaking', 'cesserreichspfennig', 'countryfolkintolerance', 'napalmbrevifoliate'], ['nextproto_s', 'ntohs', 'ntohs', 'nextproto_s', 'letohl', 'string', 'float', 'ntohl', 'string', 'ntohl', 'ntohs', 'lv', 'letohl', 'ntohs', 'ntohs', 'double', 'string', 'lv', 'letohs', 'letohl', 'ntohl', 'double', 'ntohl', 'nextproto_s', 'letohll', 'letohll', 'letohl', 'letohll']), 'menialitypreintelligent': ([], ['letohll', 'letohl', 'ntohl', 'string', 'ntohl', 'byte', 'letohll', 'ntohll', 'ntohl', 'lv', 'double', 'double', 'ntohl']), 'actordocility': ([], ['string', 'string', 'float', 'byte', 'ntohll', 'ntohl', 'string', 'ntohll', 'ntohs', 'ntohl', 'letohll', 'ntohs', 'ntohl', 'string', 'ntohs', 'string', 'letohll', 'letohl', 'string', 'letohll', 'double', 'letohl', 'ntohs', 'string', 'ntohs', 'letohl', 'byte', 'byte', 'lv', 'float', 'letohl', 'double']), 'trichitepersonship': ([], ['letohl', 'byte', 'letohs', 'float', 'letohs', 'lv', 'float', 'letohll', 'letohl', 'letohs', 'float', 'ntohll']), 'rosariumpathetism': (['skeegalveoloclasia', 'Suionesunprejudicially', 'bumblefooticonology', 'undistinctivenondisfranchised', 'untuckedsolenoglyphic', 'Tdapproximatively', 'antleredadunc', 'cudavaogreish', 'stagemansupa', 'correctorSpirochaeta', 'subsorterbecuffed', 'cynophileLobale', 'clientageshudderingly', 'unmistgraffer', 'unfannedhopperman', 'prattlersuffumigate', 'holdsmanoversalty', 'premortuarybenchy', 'prelanguagecloudage', 'delthyrialGee', 'alveololingualMindererus', 'subrelationsepiolite', 'tellurethurryproof', 'skeelysubtriangular', 'percontationMaimonist', 'unimplicitoothecal', 'oysterhouseamarillo', 'photonephographPima'], ['ntohll', 'letohll', 'float', 'byte', 'ntohl', 'letohl', 'lv', 'nextproto_b', 'ntohl', 'ntohll', 'float', 'string', 'nextproto_b', 'double', 'byte', 'ntohs', 'string', 'letohl', 'ntohll', 'ntohll', 'letohll', 'letohl', 'nextproto_s', 'nextproto_b', 'double', 'double', 'lv']), 'scheltopusikAmpelidaceae': ([], ['ntohl', 'letohll', 'float', 'letohll', 'letohs', 'string', 'letohll', 'ntohl', 'letohl', 'string', 'ntohl', 'letohll', 'lv', 'ntohll', 'lv', 'letohl', 'float', 'float', 'ntohll']), 'planetologyphocine': ([], ['byte', 'ntohl', 'ntohl', 'lv', 'double', 'letohll', 'letohs', 'letohs', 'byte', 'double', 'ntohl', 'double', 'letohs', 'letohs', 'letohl', 'letohs', 'string', 'byte', 'byte', 'ntohll', 'ntohs', 'byte', 'float', 'double', 'letohll', 'lv', 'ntohll', 'letohl', 'string', 'letohll', 'letohl', 'ntohl', 'letohll', 'string', 'double', 'ntohll', 'byte']), 'hornilychrysolitic': ([], ['byte', 'byte', 'letohs', 'double', 'ntohs', 'ntohs', 'float', 'byte', 'letohll', 'string', 'double', 'letohll', 'letohl', 'double', 'ntohl', 'ntohs', 'ntohl', 'letohl', 'ntohll', 'ntohl', 'float', 'letohl', 'ntohs', 'letohll', 'lv', 'ntohs', 'ntohs', 'float', 'letohs', 'byte', 'byte', 'letohll']), 'unfootedHilary': (['rosiedunarchdeacon', 'asteamincandescency', 'paralyzerthiocarbimide', 'sagaiebarrister', 'hematozoalinfinitarily', 'udometricpredefault', 'GemitoresBourignian', 'tautoousianentente', 'clientageshudderingly', 'snakeletwounds', 'Trinorantumpyramides', 'hypoplasyhooping', 'psychrographismdom', 'unbeggarbroncholithiasis', 'Sarothrawrencher', 'unsanctioningperiuvular', 'remisrepresentationlancet', 'misspellquinaldic', 'anusimnonstationary', 'rattlepodMuntiacus', 'catagmaticMegalosaurus', 'allottrichopterous', 'slutteryprivant', 'vivifybenefactorship', 'receptivelynonshredding', 'acanthopterygianMuranese', 'counterpotentMetabola', 'unsubstantiaterightfulness', 'chromophilouspyometra', 'byworkplastid', 'unstalledneutralism', 'unrevenuedindecorousness', 'peritrichouslyhepatoflavin', 'Larinaecoydog'], ['ntohll', 'ntohs', 'double', 'letohll', 'nextproto_s', 'double', 'float', 'lv', 'string', 'nextproto_s', 'letohs', 'ntohl', 'letohll', 'float', 'letohll', 'float', 'float', 'nextproto_s', 'ntohs', 'ntohl']), 'keraunophoneinhabited': (['Vandiemenianwinery', 'dissogenyBarney', 'querulouslycooky', 'declamatorinessSerrifera', 'udometricpredefault', 'cineplastyanonang', 'rosiedunarchdeacon', 'surlyreptilferous', 'undercovertcoloss', 'predefinitionCarnaria', 'malthouseenteralgia', 'endogalvanismunwarrantedly', 'addressorcondensedly', 'visorlikeNagari', 'tongueshoticonophilism', 'unenterprisedargumentatious', 'piskgriff', 'misspellquinaldic', 'reladepropiolaldehyde', 'refilmopenhandedness', 'zoosporangialbuyable', 'Wagnerianaaviculturist', 'unusehydroponist', 'unreprovedlysprier', 'appendiceunmetaled', 'pilchermonaulos', 'prosubscriptiontribracteate', 'Maytimeraillike', 'oversolicitouslyhour', 'chytridialgoosemouth', 'recapitalizationdissipative', 'hammerkopnegativer', 'photoheliographoctuplicate', 'overganggenesial'], ['ntohll', 'ntohl', 'ntohl', 'lv', 'byte', 'float', 'letohll', 'double', 'letohll', 'letohl', 'ntohl']), 'hammerkopnegativer': ([], ['ntohs', 'lv', 'letohll', 'letohll', 'ntohs', 'ntohl', 'byte', 'double', 'ntohll', 'lv', 'letohl', 'lv', 'ntohll', 'ntohl', 'ntohs', 'float', 'double', 'string', 'lv', 'letohl']), 'oversolicitouslyhour': (['summarizationyatter', 'diseasednessthioantimonate', 'countryfolkintolerance', 'hammerkopnegativer', 'allerChilostoma', 'raspberrylikesubvertebral', 'scleroblastemicpalaeocosmology', 'blepharanthracosisuncliented', 'hookahsupersimplicity', 'cantingnesstideful', 'noggencapitulate', 'sagaiebarrister', 'photocompositioneneuch', 'bustedpredoubter', 'perukiershiplexicographer', 'overganggenesial', 'spraysemisaprophyte', 'manageriallyflanger', 'Carpathianmetanephron', 'mausoleandecasualize', 'agoraphobiaLenzites', 'metatitanatetarente', 'cicisbeismGonystylus', 'evenworthyharebrain', 'unpaintterebinic', 'herpetologistindeed', 'Piscataqualagoonal', 'snakeletwounds', 'wolfberrydeclaredness', 'tellurethurryproof', 'hyperduliaferrateen', 'acclaimerilluminability', 'reladepropiolaldehyde', 'paralyzerthiocarbimide', 'fetoracclimatement', 'lemologydiplasion', 'premortuarybenchy', 'Philonismpinivorous', 'asteamincandescency', 'overhollowescort', 'superestablishmentsuccor', 'catmalisoncoevally', 'spinthariscopiclieutenancy', 'loungyimpolite', 'tongueshoticonophilism', 'kansrush', 'unconvenedperpetually', 'refilmopenhandedness'], ['string', 'nextproto_b', 'float', 'string', 'nextproto_b', 'nextproto_s', 'nextproto_b', 'lv', 'string', 'ntohll', 'string', 'nextproto_b', 'byte', 'letohl', 'nextproto_b', 'lv', 'nextproto_s', 'double', 'byte']), 'subsoilercruent': ([], ['float', 'byte', 'ntohl', 'string', 'lv', 'letohll', 'ntohll', 'ntohl', 'byte', 'ntohll', 'lv', 'letohll', 'byte', 'ntohll', 'ntohl', 'ntohs', 'byte', 'ntohll', 'lv', 'ntohl', 'lv', 'lv', 'ntohs', 'letohll', 'float', 'ntohll', 'double', 'float', 'ntohs', 'ntohll', 'letohs']), 'overganggenesial': ([], ['byte', 'double', 'string', 'ntohl', 'letohl', 'letohl', 'string', 'ntohll', 'double', 'ntohl', 'letohl', 'double', 'byte', 'letohll', 'double', 'ntohs', 'byte', 'ntohl', 'ntohll', 'float', 'letohs', 'string', 'letohl', 'ntohl', 'letohl', 'float', 'letohl', 'float', 'ntohll', 'ntohll']), 'plowtailinfectress': ([], ['byte', 'lv', 'ntohll', 'ntohll', 'ntohll', 'letohll', 'ntohs', 'ntohs', 'ntohs', 'letohl', 'letohl', 'byte', 'string', 'byte', 'letohs', 'byte', 'letohl', 'double', 'letohs', 'ntohs', 'byte', 'letohs', 'lv', 'byte', 'ntohll', 'letohll', 'letohl', 'letohll', 'string', 'ntohs', 'letohl', 'ntohs', 'letohs', 'ntohs', 'ntohl', 'ntohs', 'ntohll', 'byte', 'ntohll', 'letohs', 'float']), 'untastedgirllike': (['loungyimpolite', 'asepticallyBernese', 'steelworkpsychophysiological', 'sokarailer', 'Triuridalesplagiarism', 'multicrystallinekeratoglossus'], ['letohll', 'float', 'ntohll', 'string', 'ntohll', 'double', 'letohl', 'double', 'ntohll', 'double', 'byte', 'double', 'nextproto_s', 'lv', 'nextproto_s', 'letohll', 'ntohs', 'nextproto_b', 'ntohll', 'letohll', 'float', 'nextproto_s', 'byte', 'letohll', 'double', 'double', 'letohll', 'nextproto_b', 'letohll', 'double', 'byte', 'float', 'ntohs', 'ntohs', 'letohl', 'ntohl']), 'sulphhemoglobinHerculanean': (['bemuzzlesurficial', 'herpetologistindeed', 'ettleoptimize', 'correctorSpirochaeta', 'Opisthocomidaeheterochiral', 'listeningBroussonetia', 'Robenhausianreboil', 'buttonholerindigestive', 'undercovertcoloss', 'warfaringdraghound', 'picayunishapogeotropic', 'awiwimegaloglossia', 'unlasheddialyzable', 'androgynyvegetoalkaline', 'diseasednessthioantimonate', 'responsivitykimigayo', 'vaporizetannery', 'addressorcondensedly', 'utterabilitypavement', 'Mayorunahybridizer', 'cinecameraHydropotes', 'monodromiclyretail', 'tenesmicHymettic', 'spraysemisaprophyte', 'refilmopenhandedness', 'yoreexponent', 'idioglossiascabble', 'adminiculatephosphosilicate', 'outfeatvasodilator', 'euquinquennium', 'mattapharyngological', 'summarizationyatter', 'frolickytriphyline', 'peerlesslyforetalk', 'dermobranchiataboyardom', 'cesserreichspfennig', 'splanchnopleureprelapsarian', 'pneumodynamicsprimariness', 'symptosissubcorneous', 'gumdiggingsalvarsan', 'Stromatoporoideabarry', 'spadelikemassacrer', 'dehydrogenizeCambrian', 'channelizeungarter', 'renverseundethroned', 'noniccosmopoietic', 'sokarailer', 'trentepohliaceousHectorean', 'imperializetrispaston', 'ricketssubtrihedral', 'epigenesistbisexed', 'spinthariscopemolybdena', 'Sarothrawrencher', 'mataiuntameness', 'apioidalNagari', 'hammerkopnegativer', 'unenterprisedargumentatious', 'collationdissuasively', 'remisrepresentationlancet', 'wutproamusement', 'allerChilostoma', 'Vandiemenianwinery', 'piskgriff', 'bustedpredoubter', 'misproduceunthrilled', 'appendiceunmetaled', 'interventraliaforeutter'], ['string', 'double', 'nextproto_s', 'byte', 'nextproto_s', 'letohs', 'nextproto_s', 'letohll', 'double', 'letohs', 'letohl', 'string', 'ntohll', 'letohll', 'lv', 'lv', 'ntohll', 'nextproto_s', 'double', 'double', 'ntohll', 'byte', 'double', 'lv', 'nextproto_s']), 'inferiorismobstetrix': ([], ['ntohs', 'ntohs', 'byte', 'letohl', 'ntohl', 'string', 'ntohs']), 'Slovenerecure': ([], ['double', 'letohll', 'float', 'lv', 'double', 'letohll', 'float', 'letohl', 'double', 'double', 'ntohll', 'ntohs', 'ntohs', 'string', 'byte', 'double', 'ntohs', 'letohll', 'letohs', 'letohs', 'byte', 'byte', 'letohll', 'ntohl', 'double', 'ntohll', 'letohll']), 'alkargenmoop': ([], ['letohl', 'letohl', 'letohll']), 'hypogenicquietus': ([], ['string', 'letohll', 'letohs', 'letohl', 'ntohl', 'letohs', 'letohs', 'letohs', 'float', 'letohl', 'ntohll', 'ntohl', 'ntohs', 'ntohl', 'letohll', 'ntohll', 'letohll']), 'monodromiclyretail': ([], ['float', 'ntohl', 'ntohl', 'ntohll', 'byte', 'letohl', 'letohll', 'float', 'byte', 'double', 'ntohl', 'ntohl', 'byte', 'byte', 'lv', 'ntohs', 'ntohll', 'letohl', 'ntohl', 'string', 'float', 'ntohll', 'letohs', 'double', 'string', 'ntohll', 'ntohs', 'float', 'float', 'string', 'letohl', 'float']), 'Castoroidespentacrinite': ([], ['string', 'letohs', 'double', 'byte', 'letohs', 'float', 'letohl', 'lv', 'float', 'ntohll', 'lv', 'ntohll', 'ntohll', 'double', 'string', 'ntohl', 'lv', 'byte', 'string', 'lv', 'letohl', 'float', 'double', 'letohs', 'string', 'letohl', 'letohll', 'float']), 'alphabetismpolyfenestral': ([], ['ntohs', 'lv', 'double', 'letohs', 'letohll', 'byte', 'letohl', 'ntohl', 'float', 'double', 'string', 'letohll', 'ntohll']), 'deadlockperiangitis': (['hemologistbeglide', 'symptosissubcorneous', 'kempstergarefowl', 'whusslenoreast', 'variationaladjutory', 'orographicniddick', 'dissuasivenessnondeforestation', 'intrathoraciccoemployment', 'unfeasiblecollodiotype', 'catafalquedree', 'focoidsstackfreed', 'terribletaut', 'inwrapbilophodont', 'theohumanhooper', 'archiereusHainan', 'prelanguagecloudage', 'fetoracclimatement', 'nonofficeholdingwaldgravine', 'malthouseenteralgia', 'ciderishazury', 'reburstsummity', 'vaporizetannery', 'membershiptownsboy', 'sharkletcompactedly', 'catastateateliosis', 'noggencapitulate', 'overgenialitybuzzle', 'sincerenessundominoed', 'disaffectedanchorite', 'unpopulatecurry'], ['byte', 'nextproto_s', 'nextproto_b', 'ntohll', 'string', 'double', 'letohll', 'float', 'nextproto_s', 'ntohll', 'byte', 'letohl', 'string']), 'prattlersuffumigate': ([], ['letohs', 'double', 'ntohl', 'letohs', 'double', 'ntohl', 'ntohs', 'float', 'double', 'letohll', 'byte', 'ntohll', 'byte', 'letohs', 'float', 'double', 'ntohl', 'ntohl', 'ntohl', 'ntohs', 'lv', 'lv', 'lv', 'letohll', 'string', 'ntohl', 'float', 'string', 'letohs', 'letohll', 'ntohs', 'letohll', 'ntohs', 'byte', 'float']), 'galledisocinchomeronic': (['phototherapistupsetted', 'zincotypetripodic', 'noggencapitulate', 'anomalousparallelinerved', 'udometricpredefault', 'summarizationyatter', 'focoidsstackfreed', 'mausoleandecasualize', 'subordinationbrachial', 'ivoryliketransessentiate', 'predisciplinetukra', 'dermoiddiversifiable', 'tellurethurryproof', 'diseasednessthioantimonate', 'parathyroidectomizeoutheart', 'cantingnesstideful', 'Plymouthistnashgab', 'Orakzaiunsatisfiedly', 'Mayorunahybridizer', 'semicolumnrankly', 'unreprovedlysprier', 'unhyphenedallose', 'sheepkeepingfeedman', 'rosiedunarchdeacon', 'syphilologyannularity', 'pneumodynamicsprimariness', 'springlikemonosymmetrically', 'veldcraftsubprefect', 'ineloquentundishonored', 'unusehydroponist', 'Opisthocomidaeheterochiral', 'Sumasslevulosuria', 'remisrepresentationlancet', 'previousnessoisin', 'perukiershiplexicographer', 'lindengamy', 'Philonismpinivorous', 'tenesmicHymettic', 'awiwimegaloglossia', 'prelanguagecloudage', 'outfeatvasodilator', 'byworkplastid', 'reladepropiolaldehyde', 'distilleryKiwanis', 'apioidalNagari', 'goniometerhexameral', 'tollgateandrophagous', 'stakeholderunforbade', 'parandruspercribration', 'vaporizetannery', 'Alalamenispermine', 'pilchermonaulos', 'unlasheddialyzable', 'hetericismswayable', 'galledisocinchomeronic', 'cesserreichspfennig', 'peritrichouslyhepatoflavin', 'docimasytrouserdom', 'asperationoraculousness', 'asteamincandescency', 'lemologydiplasion', 'listeningBroussonetia', 'Tullianrubidium', 'Oliveanpyromancer', 'intrathoraciccoemployment', 'zeuctocoelomicmetapodial', 'piskgriff', 'feveretunderbox', 'whusslenoreast', 'unsanctioningperiuvular', 'coeternaloverhonor', 'catagmaticMegalosaurus', 'surlyreptilferous', 'simulcastriboflavin', 'interventraliaforeutter', 'prattlersuffumigate', 'endogalvanismunwarrantedly', 'declamatorinessSerrifera', 'micrencephalypalpus', 'menialitypreintelligent', 'bullswooldraggletail', 'fleaweedprobate', 'unfannedhopperman', 'spinthariscopiclieutenancy', 'peerlesslyforetalk', 'organoantimonypreoperator', 'allerChilostoma', 'crossboltedasexually', 'utterabilitypavement', 'unsubstantiaterightfulness', 'archsnoblodgepole', 'shuttlecockscanmag', 'ambisyllabicfruitful', 'multicrystallinekeratoglossus', 'imperializetrispaston', 'reburstsummity', 'Eomecondiscolorate', 'asepticallyBernese'], ['byte', 'nextproto_s', 'ntohs', 'double', 'double', 'ntohll', 'nextproto_s', 'nextproto_b', 'letohl', 'letohs', 'ntohs', 'double']), 'acclaimerilluminability': (['syphilologyannularity', 'semicolumnrankly', 'huddlingcladautoicous', 'unfannedhopperman', 'mattapharyngological', 'zoosporangialbuyable', 'hammerkopnegativer', 'cassiteritecasemaking', 'dermoiddiversifiable', 'goniometerhexameral', 'apioidalNagari', 'hyperneuriasymbolatry', 'symptosissubcorneous', 'susurrateoutvie', 'crossboltedasexually', 'peritrichouslyhepatoflavin', 'tenesmicHymettic', 'bustedpredoubter', 'saltlypropugnator', 'maltingsurrection', 'Mayorunahybridizer', 'unreprovedlysprier', 'Dokoelectrochemically', 'cylindrarthrosisnonplusation', 'scleroblastemicpalaeocosmology', 'cancelationZoochlorella', 'radiopaqueunrecruitable', 'esophagoplastyrestrainedness', 'Voltaprotarsal', 'herpetologistindeed', 'unmistgraffer', 'recapitalizerelevate', 'counterpotentMetabola', 'paleobotanyworkpeople', 'blepharanthracosisuncliented', 'crouchingpurebred', 'visorlikeNagari', 'peccationfoolery', 'Eomecondiscolorate', 'coeternaloverhonor', 'superabsurdditremid', 'tellurethurryproof', 'evaluecystatrophia', 'katabolizedermic', 'hemianacusiadouble', 'napalmbrevifoliate', 'dehydrogenizeCambrian', 'Stromatoporoideabarry', 'ornithotomyblackwort', 'overgenialitybuzzle', 'shuttlecockscanmag', 'spinthariscopemolybdena', 'frolickytriphyline', 'seminegroSemiticize', 'idioglossiascabble', 'byworkplastid', 'ambisyllabicfruitful', 'chytridialgoosemouth', 'focoidsstackfreed', 'prattlersuffumigate', 'semiduplexskirt', 'Lawsonsemiconversion', 'Fichteanismconjobble', 'asepticallyBernese', 'chaffererunheaded', 'bumblefooticonology', 'diseasednessthioantimonate', 'summarizationyatter', 'querulouslycooky', 'bullswooldraggletail', 'refilmopenhandedness', 'hyperduliaferrateen', 'racegoingunperformed', 'pedestrianateStromateidae', 'udometricpredefault', 'grapedmassively', 'Oliveanpyromancer', 'outworthbenevolence', 'Sumasslevulosuria', 'avalanchestylopization', 'surlyreptilferous', 'ochronosusafterbody', 'carangoidbotryomycotic', 'overganggenesial', 'amlipyrexic', 'Lespedezafuthorc', 'sokarailer', 'reburstsummity', 'subregenthelmeted', 'retroclusionmetaphysicianism'], ['nextproto_s', 'float', 'float', 'float', 'nextproto_b', 'ntohl', 'nextproto_s', 'nextproto_s', 'lv', 'lv', 'float', 'ntohll', 'ntohl', 'string', 'ntohs', 'float', 'nextproto_s', 'float', 'letohs', 'ntohl', 'ntohl', 'ntohl', 'float', 'string', 'ntohl', 'string', 'ntohl', 'ntohl', 'ntohl', 'byte', 'float', 'string', 'letohs', 'letohll', 'byte', 'ntohs', 'letohll', 'letohl']), 'aerophilethyroidless': (['roofprespur', 'slopinglyautomatically', 'peritrichouslyhepatoflavin', 'ofttimessnatchingly', 'balandracaducibranch', 'smackinglyScheuchzeriaceae', 'docimasytrouserdom', 'sideflashmagniloquent', 'prizeexcrescence', 'preformisticexemplifiable', 'wirrshillingless', 'loungyimpolite', 'Brandipriestcraft', 'coeternaloverhonor', 'notwitch', 'scruplercellulifugal', 'whusslenoreast', 'radomenetherwards', 'bombonnefiendhead', 'sageshipcarcoon', 'OrleansSchedius', 'unconvenedperpetually', 'isatogenvestibulum', 'emergencechouette', 'recapitalizerelevate', 'codeinesalience', 'proportionaltasselmaker', 'appendiceunmetaled', 'ophthalmalgiamisproduce', 'iconismanisostemonous', 'unsubstantiaterightfulness', 'pellagrosemongrelization', 'ExobasidialesEppy', 'Toryizesynechthran', 'stakeholderunforbade', 'rathmemorizable', 'predisciplinetukra', 'cleansingpentahedral', 'skilderprothalline', 'tenodesisunroaming', 'lepidodendridcounterplead', 'racegoingunperformed', 'spinosotuberculatedeossify', 'prattlersuffumigate', 'Histriobdellauntread', 'diazobenzenedisburden', 'improvisatorizenoneditorial', 'hanginglypoethood', 'avalanchestylopization'], ['letohl', 'nextproto_b', 'lv', 'letohs', 'ntohll', 'ntohll', 'ntohll']), 'gooselikeaerohydropathy': ([], ['letohs', 'byte']), 'unfootsorepoonac': (['Vandiemenianwinery', 'ornithotomyblackwort', 'susurrateoutvie', 'unsubstantiaterightfulness', 'unfeasiblecollodiotype', 'prelanguagecloudage', 'dextrosinistralElaeococca', 'warfaringdraghound', 'Plymouthistnashgab', 'grammaticismmignonette', 'bustedpredoubter', 'avalanchestylopization', 'coinbellmaker', 'Nathanielbiliteral', 'diseasednessthioantimonate', 'coeternaloverhonor', 'noniccosmopoietic', 'hemianacusiadouble', 'epistlarcystoid', 'Cobitidaedismissal', 'gumdiggingsalvarsan', 'pegologyscavenage', 'prattlersuffumigate', 'isatogenvestibulum', 'clinandriabryologist', 'Sumasslevulosuria', 'strainedlypsychopompos', 'piperitiousreekingly', 'Stromatoporoideabarry', 'overpoliticunderlooker', 'arecolidinehyalodacite', 'surfactantchurchgrith', 'bairnlyneocosmic', 'tumoredcrocodilite', 'xenogenesisprenoble', 'pseudodemocraticproconscription', 'acclaimerilluminability', 'ambisyllabicfruitful', 'Lespedezafuthorc', 'pilchermonaulos', 'vibrativeoversail', 'ureterorrhagiahemogenetic', 'rosiedunarchdeacon', 'autovivisectionoverleather', 'volubilityThuidium', 'usurperunplannedly', 'amlipyrexic', 'baptizeeFrenchize', 'Pamirioversystematic', 'notchycoralliferous', 'isuroidunfitly', 'xenopodidtrencherless', 'erythriticsynergidal', 'misadministrationbroody', 'maternityhomogenetic', 'renverseundethroned', 'feveretunderbox', 'strangulableargentamid', 'disjointedlytriamylose', 'predesignateunderservice', 'subsorterbecuffed', 'creditiveplatonesque', 'subsoilercruent', 'sacroposteriorveratryl', 'interimperialvignetter', 'intrathoraciccoemployment', 'clientageshudderingly', 'cantingnesstideful', 'polyspermatouscreationistic'], ['string', 'letohll', 'ntohl', 'nextproto_b', 'lv', 'letohl', 'letohs', 'ntohll', 'letohl', 'nextproto_s', 'letohs', 'ntohs', 'letohll', 'nextproto_s', 'nextproto_b', 'letohl', 'float', 'lv', 'letohl', 'nextproto_b', 'letohll', 'lv', 'string', 'nextproto_b', 'ntohs', 'nextproto_s', 'ntohs', 'double', 'float']), 'repealistbillsticking': ([], ['string', 'double', 'ntohll', 'letohl', 'byte', 'ntohs', 'double', 'string', 'letohs', 'string', 'lv', 'float', 'letohs', 'ntohs']), 'metasomalNachitoches': ([], ['letohll', 'letohll', 'ntohll', 'lv', 'ntohs', 'ntohl', 'letohs', 'byte', 'letohll', 'lv', 'ntohll', 'ntohs', 'ntohs', 'ntohll', 'byte', 'ntohl', 'double', 'letohs', 'ntohll', 'letohl', 'double', 'ntohll', 'byte', 'string', 'letohs', 'letohs', 'double', 'letohl', 'ntohl', 'float', 'ntohs', 'ntohl', 'letohl', 'letohs', 'byte', 'letohll']), 'postiquedefeasibility': (['spadelikemassacrer', 'untuckedsolenoglyphic', 'repealistbillsticking', 'sharkletcompactedly', 'epigenesistbisexed', 'tintsausinger', 'Anglomaniaclovableness', 'slutteryprivant', 'agonizefloating', 'coeternaloverhonor', 'pentaptychBantingism', 'provectgastrocolostomy', 'iconismanisostemonous', 'Steganophthalmiagnomic', 'cardinghygeistic', 'fleaweedprobate', 'refallGanguela', 'gratifyinglymetrorrhea', 'submountainhopper', 'focoidsstackfreed', 'applanationnitrifaction', 'unmooredtowy', 'onomatopoeiaeggfish', 'reshoedrachmae', 'gardenedfugacious', 'overedgeevangelican', 'evenworthyharebrain'], ['ntohll', 'ntohs', 'ntohs', 'string', 'ntohll', 'ntohll', 'letohl', 'ntohs', 'nextproto_b', 'letohll', 'nextproto_b', 'nextproto_s', 'nextproto_b', 'float', 'ntohs', 'lv']), 'malapleurogenous': ([], ['letohl', 'ntohll', 'letohll', 'ntohl', 'ntohl', 'letohl', 'letohs', 'lv', 'ntohll', 'ntohll', 'ntohs', 'byte', 'string', 'ntohs', 'string', 'letohl', 'lv', 'letohs', 'string', 'letohl', 'lv', 'ntohl', 'float', 'ntohl', 'letohll', 'double', 'letohs', 'letohl', 'letohl', 'string', 'string', 'lv', 'byte', 'letohl', 'ntohs', 'letohs']), 'lemologydiplasion': ([], ['letohs', 'letohl', 'letohl', 'ntohs', 'ntohl', 'double', 'ntohs', 'lv', 'float', 'ntohll', 'byte', 'letohs', 'letohll', 'ntohl', 'letohs', 'ntohl', 'ntohs', 'lv', 'float', 'lv', 'ntohs', 'double', 'float', 'lv', 'letohl', 'ntohs', 'ntohl', 'double']), 'catafalquedree': ([], ['ntohs', 'letohl', 'double', 'lv', 'float', 'ntohll', 'byte', 'letohll']), 'unbeggarbroncholithiasis': (['xenopodidtrencherless'], ['ntohll', 'nextproto_b', 'letohll', 'double', 'lv', 'letohl', 'byte', 'double', 'ntohll', 'ntohll', 'nextproto_s', 'ntohl', 'letohl', 'string', 'float', 'byte', 'double', 'nextproto_b', 'ntohl', 'double', 'letohl', 'byte', 'letohl', 'nextproto_s', 'nextproto_s', 'ntohs', 'float', 'double', 'nextproto_s', 'letohll', 'nextproto_b', 'string', 'byte']), 'superabsurdditremid': ([], ['ntohs', 'byte', 'letohll', 'byte', 'byte', 'letohll', 'double', 'double', 'float', 'letohs', 'letohs', 'lv', 'byte', 'letohl', 'letohl', 'lv', 'letohll', 'ntohs', 'byte', 'ntohs', 'byte', 'double', 'byte', 'byte', 'ntohl', 'string', 'ntohll', 'byte', 'float', 'letohl', 'letohll', 'ntohll', 'float', 'ntohl', 'float', 'double', 'byte', 'ntohs', 'letohl']), 'cassiteritecasemaking': ([], ['ntohll', 'letohs', 'letohs', 'float', 'letohl', 'letohl', 'double', 'letohll', 'byte', 'string', 'letohs', 'ntohl', 'letohll', 'ntohll', 'letohs', 'ntohs', 'letohl', 'byte', 'double', 'letohl', 'ntohs', 'letohl', 'ntohl', 'letohll', 'letohs', 'ntohl', 'string']), 'vibrativeoversail': ([], ['float', 'ntohl', 'float', 'ntohl', 'ntohll', 'letohll', 'string', 'ntohl', 'letohs', 'double', 'float', 'ntohll', 'letohl', 'string', 'ntohs', 'float', 'byte', 'letohll', 'letohll']), 'paraderDendrocygna': ([], ['ntohll']), 'unsubstantiaterightfulness': ([], ['ntohs', 'double', 'letohs', 'lv', 'float', 'float', 'ntohll', 'ntohll', 'byte', 'ntohs', 'letohs', 'lv', 'double', 'ntohs', 'ntohll', 'ntohs', 'byte', 'letohll', 'letohs', 'ntohl', 'byte', 'float', 'letohl', 'string', 'float', 'lv', 'string', 'letohs', 'byte', 'double', 'letohll', 'string']), 'luminaristvasculated': ([], ['ntohll', 'double', 'ntohl', 'letohl', 'string', 'double', 'ntohll', 'letohl', 'ntohl', 'string', 'lv', 'float', 'string', 'ntohl', 'byte', 'letohl', 'byte', 'double', 'letohl', 'ntohll', 'letohll', 'byte', 'string', 'string', 'byte', 'letohll', 'byte']), 'pellagrosemongrelization': ([], ['ntohll', 'letohll', 'letohl', 'ntohs', 'letohll', 'ntohs', 'ntohl', 'ntohll', 'ntohl', 'letohs', 'ntohll', 'ntohll', 'string', 'lv', 'byte', 'double', 'float', 'double', 'letohl', 'ntohl', 'ntohl', 'byte', 'letohll', 'ntohl', 'ntohs', 'ntohs', 'letohll', 'string', 'ntohll', 'string', 'byte', 'letohs', 'lv', 'double', 'lv', 'byte', 'byte', 'ntohs', 'float', 'ntohs']), 'unfannedhopperman': (['cesserreichspfennig', 'pilchermonaulos', 'unmistgraffer', 'Tullianrubidium', 'hyperneuriasymbolatry', 'unbeggarbroncholithiasis', 'udometricpredefault', 'intrathoraciccoemployment', 'hetericismswayable'], ['nextproto_b', 'lv', 'ntohl', 'double', 'lv', 'string', 'string', 'double', 'letohl', 'nextproto_b', 'byte', 'byte', 'string', 'letohll', 'double', 'letohl', 'letohl', 'string', 'ntohs', 'byte', 'ntohs', 'letohs', 'nextproto_s', 'letohl', 'ntohs', 'letohll', 'byte', 'lv', 'double', 'lv', 'letohs', 'nextproto_b', 'double', 'string', 'string', 'string']), 'tonguinessresoundingly': ([], ['ntohll', 'letohs', 'float', 'byte', 'ntohll', 'ntohs', 'byte', 'ntohl']), 'allottrichopterous': ([], ['ntohl', 'letohs', 'byte', 'float', 'float', 'ntohs', 'letohs', 'double', 'byte', 'ntohl', 'letohs', 'float', 'float', 'letohl', 'string', 'double', 'letohs', 'letohl', 'float', 'lv', 'float', 'letohll', 'ntohs', 'letohl', 'double', 'letohl', 'double', 'letohll', 'letohs', 'ntohl']), 'cathodofluorescencemonkcraft': ([], ['ntohl', 'lv', 'float', 'ntohl', 'letohll', 'ntohl', 'string', 'ntohl', 'float', 'letohs', 'string', 'lv', 'string', 'letohll', 'byte', 'float', 'ntohll', 'ntohs', 'ntohs', 'string', 'ntohs', 'ntohl', 'float', 'string', 'ntohll', 'ntohs', 'double', 'ntohs', 'ntohl', 'letohl', 'string', 'ntohll', 'letohl', 'ntohs', 'letohl', 'ntohl']), 'unremittinglyaffronting': (['precoxseambiter', 'chytridialgoosemouth', 'chromophilouspyometra', 'parathyroidectomizeoutheart', 'wirrshillingless', 'thysanuriformcrossrail', 'iridemiabisque', 'listeningBroussonetia', 'Slavophilesedigitate', 'predesignateunderservice', 'Bryumextrafocal', 'Steganophthalmiagnomic', 'cudavaogreish', 'stickleafethenyl', 'redifferentiationmustachio', 'genipacombiner', 'picayunishapogeotropic', 'hookahsupersimplicity', 'untrainhearkener', 'amlipyrexic', 'terrazzododder', 'Erotylidaeprehesitate', 'sokarailer', 'tecalipalingenesy', 'Aparaipsychiatrist', 'tongueshoticonophilism', 'electrocardiographyamaranthaceous', 'sideflashmagniloquent', 'microcrystallogenyfuniculus'], ['ntohl', 'ntohl', 'string', 'float', 'nextproto_b', 'string', 'ntohs', 'double', 'letohl', 'double', 'float', 'string', 'letohl', 'nextproto_s', 'lv', 'string', 'nextproto_b', 'nextproto_b', 'string', 'ntohll', 'nextproto_s', 'byte', 'string', 'letohll', 'nextproto_s', 'double', 'letohs', 'letohs', 'ntohll', 'float', 'ntohll']), 'psilotaceousectozoan': ([], ['ntohll', 'ntohll', 'double', 'letohll', 'float', 'lv', 'ntohs', 'lv', 'byte', 'byte', 'letohl', 'float', 'ntohs', 'ntohll', 'double', 'ntohll', 'lv', 'letohll', 'double', 'letohs', 'double']), 'picayunishapogeotropic': ([], ['string', 'letohll']), 'mausoleandecasualize': (['unfannedhopperman', 'polyspermatouscreationistic', 'chytridialgoosemouth', 'utterabilitypavement', 'udometricpredefault', 'racegoingunperformed', 'isuroidunfitly', 'tenesmicHymettic', 'unhittabledoublehorned'], ['nextproto_b', 'ntohs', 'ntohll', 'letohs', 'nextproto_b', 'letohll', 'double']), 'refallGanguela': ([], ['letohll', 'byte', 'string', 'float', 'ntohs', 'ntohl', 'string', 'lv', 'string', 'ntohs', 'lv', 'double', 'lv', 'letohll', 'ntohs', 'ntohs', 'byte', 'letohll', 'lv', 'double', 'ntohll', 'double', 'double', 'byte', 'byte', 'ntohs', 'float', 'float', 'letohs', 'byte', 'ntohs', 'string', 'lv', 'byte', 'ntohl', 'letohll', 'byte', 'double', 'lv', 'string', 'ntohl', 'letohll', 'lv']), 'preservatizeskyphoi': (['unmistgraffer', 'provectgastrocolostomy', 'epexegeticallyreadjournment', 'addressorcondensedly', 'interimperialvignetter', 'Suionesunprejudicially', 'tenodesisunroaming', 'steinkirkmisaffection', 'electrocardiographyamaranthaceous', 'ambisyllabicfruitful', 'xenogenesisprenoble', 'adiaphorousfalsifiable', 'changeablyzoophilitic', 'utterabilitypavement', 'gynarchicagedly', 'collationdissuasively', 'apioidalNagari', 'cancelationZoochlorella', 'fleaweedprobate', 'skeelysubtriangular', 'pilchermonaulos', 'pentaptychBantingism', 'skilderprothalline', 'qualmyishHolocene', 'prebromidicMonopetalae', 'unflukedcleck', 'loungyimpolite', 'feveretunderbox', 'tenesmicHymettic', 'sowbackgastrotrichan', 'turbidlycorticoefferent', 'unsanctioningperiuvular', 'popeyednaphtha', 'baptizeeFrenchize', 'Fichteanismconjobble', 'ruinlikesilva', 'spinthariscopiclieutenancy', 'unfootsorepoonac', 'hematozoalinfinitarily', 'acclaimerilluminability', 'mischieveunfomented', 'predefinitionCarnaria', 'ochronosusafterbody', 'unusehydroponist', 'unenterprisedargumentatious', 'unrevenuedindecorousness', 'leadstonehypovitaminosis', 'pavonatedcozily', 'lepidodendridcounterplead', 'symmetricalantimasker', 'semiduplexskirt', 'poonghiehectic', 'kansrush', 'catagmaticMegalosaurus', 'renverseundethroned', 'avalanchestylopization', 'indubitablenoncollaboration', 'ineloquentundishonored', 'untuckedsolenoglyphic', 'semistillpassback', 'springlikemonosymmetrically', 'steelworkpsychophysiological', 'stickleafethenyl', 'crossboltedasexually', 'mausoleandecasualize', 'preinjuryduplicature', 'foliicolousskeletonweed', 'Stromatoporoideabarry', 'whusslenoreast', 'ettleoptimize', 'refilmopenhandedness', 'grammaticismmignonette', 'dehydrogenizeCambrian', 'variationaladjutory', 'spadelikemassacrer', 'lamellicornousPolygonaceae', 'xerophagyhematography'], ['double', 'letohs', 'letohs', 'byte', 'lv', 'ntohs', 'nextproto_s']), 'ricketssubtrihedral': ([], ['ntohll', 'letohs', 'lv', 'ntohs', 'letohll', 'ntohll', 'ntohs', 'double', 'letohl', 'letohl', 'string', 'string']), 'wirrshillingless': (['ochronosusafterbody', 'loungyimpolite', 'mataiuntameness', 'noniccosmopoietic', 'maternityhomogenetic', 'unhittabledoublehorned', 'creditiveplatonesque', 'arecolidinehyalodacite', 'phototherapistupsetted', 'gemeledAdonai', 'sharkletcompactedly', 'predestinarianglia', 'wutproamusement', 'pseudodemocraticproconscription', 'epistlarcystoid', 'skeelysubtriangular', 'Oliveanpyromancer', 'zoosporangialbuyable', 'balandracaducibranch', 'unbeggarbroncholithiasis', 'Toryizesynechthran', 'unreprovedlysprier', 'asepticallyBernese', 'xenogenesisprenoble', 'Lespedezafuthorc', 'evaluecystatrophia', 'sacroposteriorveratryl', 'ruinlikesilva', 'importationPerisphinctidae', 'Stromatoporoideabarry', 'heliconbonnetman', 'veldcraftsubprefect', 'blepharanthracosisuncliented', 'TaboriteSanche', 'Trinorantumpyramides', 'ambisyllabicfruitful', 'nonofficeholdingwaldgravine', 'mediumismgypsyism', 'zincotypetripodic', 'maskflowerkeynoter', 'misspellquinaldic', 'surlyreptilferous', 'iconismanisostemonous', 'palatableJonesian', 'unengravedeosin', 'prebromidicMonopetalae', 'maltingsurrection', 'warneriodocasein', 'Senecanovercorruptly', 'unexchangedsupraventricular', 'appendiceunmetaled', 'improvisatorizenoneditorial', 'mattapharyngological', 'goniometerhexameral', 'Opisthocomidaeheterochiral', 'utterabilitypavement', 'Vickyimmigrant', 'Robenhausianreboil', 'menialitypreintelligent', 'untastedgirllike', 'Philonismpinivorous', 'tenesmicHymettic', 'orographicniddick', 'urningsubpubescent', 'blossomscrimshander', 'cantingnesstideful', 'cineplastyanonang', 'querulouslycooky', 'mammillationpemphigous', 'repealistbillsticking', 'coxbonesbirle', 'prosubscriptiontribracteate', 'adminiculatephosphosilicate', 'epitrophygoatlike', 'matelessbeatitude', 'multicrystallinekeratoglossus', 'semistillpassback', 'entomicperjuriousness', 'hammerkopnegativer', 'fillmetroptosis', 'unfootsorepoonac', 'plurifacialmicrographical', 'motacillinewidespreadly', 'unquailingshive', 'uncatholicizeSiphonognathus', 'catagmaticMegalosaurus', 'recapitalizationdissipative', 'catmalisoncoevally', 'springlikemonosymmetrically', 'vibrativeoversail'], ['nextproto_b', 'letohll', 'byte', 'ntohll', 'lv', 'letohll', 'letohs', 'nextproto_s', 'letohll', 'ntohl', 'nextproto_s', 'double', 'ntohs', 'letohs', 'nextproto_b', 'ntohll', 'ntohl', 'letohll', 'double', 'double', 'letohll', 'ntohll', 'nextproto_s', 'lv', 'letohll', 'letohll', 'byte', 'ntohl', 'lv', 'byte', 'string', 'nextproto_b', 'letohl', 'byte', 'byte', 'ntohl', 'byte', 'ntohl', 'float', 'ntohll', 'letohl', 'letohl', 'ntohl', 'ntohs', 'ntohs', 'lv', 'double']), 'Lespedezafuthorc': (['weathercockismcustodier', 'epigenesistbisexed', 'Lespedezafuthorc', 'multicrystallinekeratoglossus', 'superabsurdditremid', 'xenogenesisprenoble', 'countryfolkintolerance', 'katabolizedermic', 'peritrichouslyhepatoflavin', 'sokarailer', 'mattapharyngological', 'apioidalNagari', 'malthouseenteralgia', 'semicolumnrankly', 'perukiershiplexicographer', 'opportunisttitlark', 'prattlersuffumigate', 'unbeggarbroncholithiasis', 'cystocarppapaprelatical', 'radiopaqueunrecruitable', 'wutproamusement', 'bairnlyneocosmic', 'tautoousianentente', 'dehydrogenizeCambrian', 'piskgriff', 'Orakzaiunsatisfiedly', 'Pamirioversystematic', 'ornithotomyblackwort', 'cylindrarthrosisnonplusation', 'cardialgiacontingence', 'pneumodynamicsprimariness', 'vaporizetannery', 'dermobranchiataboyardom', 'unreprovedlysprier', 'focoidsstackfreed', 'ochronosusafterbody', 'Tullianrubidium', 'spraysemisaprophyte', 'menialitypreintelligent', 'foliicolousskeletonweed', 'veldcraftsubprefect', 'shuttlecockscanmag', 'shortcakeabase', 'collationdissuasively', 'cancelationZoochlorella', 'hetericismswayable', 'Bryumextrafocal', 'pilchermonaulos', 'predesignateunderservice', 'steelworkpsychophysiological', 'strangulableargentamid', 'blepharanthracosisuncliented', 'susurrateoutvie', 'superestablishmentsuccor', 'unmistgraffer', 'saltlypropugnator', 'udometricpredefault', 'tellurethurryproof', 'subordinationbrachial', 'amlipyrexic'], ['ntohs', 'ntohl', 'nextproto_b', 'byte', 'ntohll', 'float', 'byte', 'double', 'double', 'letohl', 'lv', 'byte', 'letohs', 'ntohll', 'nextproto_b', 'letohl', 'byte', 'ntohs', 'letohl', 'ntohl']), 'entomicperjuriousness': (['sulfureasupertramp', 'tenodesisunroaming', 'phototherapistupsetted', 'cineplastyanonang', 'Brandipriestcraft', 'manageriallyflanger', 'unoverhauledGalinsoga', 'shuttlecockscanmag', 'disjointedlytriamylose', 'Wagnerianaaviculturist', 'bustedpredoubter', 'outfeatvasodilator', 'carangoidbotryomycotic', 'intercoolingpotentialization', 'undercovertcoloss', 'declamatorinessSerrifera', 'overgenialitybuzzle', 'volubilityThuidium', 'herpetologistindeed', 'spraysemisaprophyte', 'applanationnitrifaction', 'laterodeviationNarciss', 'sagaiebarrister', 'hammerkopnegativer', 'retroclusionmetaphysicianism', 'ineloquentundishonored', 'delthyrialGee', 'xenogenesisprenoble', 'spadelikemassacrer', 'dissogenyBarney', 'predisciplinetukra', 'OrleansSchedius', 'collationdissuasively', 'polyspermatouscreationistic', 'Sarothrawrencher', 'misspellquinaldic', 'loungyimpolite', 'lobectomypreinflection', 'Bryumextrafocal', 'strangulableargentamid', 'unconvenedperpetually', 'etioporphyrinpubovesical', 'uncomminutedcommix', 'Philonismpinivorous', 'cerebroidodontolcate', 'butterrootchagrin', 'Senecanovercorruptly', 'benzalethylaminedesulphurate', 'unflukedcleck', 'Lespedezafuthorc', 'xerophagyhematography', 'stomagringo', 'leathermakersemishirker', 'piperitiousreekingly', 'oxmanoutpull', 'ureterorrhagiahemogenetic', 'subsorterbecuffed', 'flashpanstature', 'stagemansupa', 'superabsurdditremid', 'yoreexponent', 'tongueshoticonophilism', 'Lawsonsemiconversion', 'Nathanielbiliteral', 'terrazzododder', 'refallGanguela', 'unsubstantiaterightfulness', 'unhittabledoublehorned', 'interventraliaforeutter', 'hyperneuriasymbolatry', 'asepticallyBernese', 'precoxseambiter', 'Vandiemenianwinery', 'isatogenvestibulum', 'anomalousparallelinerved', 'paleobotanyworkpeople', 'sheepkeepingfeedman', 'provectgastrocolostomy', 'Mayorunahybridizer', 'nasicornousfasciated', 'Maytimeraillike', 'unpopulatecurry', 'goniometerhexameral', 'cicisbeismGonystylus', 'ivoryliketransessentiate', 'indubitablenoncollaboration', 'feveretunderbox', 'denieragedrapery', 'allegoristerserendite', 'Slovenerecure', 'changeablyzoophilitic', 'vaporizetannery', 'pantomnesiadiporpa'], ['letohll', 'float', 'string', 'double', 'string', 'string', 'ntohl', 'float', 'byte', 'letohl', 'float', 'lv', 'float', 'letohs', 'letohl', 'ntohs', 'ntohs', 'ntohs', 'ntohs', 'lv', 'byte', 'letohl', 'string', 'double', 'double']), 'craunchprovitamin': ([], ['ntohl', 'ntohs', 'byte', 'byte', 'letohl', 'ntohll']), 'irislikeaphyllose': (['recapitalizationdissipative', 'strainedlypsychopompos', 'OrleansSchedius', 'laparotomycephalohumeralis', 'Toryizesynechthran', 'focoidsstackfreed', 'dachshundpuddly', 'pensefulnessdrought', 'sheepkeepingfeedman', 'katabolizedermic', 'cystocarppapaprelatical', 'sacroposteriorveratryl', 'indirecthierarchism', 'pegologyscavenage', 'dinitrilholocentrid', 'valvotomypensionably', 'venomouslypilferment', 'Opisthocomidaeheterochiral', 'benzalethylaminedesulphurate', 'whusslenoreast', 'flashpanstature', 'overhollowescort', 'eudaemonisticallyCoccolobis', 'cophosisclour', 'warfaringdraghound', 'ochronosusafterbody', 'woodrowelshrievalty', 'hematozoalinfinitarily', 'asperationoraculousness', 'hanginglypoethood', 'unflukedcleck', 'etherifyCicadidae', 'denieragedrapery', 'untrainhearkener', 'subsorterbecuffed', 'Plymouthistnashgab', 'Brandipriestcraft', 'unfannedhopperman', 'ruinlikesilva', 'hystericsupersuperior', 'androgynyvegetoalkaline', 'polyspermatouscreationistic', 'unmensurableSoohong', 'frolickytriphyline', 'recapitalizerelevate', 'foreuseuninfluencing', 'importationPerisphinctidae', 'dermobranchiataboyardom', 'coxbonesbirle', 'reburstsummity', 'creditiveplatonesque', 'exponencecrubeen', 'oxmanoutpull', 'countrymanisodimorphism', 'perukiershiplexicographer'], ['string', 'ntohll', 'lv', 'byte', 'nextproto_s', 'nextproto_b', 'letohl', 'ntohs', 'letohs', 'letohs', 'ntohl', 'double', 'ntohs', 'letohll', 'double', 'nextproto_s', 'float', 'letohll', 'letohll', 'string', 'nextproto_b', 'letohl', 'double', 'ntohl', 'byte', 'byte', 'letohl', 'ntohll']), 'foreuseuninfluencing': ([], ['ntohs', 'double', 'ntohll', 'string', 'float', 'float', 'string', 'float', 'ntohll', 'ntohs', 'float', 'letohll', 'letohll', 'double', 'string', 'string', 'ntohl', 'letohll', 'ntohll', 'double', 'float', 'ntohll', 'letohll', 'letohs', 'double', 'string', 'ntohs', 'lv', 'string', 'ntohl', 'letohl', 'ntohll']), 'variationaladjutory': ([], ['ntohl', 'ntohl', 'letohll', 'letohl', 'string', 'ntohl', 'letohs', 'ntohl', 'letohs', 'float', 'string', 'string', 'ntohll', 'letohl', 'byte', 'string', 'letohl', 'byte', 'lv', 'ntohl', 'ntohl', 'string', 'string', 'ntohll', 'letohs', 'float', 'double', 'ntohll', 'double', 'float', 'byte', 'double', 'ntohll', 'lv', 'float', 'letohll', 'letohs', 'letohs', 'letohl', 'lv', 'letohs']), 'undiscoverableelectrifiable': (['desoxycorticosteroneshakerag', 'counterpotentMetabola', 'buttTarahumara', 'ramraceBorderies', 'graphologicautovaccination', 'sternoxiphoidunenlivened', 'ralphautonomically', 'emergencechouette', 'ligniformcoolheadedness', 'muckyuxoricide'], []), 'anusimnonstationary': ([], ['letohll', 'letohll', 'ntohs', 'letohll', 'letohl', 'ntohs', 'string', 'double', 'byte', 'letohll', 'letohl', 'letohs', 'byte', 'double', 'double', 'ntohl', 'float', 'byte', 'ntohs', 'letohll', 'float', 'byte', 'letohll', 'ntohs', 'ntohl', 'lv', 'byte', 'letohl']), 'iodolabsolutistic': ([], ['float', 'byte', 'letohll', 'byte', 'string', 'float', 'double', 'letohll', 'ntohs', 'ntohs', 'string', 'string', 'float', 'double', 'ntohl']), 'unconvenedperpetually': (['goniometerhexameral', 'tellurethurryproof', 'pilchermonaulos', 'Vandiemenianwinery', 'veldcraftsubprefect', 'pneumodynamicsprimariness', 'Tullianrubidium', 'xenogenesisprenoble', 'isuroidunfitly', 'shuttlecockscanmag', 'susurrateoutvie', 'carangoidbotryomycotic', 'udometricpredefault', 'surlyreptilferous', 'ineloquentundishonored', 'symmetricalantimasker', 'cardialgiacontingence', 'hetericismswayable', 'loungyimpolite', 'spraysemisaprophyte', 'countryfolkintolerance', 'Eomecondiscolorate', 'woodrowelshrievalty', 'intrathoraciccoemployment', 'crouchingpurebred', 'barrelmakingparoemia', 'prattlersuffumigate', 'Steganophthalmiagnomic', 'tenesmicHymettic', 'bullswooldraggletail', 'semicolumnrankly'], ['lv', 'nextproto_s', 'letohl', 'letohll', 'float', 'ntohll', 'letohs', 'byte', 'byte', 'ntohll', 'ntohl', 'letohs', 'letohll', 'nextproto_s', 'byte', 'ntohs', 'nextproto_s', 'double', 'string', 'float', 'letohs', 'string', 'ntohs', 'byte', 'ntohl', 'byte', 'string', 'lv']), 'symmetricalantimasker': (['countryfolkintolerance', 'symmetricalantimasker', 'saltlypropugnator', 'pilchermonaulos', 'Orakzaiunsatisfiedly', 'sokarailer', 'evaluecystatrophia', 'pneumodynamicsprimariness', 'xenopodidtrencherless', 'blepharanthracosisuncliented', 'asperationoraculousness', 'sacroposteriorveratryl', 'collationdissuasively'], ['byte', 'letohll', 'double', 'nextproto_b', 'double', 'double', 'double', 'byte', 'letohl', 'letohl', 'ntohll', 'letohs', 'ntohll', 'string', 'nextproto_s', 'nextproto_b', 'ntohs', 'byte', 'double', 'byte', 'double', 'ntohll', 'nextproto_b', 'letohl', 'letohs', 'lv', 'nextproto_s', 'ntohs', 'double', 'lv', 'lv', 'letohl', 'ntohl']), 'multifurcateobstructively': (['planetologyphocine', 'kempstergarefowl', 'anomalousparallelinerved', 'shuttlecockscanmag', 'munjmuchness', 'lindengamy', 'ophthalmalgiamisproduce'], ['letohl', 'letohs', 'letohll', 'nextproto_s', 'ntohll', 'byte', 'ntohll', 'string', 'nextproto_s', 'letohl', 'nextproto_b', 'ntohs', 'letohs', 'nextproto_b', 'nextproto_b', 'lv', 'lv', 'float', 'byte', 'nextproto_b', 'ntohl', 'letohll', 'byte', 'letohll', 'ntohl', 'ntohs', 'ntohs', 'nextproto_s', 'string', 'ntohl', 'float', 'ntohll', 'letohl', 'ntohs', 'float', 'ntohs', 'string', 'letohll', 'double', 'ntohl', 'letohll', 'lv', 'letohll', 'ntohl', 'ntohll', 'ntohl', 'float', 'ntohll', 'letohll', 'float']), 'Bharatadomain': ([], ['ntohs', 'ntohs']), 'dracontiasisinterparliamentary': (['urningsubpubescent', 'iridemiabisque', 'spinthariscopemolybdena', 'docimasytrouserdom', 'Saxonicalpalet', 'tuchunateacademization', 'notchycoralliferous', 'dejectedincreasing', 'repealistbillsticking', 'integralizationbremeness', 'counterpotentMetabola', 'lepidodendridcounterplead', 'outworthbenevolence', 'Vickyimmigrant', 'marblelikeTenaktak', 'uncomminutedcommix', 'applanationnitrifaction', 'preformisticexemplifiable', 'overseateddiscouragingly', 'prerailwaycannibalistically', 'unimplicitoothecal', 'physiognomicallybrasse'], ['byte', 'letohll', 'double', 'double', 'nextproto_b', 'letohs', 'double', 'nextproto_b', 'letohll', 'ntohs', 'nextproto_b', 'ntohs', 'nextproto_b', 'float', 'ntohs', 'letohs', 'letohll', 'lv', 'letohl', 'ntohl', 'letohll', 'string', 'double', 'string', 'letohs', 'letohl', 'letohll', 'ntohll', 'letohl', 'byte', 'ntohl', 'ntohs', 'ntohll', 'ntohl', 'ntohs']), 'indecencyjimply': (['secrecyheteroecy', 'unenterprisedargumentatious', 'abjudicationunpleading', 'scleroblastemicpalaeocosmology', 'rewhirlhypermotility', 'grapedmassively', 'potheenpharmacologia', 'unspendablevanilla', 'monogamianportio', 'racegoingunperformed', 'semicolumnrankly', 'whitewareCladoselachidae', 'toyingere', 'Saxonicalpalet', 'alkaneirrigable', 'elephantryleptocephalan', 'iridemiabisque', 'Chilopsiscompactible', 'subordinationbrachial', 'metatitanatetarente', 'congregationalvocimotor', 'Actiniomorphaquartzic', 'loungyimpolite', 'buttTarahumara', 'impracticalnessNemichthyidae', 'uncatholicizeSiphonognathus', 'subregenthelmeted', 'submountainhopper', 'Grahamsaloon', 'acquisitumvaletudinarist', 'pavonatedcozily', 'galimatiasphacocystectomy', 'stagemansupa', 'prefactoranchoret', 'Tdapproximatively', 'Leskeaceaemotto', 'evaluecystatrophia', 'appendiceunmetaled', 'mattapharyngological', 'scheltopusikAmpelidaceae', 'Cobitidaedismissal'], ['double', 'letohll', 'ntohs', 'letohll', 'letohs', 'letohl', 'float', 'letohs', 'lv', 'ntohl', 'letohll', 'float', 'letohs', 'letohs', 'byte', 'letohs', 'string', 'nextproto_s', 'string', 'float', 'letohs', 'byte', 'nextproto_s', 'lv', 'letohs', 'nextproto_b', 'letohll', 'nextproto_s', 'ntohs', 'nextproto_s', 'byte', 'string', 'string', 'letohl', 'nextproto_b', 'letohl']), 'misputheptarchist': ([], ['lv', 'lv', 'ntohl', 'byte']), 'sciosophyunlarge': ([], ['letohs', 'byte', 'ntohl', 'letohll', 'double', 'lv', 'double', 'double', 'string', 'letohs', 'ntohl', 'letohl', 'float', 'ntohs', 'ntohs']), 'Moorshipspermatova': (['consignificationmarshbuck', 'remisrepresentationlancet', 'Senecanovercorruptly', 'sokarailer', 'attestatorcoronule', 'Robenhausianreboil', 'insidiouslysurplicewise', 'Toryizesynechthran', 'overedgeevangelican', 'depositumspiritsome', 'TelopeaCyclotosaurus', 'Saxonicalpalet', 'balandracaducibranch', 'receptivenesssempervirent', 'bustedpredoubter', 'sagaiebarrister', 'igelstromiteMoraceae', 'SpatangusChayma', 'archcrownundistantly', 'zoosporangialbuyable', 'isuroidunfitly', 'udometricpredefault', 'crossboltedasexually', 'genipacombiner', 'Momotinaenonfortification', 'subsorterbecuffed', 'exponencecrubeen', 'rattlepodMuntiacus', 'keraunophoneinhabited', 'xenopodidtrencherless', 'cosilybridecake', 'eudaemonisticallyCoccolobis', 'unremittinglyaffronting', 'Wagnerianaaviculturist', 'furoidbasanite', 'Graphiolacolorimetry', 'ecclesiaLatinization', 'renverseundethroned', 'menialitypreintelligent', 'raucousEstheriidae', 'countrymanisodimorphism', 'Marcosianpictographically', 'urningsubpubescent', 'cannotdentigerous', 'pegologyscavenage'], ['string', 'letohll', 'double', 'lv', 'ntohll', 'string', 'nextproto_b', 'string', 'nextproto_b', 'float', 'float', 'letohll', 'nextproto_b', 'ntohl', 'nextproto_s', 'byte', 'letohll', 'float', 'string', 'ntohll', 'letohl', 'ntohs', 'letohl', 'lv', 'byte']), 'blepharanthracosisuncliented': ([], ['ntohs', 'letohl', 'byte', 'ntohl', 'float']), 'referumbrellawort': (['catagmaticMegalosaurus', 'exempttanninlike', 'oxmanoutpull', 'subcostalbaldmoney', 'undistinctivenondisfranchised', 'poonghiehectic', 'neurofibriljanapan', 'chromophilouspyometra', 'pericyclonicdipteran', 'hookahsupersimplicity', 'phlebectomySiam', 'heronerchondroplasty', 'responsivitykimigayo', 'chytridialgoosemouth', 'radiopaqueunrecruitable', 'ochronosusafterbody', 'ankylophobiaAsperula', 'spattertriphenylated', 'insidiouslysurplicewise'], ['letohl', 'letohl', 'letohll', 'float', 'nextproto_s', 'ntohl', 'ntohs', 'nextproto_b', 'letohl', 'letohll', 'byte', 'byte', 'string', 'nextproto_s', 'string', 'lv', 'letohl', 'byte', 'letohl', 'letohll', 'string', 'letohll', 'letohll', 'float']), 'springlikemonosymmetrically': ([], ['letohl', 'letohs', 'ntohs', 'letohs', 'ntohll', 'ntohl', 'letohll', 'letohs', 'double', 'ntohl', 'letohll', 'string', 'letohs', 'ntohl', 'letohl', 'string', 'letohs', 'letohll', 'float', 'ntohl', 'byte', 'lv', 'ntohl', 'ntohl', 'letohll', 'ntohs', 'string', 'ntohll']), 'symptosissubcorneous': (['subregenthelmeted', 'outworthbenevolence', 'Piscataqualagoonal', 'avalanchestylopization', 'doubleheartedstaphylolysin', 'cesserreichspfennig'], ['letohs', 'nextproto_b', 'ntohs', 'ntohll']), 'Graphiolacolorimetry': ([], ['letohl', 'letohs', 'float', 'letohs', 'letohl', 'letohs', 'ntohs', 'ntohs', 'float', 'letohll', 'ntohll', 'ntohl', 'letohll', 'letohs', 'string', 'float', 'letohs', 'letohs', 'double', 'lv', 'letohll', 'byte', 'string', 'letohl']), 'bacteriformpiercel': ([], ['byte', 'double', 'letohs', 'ntohl', 'double', 'byte', 'byte', 'string', 'float', 'ntohl', 'letohll', 'letohl', 'ntohll', 'ntohs', 'ntohl', 'lv', 'ntohs', 'string', 'double', 'ntohl', 'byte', 'letohl', 'byte', 'string', 'ntohs', 'letohl', 'letohl', 'double', 'double', 'float', 'byte', 'ntohll', 'letohl', 'float', 'float', 'letohs', 'letohl', 'ntohl', 'letohs', 'letohll']), 'unenterprisedargumentatious': ([], ['string', 'letohs', 'float', 'lv', 'byte', 'byte', 'string', 'string', 'letohs', 'byte', 'double']), 'roofprespur': ([], ['letohs', 'letohl', 'letohll', 'letohs', 'string', 'letohll', 'string', 'letohll', 'letohl', 'letohll', 'ntohl', 'letohs', 'string', 'letohll', 'ntohll', 'lv', 'lv', 'ntohll', 'lv', 'byte', 'ntohl', 'letohll', 'letohll', 'ntohll', 'float', 'ntohll', 'letohll', 'string', 'letohl', 'letohs', 'letohs', 'string']), 'disaffectedanchorite': (['pentaptychBantingism', 'recapitalizationdissipative', 'lepidodendridcounterplead', 'cannotdentigerous', 'overpoliticunderlooker', 'subordinationbrachial', 'reladepropiolaldehyde', 'premortuarybenchy', 'bullswooldraggletail', 'remisrepresentationlancet', 'genipacombiner', 'cineplastyanonang', 'declamatorinessSerrifera', 'scutcheonwiseileocolitis', 'cognaticalintransmissible', 'chytridialgoosemouth', 'sokarailer', 'unfannedhopperman', 'Trinorantumpyramides', 'popeyednaphtha', 'laterodeviationNarciss', 'cancelationZoochlorella', 'prosubscriptiontribracteate', 'avalanchestylopization', 'herpetologistindeed', 'zeuctocoelomicmetapodial', 'acanthopterygianMuranese', 'phototherapistupsetted', 'Piscataqualagoonal', 'mischieveunfomented', 'pegologyscavenage', 'bustedpredoubter', 'ornithotomyblackwort', 'gemeledAdonai', 'Lawsonsemiconversion', 'perukiershiplexicographer', 'predisciplinetukra', 'asepticallyBernese', 'maltingsurrection', 'manageriallyflanger', 'pseudodemocraticproconscription', 'cesserreichspfennig', 'antiphonybackplate', 'loungyimpolite', 'precoxseambiter', 'esophagoplastyrestrainedness', 'outfeatvasodilator', 'leadstonehypovitaminosis', 'sulfureasupertramp'], ['nextproto_s', 'letohl', 'letohs', 'byte', 'letohl', 'ntohl', 'ntohs', 'lv']), 'expiatorytranscriptional': (['Rodolphhumuslike', 'iridemiabisque', 'benzalethylaminedesulphurate', 'reladepropiolaldehyde', 'schuleclethraceous', 'channelizeungarter', 'precoxseambiter', 'hedgesublimish', 'redepositsubclassify', 'counterspyingdungeon', 'leadstonehypovitaminosis', 'purgaNycticorax', 'trinodineacetaldehyde', 'kansrush', 'endopathicnonmarrying', 'preroyaltycoagulin', 'butyrochloralfertilizational', 'matelessbeatitude', 'ridgeplatedisturbed', 'sulphhemoglobinHerculanean', 'penitentiaryshiporderedness', 'dehydrogenizeCambrian', 'prehexameraldissyllabize', 'picturedomArchaeopteris', 'cathodofluorescencemonkcraft', 'uncrevassedterministic', 'Spongiaealcelaphine', 'phlebectomySiam', 'twinklybingo', 'counterdraftdamewort', 'gatewiseunderpot', 'cantingnesstideful', 'unfootedHilary', 'stagemansupa', 'hypoplasyhooping', 'campulitropoussapogenin', 'clinandriabryologist', 'inwrapmentcarcinogenesis', 'quakinglyilliterate', 'hammerkopnegativer', 'alphabetizermonoclinal', 'steelworkpsychophysiological', 'Bitulithicscrin', 'semicolumnrankly', 'cystocarppapaprelatical', 'focoidsstackfreed', 'cattlefolk', 'autoplastycava', 'excentricalProtococcales', 'lemologydiplasion', 'unfannedhopperman', 'unrevenuedindecorousness', 'Saxonicalpalet', 'asteamincandescency', 'repolymerizationwesselton', 'Alalamenispermine', 'herpetologistindeed', 'entrapmentvoyageable', 'gooselikeaerohydropathy', 'scutcheonwiseileocolitis', 'mischieveunfomented', 'deploredlyGolaseccan', 'Aparaipsychiatrist', 'surrenalinconcluding', 'esophagoplastyrestrainedness', 'oxmanoutpull', 'stickleafethenyl', 'carpolitemortifier', 'Orakzaiunsatisfiedly', 'togueseaflower', 'maltingsurrection', 'stereopicturesalep', 'skeelysubtriangular', 'arsheenperspiration', 'Voltaprotarsal', 'piperitiousreekingly', 'evenworthyharebrain', 'bairnlyneocosmic', 'GemitoresBourignian', 'superlapsariandrawlatch'], ['nextproto_b', 'nextproto_b', 'ntohs', 'ntohs', 'letohl', 'nextproto_b', 'nextproto_s', 'nextproto_s', 'nextproto_s', 'string', 'float']), 'ambisyllabicfruitful': ([], ['float', 'letohll', 'letohs', 'ntohl', 'byte', 'double', 'ntohll', 'ntohll', 'string', 'letohll', 'byte', 'float', 'ntohl', 'ntohs', 'lv', 'letohll', 'letohs', 'letohll', 'double', 'double', 'double', 'letohl', 'letohl', 'ntohs', 'double']), 'hookahsupersimplicity': (['udometricpredefault', 'Wagnerianaaviculturist', 'chytridialgoosemouth', 'sageshipcarcoon', 'ornithotomyblackwort', 'symmetricalantimasker', 'unreprovedlysprier', 'semiduplexskirt', 'usurperunplannedly', 'unmistgraffer', 'outworthbenevolence', 'cardialgiacontingence', 'Lespedezafuthorc', 'isuroidunfitly', 'frolickytriphyline', 'outfeatvasodilator', 'Lawsonsemiconversion', 'cancelationZoochlorella', 'woodrowelshrievalty', 'extravagantkaryoplasmatic', 'cylindrarthrosisnonplusation', 'predesignateunderservice', 'seminegroSemiticize', 'tenesmicHymettic', 'doubleheartedstaphylolysin', 'noggencapitulate', 'interimperialvignetter', 'blepharanthracosisuncliented', 'pneumodynamicsprimariness', 'piskgriff', 'untastedgirllike', 'overhollowescort', 'Vandiemenianwinery', 'etioporphyrinpubovesical', 'focoidsstackfreed', 'bumblefooticonology', 'asepticallyBernese', 'semicolumnrankly', 'catmalisoncoevally', 'stakeholderunforbade', 'asperationoraculousness', 'anomalousparallelinerved', 'cacuminalgastrohysterorrhaphy', 'Eomecondiscolorate', 'fetoracclimatement', 'pedestrianateStromateidae', 'iconismanisostemonous', 'prattlersuffumigate', 'pilchermonaulos', 'Opisthocomidaeheterochiral', 'xenogenesisprenoble', 'subregenthelmeted', 'Orakzaiunsatisfiedly', 'cystocarppapaprelatical', 'amlipyrexic', 'surlyreptilferous', 'veldcraftsubprefect', 'carannaaccension', 'cassiteritecasemaking', 'utterabilitypavement', 'grapedmassively', 'saltlypropugnator'], ['float']), 'raucousEstheriidae': (['vaporizetannery', 'intercoolingpotentialization', 'petalocerouscamus', 'endogalvanismunwarrantedly', 'hypoplasyhooping', 'intwistpunter', 'unreprovedlysprier', 'katabolizedermic', 'responsivitykimigayo', 'microcrystallogenyfuniculus', 'wolfberrydeclaredness', 'ochronosusafterbody', 'Abrahamicinordinateness', 'dominionistversableness', 'frontomallarforedetermine', 'strainedlypsychopompos', 'hookahsupersimplicity', 'retroclusionmetaphysicianism', 'frolickytriphyline', 'alphabetismpolyfenestral', 'galvanothermometerBalzacian', 'erythriticsynergidal', 'interimperialvignetter', 'susurrateoutvie', 'pedestrianateStromateidae', 'appendiceunmetaled', 'counterspyingdungeon', 'chinkingcytologic', 'preservatizeskyphoi', 'catmalisoncoevally', 'Sumasslevulosuria', 'androgynyvegetoalkaline', 'spinthariscopemolybdena', 'Jesperyearlong', 'xerophagyhematography', 'yoreexponent', 'bumblefooticonology', 'laterodeviationNarciss', 'antleredadunc', 'grammaticismmignonette', 'miningFlavia', 'bombonnefiendhead', 'ridgeplatedisturbed', 'prefactoranchoret', 'refilmopenhandedness', 'ecclesiaLatinization', 'Tullianrubidium', 'perukiershiplexicographer', 'notchycoralliferous', 'dinitrilholocentrid', 'acanthopterygianMuranese', 'menialitypreintelligent', 'ineloquentundishonored', 'precoxseambiter', 'disjointedlytriamylose', 'venomouslypilferment', 'prelanguagecloudage', 'unremittinglyaffronting', 'balandracaducibranch', 'subcineritiousphrenitic', 'neurofibriljanapan', 'blepharanthracosisuncliented', 'graphologicautovaccination', 'xenogenesisprenoble', 'cesserreichspfennig', 'unenterprisedargumentatious', 'cardialgiacontingence', 'focoidsstackfreed', 'steinkirkmisaffection', 'Cobitidaedismissal', 'Eomecondiscolorate', 'isatogenvestibulum', 'Orakzaiunsatisfiedly', 'prankinglypneumotherapy', 'pavonatedcozily', 'meddlingsmall', 'euquinquennium', 'strangulableargentamid'], ['string', 'string', 'double', 'lv', 'ntohl', 'ntohl', 'letohs', 'ntohl', 'letohs', 'lv', 'letohll', 'nextproto_b']), 'petalousausterity': ([], ['letohs', 'string', 'byte', 'lv', 'letohl', 'letohll', 'letohs', 'byte', 'ntohl', 'byte', 'string', 'double', 'ntohl', 'letohs', 'letohl', 'string', 'ntohll', 'double', 'letohl', 'ntohll', 'ntohl', 'ntohll', 'ntohs', 'letohll', 'lv', 'lv']), 'codeinesalience': ([], ['letohs', 'letohs', 'letohs', 'letohll', 'lv', 'ntohll', 'byte', 'string', 'double', 'ntohll', 'ntohll', 'float', 'byte', 'double', 'string', 'double', 'ntohll', 'ntohl', 'string', 'lv', 'letohs', 'letohl', 'float', 'float', 'float', 'lv', 'lv', 'byte', 'ntohs', 'ntohl', 'lv', 'letohl']), 'solferinocircumjacence': ([], ['letohll', 'string', 'byte', 'ntohll', 'letohl', 'double', 'lv', 'ntohs', 'float', 'letohl', 'letohl', 'lv', 'ntohs', 'letohs', 'lv', 'float', 'lv', 'ntohl', 'lv', 'lv', 'ntohl']), 'unimplicitoothecal': ([], ['ntohl', 'letohll', 'float', 'float', 'float', 'ntohl', 'letohs', 'string', 'ntohll', 'ntohl', 'lv', 'ntohl', 'double', 'float', 'byte', 'lv', 'lv', 'double', 'ntohll', 'byte', 'ntohl', 'string', 'ntohll', 'float', 'ntohs', 'ntohll', 'lv', 'lv', 'ntohs', 'ntohs', 'double', 'lv', 'float', 'string', 'ntohll', 'ntohll', 'letohll']), 'precoxseambiter': ([], ['ntohl', 'string', 'letohl', 'string', 'letohl', 'ntohl', 'lv', 'letohs', 'letohs', 'ntohs', 'letohll', 'byte', 'float', 'letohl', 'letohs', 'string', 'letohs', 'byte', 'float', 'ntohll', 'float', 'lv', 'byte', 'string', 'string', 'double', 'ntohs', 'lv', 'ntohl', 'ntohl', 'letohs', 'letohl', 'byte', 'ntohll', 'string', 'double']), 'Sonjapylorogastrectomy': (['gatewiseunderpot', 'Brandipriestcraft', 'schuleclethraceous', 'diseasednessthioantimonate', 'Sumasslevulosuria', 'fleaweedprobate', 'katabolizedermic', 'predefinitionCarnaria', 'interimperialvignetter', 'recapitalizationdissipative', 'anomalousparallelinerved', 'hemianacusiadouble', 'subregenthelmeted', 'menialitypreintelligent', 'maltingsurrection', 'Robenhausianreboil', 'countryfolkintolerance', 'paleobotanyworkpeople', 'emergencechouette', 'unpopulatecurry', 'Slovenerecure', 'wolfberrydeclaredness', 'misspellquinaldic', 'raspberrylikesubvertebral', 'dissogenyBarney', 'unreprovedlysprier', 'spinthariscopiclieutenancy', 'ivoryliketransessentiate', 'vaporizetannery', 'domanialPhora', 'appendiceunmetaled', 'summarizationyatter', 'TelopeaCyclotosaurus', 'Triuridalesplagiarism', 'sulphhemoglobinHerculanean', 'gemeledAdonai', 'opportunisttitlark', 'subordinationbrachial', 'agonizefloating', 'bullswooldraggletail', 'simulcastriboflavin', 'tenodesisunroaming', 'unexchangedsupraventricular', 'amlipyrexic', 'bumblefooticonology', 'nonadjustmentwritmaking', 'flashpanstature', 'cantingnesstideful', 'oxmanoutpull', 'predesignateunderservice', 'heliconbonnetman', 'xenopodidtrencherless', 'splanchnopleureprelapsarian', 'reburstsummity', 'scheltopusikAmpelidaceae', 'pedestrianateStromateidae', 'kansrush', 'Maytimeraillike', 'focoidsstackfreed', 'loungyimpolite', 'zeuctocoelomicmetapodial', 'foliicolousskeletonweed', 'doubleheartedstaphylolysin', 'lemologydiplasion', 'predisciplinetukra', 'Dokoelectrochemically', 'wutproamusement'], ['nextproto_b', 'byte', 'letohl', 'byte', 'nextproto_b', 'ntohs', 'string', 'lv', 'string', 'double', 'letohl', 'nextproto_b', 'float', 'letohll', 'lv', 'nextproto_b', 'letohs', 'nextproto_b', 'letohl', 'ntohll', 'byte', 'ntohll', 'double', 'letohll', 'double', 'letohl', 'ntohll', 'ntohs', 'nextproto_b', 'ntohl', 'letohs', 'ntohll', 'string', 'double', 'letohs', 'letohl', 'string', 'ntohll', 'ntohll', 'letohs', 'ntohl', 'byte', 'letohll', 'letohl', 'ntohl', 'letohll']), 'unodoriferousWhiggish': (['venomouslypilferment', 'sideflashmagniloquent', 'Anglomaniaclovableness', 'steinkirkmisaffection', 'hetericismswayable', 'acquisitumvaletudinarist', 'semistillpassback', 'disjointedlytriamylose', 'reladepropiolaldehyde', 'tollgateandrophagous', 'prosubscriptiontribracteate', 'phototherapistupsetted', 'scutcheonwiseileocolitis', 'elementalismpietism', 'intrathoraciccoemployment', 'mataiuntameness', 'Vandiemenianwinery', 'consignificationmarshbuck', 'Oliveanpyromancer', 'nondistributionclitellus', 'ivoryliketransessentiate', 'cacuminalgastrohysterorrhaphy', 'sageshipcarcoon', 'superabsurdditremid', 'graphologicautovaccination', 'TelopeaCyclotosaurus', 'untuckedsolenoglyphic', 'dunneaneuploidy', 'usurperunplannedly', 'spadelikemassacrer', 'piskgriff'], ['ntohl', 'byte', 'ntohl', 'letohll', 'nextproto_s', 'letohs', 'double', 'letohll', 'ntohl', 'nextproto_s', 'ntohs', 'ntohs', 'letohs', 'lv', 'byte', 'lv', 'string', 'byte', 'double', 'string', 'byte', 'byte', 'lv', 'lv', 'nextproto_b', 'lv', 'lv', 'ntohll', 'letohl', 'letohs', 'string', 'string', 'double', 'nextproto_s', 'float', 'letohs', 'float', 'double', 'ntohll', 'letohll', 'letohl', 'letohs', 'letohl', 'letohs', 'string', 'double', 'letohll', 'byte']), 'mercurializationsimulacre': ([], ['string', 'letohl', 'float', 'letohll', 'byte', 'float', 'lv', 'float', 'ntohs', 'double', 'ntohll', 'ntohl', 'double', 'lv', 'double', 'string', 'letohs', 'letohs', 'lv', 'string', 'ntohll', 'string', 'byte', 'ntohs', 'float', 'letohl', 'double', 'ntohs', 'lv', 'byte', 'lv', 'ntohl', 'ntohl']), 'diseasednessthioantimonate': ([], ['ntohs', 'ntohs', 'double', 'letohll', 'lv', 'ntohs', 'string', 'letohl', 'ntohll', 'double', 'byte', 'letohll']), 'colletingobylike': ([], ['ntohl', 'letohll', 'ntohll', 'ntohll', 'float', 'letohs', 'string', 'ntohl', 'double', 'float', 'ntohs', 'letohl', 'lv', 'ntohs', 'letohs', 'ntohll', 'string', 'ntohl', 'letohs', 'ntohs', 'lv', 'float', 'string', 'lv', 'ntohs', 'letohs', 'letohs', 'lv', 'letohl', 'ntohll', 'string', 'ntohll', 'byte', 'letohll', 'lv', 'float', 'lv']), 'Philoctetessupersalesman': ([], ['float', 'letohll', 'double', 'double', 'ntohl', 'letohs', 'byte', 'letohl', 'letohll', 'float', 'double', 'letohl', 'byte', 'ntohl', 'letohll', 'letohs', 'ntohll', 'ntohl', 'lv', 'ntohll', 'string', 'ntohl', 'ntohll', 'byte', 'ntohll', 'ntohs', 'ntohl']), 'hetericismswayable': (['Pamirioversystematic', 'sacroposteriorveratryl', 'tautoousianentente', 'subordinationbrachial', 'sokarailer', 'veldcraftsubprefect', 'unhittabledoublehorned', 'evaluecystatrophia', 'malthouseenteralgia', 'hetericismswayable', 'countryfolkintolerance', 'crouchingpurebred', 'cylindrarthrosisnonplusation', 'blepharanthracosisuncliented', 'outworthbenevolence', 'Bryumextrafocal'], ['float', 'letohl', 'letohll', 'letohll', 'byte', 'lv', 'float', 'float', 'double', 'ntohl', 'letohs', 'letohl', 'letohs', 'byte', 'lv']), 'Dokoelectrochemically': ([], ['byte', 'ntohll', 'letohll', 'lv', 'letohs', 'byte', 'float', 'ntohs', 'letohl', 'byte', 'byte', 'ntohs', 'lv', 'lv', 'float', 'letohll', 'double']), 'invulnerabledimerization': ([], ['byte', 'float', 'letohs', 'letohll', 'ntohs', 'ntohll', 'letohll', 'ntohll', 'string', 'lv', 'letohs', 'ntohl', 'string', 'letohl', 'letohs', 'letohll', 'lv', 'ntohs', 'ntohll', 'letohl', 'double', 'letohll', 'letohs', 'string', 'string', 'string', 'letohs', 'letohl', 'float', 'ntohl', 'letohll', 'double', 'letohl', 'ntohl', 'lv', 'ntohl', 'byte', 'string', 'letohs', 'double', 'byte']), 'whiskerypodoscapher': ([], ['ntohs', 'letohs', 'ntohl', 'string', 'letohs', 'double', 'lv', 'letohs', 'ntohll', 'letohs', 'ntohll', 'double', 'ntohl', 'double', 'ntohs', 'ntohl', 'ntohl', 'letohll', 'letohs', 'lv', 'lv', 'float', 'float', 'ntohs', 'ntohs']), 'opportunisttitlark': (['intrathoraciccoemployment', 'saltlypropugnator', 'xenopodidtrencherless', 'katabolizedermic', 'epigenesistbisexed', 'maltingsurrection', 'veldcraftsubprefect', 'xenogenesisprenoble', 'hyperneuriasymbolatry', 'sacroposteriorveratryl', 'udometricpredefault', 'outworthbenevolence', 'apioidalNagari', 'predesignateunderservice', 'susurrateoutvie', 'sokarailer', 'Tullianrubidium', 'tautoousianentente', 'cannotdentigerous', 'amlipyrexic', 'bullswooldraggletail', 'peccationfoolery', 'sheepkeepingfeedman', 'unbeggarbroncholithiasis', 'strangulableargentamid', 'Triuridalesplagiarism', 'menialitypreintelligent', 'piskgriff', 'foliicolousskeletonweed', 'barrelmakingparoemia', 'unreprovedlysprier', 'pneumodynamicsprimariness', 'subordinationbrachial', 'Orakzaiunsatisfiedly', 'spraysemisaprophyte', 'asperationoraculousness', 'weathercockismcustodier'], ['letohs', 'ntohl', 'double', 'nextproto_b', 'ntohl', 'double', 'nextproto_s', 'letohs', 'byte', 'byte', 'float', 'nextproto_s', 'ntohl', 'letohll', 'string', 'float', 'ntohs', 'letohl', 'ntohl', 'nextproto_s', 'letohs', 'ntohll', 'double', 'ntohl', 'ntohs', 'letohll', 'float', 'ntohs', 'letohs', 'nextproto_s', 'ntohl', 'double', 'byte', 'letohll', 'double', 'ntohl', 'lv', 'ntohll', 'byte', 'nextproto_s', 'letohl', 'nextproto_s', 'float']), 'allerChilostoma': ([], ['lv', 'ntohll', 'byte', 'letohl', 'byte', 'ntohll', 'byte', 'byte', 'letohl', 'double', 'letohl', 'ntohll', 'byte', 'letohs', 'string', 'letohll', 'letohs', 'double', 'float', 'letohs', 'ntohll', 'float', 'string', 'double', 'float', 'letohl', 'lv', 'double', 'ntohl', 'ntohl', 'letohl', 'ntohll', 'lv', 'byte', 'double', 'float', 'ntohs', 'ntohl', 'letohs']), 'dissogenyBarney': ([], ['lv', 'lv', 'letohll', 'lv', 'byte', 'letohll', 'letohll', 'ntohl']), 'ectallycoenosteal': ([], ['ntohl', 'letohll', 'double', 'ntohs', 'double', 'string', 'letohs', 'ntohll', 'double', 'ntohl', 'ntohl', 'ntohl', 'float', 'ntohl', 'letohll', 'float', 'ntohs', 'lv', 'float', 'string', 'ntohll', 'letohll', 'float', 'ntohl', 'ntohl', 'byte', 'letohs', 'letohl', 'string', 'ntohs', 'string', 'letohll', 'byte', 'double', 'double', 'ntohl']), 'settlehydrophid': ([], ['ntohs', 'letohl', 'lv', 'float', 'letohl', 'ntohs', 'string', 'ntohs', 'letohll', 'byte', 'letohl', 'ntohl', 'ntohll', 'letohll', 'letohll', 'float', 'ntohll', 'double', 'float', 'ntohll', 'ntohs', 'string', 'ntohll', 'ntohs', 'ntohl', 'letohll', 'letohs', 'string', 'letohl', 'string', 'ntohs', 'letohs', 'float', 'ntohs', 'lv', 'double', 'letohl', 'byte', 'letohl', 'letohl', 'string', 'string', 'double']), 'huddlingcladautoicous': ([], ['lv', 'letohl', 'double', 'lv', 'letohll', 'lv', 'double', 'ntohs', 'string', 'letohl', 'letohs', 'ntohl', 'letohs', 'float', 'string', 'lv', 'string', 'lv', 'ntohl', 'ntohl', 'letohll', 'string', 'letohll', 'ntohs', 'letohs']), 'pilchermonaulos': ([], ['letohs', 'ntohll', 'string', 'letohs', 'double', 'ntohl', 'double', 'ntohll', 'lv', 'string', 'float', 'letohl', 'letohl', 'byte', 'ntohll', 'ntohl', 'letohs', 'float', 'letohll', 'ntohll', 'byte', 'letohl', 'letohs', 'ntohs', 'double', 'letohll', 'byte']), 'monogamianportio': ([], ['double', 'string', 'byte', 'ntohs', 'letohl', 'float', 'letohl', 'letohl', 'letohll', 'letohs', 'ntohs', 'ntohs', 'letohll', 'letohs', 'float', 'double', 'ntohl', 'letohll', 'float', 'double', 'string', 'string', 'ntohll', 'float', 'ntohs', 'byte', 'letohl', 'letohs', 'string', 'double', 'ntohl', 'ntohll', 'double', 'ntohl', 'ntohl', 'lv', 'letohl', 'letohs', 'float', 'string']), 'premortuarybenchy': (['lepidodendridcounterplead', 'flashpanstature', 'noggencapitulate', 'cesserreichspfennig', 'symptosissubcorneous', 'frolickytriphyline', 'interimperialvignetter', 'correctorSpirochaeta', 'unhittabledoublehorned', 'warfaringdraghound', 'carannaaccension', 'ochronosusafterbody', 'pellagrosemongrelization', 'snakeletwounds', 'arecolidinehyalodacite', 'sageshipcarcoon', 'oxmanoutpull', 'nonadjustmentwritmaking', 'dissogenyBarney', 'pilchermonaulos', 'raspberrylikesubvertebral', 'napalmbrevifoliate', 'misspellquinaldic', 'superestablishmentsuccor', 'Eomecondiscolorate', 'yoreexponent', 'unsubstantiaterightfulness', 'heliconbonnetman', 'racegoingunperformed', 'clientageshudderingly', 'Triuridalesplagiarism', 'lemologydiplasion', 'chytridialgoosemouth', 'huddlingcladautoicous', 'sokarailer', 'yawpwoodwax', 'cylindrarthrosisnonplusation', 'prosubscriptiontribracteate', 'slichtarradiddler'], ['nextproto_s', 'ntohs', 'string', 'nextproto_b', 'ntohll', 'letohs', 'ntohl', 'lv', 'ntohll', 'ntohll', 'double', 'letohll', 'nextproto_s', 'string', 'string', 'lv', 'nextproto_b', 'ntohs', 'lv', 'string', 'nextproto_s', 'letohll', 'double', 'float', 'ntohs', 'letohll', 'ntohl', 'ntohs', 'ntohs', 'nextproto_s', 'ntohs', 'letohs', 'string']), 'toxiferousphthalate': (['subregenthelmeted', 'alveololingualMindererus'], ['ntohs', 'ntohl', 'lv', 'nextproto_s', 'byte', 'ntohll', 'float', 'nextproto_s', 'double', 'float', 'ntohs', 'letohl', 'float', 'ntohl', 'string', 'letohs', 'letohl', 'letohs', 'letohll', 'ntohl', 'string', 'lv', 'ntohl', 'float', 'ntohs', 'letohl', 'float', 'lv', 'nextproto_s', 'lv', 'ntohs', 'float', 'ntohl', 'letohll', 'double', 'ntohs', 'nextproto_s', 'letohs', 'ntohs', 'letohs']), 'algorithmicSericana': ([], ['ntohs', 'byte', 'letohll', 'letohs', 'letohll', 'string', 'ntohs', 'string', 'ntohs', 'ntohs', 'letohl', 'string', 'ntohs', 'ntohl', 'string', 'double', 'letohs', 'string', 'ntohl', 'double']), 'counterpotentMetabola': ([], ['letohl', 'letohs', 'ntohl', 'byte', 'byte', 'double', 'byte', 'letohl', 'double', 'letohll', 'letohl', 'string', 'ntohll', 'double', 'double', 'lv', 'letohl', 'letohl', 'double', 'ntohl', 'double', 'float', 'float', 'letohl', 'ntohll', 'letohll', 'double', 'byte', 'byte', 'string', 'float', 'ntohll', 'double', 'letohs', 'lv', 'letohs', 'string', 'letohll', 'double', 'ntohs']), 'concussionalmonobromoacetanilide': ([], ['ntohs', 'letohs', 'double', 'ntohl', 'byte', 'letohll', 'byte', 'string', 'byte', 'byte', 'double', 'byte']), 'tautologicpanimmunity': (['tollgateandrophagous', 'isatogenvestibulum', 'semicolumnrankly', 'surlyreptilferous', 'racegoingunperformed', 'isuroidunfitly', 'maltingsurrection', 'sokarailer', 'unexchangedsupraventricular', 'epistlarcystoid', 'listeningBroussonetia', 'focoidsstackfreed', 'Lespedezafuthorc', 'untastedgirllike', 'Lawsonsemiconversion', 'Voltaprotarsal', 'domanialPhora', 'Erotylidaeprehesitate', 'Oliveanpyromancer'], ['ntohll', 'ntohll', 'byte', 'ntohs', 'byte', 'ntohl', 'ntohll', 'float']), 'Cobitidaedismissal': ([], ['string', 'ntohs', 'byte', 'lv', 'letohll', 'string', 'letohl', 'ntohll', 'letohll', 'ntohl', 'lv', 'letohl', 'ntohll', 'ntohs', 'byte', 'ntohll', 'letohl', 'ntohl', 'ntohs', 'ntohll', 'letohs', 'ntohl']), 'Bryumextrafocal': (['cesserreichspfennig', 'mattapharyngological', 'pneumodynamicsprimariness', 'semicolumnrankly', 'blepharanthracosisuncliented', 'collationdissuasively', 'outworthbenevolence', 'peccationfoolery', 'unmistgraffer', 'unbeggarbroncholithiasis'], ['nextproto_s', 'nextproto_s', 'double', 'ntohl', 'letohl', 'lv', 'letohs', 'nextproto_s', 'ntohs', 'letohs']), 'bumblefooticonology': ([], ['letohs', 'letohll', 'string', 'ntohs', 'ntohll', 'double', 'ntohl', 'string', 'ntohl', 'ntohll']), 'multicrystallinekeratoglossus': ([], ['ntohll', 'letohl', 'ntohll', 'ntohl', 'lv', 'letohl', 'ntohll', 'string', 'lv', 'ntohl', 'double', 'letohs', 'float', 'float', 'double', 'ntohs', 'ntohl', 'ntohl', 'ntohs', 'letohl', 'ntohs', 'byte', 'ntohll', 'ntohs', 'string', 'string', 'letohll', 'letohll', 'ntohll', 'ntohl', 'ntohl', 'letohl', 'letohll', 'letohs', 'ntohll', 'string', 'double', 'ntohll', 'letohl', 'letohs', 'ntohs', 'letohl']), 'withsavesatinize': ([], ['ntohl', 'letohs', 'float', 'letohl', 'letohs', 'letohs', 'byte', 'ntohs', 'ntohl', 'double', 'ntohs', 'float', 'byte', 'ntohs', 'ntohs', 'double', 'letohs', 'ntohll', 'ntohl', 'letohs', 'ntohs', 'ntohl', 'string', 'float', 'ntohl', 'double', 'ntohll']), 'splanchnopleureprelapsarian': ([], ['letohll', 'ntohl', 'ntohl', 'letohll', 'byte', 'letohs', 'letohll', 'letohl', 'lv', 'ntohll', 'double', 'letohs', 'ntohll', 'letohl', 'string', 'lv', 'byte', 'string', 'letohll', 'letohs', 'float', 'float', 'string', 'letohll']), 'pegologyscavenage': ([], ['ntohs', 'ntohll']), 'slopinglyautomatically': (['unflukedcleck', 'goniometerhexameral', 'tollgateandrophagous', 'noggencapitulate', 'untastedgirllike', 'foreuseuninfluencing', 'hematozoalinfinitarily', 'unsubstantiaterightfulness', 'wingerconsoler', 'Steganophthalmiagnomic', 'ineloquentundishonored', 'cystocarppapaprelatical', 'arecolidinehyalodacite', 'slichtarradiddler', 'cudavaogreish', 'photoheliographoctuplicate', 'utterabilitypavement', 'heliconbonnetman', 'skeelysubtriangular', 'Orakzaiunsatisfiedly', 'slopinglyautomatically', 'lepidodendridcounterplead', 'bacteriformpiercel', 'Brandipriestcraft', 'clientageshudderingly', 'premortuarybenchy', 'awiwimegaloglossia', 'dextrosinistralElaeococca', 'bombonnefiendhead', 'shuttlecockscanmag', 'visorlikeNagari', 'xiphosternamedia', 'Philoctetessupersalesman', 'retroclusionmetaphysicianism', 'remirrorundepreciated', 'misspellquinaldic', 'overseateddiscouragingly', 'doubleheartedstaphylolysin', 'veldcraftsubprefect', 'vivifybenefactorship', 'subsorterbecuffed', 'flashpanstature', 'Sarothrawrencher', 'undercovertcoloss', 'Plymouthistnashgab', 'prelanguagecloudage', 'unoverhauledGalinsoga', 'contrarietyinconceivableness'], ['ntohs', 'lv', 'float', 'nextproto_b', 'nextproto_s', 'letohll', 'byte', 'ntohll', 'ntohl', 'nextproto_s', 'nextproto_b']), 'trammelingprotrude': ([], ['double', 'letohl', 'ntohs', 'letohs', 'ntohl', 'double', 'letohll', 'lv', 'ntohl', 'ntohl', 'float', 'ntohs', 'float', 'float', 'ntohl', 'letohll', 'lv', 'string', 'ntohs', 'string', 'ntohll', 'letohll', 'letohll', 'ntohs', 'byte', 'letohs', 'double', 'ntohs', 'letohll', 'letohs', 'lv', 'double', 'string', 'float', 'byte', 'letohs']), 'photoheliographoctuplicate': ([], ['ntohll', 'letohll', 'byte', 'byte', 'letohs', 'ntohs', 'double', 'double', 'ntohll', 'double', 'float', 'string', 'letohl', 'ntohs', 'lv', 'ntohll', 'lv', 'ntohl', 'ntohll', 'byte', 'letohs', 'letohs', 'string', 'letohll', 'letohs', 'letohl', 'letohl', 'letohll', 'letohll', 'ntohl', 'float', 'ntohll', 'lv']), 'recapitalizationdissipative': ([], ['letohl', 'lv', 'letohl', 'letohll', 'lv', 'letohs', 'letohll']), 'syenitemanufactural': ([], ['letohs', 'ntohs', 'lv', 'letohl', 'ntohl', 'lv', 'float', 'lv', 'letohl', 'letohll', 'double', 'ntohs', 'ntohll', 'ntohl', 'byte', 'string', 'lv']), 'ochronosusafterbody': (['menialitypreintelligent', 'cylindrarthrosisnonplusation', 'ornithotomyblackwort', 'piskgriff', 'predesignateunderservice', 'intrathoraciccoemployment', 'steelworkpsychophysiological', 'saltlypropugnator', 'pneumodynamicsprimariness', 'hyperneuriasymbolatry', 'perukiershiplexicographer', 'dehydrogenizeCambrian', 'sokarailer', 'weathercockismcustodier', 'Steganophthalmiagnomic', 'tellurethurryproof', 'subordinationbrachial', 'loungyimpolite', 'crouchingpurebred', 'veldcraftsubprefect', 'pilchermonaulos', 'mattapharyngological', 'bawcockPicnickian', 'hetericismswayable', 'blepharanthracosisuncliented', 'asperationoraculousness', 'symmetricalantimasker', 'ochronosusafterbody', 'cassiteritecasemaking', 'maltingsurrection', 'spraysemisaprophyte', 'evaluecystatrophia', 'superabsurdditremid', 'cannotdentigerous', 'focoidsstackfreed', 'goniometerhexameral', 'peccationfoolery', 'unreprovedlysprier', 'xenopodidtrencherless', 'Bryumextrafocal', 'tautoousianentente'], ['nextproto_s', 'letohl', 'lv']), 'steinkirkmisaffection': (['stagemansupa', 'weathercockismcustodier', 'prelanguagecloudage', 'gumdiggingsalvarsan', 'Voltaprotarsal', 'coeternaloverhonor', 'yoreexponent', 'monodromiclyretail', 'ureterorrhagiahemogenetic', 'flashpanstature', 'cancelationZoochlorella', 'heliconbonnetman', 'huddlingcladautoicous', 'intercoolingpotentialization', 'unrevenuedindecorousness', 'dejectedincreasing', 'subordinationbrachial', 'warfaringdraghound', 'evaluecystatrophia', 'stomagringo', 'interimperialvignetter', 'usurperunplannedly', 'TaboriteSanche', 'sowbackgastrotrichan', 'prehexameraldissyllabize', 'allegoristerserendite', 'Fichteanismconjobble', 'fetoracclimatement', 'matelessbeatitude', 'susurrateoutvie', 'steinkirkmisaffection', 'keraunophoneinhabited', 'hammerkopnegativer', 'repealistbillsticking', 'Ternstroemiaanisostomous', 'symptosissubcorneous', 'pellagrosemongrelization', 'isuroidunfitly', 'querulouslycooky', 'distilleryKiwanis', 'schuleclethraceous', 'pantomnesiadiporpa', 'Momotinaenonfortification', 'lindengamy', 'Cobitidaedismissal', 'springlikemonosymmetrically', 'erythriticsynergidal', 'ecclesiaLatinization', 'predisciplinetukra', 'menialitypreintelligent', 'ettleoptimize', 'frolickytriphyline', 'Eomecondiscolorate', 'sokarailer', 'predesignateunderservice', 'terribletaut', 'vibrativeoversail', 'thysanuriformcrossrail', 'epistlarcystoid', 'unstalledneutralism', 'mattapharyngological', 'saltlypropugnator', 'adminiculatephosphosilicate'], ['letohl', 'ntohs', 'byte', 'double', 'ntohl', 'ntohll', 'letohll', 'nextproto_s', 'float', 'double']), 'noniccosmopoietic': ([], ['letohll', 'float']), 'bemuzzlesurficial': ([], ['string', 'ntohs', 'letohs', 'double', 'letohs', 'string', 'double', 'ntohll', 'ntohl', 'ntohs', 'letohll', 'ntohs', 'ntohs', 'ntohs', 'string', 'letohs', 'double', 'letohll', 'ntohs', 'ntohl', 'letohll', 'lv', 'ntohs', 'float', 'byte']), 'exempttanninlike': (['secrecyheteroecy', 'phototherapistupsetted', 'overgenialitybuzzle', 'semiduplexskirt', 'semicolumnrankly', 'volubilityThuidium', 'cardinghygeistic', 'assecurationAshkenazim', 'iconismanisostemonous', 'tartishlynarcotical', 'epexegeticallyreadjournment', 'dermobranchiataboyardom', 'prosubscriptiontribracteate', 'subcostalbaldmoney', 'indubitablenoncollaboration', 'deadlockperiangitis', 'Slovenerecure', 'indirecthierarchism', 'microcaltropmyosarcomatous', 'Pamirioversystematic', 'importationPerisphinctidae', 'anapneaCystignathidae', 'appendiceunmetaled', 'rathmemorizable', 'ricketssubtrihedral', 'OrleansSchedius', 'seminegroSemiticize', 'brackishrehazard', 'skeesicksunsteamed', 'petalocerouscamus', 'endopathicnonmarrying', 'refilmopenhandedness', 'Philonismpinivorous', 'algorithmicSericana', 'catagmaticMegalosaurus', 'Senecanovercorruptly', 'Nathanielbiliteral', 'peragratemultifoliate', 'laurdalitewistonwish', 'reladepropiolaldehyde', 'sulphhemoglobinHerculanean', 'stickleafethenyl', 'rhynchophoranunwinking', 'congregationalvocimotor', 'nugacioushypotensive', 'domanialPhora', 'summarizationyatter', 'intrathoraciccoemployment', 'awiwimegaloglossia', 'onomatopoeiaeggfish', 'autoplastycava', 'frolickytriphyline', 'somnipathistcarbonometry', 'funestworser', 'correctorSpirochaeta', 'damnonianscrankly', 'avalanchestylopization', 'hallowerhydrophthalmos', 'Ibaditehypotenuse', 'delthyrialGee'], ['nextproto_b', 'letohll', 'ntohs', 'letohs', 'float', 'float', 'string', 'lv', 'ntohll', 'byte', 'double', 'float', 'float', 'string', 'ntohs', 'nextproto_b', 'letohl', 'float', 'letohll', 'nextproto_s', 'ntohl', 'ntohll', 'nextproto_s', 'float', 'float', 'byte', 'letohll', 'nextproto_s', 'ntohl', 'letohl', 'string', 'letohll', 'ntohs', 'letohl', 'string', 'ntohs', 'nextproto_s', 'letohl', 'nextproto_b', 'letohl', 'lv', 'lv', 'ntohs', 'letohs', 'nextproto_s', 'lv', 'letohll']), 'forswearfreewheel': ([], ['byte', 'byte', 'lv', 'ntohl', 'ntohll', 'letohs', 'letohs', 'byte', 'ntohs', 'double', 'byte', 'byte', 'lv', 'float', 'ntohll', 'letohl', 'double', 'letohs', 'letohl', 'ntohs', 'double', 'ntohll', 'ntohll', 'lv', 'byte', 'letohs', 'float']), 'carpolitemortifier': ([], ['letohs']), 'hungerlysphenocephaly': ([], ['string', 'letohll', 'letohs', 'letohll', 'ntohs', 'float', 'ntohll', 'ntohll', 'double', 'byte', 'float', 'lv', 'ntohll', 'letohl', 'double', 'string', 'letohl', 'letohl', 'lv', 'letohs', 'float', 'byte', 'letohl', 'string', 'byte']), 'Stromatoporoideabarry': (['radiopaqueunrecruitable', 'steelworkpsychophysiological', 'carannaaccension', 'mattapharyngological', 'wutproamusement', 'subregenthelmeted', 'opportunisttitlark', 'Eomecondiscolorate', 'anomalousparallelinerved', 'chaffererunheaded', 'focoidsstackfreed', 'etioporphyrinpubovesical', 'Lespedezafuthorc', 'apioidalNagari', 'spinthariscopemolybdena', 'cardialgiacontingence', 'usurperunplannedly', 'frolickytriphyline', 'predesignateunderservice', 'bawcockPicnickian', 'pilchermonaulos', 'visorlikeNagari', 'crouchingpurebred', 'outworthbenevolence', 'amlipyrexic', 'esophagoplastyrestrainedness', 'Piscataqualagoonal', 'changeablyzoophilitic', 'woodrowelshrievalty', 'dehydrogenizeCambrian', 'semicolumnrankly', 'peccationfoolery', 'barrelmakingparoemia', 'cancelationZoochlorella', 'subordinationbrachial', 'cacuminalgastrohysterorrhaphy', 'strangulableargentamid', 'veldcraftsubprefect', 'intrathoraciccoemployment', 'unlasheddialyzable', 'asepticallyBernese', 'dermoiddiversifiable', 'malthouseenteralgia', 'prattlersuffumigate', 'tenesmicHymettic', 'udometricpredefault', 'goniometerhexameral', 'coeternaloverhonor', 'bullswooldraggletail', 'asperationoraculousness', 'epigenesistbisexed', 'cassiteritecasemaking', 'dermobranchiataboyardom', 'evaluecystatrophia', 'tautoousianentente', 'sokarailer', 'ornithotomyblackwort', 'katabolizedermic', 'blepharanthracosisuncliented', 'refilmopenhandedness', 'sheepkeepingfeedman', 'utterabilitypavement', 'symmetricalantimasker', 'paleobotanyworkpeople', 'Vandiemenianwinery', 'hammerkopnegativer', 'unmistgraffer', 'foliicolousskeletonweed', 'isuroidunfitly', 'cystocarppapaprelatical', 'superabsurdditremid', 'xenogenesisprenoble', 'maltingsurrection', 'syphilologyannularity', 'iconismanisostemonous', 'Bryumextrafocal'], []), 'alkaneirrigable': (['leathermakersemishirker', 'ettleoptimize', 'orographicniddick', 'Ibaditehypotenuse', 'buprestidanarithmetic', 'carcerationinterrenal', 'prerailwaycannibalistically', 'responsivitykimigayo', 'ineloquentundishonored', 'mattapharyngological', 'qualmyishHolocene', 'volubilityThuidium', 'Philoctetessupersalesman', 'marblelikeTenaktak', 'unhittabledoublehorned', 'subsoilercruent', 'rosiedunarchdeacon', 'unhyphenedallose', 'unremittinglyaffronting', 'raspberrylikesubvertebral', 'tuchunateacademization', 'radomenetherwards', 'onomatopoeiaeggfish', 'mammillationpemphigous'], ['byte', 'string', 'letohll', 'ntohl']), 'withoctopede': ([], ['byte', 'byte', 'letohll', 'lv', 'float', 'ntohll', 'double', 'letohl', 'letohll', 'ntohll', 'string', 'float', 'lv', 'ntohll', 'float', 'float', 'letohs', 'letohll', 'ntohll', 'letohs', 'letohs', 'byte', 'ntohll', 'ntohs', 'string', 'lv', 'string', 'float', 'letohs', 'letohl', 'ntohll', 'string', 'ntohl', 'byte', 'lv']), 'autozooidexternization': ([], ['letohs']), 'tranquilizeallochetite': (['agonizefloating', 'perukiershiplexicographer', 'oxmanoutpull', 'xenopodidtrencherless', 'overdiligentlyrifleshot', 'allanitictrichitis', 'assentaneoushemal', 'thysanuriformcrossrail', 'precoxseambiter', 'Pileabayadere', 'blossomscrimshander', 'mataiuntameness', 'improvisatorizenoneditorial', 'yawpwoodwax', 'polishedlyhematosis', 'vibrativeoversail', 'oversoldafield', 'Vandiemenianwinery', 'chromophilouspyometra', 'saddirhamtaxometer', 'heronerchondroplasty', 'unimplicitoothecal', 'exarteritisthenadays', 'unsilentiousskimpy', 'goniometerhexameral', 'urogastricjesting', 'veldcraftsubprefect', 'teleophoreunspinsterlike', 'unenterprisedargumentatious', 'triquetricinfrasternal', 'affinitativelybrawling', 'inwrapbilophodont', 'calycoideousunpressed', 'chaffererunheaded', 'chiliasticskean', 'cinecameraHydropotes', 'triplewisepostepileptic', 'splanchnopleureprelapsarian', 'cotteextubate', 'typhemiacubit', 'deletoryrollerskating', 'appendiceunmetaled', 'outwindowmesothoracic', 'emblazonarsenopyrite', 'SpatangusChayma', 'unpopulatecurry'], ['float', 'float', 'ntohll', 'double', 'letohl', 'string', 'byte', 'double', 'nextproto_s', 'ntohll', 'double', 'ntohs', 'nextproto_b', 'float', 'letohs', 'letohll', 'ntohs', 'letohl', 'letohl']), 'entrapmentvoyageable': ([], ['lv', 'ntohll', 'ntohs', 'double', 'float', 'ntohll', 'double']), 'respitelesssuccenturiation': ([], ['string', 'ntohs', 'float', 'double', 'letohl', 'letohs', 'letohl', 'byte', 'letohll', 'byte', 'lv', 'double', 'ntohl', 'ntohs', 'letohll', 'ntohll', 'letohs', 'ntohs', 'letohll', 'ntohll', 'double', 'float', 'ntohs', 'ntohs', 'byte', 'string', 'lv', 'letohl', 'letohl', 'byte', 'ntohs', 'letohl', 'ntohs', 'letohll']), 'unpopulatecurry': ([], ['letohll', 'ntohs', 'lv', 'letohs', 'ntohll', 'ntohl', 'float', 'string', 'letohs', 'float', 'letohl', 'ntohll', 'string', 'byte', 'letohl', 'byte', 'letohll', 'byte', 'ntohll', 'double', 'letohs', 'lv', 'byte']), 'toyingere': (['depositumspiritsome', 'hematozoalinfinitarily', 'preservatizeskyphoi', 'tellurethurryproof', 'integralizationbremeness', 'lepidodendridcounterplead', 'stakeholderunforbade', 'cycloolefinmonostylous', 'unpaintterebinic', 'delthyrialGee', 'clientageshudderingly', 'demibeastuninflicted', 'goniometerhexameral', 'Mayorunahybridizer', 'Aparaipsychiatrist', 'cineplastyanonang', 'Bharatadomain', 'noniccosmopoietic', 'intercoolingpotentialization', 'spraysemisaprophyte', 'pilchermonaulos', 'usurperunplannedly', 'cicisbeismGonystylus', 'subsoilercruent', 'plurifacialmicrographical', 'doubleheartedstaphylolysin', 'hammerkopnegativer', 'prankinglypneumotherapy', 'monogamianportio', 'outdoortenorister', 'unvoiceCamacan', 'protosiphonaceousossiferous', 'leathermakersemishirker', 'cudavaogreish', 'crossboltedasexually', 'raucousEstheriidae', 'triquetricinfrasternal', 'galledisocinchomeronic', 'nonofficeholdingwaldgravine', 'loungyimpolite', 'unfannedhopperman', 'sincerenessundominoed', 'subsorterbecuffed', 'motacillinewidespreadly', 'archcrownundistantly', 'dinitrilholocentrid', 'Nathanielbiliteral', 'fetoracclimatement', 'unhittabledoublehorned', 'sheepkeepingfeedman', 'Philoctetessupersalesman', 'exportnontarnishable', 'Rodolphhumuslike', 'diseasednessthioantimonate', 'dejectedincreasing', 'cardinghygeistic', 'rewhirlhypermotility', 'depositoryteloblastic', 'syphilologyannularity', 'xerophagyhematography', 'vaporizetannery', 'uncomminutedcommix', 'cognaticalintransmissible', 'extravagantkaryoplasmatic', 'Orakzaiunsatisfiedly', 'consignificationmarshbuck', 'ralphautonomically', 'unquailingshive', 'funestworser', 'practicelegitimatist', 'submountainhopper', 'valvotomypensionably', 'unfeasiblecollodiotype', 'Lawsonsemiconversion'], ['double', 'double', 'byte', 'double', 'lv', 'letohs', 'nextproto_b', 'letohll', 'double', 'letohll', 'ntohl', 'lv', 'ntohll', 'letohl', 'byte', 'letohl']), 'uplookbootlegger': (['trichitepersonship', 'kansrush', 'mattapharyngological', 'Oliveanpyromancer', 'dominionistversableness', 'plurifacialmicrographical', 'elephantryleptocephalan', 'recapitalizerelevate', 'pellagrosemongrelization', 'semisomnolencegunj', 'silcretemercurous', 'Boneyretreater', 'unscalednessChamaeleon', 'chaffererunheaded', 'anomalousparallelinerved', 'shortcakeabase', 'coeternaloverhonor', 'subrelationsepiolite', 'lemologydiplasion', 'alphabetismpolyfenestral', 'predisciplinetukra', 'rattlepodMuntiacus', 'cycloolefinmonostylous', 'predefinitionCarnaria', 'scleroblastemicpalaeocosmology', 'vibrativeoversail', 'summarizationyatter', 'heronerchondroplasty', 'Eurypteroideachamaeprosopic', 'whitewareCladoselachidae', 'renverseundethroned', 'dissuasivenessnondeforestation', 'epigenesistbisexed', 'superestablishmentsuccor', 'Ternstroemiaanisostomous', 'ineloquentundishonored', 'prerailwaycannibalistically', 'kempstergarefowl', 'fleaweedprobate', 'ralphautonomically', 'Bombycillahonoraria', 'counterspyingdungeon', 'decimosextountractarian', 'dracontiasisinterparliamentary', 'brackishrehazard', 'redepositsubclassify', 'iodolabsolutistic', 'settlehydrophid', 'ramraceBorderies', 'paleocrystallinespinulosodenticulate', 'utterabilitypavement', 'gemeledAdonai', 'saltlypropugnator', 'spadelikemassacrer', 'variationaladjutory', 'overedgeevangelican', 'unremittinglyaffronting', 'galledisocinchomeronic', 'cumshawzelatrice', 'apioidalNagari', 'undiscoverableelectrifiable', 'cardinghygeistic', 'GemitoresBourignian', 'Toryizesynechthran', 'Bitulithicscrin', 'petalocerouscamus', 'allanitictrichitis', 'ligniformcoolheadedness', 'onomatopoeiaeggfish', 'damnonianscrankly', 'strangulableargentamid', 'carannaaccension', 'concussionalmonobromoacetanilide', 'Cobitidaedismissal', 'unstalledneutralism', 'steevingerotic', 'spattertriphenylated', 'gratifyinglymetrorrhea', 'coxbonesbirle', 'Eomecondiscolorate', 'craunchprovitamin', 'extravagantkaryoplasmatic', 'pneumodynamicsprimariness', 'togueseaflower', 'surrenalinconcluding', 'phallaceousunrebel', 'unreprovedlysprier', 'withsavesatinize', 'Pamirioversystematic', 'theohumanhooper', 'petalousausterity', 'crookedparonomasiastic', 'nonhumanistunsoaked', 'unpaintterebinic', 'Piscataqualagoonal', 'pentaptychBantingism', 'invulnerabledimerization'], ['letohl', 'string', 'ntohl', 'string']), 'nowhitoffscape': ([], ['letohs', 'letohl', 'byte', 'letohl', 'float', 'double', 'letohll', 'float', 'ntohs', 'lv', 'letohs', 'byte', 'lv', 'letohl', 'float', 'byte', 'string', 'ntohs', 'letohs', 'double', 'ntohl', 'ntohl', 'lv', 'float', 'letohl', 'ntohll', 'ntohs', 'letohll', 'ntohs', 'ntohl', 'ntohl', 'letohl', 'letohll', 'letohs', 'letohs', 'ntohl', 'lv', 'ntohll', 'float']), 'coxbonesbirle': ([], ['float', 'byte', 'lv', 'lv', 'float', 'letohs', 'lv', 'letohl', 'lv', 'lv', 'ntohll', 'string', 'letohll', 'byte', 'ntohll', 'letohll', 'ntohl', 'letohl', 'letohll', 'letohs']), 'skilderprothalline': (['opportunisttitlark', 'untrainhearkener', 'subcineritiousphrenitic', 'pantomnesiadiporpa', 'mediumismgypsyism', 'OrleansSchedius', 'archsnoblodgepole', 'dissogenyBarney', 'warfaringdraghound', 'symmetricalantimasker', 'unaccuracyblepharoadenitis', 'repolymerizationwesselton', 'untastedgirllike', 'querulouslycooky', 'zeuctocoelomicmetapodial', 'semicolumnrankly', 'splanchnopleureprelapsarian', 'buttTarahumara', 'seminegroSemiticize', 'Philonismpinivorous', 'disjointedlytriamylose', 'emblazonarsenopyrite', 'coeternaloverhonor', 'uncomminutedcommix', 'scutcheonwiseileocolitis', 'misadministrationbroody', 'phototherapistupsetted', 'Jesperyearlong', 'countryfolkintolerance', 'Stromatoporoideabarry', 'skeelysubtriangular', 'syphilologyannularity', 'prebromidicMonopetalae', 'scruplercellulifugal', 'ruinlikesilva', 'catmalisoncoevally', 'pyrroylprobity', 'Orakzaiunsatisfiedly', 'subsoilercruent', 'unmistgraffer', 'cannotdentigerous', 'goodlyterebenthene', 'bairnlyneocosmic', 'surrenalinconcluding', 'codeinesalience', 'venomouslypilferment', 'appendiceunmetaled', 'coinbellmaker', 'apioidalNagari', 'organoantimonypreoperator', 'Tullianrubidium', 'kleenebocJungermannia', 'subsorterbecuffed', 'mataiuntameness', 'trentepohliaceousHectorean', 'unfannedhopperman', 'changeablyzoophilitic', 'bullswooldraggletail', 'unoverhauledGalinsoga', 'repealistbillsticking', 'cylindrarthrosisnonplusation', 'indubitablenoncollaboration', 'cicisbeismGonystylus', 'reladepropiolaldehyde', 'Voltaprotarsal', 'xenogenesisprenoble', 'addressorcondensedly', 'diseasednessthioantimonate'], ['nextproto_b', 'letohll', 'string', 'letohl', 'letohll', 'letohl', 'float', 'lv', 'letohll', 'letohll', 'ntohs', 'float', 'double', 'lv', 'double', 'double', 'letohll', 'nextproto_s', 'ntohl', 'nextproto_s', 'ntohll', 'ntohll', 'lv', 'float', 'lv', 'letohl', 'ntohll', 'letohll', 'string', 'nextproto_b', 'ntohl', 'ntohl', 'letohs', 'ntohl', 'nextproto_s', 'nextproto_s', 'ntohll', 'letohll', 'float', 'double', 'nextproto_b', 'ntohs', 'letohl']), 'ankylenterongreenfish': ([], ['double', 'byte', 'ntohs', 'double', 'letohl', 'ntohs', 'ntohl', 'double', 'byte', 'letohl', 'lv', 'lv', 'double', 'ntohs', 'float', 'double', 'letohl', 'letohll', 'byte', 'ntohl', 'ntohs', 'float', 'letohs', 'letohll', 'double', 'ntohs', 'double', 'ntohl', 'ntohll', 'ntohs', 'ntohl', 'double', 'double', 'ntohs', 'ntohl', 'letohl', 'ntohs', 'string', 'ntohl']), 'Bronxbiotechnics': ([], ['ntohll', 'byte', 'double', 'letohll', 'double', 'letohl', 'lv', 'string', 'byte', 'letohll', 'letohll', 'ntohs', 'string', 'string', 'byte', 'lv', 'ntohs', 'letohll', 'letohl', 'letohll', 'letohl', 'ntohl', 'float', 'byte', 'ntohs', 'lv', 'letohll', 'double', 'letohll', 'byte', 'ntohll', 'letohs', 'ntohll', 'ntohl', 'byte', 'ntohl', 'letohs', 'lv', 'letohl', 'letohs', 'letohs', 'float']), 'summarizationyatter': (['ineloquentundishonored', 'Piscataqualagoonal', 'loungyimpolite', 'asperationoraculousness', 'vaporizetannery', 'ambisyllabicfruitful', 'Sarothrawrencher', 'cassiteritecasemaking', 'bawcockPicnickian', 'unhittabledoublehorned', 'isuroidunfitly', 'countryfolkintolerance', 'opportunisttitlark', 'subregenthelmeted', 'Eomecondiscolorate', 'overgenialitybuzzle', 'pilchermonaulos', 'surlyreptilferous', 'Mayorunahybridizer', 'cancelationZoochlorella', 'retroclusionmetaphysicianism', 'tenesmicHymettic', 'bustedpredoubter', 'carangoidbotryomycotic', 'reladepropiolaldehyde', 'cacuminalgastrohysterorrhaphy', 'Bryumextrafocal', 'shortcakeabase'], ['lv', 'letohll', 'nextproto_s', 'ntohll', 'lv', 'double', 'string', 'nextproto_b', 'letohs', 'letohll', 'string', 'nextproto_s', 'nextproto_b', 'letohll']), 'strainedlypsychopompos': ([], ['ntohll', 'string', 'letohll', 'double', 'double', 'double', 'float', 'float', 'ntohll', 'ntohl', 'lv', 'letohs', 'float', 'string', 'string', 'letohs', 'lv', 'letohll']), 'physiognomicallybrasse': ([], ['letohl', 'letohs', 'byte', 'double']), 'certainarchpontiff': ([], ['string', 'double', 'ntohl', 'string', 'float', 'ntohs', 'byte', 'double', 'letohll', 'letohs', 'byte', 'letohll', 'ntohs', 'ntohll', 'string', 'letohl', 'ntohll', 'string', 'letohl', 'double', 'string', 'string', 'lv', 'letohl', 'lv', 'byte', 'double', 'letohll']), 'Quitugryde': ([], []), 'hippocampalscrow': ([], ['float', 'letohl', 'double', 'double', 'string', 'double', 'ntohll', 'letohs', 'ntohl', 'lv', 'ntohll', 'float', 'letohl', 'lv', 'float', 'ntohs', 'float', 'letohll', 'byte', 'ntohs', 'ntohl', 'float', 'letohll', 'lv', 'byte', 'float', 'double', 'ntohl', 'ntohl', 'letohs', 'lv', 'string', 'ntohll', 'byte', 'ntohll', 'double', 'lv', 'ntohl', 'letohs']), 'redepositsubclassify': ([], ['letohll', 'string', 'float', 'ntohs', 'byte', 'ntohs', 'letohl', 'letohll', 'ntohll', 'ntohl', 'float', 'letohl', 'letohl', 'letohl', 'double', 'letohl', 'ntohl', 'ntohl', 'double', 'lv', 'float', 'ntohll', 'ntohl', 'lv']), 'sulfureasupertramp': (['prosubscriptiontribracteate', 'surlyreptilferous', 'dehydrogenizeCambrian', 'reburstsummity', 'asepticallyBernese', 'recapitalizationdissipative', 'importationPerisphinctidae', 'dissogenyBarney', 'epistlarcystoid', 'unhittabledoublehorned', 'keraunophoneinhabited', 'photoheliographoctuplicate', 'Piscataqualagoonal', 'cancelationZoochlorella', 'scutcheonwiseileocolitis', 'mausoleandecasualize', 'cantingnesstideful', 'uncomminutedcommix', 'scruplercellulifugal'], ['byte', 'letohl', 'nextproto_s', 'ntohll', 'ntohl', 'letohl', 'ntohll', 'float', 'nextproto_s', 'letohll', 'letohll', 'ntohll']), 'valvotomypensionably': ([], ['byte', 'lv']), 'Tdapproximatively': ([], ['letohl', 'ntohs', 'lv', 'double', 'ntohs', 'lv']), 'lipemiabenjamin': ([], ['ntohll', 'double', 'lv', 'double', 'letohll', 'letohll', 'ntohl', 'byte', 'letohs', 'string', 'letohll', 'letohll', 'ntohll', 'double', 'ntohll', 'letohll', 'float', 'string', 'float', 'letohl', 'double', 'float', 'ntohll', 'byte', 'ntohl', 'ntohs', 'letohs', 'ntohl', 'ntohl', 'ntohll', 'letohll', 'letohl', 'letohll', 'double']), 'dehydrogenizeCambrian': ([], ['float', 'letohs', 'ntohs', 'byte', 'double', 'letohs', 'ntohl', 'double', 'ntohs', 'letohs', 'double', 'float']), 'parorchispalingenic': ([], ['letohll', 'ntohl', 'letohll', 'letohll', 'string', 'ntohll', 'float', 'ntohll', 'ntohll', 'string', 'letohs', 'double', 'string', 'letohll', 'letohll', 'ntohl', 'letohs', 'letohs', 'letohll', 'ntohl', 'ntohll', 'double', 'ntohs', 'letohs', 'string', 'float', 'string', 'byte', 'ntohl', 'letohs', 'letohll', 'double', 'float', 'double', 'string', 'ntohll', 'ntohs', 'letohs']), 'overgenialitybuzzle': (['carannaaccension', 'unlasheddialyzable', 'symmetricalantimasker', 'wutproamusement', 'Steganophthalmiagnomic', 'steelworkpsychophysiological', 'maltingsurrection', 'sageshipcarcoon', 'usurperunplannedly', 'asepticallyBernese', 'changeablyzoophilitic', 'counterpotentMetabola'], ['letohs']), 'pantomnesiadiporpa': (['hemianacusiadouble', 'unusehydroponist', 'radiopaqueunrecruitable', 'querulouslycooky', 'metatitanatetarente', 'photoheliographoctuplicate', 'cylindrarthrosisnonplusation', 'Vandiemenianwinery', 'adiaphorousfalsifiable', 'simulcastriboflavin', 'proportionaltasselmaker', 'archsnoblodgepole', 'premortuarybenchy', 'agoraphobiaLenzites', 'catmalisoncoevally', 'recapitalizationdissipative', 'cardialgiacontingence', 'intrathoraciccoemployment', 'chytridialgoosemouth', 'cineplastyanonang', 'anomalousparallelinerved', 'seminegroSemiticize', 'misadministrationbroody', 'androgynyvegetoalkaline', 'crossboltedasexually', 'parathyroidectomizeoutheart', 'sacroposteriorveratryl', 'stagemansupa'], ['ntohs', 'double', 'ntohs', 'letohs', 'letohl', 'letohl', 'letohs', 'lv', 'float', 'float', 'ntohll', 'letohl', 'byte', 'letohll', 'letohll', 'nextproto_s', 'letohs', 'ntohl', 'ntohs', 'ntohl', 'byte', 'nextproto_s', 'nextproto_s', 'double', 'ntohs', 'float', 'byte', 'ntohs', 'ntohs', 'ntohll', 'letohl', 'letohll', 'ntohll', 'ntohll', 'ntohl', 'double', 'letohs', 'double', 'byte', 'byte', 'ntohs', 'lv', 'ntohl', 'letohl', 'double', 'letohl']), 'refragablenessabstergent': (['recapitalizerelevate', 'Philoctetessupersalesman', 'systemizableepode', 'popeyednaphtha', 'esophagoplastyrestrainedness', 'electrocardiographyamaranthaceous', 'benzalethylaminedesulphurate', 'teleorganicanthracitiferous', 'kempstergarefowl', 'picayunishapogeotropic', 'grammaticismmignonette', 'Saxonicalpalet', 'toadwiselaundrymaid', 'tautoousianentente', 'indulginglyretrue', 'hetericismswayable', 'hemologistbeglide', 'ulnaleptodactyl', 'counterspyingdungeon', 'gatewiseunderpot', 'phallaceousunrebel', 'roofprespur', 'unflukedcleck', 'recapitalizationdissipative', 'semiduplexskirt', 'repolymerizationwesselton', 'freakilyuphoard', 'redifferentiationmustachio', 'Theodotianjigget', 'metatitanatetarente', 'overgenialitybuzzle', 'Eomecondiscolorate', 'unvoiceCamacan', 'arnberrydodecadrachm', 'noninfectionvenerativeness', 'addressorcondensedly', 'sharkletcompactedly', 'corkeralbanite', 'larunfermenting', 'codeinesalience', 'oboltask', 'predefinitionCarnaria', 'unexchangedsupraventricular', 'homoeomeriametagnathous', 'overedgeevangelican', 'unfeasiblecollodiotype', 'cineplastyanonang', 'Orakzaiunsatisfiedly', 'bronchiaunbaffling', 'ettleoptimize', 'correctorSpirochaeta', 'Humeaerohydroplane', 'booteebifold', 'subsoilercruent', 'nowhitoffscape', 'cumshawzelatrice', 'hyperneuriasymbolatry', 'racegoingunperformed', 'ectallycoenosteal', 'demibeastuninflicted', 'unfannedhopperman', 'meddlingsmall', 'cathodofluorescencemonkcraft', 'alkaneirrigable', 'galimatiasphacocystectomy', 'remisrepresentationlancet'], ['lv']), 'prochordalnaveled': (['hemianacusiadouble', 'sokarailer', 'spicousHippopotamidae', 'inwrapbilophodont', 'pneumodynamicsprimariness', 'flamprelate', 'dehydrogenizeCambrian', 'oxmanoutpull', 'opportunisttitlark', 'ricketssubtrihedral', 'untrammelednessHannibalian', 'maternityhomogenetic', 'miningFlavia', 'urningsubpubescent', 'bemuzzlesurficial', 'campulitropoussapogenin', 'remisrepresentationlancet'], ['string', 'byte', 'nextproto_b', 'letohl', 'string', 'letohl', 'letohs', 'ntohs', 'nextproto_b', 'ntohl', 'letohl', 'letohs', 'byte', 'letohs', 'nextproto_s', 'byte', 'ntohll', 'ntohs', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'string', 'lv', 'float', 'double', 'float', 'float']), 'violationguggle': ([], ['ntohl', 'letohll', 'letohll', 'string', 'letohs', 'byte', 'lv', 'lv', 'float', 'lv', 'ntohl', 'ntohs', 'letohs', 'ntohl', 'double', 'lv', 'float', 'ntohll', 'letohs', 'byte', 'ntohl', 'ntohs', 'double', 'float', 'byte', 'float', 'letohl', 'ntohs', 'lv', 'letohll', 'letohll', 'double', 'double', 'string', 'ntohl', 'byte', 'string', 'ntohs', 'ntohs']), 'shortishscob': (['Senecanovercorruptly', 'unenterprisedargumentatious', 'Bitulithicscrin', 'correctorSpirochaeta', 'homoeomeriametagnathous', 'pavonatedcozily', 'barrelmakingparoemia', 'etioporphyrinpubovesical', 'disjointedlytriamylose', 'vivacityOlneya', 'archcrownundistantly', 'Momotinaenonfortification', 'dowsettroughway', 'opportunisttitlark', 'predefinitionCarnaria', 'pegologyscavenage', 'variationaladjutory', 'stertoriouscrass', 'ourselfmetaplast', 'fitfulunshrill', 'baptizeeFrenchize', 'araguatolucinoid', 'concussionalmonobromoacetanilide', 'desoxycorticosteroneshakerag', 'epistlarcystoid', 'attestatorcoronule', 'invulnerabledimerization', 'cleansingpentahedral', 'dejectedincreasing', 'emblazonarsenopyrite', 'sandwortFierasfer', 'butterrootchagrin', 'irislikeaphyllose', 'unconvenedperpetually', 'mediumismgypsyism', 'biserialsmithite', 'terrazzododder', 'wingerconsoler', 'snakeletwounds', 'colletingobylike', 'ketembillaantiferment', 'ophthalmalgiamisproduce', 'spinthariscopemolybdena', 'whusslenoreast', 'pejoristbromalbumin', 'cycloolefinmonostylous', 'gardenedfugacious', 'sheephookflushboard', 'unfootedHilary', 'pyrroylprobity', 'galimatiasphacocystectomy', 'antiviraltackety', 'improvisatorizenoneditorial', 'steelworkpsychophysiological', 'epexegeticallyreadjournment', 'surfactantchurchgrith', 'ectallycoenosteal', 'sokarailer', 'outworthbenevolence', 'clinandriabryologist', 'leadstonehypovitaminosis', 'recapitalizationdissipative', 'undercovertcoloss', 'gatewiseunderpot', 'retickettopotaxis', 'coinbellmaker', 'enclothearmiferous', 'Bryumextrafocal', 'Vandiemenianwinery', 'listeningBroussonetia', 'galledisocinchomeronic', 'cryptanalystteenet', 'Abrahamicinordinateness', 'herpetologistindeed', 'radiopaqueunrecruitable', 'untabernacledmedicamental', 'predesignateunderservice', 'agoraphobiaLenzites', 'dunneaneuploidy', 'unsilentiousskimpy', 'smackinglyScheuchzeriaceae', 'metacentralpaleocrystal', 'unengravedeosin', 'trichitepersonship'], ['float', 'ntohs', 'ntohll', 'float', 'letohl', 'ntohs', 'nextproto_b', 'letohl', 'string', 'float', 'string', 'nextproto_s', 'lv', 'letohll', 'nextproto_s', 'letohl', 'ntohs', 'double', 'ntohs', 'double', 'nextproto_s', 'double', 'float', 'float', 'letohl', 'nextproto_b', 'string']), 'deletoryrollerskating': ([], ['letohll', 'letohll', 'string', 'letohll', 'ntohl', 'letohl', 'letohl', 'float', 'float', 'ntohl', 'float', 'string', 'string', 'ntohl', 'double', 'letohs', 'byte', 'float', 'string', 'lv', 'float', 'ntohs', 'float']), 'intercoolingpotentialization': ([], ['ntohs', 'letohs', 'letohl', 'letohll', 'float', 'ntohll', 'float']), 'photocompositioneneuch': ([], ['letohl', 'string', 'lv', 'letohs', 'letohll', 'double', 'letohll', 'ntohll', 'lv', 'ntohl', 'string', 'letohll', 'byte', 'lv', 'double', 'byte', 'ntohll', 'lv', 'double', 'letohll', 'double', 'float', 'ntohl', 'string', 'letohs', 'lv', 'ntohs', 'double', 'letohll', 'string', 'ntohs', 'ntohll', 'byte', 'ntohll']), 'surfactantchurchgrith': (['cycloolefinmonostylous', 'unsubstantiaterightfulness', 'preformisticexemplifiable', 'epexegeticallyreadjournment', 'micrencephalypalpus', 'unfannedhopperman', 'carannaaccension', 'unquailingshive', 'esophagoplastyrestrainedness', 'warneriodocasein', 'stickleafethenyl', 'northwestwardpassementerie', 'pensefulnessdrought', 'Senecanovercorruptly', 'dihedronsubcircuit', 'sheepkeepingfeedman', 'strainedlypsychopompos', 'usurperunplannedly', 'tongueshoticonophilism', 'countryfolkintolerance', 'ornithomanticrada', 'ExobasidialesEppy', 'surlyreptilferous', 'iconismanisostemonous', 'avalanchestylopization', 'crouchingpurebred', 'hippocampalscrow', 'subrelationsepiolite', 'Philonismpinivorous', 'frolickytriphyline', 'epigenesistbisexed', 'seminegroSemiticize', 'subcostalbaldmoney', 'unflukedcleck'], ['ntohl', 'ntohll', 'ntohl', 'ntohs', 'ntohs', 'double', 'letohll', 'lv', 'byte', 'ntohl', 'letohll', 'ntohl', 'byte', 'letohll', 'ntohs', 'letohs', 'letohs', 'ntohl', 'letohll', 'nextproto_b', 'lv', 'ntohl', 'float', 'letohl', 'lv', 'byte', 'nextproto_s', 'ntohll', 'lv']), 'coeternaloverhonor': (['tautoousianentente', 'bawcockPicnickian', 'xenopodidtrencherless', 'coeternaloverhonor', 'unbeggarbroncholithiasis', 'blepharanthracosisuncliented'], ['double', 'string', 'ntohs', 'ntohll', 'lv', 'letohl', 'lv', 'lv', 'float', 'letohll', 'ntohll', 'letohll', 'string', 'letohs', 'double', 'double', 'float', 'letohl', 'ntohll', 'lv', 'letohs', 'nextproto_b', 'lv', 'lv', 'letohll', 'letohl', 'byte', 'byte', 'lv', 'ntohll', 'float', 'ntohs', 'lv', 'float', 'ntohll', 'lv', 'letohs', 'ntohll']), 'noggencapitulate': ([], ['byte', 'ntohll', 'string', 'letohll', 'ntohl', 'ntohll', 'string', 'string', 'double', 'letohll', 'letohll', 'letohs', 'letohll', 'lv']), 'Vandiemenianwinery': ([], []), 'subcineritiousphrenitic': ([], ['ntohll', 'float', 'letohll', 'letohs', 'byte', 'ntohll', 'float', 'ntohll', 'double', 'ntohll', 'lv', 'byte', 'double', 'double', 'float', 'letohs', 'letohll', 'letohll', 'byte', 'ntohll', 'letohll', 'string', 'ntohs', 'ntohl', 'double', 'double', 'string', 'double']), 'foliicolousskeletonweed': (['hyperneuriasymbolatry', 'peritrichouslyhepatoflavin', 'cesserreichspfennig', 'mattapharyngological', 'Steganophthalmiagnomic', 'malthouseenteralgia', 'cassiteritecasemaking', 'intrathoraciccoemployment', 'amlipyrexic', 'loungyimpolite', 'cannotdentigerous', 'unfannedhopperman', 'steelworkpsychophysiological', 'unbeggarbroncholithiasis', 'Orakzaiunsatisfiedly', 'veldcraftsubprefect', 'counterpotentMetabola', 'saltlypropugnator', 'evaluecystatrophia', 'dermoiddiversifiable', 'Triuridalesplagiarism', 'spraysemisaprophyte', 'hetericismswayable', 'pneumodynamicsprimariness', 'bawcockPicnickian', 'ochronosusafterbody', 'predesignateunderservice', 'tautoousianentente'], ['nextproto_b', 'nextproto_s', 'letohs', 'lv', 'lv', 'ntohll', 'nextproto_b', 'lv', 'float', 'nextproto_b', 'double']), 'palatableJonesian': (['acquisitumvaletudinarist', 'munjmuchness', 'sageshipcarcoon', 'tumoredcrocodilite', 'loungyimpolite', 'subcostalbaldmoney', 'provectgastrocolostomy', 'epistlarcystoid', 'arsheenperspiration', 'yawpwoodwax', 'oversoldafield', 'lungflowerhorrormonger', 'piperitiousreekingly', 'recapitalizerelevate', 'dissogenyBarney'], ['float', 'ntohll', 'double', 'ntohll', 'float', 'letohll', 'letohs', 'letohs', 'ntohs', 'letohs', 'letohl', 'nextproto_b', 'nextproto_b', 'nextproto_b', 'nextproto_b', 'lv', 'double', 'ntohl', 'ntohll', 'nextproto_b', 'nextproto_s', 'float', 'ntohl', 'letohll', 'ntohll', 'ntohll', 'string', 'ntohll', 'ntohl', 'string', 'ntohll', 'ntohll']), 'Wagnerianaaviculturist': ([], ['ntohl', 'byte', 'lv', 'string', 'string', 'string', 'ntohl', 'byte', 'string', 'letohll', 'ntohl', 'float', 'letohs', 'lv', 'lv', 'letohll', 'ntohs', 'ntohl', 'letohll', 'ntohll', 'letohll', 'string', 'double']), 'spermatozoaTrachodontidae': ([], ['letohll', 'ntohll', 'ntohll', 'double', 'byte', 'double', 'ntohl', 'ntohll', 'double', 'string', 'string', 'float', 'ntohll', 'float', 'letohs', 'byte', 'letohs', 'lv', 'float', 'byte', 'ntohl', 'ntohl', 'ntohs', 'float', 'double', 'byte', 'ntohll', 'byte', 'ntohs', 'ntohl', 'float', 'letohs', 'ntohl', 'string', 'letohl', 'letohs', 'letohll']), 'Melanorrhoeadewworm': ([], ['letohs', 'letohll', 'ntohl', 'ntohl', 'letohll']), 'preformisticexemplifiable': ([], ['lv', 'float', 'double', 'ntohll', 'ntohl', 'double', 'letohll', 'ntohl', 'float', 'letohs', 'ntohs', 'string', 'letohl', 'letohs', 'ntohs', 'ntohs', 'letohl', 'float', 'double', 'letohll', 'ntohl', 'float', 'letohll', 'byte', 'letohl', 'ntohl', 'ntohl', 'letohll', 'letohll', 'letohs', 'letohs', 'ntohll', 'letohs', 'lv', 'letohl', 'letohs', 'ntohs', 'float', 'float']), 'feveretunderbox': ([], ['ntohll', 'letohl', 'float', 'lv', 'lv', 'double', 'string', 'ntohs', 'string', 'ntohll', 'ntohll', 'letohs', 'lv', 'double', 'lv', 'string', 'ntohl', 'ntohs', 'ntohs', 'ntohs', 'double', 'lv', 'byte', 'float', 'lv', 'ntohs', 'ntohl', 'ntohll', 'string', 'letohll', 'letohl', 'ntohll', 'letohs', 'float', 'ntohs', 'ntohl', 'ntohs']), 'agoraphobiaLenzites': ([], ['letohs', 'ntohs', 'string']), 'antiphonybackplate': ([], ['string', 'ntohll', 'float', 'byte', 'double', 'ntohl']), 'heliconbonnetman': ([], ['lv', 'letohll', 'double', 'letohs', 'ntohll', 'byte', 'float', 'ntohll', 'letohs', 'ntohs', 'ntohll', 'letohs', 'letohll', 'letohs']), 'carcerationinterrenal': ([], ['string', 'ntohll', 'ntohs', 'letohl', 'ntohs', 'byte', 'byte', 'string', 'letohll', 'ntohl', 'float', 'ntohl', 'string', 'ntohll', 'float']), 'plagioclinalmesolecithal': (['paleocrystallinespinulosodenticulate', 'lindengamy', 'pseudodemocraticproconscription', 'lagoonaltanning', 'autovivisectionoverleather', 'antiphonybackplate', 'kleenebocJungermannia', 'overhollowescort', 'parathyroidectomizeoutheart', 'chytridialgoosemouth', 'scheltopusikAmpelidaceae', 'loketprincipiate', 'overseateddiscouragingly', 'saltlypropugnator', 'unbeggarbroncholithiasis', 'Sarothrawrencher', 'intrathoraciccoemployment', 'Larinaecoydog', 'untrainhearkener'], ['ntohs', 'double', 'letohll', 'float', 'lv', 'nextproto_b', 'letohl', 'nextproto_b', 'ntohl', 'letohs', 'letohl', 'letohs', 'ntohs', 'nextproto_b', 'ntohll', 'nextproto_b', 'string', 'ntohl', 'letohll', 'nextproto_b', 'letohl', 'letohl', 'nextproto_s', 'double', 'byte', 'ntohll', 'ntohs', 'ntohll', 'double', 'nextproto_b', 'lv', 'byte', 'double', 'letohl', 'byte', 'nextproto_b', 'lv', 'byte', 'lv', 'lv', 'string', 'double', 'nextproto_b', 'float', 'double', 'lv']), 'lippitudebaetyl': (['unflukedcleck', 'alphabetismpolyfenestral', 'tintsausinger', 'unpaintterebinic', 'premortuarybenchy', 'untrainhearkener', 'domanialPhora', 'foliicolousskeletonweed', 'frolickytriphyline', 'Abrahamicinordinateness', 'overseateddiscouragingly', 'cineplastyanonang', 'paleocrystallinespinulosodenticulate', 'stomagringo', 'cleansingpentahedral', 'Toryizesynechthran', 'tenodesisunroaming', 'manageriallyflanger', 'responsivitykimigayo', 'hemianacusiadouble', 'polyspermatouscreationistic', 'codeinesalience', 'plurifacialmicrographical', 'Slavophilesedigitate', 'microcrystallogenyfuniculus', 'lepidodendridcounterplead', 'cerebroidodontolcate', 'blepharanthracosisuncliented', 'foreuseuninfluencing', 'Limodorumscrotal', 'nonaugmentativehypertelic', 'symmetricalantimasker', 'lippitudebaetyl', 'hammerkopnegativer', 'surlyreptilferous', 'epistlarcystoid', 'asteamincandescency', 'Anglomaniaclovableness', 'barrelmakingparoemia'], ['letohs', 'lv', 'double', 'letohl', 'letohs', 'letohl', 'ntohl', 'letohll', 'nextproto_s', 'lv', 'byte', 'ntohll', 'ntohll', 'nextproto_b', 'ntohl', 'nextproto_s', 'lv', 'ntohs', 'letohll', 'float', 'ntohl', 'string', 'double', 'letohl', 'float', 'ntohll', 'ntohll', 'ntohs', 'string', 'letohll', 'ntohll']), 'motacillinewidespreadly': (['zoosporangialbuyable', 'doubleheartedstaphylolysin', 'retroclusionmetaphysicianism', 'allerChilostoma', 'domanialPhora', 'tautoousianentente', 'Steganophthalmiagnomic', 'ambisyllabicfruitful', 'dehydrogenizeCambrian', 'yawpwoodwax', 'unfannedhopperman', 'subcostalbaldmoney', 'applanationnitrifaction', 'menialitypreintelligent', 'microcrystallogenyfuniculus', 'Wagnerianaaviculturist', 'unflukedcleck', 'heliconbonnetman', 'catagmaticMegalosaurus', 'laparotomycephalohumeralis', 'adiaphorousfalsifiable', 'misputheptarchist', 'Lespedezafuthorc', 'emblazonarsenopyrite', 'cophosisclour', 'untrainhearkener', 'cudavaogreish', 'strangulableargentamid', 'reburstsummity', 'predesignateunderservice', 'Alalamenispermine', 'repolymerizationwesselton'], ['ntohs', 'letohll', 'ntohll', 'nextproto_s', 'nextproto_s', 'nextproto_b', 'letohll', 'string', 'lv', 'ntohs', 'letohll', 'letohll', 'byte', 'float', 'byte', 'letohl', 'ntohl']), 'Ciceronicpownie': (['whusslenoreast', 'somnipathistcarbonometry', 'pantomnesiadiporpa', 'knuckleboneunnegotiableness', 'unhyphenedallose', 'androgynyvegetoalkaline', 'appendiceunmetaled', 'Robenhausianreboil', 'cancelationZoochlorella', 'unsanctioningperiuvular', 'cicisbeismGonystylus', 'tauromachyoutgive', 'scheltopusikAmpelidaceae', 'diazobenzenedisburden', 'kansrush', 'premortuarybenchy', 'cantingnesstideful', 'gatewiseunderpot', 'cassiteritecasemaking', 'unquailingshive', 'fetoracclimatement', 'proportionaltasselmaker', 'cineplastyanonang', 'Steganophthalmiagnomic', 'ureterorrhagiahemogenetic', 'preinjuryduplicature', 'pistoleerproexamination', 'semicolumnrankly', 'marblelikeTenaktak', 'Vickyimmigrant', 'precoxseambiter', 'Oliveanpyromancer', 'limsypersistence', 'bronchiaunbaffling', 'subsorterbecuffed', 'seminegroSemiticize', 'isuroidunfitly', 'purgaNycticorax'], ['float', 'double', 'letohs', 'letohs', 'letohs', 'nextproto_s', 'string', 'letohl', 'lv', 'string', 'letohs', 'float', 'ntohll', 'nextproto_b', 'byte', 'nextproto_b', 'letohs', 'nextproto_b', 'ntohll', 'lv', 'lv', 'letohl', 'byte', 'ntohs', 'letohl', 'string', 'double', 'nextproto_s', 'lv', 'nextproto_b', 'nextproto_s', 'double']), 'quakinglyilliterate': ([], ['ntohs', 'letohl', 'ntohll', 'letohll', 'letohs', 'letohl', 'ntohs', 'float', 'double', 'byte', 'letohll', 'letohl', 'letohs', 'letohll', 'string', 'double', 'lv', 'ntohs', 'ntohl', 'lv', 'letohs', 'float', 'letohl']), 'rathmemorizable': ([], ['string', 'ntohll', 'letohl', 'ntohs', 'string', 'double', 'letohs', 'letohl', 'float', 'letohs', 'lv', 'byte', 'ntohl', 'byte', 'letohll', 'ntohll', 'string', 'string', 'letohl', 'ntohl', 'string', 'letohll']), 'proctorshipscoptical': ([], ['float', 'letohll', 'double', 'string']), 'homozygotemagicalize': ([], ['ntohs', 'ntohs', 'ntohll', 'lv', 'letohl', 'lv', 'letohll', 'lv', 'float', 'byte', 'float', 'letohll', 'letohs', 'string', 'letohl', 'lv', 'byte', 'double', 'ntohl', 'letohs', 'lv', 'string', 'double', 'float', 'double', 'letohll', 'string', 'byte', 'lv', 'ntohs', 'lv', 'ntohl', 'byte']), 'intrathoraciccoemployment': ([], ['letohs', 'ntohll', 'byte', 'ntohl', 'byte', 'lv', 'string', 'letohll', 'ntohll', 'letohl']), 'dunneaneuploidy': ([], ['letohs', 'ntohs', 'ntohll', 'double', 'letohl', 'byte', 'ntohs', 'letohs', 'byte', 'double', 'ntohl', 'float', 'ntohll', 'ntohs', 'ntohl', 'float', 'lv', 'ntohl', 'ntohl', 'letohll', 'letohl', 'float', 'ntohll', 'letohs']), 'haloidazeotropism': ([], ['double', 'double', 'letohll', 'ntohs', 'ntohs', 'letohs', 'lv', 'string']), 'gemeledAdonai': (['Lespedezafuthorc', 'hetericismswayable', 'ruinlikesilva', 'yoreexponent', 'surlyreptilferous', 'unsanctioningperiuvular', 'flashpanstature', 'galledisocinchomeronic', 'semicolumnrankly', 'listeningBroussonetia', 'tongueshoticonophilism', 'gatewiseunderpot', 'refilmopenhandedness', 'paralyzerthiocarbimide', 'buttonholerindigestive', 'monodromiclyretail', 'indirecthierarchism', 'dissogenyBarney', 'unfeasiblecollodiotype', 'foliicolousskeletonweed', 'cycloolefinmonostylous', 'photoheliographoctuplicate', 'gemeledAdonai', 'baptizeeFrenchize', 'overganggenesial', 'fetoracclimatement', 'herpetologistindeed', 'xenogenesisprenoble', 'overpoliticunderlooker', 'importationPerisphinctidae', 'carannaaccension', 'tautologicpanimmunity', 'cerebroidodontolcate', 'ambisyllabicfruitful', 'sokarailer', 'unexchangedsupraventricular', 'radiopaqueunrecruitable', 'prelanguagecloudage', 'allerChilostoma', 'imperializetrispaston', 'woodrowelshrievalty', 'bemuzzlesurficial', 'delthyrialGee'], ['ntohll', 'ntohll', 'letohl', 'letohll', 'letohll', 'lv', 'nextproto_s', 'double', 'nextproto_b', 'byte', 'letohl', 'ntohll', 'float', 'string', 'ntohl', 'ntohll', 'nextproto_b', 'letohs', 'letohs', 'nextproto_s', 'string', 'letohl', 'letohll', 'double', 'string', 'nextproto_s', 'nextproto_b', 'nextproto_s', 'nextproto_s', 'lv', 'string']), 'sternoxiphoidunenlivened': ([], ['string', 'lv', 'byte', 'ntohll', 'letohs', 'byte', 'float', 'ntohs', 'float', 'letohl', 'string', 'float', 'letohll', 'lv', 'letohl', 'lv', 'ntohl', 'lv', 'ntohll']), 'xiphosternamedia': ([], ['ntohl', 'letohs', 'letohll', 'letohl', 'string', 'double', 'letohl', 'letohll', 'ntohs', 'lv', 'ntohll', 'double', 'ntohl', 'double', 'ntohs', 'ntohl', 'float', 'letohs', 'letohll', 'lv', 'byte', 'ntohs', 'ntohll', 'string', 'float', 'letohll', 'double', 'byte', 'ntohll', 'lv', 'double', 'lv', 'letohll', 'ntohs', 'byte']), 'vanilleshellburst': (['unadversenessmaro', 'alkargenmoop', 'acutelyminar', 'unreprovedlysprier', 'uncatholicizeSiphonognathus', 'Silicoideasaltator', 'terribletaut', 'faddyamputational', 'oversolicitouslyhour', 'smotheringlyhumpbacked', 'gratifyinglymetrorrhea', 'subcostalbaldmoney', 'valvotomypensionably', 'submountainhopper', 'unpaintterebinic', 'arhatsporozoic', 'reproachablepancreatogenic', 'poonghiehectic', 'rattlepodMuntiacus', 'bacteriformpiercel', 'consignificationmarshbuck', 'ananaamasty', 'palatableJonesian', 'prebromidicMonopetalae', 'idioglossiascabble', 'ivoryliketransessentiate', 'unoverhauledGalinsoga', 'archiereusHainan', 'Senecanovercorruptly', 'mediumismgypsyism', 'responsivitykimigayo', 'catastateateliosis', 'sagaiebarrister', 'limsypersistence', 'logarithmeticallydeliriant', 'pistoleerproexamination', 'crouchingpurebred', 'SpatangusChayma', 'warneriodocasein', 'dejectedincreasing', 'premortuarybenchy', 'hancesmoothness', 'keraunophoneinhabited', 'notwitch', 'ExobasidialesEppy', 'monogamianportio', 'undiametricsinningness', 'teleorganicanthracitiferous', 'burgonetcarefully', 'TaboriteSanche', 'endopathicnonmarrying', 'dissogenyBarney', 'balandracaducibranch', 'raucousEstheriidae', 'cognaticalintransmissible', 'prattlersuffumigate', 'buttonholerindigestive', 'listeningBroussonetia', 'postiquedefeasibility', 'rhynchophoranunwinking', 'focoidsstackfreed', 'Eurypteroideachamaeprosopic', 'certainarchpontiff', 'nonaugmentativehypertelic', 'organosiliconsegmentary', 'hanginglypoethood', 'psychrographismdom', 'peerlesslyforetalk', 'unrevenuedindecorousness', 'unstalledneutralism', 'rewhirlhypermotility'], ['ntohs', 'lv', 'letohs', 'letohl', 'letohs', 'ntohll']), 'Manobountopping': ([], ['ntohll', 'lv', 'byte', 'byte', 'letohl', 'letohll', 'letohs', 'ntohs', 'letohs', 'letohll', 'byte', 'ntohs']), 'unflukedcleck': ([], ['float', 'byte', 'ntohll', 'ntohll', 'letohs', 'double', 'byte', 'ntohl', 'lv', 'letohs', 'ntohs', 'ntohll', 'string', 'double', 'letohll', 'ntohl', 'letohl', 'letohll', 'letohl', 'letohs', 'byte', 'letohl', 'letohll', 'ntohll', 'ntohs', 'letohll', 'float', 'float', 'letohll', 'letohl', 'lv', 'ntohll', 'ntohs']), 'epigenesistbisexed': ([], ['byte', 'lv', 'lv', 'lv', 'double', 'byte', 'byte', 'double', 'ntohll', 'ntohs', 'ntohs', 'letohll', 'ntohll', 'ntohll', 'byte', 'byte', 'letohs', 'string', 'letohll', 'lv', 'letohl', 'double', 'ntohs', 'byte', 'letohl', 'letohs', 'letohl', 'string', 'ntohl', 'float', 'ntohl', 'byte', 'byte', 'letohs']), 'fitfulunshrill': ([], ['lv', 'double', 'string', 'letohs', 'lv', 'letohs', 'string', 'letohll', 'ntohl', 'float', 'string', 'byte', 'letohs', 'letohs', 'double', 'ntohl', 'ntohs', 'ntohl', 'ntohs', 'byte', 'ntohs', 'lv', 'lv', 'ntohs', 'ntohll', 'lv']), 'unvoiceCamacan': ([], ['letohl']), 'Steganophthalmiagnomic': ([], ['ntohs', 'ntohs', 'float', 'ntohs', 'ntohl', 'ntohll', 'float', 'byte', 'letohll', 'double', 'ntohs', 'byte', 'string', 'double', 'lv']), 'perukiershiplexicographer': ([], ['byte', 'lv', 'ntohll', 'ntohs', 'ntohs', 'double', 'letohll', 'ntohs', 'ntohll', 'ntohl', 'ntohll', 'letohl', 'double', 'letohl', 'letohll', 'ntohl', 'ntohs', 'ntohl', 'ntohl', 'ntohl', 'ntohl', 'letohll', 'double', 'letohl', 'ntohl', 'ntohll', 'letohs', 'ntohll', 'letohs', 'letohs']), 'brackishrehazard': (['lepidodendridcounterplead', 'thysanuriformcrossrail', 'reladepropiolaldehyde', 'epigenesistbisexed', 'receptivelynonshredding', 'yinsttenderness', 'holdsmanoversalty', 'appendiceunmetaled', 'Sarothrawrencher', 'attestatorcoronule', 'changeablyzoophilitic', 'Vandiemenianwinery', 'tauromachyoutgive', 'udometricpredefault', 'Bryumextrafocal', 'hystericsupersuperior', 'steelworkpsychophysiological', 'scheltopusikAmpelidaceae', 'whusslenoreast', 'applanationnitrifaction', 'chartermarrowy', 'unadversenessmaro', 'shortcakeabase', 'overseateddiscouragingly', 'qualmyishHolocene', 'kleenebocJungermannia', 'outlawrypervertedness', 'excentricalProtococcales', 'cineplastyanonang', 'gratefulAlcedinidae', 'blepharanthracosisuncliented', 'allegoristerserendite', 'butyrochloralfertilizational', 'overfretdisenthronement', 'Paridaeamylum', 'radomenetherwards', 'spattertriphenylated', 'matelessbeatitude', 'Dokoelectrochemically', 'preformisticexemplifiable', 'unaccuracyblepharoadenitis', 'diazobenzenedisburden', 'repealistbillsticking', 'slutteryprivant', 'hungerlysphenocephaly', 'peragratemultifoliate', 'symmetricalantimasker', 'cognaticalintransmissible', 'antleredadunc', 'ureterorrhagiahemogenetic', 'polishedlyhematosis', 'Marcosianpictographically', 'smotheringlyhumpbacked', 'merseglobular', 'ofttimessnatchingly'], ['letohs', 'nextproto_s', 'string', 'ntohl', 'double', 'float', 'letohl', 'byte', 'letohs', 'nextproto_b', 'double', 'string', 'letohll', 'letohll', 'ntohs', 'float', 'nextproto_s', 'float', 'lv', 'byte', 'string', 'nextproto_b', 'lv', 'string', 'ntohl', 'letohl', 'lv', 'byte', 'nextproto_s', 'nextproto_b', 'double', 'letohll', 'nextproto_s', 'nextproto_b', 'lv', 'lv', 'letohl', 'string', 'letohll', 'nextproto_b']), 'togueseaflower': ([], ['ntohll', 'lv', 'ntohll', 'letohll', 'lv', 'string', 'float', 'byte', 'ntohll', 'letohl', 'byte', 'string', 'double', 'letohll', 'double', 'letohll', 'byte', 'lv', 'ntohll', 'letohs', 'letohll', 'double', 'float', 'letohl', 'ntohs', 'string', 'float', 'float', 'ntohll', 'string', 'lv', 'letohll', 'letohll', 'letohll', 'letohs', 'ntohs', 'float', 'ntohll', 'letohll']), 'Pileabayadere': ([], ['ntohl', 'double', 'ntohl', 'lv', 'letohs', 'string', 'letohll', 'ntohll', 'ntohll']), 'archiereusHainan': (['elementalismpietism', 'skeelysubtriangular', 'unusehydroponist', 'xerophagyhematography', 'repolymerizationwesselton', 'ramraceBorderies', 'iconismanisostemonous', 'neurofibriljanapan', 'mercurializationsimulacre', 'uncrevassedterministic', 'onomatopoeiaeggfish', 'mediumismgypsyism', 'mataiuntameness', 'prefactoranchoret', 'slopinglyautomatically', 'unfannedhopperman', 'untabernacledmedicamental', 'isatogenvestibulum', 'gardenedfugacious', 'Anglomaniaclovableness', 'hetericismswayable', 'slutteryprivant', 'raspberrylikesubvertebral', 'unspendablevanilla', 'bemuzzlesurficial', 'gratefulAlcedinidae', 'unoverhauledGalinsoga', 'lobectomypreinflection', 'mischieveunfomented', 'pistoleerproexamination', 'laparotomycephalohumeralis', 'reburstsummity', 'phenomenalisticallyunmomentary', 'notchycoralliferous', 'smotheringlyhumpbacked', 'Wagnerianaaviculturist', 'weathercockismcustodier', 'arnberrydodecadrachm', 'apioidalNagari', 'matelessbeatitude', 'ochronosusafterbody', 'bustedpredoubter', 'precoxseambiter', 'eudaemonisticallyCoccolobis', 'uncatholicizeSiphonognathus', 'oxmanoutpull', 'kansrush', 'undiametricsinningness', 'catafalquedree', 'indubitablenoncollaboration', 'Brandipriestcraft', 'spinthariscopiclieutenancy', 'unbeggarbroncholithiasis', 'demibeastuninflicted', 'arsheenperspiration', 'doubleheartedstaphylolysin', 'prattlersuffumigate', 'erythriticsynergidal', 'dejectedincreasing', 'overhollowescort', 'Lachnosternaadenodermia', 'balandracaducibranch', 'semisomnolencegunj', 'unvoiceCamacan', 'alveololingualMindererus', 'urningsubpubescent', 'Caraipaearcap', 'Voltaprotarsal', 'turbidlycorticoefferent', 'interimperialvignetter', 'loketprincipiate', 'multicrystallinekeratoglossus', 'awiwimegaloglossia', 'scutcheonwiseileocolitis', 'volubilityThuidium', 'Suionesunprejudicially', 'benzalethylaminedesulphurate', 'unscalednessChamaeleon', 'xiphosternamedia', 'gemeledAdonai', 'purgaNycticorax', 'overfretdisenthronement', 'venomouslypilferment', 'disjointedlytriamylose', 'pseudodemocraticproconscription', 'arhatsporozoic', 'peccationfoolery', 'whusslenoreast', 'yoreexponent', 'tautoousianentente', 'dyewoodsocii', 'Stromatoporoideabarry', 'cognaticalintransmissible', 'laterodeviationNarciss'], ['letohll', 'ntohll', 'nextproto_s', 'nextproto_b', 'float', 'lv', 'ntohl', 'ntohs', 'string']), 'unsanctioningperiuvular': ([], ['float']), 'projicientcolumellate': (['pseudodemocraticproconscription', 'certainarchpontiff', 'dermobranchiataboyardom', 'Orakzaiunsatisfiedly', 'seminegroSemiticize', 'byworkplastid', 'arhatsporozoic', 'remirrorundepreciated', 'scleroblastemicpalaeocosmology', 'unmistgraffer', 'foreuseuninfluencing', 'huddlingcladautoicous', 'Momotinaenonfortification', 'pedestrianateStromateidae', 'Histriobdellauntread', 'nondistributionclitellus', 'unrevenuedindecorousness', 'motacillinewidespreadly', 'flashpanstature', 'hippocampalscrow', 'predestinarianglia', 'integralizationbremeness', 'awiwimegaloglossia', 'terrazzododder', 'denieragedrapery', 'buprestidanarithmetic', 'gardenedfugacious', 'susurrateoutvie', 'dejectedincreasing', 'Triuridalesplagiarism', 'docimasytrouserdom', 'poonghiehectic', 'tecalipalingenesy', 'pinkberrynonvillainous', 'ochronosusafterbody', 'cophosisclour', 'Dokoelectrochemically', 'Eomecondiscolorate', 'gemeledAdonai', 'symmetricalantimasker', 'Ternstroemiaanisostomous', 'fleaweedprobate', 'Slavophilesedigitate', 'extravagantkaryoplasmatic', 'unfeasiblecollodiotype', 'hemologistbeglide', 'Suionesunprejudicially', 'unspendablevanilla', 'tuboovariandeducibleness', 'percontationMaimonist', 'unconvenedperpetually', 'buttonholerindigestive', 'hematozoalinfinitarily', 'gatewiseunderpot', 'ambisyllabicfruitful', 'piperitiousreekingly', 'depositoryteloblastic', 'Oliveanpyromancer', 'clinandriabryologist', 'predesignateunderservice', 'untastedgirllike', 'miningFlavia', 'wutproamusement', 'splanchnopleureprelapsarian', 'prebromidicMonopetalae', 'Vickyimmigrant', 'outworthbenevolence', 'asteamincandescency', 'Tullianrubidium', 'spraysemisaprophyte', 'subsoilercruent', 'Brandipriestcraft', 'knuckleboneunnegotiableness', 'neurofibriljanapan', 'nonofficeholdingwaldgravine', 'slichtarradiddler', 'misadministrationbroody', 'Lespedezafuthorc', 'unsanctioningperiuvular', 'semiduplexskirt', 'frolickytriphyline', 'ineloquentundishonored', 'kleenebocJungermannia'], ['byte', 'nextproto_b', 'nextproto_b', 'double', 'letohs', 'double', 'nextproto_s', 'letohll', 'nextproto_b', 'string', 'letohs', 'double', 'ntohl', 'ntohs', 'lv', 'letohs', 'byte', 'letohl', 'lv', 'letohll', 'string', 'string', 'string', 'nextproto_s', 'ntohs', 'double', 'letohl', 'nextproto_b', 'string', 'nextproto_s', 'ntohll', 'letohll', 'nextproto_b', 'ntohll', 'double', 'letohl', 'ntohl', 'byte', 'ntohl', 'double', 'letohs', 'nextproto_s', 'byte', 'string', 'letohs', 'nextproto_b']), 'medicochirurgicadvise': ([], ['float', 'double', 'ntohs', 'ntohl', 'ntohs', 'ntohll', 'ntohs', 'letohs', 'double', 'ntohs', 'double', 'byte', 'lv', 'ntohs', 'letohs', 'double', 'ntohll', 'double', 'string', 'byte', 'ntohll', 'float', 'float', 'lv', 'letohl', 'byte', 'ntohll', 'ntohll']), 'peragratemultifoliate': ([], ['double', 'byte', 'letohll', 'letohs', 'byte', 'string', 'lv', 'letohs', 'ntohll', 'letohs', 'float']), 'snackmisinstruction': (['ivoryliketransessentiate', 'campulitropoussapogenin', 'nontechnicalrongeur', 'coxbonesbirle', 'knuckleboneunnegotiableness', 'buttTarahumara', 'cudavaogreish', 'heliconbonnetman', 'snackmisinstruction', 'mallemuckyawner', 'Senecanovercorruptly', 'piskgriff', 'raspberrylikesubvertebral', 'cassiteritecasemaking', 'grapedmassively', 'goniometerhexameral'], []), 'Piscataqualagoonal': ([], ['double', 'ntohl', 'string', 'ntohs', 'byte', 'double', 'ntohll', 'ntohl', 'ntohl', 'letohll', 'letohll', 'letohs', 'double', 'ntohl', 'letohl', 'letohl', 'double', 'ntohll', 'lv', 'double', 'ntohll', 'ntohll', 'byte', 'letohll', 'letohs', 'double', 'ntohl', 'byte', 'letohs', 'lv', 'lv', 'double', 'letohl', 'letohll', 'ntohl', 'string', 'double', 'lv']), 'stickleafethenyl': (['Triuridalesplagiarism', 'piskgriff', 'stickleafethenyl', 'sheepkeepingfeedman', 'syphilologyannularity', 'cylindrarthrosisnonplusation', 'apioidalNagari', 'sacroposteriorveratryl', 'asperationoraculousness', 'vaporizetannery', 'refilmopenhandedness', 'unhittabledoublehorned', 'ineloquentundishonored', 'overpoliticunderlooker', 'menialitypreintelligent', 'steelworkpsychophysiological', 'dermobranchiataboyardom', 'carangoidbotryomycotic', 'overhollowescort', 'Stromatoporoideabarry', 'hyperneuriasymbolatry', 'multicrystallinekeratoglossus', 'peccationfoolery', 'unreprovedlysprier', 'collationdissuasively', 'semicolumnrankly', 'malthouseenteralgia', 'xenopodidtrencherless', 'udometricpredefault', 'Steganophthalmiagnomic', 'ambisyllabicfruitful', 'lepidodendridcounterplead', 'Lespedezafuthorc', 'shortcakeabase', 'Oliveanpyromancer', 'loungyimpolite', 'hammerkopnegativer', 'unlasheddialyzable', 'prattlersuffumigate', 'tollgateandrophagous', 'shuttlecockscanmag', 'tautoousianentente', 'perukiershiplexicographer', 'subordinationbrachial', 'pneumodynamicsprimariness', 'crossboltedasexually', 'subregenthelmeted', 'imperializetrispaston', 'unbeggarbroncholithiasis', 'utterabilitypavement', 'chytridialgoosemouth', 'outworthbenevolence', 'cystocarppapaprelatical', 'xenogenesisprenoble', 'tenesmicHymettic', 'counterpotentMetabola', 'bawcockPicnickian', 'racegoingunperformed', 'cesserreichspfennig', 'untastedgirllike', 'cannotdentigerous', 'Lawsonsemiconversion', 'coeternaloverhonor', 'blepharanthracosisuncliented', 'mataiuntameness', 'dehydrogenizeCambrian', 'semiduplexskirt', 'asepticallyBernese', 'peritrichouslyhepatoflavin', 'retroclusionmetaphysicianism', 'veldcraftsubprefect', 'extravagantkaryoplasmatic', 'paleobotanyworkpeople', 'evaluecystatrophia', 'springlikemonosymmetrically', 'stakeholderunforbade', 'goniometerhexameral', 'outfeatvasodilator', 'unmistgraffer', 'symmetricalantimasker', 'spraysemisaprophyte', 'spinthariscopemolybdena', 'chaffererunheaded', 'saltlypropugnator'], ['float', 'byte', 'byte', 'ntohll', 'nextproto_b', 'double', 'nextproto_s', 'letohs', 'string', 'letohs', 'float', 'ntohll', 'float', 'nextproto_s', 'letohs', 'byte', 'ntohs', 'ntohl', 'nextproto_b', 'byte', 'ntohs', 'nextproto_s', 'string']), 'tintsausinger': ([], ['byte', 'lv', 'double', 'ntohs', 'float', 'letohs', 'string', 'ntohll', 'letohl', 'letohs', 'ntohs', 'double', 'letohs', 'string', 'ntohl', 'float', 'byte', 'byte', 'ntohll', 'letohs', 'letohl', 'ntohs', 'letohll', 'lv', 'letohll', 'ntohll', 'ntohl']), 'terribletaut': ([], ['letohl', 'ntohs', 'ntohll', 'ntohl', 'float', 'ntohll', 'ntohl', 'letohll', 'ntohll', 'letohll', 'byte', 'float', 'byte', 'string', 'byte']), 'phlebectomySiam': ([], ['ntohl', 'ntohll', 'ntohs', 'byte', 'byte', 'double', 'letohll', 'ntohs', 'byte', 'ntohll', 'ntohs', 'float', 'float', 'letohs', 'letohl', 'letohs', 'letohl', 'ntohs', 'ntohll', 'double', 'ntohll', 'double', 'letohll', 'ntohll', 'letohll', 'ntohs', 'ntohs', 'ntohl', 'lv', 'ntohll', 'ntohl', 'lv', 'double', 'ntohll', 'lv', 'ntohl', 'byte', 'letohll']), 'sacroposteriorveratryl': ([], ['ntohl', 'byte', 'byte', 'double', 'string', 'ntohl', 'byte', 'letohl', 'float', 'letohl', 'letohs', 'byte', 'byte', 'float', 'float', 'letohll', 'ntohll', 'float', 'letohll', 'double', 'float', 'ntohl', 'ntohll', 'ntohs', 'ntohl', 'double', 'letohll', 'ntohll', 'float', 'letohl', 'ntohs', 'float', 'ntohs', 'letohl']), 'sitfastcaret': ([], ['ntohl', 'ntohl', 'ntohs', 'float', 'string', 'letohll', 'ntohl', 'byte', 'ntohs', 'ntohs', 'ntohs']), 'leathermakersemishirker': (['spadelikemassacrer', 'maltingsurrection', 'arnberrydodecadrachm', 'addressorcondensedly', 'cycloolefinmonostylous', 'frolickytriphyline', 'subcostalbaldmoney', 'evaluecystatrophia', 'parathyroidectomizeoutheart', 'Mayorunahybridizer', 'summarizationyatter', 'subregenthelmeted', 'hookahsupersimplicity', 'symmetricalantimasker', 'coinbellmaker'], ['letohl']), 'miningFlavia': ([], ['ntohll', 'letohl', 'ntohs', 'letohs', 'ntohl', 'double']), 'Islamiticgreenbark': ([], ['letohll', 'double', 'letohl', 'lv', 'string', 'ntohll', 'letohs', 'letohs', 'letohl', 'ntohl', 'letohs', 'letohll', 'letohll', 'ntohll', 'lv', 'byte', 'letohll', 'ntohs', 'string']), 'piskgriff': ([], ['float', 'ntohs', 'ntohs', 'ntohll', 'ntohl', 'double', 'letohs', 'string', 'lv', 'letohl', 'byte', 'ntohll', 'double', 'letohs', 'letohs', 'letohll', 'string', 'letohl', 'ntohs', 'letohll', 'lv', 'letohs']), 'uncarrieddigitinerved': (['thiodiphenylaminediterpene', 'micrencephalypalpus', 'Trinorantumpyramides', 'amlipyrexic', 'domanialPhora', 'superabsurdditremid', 'hyperduliaferrateen', 'counterdraftdamewort', 'meddlingsmall', 'endopathicnonmarrying', 'hystericsupersuperior', 'baptizeeFrenchize', 'stomagringo', 'matelessbeatitude', 'roofprespur', 'overhollowescort', 'Limodorumscrotal', 'untrammelednessHannibalian', 'cerebroidodontolcate', 'angiomyocardiacmisinformer', 'Lespedezafuthorc', 'perukiershiplexicographer', 'ExobasidialesEppy', 'predefinitionCarnaria', 'dinitrilholocentrid', 'prelanguagecloudage', 'hyperneuriasymbolatry', 'mercurializationsimulacre', 'warfaringdraghound', 'entrapmentvoyageable', 'protosiphonaceousossiferous', 'crossboltedasexually', 'membershiptownsboy', 'weathercockismcustodier', 'ralphautonomically', 'visorlikeNagari', 'heronerchondroplasty', 'theohumanhooper', 'misputheptarchist', 'disaffectedanchorite', 'depositoryteloblastic', 'attestatorcoronule', 'autovivisectionoverleather', 'pyrroylprobity', 'scleroblastemicpalaeocosmology', 'peerlesslyforetalk', 'mattapharyngological', 'campulitropoussapogenin', 'lepidodendridcounterplead', 'hemianacusiadouble', 'dyewoodsocii', 'chinkingcytologic', 'catastateateliosis', 'paleobotanyworkpeople', 'elementalismpietism', 'alkaneirrigable', 'brackishrehazard', 'oversolicitouslyhour', 'unvoiceCamacan', 'dissogenyBarney', 'triplewisepostepileptic', 'ornithotomyblackwort', 'irislikeaphyllose', 'pilchermonaulos', 'mammillationpemphigous', 'laparotomycephalohumeralis', 'mediumismgypsyism', 'bacteriformpiercel', 'focoidsstackfreed', 'unhittabledoublehorned'], ['letohll', 'letohll', 'double', 'nextproto_b', 'float', 'byte']), 'nugacioushypotensive': ([], ['letohll', 'letohs', 'letohl', 'letohll', 'lv', 'letohs', 'letohs', 'ntohll', 'letohl', 'ntohl', 'double', 'letohs', 'lv', 'letohll', 'double', 'letohl', 'float', 'string', 'ntohll', 'ntohll', 'byte', 'letohs', 'float']), 'katabolizedermic': ([], ['float', 'float', 'letohl', 'byte', 'ntohl', 'byte', 'string', 'lv', 'double', 'byte', 'ntohs', 'byte', 'ntohs', 'ntohl', 'float', 'ntohll', 'letohs', 'letohs', 'byte', 'letohl', 'lv', 'lv', 'lv', 'ntohll', 'letohs', 'ntohs', 'string', 'ntohl', 'double', 'letohll', 'letohll', 'float', 'letohl', 'ntohl', 'byte', 'letohl', 'byte']), 'shortcakeabase': ([], ['letohs', 'letohll', 'letohs', 'ntohl', 'letohll', 'letohll', 'lv', 'lv', 'letohll']), 'unhyphenedallose': ([], ['letohl', 'ntohll', 'lv', 'ntohl', 'letohs', 'lv', 'ntohs', 'letohs', 'ntohll', 'double', 'string', 'string', 'letohll']), 'depositumspiritsome': (['racegoingunperformed', 'cacuminalgastrohysterorrhaphy', 'agonizefloating', 'pantomnesiadiporpa', 'pavonatedcozily', 'fleaweedprobate', 'cinecameraHydropotes', 'unfootsorepoonac', 'roofprespur', 'micrencephalypalpus', 'insidiouslysurplicewise', 'predefinitionCarnaria', 'unhyphenedallose', 'channelizeungarter', 'etioporphyrinpubovesical', 'pellagrosemongrelization', 'undercovertcoloss', 'euquinquennium', 'counterspyingdungeon', 'symptosissubcorneous', 'steinkirkmisaffection', 'stagemansupa', 'apioidalNagari', 'cardialgiacontingence', 'zeuctocoelomicmetapodial', 'loungyimpolite', 'scruplercellulifugal', 'sulfureasupertramp', 'lungflowerhorrormonger', 'napalmbrevifoliate', 'unlasheddialyzable', 'Larinaecoydog', 'xenogenesisprenoble', 'opportunisttitlark', 'petalocerouscamus', 'gemeledAdonai', 'OrleansSchedius', 'unrevenuedindecorousness', 'chromophilouspyometra', 'anomalousparallelinerved', 'vaporizetannery', 'dissogenyBarney', 'bacteriformpiercel', 'subregenthelmeted', 'reburstsummity', 'dominionistversableness', 'dehydrogenizeCambrian', 'cudavaogreish', 'notwitch', 'slopinglyautomatically', 'spadelikemassacrer', 'interventraliaforeutter', 'GemitoresBourignian', 'endogalvanismunwarrantedly', 'depositoryteloblastic', 'querulouslycooky', 'photocompositioneneuch', 'echinostomewont', 'Mayorunahybridizer', 'emblazonarsenopyrite', 'popeyednaphtha', 'certainarchpontiff', 'tecalipalingenesy', 'untuckedsolenoglyphic', 'foreuseuninfluencing', 'shuttlecockscanmag', 'erythriticsynergidal', 'subcineritiousphrenitic', 'tautologicpanimmunity'], ['letohl', 'ntohl', 'ntohl', 'letohl', 'float', 'ntohs', 'string', 'lv', 'double', 'letohs', 'letohl']), 'OrleansSchedius': (['outfeatvasodilator', 'apioidalNagari', 'antleredadunc', 'carcerationinterrenal', 'radiopaqueunrecruitable', 'outworthbenevolence', 'warneriodocasein', 'ivoryliketransessentiate', 'Pamirioversystematic', 'stickleafethenyl', 'avalanchestylopization', 'mausoleandecasualize', 'surlyreptilferous', 'pellagrosemongrelization', 'prelanguagecloudage', 'previousnessoisin', 'racegoingunperformed', 'cassiteritecasemaking', 'arhatsporozoic', 'misadministrationbroody', 'susurrateoutvie', 'reburstsummity', 'opportunisttitlark', 'hyperneuriasymbolatry', 'mataiuntameness', 'ochronosusafterbody', 'engrossedlyDinoceras'], ['nextproto_b', 'ntohs', 'ntohs', 'letohl', 'lv', 'nextproto_b', 'letohll', 'lv', 'string', 'lv', 'ntohll', 'lv', 'lv', 'nextproto_s', 'float', 'letohl', 'string', 'letohs', 'letohl', 'ntohs', 'ntohs', 'float', 'float', 'float', 'float', 'ntohs', 'lv', 'nextproto_b', 'byte', 'ntohl', 'float', 'double', 'lv', 'ntohl', 'string', 'letohs', 'lv', 'string', 'letohl', 'letohs', 'double']), 'tecalipalingenesy': ([], ['lv', 'letohl', 'lv', 'float', 'byte', 'lv', 'string']), 'uncrevassedterministic': ([], ['byte', 'ntohl', 'string', 'double', 'float', 'ntohs', 'float', 'double', 'letohs', 'letohll', 'ntohll', 'ntohll', 'letohll', 'string', 'lv', 'ntohll', 'ntohl', 'ntohl', 'ntohs', 'lv', 'string', 'float', 'float', 'float', 'float']), 'cytochromemonosepalous': ([], ['lv', 'ntohs', 'ntohll', 'ntohs', 'ntohll', 'letohll', 'ntohs', 'float', 'ntohll', 'double', 'ntohll', 'lv']), 'bullswooldraggletail': ([], ['double', 'letohll', 'byte', 'ntohs', 'letohs', 'letohl', 'ntohs', 'byte', 'ntohl', 'float', 'double', 'letohs', 'letohs', 'ntohs', 'lv', 'ntohs', 'lv', 'double', 'lv', 'byte', 'letohl', 'double', 'ntohll', 'letohll', 'byte', 'float', 'string', 'float', 'ntohs', 'letohs', 'ntohs']), 'camphyleneremarkedly': (['thiodiphenylaminediterpene', 'gratefulAlcedinidae', 'unhyphenedallose', 'imperializetrispaston', 'syphilologyannularity', 'antleredadunc', 'cycloolefinmonostylous', 'unoverhauledGalinsoga', 'otogenouschromatographic', 'fitfulunshrill', 'channelizeungarter', 'geriatricundaubed', 'unmistgraffer', 'sideflashmagniloquent', 'grammaticismmignonette', 'tantarabobusaurify', 'deadlockperiangitis', 'agoraphobiaLenzites', 'hyperneuriasymbolatry', 'etioporphyrinpubovesical', 'Limodorumscrotal', 'paleobotanyworkpeople', 'rosiedunarchdeacon', 'reladepropiolaldehyde', 'bustedpredoubter', 'hyperduliaferrateen', 'excentricalProtococcales', 'dermobranchiataboyardom', 'vibrativeoversail', 'shellycoatcallousness', 'Slovenerecure', 'inferiorismobstetrix', 'enclothearmiferous', 'ananaamasty', 'Eurypteroideachamaeprosopic', 'euquinquennium', 'tonguinessresoundingly', 'cacuminalgastrohysterorrhaphy', 'overganggenesial', 'interimperialvignetter', 'Bharatadomain', 'hematozoalinfinitarily', 'Ibaditehypotenuse', 'pegologyscavenage', 'crouchingpurebred', 'shuttlecockscanmag', 'utterabilitypavement', 'Graphiolacolorimetry', 'psychrographismdom', 'wutproamusement', 'Abrahamicinordinateness', 'logarithmeticallydeliriant', 'engrossedlyDinoceras', 'unscalednessChamaeleon', 'meddlingsmall', 'unodoriferousWhiggish', 'declamatorinessSerrifera'], ['double', 'letohl', 'letohll', 'ntohs', 'letohs', 'letohs', 'letohl', 'ntohs', 'letohl', 'double', 'ntohs', 'letohs', 'letohs', 'byte', 'ntohs', 'ntohll', 'string', 'letohl', 'byte', 'ntohl', 'byte', 'nextproto_s', 'letohl', 'double', 'ntohl', 'ntohs', 'byte', 'string', 'float', 'ntohll', 'nextproto_s', 'ntohs', 'letohs', 'lv', 'nextproto_s', 'nextproto_s', 'string', 'ntohll', 'nextproto_b', 'string', 'ntohll', 'nextproto_s', 'double', 'ntohs', 'letohll', 'nextproto_b', 'nextproto_b', 'nextproto_s', 'lv']), 'dookmainport': ([], ['ntohl', 'double', 'ntohs', 'string', 'letohll', 'letohl', 'letohl', 'letohl', 'double', 'string', 'byte', 'lv', 'letohs', 'letohs', 'byte', 'ntohl', 'double', 'lv', 'letohs', 'double', 'ntohs', 'float', 'string', 'letohl', 'string']), 'matelessbeatitude': ([], ['ntohl', 'letohl', 'letohs', 'ntohs', 'ntohl', 'byte', 'lv', 'string', 'byte', 'byte', 'double', 'string', 'lv', 'ntohl', 'double', 'letohll', 'letohs', 'lv', 'letohll', 'letohs']), 'unfeasiblecollodiotype': (['pellagrosemongrelization', 'bemuzzlesurficial', 'tenesmicHymettic', 'napalmbrevifoliate', 'evaluecystatrophia', 'shortcakeabase', 'epistlarcystoid', 'Dokoelectrochemically'], ['ntohll', 'float', 'letohs', 'ntohs', 'ntohll', 'float', 'double', 'ntohs', 'float', 'ntohll', 'float', 'ntohl', 'float', 'byte', 'float', 'ntohs', 'lv', 'nextproto_b', 'float', 'letohs', 'string', 'nextproto_b', 'ntohs', 'ntohs', 'double', 'letohl', 'letohs', 'ntohll', 'letohs', 'nextproto_b', 'letohll', 'letohll', 'nextproto_s', 'ntohll', 'nextproto_b', 'float', 'letohll', 'byte', 'float', 'double', 'ntohll', 'byte', 'nextproto_s', 'letohll', 'letohs', 'letohs', 'nextproto_s', 'ntohll', 'letohll']), 'counterspyingdungeon': ([], ['ntohll', 'letohll', 'ntohl', 'lv', 'double', 'ntohl', 'ntohs', 'lv', 'letohl', 'byte', 'ntohl', 'lv', 'ntohl', 'double', 'ntohs', 'double', 'byte', 'letohll', 'letohl', 'letohl', 'ntohll', 'float', 'ntohll', 'letohll', 'ntohs', 'string', 'ntohs', 'byte', 'double', 'lv', 'ntohll', 'float', 'byte', 'lv', 'lv']), 'spinosotuberculatedeossify': (['spinosotuberculatedeossify', 'polishedlyhematosis', 'maskflowerkeynoter', 'etherifyCicadidae', 'dyewoodsocii', 'disjointedlytriamylose', 'gynarchicagedly', 'sulphhemoglobinHerculanean', 'nasicornousfasciated', 'Slovenerecure', 'logarithmeticallydeliriant', 'nowhitoffscape', 'Philoctetessupersalesman', 'pyrroylprobity', 'carangoidbotryomycotic', 'gatewiseunderpot', 'Histriobdellauntread', 'opportunisttitlark', 'butterrootchagrin', 'endogalvanismunwarrantedly', 'steinkirkmisaffection', 'tuboovariandeducibleness', 'unflukedcleck', 'gratefulAlcedinidae', 'gymnosporouswoubit', 'nonaugmentativehypertelic', 'counterspyingdungeon', 'togueseaflower', 'subsorterbecuffed', 'subregenthelmeted', 'ancestorialLicania', 'tollgateandrophagous', 'codeinesalience', 'docimasytrouserdom', 'cudavaogreish', 'peccationfoolery', 'preinjuryduplicature', 'faddyamputational', 'fillmetroptosis', 'laparotomycephalohumeralis', 'arnberrydodecadrachm', 'Dokoelectrochemically', 'saltlypropugnator', 'picayunishapogeotropic', 'hallowerhydrophthalmos', 'noniccosmopoietic', 'bacteriformpiercel'], ['nextproto_b', 'double', 'letohl', 'letohl', 'byte', 'byte', 'string', 'ntohll', 'lv', 'ntohll', 'ntohll', 'lv', 'letohs', 'ntohll', 'letohs', 'byte', 'letohs', 'ntohll', 'nextproto_s', 'double', 'ntohs', 'lv', 'double', 'ntohl', 'letohl', 'ntohl', 'ntohll', 'double', 'byte', 'letohs', 'float', 'ntohll', 'letohs', 'letohll', 'lv', 'double', 'nextproto_b', 'ntohl', 'ntohll', 'float', 'letohll', 'letohl']), 'muckyuxoricide': ([], ['float', 'ntohs', 'double', 'double', 'letohll', 'letohll', 'ntohs', 'string', 'ntohs', 'letohs', 'ntohs', 'float', 'letohs', 'letohl', 'letohll', 'ntohll', 'letohs', 'ntohl', 'double', 'lv']), 'indubitablenoncollaboration': (['nonadjustmentwritmaking', 'amlipyrexic', 'xenopodidtrencherless', 'unhittabledoublehorned', 'engrossedlyDinoceras', 'precoxseambiter', 'remisrepresentationlancet', 'saltlypropugnator', 'TelopeaCyclotosaurus', 'distilleryKiwanis', 'bawcockPicnickian', 'chaffererunheaded', 'fleaweedprobate', 'Lespedezafuthorc', 'unpaintterebinic', 'dehydrogenizeCambrian', 'recapitalizerelevate', 'bemuzzlesurficial', 'utterabilitypavement', 'gatewiseunderpot', 'multicrystallinekeratoglossus', 'ambisyllabicfruitful', 'unmistgraffer', 'whusslenoreast', 'extravagantkaryoplasmatic', 'napalmbrevifoliate', 'sheepkeepingfeedman', 'acclaimerilluminability', 'renverseundethroned', 'fetoracclimatement', 'bustedpredoubter', 'Stromatoporoideabarry', 'herpetologistindeed', 'laterodeviationNarciss', 'loungyimpolite', 'subcineritiousphrenitic', 'strangulableargentamid', 'channelizeungarter', 'peccationfoolery', 'tollgateandrophagous', 'semicolumnrankly', 'barrelmakingparoemia', 'percontationMaimonist', 'weathercockismcustodier', 'phototherapistupsetted', 'apioidalNagari', 'interimperialvignetter', 'querulouslycooky', 'springlikemonosymmetrically', 'hemianacusiadouble', 'coeternaloverhonor', 'grapedmassively', 'changeablyzoophilitic', 'agonizefloating', 'cassiteritecasemaking', 'tumoredcrocodilite', 'esophagoplastyrestrainedness', 'anomalousparallelinerved', 'Fichteanismconjobble', 'addressorcondensedly', 'pedestrianateStromateidae'], ['letohll', 'float', 'byte', 'nextproto_b', 'double', 'letohll', 'letohll', 'letohl', 'string', 'lv', 'lv', 'ntohll', 'ntohll', 'letohs', 'double', 'string', 'float', 'lv', 'nextproto_s', 'ntohll', 'nextproto_s']), 'ankylophobiaAsperula': (['scleroblastemicpalaeocosmology', 'skeesicksunsteamed', 'hyperneuriasymbolatry', 'cerebroidodontolcate', 'heronerchondroplasty', 'decimosextountractarian', 'changeablyzoophilitic', 'thymegollidflower', 'redifferentiationmustachio', 'codeinesalience', 'listeningBroussonetia', 'lobectomypreinflection', 'schuleclethraceous', 'exportnontarnishable', 'oxmanoutpull', 'cattlefolk', 'venomouslypilferment', 'appendiceunmetaled', 'unexchangedsupraventricular', 'imperializetrispaston', 'cesserreichspfennig', 'remirrorundepreciated', 'mammillationpemphigous', 'smotheringlyhumpbacked', 'noniccosmopoietic', 'Lachnosternaadenodermia', 'Ciceronicpownie', 'uncrevassedterministic', 'pavonatedcozily', 'sulphhemoglobinHerculanean', 'disjointedlytriamylose', 'pedestrianateStromateidae', 'gumdiggingsalvarsan', 'Slavophilesedigitate', 'prizeexcrescence', 'counterpotentMetabola', 'Chilopsiscompactible', 'craunchprovitamin', 'protosiphonaceousossiferous', 'Histriobdellauntread', 'Heterodactylaefrisk', 'microcaltropmyosarcomatous', 'antleredadunc', 'motacillinewidespreadly'], ['nextproto_b', 'ntohs', 'double', 'nextproto_b', 'letohl', 'letohl', 'string', 'float', 'ntohl', 'float', 'nextproto_b', 'letohs', 'byte', 'letohl', 'double', 'ntohs', 'float', 'byte', 'double', 'string', 'ntohll', 'ntohll', 'ntohll', 'letohs', 'ntohs', 'ntohs', 'lv', 'float', 'letohll', 'double', 'lv', 'letohll', 'string', 'nextproto_s', 'ntohs', 'string', 'letohll']), 'overseateddiscouragingly': ([], ['letohl', 'letohl', 'letohl', 'letohs', 'letohll', 'string', 'letohl', 'ntohs', 'string', 'letohll', 'letohll', 'string', 'letohll', 'double', 'letohl', 'letohl', 'ntohl', 'ntohs']), 'skeelysubtriangular': ([], ['ntohs', 'double', 'byte', 'letohs', 'letohl', 'letohs', 'double', 'string', 'letohll', 'ntohll', 'double', 'letohll', 'ntohll', 'letohs', 'letohl', 'string', 'lv', 'byte', 'string', 'letohll', 'letohs', 'letohs', 'double', 'ntohl', 'float', 'ntohl', 'ntohll', 'string', 'letohs', 'float', 'byte', 'double', 'byte', 'lv', 'string', 'string', 'letohl', 'ntohll', 'letohl']), 'Physciawenny': ([], ['float', 'lv', 'float', 'float', 'letohs', 'byte', 'ntohs', 'letohl']), 'xenogenesisprenoble': ([], ['float', 'string', 'float', 'double', 'letohll', 'ntohll', 'letohll', 'ntohs', 'lv', 'byte', 'letohll', 'letohs', 'ntohs', 'lv', 'letohs', 'letohs', 'ntohll', 'letohl', 'ntohs', 'letohl', 'letohl', 'ntohll', 'letohl', 'letohll', 'float', 'letohl', 'ntohll', 'lv', 'float', 'letohll', 'letohl', 'letohl', 'byte', 'float', 'letohs', 'ntohs', 'double', 'letohll', 'string', 'letohs', 'ntohs', 'letohll', 'byte']), 'gratifyinglymetrorrhea': ([], ['letohs', 'lv', 'double', 'letohll', 'byte', 'string', 'byte', 'letohl', 'double', 'float', 'ntohll', 'ntohs', 'letohs', 'ntohl', 'double', 'string', 'string']), 'smotheringlyhumpbacked': (['clinandriabryologist', 'Ternstroemiaanisostomous', 'loketprincipiate', 'gynarchicagedly', 'cannotdentigerous', 'unhyphenedallose', 'unquailingshive', 'pantomnesiadiporpa', 'allerChilostoma', 'simulcastriboflavin', 'Trinorantumpyramides', 'whusslenoreast', 'petalocerouscamus', 'enclothearmiferous', 'predisciplinetukra', 'cophosisclour', 'prehexameraldissyllabize', 'scheltopusikAmpelidaceae', 'chaffererunheaded', 'unfannedhopperman', 'semisomnolencegunj', 'sharkletcompactedly', 'unhittabledoublehorned', 'sokarailer', 'emblazonarsenopyrite', 'ettleoptimize', 'untuckedsolenoglyphic', 'volubilityThuidium', 'cardialgiacontingence', 'bawcockPicnickian', 'euquinquennium', 'unstalledneutralism', 'evaluecystatrophia', 'hyperduliaferrateen', 'misproduceunthrilled', 'butyrochloralfertilizational', 'subsoilercruent', 'semiduplexskirt', 'petalousausterity', 'TaboriteSanche', 'recapitalizationdissipative', 'predestinarianglia', 'foliicolousskeletonweed', 'addressorcondensedly', 'Wagnerianaaviculturist', 'pilchermonaulos', 'cudavaogreish', 'ruinlikesilva', 'amlipyrexic', 'Lawsonsemiconversion', 'stomagringo', 'microcrystallogenyfuniculus', 'saltlypropugnator', 'SpatangusChayma'], ['letohll', 'nextproto_s', 'byte', 'byte', 'double', 'letohl', 'letohs', 'letohll', 'letohll']), 'wutproamusement': ([], ['letohll', 'double', 'letohll', 'ntohll', 'float', 'ntohs', 'float', 'double', 'ntohl', 'lv', 'letohs', 'string', 'letohll', 'double', 'ntohll', 'float', 'ntohs', 'lv', 'byte', 'lv', 'ntohll', 'ntohl', 'ntohll', 'float', 'letohll', 'letohll', 'lv', 'letohs', 'letohs', 'float', 'double', 'ntohl', 'ntohll', 'byte', 'letohll']), 'buttTarahumara': (['amlipyrexic'], ['ntohs', 'letohll', 'ntohs', 'nextproto_s', 'float', 'float', 'nextproto_s', 'ntohs', 'letohs', 'letohl', 'letohl', 'nextproto_b', 'double', 'string', 'nextproto_s', 'letohs', 'letohs', 'letohl', 'letohs', 'letohs', 'ntohl', 'lv', 'ntohl', 'ntohs', 'letohs', 'ntohs', 'ntohl', 'ntohs', 'lv', 'ntohs', 'string', 'nextproto_s', 'letohs', 'letohl', 'nextproto_b', 'float']), 'Slavophilesedigitate': (['recapitalizationdissipative', 'motacillinewidespreadly', 'pneumodynamicsprimariness', 'clientageshudderingly', 'Sonjapylorogastrectomy', 'petalousausterity', 'woodrowelshrievalty', 'zeuctocoelomicmetapodial', 'Vickyimmigrant', 'enclothearmiferous', 'ramraceBorderies', 'nonadjustmentwritmaking', 'hyperduliaferrateen', 'isuroidunfitly', 'laparotomycephalohumeralis', 'paleobotanyworkpeople', 'goodlyterebenthene', 'falsificationcomer', 'eudaemonisticallyCoccolobis', 'matelessbeatitude', 'notwitch', 'pistoleerproexamination', 'overhollowescort', 'intercoolingpotentialization', 'cardialgiacontingence', 'violationguggle', 'maskflowerkeynoter', 'Rodolphhumuslike', 'spinthariscopemolybdena', 'dehydrogenizeCambrian', 'scruplercellulifugal', 'iridemiabisque', 'wirrshillingless', 'esophagoplastyrestrainedness', 'surlyreptilferous', 'bacteriformpiercel', 'peccationfoolery', 'superestablishmentsuccor', 'plurifacialmicrographical', 'miningFlavia', 'asperationoraculousness', 'stagemansupa', 'repolymerizationwesselton', 'gratefulAlcedinidae', 'echinostomewont', 'nondistributionclitellus', 'outlawrypervertedness', 'unsanctioningperiuvular', 'overseateddiscouragingly', 'Sumasslevulosuria', 'dyewoodsocii', 'Slavophilesedigitate', 'dinitrilholocentrid', 'roofprespur', 'seminegroSemiticize', 'Brandipriestcraft', 'refilmopenhandedness'], ['double', 'lv', 'nextproto_s', 'lv', 'nextproto_b', 'letohl', 'float', 'nextproto_s', 'letohs', 'double', 'lv', 'ntohll', 'nextproto_s', 'letohll', 'lv', 'letohl', 'letohl', 'double', 'letohll', 'letohs', 'lv', 'ntohs', 'nextproto_s', 'letohs', 'ntohl', 'byte', 'ntohl', 'ntohl', 'float', 'ntohs', 'letohl', 'string', 'nextproto_b', 'double', 'ntohl', 'lv', 'ntohs', 'lv', 'nextproto_s', 'letohll', 'letohll']), 'yoreexponent': ([], ['letohs', 'letohll', 'lv', 'double', 'lv', 'ntohl', 'ntohl', 'ntohl', 'ntohl', 'ntohll', 'ntohs']), 'unfangedramline': ([], ['letohs', 'double', 'letohll', 'letohs', 'letohll', 'float', 'letohl', 'byte', 'letohll', 'lv', 'ntohll', 'double', 'float', 'string', 'ntohl', 'double', 'ntohl']), 'reproachablepancreatogenic': ([], ['ntohs', 'ntohll', 'letohll', 'double', 'string', 'ntohs', 'letohl', 'byte', 'ntohs', 'float', 'ntohs', 'double', 'ntohll', 'letohll', 'ntohs', 'ntohll', 'letohl', 'ntohl', 'ntohll', 'letohll', 'ntohl', 'ntohll', 'byte', 'letohs', 'ntohl', 'byte', 'letohl', 'ntohl', 'float', 'letohs', 'byte', 'letohl', 'letohll', 'ntohl', 'letohl', 'ntohll']), 'spicousHippopotamidae': ([], []), 'prankinglypneumotherapy': (['spinthariscopiclieutenancy', 'unmistgraffer', 'zeuctocoelomicmetapodial', 'dermobranchiataboyardom', 'Piscataqualagoonal', 'overseateddiscouragingly', 'subregenthelmeted', 'xiphosternamedia', 'evenworthyharebrain', 'paralyzerthiocarbimide', 'loungyimpolite', 'enclothearmiferous', 'hemianacusiadouble', 'tautologicpanimmunity', 'hippocampalscrow', 'refilmopenhandedness', 'Robenhausianreboil', 'awiwimegaloglossia', 'skilderprothalline', 'percontationMaimonist', 'prosubscriptiontribracteate', 'Plymouthistnashgab', 'proportionaltasselmaker', 'coxbonesbirle', 'unoverhauledGalinsoga', 'addressorcondensedly', 'utterabilitypavement', 'matelessbeatitude', 'Vandiemenianwinery', 'cudavaogreish', 'Momotinaenonfortification', 'agonizefloating', 'photocompositioneneuch', 'yawpwoodwax', 'piperitiousreekingly', 'subrigidlithophysal', 'allegoristerserendite', 'Slovenerecure'], ['float', 'letohl', 'ntohll', 'ntohs', 'nextproto_s', 'ntohs', 'letohl', 'byte', 'letohs', 'letohll', 'float', 'nextproto_b', 'double', 'nextproto_s', 'ntohl', 'float', 'double', 'letohl']), 'untrainhearkener': ([], ['ntohl', 'letohl', 'float', 'byte', 'ntohs', 'ntohl', 'string', 'string', 'string', 'ntohll', 'ntohl', 'float']), 'torskpiss': (['subcineritiousphrenitic', 'poonghiehectic', 'hyperduliaferrateen', 'cerebroidodontolcate', 'stickleafethenyl', 'overkneePolypoda', 'prehexameraldissyllabize', 'fillmetroptosis', 'smackinglyScheuchzeriaceae', 'urogastricjesting', 'decimosextountractarian', 'saffianpackcloth', 'emergencechouette', 'interimperialvignetter', 'prochordalnaveled', 'misspellquinaldic', 'tellurethurryproof', 'wirrshillingless', 'allanitictrichitis', 'vernileDasya', 'cosilybridecake', 'anomalousparallelinerved', 'sincerenessundominoed', 'acclaimerilluminability', 'balandracaducibranch', 'Orakzaiunsatisfiedly', 'napalmbrevifoliate', 'usurperunplannedly', 'uncomminutedcommix', 'valvotomypensionably', 'Anglomaniaclovableness', 'enclothearmiferous', 'Wagnerianaaviculturist', 'herpetologistindeed', 'vanilleshellburst', 'vaporizetannery', 'zincotypetripodic', 'rewhirlhypermotility', 'distilleryKiwanis', 'ambisyllabicfruitful', 'fleaweedprobate', 'Saxonicalpalet', 'demibeastuninflicted', 'petalocerouscamus', 'abjudicationunpleading', 'unsubstantiaterightfulness', 'cacuminalgastrohysterorrhaphy', 'carannaaccension', 'scleroblastemicpalaeocosmology', 'Maytimeraillike', 'holdsmanoversalty', 'provectgastrocolostomy', 'butyrochloralfertilizational', 'rachiometersuprachoroid'], ['ntohs', 'letohs', 'string', 'ntohs', 'byte', 'byte', 'string', 'nextproto_s', 'float', 'lv', 'double', 'letohl', 'ntohll', 'lv', 'string', 'nextproto_b', 'double', 'float', 'letohl', 'nextproto_b', 'nextproto_s', 'ntohs', 'letohll', 'lv', 'letohll', 'ntohll', 'ntohl', 'lv', 'ntohl']), 'Erotylidaeprehesitate': ([], ['letohll', 'letohl', 'letohll', 'float', 'byte', 'ntohl', 'letohs', 'ntohs', 'string', 'letohll', 'lv', 'byte', 'letohl', 'letohll', 'ntohll', 'lv', 'byte', 'lv', 'letohs', 'byte', 'letohl', 'double', 'letohs', 'ntohl', 'byte', 'ntohll', 'letohll', 'letohs', 'ntohll', 'float', 'ntohs', 'ntohl']), 'protosiphonaceousossiferous': ([], ['letohl', 'ntohs', 'float', 'string', 'ntohll', 'ntohs', 'letohll', 'ntohl', 'double', 'ntohs', 'float', 'letohs', 'ntohll', 'letohl', 'lv', 'string', 'letohll', 'letohs', 'ntohs', 'letohs', 'letohl', 'ntohll', 'float', 'double', 'byte']), 'exponencecrubeen': ([], ['letohll', 'string', 'string', 'float', 'ntohl', 'ntohl', 'string', 'letohl', 'lv', 'float', 'letohl', 'lv', 'string', 'double', 'letohll', 'letohll', 'ntohl', 'double', 'ntohl', 'byte']), 'goodlyterebenthene': (['sokarailer', 'shuttlecockscanmag', 'laparotomycephalohumeralis', 'cardialgiacontingence', 'monodromiclyretail', 'pavonatedcozily', 'maltingsurrection', 'anomalousparallelinerved', 'springlikemonosymmetrically', 'herpetologistindeed', 'prelanguagecloudage', 'clientageshudderingly', 'nonadjustmentwritmaking', 'udometricpredefault', 'shortcakeabase', 'overpoliticunderlooker', 'yoreexponent', 'predesignateunderservice', 'peerlesslyforetalk', 'untastedgirllike', 'unfannedhopperman', 'previousnessoisin', 'Lawsonsemiconversion', 'noniccosmopoietic', 'changeablyzoophilitic', 'doubleheartedstaphylolysin', 'carcerationinterrenal', 'Stromatoporoideabarry', 'xenogenesisprenoble', 'depositoryteloblastic', 'cineplastyanonang', 'carannaaccension', 'feveretunderbox', 'Vandiemenianwinery', 'parathyroidectomizeoutheart', 'superestablishmentsuccor', 'unhyphenedallose', 'epistlarcystoid', 'Dokoelectrochemically', 'crossboltedasexually', 'Lespedezafuthorc', 'idioglossiascabble', 'unpaintterebinic', 'faddyamputational', 'unusehydroponist', 'hookahsupersimplicity', 'Oliveanpyromancer', 'grapedmassively', 'misadministrationbroody', 'spraysemisaprophyte', 'semicolumnrankly', 'declamatorinessSerrifera', 'zoosporangialbuyable', 'cystocarppapaprelatical', 'distilleryKiwanis', 'trentepohliaceousHectorean', 'iconismanisostemonous', 'avalanchestylopization', 'bemuzzlesurficial', 'seminegroSemiticize', 'symmetricalantimasker', 'predefinitionCarnaria', 'apioidalNagari', 'prattlersuffumigate', 'tenesmicHymettic', 'unhittabledoublehorned', 'subregenthelmeted', 'cannotdentigerous', 'spadelikemassacrer', 'androgynyvegetoalkaline', 'unmistgraffer', 'epigenesistbisexed', 'bumblefooticonology', 'dissogenyBarney', 'cylindrarthrosisnonplusation', 'Erotylidaeprehesitate', 'laterodeviationNarciss', 'microcrystallogenyfuniculus', 'undercovertcoloss', 'Philonismpinivorous', 'OrleansSchedius'], ['ntohl', 'byte', 'letohll', 'letohs', 'lv', 'lv', 'double', 'double', 'double', 'byte', 'string', 'ntohs', 'nextproto_s', 'ntohll', 'string', 'double', 'ntohl', 'ntohll', 'nextproto_s', 'nextproto_s', 'letohll', 'ntohs', 'float', 'lv', 'float', 'letohl', 'letohll', 'string', 'letohs', 'double', 'letohs', 'ntohl', 'nextproto_b', 'double', 'ntohl', 'ntohll', 'nextproto_s', 'float', 'float', 'ntohs', 'ntohll', 'byte', 'double', 'nextproto_s']), 'overedgeevangelican': (['erythriticsynergidal', 'photocompositioneneuch', 'wutproamusement', 'semiduplexskirt', 'unconvenedperpetually', 'wirrshillingless', 'unbeggarbroncholithiasis', 'recapitalizationdissipative', 'ridgeplatedisturbed', 'hippocampalscrow', 'hetericismswayable', 'venomouslypilferment', 'hammerkopnegativer', 'superestablishmentsuccor', 'sacroposteriorveratryl', 'responsivitykimigayo', 'trichitepersonship', 'epistlarcystoid', 'unsanctioningperiuvular', 'Robenhausianreboil', 'Ibaditehypotenuse', 'skilderprothalline', 'Saxonicalpalet', 'Tullianrubidium', 'nowhitoffscape', 'steinkirkmisaffection', 'premortuarybenchy', 'ExobasidialesEppy', 'paleobotanyworkpeople', 'roofprespur', 'strangulableargentamid', 'spinthariscopemolybdena', 'Mayorunahybridizer', 'leathermakersemishirker', 'stomagringo', 'tenodesisunroaming', 'saltlypropugnator'], ['ntohl', 'float', 'string', 'letohll', 'double', 'ntohll', 'ntohll', 'ntohs', 'letohl', 'string', 'ntohs', 'string', 'ntohll', 'ntohs', 'nextproto_b', 'letohll', 'ntohs', 'float', 'letohl', 'ntohs', 'lv', 'nextproto_b', 'nextproto_b']), 'panegyricalPodsnappery': ([], ['ntohll', 'string', 'letohll', 'byte', 'letohs', 'string', 'double', 'byte']), 'ligniformcoolheadedness': ([], ['byte', 'ntohs', 'string', 'double', 'lv', 'string', 'letohll', 'letohs', 'letohl', 'double', 'float', 'letohs', 'string', 'float', 'ntohll', 'lv']), 'whusslenoreast': ([], ['ntohll', 'string', 'byte', 'letohll', 'float', 'double', 'ntohl', 'float', 'string', 'float', 'double', 'lv', 'double', 'lv', 'ntohll', 'double', 'string', 'ntohs', 'letohl', 'ntohs', 'letohs', 'byte', 'string', 'double', 'letohs', 'ntohl', 'ntohll', 'float', 'ntohs', 'letohl', 'ntohl', 'float', 'float']), 'hyperduliaferrateen': (['symmetricalantimasker', 'untastedgirllike', 'imperializetrispaston', 'Bryumextrafocal', 'recapitalizerelevate', 'isuroidunfitly', 'cacuminalgastrohysterorrhaphy', 'usurperunplannedly', 'unconvenedperpetually', 'unhittabledoublehorned', 'byworkplastid', 'changeablyzoophilitic', 'catmalisoncoevally', 'Fichteanismconjobble', 'lepidodendridcounterplead', 'unbeggarbroncholithiasis', 'Orakzaiunsatisfiedly', 'saltlypropugnator', 'visorlikeNagari', 'asperationoraculousness', 'hetericismswayable', 'pellagrosemongrelization', 'diseasednessthioantimonate', 'superestablishmentsuccor', 'Tullianrubidium', 'unfannedhopperman', 'springlikemonosymmetrically', 'perukiershiplexicographer', 'hyperneuriasymbolatry', 'steelworkpsychophysiological', 'foliicolousskeletonweed', 'mausoleandecasualize', 'xenogenesisprenoble', 'overhollowescort', 'peritrichouslyhepatoflavin', 'counterpotentMetabola', 'superabsurdditremid', 'sheepkeepingfeedman', 'carannaaccension', 'dermobranchiataboyardom', 'idioglossiascabble', 'chytridialgoosemouth', 'Steganophthalmiagnomic', 'bullswooldraggletail', 'tautoousianentente', 'Oliveanpyromancer', 'pneumodynamicsprimariness', 'xenopodidtrencherless', 'syphilologyannularity', 'paleobotanyworkpeople', 'cancelationZoochlorella', 'ochronosusafterbody', 'grapedmassively', 'apioidalNagari', 'retroclusionmetaphysicianism', 'malthouseenteralgia'], ['ntohll', 'nextproto_b', 'double', 'ntohl', 'ntohll', 'lv', 'nextproto_b', 'ntohs', 'letohll', 'double', 'letohl', 'byte', 'letohl', 'double', 'letohs', 'float', 'lv', 'double', 'ntohll', 'byte', 'ntohll', 'float', 'letohs', 'letohs', 'lv', 'nextproto_s', 'nextproto_s', 'nextproto_s', 'ntohl', 'letohll', 'double', 'lv', 'letohl', 'ntohl', 'letohl', 'ntohll', 'letohl', 'lv', 'ntohll', 'ntohl', 'double', 'float', 'ntohl', 'ntohl', 'string', 'letohs', 'letohl', 'letohs', 'letohl', 'string']), 'snakeletwounds': (['unconvenedperpetually', 'subsoilercruent', 'indubitablenoncollaboration', 'terribletaut', 'mattapharyngological', 'changeablyzoophilitic', 'strangulableargentamid', 'Opisthocomidaeheterochiral', 'subsorterbecuffed', 'lindengamy', 'tautologicpanimmunity', 'multicrystallinekeratoglossus', 'reladepropiolaldehyde', 'docimasytrouserdom', 'flashpanstature', 'channelizeungarter', 'photocompositioneneuch', 'simulcastriboflavin', 'catmalisoncoevally', 'extravagantkaryoplasmatic', 'clientageshudderingly', 'isatogenvestibulum', 'etioporphyrinpubovesical', 'unbeggarbroncholithiasis', 'perukiershiplexicographer', 'vaporizetannery', 'awiwimegaloglossia', 'weathercockismcustodier', 'untastedgirllike', 'usurperunplannedly', 'tenesmicHymettic', 'prattlersuffumigate', 'whusslenoreast', 'Oliveanpyromancer', 'katabolizedermic', 'cylindrarthrosisnonplusation', 'pneumodynamicsprimariness', 'micrencephalypalpus', 'misadministrationbroody', 'menialitypreintelligent', 'outfeatvasodilator', 'stickleafethenyl', 'sageshipcarcoon', 'stagemansupa', 'outworthbenevolence', 'tautoousianentente', 'crouchingpurebred', 'cardialgiacontingence', 'Lawsonsemiconversion', 'unusehydroponist', 'addressorcondensedly', 'cacuminalgastrohysterorrhaphy', 'Carpathianmetanephron', 'organosiliconsegmentary', 'tumoredcrocodilite', 'saltlypropugnator', 'Tullianrubidium'], ['letohl', 'nextproto_b', 'letohl', 'nextproto_s', 'string', 'nextproto_b', 'nextproto_s', 'ntohl', 'letohll', 'string', 'letohll', 'nextproto_s', 'string', 'byte', 'nextproto_b', 'double', 'ntohl', 'letohs', 'letohll', 'letohl', 'letohl', 'lv', 'nextproto_s', 'letohl', 'ntohl', 'letohl', 'letohll', 'letohl', 'lv', 'string', 'letohl', 'ntohl', 'ntohs', 'letohll']), 'woodwosesupraterraneous': ([], ['lv', 'ntohll', 'float', 'lv', 'byte', 'ntohl', 'letohs', 'ntohl', 'float', 'ntohs', 'float', 'ntohs', 'ntohll', 'lv', 'byte', 'letohl', 'float', 'ntohs', 'ntohll', 'string']), 'frolickytriphyline': (['crouchingpurebred', 'dermobranchiataboyardom', 'Bryumextrafocal', 'tautoousianentente', 'bullswooldraggletail', 'ineloquentundishonored', 'unlasheddialyzable', 'weathercockismcustodier', 'unbeggarbroncholithiasis', 'evaluecystatrophia', 'etioporphyrinpubovesical', 'Pamirioversystematic', 'outworthbenevolence', 'untastedgirllike', 'countryfolkintolerance', 'xenogenesisprenoble', 'dehydrogenizeCambrian', 'radiopaqueunrecruitable', 'sokarailer', 'semicolumnrankly', 'dermoiddiversifiable', 'opportunisttitlark'], ['ntohll', 'string', 'letohs', 'nextproto_b', 'byte', 'letohs', 'letohl']), 'campulitropoussapogenin': (['sulfureasupertramp', 'tenesmicHymettic', 'sulphhemoglobinHerculanean', 'dermobranchiataboyardom', 'Slovenerecure', 'paralyzerthiocarbimide', 'adminiculatephosphosilicate', 'archsnoblodgepole', 'pavonatedcozily', 'Sonjapylorogastrectomy', 'ricketssubtrihedral', 'goodlyterebenthene', 'distilleryKiwanis', 'lepidodendridcounterplead', 'predestinarianglia', 'herpetologistindeed', 'iconismanisostemonous', 'semicolumnrankly', 'peccationfoolery', 'stickleafethenyl', 'ochronosusafterbody', 'unreprovedlysprier', 'unpopulatecurry', 'Plymouthistnashgab', 'metatitanatetarente', 'Cobitidaedismissal', 'untrainhearkener', 'laterodeviationNarciss', 'diseasednessthioantimonate', 'multicrystallinekeratoglossus', 'zoosporangialbuyable', 'proportionaltasselmaker', 'Toryizesynechthran', 'predefinitionCarnaria', 'dehydrogenizeCambrian', 'bombonnefiendhead', 'cinecameraHydropotes', 'tautologicpanimmunity', 'anomalousparallelinerved', 'carannaaccension', 'northwestwardpassementerie', 'indirecthierarchism', 'unstalledneutralism', 'Momotinaenonfortification', 'nasicornousfasciated', 'unfeasiblecollodiotype', 'organosiliconsegmentary', 'subordinationbrachial', 'pistoleerproexamination', 'weathercockismcustodier', 'sharkletcompactedly', 'esophagoplastyrestrainedness', 'Senecanovercorruptly', 'ornithomanticrada', 'woodrowelshrievalty', 'misputheptarchist', 'mattapharyngological', 'cylindrarthrosisnonplusation', 'pilchermonaulos', 'eudaemonisticallyCoccolobis', 'genipacombiner', 'Piscataqualagoonal', 'cantingnesstideful', 'asperationoraculousness', 'subsoilercruent', 'changeablyzoophilitic', 'appendiceunmetaled', 'parandruspercribration', 'lemologydiplasion', 'tautoousianentente', 'unaccuracyblepharoadenitis'], ['float', 'lv', 'letohl', 'letohl', 'ntohs', 'ntohll', 'double', 'ntohs', 'nextproto_b', 'letohs', 'ntohs', 'byte', 'nextproto_b', 'string', 'letohs', 'string', 'string', 'lv', 'float', 'lv', 'ntohl', 'letohll', 'lv', 'string']), 'retroclusionmetaphysicianism': (['bullswooldraggletail', 'napalmbrevifoliate', 'shuttlecockscanmag', 'cacuminalgastrohysterorrhaphy', 'ineloquentundishonored', 'prattlersuffumigate', 'Orakzaiunsatisfiedly', 'katabolizedermic', 'cancelationZoochlorella', 'isuroidunfitly', 'unhittabledoublehorned', 'asperationoraculousness', 'unfannedhopperman', 'amlipyrexic', 'bawcockPicnickian', 'tautoousianentente', 'chaffererunheaded', 'ornithotomyblackwort', 'predesignateunderservice', 'intrathoraciccoemployment', 'cannotdentigerous', 'udometricpredefault', 'subordinationbrachial', 'counterpotentMetabola', 'ambisyllabicfruitful', 'unmistgraffer', 'Steganophthalmiagnomic', 'Triuridalesplagiarism', 'sacroposteriorveratryl', 'carangoidbotryomycotic', 'Pamirioversystematic', 'hyperneuriasymbolatry', 'loungyimpolite', 'sokarailer', 'Piscataqualagoonal', 'superestablishmentsuccor', 'radiopaqueunrecruitable', 'xenopodidtrencherless', 'wutproamusement', 'dermobranchiataboyardom', 'veldcraftsubprefect', 'piskgriff', 'bairnlyneocosmic', 'spraysemisaprophyte', 'malthouseenteralgia', 'apioidalNagari', 'woodrowelshrievalty', 'cassiteritecasemaking', 'pneumodynamicsprimariness', 'mattapharyngological', 'ochronosusafterbody', 'saltlypropugnator', 'Tullianrubidium', 'Vandiemenianwinery', 'epigenesistbisexed', 'goniometerhexameral', 'dehydrogenizeCambrian', 'menialitypreintelligent', 'hetericismswayable', 'evaluecystatrophia', 'foliicolousskeletonweed', 'outworthbenevolence', 'blepharanthracosisuncliented', 'cesserreichspfennig', 'focoidsstackfreed'], ['byte', 'lv', 'letohs', 'float', 'ntohl', 'string', 'string', 'lv', 'ntohl', 'ntohs', 'ntohs', 'letohs', 'letohl', 'double', 'double', 'ntohll', 'double', 'string', 'nextproto_b', 'ntohll', 'ntohl', 'string', 'lv', 'ntohs', 'nextproto_b', 'nextproto_b', 'ntohl', 'letohs', 'letohll', 'letohs', 'ntohll', 'string']), 'hemianacusiadouble': ([], ['ntohl', 'letohs', 'double', 'float', 'letohll', 'letohll', 'ntohs', 'ntohl', 'letohs']), 'bizonedraconites': ([], ['byte', 'letohll', 'letohs', 'float', 'letohs', 'string', 'ntohl', 'double', 'byte', 'float', 'letohl', 'ntohs', 'float', 'letohs', 'float', 'string', 'letohl', 'string']), 'oxmanoutpull': ([], ['letohl', 'float', 'letohs', 'double', 'ntohl', 'letohl', 'ntohs', 'letohll', 'letohl', 'ntohll', 'ntohl', 'double', 'float', 'float', 'ntohl', 'letohl', 'float', 'letohl', 'ntohl', 'string', 'lv', 'ntohll', 'ntohl', 'letohll', 'ntohll']), 'unmistgraffer': ([], ['ntohl', 'lv', 'ntohll', 'letohll', 'ntohll', 'byte', 'letohs', 'ntohl', 'ntohl', 'letohl', 'double', 'letohl', 'letohs', 'letohs', 'string', 'letohs', 'float', 'letohll', 'letohl', 'ntohl', 'ntohl', 'letohs', 'letohs', 'float', 'ntohll', 'double', 'byte', 'ntohl', 'double', 'ntohll', 'string', 'letohl', 'float', 'ntohl', 'double', 'letohs', 'lv', 'float', 'ntohll', 'byte', 'float', 'letohl', 'lv']), 'silcretemercurous': ([], ['ntohl', 'letohll', 'letohl', 'string', 'ntohl', 'string', 'letohl', 'letohll', 'byte', 'ntohll', 'lv', 'ntohs', 'string', 'byte', 'lv', 'ntohll', 'ntohl', 'float', 'double', 'letohl', 'float', 'ntohll', 'lv', 'letohll', 'ntohs', 'letohll', 'ntohs', 'lv', 'letohl', 'lv', 'float', 'float', 'byte', 'letohs', 'float', 'float']), 'microcrystallogenyfuniculus': ([], ['float', 'letohs', 'ntohll', 'ntohll', 'string', 'byte', 'byte', 'ntohll', 'ntohll', 'string', 'ntohl', 'float', 'ntohl', 'letohll', 'letohs']), 'ketembillaantiferment': ([], ['ntohs']), 'rattlepodMuntiacus': ([], ['float', 'letohl', 'ntohs', 'float', 'ntohll', 'string', 'string', 'ntohs', 'ntohll', 'string', 'letohll', 'byte', 'string', 'double', 'ntohll', 'letohl', 'float', 'ntohs', 'byte', 'ntohll', 'lv', 'letohll', 'double']), 'rhynchophoranunwinking': ([], ['letohs', 'float', 'letohs', 'letohs', 'letohs', 'ntohs', 'byte', 'ntohl']), 'tenodesisunroaming': (['nonadjustmentwritmaking', 'chaffererunheaded', 'diseasednessthioantimonate', 'asperationoraculousness', 'catmalisoncoevally', 'androgynyvegetoalkaline', 'katabolizedermic', 'interventraliaforeutter', 'pneumodynamicsprimariness', 'appendiceunmetaled', 'springlikemonosymmetrically', 'unbeggarbroncholithiasis', 'hyperneuriasymbolatry', 'peccationfoolery', 'hemianacusiadouble'], ['ntohll', 'byte', 'lv', 'ntohl', 'float', 'nextproto_s', 'ntohs', 'letohs', 'double', 'letohll', 'lv', 'letohs', 'nextproto_b', 'nextproto_b', 'letohll', 'nextproto_s', 'ntohll', 'ntohll', 'ntohll', 'letohll', 'letohl', 'byte', 'string', 'ntohl', 'double', 'nextproto_b', 'ntohl', 'ntohl', 'letohl', 'lv', 'letohs', 'byte', 'letohll', 'float', 'double', 'ntohl', 'nextproto_s', 'ntohl', 'letohl', 'ntohl']), 'Ternstroemiaanisostomous': ([], ['byte', 'letohl', 'float', 'ntohll', 'string', 'string', 'ntohl', 'ntohll', 'ntohl', 'ntohll', 'letohll', 'letohs', 'double', 'float', 'ntohll', 'letohl', 'double']), 'correctorSpirochaeta': ([], ['ntohs', 'ntohs', 'letohl', 'lv']), 'hedgesublimish': ([], ['letohl', 'ntohll', 'ntohl', 'letohs', 'string', 'ntohs', 'byte', 'lv', 'ntohs', 'float', 'double', 'letohll', 'letohl', 'ntohl', 'letohl', 'letohs', 'letohl', 'ntohll', 'ntohll', 'ntohs', 'ntohl', 'string', 'lv', 'double', 'double', 'byte']), 'laparotomycephalohumeralis': ([], ['ntohl', 'lv', 'ntohl', 'ntohs', 'ntohs', 'ntohll']), 'previousnessoisin': (['cylindrarthrosisnonplusation', 'Oliveanpyromancer', 'mattapharyngological', 'avalanchestylopization', 'precoxseambiter', 'spinthariscopemolybdena', 'visorlikeNagari', 'awiwimegaloglossia', 'chytridialgoosemouth', 'picayunishapogeotropic', 'iconismanisostemonous', 'radiopaqueunrecruitable', 'scutcheonwiseileocolitis', 'mataiuntameness', 'Vandiemenianwinery', 'epistlarcystoid', 'piskgriff', 'semiduplexskirt', 'fetoracclimatement', 'semicolumnrankly', 'pneumodynamicsprimariness', 'napalmbrevifoliate', 'importationPerisphinctidae', 'grapedmassively', 'herpetologistindeed', 'phototherapistupsetted', 'bairnlyneocosmic', 'roofprespur', 'unhittabledoublehorned', 'pedestrianateStromateidae', 'ineloquentundishonored', 'sokarailer', 'weathercockismcustodier', 'appendiceunmetaled'], ['ntohs', 'float', 'float', 'ntohs', 'byte', 'letohl', 'double', 'byte', 'double', 'ntohl', 'double', 'letohl', 'double', 'string', 'nextproto_s', 'nextproto_s', 'letohll', 'nextproto_s', 'ntohl', 'ntohll', 'nextproto_s', 'double', 'lv', 'ntohs', 'nextproto_s', 'nextproto_s', 'nextproto_b', 'letohl', 'float', 'double', 'letohs', 'ntohs', 'letohll', 'nextproto_s', 'ntohl']), 'overhollowescort': ([], ['letohll', 'lv', 'ntohs', 'letohll', 'letohl', 'double', 'letohl', 'letohl', 'string', 'ntohl', 'ntohl', 'ntohll', 'letohs', 'string', 'float', 'letohl', 'letohs', 'float']), 'geriatricundaubed': ([], ['float', 'double', 'lv', 'lv', 'letohs']), 'shuttlecockscanmag': ([], ['letohll', 'ntohs', 'double', 'byte', 'ntohll', 'float', 'string', 'float', 'double', 'ntohll', 'letohl', 'byte', 'string', 'letohs', 'byte', 'ntohll', 'double', 'float']), 'tonkredarken': (['Negritohydroponicist', 'tartishlynarcotical', 'fillmetroptosis', 'iodolabsolutistic', 'steevingerotic', 'galvanothermometerBalzacian', 'Zantedeschiacladocarpous', 'raspberrylikesubvertebral', 'biserialsmithite', 'gemeledAdonai', 'ophthalmalgiamisproduce', 'summarizationyatter', 'antiphonybackplate', 'subsorterbecuffed', 'ankylophobiaAsperula', 'menialitypreintelligent', 'grapedmassively', 'reproachablepancreatogenic', 'metacentralpaleocrystal', 'Batwaoverpopularity', 'untastedgirllike', 'nontechnicalrongeur', 'Quitugryde', 'autozooidexternization', 'zoosporangialbuyable', 'yawpwoodwax', 'goodlyterebenthene', 'yoreexponent', 'paraderDendrocygna', 'Mayorunahybridizer', 'zeuctocoelomicmetapodial', 'picayunishapogeotropic', 'tuchunateacademization', 'phenomenalisticallyunmomentary', 'larunfermenting', 'chartermarrowy', 'rosiedunarchdeacon', 'oysterhouseamarillo', 'nowhitoffscape', 'overdiligentlyrifleshot', 'tenesmicHymettic', 'utterabilitypavement', 'noniccosmopoietic', 'Erotylidaeprehesitate', 'twinklybingo', 'GemitoresBourignian', 'idioglossiascabble', 'dextrosinistralElaeococca', 'preformisticexemplifiable'], ['float', 'letohs', 'double', 'float', 'float', 'nextproto_b', 'letohll', 'double', 'ntohs', 'letohs', 'double', 'byte', 'letohs', 'float', 'double', 'byte', 'nextproto_s', 'byte', 'double', 'letohll', 'ntohs', 'byte', 'letohll', 'letohl', 'nextproto_s', 'string', 'string', 'nextproto_s', 'letohl', 'float', 'string', 'byte', 'nextproto_s', 'ntohs', 'ntohll', 'letohs', 'ntohs', 'float', 'ntohs', 'byte']), 'allanitictrichitis': ([], ['string', 'float', 'float', 'string', 'ntohll', 'lv', 'double', 'lv', 'letohll', 'lv', 'double', 'string', 'float', 'lv', 'string', 'ntohs', 'letohs', 'float', 'ntohs', 'ntohl', 'byte', 'letohl', 'letohl', 'ntohl', 'ntohl', 'ntohs', 'letohll', 'ntohl', 'ntohs', 'ntohl', 'ntohs', 'letohll']), 'metacentralpaleocrystal': ([], ['letohs', 'letohs', 'ntohll', 'double', 'letohs', 'float', 'lv', 'ntohs', 'letohs', 'lv', 'ntohll', 'byte', 'letohll', 'byte', 'ntohs', 'double', 'double', 'double', 'letohs', 'ntohll', 'ntohl', 'ntohll', 'letohs']), 'declamatorinessSerrifera': ([], ['letohll', 'float', 'letohll', 'letohs', 'letohs', 'double', 'ntohs', 'lv', 'string', 'letohll', 'letohll', 'letohll', 'double', 'float', 'ntohl', 'ntohs', 'ntohs', 'float', 'letohl', 'byte', 'double', 'letohs', 'byte', 'float', 'ntohs']), 'elementalismpietism': ([], ['ntohll', 'float', 'lv', 'ntohl', 'ntohll', 'double', 'letohll', 'ntohll', 'letohll', 'double', 'ntohl', 'ntohll', 'ntohll', 'ntohll', 'ntohl', 'ntohll', 'letohs', 'ntohll', 'float', 'string', 'float', 'string', 'double', 'ntohll']), 'mischieveunfomented': (['opportunisttitlark', 'subordinationbrachial', 'channelizeungarter', 'bairnlyneocosmic', 'metatitanatetarente', 'napalmbrevifoliate', 'keraunophoneinhabited', 'pavonatedcozily', 'hyperduliaferrateen', 'byworkplastid', 'remisrepresentationlancet', 'roofprespur', 'shuttlecockscanmag', 'docimasytrouserdom', 'slichtarradiddler', 'provectgastrocolostomy', 'subcostalbaldmoney', 'northwestwardpassementerie', 'poonghiehectic', 'misspellquinaldic', 'sageshipcarcoon', 'interimperialvignetter', 'subsorterbecuffed', 'vaporizetannery', 'photocompositioneneuch', 'imperializetrispaston', 'pneumodynamicsprimariness', 'hookahsupersimplicity', 'androgynyvegetoalkaline', 'Fichteanismconjobble', 'collationdissuasively', 'ureterorrhagiahemogenetic', 'Slovenerecure', 'agoraphobiaLenzites', 'superestablishmentsuccor', 'pellagrosemongrelization', 'susurrateoutvie', 'semicolumnrankly', 'kleenebocJungermannia', 'Lawsonsemiconversion', 'isuroidunfitly', 'cassiteritecasemaking', 'overhollowescort', 'unenterprisedargumentatious', 'cancelationZoochlorella', 'archsnoblodgepole', 'saltlypropugnator', 'Oliveanpyromancer', 'spinthariscopiclieutenancy', 'rosiedunarchdeacon', 'undercovertcoloss', 'lemologydiplasion', 'phototherapistupsetted', 'renverseundethroned', 'querulouslycooky', 'woodrowelshrievalty', 'hippocampalscrow', 'turbidlycorticoefferent', 'Cobitidaedismissal', 'yoreexponent', 'indubitablenoncollaboration', 'symptosissubcorneous', 'unusehydroponist', 'unreprovedlysprier', 'peccationfoolery', 'catafalquedree', 'hyperneuriasymbolatry', 'outfeatvasodilator'], ['byte', 'letohs', 'string', 'double', 'string', 'letohs', 'nextproto_b', 'float', 'lv', 'lv', 'letohl', 'ntohs']), 'poonghiehectic': ([], ['ntohll', 'lv', 'letohll', 'ntohs']), 'Polemoniumoutburn': ([], ['byte', 'double', 'ntohl', 'ntohll', 'double', 'double', 'float', 'double', 'letohs', 'letohs', 'letohll', 'lv', 'string', 'ntohl', 'byte', 'letohl', 'letohl', 'letohl', 'string', 'float', 'ntohl', 'string', 'ntohs', 'double', 'byte', 'letohll', 'lv', 'ntohl', 'string', 'ntohll', 'letohl', 'letohs', 'float', 'byte', 'letohs', 'letohs', 'ntohl', 'double', 'letohl']), 'mataiuntameness': ([], ['lv', 'letohs', 'double', 'letohll', 'letohs', 'ntohl', 'ntohll', 'double', 'letohs', 'lv', 'float', 'string', 'letohl', 'byte', 'letohll', 'ntohl', 'lv', 'letohll', 'letohll', 'float', 'double', 'lv', 'ntohs', 'letohll', 'ntohll', 'letohl', 'letohll', 'letohs', 'string', 'ntohs', 'lv', 'letohll', 'ntohs', 'double']), 'stomagringo': ([], ['ntohll', 'letohll', 'ntohll', 'letohl', 'letohs', 'ntohs', 'letohl', 'ntohll', 'letohs', 'string', 'double', 'string', 'float', 'ntohl', 'ntohl', 'ntohs', 'letohs', 'lv']), 'nonhumanistunsoaked': ([], ['ntohl', 'byte', 'letohll', 'ntohll', 'byte', 'byte', 'ntohs', 'ntohs', 'ntohs', 'double', 'letohs', 'letohl', 'float', 'ntohl', 'string', 'double', 'double', 'byte', 'letohl', 'ntohll', 'letohs', 'byte', 'letohl', 'byte', 'letohs', 'string', 'byte', 'letohll', 'string', 'ntohl', 'ntohll', 'double', 'ntohll', 'ntohll', 'ntohs', 'ntohll', 'letohl', 'letohs', 'lv', 'byte', 'double']), 'inwrapmentcarcinogenesis': (['microcrystallogenyfuniculus', 'percontationMaimonist', 'snackmisinstruction', 'catmalisoncoevally', 'awiwimegaloglossia', 'pedestrianateStromateidae', 'impracticalnessNemichthyidae', 'springlikemonosymmetrically', 'scutcheonwiseileocolitis', 'schuleclethraceous', 'Zantedeschiacladocarpous', 'unaccoutereddrivebolt', 'malthouseenteralgia', 'hypernutritionmarae', 'sulphostannideuntimeliness', 'solemnlystre', 'nugacioushypotensive', 'pinkberrynonvillainous', 'hallowerhydrophthalmos', 'Fichteanismconjobble', 'epigenesistbisexed', 'flamprelate', 'whealwormrice', 'spattertriphenylated', 'hippocampalscrow', 'peragratemultifoliate', 'veldcraftsubprefect', 'kempstergarefowl', 'inferiorismobstetrix', 'dowsettroughway', 'practicelegitimatist', 'cassiteritecasemaking', 'baptizeeFrenchize', 'Heterodactylaefrisk', 'pseudodemocraticproconscription', 'simpletonianreformulate', 'fitfulunshrill', 'bombonnefiendhead', 'Larinaecoydog', 'haabdimeric', 'buttonholerindigestive', 'ketembillaantiferment', 'remirrorundepreciated', 'laterodeviationNarciss', 'depositoryteloblastic', 'cytochromemonosepalous', 'Eurypteroideachamaeprosopic', 'nonofficeholdingwaldgravine', 'premortuarybenchy', 'imperializetrispaston', 'intrathoraciccoemployment', 'loungyimpolite', 'epistlarcystoid', 'coeternaloverhonor', 'stakeholderunforbade', 'funestworser', 'hyperexaltationBrachyphyllum', 'urogastricjesting', 'Dokoelectrochemically', 'Limodorumscrotal', 'fetoracclimatement', 'coxbonesbirle', 'etherifyCicadidae', 'overseateddiscouragingly', 'quakinglyilliterate', 'hyperduliaferrateen', 'organosiliconsegmentary', 'cannotdentigerous', 'abjudicationunpleading', 'maltingsurrection', 'alkargenmoop', 'saffianpackcloth', 'indirecthierarchism', 'counterdraftdamewort', 'matelessbeatitude', 'gratefulAlcedinidae', 'unadversenessmaro', 'outfeatvasodilator', 'agoraphobiaLenzites', 'monodromiclyretail', 'allottrichopterous'], ['ntohl', 'nextproto_s', 'lv', 'ntohl', 'lv', 'ntohl', 'ntohs', 'letohs', 'float', 'lv', 'letohll', 'double', 'byte', 'letohl', 'lv', 'lv', 'nextproto_s']), 'sulphuratorjonquil': (['renverseundethroned', 'falsificationcomer', 'unexchangedsupraventricular', 'piskgriff', 'cognaticalintransmissible', 'roofprespur', 'zeuctocoelomicmetapodial', 'laterodeviationNarciss', 'tautoousianentente', 'emblazonarsenopyrite', 'hematozoalinfinitarily', 'sulphuratorjonquil', 'lindengamy', 'refallGanguela', 'dracontiasisinterparliamentary', 'docimasytrouserdom', 'butyrochloralfertilizational', 'blepharanthracosisuncliented', 'loketprincipiate', 'ettleoptimize', 'engrossedlyDinoceras', 'TaboriteSanche', 'hyperduliaferrateen', 'xiphosternamedia', 'redifferentiationmustachio', 'burgonetcarefully', 'trinodineacetaldehyde', 'photocompositioneneuch', 'knuckleboneunnegotiableness', 'sharkletcompactedly', 'clientageshudderingly', 'loungyimpolite', 'buttTarahumara', 'Carpathianmetanephron', 'visorlikeNagari', 'querulouslycooky', 'dihedronsubcircuit', 'motacillinewidespreadly', 'monogamianportio', 'unmistgraffer', 'notchycoralliferous', 'domanialPhora', 'violationguggle', 'ornithomanticrada', 'logarithmeticallydeliriant', 'surlyreptilferous', 'Bombycillahonoraria', 'ambisyllabicfruitful', 'grammaticismmignonette', 'nondistributionclitellus', 'Lespedezafuthorc', 'usurperunplannedly', 'previousnessoisin', 'physiognomicallybrasse', 'goodlyterebenthene', 'munjmuchness', 'reburstsummity', 'oxmanoutpull', 'unfootsorepoonac', 'cycloolefinmonostylous', 'ineloquentundishonored', 'dyewoodsocii', 'Abrahamicinordinateness', 'unsanctioningperiuvular', 'Senecanovercorruptly', 'shortcakeabase', 'dissogenyBarney', 'orographicniddick', 'untastedgirllike', 'Larinaecoydog', 'prattlersuffumigate', 'Momotinaenonfortification', 'catagmaticMegalosaurus', 'unmooredtowy', 'ankylenterongreenfish', 'bemuzzlesurficial', 'adiaphorousfalsifiable', 'preservatizeskyphoi', 'fleaweedprobate'], ['letohs']), 'hallowerhydrophthalmos': (['chromophilouspyometra', 'reshoedrachmae', 'integralizationbremeness', 'nonadjustmentwritmaking', 'allerChilostoma', 'dihedronsubcircuit', 'tongueshoticonophilism', 'cancelationZoochlorella', 'bustedpredoubter', 'untrainhearkener', 'frontomallarforedetermine', 'intercoolingpotentialization', 'northwestwardpassementerie', 'asteamincandescency', 'hematozoalinfinitarily', 'lemologydiplasion', 'parandruspercribration', 'mammillationpemphigous', 'refilmopenhandedness', 'bacteriformpiercel', 'ureterorrhagiahemogenetic', 'epistlarcystoid', 'depositoryteloblastic', 'racegoingunperformed', 'monogamianportio', 'matelessbeatitude', 'terribletaut', 'hypoplasyhooping', 'Oliveanpyromancer', 'engrossedlyDinoceras', 'cinecameraHydropotes', 'certainarchpontiff', 'anomalousparallelinerved', 'Abrahamicinordinateness', 'hammerkopnegativer', 'leucoencephalitisconsistent', 'Tullianrubidium', 'seminegroSemiticize', 'onomatopoeiaeggfish', 'subregenthelmeted', 'bronchiaunbaffling', 'springlikemonosymmetrically', 'GemitoresBourignian', 'Alalamenispermine', 'wirrshillingless', 'benzalethylaminedesulphurate', 'Mayorunahybridizer', 'dissogenyBarney', 'Sarothrawrencher', 'shortcakeabase', 'recapitalizationdissipative', 'reburstsummity', 'misproduceunthrilled', 'dyewoodsocii', 'trinodineacetaldehyde', 'cantingnesstideful', 'ornithomanticrada', 'iconismanisostemonous', 'epexegeticallyreadjournment', 'improvisatorizenoneditorial', 'prankinglypneumotherapy', 'asperationoraculousness'], ['ntohll', 'lv', 'ntohl', 'lv', 'letohs', 'ntohs', 'string', 'byte', 'nextproto_s', 'byte', 'letohl', 'byte', 'ntohs', 'ntohs', 'nextproto_s', 'ntohll', 'letohll', 'double', 'double', 'lv', 'lv', 'lv']), 'semicolumnrankly': ([], ['letohll', 'lv', 'ntohs', 'ntohll', 'double', 'letohs', 'float']), 'subordinationbrachial': (['dehydrogenizeCambrian', 'collationdissuasively', 'countryfolkintolerance', 'subordinationbrachial', 'cardialgiacontingence', 'Orakzaiunsatisfiedly', 'outworthbenevolence', 'hyperneuriasymbolatry', 'ornithotomyblackwort', 'steelworkpsychophysiological', 'veldcraftsubprefect', 'sacroposteriorveratryl', 'bawcockPicnickian', 'sokarailer', 'evaluecystatrophia', 'xenopodidtrencherless', 'unbeggarbroncholithiasis', 'blepharanthracosisuncliented', 'tautoousianentente', 'asperationoraculousness', 'katabolizedermic', 'pneumodynamicsprimariness', 'unmistgraffer', 'loungyimpolite', 'saltlypropugnator', 'intrathoraciccoemployment', 'coeternaloverhonor', 'symmetricalantimasker'], ['ntohll', 'float', 'letohl', 'byte', 'ntohl', 'letohl', 'float', 'letohs', 'string', 'nextproto_b', 'letohl', 'letohl', 'ntohs', 'lv', 'ntohll', 'ntohl', 'ntohs', 'string', 'letohs', 'nextproto_b', 'lv', 'letohll', 'byte', 'ntohl', 'ntohl', 'nextproto_s', 'letohl', 'byte', 'letohll', 'ntohs', 'nextproto_b', 'byte']), 'unexchangedsupraventricular': (['iconismanisostemonous', 'appendiceunmetaled', 'grapedmassively', 'pneumodynamicsprimariness', 'napalmbrevifoliate', 'indirecthierarchism', 'pilchermonaulos', 'mataiuntameness', 'peccationfoolery', 'etioporphyrinpubovesical', 'syphilologyannularity', 'hammerkopnegativer', 'usurperunplannedly', 'peritrichouslyhepatoflavin', 'querulouslycooky', 'Mayorunahybridizer', 'sokarailer', 'spraysemisaprophyte', 'sageshipcarcoon', 'yoreexponent', 'malthouseenteralgia', 'zoosporangialbuyable', 'predisciplinetukra', 'hetericismswayable', 'uncatholicizeSiphonognathus', 'bumblefooticonology', 'tongueshoticonophilism', 'doubleheartedstaphylolysin', 'asepticallyBernese', 'picayunishapogeotropic', 'maltingsurrection', 'dehydrogenizeCambrian', 'asperationoraculousness', 'importationPerisphinctidae', 'foliicolousskeletonweed', 'udometricpredefault', 'laparotomycephalohumeralis', 'carangoidbotryomycotic', 'tautoousianentente', 'unexchangedsupraventricular', 'unhittabledoublehorned', 'tollgateandrophagous', 'radiopaqueunrecruitable', 'carannaaccension', 'dissogenyBarney', 'delthyrialGee', 'sheepkeepingfeedman', 'unmistgraffer', 'steelworkpsychophysiological', 'distilleryKiwanis', 'shortcakeabase', 'tenesmicHymettic', 'changeablyzoophilitic', 'reladepropiolaldehyde', 'bustedpredoubter', 'prattlersuffumigate', 'bullswooldraggletail', 'frolickytriphyline', 'Lespedezafuthorc', 'unusehydroponist', 'overgenialitybuzzle', 'cylindrarthrosisnonplusation', 'organosiliconsegmentary', 'unoverhauledGalinsoga'], ['nextproto_s', 'float', 'nextproto_s', 'nextproto_b', 'nextproto_s', 'double', 'ntohll', 'nextproto_b', 'lv', 'letohll', 'ntohl', 'float', 'double', 'byte', 'float', 'letohll', 'lv', 'string', 'byte', 'letohll', 'nextproto_s', 'nextproto_b', 'nextproto_s', 'letohl', 'float', 'float', 'ntohs', 'lv', 'nextproto_s', 'byte', 'byte', 'letohs', 'double', 'nextproto_b', 'letohl', 'letohll', 'string']), 'unspendablevanilla': ([], ['letohl', 'ntohs', 'lv', 'string', 'double', 'float', 'ntohs', 'letohs', 'ntohll', 'string', 'letohll', 'double', 'ntohll', 'ntohl', 'lv', 'ntohs', 'letohs', 'lv', 'ntohll', 'ntohll', 'ntohl', 'letohl', 'ntohll', 'ntohll', 'ntohl', 'lv', 'letohll', 'double', 'letohll', 'double', 'double', 'string', 'letohl', 'string', 'ntohl', 'ntohll', 'lv']), 'parandruspercribration': (['tenesmicHymettic', 'weathercockismcustodier', 'subregenthelmeted', 'polyspermatouscreationistic', 'bemuzzlesurficial', 'coeternaloverhonor', 'sokarailer', 'whusslenoreast', 'seminegroSemiticize', 'fetoracclimatement', 'peritrichouslyhepatoflavin', 'sheepkeepingfeedman', 'blepharanthracosisuncliented', 'arhatsporozoic', 'fleaweedprobate', 'vibrativeoversail', 'cylindrarthrosisnonplusation', 'barrelmakingparoemia', 'ambisyllabicfruitful', 'cystocarppapaprelatical', 'carannaaccension', 'predefinitionCarnaria', 'catmalisoncoevally', 'noggencapitulate', 'cardialgiacontingence', 'reburstsummity', 'appendiceunmetaled', 'chaffererunheaded', 'wutproamusement', 'awiwimegaloglossia', 'ineloquentundishonored', 'cannotdentigerous', 'epigenesistbisexed', 'bairnlyneocosmic', 'bumblefooticonology', 'cesserreichspfennig', 'stakeholderunforbade', 'unconvenedperpetually', 'parandruspercribration', 'unlasheddialyzable', 'racegoingunperformed', 'avalanchestylopization', 'gatewiseunderpot', 'susurrateoutvie', 'prelanguagecloudage', 'cerebroidodontolcate', 'hookahsupersimplicity', 'summarizationyatter', 'hammerkopnegativer', 'extravagantkaryoplasmatic', 'subcineritiousphrenitic'], []), 'falsificationcomer': ([], ['lv', 'lv', 'letohll', 'lv', 'ntohs', 'ntohll', 'ntohll', 'double', 'lv', 'letohl', 'letohs', 'float', 'double', 'ntohs', 'letohll', 'letohs', 'ntohs', 'ntohll', 'letohs', 'ntohll', 'ntohl', 'ntohs', 'ntohll', 'float', 'letohll', 'string', 'ntohll', 'lv', 'float', 'double', 'byte', 'byte', 'string', 'byte', 'letohs', 'letohl', 'double', 'letohs']), 'Rodolphhumuslike': ([], ['ntohs', 'float', 'double', 'letohl', 'ntohll', 'double', 'ntohl', 'letohs', 'ntohs', 'byte', 'lv', 'letohll', 'letohl', 'string', 'ntohl', 'ntohs', 'letohs', 'float', 'letohl', 'float', 'string', 'float', 'ntohll', 'ntohll', 'double', 'float', 'double', 'byte', 'letohs', 'byte', 'letohs', 'byte', 'lv', 'ntohs']), 'gardenedfugacious': ([], ['double', 'string', 'ntohl', 'letohs', 'ntohl', 'string', 'double', 'letohl', 'lv', 'byte', 'letohl', 'letohl', 'double', 'ntohl', 'ntohll', 'letohl', 'letohl', 'float', 'byte', 'lv', 'ntohl', 'float', 'string', 'ntohl', 'ntohl', 'letohll', 'float']), 'spinthariscopiclieutenancy': ([], ['byte', 'double', 'letohll', 'ntohl', 'ntohs', 'double', 'byte', 'lv', 'float', 'lv', 'string', 'string', 'ntohl', 'letohll', 'letohll', 'letohs', 'float', 'ntohl', 'string', 'letohll', 'float', 'double', 'letohs', 'double', 'string', 'byte', 'double', 'double', 'letohs', 'double', 'float']), 'autonomicpuerperalism': ([], ['byte', 'letohl', 'letohll', 'double', 'lv', 'double', 'string', 'ntohll', 'byte', 'lv', 'byte', 'float', 'byte', 'letohll', 'byte', 'letohl', 'float', 'letohll', 'ntohl', 'ntohl', 'letohs', 'ntohll', 'letohl', 'ntohl', 'letohll', 'letohll', 'ntohl', 'letohs', 'double', 'ntohs', 'lv', 'string']), 'Ibaditehypotenuse': ([], ['lv', 'ntohs', 'byte', 'string', 'double', 'float', 'ntohll', 'ntohl', 'double', 'letohs', 'ntohl', 'float', 'double', 'string', 'letohll', 'string', 'letohl', 'string', 'ntohl', 'lv', 'ntohs', 'string', 'letohs', 'letohl', 'double', 'double']), 'nasicornousfasciated': ([], ['float', 'lv', 'ntohll', 'string', 'float', 'letohll', 'float', 'byte', 'float', 'letohs', 'letohl', 'letohs', 'double', 'double', 'ntohl', 'ntohs', 'ntohll', 'letohs']), 'vivacityOlneya': ([], ['letohs', 'lv', 'ntohll', 'ntohs', 'ntohs', 'letohs', 'letohl', 'byte', 'string', 'double', 'double', 'ntohll', 'letohll', 'letohs', 'ntohl', 'string', 'byte', 'string', 'ntohl', 'string', 'string', 'letohs', 'letohll', 'lv', 'letohl', 'letohll', 'string', 'letohl', 'string', 'letohll', 'ntohll', 'ntohs', 'letohll', 'letohl', 'string', 'double', 'letohl', 'lv', 'lv', 'ntohll']), 'usurperunplannedly': (['sheepkeepingfeedman', 'tellurethurryproof', 'unhittabledoublehorned', 'subregenthelmeted', 'prattlersuffumigate', 'susurrateoutvie', 'peccationfoolery', 'stakeholderunforbade', 'saltlypropugnator', 'shuttlecockscanmag', 'surlyreptilferous', 'Tullianrubidium', 'sacroposteriorveratryl', 'dermobranchiataboyardom', 'cesserreichspfennig', 'retroclusionmetaphysicianism', 'goniometerhexameral', 'Bryumextrafocal', 'focoidsstackfreed', 'ineloquentundishonored', 'cystocarppapaprelatical', 'foliicolousskeletonweed', 'cardialgiacontingence', 'menialitypreintelligent', 'hyperneuriasymbolatry', 'strangulableargentamid', 'superestablishmentsuccor', 'isuroidunfitly', 'tautoousianentente', 'mattapharyngological', 'vaporizetannery', 'hetericismswayable', 'counterpotentMetabola', 'Piscataqualagoonal', 'blepharanthracosisuncliented', 'symmetricalantimasker', 'radiopaqueunrecruitable', 'outworthbenevolence', 'dermoiddiversifiable', 'perukiershiplexicographer', 'dehydrogenizeCambrian', 'Steganophthalmiagnomic', 'asepticallyBernese', 'crouchingpurebred', 'unbeggarbroncholithiasis', 'Pamirioversystematic', 'barrelmakingparoemia', 'anomalousparallelinerved', 'tenesmicHymettic', 'loungyimpolite', 'unconvenedperpetually', 'bumblefooticonology', 'unfannedhopperman', 'sokarailer', 'cacuminalgastrohysterorrhaphy'], ['ntohll', 'ntohs', 'float', 'letohl', 'lv', 'nextproto_s', 'lv', 'lv', 'nextproto_s', 'letohs', 'ntohs', 'float', 'nextproto_s', 'nextproto_s']), 'oversoldafield': ([], ['ntohl', 'float', 'ntohll', 'ntohl', 'ntohl', 'lv', 'float', 'lv', 'letohs', 'lv', 'float', 'ntohll', 'letohll', 'letohll']), 'unpaintterebinic': ([], ['letohs', 'float', 'ntohs']), 'Nathanielbiliteral': (['subsoilercruent', 'ornithotomyblackwort', 'peritrichouslyhepatoflavin', 'picayunishapogeotropic', 'mataiuntameness', 'lindengamy', 'sulfureasupertramp', 'Sarothrawrencher', 'craunchprovitamin', 'Carpathianmetanephron', 'asperationoraculousness', 'buttTarahumara', 'schuleclethraceous', 'surlyreptilferous', 'cerebroidodontolcate', 'rosiedunarchdeacon', 'lobectomypreinflection', 'blepharanthracosisuncliented', 'tenodesisunroaming', 'coeternaloverhonor', 'terrazzododder', 'snakeletwounds', 'stomagringo', 'pneumodynamicsprimariness', 'volubilityThuidium', 'spadelikemassacrer', 'emergencechouette', 'Grahamsaloon', 'springlikemonosymmetrically', 'fetoracclimatement', 'acquisitumvaletudinarist', 'Robenhausianreboil', 'Cobitidaedismissal', 'ExobasidialesEppy', 'pavonatedcozily', 'Ternstroemiaanisostomous', 'cylindrarthrosisnonplusation', 'cystocarppapaprelatical', 'misputheptarchist', 'cantingnesstideful', 'byworkplastid', 'diseasednessthioantimonate', 'channelizeungarter', 'poonghiehectic', 'cycloolefinmonostylous', 'Lespedezafuthorc', 'superestablishmentsuccor', 'subrigidlithophysal', 'cosilybridecake', 'parathyroidectomizeoutheart', 'uncatholicizeSiphonognathus', 'reburstsummity', 'warfaringdraghound', 'paleobotanyworkpeople', 'warneriodocasein'], ['ntohl', 'ntohl', 'float', 'letohl', 'letohll', 'string', 'byte', 'letohs', 'lv', 'byte', 'letohll', 'byte']), 'susurrateoutvie': ([], ['string', 'ntohl', 'letohl', 'byte', 'float', 'letohl', 'float', 'byte', 'float', 'ntohl', 'letohll', 'byte', 'letohs']), 'chytridialgoosemouth': (['semiduplexskirt', 'Vandiemenianwinery', 'barrelmakingparoemia', 'unbeggarbroncholithiasis', 'chytridialgoosemouth', 'isuroidunfitly', 'bumblefooticonology', 'dermobranchiataboyardom', 'susurrateoutvie', 'carangoidbotryomycotic', 'Triuridalesplagiarism', 'unfannedhopperman', 'katabolizedermic', 'woodrowelshrievalty', 'utterabilitypavement', 'Orakzaiunsatisfiedly', 'ambisyllabicfruitful', 'foliicolousskeletonweed', 'weathercockismcustodier', 'udometricpredefault', 'spinthariscopemolybdena', 'strangulableargentamid', 'shuttlecockscanmag', 'ineloquentundishonored', 'cannotdentigerous', 'superabsurdditremid', 'intrathoraciccoemployment', 'veldcraftsubprefect', 'tellurethurryproof'], ['byte', 'byte', 'ntohs', 'double', 'float', 'nextproto_s', 'letohs', 'letohs', 'lv', 'ntohll', 'string', 'string', 'byte', 'lv', 'lv', 'double', 'ntohll', 'nextproto_b', 'double', 'ntohll', 'float', 'string', 'letohs', 'ntohll', 'byte', 'nextproto_s', 'letohll', 'ntohll', 'byte', 'ntohl', 'ntohll', 'float', 'lv', 'byte', 'nextproto_b', 'byte', 'float', 'lv', 'nextproto_b', 'letohl', 'float', 'nextproto_s', 'float', 'ntohl', 'letohs', 'byte']), 'insidiouslysurplicewise': ([], ['double', 'ntohll', 'float', 'letohl', 'lv', 'double']), 'billbackdisease': ([], ['string', 'float', 'ntohll', 'letohs', 'ntohs', 'letohll', 'letohs', 'string', 'double', 'letohs', 'letohll', 'ntohl', 'float', 'double', 'float', 'letohll', 'string']), 'Bombycillahonoraria': ([], ['ntohs', 'letohs', 'letohs', 'string', 'string', 'lv', 'float', 'letohl', 'string', 'ntohll', 'letohs']), 'barrelmakingparoemia': ([], ['letohs', 'letohs', 'ntohl', 'ntohl', 'string', 'float', 'ntohs', 'lv', 'string', 'float', 'byte', 'string', 'byte', 'ntohs', 'letohl', 'letohl', 'lv', 'float', 'letohs', 'string', 'double', 'float', 'letohs', 'byte', 'float', 'ntohs', 'letohll', 'ntohs']), 'baptizeeFrenchize': ([], ['letohl', 'letohs', 'double', 'byte', 'ntohl', 'double', 'ntohs', 'lv']), 'dinitrilholocentrid': (['certainarchpontiff', 'peerlesslyforetalk', 'Sarothrawrencher', 'hetericismswayable', 'ochronosusafterbody', 'Mayorunahybridizer', 'predisciplinetukra', 'raspberrylikesubvertebral', 'codeinesalience', 'previousnessoisin', 'syphilologyannularity', 'slichtarradiddler', 'kansrush', 'warfaringdraghound', 'metatitanatetarente', 'foreuseuninfluencing', 'misadministrationbroody', 'unmistgraffer', 'overganggenesial', 'reladepropiolaldehyde', 'turbidlycorticoefferent', 'unpaintterebinic', 'sacroposteriorveratryl', 'susurrateoutvie', 'echinostomewont', 'fetoracclimatement', 'semicolumnrankly', 'shortcakeabase', 'strainedlypsychopompos', 'spadelikemassacrer', 'engrossedlyDinoceras', 'Brandipriestcraft', 'semiduplexskirt', 'unconvenedperpetually', 'Bryumextrafocal', 'unbeggarbroncholithiasis', 'Abrahamicinordinateness', 'surfactantchurchgrith', 'variationaladjutory', 'pedestrianateStromateidae', 'wingerconsoler'], ['byte', 'float', 'byte', 'byte', 'lv', 'string']), 'lindengamy': (['udometricpredefault', 'saltlypropugnator', 'ineloquentundishonored', 'unmistgraffer', 'bullswooldraggletail', 'crouchingpurebred', 'mausoleandecasualize', 'pistoleerproexamination', 'xerophagyhematography', 'mattapharyngological', 'pneumodynamicsprimariness', 'zoosporangialbuyable', 'misproduceunthrilled'], ['ntohs', 'nextproto_s', 'ntohll', 'letohl', 'lv', 'lv', 'string', 'float', 'letohll', 'ntohs', 'double', 'letohll', 'nextproto_s', 'nextproto_b']), 'holdsmanoversalty': ([], ['ntohs', 'letohl', 'string', 'letohll', 'double', 'letohs', 'float', 'letohs', 'ntohll', 'ntohl', 'byte', 'ntohl', 'letohs', 'ntohs', 'letohs', 'letohll', 'ntohll', 'float', 'double', 'letohl', 'string', 'lv', 'lv', 'double', 'double', 'letohl', 'letohll', 'letohl', 'byte', 'letohs', 'ntohll', 'string', 'letohl', 'letohs', 'ntohs', 'letohll', 'byte']), 'agonizefloating': ([], ['double', 'letohl', 'letohs', 'string', 'letohs', 'byte', 'byte', 'letohll', 'string', 'ntohll', 'byte', 'letohs', 'letohll', 'ntohl', 'ntohs', 'ntohs', 'double', 'lv', 'ntohl', 'string', 'letohl', 'ntohll', 'letohl', 'byte', 'ntohs', 'ntohll', 'ntohl', 'letohl', 'string', 'ntohll', 'byte', 'lv', 'ntohll', 'byte', 'string', 'ntohs', 'ntohll', 'ntohl', 'ntohl', 'letohs', 'byte', 'byte', 'ntohll']), 'tumultuouslymammonitish': ([], ['double', 'letohll', 'float', 'lv', 'string', 'byte', 'ntohl', 'byte', 'byte', 'lv', 'lv', 'letohs', 'float', 'double', 'string', 'byte', 'ntohll', 'double', 'ntohl', 'letohl', 'letohll', 'double', 'byte', 'double', 'double', 'float', 'float', 'letohll', 'ntohs', 'letohll', 'ntohl', 'ntohs', 'ntohs', 'string', 'byte', 'letohll', 'ntohl']), 'cylindrarthrosisnonplusation': ([], ['ntohll', 'letohl', 'float', 'ntohl', 'float', 'letohll', 'letohl', 'ntohl']), 'grammaticismmignonette': (['agoraphobiaLenzites', 'ivoryliketransessentiate', 'esophagoplastyrestrainedness', 'evaluecystatrophia', 'Vandiemenianwinery', 'oversoldafield', 'unscalednessChamaeleon', 'interimperialvignetter', 'poonghiehectic', 'faddyamputational', 'zoosporangialbuyable', 'summarizationyatter', 'overseateddiscouragingly', 'piperitiousreekingly', 'ornithomanticrada', 'radiopaqueunrecruitable', 'buttTarahumara', 'Slovenerecure', 'delthyrialGee', 'butterrootchagrin', 'cassiteritecasemaking', 'slichtarradiddler', 'benzalethylaminedesulphurate', 'channelizeungarter', 'intercoolingpotentialization', 'pavonatedcozily', 'raspberrylikesubvertebral'], ['nextproto_b', 'lv', 'letohll', 'letohl', 'nextproto_s', 'ntohs', 'double', 'lv', 'lv']), 'tollgateandrophagous': ([], ['ntohl', 'letohs', 'ntohs', 'letohs', 'letohs', 'letohs', 'letohl', 'byte', 'lv', 'ntohll', 'lv', 'double', 'letohl', 'byte']), 'bronchiaunbaffling': ([], ['float', 'byte', 'letohll', 'ntohl']), 'Sarothrawrencher': ([], ['double', 'double', 'letohs', 'letohll', 'ntohl', 'double', 'lv', 'ntohs', 'lv', 'byte', 'ntohs', 'letohs', 'lv', 'lv', 'ntohll', 'float', 'double', 'float', 'ntohll', 'ntohl']), 'metatitanatetarente': ([], ['float', 'ntohl', 'string', 'ntohs', 'lv', 'double', 'letohll', 'letohs', 'ntohl', 'byte', 'ntohll', 'ntohl', 'float', 'double', 'lv', 'double', 'lv', 'letohll', 'string', 'float', 'letohs', 'ntohl', 'byte', 'double', 'letohll', 'float', 'string', 'ntohl', 'letohll', 'letohll', 'letohll', 'byte']), 'sokarailer': ([], ['ntohs', 'ntohl', 'ntohs', 'lv', 'byte', 'ntohs', 'letohl', 'lv', 'string', 'letohll', 'byte', 'ntohl', 'letohs', 'ntohs', 'ntohll', 'letohll', 'ntohs', 'float', 'lv', 'ntohll', 'letohl', 'ntohs', 'float', 'letohs', 'lv', 'ntohll', 'letohll']), 'untabernacledmedicamental': ([], ['string', 'letohs', 'lv', 'ntohl', 'ntohll', 'float', 'letohl', 'float', 'letohll', 'byte', 'lv', 'lv', 'string', 'letohll', 'float', 'letohl', 'byte', 'float', 'ntohl', 'string', 'letohll', 'float', 'ntohs', 'double', 'float', 'byte', 'letohs', 'byte', 'double', 'letohs', 'ntohll', 'letohll', 'lv', 'ntohs', 'lv', 'byte', 'ntohl', 'letohs']), 'gynarchicagedly': (['codeinesalience', 'Ternstroemiaanisostomous', 'tongueshoticonophilism', 'applanationnitrifaction', 'sulphhemoglobinHerculanean', 'foliicolousskeletonweed', 'arhatsporozoic', 'hypoplasyhooping', 'TaboriteSanche', 'cinecameraHydropotes', 'focoidsstackfreed', 'Toryizesynechthran', 'cystocarppapaprelatical', 'emergencechouette', 'prizeexcrescence', 'asepticallyBernese', 'vibrativeoversail', 'xerophagyhematography', 'undercovertcoloss', 'picayunishapogeotropic', 'Carpathianmetanephron', 'evaluecystatrophia', 'catmalisoncoevally', 'lindengamy', 'bemuzzlesurficial', 'terrazzododder', 'oversoldafield', 'clientageshudderingly', 'cardinghygeistic', 'seminegroSemiticize', 'ettleoptimize', 'coeternaloverhonor', 'Opisthocomidaeheterochiral', 'untrainhearkener', 'repolymerizationwesselton', 'Plymouthistnashgab', 'splanchnopleureprelapsarian', 'sokarailer', 'dejectedincreasing', 'delthyrialGee', 'napalmbrevifoliate', 'bumblefooticonology', 'cantingnesstideful', 'Philonismpinivorous', 'barrelmakingparoemia', 'cannotdentigerous', 'multicrystallinekeratoglossus', 'subrelationsepiolite', 'Piscataqualagoonal', 'ivoryliketransessentiate', 'Lespedezafuthorc', 'dermoiddiversifiable', 'surlyreptilferous', 'dermobranchiataboyardom', 'Robenhausianreboil', 'crossboltedasexually', 'Wagnerianaaviculturist', 'photocompositioneneuch', 'renverseundethroned', 'listeningBroussonetia', 'changeablyzoophilitic', 'Jesperyearlong', 'opportunisttitlark', 'hammerkopnegativer'], ['ntohll', 'lv', 'letohll', 'ntohll', 'double', 'byte', 'ntohs', 'byte', 'string', 'nextproto_b']), 'vaporizetannery': (['xenopodidtrencherless', 'asperationoraculousness', 'sokarailer', 'pneumodynamicsprimariness', 'saltlypropugnator', 'hyperneuriasymbolatry', 'dehydrogenizeCambrian', 'Orakzaiunsatisfiedly', 'symmetricalantimasker', 'sacroposteriorveratryl', 'semicolumnrankly', 'loungyimpolite', 'ornithotomyblackwort', 'countryfolkintolerance', 'collationdissuasively', 'katabolizedermic'], ['ntohl', 'float', 'letohl', 'letohs', 'ntohs', 'double', 'string', 'byte', 'letohl', 'ntohs', 'nextproto_s', 'lv', 'letohll', 'letohll', 'float', 'nextproto_s', 'lv', 'letohs', 'ntohs', 'string']), 'denieragedrapery': (['collationdissuasively', 'bustedpredoubter', 'imperializetrispaston', 'slichtarradiddler', 'dermobranchiataboyardom', 'bawcockPicnickian', 'visorlikeNagari', 'amlipyrexic', 'scleroblastemicpalaeocosmology', 'asepticallyBernese', 'crossboltedasexually', 'retroclusionmetaphysicianism', 'counterpotentMetabola'], ['ntohll', 'float', 'byte', 'letohs', 'float', 'nextproto_s', 'nextproto_b', 'double', 'ntohll', 'lv', 'ntohl', 'nextproto_b', 'ntohll', 'letohl', 'letohl', 'double', 'lv', 'byte', 'ntohl', 'lv', 'string', 'lv', 'letohs', 'letohll', 'string', 'double', 'string', 'lv']), 'extravagantkaryoplasmatic': ([], ['ntohl', 'double', 'float', 'string', 'letohs', 'letohll', 'ntohl', 'string', 'double']), 'outgushpenniveined': ([], ['double', 'double', 'letohll', 'float', 'letohll', 'ntohs', 'ntohl']), 'whealwormrice': ([], ['float', 'string', 'letohs']), 'channelizeungarter': ([], ['double', 'letohs', 'byte', 'letohs', 'byte', 'string', 'ntohll', 'float', 'float', 'string', 'float', 'ntohs', 'byte', 'letohll', 'letohl', 'double', 'float', 'string', 'double', 'ntohll', 'float', 'letohs', 'lv', 'lv', 'letohll', 'letohl', 'lv', 'double']), 'barkeeperCurtis': ([], ['letohl', 'lv', 'letohl', 'letohll', 'letohl', 'ntohl', 'letohll']), 'subsorterbecuffed': (['depositoryteloblastic', 'barrelmakingparoemia', 'hyperduliaferrateen', 'paralyzerthiocarbimide', 'Tullianrubidium', 'overganggenesial', 'misproduceunthrilled', 'picayunishapogeotropic', 'unconvenedperpetually', 'declamatorinessSerrifera', 'cancelationZoochlorella', 'interventraliaforeutter', 'cylindrarthrosisnonplusation', 'agonizefloating', 'huddlingcladautoicous', 'asepticallyBernese', 'engrossedlyDinoceras', 'susurrateoutvie', 'imperializetrispaston', 'crouchingpurebred', 'Lespedezafuthorc', 'reladepropiolaldehyde', 'Piscataqualagoonal', 'weathercockismcustodier', 'indubitablenoncollaboration', 'roofprespur', 'outworthbenevolence', 'goniometerhexameral', 'parandruspercribration', 'Pamirioversystematic', 'renverseundethroned', 'recapitalizationdissipative', 'fetoracclimatement', 'foliicolousskeletonweed', 'gatewiseunderpot', 'recapitalizerelevate', 'ambisyllabicfruitful', 'ruinlikesilva', 'organoantimonypreoperator', 'vaporizetannery', 'Sarothrawrencher', 'herpetologistindeed', 'evaluecystatrophia', 'usurperunplannedly', 'faddyamputational', 'xenogenesisprenoble', 'unlasheddialyzable', 'predefinitionCarnaria', 'katabolizedermic', 'avalanchestylopization', 'cineplastyanonang', 'predisciplinetukra', 'cacuminalgastrohysterorrhaphy', 'superabsurdditremid', 'peerlesslyforetalk', 'remisrepresentationlancet', 'laparotomycephalohumeralis', 'doubleheartedstaphylolysin', 'woodrowelshrievalty', 'unexchangedsupraventricular', 'unsanctioningperiuvular', 'blepharanthracosisuncliented', 'untastedgirllike', 'piskgriff', 'syphilologyannularity'], ['letohll', 'lv', 'byte', 'ntohl', 'float', 'letohll', 'letohll', 'letohs', 'letohl', 'ntohs', 'letohs', 'string', 'letohl', 'string', 'double', 'nextproto_s', 'nextproto_b', 'letohl', 'letohll', 'letohl', 'string', 'ntohl', 'ntohl', 'lv', 'nextproto_b', 'float', 'letohll', 'byte', 'letohll', 'string', 'letohs', 'nextproto_s', 'ntohs', 'letohl', 'letohs', 'letohll', 'letohll', 'ntohl', 'ntohll']), 'unscalednessChamaeleon': (['turbidlycorticoefferent', 'mattapharyngological', 'seminegroSemiticize', 'blepharanthracosisuncliented', 'bullswooldraggletail', 'steelworkpsychophysiological', 'Sarothrawrencher', 'bumblefooticonology', 'subregenthelmeted', 'parathyroidectomizeoutheart', 'carannaaccension', 'ochronosusafterbody', 'overhollowescort', 'visorlikeNagari', 'pneumodynamicsprimariness', 'hetericismswayable', 'slichtarradiddler', 'addressorcondensedly', 'disjointedlytriamylose', 'warneriodocasein'], ['nextproto_b', 'letohs', 'ntohl', 'double', 'letohl', 'letohll', 'letohll', 'letohl', 'letohs', 'nextproto_b', 'nextproto_s', 'letohll', 'double', 'double', 'letohs', 'letohl', 'nextproto_s', 'ntohl', 'ntohs', 'lv', 'ntohl', 'double', 'double', 'nextproto_s', 'letohl', 'ntohs', 'letohl', 'ntohl', 'letohs', 'float', 'letohs', 'ntohl', 'float', 'letohl', 'ntohl', 'ntohs', 'ntohll', 'double']), 'knuckleboneunnegotiableness': ([], ['byte', 'string', 'ntohll', 'ntohl', 'lv', 'double', 'letohl', 'letohl', 'float', 'string', 'float', 'float', 'letohl', 'ntohl', 'lv', 'ntohll', 'letohl', 'letohll', 'letohs', 'ntohll', 'letohll', 'double', 'ntohl', 'string', 'float', 'float', 'float']), 'doubleheartedstaphylolysin': ([], ['double', 'letohs', 'float', 'ntohl', 'byte', 'letohl', 'string', 'letohl', 'byte', 'string', 'byte', 'string', 'float', 'letohs', 'letohll', 'float', 'letohs', 'ntohl', 'ntohs', 'double', 'float', 'ntohl']), 'syngraphstaminiferous': ([], ['ntohl', 'ntohs', 'float', 'letohll', 'ntohll', 'ntohll', 'ntohs', 'ntohl', 'float', 'byte', 'string', 'ntohl']), 'dermoiddiversifiable': ([], ['float', 'letohll', 'letohll', 'double', 'byte']), 'androgynyvegetoalkaline': (['doubleheartedstaphylolysin', 'ineloquentundishonored', 'visorlikeNagari', 'Voltaprotarsal', 'chytridialgoosemouth', 'cannotdentigerous', 'Triuridalesplagiarism', 'outworthbenevolence', 'asepticallyBernese', 'multicrystallinekeratoglossus', 'cystocarppapaprelatical', 'dermobranchiataboyardom', 'intrathoraciccoemployment', 'scutcheonwiseileocolitis', 'peritrichouslyhepatoflavin', 'steelworkpsychophysiological', 'Vandiemenianwinery', 'ornithotomyblackwort', 'hemianacusiadouble', 'Oliveanpyromancer', 'Steganophthalmiagnomic', 'tautoousianentente', 'lepidodendridcounterplead', 'hyperneuriasymbolatry', 'isuroidunfitly', 'racegoingunperformed', 'superabsurdditremid', 'picayunishapogeotropic', 'whusslenoreast', 'microcrystallogenyfuniculus', 'hammerkopnegativer', 'pedestrianateStromateidae', 'cesserreichspfennig', 'syphilologyannularity', 'fetoracclimatement', 'carannaaccension', 'barrelmakingparoemia', 'overganggenesial', 'peccationfoolery', 'epigenesistbisexed', 'dehydrogenizeCambrian', 'unhittabledoublehorned', 'chaffererunheaded', 'bumblefooticonology', 'usurperunplannedly', 'catmalisoncoevally', 'polyspermatouscreationistic', 'tellurethurryproof', 'katabolizedermic', 'susurrateoutvie', 'semiduplexskirt', 'mausoleandecasualize', 'weathercockismcustodier', 'foliicolousskeletonweed', 'tollgateandrophagous', 'saltlypropugnator', 'cinecameraHydropotes', 'napalmbrevifoliate', 'tenesmicHymettic', 'huddlingcladautoicous', 'woodrowelshrievalty', 'nonadjustmentwritmaking', 'cylindrarthrosisnonplusation', 'refilmopenhandedness', 'cardialgiacontingence', 'mataiuntameness', 'pilchermonaulos', 'bawcockPicnickian', 'undercovertcoloss'], ['double', 'ntohll', 'lv', 'nextproto_b', 'letohs', 'double', 'nextproto_b', 'letohs', 'letohs', 'double', 'string', 'double', 'letohs', 'lv', 'nextproto_s', 'ntohs', 'letohll', 'ntohll', 'nextproto_b']), 'gratefulAlcedinidae': (['hookahsupersimplicity', 'apioidalNagari', 'declamatorinessSerrifera', 'Wagnerianaaviculturist', 'gatewiseunderpot', 'acquisitumvaletudinarist', 'percontationMaimonist', 'keraunophoneinhabited', 'nowhitoffscape', 'baptizeeFrenchize', 'urningsubpubescent', 'strainedlypsychopompos', 'prosubscriptiontribracteate', 'phenomenalisticallyunmomentary', 'pellagrosemongrelization', 'denieragedrapery', 'provectgastrocolostomy', 'ecclesiaLatinization', 'nonadjustmentwritmaking', 'sagaiebarrister', 'bawcockPicnickian', 'unhittabledoublehorned', 'metatitanatetarente', 'unlasheddialyzable', 'skilderprothalline', 'Tullianrubidium', 'codeinesalience', 'sulfureasupertramp', 'buttonholerindigestive', 'enclothearmiferous', 'symptosissubcorneous', 'docimasytrouserdom', 'isuroidunfitly', 'eudaemonisticallyCoccolobis', 'pedestrianateStromateidae', 'furoidbasanite', 'lindengamy', 'undiametricsinningness', 'certainarchpontiff', 'undercovertcoloss', 'tuboovariandeducibleness', 'coxbonesbirle', 'spadelikemassacrer', 'dominionistversableness', 'gumdiggingsalvarsan', 'semistillpassback', 'remirrorundepreciated', 'TelopeaCyclotosaurus', 'blepharanthracosisuncliented', 'Vandiemenianwinery', 'xerophagyhematography', 'interventraliaforeutter', 'gratefulAlcedinidae', 'mediumismgypsyism', 'woodrowelshrievalty', 'perukiershiplexicographer', 'domanialPhora', 'benzalethylaminedesulphurate', 'petalocerouscamus', 'idioglossiascabble', 'allegoristerserendite', 'indirecthierarchism', 'muckyuxoricide', 'rosiedunarchdeacon', 'sulphostannideuntimeliness', 'bullswooldraggletail', 'surlyreptilferous', 'lepidodendridcounterplead', 'falsificationcomer', 'poonghiehectic', 'vaporizetannery', 'countrymanisodimorphism', 'Plymouthistnashgab', 'turbidlycorticoefferent', 'unpaintterebinic', 'androgynyvegetoalkaline', 'pilchermonaulos', 'qualmyishHolocene', 'katabolizedermic', 'Larinaecoydog', 'Stromatoporoideabarry', 'napalmbrevifoliate', 'ruinlikesilva', 'laparotomycephalohumeralis', 'peccationfoolery', 'engrossedlyDinoceras', 'Ternstroemiaanisostomous', 'northwestwardpassementerie', 'piskgriff', 'pentaptychBantingism', 'Senecanovercorruptly', 'unmistgraffer', 'TaboriteSanche'], ['ntohll', 'letohl', 'lv', 'double', 'letohll', 'nextproto_b', 'string', 'nextproto_s', 'string', 'letohs', 'letohs', 'byte', 'nextproto_s', 'letohl', 'nextproto_s', 'float', 'letohll', 'ntohs', 'nextproto_b', 'byte', 'double', 'nextproto_s', 'float', 'ntohl', 'nextproto_b', 'string', 'letohs', 'byte', 'nextproto_b', 'nextproto_b', 'float', 'double', 'letohs', 'letohl', 'double', 'ntohll', 'string', 'nextproto_s', 'double', 'letohs', 'ntohl', 'letohll', 'letohll', 'letohs', 'lv', 'letohl', 'string', 'ntohs']), 'chartermarrowy': ([], ['letohl', 'ntohs', 'ntohl', 'string', 'byte', 'letohs', 'ntohs', 'letohll', 'byte', 'ntohl', 'lv', 'double', 'double', 'ntohs']), 'lobectomypreinflection': (['correctorSpirochaeta', 'asepticallyBernese', 'kansrush', 'pedestrianateStromateidae', 'Wagnerianaaviculturist', 'Voltaprotarsal', 'leathermakersemishirker', 'polyspermatouscreationistic', 'etioporphyrinpubovesical', 'asperationoraculousness', 'spinthariscopemolybdena', 'Mayorunahybridizer', 'declamatorinessSerrifera', 'uncomminutedcommix', 'picayunishapogeotropic', 'ricketssubtrihedral', 'preinjuryduplicature', 'goniometerhexameral', 'buttTarahumara', 'utterabilitypavement', 'xenogenesisprenoble', 'Jesperyearlong', 'gynarchicagedly', 'retroclusionmetaphysicianism', 'cesserreichspfennig', 'microcrystallogenyfuniculus', 'doubleheartedstaphylolysin', 'nonadjustmentwritmaking', 'bombonnefiendhead', 'Sarothrawrencher', 'recapitalizationdissipative', 'Orakzaiunsatisfiedly', 'unfeasiblecollodiotype', 'splanchnopleureprelapsarian', 'Bryumextrafocal', 'heliconbonnetman', 'interventraliaforeutter', 'parandruspercribration', 'adiaphorousfalsifiable', 'tellurethurryproof', 'shuttlecockscanmag', 'interimperialvignetter', 'Erotylidaeprehesitate', 'autovivisectionoverleather', 'Lawsonsemiconversion', 'avalanchestylopization', 'hyperduliaferrateen', 'intwistpunter', 'zincotypetripodic', 'spraysemisaprophyte', 'chaffererunheaded', 'ornithotomyblackwort', 'ambisyllabicfruitful', 'scheltopusikAmpelidaceae', 'outworthbenevolence', 'importationPerisphinctidae', 'strangulableargentamid', 'adminiculatephosphosilicate', 'emergencechouette', 'bemuzzlesurficial', 'northwestwardpassementerie', 'extravagantkaryoplasmatic', 'acclaimerilluminability', 'Oliveanpyromancer', 'subregenthelmeted', 'unhittabledoublehorned', 'docimasytrouserdom', 'keraunophoneinhabited', 'usurperunplannedly', 'herpetologistindeed', 'dejectedincreasing', 'changeablyzoophilitic', 'unreprovedlysprier', 'collationdissuasively', 'schuleclethraceous', 'hetericismswayable', 'peerlesslyforetalk', 'precoxseambiter', 'provectgastrocolostomy', 'apioidalNagari', 'unlasheddialyzable', 'vibrativeoversail'], ['letohs', 'lv', 'letohll', 'ntohll', 'nextproto_b', 'nextproto_b', 'ntohs', 'nextproto_b', 'ntohs', 'ntohll', 'nextproto_b', 'nextproto_s', 'float', 'letohll']), 'saddirhamtaxometer': ([], ['float', 'ntohs', 'letohll', 'letohl', 'ntohll', 'letohs', 'ntohl', 'string', 'double', 'letohl', 'ntohs', 'float', 'letohs', 'ntohl', 'letohl', 'byte', 'letohl', 'double', 'float', 'byte', 'letohll', 'string', 'ntohs', 'lv', 'byte', 'float', 'lv', 'byte', 'ntohll']), 'acquisitumvaletudinarist': (['arecolidinehyalodacite', 'unsubstantiaterightfulness', 'crouchingpurebred', 'superabsurdditremid', 'Dokoelectrochemically', 'etioporphyrinpubovesical', 'utterabilitypavement', 'stakeholderunforbade', 'depositoryteloblastic', 'xerophagyhematography', 'lindengamy', 'outfeatvasodilator', 'esophagoplastyrestrainedness', 'zoosporangialbuyable', 'Tullianrubidium', 'subsorterbecuffed', 'subregenthelmeted', 'untuckedsolenoglyphic', 'sokarailer'], ['letohs', 'lv', 'ntohl', 'ntohs', 'ntohll', 'float', 'ntohs', 'lv', 'letohll', 'double', 'letohll', 'nextproto_s', 'letohl', 'lv', 'string', 'letohs', 'ntohll', 'byte', 'byte', 'ntohs', 'ntohs', 'nextproto_s', 'ntohll', 'letohl', 'letohl', 'letohll', 'letohll', 'byte', 'letohs', 'byte', 'ntohl', 'letohl', 'letohll']), 'simulcastriboflavin': (['unpopulatecurry', 'barrelmakingparoemia', 'delthyrialGee', 'mataiuntameness', 'Steganophthalmiagnomic', 'Vandiemenianwinery', 'huddlingcladautoicous', 'sheepkeepingfeedman', 'woodrowelshrievalty', 'doubleheartedstaphylolysin', 'cesserreichspfennig', 'coeternaloverhonor', 'peerlesslyforetalk', 'declamatorinessSerrifera', 'cineplastyanonang', 'hemianacusiadouble', 'unhyphenedallose', 'indirecthierarchism', 'symptosissubcorneous', 'predisciplinetukra', 'frolickytriphyline', 'blepharanthracosisuncliented', 'mausoleandecasualize', 'prattlersuffumigate', 'cinecameraHydropotes', 'ureterorrhagiahemogenetic', 'opportunisttitlark', 'pistoleerproexamination', 'unfannedhopperman', 'arhatsporozoic', 'dermobranchiataboyardom', 'recapitalizationdissipative', 'unhittabledoublehorned', 'pavonatedcozily', 'changeablyzoophilitic'], ['double']), 'Boneyretreater': (['steevingerotic', 'cycloolefinmonostylous', 'misputheptarchist', 'notwitch', 'ananaamasty', 'Bitulithicscrin', 'countrymanisodimorphism', 'carannaaccension', 'picayunishapogeotropic', 'cathodofluorescencemonkcraft', 'unsanctioningperiuvular', 'cerebroidodontolcate', 'excentricalProtococcales', 'sulphhemoglobinHerculanean', 'SpatangusChayma', 'stagemansupa', 'Dokoelectrochemically', 'laparotomycephalohumeralis', 'entomicperjuriousness', 'Sarothrawrencher', 'unexchangedsupraventricular', 'knuckleboneunnegotiableness', 'gratifyinglymetrorrhea', 'alkaneirrigable', 'mausoleandecasualize', 'redepositsubclassify', 'wolfberrydeclaredness', 'Opisthocomidaeheterochiral', 'unmistgraffer', 'elementalismpietism', 'Senecanovercorruptly', 'ivoryliketransessentiate', 'Robenhausianreboil', 'epistlarcystoid', 'peccationfoolery', 'sideflashmagniloquent', 'zoosporangialbuyable', 'epigenesistbisexed', 'Voltaprotarsal', 'unconvenedperpetually', 'logarithmeticallydeliriant', 'delthyrialGee', 'baptizeeFrenchize', 'goodlyterebenthene', 'scutcheonwiseileocolitis', 'feveretunderbox', 'spicousHippopotamidae', 'hemianacusiadouble', 'insidiouslysurplicewise', 'unoverhauledGalinsoga', 'Erotylidaeprehesitate', 'epitrophygoatlike', 'maskflowerkeynoter', 'stickleafethenyl', 'zeuctocoelomicmetapodial', 'skeesicksunsteamed', 'nonofficeholdingwaldgravine', 'preformisticexemplifiable', 'mercurializationsimulacre', 'pensefulnessdrought', 'domanialPhora', 'electrocardiographyamaranthaceous', 'iconismanisostemonous', 'trinodineacetaldehyde', 'geriatricundaubed', 'Oliveanpyromancer', 'togueseaflower', 'gemeledAdonai', 'hookahsupersimplicity', 'ofttimessnatchingly', 'prankinglypneumotherapy', 'thysanuriformcrossrail', 'Philoctetessupersalesman', 'spattertriphenylated', 'sharkletcompactedly', 'untabernacledmedicamental', 'chytridialgoosemouth', 'TelopeaCyclotosaurus', 'sagaiebarrister', 'nasicornousfasciated', 'etherifyCicadidae', 'countryfolkintolerance', 'bronchiaunbaffling', 'igelstromiteMoraceae', 'syphilologyannularity', 'steinkirkmisaffection', 'Quitugryde', 'cacuminalgastrohysterorrhaphy', 'postiquedefeasibility', 'benzalethylaminedesulphurate', 'physiognomicallybrasse', 'petalousausterity', 'overpoliticunderlooker', 'aerophilethyroidless'], ['float']), 'trinodineacetaldehyde': ([], ['double', 'double', 'letohs', 'byte', 'letohs', 'ntohl', 'float', 'letohl', 'ntohl', 'float', 'float', 'double', 'ntohll', 'double', 'double', 'ntohll', 'ntohl', 'string', 'ntohll', 'letohll', 'byte', 'ntohl']), 'repolymerizationwesselton': (['declamatorinessSerrifera', 'subordinationbrachial', 'indubitablenoncollaboration', 'goodlyterebenthene', 'unbeggarbroncholithiasis', 'ricketssubtrihedral', 'paralyzerthiocarbimide', 'sagaiebarrister', 'munjmuchness', 'predesignateunderservice', 'Carpathianmetanephron', 'unmistgraffer', 'overpoliticunderlooker', 'unenterprisedargumentatious', 'unfeasiblecollodiotype', 'Sumasslevulosuria', 'sageshipcarcoon', 'susurrateoutvie', 'Plymouthistnashgab', 'subcostalbaldmoney', 'Mayorunahybridizer', 'cannotdentigerous'], ['nextproto_b', 'string', 'nextproto_s', 'letohl', 'letohl', 'ntohll', 'ntohll', 'string', 'letohll', 'string', 'ntohl', 'ntohll', 'letohll', 'ntohl', 'ntohll', 'letohs', 'ntohs', 'ntohll', 'ntohl', 'letohl', 'letohll', 'nextproto_b', 'letohl', 'ntohl', 'lv', 'string']), 'maternityhomogenetic': ([], ['ntohs', 'ntohl', 'string', 'ntohs']), 'electrocardiographyamaranthaceous': (['organosiliconsegmentary', 'togueseaflower', 'rosiedunarchdeacon', 'Vandiemenianwinery', 'pensefulnessdrought', 'warneriodocasein', 'phototherapistupsetted', 'steelworkpsychophysiological', 'acquisitumvaletudinarist', 'Oliveanpyromancer', 'popeyednaphtha', 'delthyrialGee', 'unbeggarbroncholithiasis', 'focoidsstackfreed', 'predisciplinetukra', 'volubilityThuidium', 'pistoleerproexamination', 'unmooredtowy', 'coxbonesbirle', 'sageshipcarcoon', 'manageriallyflanger', 'asepticallyBernese', 'knuckleboneunnegotiableness', 'warfaringdraghound', 'unhittabledoublehorned', 'munjmuchness', 'tellurethurryproof', 'ornithomanticrada', 'intrathoraciccoemployment', 'chytridialgoosemouth', 'balandracaducibranch', 'interventraliaforeutter', 'kansrush', 'campulitropoussapogenin', 'antleredadunc', 'wutproamusement', 'chaffererunheaded', 'byworkplastid'], ['lv', 'letohll', 'ntohs', 'letohl', 'ntohs', 'ntohll', 'ntohll', 'float', 'float', 'ntohs', 'string', 'ntohll', 'double', 'letohll', 'letohll']), 'photometricalacantholysis': ([], ['letohs', 'double', 'letohl', 'float', 'ntohs', 'letohl', 'ntohl', 'ntohl', 'byte', 'letohs']), 'Spongiaealcelaphine': ([], ['byte', 'lv', 'letohll', 'ntohl', 'float', 'string', 'float', 'float', 'letohll', 'ntohll', 'ntohl', 'ntohll', 'letohll', 'letohl', 'string', 'string', 'ntohs', 'ntohs', 'ntohll', 'ntohl', 'ntohs', 'letohl', 'float', 'byte', 'string', 'letohl', 'ntohs', 'letohs', 'byte', 'ntohs', 'ntohll', 'lv', 'float', 'letohll', 'ntohl', 'letohll']), 'cosilybridecake': ([], ['letohll', 'ntohs', 'letohs', 'lv', 'ntohl', 'letohl', 'ntohll', 'double', 'lv', 'string', 'letohll', 'string', 'ntohll', 'letohl', 'lv', 'double', 'float', 'double', 'letohs', 'letohs', 'string', 'ntohll']), 'zoosporangialbuyable': ([], ['letohs', 'letohl', 'byte', 'letohl', 'ntohs', 'letohll', 'double', 'float', 'ntohl', 'ntohll', 'float', 'byte', 'ntohl', 'string', 'letohll', 'double', 'double', 'byte', 'float', 'letohs', 'double', 'string']), 'unreprovedlysprier': (['Pamirioversystematic', 'unmistgraffer', 'superabsurdditremid', 'bawcockPicnickian', 'focoidsstackfreed', 'steelworkpsychophysiological', 'udometricpredefault', 'saltlypropugnator', 'Orakzaiunsatisfiedly', 'sokarailer', 'hyperneuriasymbolatry', 'peccationfoolery', 'outworthbenevolence', 'Bryumextrafocal', 'cardialgiacontingence', 'mattapharyngological', 'semicolumnrankly'], ['lv', 'letohll', 'letohll', 'double', 'letohl', 'nextproto_s', 'letohll', 'ntohll', 'nextproto_s', 'letohll', 'string', 'double', 'letohs', 'byte', 'ntohl', 'letohl', 'letohll', 'letohs', 'string', 'letohs', 'double', 'string', 'ntohs', 'ntohs', 'ntohl', 'nextproto_b', 'letohs', 'byte', 'nextproto_s', 'byte', 'float', 'byte', 'double']), 'heterophyllychlorochromates': (['Trinorantumpyramides', 'paraderDendrocygna', 'batteruncommutable', 'indubitablenoncollaboration', 'proteosomalsuppletion'], ['string', 'letohs', 'ntohs', 'ntohs', 'nextproto_s', 'letohs', 'byte', 'ntohll', 'letohs', 'nextproto_b', 'letohl', 'byte', 'string', 'double', 'letohll', 'float', 'ntohl', 'float', 'double', 'letohl', 'ntohs', 'letohl', 'float', 'nextproto_s', 'nextproto_s', 'ntohl', 'nextproto_s', 'letohl', 'letohl', 'string', 'byte', 'ntohs', 'string', 'byte']), 'ananaamasty': (['Marcosianpictographically', 'nasicornousfasciated', 'limsypersistence', 'burgonetcarefully', 'pseudodemocraticproconscription', 'sageshipcarcoon', 'lamellicornousPolygonaceae', 'unaccuracyblepharoadenitis', 'pneumodynamicsprimariness', 'countrymanisodimorphism', 'ankylenterongreenfish', 'projicientcolumellate', 'ExobasidialesEppy', 'asteamincandescency', 'multicrystallinekeratoglossus', 'heronerchondroplasty', 'motacillinewidespreadly', 'balandracaducibranch', 'onomatopoeiaeggfish', 'reproachablepancreatogenic', 'racegoingunperformed', 'cantingnesstideful', 'Bharatadomain', 'Toryizesynechthran', 'turbidlycorticoefferent', 'wutproamusement', 'remirrorundepreciated', 'herpetologistindeed', 'prosubscriptiontribracteate', 'crouchingpurebred', 'autovivisectionoverleather', 'valvotomypensionably', 'inferiorismobstetrix', 'mammillationpemphigous', 'arnberrydodecadrachm', 'petalousausterity', 'emblazonarsenopyrite', 'subrigidlithophysal', 'benzalethylaminedesulphurate', 'demibeastuninflicted', 'tenesmicHymettic', 'steevingerotic', 'flashpanstature', 'loungyimpolite', 'overgenialitybuzzle'], ['nextproto_s', 'nextproto_s', 'string', 'letohl', 'string']), 'triseriallypreaccess': ([], ['ntohll', 'string', 'letohll', 'letohll', 'lv', 'byte', 'letohll', 'ntohll', 'string', 'letohll', 'double', 'byte', 'ntohl', 'double', 'letohs', 'float', 'byte', 'letohs', 'ntohl', 'ntohll', 'float', 'letohs', 'ntohll', 'letohll', 'lv', 'lv', 'double', 'ntohs', 'letohl', 'lv', 'letohs', 'lv', 'ntohl', 'ntohll', 'ntohll', 'byte', 'letohs', 'double']), 'laurdalitewistonwish': ([], ['double', 'byte', 'byte', 'letohs', 'ntohs', 'float', 'letohl', 'letohl', 'letohl', 'letohl', 'letohl', 'ntohs', 'string', 'letohll', 'float', 'letohs', 'double', 'double', 'lv', 'string', 'letohs', 'double', 'ntohl', 'lv', 'float', 'lv', 'string', 'ntohll', 'ntohll', 'string', 'ntohs', 'ntohl', 'string', 'double', 'ntohs', 'letohll', 'ntohl', 'ntohs', 'ntohl', 'ntohl']), 'TaboriteSanche': ([], ['ntohl', 'lv', 'ntohll', 'ntohl', 'ntohll', 'letohll', 'ntohl', 'byte', 'byte', 'lv', 'string', 'ntohll', 'string', 'ntohs', 'letohl', 'byte', 'string', 'letohll', 'letohs', 'lv']), 'terrazzododder': (['epexegeticallyreadjournment', 'pyrroylprobity', 'radiopaqueunrecruitable', 'Alalamenispermine', 'gumdiggingsalvarsan', 'hookahsupersimplicity', 'Oliveanpyromancer'], ['letohll', 'string', 'float', 'ntohl', 'string', 'letohs', 'letohl', 'lv', 'lv', 'nextproto_b', 'nextproto_b', 'byte', 'float', 'letohl', 'double', 'nextproto_s', 'string', 'byte', 'letohs', 'ntohll', 'nextproto_s', 'ntohs', 'nextproto_b', 'nextproto_s', 'letohll', 'string', 'ntohll', 'double', 'nextproto_b', 'string', 'letohs', 'float', 'letohll', 'ntohs', 'nextproto_b', 'byte', 'byte', 'lv', 'lv', 'ntohll', 'ntohll', 'ntohs', 'float']), 'Vickyimmigrant': ([], ['ntohll', 'ntohl', 'ntohll', 'float', 'float', 'ntohs', 'letohl', 'letohl', 'double', 'letohll', 'byte', 'ntohl', 'letohs', 'letohll', 'letohs', 'ntohll', 'ntohl', 'string', 'string', 'ntohs', 'ntohll', 'letohll', 'letohl', 'letohl', 'letohs', 'lv', 'letohs', 'ntohl', 'ntohs', 'lv', 'float', 'letohll', 'string', 'string', 'letohll', 'ntohs', 'double', 'double', 'letohl', 'ntohs', 'ntohl', 'string']), 'overfretdisenthronement': (['subcostalbaldmoney', 'endogalvanismunwarrantedly', 'matelessbeatitude', 'Bharatadomain', 'interventraliaforeutter', 'trentepohliaceousHectorean', 'inquilinecopse', 'mausoleandecasualize', 'piperitiousreekingly', 'Trinorantumpyramides', 'undercovertcoloss', 'denieragedrapery', 'carangoidbotryomycotic', 'unfeasiblecollodiotype', 'listeningBroussonetia', 'doubleheartedstaphylolysin', 'ineloquentundishonored', 'retroclusionmetaphysicianism', 'subcineritiousphrenitic', 'laparotomycephalohumeralis', 'mataiuntameness', 'prerailwaycannibalistically'], ['string', 'letohl', 'string', 'ntohl', 'letohl', 'ntohll', 'ntohll', 'byte', 'nextproto_b', 'letohll', 'letohl', 'nextproto_s', 'lv', 'ntohl', 'ntohl', 'double', 'ntohll', 'ntohl', 'double', 'nextproto_b', 'lv', 'byte', 'nextproto_b']), 'Larinaecoydog': ([], ['byte', 'ntohl', 'letohll', 'double', 'ntohl', 'letohll', 'float', 'double', 'ntohl', 'lv', 'letohl']), 'subrigidlithophysal': (['querulouslycooky', 'intrathoraciccoemployment', 'slichtarradiddler', 'eudaemonisticallyCoccolobis', 'exponencecrubeen', 'lepidodendridcounterplead', 'Oliveanpyromancer', 'predestinarianglia'], ['nextproto_s', 'letohl', 'ntohl', 'letohll', 'nextproto_b', 'nextproto_b', 'byte', 'double', 'lv', 'ntohs', 'string', 'ntohll', 'nextproto_b', 'nextproto_b', 'letohll', 'byte', 'float', 'ntohs', 'letohs', 'letohl', 'letohl', 'lv', 'nextproto_b', 'string', 'ntohl', 'string', 'nextproto_s', 'double', 'nextproto_b', 'float', 'ntohl', 'double', 'string', 'ntohll', 'letohs', 'ntohl', 'float', 'letohl', 'nextproto_s', 'letohs', 'letohs', 'nextproto_s', 'string', 'string', 'ntohl']), 'bawcockPicnickian': ([], ['letohs', 'letohll', 'lv', 'letohl', 'letohs', 'ntohs', 'float', 'ntohll', 'letohl', 'letohll', 'letohs', 'letohl', 'ntohl']), 'polishedlyhematosis': (['coinbellmaker', 'spinthariscopiclieutenancy', 'bairnlyneocosmic', 'surrenalinconcluding', 'petalousausterity', 'unremittinglyaffronting', 'disjointedlytriamylose', 'knuckleboneunnegotiableness', 'cardinghygeistic', 'mammillationpemphigous', 'hammerkopnegativer', 'paralyzerthiocarbimide', 'entomicperjuriousness', 'veldcraftsubprefect', 'mattapharyngological', 'micrencephalypalpus', 'predisciplinetukra', 'monogamianportio', 'geriatricundaubed'], ['nextproto_s', 'lv', 'letohll', 'float', 'lv', 'string', 'ntohl', 'nextproto_b', 'float', 'ntohll']), 'exarteritisthenadays': ([], ['letohll', 'ntohll', 'letohl', 'string', 'ntohll', 'letohll', 'lv', 'ntohl', 'double', 'double', 'float', 'letohll', 'lv', 'ntohll', 'byte', 'letohl', 'letohl', 'letohll', 'double', 'float', 'byte', 'byte', 'double', 'letohll', 'letohs', 'ntohs', 'letohs', 'ntohll']), 'orographicniddick': ([], ['float', 'byte', 'letohll', 'float', 'double', 'byte', 'ntohs', 'double', 'lv', 'string', 'ntohll', 'letohs', 'ntohs', 'letohs', 'letohl', 'byte', 'ntohll', 'letohl', 'byte', 'letohll', 'ntohll', 'float', 'string', 'letohl', 'string', 'byte', 'double', 'letohl', 'ntohl', 'float', 'letohll', 'ntohll']), 'subrelationsepiolite': (['Wagnerianaaviculturist', 'semicolumnrankly', 'stakeholderunforbade', 'scruplercellulifugal', 'susurrateoutvie', 'xenopodidtrencherless', 'tollgateandrophagous', 'keraunophoneinhabited', 'misadministrationbroody', 'isuroidunfitly', 'prizeexcrescence', 'spinthariscopiclieutenancy', 'endogalvanismunwarrantedly', 'foliicolousskeletonweed', 'unaccuracyblepharoadenitis', 'allerChilostoma', 'indirecthierarchism', 'subsorterbecuffed', 'ineloquentundishonored', 'unfeasiblecollodiotype', 'zincotypetripodic', 'Philonismpinivorous', 'noniccosmopoietic', 'renverseundethroned', 'opportunisttitlark', 'byworkplastid', 'doubleheartedstaphylolysin', 'counterpotentMetabola', 'genipacombiner', 'retroclusionmetaphysicianism', 'parathyroidectomizeoutheart', 'esophagoplastyrestrainedness', 'vaporizetannery', 'veldcraftsubprefect', 'Grahamsaloon', 'butterrootchagrin', 'coinbellmaker', 'usurperunplannedly', 'preinjuryduplicature', 'poonghiehectic', 'cancelationZoochlorella', 'perukiershiplexicographer', 'paleobotanyworkpeople', 'idioglossiascabble', 'kleenebocJungermannia', 'steelworkpsychophysiological', 'Piscataqualagoonal', 'spraysemisaprophyte', 'subrelationsepiolite', 'diseasednessthioantimonate', 'galledisocinchomeronic', 'misputheptarchist', 'thysanuriformcrossrail', 'ivoryliketransessentiate', 'archsnoblodgepole', 'unlasheddialyzable', 'Carpathianmetanephron', 'splanchnopleureprelapsarian', 'subcineritiousphrenitic', 'semiduplexskirt', 'tautoousianentente', 'Opisthocomidaeheterochiral', 'hyperduliaferrateen', 'catagmaticMegalosaurus'], ['ntohs', 'string', 'lv', 'letohs', 'letohll']), 'galleywormphos': (['Orakzaiunsatisfiedly', 'Lachnosternaadenodermia', 'ciderishazury', 'secrecyheteroecy', 'bombonnefiendhead', 'arnberrydodecadrachm', 'faddyamputational', 'oxmanoutpull', 'venomouslypilferment', 'unreprovedlysprier', 'smotheringlyhumpbacked', 'peragratemultifoliate', 'Vandiemenianwinery', 'Eurypteroideachamaeprosopic', 'symmetricalantimasker', 'frontomallarforedetermine', 'kleenebocJungermannia', 'agonizefloating', 'tumultuouslymammonitish', 'undiametricsinningness', 'undercropArenga', 'cattlefolk', 'hancesmoothness', 'surfactantchurchgrith', 'steinkirkmisaffection', 'sleekgavelock', 'epitrophygoatlike', 'cannotdentigerous', 'superabsurdditremid', 'delthyrialGee', 'tartishlynarcotical', 'responsivitykimigayo', 'trinodineacetaldehyde', 'provectgastrocolostomy', 'retroclusionmetaphysicianism', 'shuttlecockscanmag', 'unsilentiousskimpy', 'mammillationpemphigous', 'microcaltropmyosarcomatous', 'uncrevassedterministic', 'Philonismpinivorous', 'deploredlyGolaseccan', 'phantasmascopeMelanochroid', 'pellagrosemongrelization', 'amlipyrexic', 'meddlingsmall', 'pentaptychBantingism', 'snakeletwounds', 'prankinglypneumotherapy', 'cineplastyanonang', 'TaboriteSanche', 'pensefulnessdrought', 'overganggenesial', 'tumoredcrocodilite', 'erythriticsynergidal', 'distilleryKiwanis', 'Limodorumscrotal', 'unaccuracyblepharoadenitis', 'ineloquentundishonored', 'nonaugmentativehypertelic', 'keelfathoplomachos', 'motacillinewidespreadly', 'bumblefooticonology', 'Hetaeristaltimetrical', 'ankylenterongreenfish', 'bronchiaunbaffling', 'susurrateoutvie', 'cudavaogreish', 'eudaemonisticallyCoccolobis', 'appendiceunmetaled', 'ivoryliketransessentiate', 'skeelysubtriangular', 'Brandipriestcraft', 'unmistgraffer', 'ancestorialLicania', 'Grahamsaloon', 'monogamianportio', 'unfangedramline', 'changeablyzoophilitic'], ['ntohs', 'ntohll', 'ntohl', 'double', 'double', 'byte', 'string', 'letohll', 'ntohll', 'byte', 'string', 'ntohs', 'ntohl', 'nextproto_b', 'ntohll', 'ntohll', 'letohs', 'ntohll', 'byte', 'letohs', 'letohl', 'ntohll', 'nextproto_b', 'nextproto_s']), 'distilleryKiwanis': ([], ['lv', 'double', 'letohl', 'lv', 'lv']), 'Marcosianpictographically': ([], ['float', 'byte', 'float', 'ntohl', 'float', 'letohl', 'byte', 'letohl', 'letohll', 'float', 'byte', 'double', 'byte', 'double', 'lv', 'ntohll', 'double', 'ntohl', 'letohl', 'byte', 'letohll', 'ntohll', 'ntohl', 'letohs', 'letohl', 'byte', 'letohs', 'letohl', 'letohl']), 'freakilyuphoard': ([], ['letohll', 'byte', 'double', 'string', 'byte', 'byte', 'letohs', 'letohl', 'letohs', 'float', 'lv', 'lv', 'ntohs', 'ntohl', 'letohs', 'letohs', 'letohll', 'lv', 'letohl', 'letohl', 'double', 'float', 'ntohs', 'ntohl', 'lv', 'string', 'letohll', 'letohl', 'string', 'float']), 'zincotypetripodic': ([], ['ntohl', 'double', 'float', 'ntohs', 'ntohl']), 'alveolonasaltige': ([], ['ntohs', 'lv', 'string', 'ntohs', 'string', 'lv', 'ntohl', 'letohs', 'ntohs', 'letohl', 'ntohs', 'letohs', 'float', 'float']), 'ralphautonomically': ([], ['letohll', 'byte', 'letohl', 'double', 'letohs', 'ntohll', 'letohs', 'byte', 'ntohl', 'letohs']), 'sowbackgastrotrichan': ([], ['double', 'string', 'byte', 'string', 'ntohll', 'letohl', 'letohll', 'ntohll', 'ntohll', 'byte', 'letohll', 'ntohll', 'letohll', 'lv', 'letohs', 'double', 'letohll', 'ntohl', 'double', 'byte', 'lv', 'letohl', 'letohll', 'letohs', 'ntohl', 'letohs', 'byte', 'ntohll', 'lv', 'ntohs', 'byte', 'float', 'ntohl', 'letohl', 'string', 'letohll', 'float', 'ntohll', 'letohll', 'letohl', 'ntohs', 'ntohl']), 'placitumunmortgage': ([], ['string', 'string', 'ntohs', 'double', 'ntohll', 'ntohs', 'byte', 'lv', 'double', 'lv', 'letohs', 'lv', 'letohll', 'byte', 'ntohl', 'float', 'float', 'ntohl', 'letohll', 'letohs', 'letohll', 'letohll', 'letohl', 'ntohs', 'string', 'letohs', 'lv', 'string', 'string', 'float', 'ntohll', 'ntohs', 'lv', 'letohl', 'letohs', 'lv', 'string', 'letohl', 'double', 'ntohl', 'float', 'byte', 'letohll', 'double']), 'Chlamydobacteriaceaesystematize': ([], ['letohl', 'ntohl', 'ntohs', 'letohl', 'ntohs', 'ntohll', 'letohl', 'byte', 'ntohll', 'ntohl', 'float', 'string', 'letohs', 'float', 'byte', 'letohl', 'letohl', 'letohl', 'letohll', 'double', 'ntohs', 'lv', 'string', 'letohl', 'string', 'ntohs', 'byte', 'double', 'float', 'double', 'byte']), 'Bitulithicscrin': (['assecurationAshkenazim', 'katabolizedermic', 'prizeexcrescence', 'roofprespur', 'Larinaecoydog', 'asteamincandescency', 'contrarietyinconceivableness', 'untrainhearkener', 'entomicperjuriousness', 'unrevenuedindecorousness', 'Bombycillahonoraria', 'SpatangusChayma', 'unquailingshive', 'prattlersuffumigate', 'Sonjapylorogastrectomy', 'overgenialitybuzzle', 'raspberrylikesubvertebral', 'photoheliographoctuplicate', 'stomagringo', 'geriatricundaubed', 'semicolumnrankly', 'anomalousparallelinerved', 'erythriticsynergidal', 'petalousausterity', 'craunchprovitamin', 'channelizeungarter', 'summarizationyatter', 'unpaintterebinic', 'hypoplasyhooping', 'paleobotanyworkpeople', 'furoidbasanite', 'xenogenesisprenoble', 'noninfectionvenerativeness', 'parathyroidectomizeoutheart', 'unflukedcleck', 'subcostalbaldmoney', 'gardenedfugacious', 'idioglossiascabble', 'bustedpredoubter', 'bacteriformpiercel', 'recapitalizerelevate', 'unlasheddialyzable', 'monogamianportio', 'vibrativeoversail', 'hyperneuriasymbolatry', 'Senecanovercorruptly', 'motacillinewidespreadly', 'pensefulnessdrought', 'blepharanthracosisuncliented', 'etherifyCicadidae', 'hippocampalscrow', 'munjmuchness', 'tenodesisunroaming', 'dachshundpuddly', 'endogalvanismunwarrantedly', 'sokarailer', 'catmalisoncoevally', 'udometricpredefault', 'avalanchestylopization', 'preformisticexemplifiable', 'parandruspercribration', 'nonofficeholdingwaldgravine', 'napalmbrevifoliate', 'pegologyscavenage', 'steelworkpsychophysiological', 'disaffectedanchorite', 'GemitoresBourignian'], ['letohl', 'string', 'letohll', 'byte', 'float', 'float', 'ntohll', 'ntohll', 'nextproto_b', 'letohl']), 'archcrownundistantly': ([], ['ntohl', 'letohl', 'string', 'ntohs', 'ntohl', 'letohs', 'lv', 'string', 'letohll', 'letohs', 'byte']), 'Histriobdellauntread': (['parathyroidectomizeoutheart', 'pensefulnessdrought', 'agoraphobiaLenzites', 'udometricpredefault', 'Nathanielbiliteral', 'Oliveanpyromancer', 'miningFlavia', 'stagemansupa', 'disjointedlytriamylose', 'blepharanthracosisuncliented', 'vibrativeoversail', 'indirecthierarchism', 'overgenialitybuzzle', 'terrazzododder', 'kleenebocJungermannia', 'pentaptychBantingism', 'misadministrationbroody', 'arsheenperspiration', 'gatewiseunderpot', 'collationdissuasively', 'ochronosusafterbody', 'Philoctetessupersalesman', 'prizeexcrescence', 'lindengamy', 'slopinglyautomatically', 'retroclusionmetaphysicianism', 'responsivitykimigayo'], ['ntohll', 'ntohl', 'ntohl', 'ntohl', 'ntohll', 'letohll', 'ntohs', 'letohl', 'ntohl', 'string', 'string', 'letohs', 'float', 'ntohl', 'ntohl', 'ntohll', 'nextproto_s', 'nextproto_b', 'byte', 'lv', 'double', 'ntohs', 'ntohl', 'lv', 'ntohs', 'letohs', 'lv', 'nextproto_s', 'ntohll', 'string', 'lv', 'ntohl', 'nextproto_b', 'float', 'string']), 'outworthbenevolence': ([], ['letohs', 'lv', 'letohl', 'lv', 'string', 'ntohll', 'string', 'string', 'ntohl', 'double', 'letohl', 'lv', 'ntohs', 'letohs', 'lv', 'ntohl', 'double']), 'paleocrystallinespinulosodenticulate': ([], ['ntohs', 'double', 'ntohll', 'letohl', 'letohll', 'letohll', 'double', 'ntohl', 'letohs', 'letohl', 'letohll', 'ntohll', 'ntohl', 'letohll', 'ntohs', 'ntohll', 'ntohl', 'letohl', 'double', 'float', 'lv', 'letohs', 'lv', 'double', 'ntohll', 'letohs', 'letohs', 'lv', 'ntohl', 'ntohs', 'ntohl', 'double', 'letohs']), 'Lawsonsemiconversion': ([], ['ntohl', 'ntohl', 'letohl', 'byte', 'ntohll', 'letohs', 'ntohs', 'letohll', 'lv', 'string', 'float', 'double', 'letohl', 'byte', 'double', 'double', 'float', 'ntohll', 'ntohll', 'double', 'lv', 'letohs', 'ntohl', 'lv', 'float', 'letohl']), 'prehexameraldissyllabize': ([], ['ntohs', 'letohl']), 'schuleclethraceous': ([], ['float', 'ntohl', 'letohl', 'letohs', 'ntohll', 'ntohl', 'lv']), 'piperitiousreekingly': (['erythriticsynergidal', 'appendiceunmetaled', 'faddyamputational', 'cinecameraHydropotes', 'dermoiddiversifiable', 'apioidalNagari', 'venomouslypilferment', 'surlyreptilferous', 'warneriodocasein', 'stickleafethenyl', 'xenopodidtrencherless', 'hetericismswayable', 'prattlersuffumigate', 'utterabilitypavement', 'allerChilostoma', 'importationPerisphinctidae', 'thysanuriformcrossrail', 'addressorcondensedly', 'pantomnesiadiporpa', 'bawcockPicnickian', 'unoverhauledGalinsoga', 'terribletaut', 'monodromiclyretail', 'schuleclethraceous', 'uncomminutedcommix', 'snakeletwounds', 'yoreexponent', 'symptosissubcorneous', 'unflukedcleck', 'subsoilercruent', 'cardinghygeistic', 'unlasheddialyzable', 'unsubstantiaterightfulness', 'refilmopenhandedness', 'arecolidinehyalodacite', 'xerophagyhematography', 'cylindrarthrosisnonplusation', 'unfannedhopperman', 'subordinationbrachial', 'tellurethurryproof', 'stagemansupa', 'spinthariscopemolybdena', 'Abrahamicinordinateness', 'parathyroidectomizeoutheart', 'napalmbrevifoliate', 'tongueshoticonophilism', 'asteamincandescency', 'eudaemonisticallyCoccolobis', 'qualmyishHolocene', 'slichtarradiddler', 'Sonjapylorogastrectomy', 'ettleoptimize', 'barrelmakingparoemia', 'imperializetrispaston', 'bombonnefiendhead', 'menialitypreintelligent', 'feveretunderbox', 'emergencechouette', 'simulcastriboflavin', 'multicrystallinekeratoglossus', 'cannotdentigerous', 'benzalethylaminedesulphurate', 'carcerationinterrenal', 'cycloolefinmonostylous', 'ureterorrhagiahemogenetic', 'delthyrialGee', 'scruplercellulifugal', 'Senecanovercorruptly', 'Oliveanpyromancer', 'zoosporangialbuyable', 'misadministrationbroody', 'Cobitidaedismissal', 'Suionesunprejudicially', 'picayunishapogeotropic', 'wingerconsoler', 'trentepohliaceousHectorean', 'previousnessoisin', 'hyperduliaferrateen', 'unhyphenedallose', 'echinostomewont', 'catagmaticMegalosaurus', 'ruinlikesilva', 'arnberrydodecadrachm', 'TelopeaCyclotosaurus', 'yawpwoodwax', 'tautologicpanimmunity'], ['letohs', 'double', 'ntohs', 'float', 'double', 'double', 'double', 'letohll', 'lv', 'letohll', 'ntohll', 'byte', 'float', 'nextproto_b', 'double']), 'stakeholderunforbade': ([], ['lv', 'letohll', 'letohl', 'double', 'letohll', 'double', 'ntohs', 'letohll', 'string', 'byte', 'letohll', 'double', 'byte', 'byte', 'ntohll', 'letohl', 'letohll', 'byte', 'string', 'ntohll', 'float', 'float', 'letohl', 'ntohs', 'float', 'letohs', 'ntohl', 'letohl', 'lv', 'float']), 'alphabetizermonoclinal': (['carcerationinterrenal', 'leucoencephalitisconsistent', 'syphilologyannularity', 'cognaticalintransmissible', 'untuckedsolenoglyphic', 'snakeletwounds', 'Suionesunprejudicially', 'strainedlypsychopompos', 'indirecthierarchism', 'prefactoranchoret', 'Plymouthistnashgab', 'intergeneratingruneword', 'gynarchicagedly', 'microcrystallogenyfuniculus', 'protosiphonaceousossiferous', 'precoxseambiter', 'ettleoptimize', 'pellagrosemongrelization', 'bumblefooticonology', 'unfannedhopperman', 'counterspyingdungeon', 'opportunisttitlark', 'semisomnolencegunj', 'laparotomycephalohumeralis', 'unadversenessmaro', 'practicelegitimatist', 'logarithmeticallydeliriant', 'wirrshillingless', 'radiopaqueunrecruitable', 'arnberrydodecadrachm', 'uncomminutedcommix', 'outfeatvasodilator', 'stickleafethenyl', 'foreuseuninfluencing', 'prehexameraldissyllabize', 'arecolidinehyalodacite', 'scleroblastemicpalaeocosmology', 'misproduceunthrilled', 'ExobasidialesEppy', 'pyroaceticnunciature', 'yawpwoodwax', 'undiametricsinningness', 'mammillationpemphigous', 'cycloolefinmonostylous', 'trentepohliaceousHectorean', 'Fichteanismconjobble', 'acutelyminar', 'unenterprisedargumentatious', 'uncatholicizeSiphonognathus', 'spinthariscopiclieutenancy', 'catastateateliosis', 'cystocarppapaprelatical', 'projicientcolumellate', 'mataiuntameness', 'codeinesalience', 'raspberrylikesubvertebral', 'geriatricundaubed', 'submountainhopper', 'Bharatadomain', 'GemitoresBourignian', 'unconvenedperpetually', 'idioglossiascabble', 'trichitepersonship', 'porencephalonpostplegic', 'sokarailer', 'previousnessoisin', 'nonadjustmentwritmaking', 'funestworser', 'gratefulAlcedinidae', 'ricketssubtrihedral', 'refilmopenhandedness', 'Boneyretreater', 'iconismanisostemonous', 'picayunishapogeotropic'], ['letohll', 'string', 'ntohl', 'double', 'ntohll', 'letohs', 'ntohl', 'letohl', 'letohll', 'letohs', 'byte', 'float', 'float', 'string', 'byte', 'lv', 'float', 'letohs', 'letohs', 'byte', 'nextproto_b', 'letohl', 'ntohll', 'float', 'nextproto_b', 'ntohl', 'lv', 'byte', 'lv', 'ntohl', 'ntohs', 'ntohll', 'float', 'letohs', 'letohll', 'lv', 'nextproto_b', 'ntohll', 'lv', 'nextproto_s', 'letohl', 'ntohll', 'float', 'ntohll', 'letohs', 'nextproto_s', 'double', 'byte', 'double']), 'calycoideousunpressed': ([], ['ntohl', 'double', 'string', 'letohl', 'byte', 'string', 'ntohll', 'float', 'letohl', 'float', 'byte', 'ntohll', 'ntohl', 'letohl', 'ntohs', 'ntohll', 'letohl', 'ntohll', 'letohll', 'float', 'letohll', 'byte', 'ntohs']), 'endogalvanismunwarrantedly': ([], ['lv', 'float', 'ntohl']), 'northwestwardpassementerie': ([], ['letohll', 'ntohl', 'ntohs', 'string', 'string', 'byte', 'ntohs', 'double', 'letohs', 'letohl', 'ntohs', 'ntohl', 'float', 'lv', 'letohs']), 'ciderishazury': (['pellagrosemongrelization', 'codeinesalience', 'unsanctioningperiuvular', 'preinjuryduplicature', 'unrevenuedindecorousness', 'thysanuriformcrossrail', 'noniccosmopoietic', 'unconvenedperpetually', 'genipacombiner', 'creditiveplatonesque'], ['float', 'letohll', 'ntohs', 'ntohl', 'letohs', 'float', 'byte', 'byte', 'lv', 'ntohll', 'float', 'letohs', 'byte', 'ntohs', 'byte', 'byte', 'nextproto_b', 'letohll', 'string', 'lv', 'byte', 'letohll', 'ntohs', 'byte', 'lv', 'letohl', 'letohl', 'ntohs', 'string', 'byte', 'byte', 'float', 'letohs', 'letohll', 'byte', 'lv', 'byte', 'lv', 'string']), 'penitentiaryshiporderedness': ([], ['double', 'letohl', 'double', 'byte', 'lv', 'byte', 'ntohll', 'double', 'byte', 'byte', 'letohll', 'double', 'double', 'ntohl', 'double', 'letohll', 'byte', 'ntohll', 'byte', 'double', 'letohs', 'ntohs', 'letohs', 'lv', 'ntohs']), 'semideliriousmelituria': ([], ['letohll', 'letohs', 'ntohl', 'letohs', 'ntohs', 'double', 'string', 'ntohll', 'float', 'double', 'ntohl', 'lv', 'ntohll', 'double', 'letohll', 'ntohll', 'float', 'ntohll', 'letohll', 'lv', 'letohll', 'letohs', 'ntohll', 'float', 'letohs', 'string', 'letohs', 'float', 'letohs', 'lv', 'string', 'ntohll', 'string', 'ntohl']), 'domanialPhora': ([], ['double', 'ntohll', 'ntohll', 'ntohl', 'letohll', 'letohll', 'double', 'ntohs', 'string', 'byte', 'string', 'letohs', 'letohs', 'letohll', 'ntohl', 'letohs', 'ntohl', 'ntohll']), 'nookingspellword': ([], ['float', 'string', 'string', 'byte', 'ntohl', 'letohll']), 'uncatholicizeSiphonognathus': ([], ['double', 'ntohs', 'letohll', 'byte', 'letohs', 'double', 'ntohl', 'string', 'double', 'ntohll', 'string', 'letohl', 'double', 'lv', 'double', 'letohll', 'ntohll', 'double', 'ntohs', 'string', 'float', 'ntohll', 'ntohl', 'double', 'letohl', 'letohl', 'letohl', 'letohs', 'letohl', 'float', 'letohll', 'letohl', 'lv', 'string', 'ntohll', 'byte', 'letohs', 'byte', 'double', 'lv', 'letohll']), 'recapitalizerelevate': ([], ['float', 'double', 'byte', 'ntohl', 'ntohll', 'letohll', 'lv', 'letohs', 'letohs', 'lv', 'string', 'lv', 'byte', 'lv', 'lv', 'double', 'letohll', 'ntohl', 'double', 'byte', 'lv', 'ntohl', 'ntohll', 'ntohll', 'letohll', 'letohl', 'float', 'letohl', 'ntohl', 'float', 'ntohl', 'double', 'letohl', 'string']), 'cantingnesstideful': ([], ['ntohs', 'double', 'ntohl', 'ntohll', 'letohs', 'lv', 'byte']), 'docimasytrouserdom': ([], ['string', 'double', 'ntohll', 'letohs', 'lv', 'ntohl', 'letohl', 'letohs', 'ntohll', 'double', 'float', 'double', 'ntohl', 'letohs']), 'manageriallyflanger': (['querulouslycooky', 'countryfolkintolerance', 'clientageshudderingly', 'asteamincandescency', 'bairnlyneocosmic', 'Lespedezafuthorc', 'Grahamsaloon', 'cylindrarthrosisnonplusation', 'Opisthocomidaeheterochiral', 'unfannedhopperman', 'vibrativeoversail', 'steelworkpsychophysiological', 'carangoidbotryomycotic', 'ineloquentundishonored', 'misadministrationbroody', 'polyspermatouscreationistic', 'crouchingpurebred', 'cannotdentigerous', 'unlasheddialyzable', 'Vandiemenianwinery', 'tellurethurryproof', 'tongueshoticonophilism', 'grapedmassively', 'cystocarppapaprelatical', 'focoidsstackfreed', 'yawpwoodwax', 'carcerationinterrenal', 'hyperneuriasymbolatry', 'maltingsurrection', 'goniometerhexameral', 'peccationfoolery', 'sacroposteriorveratryl', 'dermoiddiversifiable', 'hookahsupersimplicity', 'androgynyvegetoalkaline', 'uncatholicizeSiphonognathus', 'yoreexponent', 'intrathoraciccoemployment', 'susurrateoutvie', 'extravagantkaryoplasmatic', 'paralyzerthiocarbimide', 'microcrystallogenyfuniculus', 'indubitablenoncollaboration', 'laterodeviationNarciss', 'unhyphenedallose'], ['letohll', 'lv', 'ntohs', 'letohs', 'letohll', 'lv', 'nextproto_s', 'letohll', 'ntohll', 'ntohl', 'letohl', 'float', 'letohs', 'ntohll', 'double', 'ntohl', 'ntohl', 'string', 'nextproto_b', 'string', 'lv', 'letohs', 'float', 'nextproto_b', 'string', 'ntohl', 'letohs', 'ntohll', 'string', 'string', 'nextproto_b', 'float', 'float', 'ntohs', 'lv', 'letohl', 'letohs', 'ntohl', 'byte', 'string', 'float', 'letohl']), 'integralizationbremeness': (['cicisbeismGonystylus', 'allerChilostoma', 'acanthopterygianMuranese', 'Wagnerianaaviculturist', 'noniccosmopoietic', 'mausoleandecasualize', 'slopinglyautomatically', 'vibrativeoversail', 'unpaintterebinic', 'petalousausterity', 'xiphosternamedia', 'chinkingcytologic', 'untastedgirllike', 'subsorterbecuffed', 'asteamincandescency', 'strainedlypsychopompos', 'terribletaut', 'Senecanovercorruptly', 'bairnlyneocosmic', 'Limodorumscrotal', 'prerailwaycannibalistically', 'loungyimpolite', 'galledisocinchomeronic', 'declamatorinessSerrifera', 'bullswooldraggletail', 'symmetricalantimasker', 'refallGanguela', 'domanialPhora', 'menialitypreintelligent', 'gemeledAdonai', 'spadelikemassacrer', 'Stromatoporoideabarry', 'piskgriff', 'allegoristerserendite', 'skilderprothalline', 'simulcastriboflavin', 'dihedronsubcircuit', 'grapedmassively', 'hetericismswayable', 'opportunisttitlark', 'campulitropoussapogenin', 'Dokoelectrochemically', 'syphilologyannularity', 'Bryumextrafocal', 'pavonatedcozily', 'bawcockPicnickian', 'imperializetrispaston', 'interimperialvignetter', 'unsubstantiaterightfulness', 'variationaladjutory', 'ettleoptimize', 'sacroposteriorveratryl', 'tautoousianentente', 'catmalisoncoevally', 'microcrystallogenyfuniculus', 'ambisyllabicfruitful', 'hyperduliaferrateen', 'cinecameraHydropotes', 'strangulableargentamid', 'scruplercellulifugal', 'etioporphyrinpubovesical', 'carangoidbotryomycotic', 'sokarailer', 'Mayorunahybridizer', 'lamellicornousPolygonaceae', 'kansrush', 'pellagrosemongrelization', 'fleaweedprobate', 'steinkirkmisaffection', 'furoidbasanite', 'overseateddiscouragingly', 'raspberrylikesubvertebral', 'popeyednaphtha', 'esophagoplastyrestrainedness', 'visorlikeNagari', 'reburstsummity'], ['nextproto_b', 'nextproto_s', 'float', 'string', 'nextproto_b']), 'ornithotomyblackwort': ([], ['letohs', 'letohl', 'string', 'ntohs', 'ntohl', 'double', 'ntohl', 'ntohs', 'byte', 'double', 'string', 'letohll', 'float', 'float', 'letohll', 'byte', 'ntohs', 'letohll', 'string', 'float', 'letohl', 'float', 'letohll', 'string', 'lv', 'letohll', 'ntohll', 'byte', 'ntohs', 'ntohll', 'lv', 'letohll', 'ntohs', 'float', 'string']), 'cannotdentigerous': ([], ['double', 'double', 'ntohl', 'letohs', 'ntohl', 'float', 'letohl', 'ntohs', 'letohs', 'double', 'string', 'letohll', 'string', 'lv', 'ntohs', 'ntohs', 'float', 'letohl', 'ntohll', 'lv', 'ntohl', 'letohs', 'byte', 'letohs', 'byte', 'double', 'ntohll', 'double', 'float', 'ntohl', 'ntohs', 'ntohll', 'double', 'letohll', 'ntohll', 'float', 'letohll']), 'catmalisoncoevally': ([], ['letohs', 'double', 'letohl', 'lv', 'letohl', 'string', 'ntohs', 'ntohs', 'letohl', 'letohs', 'string', 'letohs', 'string', 'letohl', 'ntohl', 'ntohll', 'byte', 'string', 'ntohl']), 'rosiedunarchdeacon': (['asperationoraculousness', 'overgenialitybuzzle', 'arhatsporozoic', 'tongueshoticonophilism', 'weathercockismcustodier', 'addressorcondensedly', 'correctorSpirochaeta', 'Stromatoporoideabarry', 'surlyreptilferous', 'semicolumnrankly', 'uncatholicizeSiphonognathus', 'acclaimerilluminability', 'trentepohliaceousHectorean', 'androgynyvegetoalkaline', 'collationdissuasively', 'sageshipcarcoon', 'stakeholderunforbade', 'piskgriff', 'foliicolousskeletonweed', 'hemianacusiadouble', 'bumblefooticonology', 'uncomminutedcommix', 'unhyphenedallose', 'superabsurdditremid', 'outworthbenevolence'], ['double', 'double', 'letohl', 'nextproto_s', 'float', 'double', 'double', 'letohs', 'ntohl', 'letohll', 'ntohll', 'nextproto_b', 'string', 'nextproto_b', 'nextproto_b', 'ntohs', 'letohs', 'nextproto_s', 'double', 'nextproto_s', 'ntohl', 'lv', 'byte', 'double', 'ntohl']), 'Theodotianjigget': ([], ['string', 'letohll', 'lv', 'lv', 'ntohll']), 'cycloolefinmonostylous': ([], ['ntohl', 'float', 'float', 'lv', 'lv'])}

#!/usr/bin/env python
#
# Copyright (C) 2014 Narf Industries <info@narfindustries.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

from struct import *

typelen = {
    'ntohll':8,
    'letohll':8,
    'ntohl':4,
    'letohl':4,
    'ntohs':2,
    'letohs':2,
    'byte':1,
    'float':4,
    'double':8,
}

class DUPE(object):
    def __init__(self,ver=1,ctype=0,clen=-1,flen=1000,idx=0,pkts=[]):
        self.ver = ver
        self.ctype = ctype
        self.clen = clen
        self.flen = flen
        self.idx = idx
        self.pkts = pkts
    def __str__(self):
        pktdata = "".join(str(pkt) for pkt in self.pkts)
        if self.clen == -1:
            self.clen = len(pktdata)
        s = pack("<IIiiI",self.ver,self.ctype,self.clen,self.flen,self.idx)
        return s+pktdata

class DUPEpkt(object):
    def __init__(self,data,ts=0,l=-1):
        self.data = data
        self.ts = ts
        if l == -1:
            self.l = len(data)
        else:
            self.l = l

    def __str__(self):
        return pack("<Ii",self.ts,self.l)+self.data

def random_alpha(a, b):
    return ''.join(choice(string.letters) for _ in range(randint(a, b)))

def random_string(a, b):
    chars = string.letters + string.digits
    return ''.join(choice(chars) for _ in range(randint(a, b)))

def urand(size):
    return ''.join(chr(randint(0,255)) for _ in range(size)) 

def makerandpkt(framelen=1000,ctype=0):
    #need to make a rofl or lol header in a bit
    if ctype == 0:
        idx = randint(0,len(rofl)-1)
        layers = [urand(20)+pack("<I",idx)]
        curname = rofl[idx].split("_")[1]
        names = ["rofl"]
    else:
        idx = randint(0,len(lol)-1)
        layers = [urand(12)+pack("<I",idx)+urand(4)]
        curname = lol[idx].split("_")[1]
        names = ["lol"]
        
    while 1:
        cur = pollinfo[curname]
        names.append(curname)
        nxt = -1
        layer = []
        for field in cur[1]:
            if field in typelen:
                layer.append(urand(typelen[field]))
            elif field == "nextproto_b":
                nxt = -1 if len(cur[0]) == 0 else randint(0,len(cur[0])-1)
                layer.append(pack("b",nxt))
            elif field == "nextproto_s":
                nxt = -1 if len(cur[0]) == 0 else randint(0,len(cur[0])-1)
                layer.append(pack("<h",nxt))
            elif field in ["lv","string"]:
                l = randint(1,255)
                layer.append(pack("B",l))
                layer.append(urand(l))
                
        if len("".join(layer+layers)) > framelen or len("".join(layer)) == 0:
            names = names[:-1]
            break
        layers.append("".join(layer))
        if nxt == -1 :
            break
        curname = cur[0][nxt]
    
    return DUPEpkt("".join(layers)),names

class CABLEGRINDER(Actions):
    def start(self):
        pass
    def valid(self):
        numpkts = randint(1,200)
        pkts,names = [],[]
        ctype = choice([0,1])
        flen = randint(250,8000)
        for i in range(numpkts):
            pkt,name = makerandpkt(ctype=ctype,framelen=flen)
            pkts.append(pkt)
            names.append(name)
        payload = str(DUPE(pkts=pkts,ctype=ctype,flen=flen))
        self.write(pack("<I",len(payload)))
        self.write(payload)

        #our match deems most of the actual dissection non-essential
        #checking layer names is sufficient to ensure desync hasn't occurred
        #and our for-testing release checks actual dissection of vuln layer
        self.read(delim="\n",expect="Starting dissection...")
        for cur in names:
            self.read(delim="====\n",expect=".*New Packet",expect_format='pcre')
            for name in cur:
                self.read(delim="===\n",expect=".*==="+name,expect_format='pcre')
            
        self.read(delim="===\n",expect=".*Dissection finished",expect_format='pcre')
    '''
    def invalidlen(self):
        pkt = VPacket(self.pkttypes['GETV'],random_data(1,128))
        self.write(str(pkt))
        self.read(delim="\n",expect="\d+",expect_format='pcre')
    def invalidproto(self):
        pkt = VPacket(self.pkttypes['SETV'],random_data(1,128))
        self.write(str(pkt))
        self.read(delim="\n",expect=self.SUCCESS)
    '''
    def invalidver(self):
        numpkts = randint(1,200)
        pkts,names = [],[]
        ctype = choice([0,1])
        flen = randint(250,8000)
        pkt,name = makerandpkt(ctype=ctype,framelen=flen)
        pkts.append(pkt)
        names.append(name)
        payload = str(DUPE(ver=randint(4,255),pkts=pkts,ctype=ctype,flen=flen))
        self.write(pack("<I",len(payload)))
        self.write(payload)
        self.read(delim="\n",expect="Bad file.")
